/* File: cmd3.c */

/* Purpose: Inventory commands */

/*
 * Copyright (c) 1997 Ben Harrison, James E. Wilson, Robert A. Koeneke
 *
 * This software may be copied and distributed for educational, research,
 * and not for profit purposes provided that this copyright and statement
 * are included in all such copies.  Other copyrights may also apply.
 */

#include "angband.h"



/*
 * Display inventory
 */
/*:::UbN̒\*/
void do_cmd_inven(void)
{
	char out_val[160];


	/* Note that we are in "inventory" mode */
	command_wrk = FALSE;

#ifdef ALLOW_EASY_FLOOR

	/* Note that we are in "inventory" mode */
	if (easy_floor) command_wrk = (USE_INVEN);

#endif /* ALLOW_EASY_FLOOR */

	/* Save screen */
	screen_save();

	/* Hack -- show empty slots */
	item_tester_full = TRUE;

	/* Display the inventory */
	(void)show_inven(0);

	/* Hack -- hide empty slots */
	item_tester_full = FALSE;

#ifdef JP
	sprintf(out_val, "F v %3d.%1d kg (E%ld%%) R}h: ",
	    (int)lbtokg1(p_ptr->total_weight) , (int)lbtokg2(p_ptr->total_weight) ,
	    (long int)((p_ptr->total_weight * 100) / weight_limit()));
#else
	sprintf(out_val, "Inventory: carrying %d.%d pounds (%ld%% of capacity). Command: ",
	    (int)(p_ptr->total_weight / 10), (int)(p_ptr->total_weight % 10),
	    (p_ptr->total_weight * 100) / weight_limit());
#endif


	/* Get a command */
	prt(out_val, 0, 0);

	/* Get a new command */
	command_new = inkey();

	/* Load screen */
	screen_load();


	/* Process "Escape" */
	if (command_new == ESCAPE)
	{
		int wid, hgt;

		/* Get size */
		Term_get_size(&wid, &hgt);

		/* Reset stuff */
		command_new = 0;
		command_gap = wid - 30;
	}

	/* Process normal keys */
	else
	{
		/* Hack -- Use "display" mode */
		command_see = TRUE;
	}
}


/*
 * Display equipment
 */
/*:::iꗗ\R}h҂*/
void do_cmd_equip(void)
{
	char out_val[160];


	/* Note that we are in "equipment" mode */
	command_wrk = TRUE;

#ifdef ALLOW_EASY_FLOOR

	/* Note that we are in "equipment" mode */
	if (easy_floor) command_wrk = (USE_EQUIP);

#endif /* ALLOW_EASY_FLOOR  */

	/* Save the screen */
	screen_save();

	/* Hack -- show empty slots */
	item_tester_full = TRUE;

	/* Display the equipment */
	(void)show_equip(0);

	/* Hack -- undo the hack above */
	item_tester_full = FALSE;

	/* Build a prompt */
#ifdef JP
	sprintf(out_val, "F v %3d.%1d kg (E%ld%%) R}h: ",
	    (int)lbtokg1(p_ptr->total_weight) , (int)lbtokg2(p_ptr->total_weight) ,
	    (long int)((p_ptr->total_weight * 100) / weight_limit()));
#else
	sprintf(out_val, "Equipment: carrying %d.%d pounds (%ld%% of capacity). Command: ",
	    (int)(p_ptr->total_weight / 10), (int)(p_ptr->total_weight % 10),
	    (long int)((p_ptr->total_weight * 100) / weight_limit()));
#endif


	/* Get a command */
	prt(out_val, 0, 0);

	/* Get a new command */
	command_new = inkey();

	/* Restore the screen */
	screen_load();


	/* Process "Escape" */
	if (command_new == ESCAPE)
	{
		int wid, hgt;

		/* Get size */
		Term_get_size(&wid, &hgt);

		/* Reset stuff */
		command_new = 0;
		command_gap = wid - 30;
	}

	/* Process normal keys */
	else
	{
		/* Enter "display" mode */
		command_see = TRUE;
	}
}


/*
 * The "wearable" tester
 */
/*:::do_cmd_wield()gB\ȃACeIʂB*/
///item ꏈTVAL
///sys E푰͂ɏ悤H
///mod150403 staticłȂ
bool item_tester_hook_wear(object_type *o_ptr)
{
	///del131223 폜
	//if ((o_ptr->tval == TV_SOFT_ARMOR) && (o_ptr->sval == SV_ABUNAI_MIZUGI))
	//	if (p_ptr->psex == SEX_MALE) return FALSE;

	/* Check for a usable slot */
	/*:::iłȂ̂-1Ԃ֐*/
	if (wield_slot(o_ptr) >= INVEN_RARM) return (TRUE);

	/* Assume not wearable */
	return (FALSE);
}

///item TVAL ύX@Ɏ\ׂ̂Ďw
///mod140309 ˌΏۂɂ
///mod151214 oOC@MAGICWEAPONǉ
static bool item_tester_hook_mochikae(object_type *o_ptr)
{
	///mod151202 Odpꏈ Ȃ
	if(p_ptr->pclass == CLASS_3_FAIRIES)
	{
		if (((o_ptr->tval >= TV_KNIFE) && (o_ptr->tval <= TV_POLEARM)) ||
		    (o_ptr->tval == TV_CAPTURE) ||
		    (o_ptr->tval == TV_MAGICWEAPON) ||
		    (o_ptr->tval == TV_MAGICITEM) ||
		    (o_ptr->tval == TV_OTHERWEAPON)) return (TRUE);
		if(object_is_shooting_weapon(o_ptr)) return TRUE;
		return (FALSE);
	}

	/* Check for a usable slot */
	if (((o_ptr->tval >= TV_KNIFE) && (o_ptr->tval <= TV_POLEARM)) ||
	    (o_ptr->tval == TV_SHIELD) || (o_ptr->tval == TV_CAPTURE) ||
	    (o_ptr->tval == TV_MAGICITEM) ||
	    (o_ptr->tval == TV_MAGICWEAPON) ||
	    (o_ptr->tval == TV_OTHERWEAPON)) return (TRUE);
	if(object_is_shooting_weapon(o_ptr)) return TRUE;
	/* Assume not wearable */
	return (FALSE);
}


static bool item_tester_hook_melee_weapon(object_type *o_ptr)
{
	/* Check for a usable slot */
	if ((o_ptr->tval >= TV_KNIFE) && (o_ptr->tval <= TV_POLEARM)
		|| (o_ptr->tval == TV_OTHERWEAPON))return (TRUE);

	/* Assume not wearable */
	return (FALSE);
}

//ȂقǗD悵INVEN_RARMɓBNX{EƏeuʏEɎߐڕƈꏏɎ獶ɂȂvȂĕςȎdlɂŔ肪ʓ|ɂȂčɂȂč
int check_priority_inven_rarm(object_type *o_ptr)
{
	switch(o_ptr->tval)
	{
	case TV_BOW:
		return 4;
	case TV_CAPTURE:
	case TV_MAGICITEM:
	case TV_SHIELD:
		return 3;
	case TV_CROSSBOW:
	case TV_GUN:
		return 2;
	default:
		return 1;
	}

}


bool select_ring_slot = FALSE;

/*
 * Wield or wear a single item from the pack or floor
 */
/*:::ύX*/
///item TVAL ύX
///mod131223 tval
//mod160515 mochikaeIvVǉ@葕î
void do_cmd_wield(bool mochikae)
{
	int item, slot;
	bool asia = FALSE;

	object_type forge,forge2;
	object_type *q_ptr;

	object_type *o_ptr;
	bool moon_vault_trap = FALSE;

	bool flag_quickdraw = FALSE;

	cptr act;

	char o_name[MAX_NLEN];

	cptr q, s;

	/*:::E肪ō肪ȂǁAւƂ̃tO*/
	int need_switch_wielding = 0;

	/*:::EɃNX{E肪|ŗ͎ȂȂǁAXbg̑OƂ̃tOǉ*/
	int need_takeoff = 0;
	object_type *takeoff_o_ptr;
	takeoff_o_ptr = &forge2;

	if (mimic_info[p_ptr->mimic_form].MIMIC_FLAGS & MIMIC_NO_WIELD || p_ptr->clawextend)
	{
		msg_print("̎pł͑ύXłȂB");
		return ;
	}

	if (p_ptr->special_defense & KATA_MUSOU)
	{
		set_action(ACTION_NONE);
	}

	/* Restrict the choices */
	if(mochikae)
		item_tester_hook = item_tester_hook_mochikae;
	else
		item_tester_hook = item_tester_hook_wear;

	/* Get an item */
#ifdef JP
	q = "ǂ𑕔܂? ";
	s = "\ȃACeȂB";
#else
	q = "Wear/Wield which item? ";
	s = "You have nothing you can wear or wield.";
#endif
	/*:::ACeIԁBꗗւ̕\item_tester_hookŃtB^*/
	if (!get_item(&item, q, s, (USE_INVEN | USE_FLOOR))) return;

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}


	/* Check the slot */
	slot = wield_slot(o_ptr);

	if(o_ptr->tval == TV_GUN && HAVE_SOLDIER_SKILL(SOLDIER_SKILL_SHOOT,SS_S_QUICK_DRAW)) 
		flag_quickdraw = TRUE;

	///mod160515 uEƍɕʁX̕ƂɊmFvIvVǉ
	if((always_check_arms) && (slot == INVEN_RARM || slot == INVEN_LARM))
	{
		int old_slot = slot;
		if(!inventory[INVEN_RARM].k_idx && !inventory[INVEN_LARM].k_idx)
		{	//肪̎̂܂ܑ
			;
		}
		else if(inventory[INVEN_RARM].k_idx && inventory[INVEN_LARM].k_idx)
		{	//łɗɕĂƂAɓւmF
			item_tester_hook = item_tester_hook_mochikae;
			q = "ǂ̑iƎւ܂?";
			s = "ERROR:do_cmd_wield()̏(1)";
			if (!get_item(&slot, q, s, (USE_EQUIP))) return;

			//ւʁAʍɎEɎĂĉEɎ̂ɎԂɂȂ獶Ȇւ
			if(slot == INVEN_RARM && check_priority_inven_rarm(o_ptr) > check_priority_inven_rarm(&inventory[INVEN_LARM]))
				need_switch_wielding = INVEN_LARM;
			else if(slot == INVEN_LARM && check_priority_inven_rarm(o_ptr) < check_priority_inven_rarm(&inventory[INVEN_RARM]))
				need_switch_wielding = INVEN_RARM;
		}
		else
		{	//Eǂ炩̃XbgӂĂƂAOǂmF
			if (get_check("ɎĂ镨ƈꏏɑ܂H"))
			{	
//					if(inventory[INVEN_LARM].k_idx && check_priority_inven_rarm(o_ptr) > check_priority_inven_rarm(&inventory[INVEN_LARM]))
//						need_switch_wielding = INVEN_LARM;
//					else if(inventory[INVEN_RARM].k_idx && check_priority_inven_rarm(o_ptr) < check_priority_inven_rarm(&inventory[INVEN_RARM]))
//						need_switch_wielding = INVEN_RARM;

				//v1.1.15b ɋ|ƂƂOĂ܂̂ŏC
				if(inventory[slot].k_idx)
				{
					if(slot == INVEN_RARM && check_priority_inven_rarm(o_ptr) < check_priority_inven_rarm(&inventory[INVEN_RARM]))
					{
						slot = INVEN_LARM;
						need_switch_wielding = INVEN_RARM;
					}
					if(slot == INVEN_LARM && check_priority_inven_rarm(o_ptr) > check_priority_inven_rarm(&inventory[INVEN_LARM]))
					{
						slot = INVEN_RARM;
						need_switch_wielding = INVEN_LARM;
					}

				}
			}
			else
			{	//O
				if(inventory[INVEN_RARM].k_idx)
				{
					need_takeoff = INVEN_RARM;
					if(check_priority_inven_rarm(o_ptr) < 3) slot = INVEN_RARM;
				}
				else if(inventory[INVEN_LARM].k_idx)
				{
					need_takeoff = INVEN_LARM;
					if(check_priority_inven_rarm(o_ptr) > 2) slot = INVEN_LARM;
				}
			}
		}
	}
	else
	/*:::EEO͂ǂɑ邩܂Ȃ̂őIACeɑ邩߂slotɊi[*/
	switch (o_ptr->tval)
	{
	/* Shields and some misc. items */
	/*:::AX^[{[*/
		///item TVAL
	case TV_CAPTURE:
	case TV_MAGICITEM:
	case TV_SHIELD:
	//case TV_CARD:
		/* Dual wielding */
		/*:::񓁗̏ꍇǂ̕Ǝւ邩I*/
		if (buki_motteruka(INVEN_RARM) && buki_motteruka(INVEN_LARM))
		{
			/* Restrict the choices */
			/*:::Iꗗ(ŐjȊO)킵oȂ߂hook*/
			/*:::EEȂ񂾂AŐj񓁗ɂĂĂƗɏoBǂƂB*/
			item_tester_hook = item_tester_hook_melee_weapon;
			item_tester_no_ryoute = TRUE;

			/* Choose a weapon from the equipment only */
#ifdef JP
			q = "ǂ̕Ǝւ܂?";
			s = "ƁB";
#else
			q = "Replace which weapon? ";
			s = "Oops.";
#endif

			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
			if (slot == INVEN_RARM) need_switch_wielding = INVEN_LARM;
		}
		/*:::ɕĂꍇEɏƂHۂɂ͂ĂȂBɂ͗̂H*/
		else if (buki_motteruka(INVEN_LARM)) slot = INVEN_RARM;

		///mod140309 |gp~֘A
		/*:::Eǂ炩̎ɎˌĂĐVɏȂǂ𑕔ꍇ̏ǉ*/
		else if(object_is_shooting_weapon(&inventory[INVEN_RARM]) || object_is_shooting_weapon(&inventory[INVEN_LARM]))
		{
			/*:::EɎˌAɉĂȂƂiNX{Ee𗼎莝A̓NX{EeƎjj́Â܂܏Ȃǂɑ*/
			if(object_is_shooting_weapon(&inventory[INVEN_RARM]) && !inventory[INVEN_LARM].k_idx)
			{
				;
			}
			/*:::ɎˌAEɉĂȂƂi|𗼎莝A͋|Ǝjj́AȂǂEɑ*/
			else if(object_is_shooting_weapon(&inventory[INVEN_LARM]) && !inventory[INVEN_RARM].k_idx)
			{
				slot = INVEN_RARM;
			}
			/*:::Ɏˌ܂މĂƂ@܂͂ǂOI*/
			else
			{
				item_tester_hook = item_tester_hook_mochikae;
#ifdef JP
				q = "ǂ̑iƎւ܂?";
				s = "ƁB";
#else
				q = "Equip which hand? ";
				s = "Oops.";
#endif
				if (!get_item(&slot, q, s, (USE_EQUIP))) return;

				if(slot == INVEN_RARM)
				{
					/*:::ȆƎւAɎĉߐڕEeENX{EȂ玝ւ*/
					if(object_is_melee_weapon(&inventory[INVEN_LARM]) || inventory[INVEN_LARM].tval == TV_CROSSBOW || inventory[INVEN_LARM].tval == TV_GUN)
					{
						need_switch_wielding = INVEN_LARM;
					}
					/*:::ɂ̂|AȂǂȂ炻̂܂ܑ*/
				}
				else
				{
					/*:::̑ƎւAEɎĉ|Ȃ玝ւ*/
					if(inventory[INVEN_RARM].tval == TV_BOW)
					{
						need_switch_wielding = INVEN_RARM;
					}
				}

			}
		}

		/* Both arms are already used by non-weapon */
		/*:::Ȃǂ𗼎ɎĂꍇǂ炩Ɠւ*/
		else if (inventory[INVEN_RARM].k_idx && !object_is_melee_weapon(&inventory[INVEN_RARM]) &&
		         inventory[INVEN_LARM].k_idx && !object_is_melee_weapon(&inventory[INVEN_LARM]))
		{
			/* Restrict the choices */
			item_tester_hook = item_tester_hook_mochikae;

			/* Choose a hand */
#ifdef JP
			q = "ǂ̎ɑ܂?";
			s = "ƁB";
#else
			q = "Equip which hand? ";
			s = "Oops.";
#endif

			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
		}
		break;

	/* Melee weapons */
	///item TVAL
	case TV_KNIFE:
	case TV_SWORD:
	case TV_KATANA:
	case TV_HAMMER:
	case TV_STICK:
	case TV_AXE:
	case TV_SPEAR:
	case TV_POLEARM:		
	case TV_OTHERWEAPON:
	case TV_MAGICWEAPON:


		///mod140309 |gp~֘A
		/*:::Eǂ炩̎ɎˌĂĐVɋߐڕ𑕔ꍇ̏ǉ*/
		if(object_is_shooting_weapon(&inventory[INVEN_RARM]) || object_is_shooting_weapon(&inventory[INVEN_LARM]))
		{
			/*:::EɎˌAɉĂȂƂiNX{Ee𗼎莝A̓NX{EeƎjj́AˌɎւ*/
			if(object_is_shooting_weapon(&inventory[INVEN_RARM]) && !inventory[INVEN_LARM].k_idx)
			{
				slot = INVEN_LARM;
				need_switch_wielding = INVEN_RARM;
			}
			/*:::ɎˌAEɉĂȂƂi|𗼎莝A͋|Ǝjj́AVȋߐڕ̂܂܉Eɑ*/
			else if(object_is_shooting_weapon(&inventory[INVEN_LARM]) && !inventory[INVEN_RARM].k_idx)
			{
				;
			}
			/*:::Ɏˌ܂މĂƂ@܂͂ǂOI*/
			else
			{
				item_tester_hook = item_tester_hook_mochikae;
#ifdef JP
				q = "ǂ̑iƎւ܂?";
				s = "ƁB";
#else
				q = "Equip which hand? ";
				s = "Oops.";
#endif
				if (!get_item(&slot, q, s, (USE_EQUIP))) return;

				if(slot == INVEN_RARM)
				{
					/*:::ȆƎւꍇAɎĂ̂ł낤Ƃ̂܂*/
					;
				}
				else
				{
					/*:::̑ƎւꍇAEɎĂ̂ߐڕȊOȂ玝ւ*/
					if(!object_is_melee_weapon(&inventory[INVEN_RARM]))
					{
						need_switch_wielding = INVEN_RARM;
					}
				}

			}
		}

		/* Asking for dual wielding */
		/*:::ߐڕ𑕔悤ƂslotLARMɂȂ͉̂Eɂ̂݉𑕔ĂƂ@*/
		/*:::Lv`[ĂƂ͍ɎĂ̂ŉEɂ̂݉ĂȂ炻͏ɋߐڕ*/
		/*:::|gp~łƂȂȂ̏͏ōς܂*/
		else if (slot == INVEN_LARM)
		{
#ifdef JP
			if (!get_check("񓁗Ő킢܂H")) slot = INVEN_RARM;
#else
			if (!get_check("Dual wielding? ")) slot = INVEN_RARM;
#endif
		}

		else if (!inventory[INVEN_RARM].k_idx && buki_motteruka(INVEN_LARM))
		{
#ifdef JP
			if (!get_check("񓁗Ő킢܂H")) slot = INVEN_LARM;
#else
			if (!get_check("Dual wielding? ")) slot = INVEN_LARM;
#endif
		}

		/* Both arms are already used */
		else if (inventory[INVEN_LARM].k_idx && inventory[INVEN_RARM].k_idx)
		{
			/* Restrict the choices */
			item_tester_hook = item_tester_hook_mochikae;

			/* Choose a hand */
#ifdef JP
			q = "ǂ̎ɑ܂?";
			s = "ƁB";
#else
			q = "Equip which hand? ";
			s = "Oops.";
#endif

			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
			if ((slot == INVEN_LARM) && !buki_motteruka(INVEN_RARM))
				need_switch_wielding = INVEN_RARM;
		}
		break;


///mod140309 |gp~֘A
	/*:::|Vɑ@slot͏INVEN_LARM*/
	case TV_BOW:
		/*:::ɂꂼꉽĂꍇAǂOIŎc͏ɉEŎ*/
		if (inventory[INVEN_LARM].k_idx && inventory[INVEN_RARM].k_idx)
		{
			item_tester_hook = item_tester_hook_mochikae;
#ifdef JP
			q = "ǂ̑iƎւ܂?";
			s = "ƁB";
#else
			q = "Equip which hand? ";
			s = "Oops.";
#endif
			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
			if (slot == INVEN_RARM)	need_switch_wielding = INVEN_LARM;
		}
		/*:::ˌ̂ݎĂƂAɎmFNOȂV@tOǉ*/
		else if(object_is_shooting_weapon(&inventory[INVEN_RARM]))
		{
			if (!get_check("ɂꂼˌ܂H")) need_takeoff = INVEN_RARM;
		}
		else if(object_is_shooting_weapon(&inventory[INVEN_LARM]))
		{
			if (get_check("ɂꂼˌ܂H")) slot = INVEN_RARM;
		}
		/*:::ߐڕ̂ݎĂƂiKÊ͂jAǉȂ@|͍Ŏ*/
		else if(object_is_melee_weapon(&inventory[INVEN_RARM]))
		{
			;
		}
		/*:::d{̂ݎĂƂiK̂͂jA|ɎĂ͉E*/
		else if(inventory[INVEN_LARM].k_idx)
		{
			slot = INVEN_RARM;
			need_switch_wielding = INVEN_LARM;
		}
		/*:::ĂȂƂA|͍*/
		else
		{
			;
		}
		break;

	/*:::eNX{EVɑ@slot͉EɉĂINVEN_LARM*/
	case TV_CROSSBOW:
	case TV_GUN:
		/*:::ɂꂼꉽĂꍇA܂ǂOI*/
		if (inventory[INVEN_LARM].k_idx && inventory[INVEN_RARM].k_idx)
		{
			item_tester_hook = item_tester_hook_mochikae;
#ifdef JP
			q = "ǂ̑iƎւ܂?";
			s = "ƁB";
#else
			q = "Equip which hand? ";
			s = "Oops.";
#endif
			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
			/*:::ĉߐڕȂ炻EɎeNX{E͍*/
			if (slot == INVEN_RARM && object_is_melee_weapon(&inventory[INVEN_LARM]))
			{
				need_switch_wielding = INVEN_LARM;
			}
			//ĉȅꍇւȂ
			else if(slot == INVEN_LARM && inventory[INVEN_RARM].tval == TV_GUN ||
				slot == INVEN_RARM && inventory[INVEN_LARM].tval == TV_GUN )
			{
				; //Ȃ
			}
			/*:::ĉd{Ȃ炻Ɏ*/
			else if (slot == INVEN_LARM && !object_is_melee_weapon(&inventory[INVEN_RARM]))
			{
				need_switch_wielding = INVEN_RARM;
			}
		}
		/*:::ˌ̂ݎĂƂAɎmFNOȂV@tOǉ*/
		else if(object_is_shooting_weapon(&inventory[INVEN_LARM]))
		{
			if (!get_check("ɂꂼˌ܂H")) need_takeoff = INVEN_LARM;
		}
		else if(object_is_shooting_weapon(&inventory[INVEN_RARM]))
		{
			if (get_check("ɂꂼˌ܂H")) slot = INVEN_LARM;
			else slot = INVEN_RARM;
		}
		/*:::ߐڕ̂ݎĂƂiKÊ͂jAeƃNX{E͍Ŏ*/
		else if(object_is_melee_weapon(&inventory[INVEN_RARM]))
		{
			slot = INVEN_LARM;
		}
		/*:::d{̂ݎĂƂiK̂͂jAǉȂ@eƃNX{E͉E*/
		else if(inventory[INVEN_LARM].k_idx)
		{
			;
		}
		/*:::ĂȂƂAeƃNX{E͉E*/
		else
		{
			;
		}
		break;

	/* Rings */
	case TV_RING:
		/* Choose a ring slot */
		if (inventory[INVEN_LEFT].k_idx && inventory[INVEN_RIGHT].k_idx)
		{
#ifdef JP
			q = "ǂ̎wւƎւ܂?";
#else
			q = "Replace which ring? ";
#endif
		}
		else
		{
#ifdef JP
			q = "ǂ̎ɑ܂?";
#else
			q = "Equip which hand? ";
#endif
		}

#ifdef JP
		s = "ƁB";
#else
		s = "Oops.";
#endif

		/* Restrict the choices */
		select_ring_slot = TRUE;
		item_tester_no_ryoute = TRUE;

		if (!get_item(&slot, q, s, (USE_EQUIP)))
		{
			select_ring_slot = FALSE;
			return;
		}
		select_ring_slot = FALSE;
		break;
	}
	/*:::EEÕXbg菈I*/

	///mod140122 ǉ
	if(!(wield_check(slot,item))) return;

	//v1.1.43 need_takeoff̑OĂ̂Œǉ
	if (need_takeoff && !(wield_check(need_takeoff, INVEN_PACK))) return;

	/* Prevent wielding into a cursed slot */
	if (object_is_cursed(&inventory[slot]))
	{
		/* Describe it */
		object_desc(o_name, &inventory[slot], (OD_OMIT_PREFIX | OD_NAME_ONLY));

		/* Message */
#ifdef JP
		msg_format("%s%s͎Ă悤B",
			   describe_use(slot) , o_name );
#else
		msg_format("The %s you are %s appears to be cursed.",
			   o_name, describe_use(slot));
#endif

		/* Cancel the command */
		return;
	}

	///mod160807 need_takeoffgƂ̎􂢏Ȃ̂Œǉ
	if (need_takeoff && object_is_cursed(&inventory[need_takeoff]))
	{
		object_desc(o_name, &inventory[need_takeoff], (OD_OMIT_PREFIX | OD_NAME_ONLY));
		msg_format("%s%s͎Ă悤B",  describe_use(need_takeoff) , o_name );
		return;
	}



	if (confirm_wear &&
		((object_is_cursed(o_ptr) && object_is_known(o_ptr)) ||
		((o_ptr->ident & IDENT_SENSE) &&
			(FEEL_BROKEN <= o_ptr->feeling) && (o_ptr->feeling <= FEEL_CURSED))))
	{
		char dummy[MAX_NLEN+80];

		/* Describe it */
		object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

#ifdef JP
sprintf(dummy, "{%s{Ă}g܂H", o_name);
#else
		sprintf(dummy, "Really use the %s {cursed}? ", o_name);
#endif

		if (!get_check(dummy)) return;
	}
	///item system Ήʂ̎푰ϗe AhChidl`jψق悤ɂ悤Ǝv悭lolvZςȂƂɂȂ
	if ((o_ptr->name1 == ART_STONEMASK) && object_is_known(o_ptr) && !(NO_CHANGE_RACE) && (p_ptr->prace != RACE_ULTIMATE))
	{
		char dummy[MAX_NLEN+80];

		int j;

		for (j = 0; j < INVEN_PACK; j++) if(inventory[j].tval == TV_SOUVENIR && inventory[j].sval == SV_SOUVENIR_ASIA) asia = TRUE;

		if(asia)
		{
			msg_print("ʂ̊zɁuGCW̐Ԑ΁v҂܂ĂB");
			msg_print(NULL);
			sprintf(dummy, "̂܂ܑĂ݂܂H");
			if (!get_check(dummy)) return;
		}
		else if(p_ptr->prace != RACE_VAMPIRE)
		{
			/* Describe it */
			object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));
			sprintf(dummy, "%s𑕔ƋzSɂȂ܂B낵łH", o_name);
			if (!get_check(dummy)) return;
		}
	}
	///mod140115 |̎푰ϗe dl`͕ϐgȂ
	if ((o_ptr->name1 == ART_MENPO) && object_is_known(o_ptr) && !(NO_CHANGE_RACE) && p_ptr->prace != RACE_NINJA)
	{
		char dummy[MAX_NLEN+80];

		/* Describe it */
		object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

#ifdef JP
sprintf(dummy, "%s𑕔ƃjWɂȂ܂B낵łH", o_name);
#endif

		if (!get_check(dummy)) return;
	}

	//\otf
	stop_tsukumo_music();

	if (need_switch_wielding && !object_is_cursed(&inventory[need_switch_wielding]))
	{
		object_type *slot_o_ptr = &inventory[slot];
		object_type *switch_o_ptr = &inventory[need_switch_wielding];
		object_type object_tmp;
		object_type *otmp_ptr = &object_tmp;
		char switch_name[MAX_NLEN];

		object_desc(switch_name, switch_o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

		object_copy(otmp_ptr, switch_o_ptr);
		object_copy(switch_o_ptr, slot_o_ptr);
		object_copy(slot_o_ptr, otmp_ptr);
#ifdef JP
		msg_format("%s%sɍ\ȂB", switch_name, (slot == INVEN_RARM) ? (left_hander ? "" : "E") : (left_hander ? "E" : ""));
#else
		msg_format("You wield %s at %s hand.", switch_name, (slot == INVEN_RARM) ? (left_hander ? "left" : "right") : (left_hander ? "right" : "left"));
#endif

		slot = need_switch_wielding;
	}



	/*:::^NGXgŊYACeE`FbN*/
	/*:::󕨌ɂ̃^[Qbg璼ڑƂ̂߂̏Ǝv*/
	check_find_art_quest_completion(o_ptr);


	//sۓWpACe
	if(	p_ptr->inside_quest == QUEST_MOON_VAULT && o_ptr->marked & OM_SPECIAL_FLAG)
	{
		activate_moon_vault_trap();
	}



	///seikaku
	if (p_ptr->pseikaku == SEIKAKU_MUNCHKIN)
	{
		identify_item(o_ptr);

		/* Auto-inscription */
		autopick_alter_item(item, FALSE);
	}

	/* Take a turn */
	if(flag_quickdraw)
	{
		msg_print("Ȃ͑fe\B");
		energy_use = 50;
	}
	else
		energy_use = 100;

	/* Get local object */
	q_ptr = &forge;

	/* Obtain local object */
	object_copy(q_ptr, o_ptr);

	/* Modify quantity */
	q_ptr->number = 1;

	/* Decrease the item (from the pack) */
	if (item >= 0)
	{
		inven_item_increase(item, -1);
		inven_item_optimize(item);
	}

	/* Decrease the item (from the floor) */
	else
	{
		floor_item_increase(0 - item, -1);
		floor_item_optimize(0 - item);
	}

	/* Access the wield slot */
	o_ptr = &inventory[slot];

	/* Take off existing item */
	if (o_ptr->k_idx)
	{
		/* Take off existing item */
		(void)inven_takeoff(slot, 255);
	}
	else if(need_takeoff)
	{
		(void)inven_takeoff(need_takeoff, 255);
	}

	/* Wear the new stuff */
	object_copy(o_ptr, q_ptr);

	/* Player touches it */
	o_ptr->marked |= OM_TOUCHED;

	/* Increase the weight */
	p_ptr->total_weight += q_ptr->weight;

	/* Increment the equip counter by hand */
	equip_cnt++;

#ifdef JP
#define STR_WIELD_RARM "%s(%c)EɑB"
#define STR_WIELD_LARM "%s(%c)ɑB"
#define STR_WIELD_ARMS "%s(%c)𗼎ō\B"
#else
#define STR_WIELD_RARM "You are wielding %s (%c) in your right hand."
#define STR_WIELD_LARM "You are wielding %s (%c) in your left hand."
#define STR_WIELD_ARMS "You are wielding %s (%c) with both hands."
#endif

	/* Where is the item now */
	switch (slot)
	{
	case INVEN_RARM:
		if (object_allow_two_hands_wielding(o_ptr) && (empty_hands(FALSE) == EMPTY_HAND_LARM) && CAN_TWO_HANDS_WIELDING())
			act = STR_WIELD_ARMS;
		else
			act = (left_hander ? STR_WIELD_LARM : STR_WIELD_RARM);
		break;

	case INVEN_LARM:
		if (object_allow_two_hands_wielding(o_ptr) && (empty_hands(FALSE) == EMPTY_HAND_RARM) && CAN_TWO_HANDS_WIELDING())
			act = STR_WIELD_ARMS;
		else
			act = (left_hander ? STR_WIELD_RARM : STR_WIELD_LARM);
		break;

	case INVEN_RIBBON:
#ifdef JP
		act = "%s(%c)񂾁B";
#else
		act = "You are shooting with %s (%c).";
#endif
		break;

	case INVEN_LITE:
#ifdef JP
		act = "%s(%c)ɂB";
#else
		act = "Your light source is %s (%c).";
#endif
		break;

	default:
#ifdef JP
		act = "%s(%c)𑕔B";
#else
		act = "You are wearing %s (%c).";
#endif
		break;
	}

	/* Describe the result */
	object_desc(o_name, o_ptr, 0);

	/* Message */
	msg_format(act, o_name, index_to_label(slot));


	/* Cursed! */
	if (object_is_cursed(o_ptr))
	{
		/* Warn the player */
#ifdef JP
		msg_print("I ܂₽I");
#else
		msg_print("Oops! It feels deathly cold!");
#endif


		//chg_virtue(V_HARMONY, -1);

		/* Note the curse */
		o_ptr->ident |= (IDENT_SENSE);
	}

	///item race Ήʂ̎푰ϗe
	/* The Stone Mask make the player turn into a vampire! */
	if ((o_ptr->name1 == ART_STONEMASK) && !(NO_CHANGE_RACE) && (p_ptr->prace != RACE_ULTIMATE))
	{
		/* Turn into a vampire */
		if(asia) change_race(RACE_ULTIMATE, "");
		else if(p_ptr->prace != RACE_VAMPIRE) change_race(RACE_VAMPIRE, "");
	}
	///mod140115 |̎푰ϗe@dl`͕ϐgȂ
	if (o_ptr->name1 == ART_MENPO && !(NO_CHANGE_RACE) && p_ptr->prace != RACE_NINJA)
	{
		/*:::*/
		sprintf(p_ptr->history[0], "Ȃ%sƂĕɐĂB",rp_ptr->title);
		sprintf(p_ptr->history[1], "Ȃɕ̃jWE\E߈˂I");
		if(one_in_(6))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BAΐNւ̕QI");
		else if(one_in_(5))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BȀ_bMւ̕QI");
		else if(one_in_(4))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BAwׂ̃T[ygxւ̕QI");
		else if(one_in_(3))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BASẴjW̖EI");
		else if(one_in_(2))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BAsҒBւ̕QI");
		else
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BASAo[̉ւ̕QI");
		sprintf(p_ptr->history[3], "A%sAI",player_name);
		/* Turn into a NINJA */
		change_race(RACE_NINJA, "");
	}

	/* Recalculate bonuses */
	p_ptr->update |= (PU_BONUS);

	/* Recalculate torch */
	p_ptr->update |= (PU_TORCH);

	/* Recalculate mana */
	p_ptr->update |= (PU_MANA | PU_HP);

	p_ptr->redraw |= (PR_EQUIPPY | PR_HP | PR_MANA);

	/* Window stuff */
	p_ptr->window |= (PW_INVEN | PW_EQUIP | PW_PLAYER);

	calc_android_exp();
}


/*:::̎Odp̑ύX*/
void do_cmd_wield_3_fairies(void)
{
	int item, slot;
	bool asia = FALSE;

	object_type forge,forge2;
	object_type *q_ptr;

	object_type *o_ptr;

	cptr act;

	char o_name[MAX_NLEN];

	cptr q, s;

	/*:::E肪ō肪ȂǁAւƂ̃tO*/
	int need_switch_wielding = 0;

	/*:::EɃNX{E肪|ŗ͎ȂȂǁAXbg̑OƂ̃tOǉ*/
	int need_takeoff = 0;
	object_type *takeoff_o_ptr;
	takeoff_o_ptr = &forge2;

	if (mimic_info[p_ptr->mimic_form].MIMIC_FLAGS & MIMIC_NO_WIELD || p_ptr->clawextend)
	{
		msg_print("̎pł͑ύXłȂB");
		return ;
	}

	/* Restrict the choices */
	item_tester_hook = item_tester_hook_wear;

	/* Get an item */
	q = "ǂ𑕔܂? ";
	s = "\ȃACeȂB";
	if (!get_item(&item, q, s, (USE_INVEN | USE_FLOOR))) return;
	if (item >= 0)
		o_ptr = &inventory[item];
	else
		o_ptr = &o_list[0 - item];

	/* Check the slot */
	slot = wield_slot_3_fairies(o_ptr);

	/*:::EEO͂ǂɑ邩܂Ȃ̂őIACeɑ邩߂slotɊi[*/

	switch (o_ptr->tval)
	{
	//d{(͕ʕ)
	case TV_CAPTURE:
	case TV_MAGICITEM:
		/*:::񓁗̏ꍇǂ̕Ǝւ邩I*/
		if (buki_motteruka(INVEN_RARM) && buki_motteruka(INVEN_LARM))
		{
			/* Restrict the choices */
			/*:::Iꗗ(ŐjȊO)킵oȂ߂hook*/
			/*:::EEȂ񂾂AŐj񓁗ɂĂĂƗɏoBǂƂB*/
			item_tester_hook = item_tester_hook_melee_weapon;
			item_tester_no_ryoute = TRUE;
			q = "ǂ̕Ǝւ܂?";
			s = "ƁB";

			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
			if (slot == INVEN_RARM) need_switch_wielding = INVEN_LARM;
		}
		else if (buki_motteruka(INVEN_LARM)) slot = INVEN_RARM;

		/*:::Eǂ炩̎ɎˌĂĐVɏȂǂ𑕔ꍇ̏ǉ*/
		else if(object_is_shooting_weapon(&inventory[INVEN_RARM]) || object_is_shooting_weapon(&inventory[INVEN_LARM]))
		{
			/*:::EɎˌAɉĂȂƂiNX{Ee𗼎莝A̓NX{EeƎjj́Â܂܏Ȃǂɑ*/
			if(object_is_shooting_weapon(&inventory[INVEN_RARM]) && !inventory[INVEN_LARM].k_idx)
			{
				;
			}
			/*:::ɎˌAEɉĂȂƂi|𗼎莝A͋|Ǝjj́AȂǂEɑ*/
			else if(object_is_shooting_weapon(&inventory[INVEN_LARM]) && !inventory[INVEN_RARM].k_idx)
			{
				slot = INVEN_RARM;
			}
			/*:::Ɏˌ܂މĂƂ@܂͂ǂOI*/
			else
			{
				item_tester_hook = item_tester_hook_mochikae;
				q = "ǂ̑iƎւ܂?";
				s = "ƁB";
				if (!get_item(&slot, q, s, (USE_EQUIP))) return;

				if(slot == INVEN_RARM)
				{
					/*:::ȆƎւAɎĉߐڕEeENX{EȂ玝ւ*/
					if(object_is_melee_weapon(&inventory[INVEN_LARM]) || inventory[INVEN_LARM].tval == TV_CROSSBOW || inventory[INVEN_LARM].tval == TV_GUN)
					{
						need_switch_wielding = INVEN_LARM;
					}
					/*:::ɂ̂|AȂǂȂ炻̂܂ܑ*/
				}
				else
				{
					/*:::̑ƎւAEɎĉ|Ȃ玝ւ*/
					if(inventory[INVEN_RARM].tval == TV_BOW)
					{
						need_switch_wielding = INVEN_RARM;
					}
				}

			}
		}

		/* Both arms are already used by non-weapon */
		/*:::Ȃǂ𗼎ɎĂꍇǂ炩Ɠւ*/
		else if (inventory[INVEN_RARM].k_idx && !object_is_melee_weapon(&inventory[INVEN_RARM]) &&
		         inventory[INVEN_LARM].k_idx && !object_is_melee_weapon(&inventory[INVEN_LARM]))
		{
			/* Restrict the choices */
			item_tester_hook = item_tester_hook_mochikae;

			/* Choose a hand */
#ifdef JP
			q = "ǂ̎ɑ܂?";
			s = "ƁB";
#else
			q = "Equip which hand? ";
			s = "Oops.";
#endif

			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
		}
		break;

	/* Melee weapons */
	///item TVAL
	case TV_KNIFE:
	case TV_SWORD:
	case TV_KATANA:
	case TV_HAMMER:
	case TV_STICK:
	case TV_AXE:
	case TV_SPEAR:
	case TV_POLEARM:		
	case TV_OTHERWEAPON:
	case TV_MAGICWEAPON:


		///mod140309 |gp~֘A
		/*:::Eǂ炩̎ɎˌĂĐVɋߐڕ𑕔ꍇ̏ǉ*/
		if(object_is_shooting_weapon(&inventory[INVEN_RARM]) || object_is_shooting_weapon(&inventory[INVEN_LARM]))
		{
			/*:::EɎˌAɉĂȂƂiNX{Ee𗼎莝A̓NX{EeƎjj́AˌɎւ*/
			if(object_is_shooting_weapon(&inventory[INVEN_RARM]) && !inventory[INVEN_LARM].k_idx)
			{
				slot = INVEN_LARM;
				need_switch_wielding = INVEN_RARM;
			}
			/*:::ɎˌAEɉĂȂƂi|𗼎莝A͋|Ǝjj́AVȋߐڕ̂܂܉Eɑ*/
			else if(object_is_shooting_weapon(&inventory[INVEN_LARM]) && !inventory[INVEN_RARM].k_idx)
			{
				;
			}
			/*:::Ɏˌ܂މĂƂ@܂͂ǂOI*/
			else
			{
				item_tester_hook = item_tester_hook_mochikae;
#ifdef JP
				q = "ǂ̑iƎւ܂?";
				s = "ƁB";
#else
				q = "Equip which hand? ";
				s = "Oops.";
#endif
				if (!get_item(&slot, q, s, (USE_EQUIP))) return;

				if(slot == INVEN_RARM)
				{
					/*:::ȆƎւꍇAɎĂ̂ł낤Ƃ̂܂*/
					;
				}
				else
				{
					/*:::̑ƎւꍇAEɎĂ̂ߐڕȊOȂ玝ւ*/
					if(!object_is_melee_weapon(&inventory[INVEN_RARM]))
					{
						need_switch_wielding = INVEN_RARM;
					}
				}

			}
		}

		//񓁗mF폜

		/* Both arms are already used */
		else if (inventory[INVEN_LARM].k_idx && inventory[INVEN_RARM].k_idx)
		{
			/* Restrict the choices */
			item_tester_hook = item_tester_hook_mochikae;

			q = "ǂ̎ɑ܂?";
			s = "ƁB";

			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
			if ((slot == INVEN_LARM) && !buki_motteruka(INVEN_RARM))
				need_switch_wielding = INVEN_RARM;
		}
		break;


///mod140309 |gp~֘A
	/*:::|Vɑ@slot͏INVEN_LARM*/
	case TV_BOW:
		/*:::ɂꂼꉽĂꍇAǂOIŎc͏ɉEŎ*/
		if (inventory[INVEN_LARM].k_idx && inventory[INVEN_RARM].k_idx)
		{
			item_tester_hook = item_tester_hook_mochikae;
#ifdef JP
			q = "ǂ̑iƎւ܂?";
			s = "ƁB";
#else
			q = "Equip which hand? ";
			s = "Oops.";
#endif
			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
			if (slot == INVEN_RARM)	need_switch_wielding = INVEN_LARM;
		}
		/*:::ˌ̂ݎĂƂAɎmFNOȂV@tOǉ*/
		else if(object_is_shooting_weapon(&inventory[INVEN_RARM]))
		{
			if (!get_check("ɂꂼˌ܂H")) need_takeoff = INVEN_RARM;
		}
		else if(object_is_shooting_weapon(&inventory[INVEN_LARM]))
		{
			if (get_check("ɂꂼˌ܂H")) slot = INVEN_RARM;
		}
		/*:::ߐڕ̂ݎĂƂiKÊ͂jAǉȂ@|͍Ŏ*/
		else if(object_is_melee_weapon(&inventory[INVEN_RARM]))
		{
			;
		}
		/*:::d{̂ݎĂƂiK̂͂jA|ɎĂ͉E*/
		else if(inventory[INVEN_LARM].k_idx)
		{
			slot = INVEN_RARM;
			need_switch_wielding = INVEN_LARM;
		}
		/*:::ĂȂƂA|͍*/
		else
		{
			;
		}
		break;

	/*:::eNX{EVɑ@slot͉EɉĂINVEN_LARM*/
	case TV_CROSSBOW:
	case TV_GUN:
		/*:::ɂꂼꉽĂꍇA܂ǂOI*/
		if (inventory[INVEN_LARM].k_idx && inventory[INVEN_RARM].k_idx)
		{
			item_tester_hook = item_tester_hook_mochikae;
#ifdef JP
			q = "ǂ̑iƎւ܂?";
			s = "ƁB";
#else
			q = "Equip which hand? ";
			s = "Oops.";
#endif
			if (!get_item(&slot, q, s, (USE_EQUIP))) return;
			/*:::ĉߐڕȂ炻EɎeNX{E͍*/
			if (slot == INVEN_RARM && object_is_melee_weapon(&inventory[INVEN_LARM]))
			{
				need_switch_wielding = INVEN_LARM;
			}
			/*:::ĉd{Ȃ炻Ɏ*/
			if (slot == INVEN_LARM && !object_is_melee_weapon(&inventory[INVEN_RARM]))
			{
				need_switch_wielding = INVEN_RARM;
			}
		}
		/*:::ˌ̂ݎĂƂAɎmFNOȂV@tOǉ*/
		else if(object_is_shooting_weapon(&inventory[INVEN_LARM]))
		{
			if (!get_check("ɂꂼˌ܂H")) need_takeoff = INVEN_LARM;
		}
		else if(object_is_shooting_weapon(&inventory[INVEN_RARM]))
		{
			if (get_check("ɂꂼˌ܂H")) slot = INVEN_LARM;
			else slot = INVEN_RARM;
		}
		/*:::ߐڕ̂ݎĂƂiKÊ͂jAeƃNX{E͍Ŏ*/
		else if(object_is_melee_weapon(&inventory[INVEN_RARM]))
		{
			slot = INVEN_LARM;
		}
		/*:::d{̂ݎĂƂiK̂͂jAǉȂ@eƃNX{E͉E*/
		else if(inventory[INVEN_LARM].k_idx)
		{
			;
		}
		/*:::ĂȂƂAeƃNX{E͉E*/
		else
		{
			;
		}
		break;

		case TV_RIBBON:		
		case TV_RING:
		case TV_AMULET:
		case TV_WHISTLE:
		case TV_DRAG_ARMOR:
		case TV_ARMOR:
		case TV_CLOTHES:
		case TV_CLOAK:
		case TV_HEAD:
		case TV_GLOVES:
		case TV_BOOTS:

		//ɑSXbg܂ĂƂɓ͂
		if (slot == INVEN_FEET && inventory[INVEN_FEET].k_idx)
		{
			q = "ǂ̑iƎւ܂?";
			s = "ƁB";


		}

		/*::: hack - select_ring_slot̖㏑ĕAAȊȎSXbgΏۂɂĂ܂*/
		select_ring_slot = TRUE;
		item_tester_no_ryoute = TRUE;

		if (!get_item(&slot, q, s, (USE_EQUIP)))
		{
			select_ring_slot = FALSE;
			return;
		}
		select_ring_slot = FALSE;
		break;
	}
	/*:::EEÕXbg菈I*/

	if(!(wield_check(slot,item))) return;


	/* Prevent wielding into a cursed slot */
	if (object_is_cursed(&inventory[slot]))
	{
		/* Describe it */
		object_desc(o_name, &inventory[slot], (OD_OMIT_PREFIX | OD_NAME_ONLY));

		/* Message */
#ifdef JP
		msg_format("%s%s͎Ă悤B",
			   describe_use(slot) , o_name );
#else
		msg_format("The %s you are %s appears to be cursed.",
			   o_name, describe_use(slot));
#endif

		/* Cancel the command */
		return;
	}

	if (confirm_wear &&
		((object_is_cursed(o_ptr) && object_is_known(o_ptr)) ||
		((o_ptr->ident & IDENT_SENSE) &&
			(FEEL_BROKEN <= o_ptr->feeling) && (o_ptr->feeling <= FEEL_CURSED))))
	{
		char dummy[MAX_NLEN+80];

		/* Describe it */
		object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

#ifdef JP
sprintf(dummy, "{%s{Ă}g܂H", o_name);
#else
		sprintf(dummy, "Really use the %s {cursed}? ", o_name);
#endif

		if (!get_check(dummy)) return;
	}
	///item system Ήʂ̎푰ϗe AhChidl`jψق悤ɂ悤Ǝv悭lolvZςȂƂɂȂ
	if ((o_ptr->name1 == ART_STONEMASK) && object_is_known(o_ptr) && !(NO_CHANGE_RACE) && (p_ptr->prace != RACE_ULTIMATE))
	{
		char dummy[MAX_NLEN+80];

		int j;

		for (j = 0; j < INVEN_PACK; j++) if(inventory[j].tval == TV_SOUVENIR && inventory[j].sval == SV_SOUVENIR_ASIA) asia = TRUE;

		if(asia)
		{
			msg_print("ʂ̊zɁuGCW̐Ԑ΁v҂܂ĂB");
			msg_print(NULL);
			sprintf(dummy, "̂܂ܑĂ݂܂H");
			if (!get_check(dummy)) return;
		}
		else if(p_ptr->prace != RACE_VAMPIRE)
		{
			/* Describe it */
			object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));
			sprintf(dummy, "%s𑕔ƋzSɂȂ܂B낵łH", o_name);
			if (!get_check(dummy)) return;
		}
	}
	///mod140115 |̎푰ϗe dl`͕ϐgȂ
	if ((o_ptr->name1 == ART_MENPO) && object_is_known(o_ptr) && !(NO_CHANGE_RACE) && p_ptr->prace != RACE_NINJA)
	{
		char dummy[MAX_NLEN+80];

		/* Describe it */
		object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

#ifdef JP
sprintf(dummy, "%s𑕔ƃjWɂȂ܂B낵łH", o_name);
#endif

		if (!get_check(dummy)) return;
	}


	if (need_switch_wielding && !object_is_cursed(&inventory[need_switch_wielding]))
	{
		object_type *slot_o_ptr = &inventory[slot];
		object_type *switch_o_ptr = &inventory[need_switch_wielding];
		object_type object_tmp;
		object_type *otmp_ptr = &object_tmp;
		char switch_name[MAX_NLEN];

		object_desc(switch_name, switch_o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

		object_copy(otmp_ptr, switch_o_ptr);
		object_copy(switch_o_ptr, slot_o_ptr);
		object_copy(slot_o_ptr, otmp_ptr);

		msg_format("%sւB", switch_name);

#ifdef JP
	//	msg_format("%s%sɍ\ȂB", switch_name, (slot == INVEN_RARM) ? (left_hander ? "" : "E") : (left_hander ? "E" : ""));
#else
		msg_format("You wield %s at %s hand.", switch_name, (slot == INVEN_RARM) ? (left_hander ? "left" : "right") : (left_hander ? "right" : "left"));
#endif

		slot = need_switch_wielding;
	}

	/*:::^NGXgŊYACeE`FbN*/
	/*:::󕨌ɂ̃^[Qbg璼ڑƂ̂߂̏Ǝv*/
	check_find_art_quest_completion(o_ptr);


	///seikaku
	if (p_ptr->pseikaku == SEIKAKU_MUNCHKIN)
	{
		identify_item(o_ptr);

		/* Auto-inscription */
		autopick_alter_item(item, FALSE);
	}

	/* Take a turn */
	energy_use = 100;

	/* Get local object */
	q_ptr = &forge;

	/* Obtain local object */
	object_copy(q_ptr, o_ptr);

	/* Modify quantity */
	q_ptr->number = 1;

	/* Decrease the item (from the pack) */
	if (item >= 0)
	{
		inven_item_increase(item, -1);
		inven_item_optimize(item);
	}

	/* Decrease the item (from the floor) */
	else
	{
		floor_item_increase(0 - item, -1);
		floor_item_optimize(0 - item);
	}

	/* Access the wield slot */
	o_ptr = &inventory[slot];

	/* Take off existing item */
	if (o_ptr->k_idx)
	{
		/* Take off existing item */
		(void)inven_takeoff(slot, 255);
	}
	else if(need_takeoff)
	{
		(void)inven_takeoff(need_takeoff, 255);
	}

	/* Wear the new stuff */
	object_copy(o_ptr, q_ptr);

	/* Player touches it */
	o_ptr->marked |= OM_TOUCHED;

	/* Increase the weight */
	p_ptr->total_weight += q_ptr->weight;

	/* Increment the equip counter by hand */
	equip_cnt++;
/*
#ifdef JP
#define STR_WIELD_RARM "%s(%c)EɑB"
#define STR_WIELD_LARM "%s(%c)ɑB"
#define STR_WIELD_ARMS "%s(%c)𗼎ō\B"
#else
#define STR_WIELD_RARM "You are wielding %s (%c) in your right hand."
#define STR_WIELD_LARM "You are wielding %s (%c) in your left hand."
#define STR_WIELD_ARMS "You are wielding %s (%c) with both hands."
#endif
*/
	/* Where is the item now */
	switch (slot)
	{
	case INVEN_RARM:
	case INVEN_LARM:
		//{gXbgɂȂ
	case INVEN_RIBBON:
#ifdef JP
		act = "%s(%c)\B";
#else
		act = "You are shooting with %s (%c).";
#endif
		break;

	case INVEN_LITE:
#ifdef JP
		act = "%s(%c)ɂB";
#else
		act = "Your light source is %s (%c).";
#endif
		break;

	default:
#ifdef JP
		act = "%s(%c)𑕔B";
#else
		act = "You are wearing %s (%c).";
#endif
		break;
	}

	/* Describe the result */
	object_desc(o_name, o_ptr, 0);

	/* Message */
	msg_format(act, o_name, index_to_label(slot));


	/* Cursed! */
	if (object_is_cursed(o_ptr))
	{
		/* Warn the player */
#ifdef JP
		msg_print("I ܂₽I");
#else
		msg_print("Oops! It feels deathly cold!");
#endif


		//chg_virtue(V_HARMONY, -1);

		/* Note the curse */
		o_ptr->ident |= (IDENT_SENSE);
	}

	///item race Ήʂ̎푰ϗe
	/* The Stone Mask make the player turn into a vampire! */
	if ((o_ptr->name1 == ART_STONEMASK) && !(NO_CHANGE_RACE) && (p_ptr->prace != RACE_ULTIMATE))
	{
		/* Turn into a vampire */
		if(asia) change_race(RACE_ULTIMATE, "");
		else if(p_ptr->prace != RACE_VAMPIRE) change_race(RACE_VAMPIRE, "");
	}
	///mod140115 |̎푰ϗe@dl`͕ϐgȂ
	if (o_ptr->name1 == ART_MENPO && !(NO_CHANGE_RACE) && p_ptr->prace != RACE_NINJA)
	{
		/*:::*/
		sprintf(p_ptr->history[0], "Ȃ%sƂĕɐĂB",rp_ptr->title);
		sprintf(p_ptr->history[1], "̃jWE\E߈˂I");
		if(one_in_(6))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BAΐNւ̕QI");
		else if(one_in_(5))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BȀ_bMւ̕QI");
		else if(one_in_(4))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BAwׂ̃T[ygxւ̕QI");
		else if(one_in_(3))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BASẴjW̖EI");
		else if(one_in_(2))
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BAsҒBւ̕QI");
		else
			sprintf(p_ptr->history[2], "Ȃ̖ړI͗BASAo[̉ւ̕QI");
		sprintf(p_ptr->history[3], "A%sAI",player_name);
		/* Turn into a NINJA */
		change_race(RACE_NINJA, "");
	}

	/* Recalculate bonuses */
	p_ptr->update |= (PU_BONUS);

	/* Recalculate torch */
	p_ptr->update |= (PU_TORCH);

	/* Recalculate mana */
	p_ptr->update |= (PU_MANA);

	p_ptr->redraw |= (PR_EQUIPPY);

	/* Window stuff */
	p_ptr->window |= (PW_INVEN | PW_EQUIP | PW_PLAYER);

	calc_android_exp();
}


/*:::i𓊂藎ƂO蔄肵ƂAciK؂ɑ*/
/*:::item:OĩXbg*/
///mod140309 |gp~֘Aǉ
void kamaenaoshi(int item)
{
	object_type *o_ptr, *new_o_ptr;
	char o_name[MAX_NLEN];

	if (item == INVEN_RARM)
	{
		/*:::E葕OčɏeNX{EĂAEɎւ*/
		if( inventory[INVEN_LARM].tval == TV_GUN || inventory[INVEN_LARM].tval == TV_CROSSBOW)
		{
			o_ptr = &inventory[INVEN_LARM];
			object_desc(o_name, o_ptr, 0);
			if (!object_is_cursed(o_ptr))
			{
				new_o_ptr = &inventory[INVEN_RARM];
				object_copy(new_o_ptr, o_ptr);
				p_ptr->total_weight += o_ptr->weight;
				inven_item_increase(INVEN_LARM, -((int)o_ptr->number));
				inven_item_optimize(INVEN_LARM);
				if (object_allow_two_hands_wielding(o_ptr) && CAN_TWO_HANDS_WIELDING())
#ifdef JP
					msg_format("%s𗼎ō\B", o_name);
#else
					msg_format("You are wielding %s with both hands.", o_name);
#endif

				else if(p_ptr->pclass == CLASS_3_FAIRIES)
					msg_format("%s\B", o_name);
				else
#ifdef JP
					msg_format("%s%sō\B", o_name, (left_hander ? "" : "E"));
#else
					msg_format("You are wielding %s in your %s hand.", o_name, (left_hander ? "left":"right"));
#endif
			}
			else
			{
				if (object_allow_two_hands_wielding(o_ptr) && CAN_TWO_HANDS_WIELDING())
#ifdef JP
					msg_format("%s𗼎ō\B", o_name);
#else
					msg_format("You are wielding %s with both hands.", o_name);
#endif
			}
		}
		else if (buki_motteruka(INVEN_LARM))
		{
			o_ptr = &inventory[INVEN_LARM];
			object_desc(o_name, o_ptr, 0);

			if (!object_is_cursed(o_ptr))
			{
				new_o_ptr = &inventory[INVEN_RARM];
				object_copy(new_o_ptr, o_ptr);
				p_ptr->total_weight += o_ptr->weight;
				inven_item_increase(INVEN_LARM, -((int)o_ptr->number));
				inven_item_optimize(INVEN_LARM);
				if (object_allow_two_hands_wielding(o_ptr) && CAN_TWO_HANDS_WIELDING())
#ifdef JP
					msg_format("%s𗼎ō\B", o_name);
#else
					msg_format("You are wielding %s with both hands.", o_name);
#endif
				else if(p_ptr->pclass == CLASS_3_FAIRIES)
					msg_format("%s\B", o_name);
				else
#ifdef JP
					msg_format("%s%sō\B", o_name, (left_hander ? "" : "E"));
#else
					msg_format("You are wielding %s in your %s hand.", o_name, (left_hander ? "left":"right"));
#endif
			}
			else
			{
				if (object_allow_two_hands_wielding(o_ptr) && CAN_TWO_HANDS_WIELDING())
#ifdef JP
					msg_format("%s𗼎ō\B", o_name);
#else
					msg_format("You are wielding %s with both hands.", o_name);
#endif
			}
		}
		else if(inventory[INVEN_LARM].tval == TV_BOW)
		{
			o_ptr = &inventory[INVEN_LARM];
			object_desc(o_name, o_ptr, 0);
#ifdef JP
			if(p_ptr->pclass != CLASS_3_FAIRIES)
				msg_format("%s𗼎ō\B", o_name);
#else
			msg_format("You are wielding %s with both hands.", o_name);
#endif

		}

	}
	else if (item == INVEN_LARM)
	{
		o_ptr = &inventory[INVEN_RARM];
		if (o_ptr->k_idx) object_desc(o_name, o_ptr, 0);

		/*:::葕OĉEɋ|ĂAɎւ*/
		if( inventory[INVEN_RARM].tval == TV_BOW)
		{
			o_ptr = &inventory[INVEN_RARM];
			object_desc(o_name, o_ptr, 0);
			if (!object_is_cursed(o_ptr))
			{
				new_o_ptr = &inventory[INVEN_LARM];
				object_copy(new_o_ptr, o_ptr);
				p_ptr->total_weight += o_ptr->weight;
				inven_item_increase(INVEN_RARM, -((int)o_ptr->number));
				inven_item_optimize(INVEN_RARM);
				if (object_allow_two_hands_wielding(o_ptr) && CAN_TWO_HANDS_WIELDING())
#ifdef JP
					msg_format("%s𗼎ō\B", o_name);
#else
					msg_format("You are wielding %s with both hands.", o_name);
#endif
				else if(p_ptr->pclass == CLASS_3_FAIRIES)
					msg_format("%s\B", o_name);
				else
#ifdef JP
					msg_format("%s%sō\B", o_name, (left_hander ? "" : "E"));
#else
					msg_format("You are wielding %s in your %s hand.", o_name, (left_hander ? "left":"right"));
#endif
			}
			else
			{
				if (object_allow_two_hands_wielding(o_ptr) && CAN_TWO_HANDS_WIELDING())
#ifdef JP
					msg_format("%s𗼎ō\B", o_name);
#else
					msg_format("You are wielding %s with both hands.", o_name);
#endif
			}
		}

		else if (buki_motteruka(INVEN_RARM) || o_ptr->tval == TV_CROSSBOW || o_ptr->tval == TV_GUN)
		{
			if (object_allow_two_hands_wielding(o_ptr) && CAN_TWO_HANDS_WIELDING())
#ifdef JP
				msg_format("%s𗼎ō\B", o_name);
#else
				msg_format("You are wielding %s with both hands.", o_name);
#endif
		}
		else if (!(empty_hands(FALSE) & EMPTY_HAND_RARM) && !object_is_cursed(o_ptr))
		{
			new_o_ptr = &inventory[INVEN_LARM];
			object_copy(new_o_ptr, o_ptr);
			p_ptr->total_weight += o_ptr->weight;
			inven_item_increase(INVEN_RARM, -((int)o_ptr->number));
			inven_item_optimize(INVEN_RARM);
#ifdef JP
			msg_format("%sւB", o_name);
#else
			msg_format("You switched hand of %s.", o_name);
#endif
		}
	}
}


/*
 * Take off an item
 */
/*:::O*/
///item TVAL
void do_cmd_takeoff(void)
{
	int item;
	bool flag_quickdraw = FALSE;

	object_type *o_ptr;

	cptr q, s;
	if (mimic_info[p_ptr->mimic_form].MIMIC_FLAGS & MIMIC_NO_WIELD || p_ptr->clawextend)
	{
		msg_print("̎pł͑ύXłȂB");
		return ;
	}
	if (p_ptr->special_defense & KATA_MUSOU)
	{
		set_action(ACTION_NONE);
	}

	item_tester_no_ryoute = TRUE;
	/* Get an item */
#ifdef JP
	q = "ǂ𑕔͂܂? ";
	s = "͂鑕ȂB";
#else
	q = "Take off which item? ";
	s = "You are not wearing anything to take off.";
#endif
	/*:::OIBꗗŏ\Ȃ̂hook̎w͕sv*/
	if (!get_item(&item, q, s, (USE_EQUIP))) return;

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}

	if(o_ptr->tval == TV_GUN && HAVE_SOLDIER_SKILL(SOLDIER_SKILL_SHOOT,SS_S_QUICK_DRAW)) 
		flag_quickdraw = TRUE;

	///mod140122 
	if(!(wield_check(item,INVEN_PACK))) return;

	///sys EA푰Lqv ij
	//v1.1.28 ƋLqƎdlύX
	/* Item is cursed */
	if (object_is_cursed(o_ptr))
	{
		bool force_remove1 = FALSE; //OtO
		bool force_remove2 = FALSE; //G߂ĊOtO

		if(o_ptr->curse_flags & TRC_PERMA_CURSE)
		{
			msg_print("OȂB̑i̎􂢂͂܂ɂI");
			return;
		}

		if(p_ptr->pclass == CLASS_FLAN) force_remove1 = TRUE;
		if(p_ptr->pclass == CLASS_YUGI) force_remove1 = TRUE;
		if(p_ptr->pseikaku == SEIKAKU_BERSERK) force_remove1 = TRUE;

		if(p_ptr->pclass == CLASS_TSUKUMO_MASTER) force_remove2 = TRUE;
		if(p_ptr->prace == RACE_TSUKUMO) force_remove2 = TRUE;

		if(force_remove1 || force_remove2)
		{
			bool success = FALSE;

			if(o_ptr->curse_flags & TRC_HEAVY_CURSE)
			{
				if(one_in_(7))
				{
					if(force_remove2)
						msg_print("͂ɎꂽiȂ߂ĉƂOĂB");
					else 
						msg_print("͂Ȏ􂢂͂ÂŔI");
					success = TRUE;
				}
				else
				{
					if(force_remove2)
					{
						msg_print("͂ɎꂽiȂ߂ĊOƂsB");
					}
					else
					{
						msg_print("͂Ȏ􂢂͂ÂŔƂRꂽI");
						if(one_in_(2)) 
						{
							msg_print("_[W󂯂I");
							take_hit(DAMAGE_NOESCAPE,randint1(50),"͂Ȏ􂢂͂ŔƂɂ",-1);
						}
					}
				}
			}
			else
			{
				if(one_in_(4))
				{
					if(force_remove2)
						msg_print("ꂽiȂ߂ĉƂOĂB");
					else 
						msg_print("ꂽ͂ÂŔI");
					success = TRUE;
				}
				else
				{
					if(force_remove2)
						msg_print("ꂽiȂ߂悤ƂsB");				
					else
					{
						msg_print("ꂽ͂ÂŔƂRꂽI");
						if(one_in_(4)) 
						{
							msg_print("_[W󂯂I");
							take_hit(DAMAGE_NOESCAPE,randint1(20),"􂢂͂ŔƂɂ",-1);
						}
					}
				}
			}

			if(success)
			{
				o_ptr->ident |= (IDENT_SENSE);

				if(force_remove1)
				{
					o_ptr->curse_flags = 0L;
					/* Take note */
					o_ptr->feeling = FEEL_NONE;
					msg_print("􂢂łjB");
				}
				/* Recalculate the bonuses */
				p_ptr->update |= (PU_BONUS);
				/* Window stuff */
				p_ptr->window |= (PW_EQUIP);
			}
			else
			{
				return;
			}
		}
		else
		{
			msg_print("OȂBǂĂ悤B");
			return;
		}

#if 0
		///class mꂽ𔍂ꏈ
		///mod140119 tr_ǉ@􂢉͂Ȃ
		if ((o_ptr->curse_flags & TRC_PERMA_CURSE) || (p_ptr->pclass != CLASS_TSUKUMO_MASTER && p_ptr->prace != RACE_TSUKUMO && p_ptr->pclass != CLASS_FLAN))
		{
			/* Oops */
#ifdef JP
			msg_print("Ӂ[ށAǂĂ悤B");
#else
			msg_print("Hmmm, it seems to be cursed.");
#endif

			/* Nope */
			return;
		}
		/*:::m͗͂Âő͂@m(ƕtr_)ȊO͂łreturnĂ*/
		if (((o_ptr->curse_flags & TRC_HEAVY_CURSE) && one_in_(7)) || one_in_(4))
		{
#ifdef JP

			if(p_ptr->pclass == CLASS_FLAN ) msg_print("ꂽ͂ÂŔI");
			else msg_print("ꂽiȂ߂ĉƂOĂB");
#else
			msg_print("You teared a cursed equipment off by sheer strength!");
#endif

			/* Hack -- Assume felt */
			o_ptr->ident |= (IDENT_SENSE);

			if(p_ptr->pclass == CLASS_FLAN )
			{
				o_ptr->curse_flags = 0L;
				/* Take note */
				o_ptr->feeling = FEEL_NONE;
#ifdef JP
				msg_print("􂢂łjB");
#else
				msg_print("You break the curse.");
#endif
			}
			/* Recalculate the bonuses */
			p_ptr->update |= (PU_BONUS);

			/* Window stuff */
			p_ptr->window |= (PW_EQUIP);


		}
		else
		{
#ifdef JP
			msg_print("OȂB");
#else
			msg_print("You couldn't remove the equipment.");
#endif
			energy_use = 50;
			return;
		}
#endif

	}


	//\otf
	stop_tsukumo_music();

	/* Take a partial turn */
	if(flag_quickdraw)
	{
		msg_print("Ȃ͑fe[߂B");
		energy_use = 25;
	}
	else
		energy_use = 50;

	/* Take off the item */
	(void)inven_takeoff(item, 255);

	/*:::莝Ȃǂ̍ĔH*/
	kamaenaoshi(item);

	calc_android_exp();

	p_ptr->redraw |= (PR_EQUIPPY);
	/* Window stuff */
	p_ptr->window |= (PW_INVEN | PW_EQUIP | PW_PLAYER);

}


/*
 * Drop an item
 */
/*:::ACe𗎂Ƃ*/
void do_cmd_drop(void)
{
	int item, amt = 1;

	object_type *o_ptr;

	cptr q, s;

	if (p_ptr->special_defense & KATA_MUSOU)
	{
		set_action(ACTION_NONE);
	}

	item_tester_no_ryoute = TRUE;
	/* Get an item */
#ifdef JP
	q = "ǂ̃ACe𗎂Ƃ܂? ";
	s = "ƂACeĂȂB";
#else
	q = "Drop which item? ";
	s = "You have nothing to drop.";
#endif

	///mod160224 ŋACeɏEoOւ̑Ή̂ߑSACe\ON
	//AdR}hs[gŋACeȂǃoOpôł߂
	//item_tester_full = TRUE;
	if (!get_item(&item, q, s, (USE_EQUIP | USE_INVEN)))
	{
		//item_tester_full = FALSE;
		return;
	}
	//item_tester_full = FALSE;

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}

	///mod140122 
	if(!(wield_check(item,INVEN_PACK))) return;


	/* Hack -- Cannot remove cursed items */
	if ((item >= INVEN_RARM) && object_is_cursed(o_ptr))
	{
		///sys EA푰Lqv3
		/* Oops */
#ifdef JP
		msg_print("Ӂ[ށAǂĂ悤B");
#else
		msg_print("Hmmm, it seems to be cursed.");
#endif


		/* Nope */
		return;
	}


	/* See how many items */
	if (o_ptr->number > 1)
	{
		/* Get a quantity */
		amt = get_quantity(NULL, o_ptr->number);

		/* Allow user abort */
		if (amt <= 0) return;
	}


	/* Take a partial turn */
	energy_use = 50;

	/* Drop (some of) the item */
	inven_drop(item, amt);

	if (item >= INVEN_RARM)
	{
		kamaenaoshi(item);
		calc_android_exp();
	}

	p_ptr->redraw |= (PR_EQUIPPY);
}

///sysdel @jŌol𓾂邽߂̔
static bool high_level_book(object_type *o_ptr)
{
	/*
	if ((o_ptr->tval == TV_LIFE_BOOK) ||
	    (o_ptr->tval == TV_SORCERY_BOOK) ||
	    (o_ptr->tval == TV_NATURE_BOOK) ||
	    (o_ptr->tval == TV_CHAOS_BOOK) ||
	    (o_ptr->tval == TV_DEATH_BOOK) ||
	    (o_ptr->tval == TV_TRUMP_BOOK) ||
	    (o_ptr->tval == TV_CRAFT_BOOK) ||
	    (o_ptr->tval == TV_DAEMON_BOOK) ||
	    (o_ptr->tval == TV_CRUSADE_BOOK) ||
	    (o_ptr->tval == TV_MUSIC_BOOK) ||
		(o_ptr->tval == TV_HEX_BOOK))
	{
		if (o_ptr->sval > 1)
			return TRUE;
		else
			return FALSE;
	}
	*/
	return FALSE;
}


/*
 * Destroy an item
 */
/*:::ACe*/
/*:::command_argݒ肳ĂꍇmFȂH*/
void do_cmd_destroy(void)
{
	int			item, amt = 1;
	int			old_number;

	bool		force = FALSE;

	object_type		*o_ptr;
	object_type             forge;
	object_type             *q_ptr = &forge;

	char		o_name[MAX_NLEN];

	char		out_val[MAX_NLEN+40];

	cptr q, s;

	if (p_ptr->special_defense & KATA_MUSOU)
	{
		set_action(ACTION_NONE);
	}

	/* Hack -- force destruction */
	if (command_arg > 0) force = TRUE;


	/* Get an item */
#ifdef JP
	q = "ǂ̃ACe󂵂܂? ";
	s = "󂹂ACeĂȂB";
#else
	q = "Destroy which item? ";
	s = "You have nothing to destroy.";
#endif

	if (!get_item(&item, q, s, (USE_INVEN | USE_FLOOR))) return;

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}

	/* Verify unless quantity given beforehand */
	/*:::command_arg1ȏŃACelłȂmFIvVON̏ꍇmF*/
	if (!force && (confirm_destroy || (object_value(o_ptr) > 0)))
	{
		object_desc(o_name, o_ptr, OD_OMIT_PREFIX);

		/* Make a verification */
		sprintf(out_val, 
#ifdef JP
			"{%s󂵂܂? [y/n/Auto]",
#else
			"Really destroy %s? [y/n/Auto]",
#endif
			o_name);

		msg_print(NULL);

		/* HACK : Add the line to message buffer */
		message_add(out_val);
		p_ptr->window |= (PW_MESSAGE);
		window_stuff();

		/* Get an acceptable answer */
		/*:::ACe󂷂ǂmFAIɂĂ͎j̑Ώۂɒǉ*/
		while (TRUE)
		{
			char i;

			/* Prompt */
			prt(out_val, 0, 0);

			i = inkey();

			/* Erase the prompt */
			prt("", 0, 0);


			if (i == 'y' || i == 'Y')
			{
				break;
			}
			if (i == ESCAPE || i == 'n' || i == 'N')
			{
				/* Cancel */
				return;
			}
			if (i == 'A')
			{
				/* Add an auto-destroy preference line */
				if (autopick_autoregister(o_ptr))
				{
					/* Auto-destroy it */
					autopick_alter_item(item, TRUE);
				}

				/* The object is already destroyed. */
				return;
			}
		} /* while (TRUE) */
	}

	/* See how many items */
	if (o_ptr->number > 1)
	{
		/* Get a quantity */
		amt = get_quantity(NULL, o_ptr->number);

		/* Allow user abort */
		if (amt <= 0) return;
	}


	/* Describe the object */
	old_number = o_ptr->number;
	o_ptr->number = amt;
	object_desc(o_name, o_ptr, 0);
	o_ptr->number = old_number;

	/* Take a turn */
	energy_use = 100;

	/* Artifacts cannot be destroyed */
	/*:::ʐ͉󂹂ȂBӒȂȈՊӒ肷*/
	if (!can_player_destroy_object(o_ptr))
	{
		energy_use = 0;

		/* Message */
#ifdef JP
		msg_format("%s͔js\B", o_name);
#else
		msg_format("You cannot destroy %s.", o_name);
#endif

		/* Done */
		return;
	}

	object_copy(q_ptr, o_ptr);

	/* Message */
#ifdef JP
	msg_format("%s󂵂B", o_name);
#else
	msg_format("You destroy %s.", o_name);
#endif

	sound(SOUND_DESTITEM);

	/* Reduce the charges of rods/wands */
	/*:::bhƖ@_̏[U*/
	reduce_charges(o_ptr, amt);

	/* Eliminate the item (from the pack) */
	if (item >= 0)
	{
		inven_item_increase(item, -amt);
		inven_item_describe(item);
		inven_item_optimize(item);
	}

	/* Eliminate the item (from the floor) */
	else
	{
		floor_item_increase(0 - item, -amt);
		floor_item_describe(0 - item);
		floor_item_optimize(0 - item);
	}

	/*:::ꕔEʖ@󂷂ƌol𓾂鏈*/
	///sysdel class mpfB̖@joll
#if 0
	if (high_level_book(q_ptr))
	{
		bool gain_expr = FALSE;

		if (p_ptr->prace == RACE_ANDROID)
		{
		}
		else if ((p_ptr->pclass == CLASS_WARRIOR) || (p_ptr->pclass == CLASS_BERSERKER))
		{
			gain_expr = TRUE;
		}
		else if (p_ptr->pclass == CLASS_PALADIN)
		{
			if (is_good_realm(p_ptr->realm1))
			{
				if (!is_good_realm(tval2realm(q_ptr->tval))) gain_expr = TRUE;
			}
			else
			{
				if (is_good_realm(tval2realm(q_ptr->tval))) gain_expr = TRUE;
			}
		}

		if (gain_expr && (p_ptr->exp < PY_MAX_EXP))
		{
			s32b tester_exp = p_ptr->max_exp / 20;
			if (tester_exp > 10000) tester_exp = 10000;
			if (q_ptr->sval < 3) tester_exp /= 4;
			if (tester_exp<1) tester_exp = 1;

#ifdef JP
msg_print("XɌoς񂾂悤ȋCB");
#else
			msg_print("You feel more experienced.");
#endif

			gain_exp(tester_exp * amt);
		}
		if (high_level_book(q_ptr) && q_ptr->tval == TV_LIFE_BOOK)
		{
			chg_virtue(V_UNLIFE, 1);
			chg_virtue(V_VITALITY, -1);
		}
		else if (high_level_book(q_ptr) && q_ptr->tval == TV_DEATH_BOOK)
		{
			chg_virtue(V_UNLIFE, -1);
			chg_virtue(V_VITALITY, 1);
		}
	
		if (q_ptr->to_a || q_ptr->to_h || q_ptr->to_d)
			chg_virtue(V_ENCHANT, -1);
	
		if (object_value_real(q_ptr) > 30000)
			chg_virtue(V_SACRIFICE, 2);
	
		else if (object_value_real(q_ptr) > 10000)
			chg_virtue(V_SACRIFICE, 1);
	}
	///sysdel virtue
	if (q_ptr->to_a != 0 || q_ptr->to_d != 0 || q_ptr->to_h != 0)
		chg_virtue(V_HARMONY, 1);
#endif
	if (item >= INVEN_RARM) calc_android_exp();
}


/*
 * Observe an item which has been *identify*-ed
 */
/*:::ACȅڍ׏𒲂ׂ*/
void do_cmd_observe(void)
{
	int			item;

	object_type		*o_ptr;

	char		o_name[MAX_NLEN];

	cptr q, s;

	item_tester_no_ryoute = TRUE;
	/* Get an item */
#ifdef JP
	q = "ǂ̃ACe𒲂ׂ܂? ";
	s = "ׂACeȂB";
#else
	q = "Examine which item? ";
	s = "You have nothing to examine.";
#endif

	if (!get_item(&item, q, s, (USE_EQUIP | USE_INVEN | USE_FLOOR))) return;

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}


	/* Require full knowledge */
	if (!(o_ptr->ident & IDENT_MENTAL))
	{
		///mod150121 d򎞓ꏈ
		if(p_ptr->pclass == CLASS_KEINE && p_ptr->magic_num1[0] )
		{
			msg_print("̃ACeɂĂ̒mɗꍞłI");
			object_aware(o_ptr);
			object_known(o_ptr);
			o_ptr->ident |= (IDENT_MENTAL);
			p_ptr->update |= (PU_BONUS);
			p_ptr->notice |= (PN_COMBINE | PN_REORDER);
			p_ptr->window |= (PW_INVEN | PW_EQUIP | PW_PLAYER);
		}
		else
		{
			msg_print("̃ACeɂēɒmĂ邱Ƃ͂ȂB");
			return;
		}
	}


	/* Description */
	object_desc(o_name, o_ptr, 0);

	/* Describe */
#ifdef JP
	msg_format("%s𒲂ׂĂ...", o_name);
#else
	msg_format("Examining %s...", o_name);
#endif

	/* Describe it fully */
#ifdef JP
	if (!screen_object(o_ptr, SCROBJ_FORCE_DETAIL)) msg_print("ɕςƂ͂Ȃ悤B");
#else
	if (!screen_object(o_ptr, SCROBJ_FORCE_DETAIL)) msg_print("You see nothing special.");
#endif

}



/*
 * Remove the inscription from an object
 * XXX Mention item (when done)?
 */
/*:::ACe̖*/
void do_cmd_uninscribe(void)
{
	int   item;

	object_type *o_ptr;

	cptr q, s;

	item_tester_no_ryoute = TRUE;
	/* Get an item */
#ifdef JP
	q = "ǂ̃ACe̖܂? ";
	s = "ACeȂB";
#else
	q = "Un-inscribe which item? ";
	s = "You have nothing to un-inscribe.";
#endif

	if (!get_item(&item, q, s, (USE_EQUIP | USE_INVEN | USE_FLOOR))) return;

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}

	/* Nothing to remove */
	if (!o_ptr->inscription)
	{
#ifdef JP
		msg_print("̃ACeɂ͏ׂȂB");
#else
		msg_print("That item had no inscription to remove.");
#endif

		return;
	}

	/* Message */
#ifdef JP
	msg_print("B");
#else
	msg_print("Inscription removed.");
#endif


	/* Remove the incription */
	/*:::ւ̃CfbNX폜@quarkɊi[ꂽ{̂ɂ͉Ȃ炵*/
	o_ptr->inscription = 0;

	/* Combine the pack */
	p_ptr->notice |= (PN_COMBINE);

	/* Window stuff */
	p_ptr->window |= (PW_INVEN | PW_EQUIP);

	/* .$̊֌W, ČvZKvȂ͂ -- henkma */
	p_ptr->update |= (PU_BONUS);

}


/*
 * Inscribe an object with a comment
 */
/*:::ACeɖ*/
void do_cmd_inscribe(void)
{
	int			item;

	object_type		*o_ptr;

	char		o_name[MAX_NLEN];

	char		out_val[80];

	cptr q, s;

	item_tester_no_ryoute = TRUE;
	/* Get an item */
#ifdef JP
	q = "ǂ̃ACeɖ݂܂? ";
	s = "߂ACeȂB";
#else
	q = "Inscribe which item? ";
	s = "You have nothing to inscribe.";
#endif

	if (!get_item(&item, q, s, (USE_EQUIP | USE_INVEN | USE_FLOOR))) return;

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];

		if(check_invalidate_inventory(item))
		{
			msg_format("܂̃ACeɂ͐GȂB");
			return;
		}
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}

	/* Describe the activity */
	object_desc(o_name, o_ptr, OD_OMIT_INSCRIPTION);

	/* Message */
#ifdef JP
	msg_format("%sɖށB", o_name);
#else
	msg_format("Inscribing %s.", o_name);
#endif

	msg_print(NULL);

	/* Start with nothing */
	strcpy(out_val, "");

	/* Use old inscription */
	if (o_ptr->inscription)
	{
		/* Start with the old inscription */
		strcpy(out_val, quark_str(o_ptr->inscription));
	}

	/* Get a new inscription (possibly empty) */
#ifdef JP
	if (get_string(": ", out_val, 80))
#else
	if (get_string("Inscription: ", out_val, 80))
#endif
	{
		/* Save the inscription */
		o_ptr->inscription = quark_add(out_val);

		/* Combine the pack */
		p_ptr->notice |= (PN_COMBINE);

		/* Window stuff */
		p_ptr->window |= (PW_INVEN | PW_EQUIP);

		/* .$̊֌W, ČvZKvȂ͂ -- henkma */
		p_ptr->update |= (PU_BONUS);
	}
}



/*
 * An "item_tester_hook" for refilling lanterns
 */
/*:::^ɕ⋋@ق̃^*/
///mod140819 TV_FLASKɑ̃ACe₵̂Ŗ₾Ώۂɂ悤C
static bool item_tester_refill_lantern(object_type *o_ptr)
{
	/* Flasks of oil are okay */
	if (o_ptr->tval == TV_FLASK && o_ptr->sval == SV_FLASK_OIL) return (TRUE);

	/* Laterns are okay */
	if ((o_ptr->tval == TV_LITE) &&
	    (o_ptr->sval == SV_LITE_LANTERN)) return (TRUE);

	/* Assume not okay */
	return (FALSE);
}


/*
 * Refill the players lamp (from the pack or floor)
 */
/*:::^ւ̔R⋋*/
///item ego ^ւ̔R⋋
static void do_cmd_refill_lamp(void)
{
	int item;

	object_type *o_ptr;
	object_type *j_ptr;

	cptr q, s;

	if(check_invalidate_inventory(INVEN_LITE))
	{
		msg_print("܂͌ȂB");
		return;
	}

	if (world_player || SAKUYA_WORLD)
	{
		msg_print("^͓̓悤ɂ߂~߂ĂEE");
		return;
	}


	/* Restrict the choices */
	item_tester_hook = item_tester_refill_lantern;


	/* Get an item */
#ifdef JP
	q = "ǂ̖ڂ璍܂? ";
	s = "ڂȂB";
#else
	q = "Refill with which flask? ";
	s = "You have no flasks of oil.";
#endif

	if (!get_item(&item, q, s, (USE_INVEN | USE_FLOOR))) return;

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}


	/* Take a partial turn */
	energy_use = 50;

	/* Access the lantern */
	j_ptr = &inventory[INVEN_LITE];

	/* Refuel */
	j_ptr->xtra4 += o_ptr->xtra4;

	/* Message */
#ifdef JP
	msg_print("vɖ𒍂B");
#else
	msg_print("You fuel your lamp.");
#endif

	/* Comment */
	if ((o_ptr->name2 == EGO_LITE_DARKNESS) && (j_ptr->xtra4 > 0))
	{
		j_ptr->xtra4 = 0;
#ifdef JP
		msg_print("vĂ܂I");
#else
		msg_print("Your lamp has gone out!");
#endif
	}
	else if ((o_ptr->name2 == EGO_LITE_DARKNESS) || (j_ptr->name2 == EGO_LITE_DARKNESS))
	{
		j_ptr->xtra4 = 0;
#ifdef JP
		msg_print("v͑SȂB");
#else
		msg_print("Curiously, your lamp doesn't light.");
#endif
	}
	else if (j_ptr->xtra4 >= FUEL_LAMP)
	{
		j_ptr->xtra4 = FUEL_LAMP;
#ifdef JP
		msg_print("v̖͈tB");
#else
		msg_print("Your lamp is full.");
#endif

	}

	if(object_is_artifact(o_ptr))
	{
		o_ptr->xtra4 = 0;
		p_ptr->update |= (PU_TORCH | PU_BONUS);
		p_ptr->window |= (PW_INVEN | PW_EQUIP);

		return;
	}

	/* Decrease the item (from the pack) */
	if (item >= 0)
	{
		inven_item_increase(item, -1);
		inven_item_describe(item);
		inven_item_optimize(item);
	}

	/* Decrease the item (from the floor) */
	else
	{
		floor_item_increase(0 - item, -1);
		floor_item_describe(0 - item);
		floor_item_optimize(0 - item);
	}

	/* Recalculate torch */
	p_ptr->update |= (PU_TORCH);
}


/*
 * An "item_tester_hook" for refilling torches
 */
static bool item_tester_refill_torch(object_type *o_ptr)
{
	/* Torches are okay */
	if ((o_ptr->tval == TV_LITE) && (o_ptr->sval == SV_LITE_TORCH) && !object_is_artifact(o_ptr)) return (TRUE);

	/* Assume not okay */
	return (FALSE);
}


/*
 * Refuel the players torch (from the pack or floor)
 */
///item ܂̎΂
static void do_cmd_refill_torch(void)
{
	int item;

	object_type *o_ptr;
	object_type *j_ptr;

	cptr q, s;

	if(check_invalidate_inventory(INVEN_LITE))
	{
		msg_print("܂͏ɐGȂB");
		return;
	}
	if (world_player || SAKUYA_WORLD)
	{
		msg_print("͓̓悤ɂ߂~߂ĂEE");
		return;
	}

	/* Restrict the choices */
	item_tester_hook = item_tester_refill_torch;

	/* Get an item */
#ifdef JP
	q = "ǂ̏Ŗ߂܂? ";
	s = "ɏȂB";
#else
	q = "Refuel with which torch? ";
	s = "You have no extra torches.";
#endif

	if (!get_item(&item, q, s, (USE_INVEN | USE_FLOOR))) return;

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}


	/* Take a partial turn */
	energy_use = 50;

	/* Access the primary torch */
	j_ptr = &inventory[INVEN_LITE];

	/* Refuel */
	j_ptr->xtra4 += o_ptr->xtra4 + 5;

	/* Message */
#ifdef JP
	msg_print("B");
#else
	msg_print("You combine the torches.");
#endif


	/* Comment */
	if ((o_ptr->name2 == EGO_LITE_DARKNESS) && (j_ptr->xtra4 > 0))
	{
		j_ptr->xtra4 = 0;
#ifdef JP
		msg_print("Ă܂I");
#else
		msg_print("Your torch has gone out!");
#endif
	}
	else if ((o_ptr->name2 == EGO_LITE_DARKNESS) || (j_ptr->name2 == EGO_LITE_DARKNESS))
	{
		j_ptr->xtra4 = 0;
#ifdef JP
		msg_print("͑SȂB");
#else
		msg_print("Curiously, your torche don't light.");
#endif
	}
	/* Over-fuel message */
	else if (j_ptr->xtra4 >= FUEL_TORCH)
	{
		j_ptr->xtra4 = FUEL_TORCH;
#ifdef JP
		msg_print("̎͏\B");
#else
		msg_print("Your torch is fully fueled.");
#endif

	}

	/* Refuel message */
	else
	{
#ifdef JP
		msg_print("͂邭PB");
#else
		msg_print("Your torch glows more brightly.");
#endif

	}

	/* Decrease the item (from the pack) */
	if (item >= 0)
	{
		inven_item_increase(item, -1);
		inven_item_describe(item);
		inven_item_optimize(item);
	}

	/* Decrease the item (from the floor) */
	else
	{
		floor_item_increase(0 - item, -1);
		floor_item_describe(0 - item);
		floor_item_optimize(0 - item);
	}

	/* Recalculate torch */
	p_ptr->update |= (PU_TORCH);
}


/*
 * Refill the players lamp, or restock his torches
 */
/*:::R⋋*/
///item TVAL ܂^ւ̔R⋋
void do_cmd_refill(void)
{
	object_type *o_ptr;

	/* Get the light */
	o_ptr = &inventory[INVEN_LITE];

	if (p_ptr->special_defense & KATA_MUSOU)
	{
		set_action(ACTION_NONE);
	}

	/* It is nothing */
	if (o_ptr->tval != TV_LITE)
	{
#ifdef JP
		msg_print("𑕔ĂȂB");
#else
		msg_print("You are not wielding a light.");
#endif

	}

	/* It's a lamp */
	else if (o_ptr->sval == SV_LITE_LANTERN)
	{
		do_cmd_refill_lamp();
	}

	/* It's a torch */
	else if (o_ptr->sval == SV_LITE_TORCH && !object_is_artifact(o_ptr))
	{
		do_cmd_refill_torch();
	}

	/* No torch to refill */
	else
	{
#ifdef JP
		msg_print("͎̌΂ȂB");
#else
		msg_print("Your light cannot be refilled.");
#endif

	}
}


/*
 * Target command
 */
/*:::^[Qbgݒ@lR}hƂǂႤ̂悭*/
void do_cmd_target(void)
{
	/* Target set */
	if (target_set(TARGET_KILL))
	{
#ifdef JP
		msg_print("^[QbgB");
#else
		msg_print("Target Selected.");
#endif

	}

	/* Target aborted */
	else
	{
#ifdef JP
		msg_print("^[QbgB");
#else
		msg_print("Target Aborted.");
#endif

	}
}



/*
 * Look command
 */
void do_cmd_look(void)
{
	/*TEST*/
	p_ptr->window |= PW_MONSTER_LIST;
	p_ptr->window |= PW_FLOOR_ITEM_LIST;
	window_stuff();
	/*TEST*/

	/* Look around */
	if (target_set(TARGET_LOOK))
	{
#ifdef JP
		msg_print("^[QbgB");
#else
		msg_print("Target Selected.");
#endif

	}
}



/*
 * Allow the player to examine other sectors on the map
 */
/*:::}bvn@ڍז*/
void do_cmd_locate(void)
{
	int		dir, y1, x1, y2, x2;

	char	tmp_val[80];

	char	out_val[160];

	int wid, hgt;

	/* Get size */
	get_screen_size(&wid, &hgt);


	/* Start at current panel */
	y2 = y1 = panel_row_min;
	x2 = x1 = panel_col_min;

	/* Show panels until done */
	while (1)
	{
		/* Describe the location */
		if ((y2 == y1) && (x2 == x1))
		{
#ifdef JP
			strcpy(tmp_val, "^");
#else
			tmp_val[0] = '\0';
#endif

		}
		else
		{
#ifdef JP
			sprintf(tmp_val, "%s%s",
				((y2 < y1) ? "k" : (y2 > y1) ? "" : ""),
				((x2 < x1) ? "" : (x2 > x1) ? "" : ""));
#else
			sprintf(tmp_val, "%s%s of",
				((y2 < y1) ? " North" : (y2 > y1) ? " South" : ""),
				((x2 < x1) ? " West" : (x2 > x1) ? " East" : ""));
#endif

		}

		/* Prepare to ask which way to look */
		sprintf(out_val,
#ifdef JP
			"}bvʒu [%d(%02d),%d(%02d)] (vC[%s)  ?",
#else
			"Map sector [%d(%02d),%d(%02d)], which is%s your sector.  Direction?",
#endif

			y2 / (hgt / 2), y2 % (hgt / 2),
			x2 / (wid / 2), x2 % (wid / 2), tmp_val);

		/* Assume no direction */
		dir = 0;

		/* Get a direction */
		while (!dir)
		{
			char command;

			/* Get a command (or Cancel) */
			if (!get_com(out_val, &command, TRUE)) break;

			/* Extract the action (if any) */
			dir = get_keymap_dir(command);

			/* Error */
			if (!dir) bell();
		}

		/* No direction */
		if (!dir) break;

		/* Apply the motion */
		if (change_panel(ddy[dir], ddx[dir]))
		{
			y2 = panel_row_min;
			x2 = panel_col_min;
		}
	}


	/* Recenter the map around the player */
	verify_panel();

	/* Update stuff */
	p_ptr->update |= (PU_MONSTERS);

	/* Redraw map */
	p_ptr->redraw |= (PR_MAP);

	/* Window stuff */
	p_ptr->window |= (PW_OVERHEAD | PW_DUNGEON);

	/* Handle stuff */
	handle_stuff();
}



/*
 * Sorting hook -- Comp function -- see below
 *
 * We use "u" to point to array of monster indexes,
 * and "v" to select the type of sorting to perform on "u".
 */
/*:::ang_sort()Ɏg߂̐֐̂ЂƂH*/
bool ang_sort_comp_hook(vptr u, vptr v, int a, int b)
{
	u16b *who = (u16b*)(u);

	u16b *why = (u16b*)(v);

	int w1 = who[a];
	int w2 = who[b];

	int z1, z2;

	/* Sort by player kills */
	if (*why >= 4)
	{
		/* Extract player kills */
		z1 = r_info[w1].r_pkills;
		z2 = r_info[w2].r_pkills;

		/* Compare player kills */
		if (z1 < z2) return (TRUE);
		if (z1 > z2) return (FALSE);
	}


	/* Sort by total kills */
	if (*why >= 3)
	{
		/* Extract total kills */
		z1 = r_info[w1].r_tkills;
		z2 = r_info[w2].r_tkills;

		/* Compare total kills */
		if (z1 < z2) return (TRUE);
		if (z1 > z2) return (FALSE);
	}


	/* Sort by monster level */
	if (*why >= 2)
	{
		/* Extract levels */
		z1 = r_info[w1].level;
		z2 = r_info[w2].level;

		/* Compare levels */
		if (z1 < z2) return (TRUE);
		if (z1 > z2) return (FALSE);
	}


	/* Sort by monster experience */
	if (*why >= 1)
	{
		/* Extract experience */
		z1 = r_info[w1].mexp;
		z2 = r_info[w2].mexp;

		/* Compare experience */
		if (z1 < z2) return (TRUE);
		if (z1 > z2) return (FALSE);
	}


	/* Compare indexes */
	return (w1 <= w2);
}


/*
 * Sorting hook -- Swap function -- see below
 *
 * We use "u" to point to array of monster indexes,
 * and "v" to select the type of sorting to perform.
 */
/*:::ang_sort()̃NCbN\[gp̓ւ[`*/
void ang_sort_swap_hook(vptr u, vptr v, int a, int b)
{
	u16b *who = (u16b*)(u);

	u16b holder;

	/* Unused */
	(void)v;

	/* Swap */
	holder = who[a];
	who[a] = who[b];
	who[b] = holder;
}



/*
 * Identify a character, allow recall of monsters
 *
 * Several "special" responses recall "multiple" monsters:
 *   ^A (all monsters)
 *   ^U (all unique monsters)
 *   ^N (all non-unique monsters)
 *
 * The responses may be sorted in several ways, see below.
 *
 * Note that the player ghosts are ignored. XXX XXX XXX
 */
/*:::X^[̎vo@ڍז*/
void do_cmd_query_symbol(void)
{
	int		i, n, r_idx;
	char	sym, query;
	char	buf[128];

	bool	all = FALSE;
	bool	uniq = FALSE;
	bool	norm = FALSE;
	bool	ride = FALSE;
	char    temp[80] = "";

	bool	recall = FALSE;

	u16b	why = 0;
	u16b	*who;

	/* Get a character, or abort */
#ifdef JP
	if (!get_com("m肽͂ĉ(L or ^AS,^U,^N,^Rn,^MO): ", &sym, FALSE)) return;
#else
	if (!get_com("Enter character to be identified(^A:All,^U:Uniqs,^N:Non uniqs,^M:Name): ", &sym, FALSE)) return;
#endif

	/* Find that character info, and describe it */
	for (i = 0; ident_info[i]; ++i)
	{
		if (sym == ident_info[i][0]) break;
	}

	/* Describe */
	if (sym == KTRL('A'))
	{
		all = TRUE;
#ifdef JP
		strcpy(buf, "SX^[̃Xg");
#else
		strcpy(buf, "Full monster list.");
#endif
	}
	else if (sym == KTRL('U'))
	{
		all = uniq = TRUE;
#ifdef JP
		strcpy(buf, "j[NEX^[̃Xg");
#else
		strcpy(buf, "Unique monster list.");
#endif
	}
	else if (sym == KTRL('N'))
	{
		all = norm = TRUE;
#ifdef JP
		strcpy(buf, "j[NOX^[̃Xg");
#else
		strcpy(buf, "Non-unique monster list.");
#endif
	}
	else if (sym == KTRL('R'))
	{
		all = ride = TRUE;
#ifdef JP
		strcpy(buf, "n\X^[̃Xg");
#else
		strcpy(buf, "Ridable monster list.");
#endif
	}
	/* XTRA HACK WHATSEARCH */
	else if (sym == KTRL('M'))
	{
		all = TRUE;
#ifdef JP
		if (!get_string("O(p̏ꍇŉ)",temp, 70))
#else
		if (!get_string("Enter name:",temp, 70))
#endif
		{
			temp[0]=0;
			return;
		}
#ifdef JP
		sprintf(buf, "O:%sɃ}b`",temp);
#else
		sprintf(buf, "Monsters with a name \"%s\"",temp);
#endif
	}
	else if (ident_info[i])
	{
		sprintf(buf, "%c - %s.", sym, ident_info[i] + 2);
	}
	else
	{
#ifdef JP
		sprintf(buf, "%c - %s", sym, "ȕ");
#else
		sprintf(buf, "%c - %s.", sym, "Unknown Symbol");
#endif
	}

	/* Display the result */
	prt(buf, 0, 0);

	/* Allocate the "who" array */
	C_MAKE(who, max_r_idx, u16b);

	/* Collect matching monsters */
	for (n = 0, i = 1; i < max_r_idx; i++)
	{
		monster_race *r_ptr = &r_info[i];

		///mod140712 σp[^X^[/R}hQƂłȂ悤ɂ
		if(r_ptr->flags7 & RF7_VARIABLE) continue;

		/* Nothing to recall */
		if (!cheat_know && !r_ptr->r_sights) continue;

		/* Require non-unique monsters if needed */
		if (norm && (r_ptr->flags1 & (RF1_UNIQUE))) continue;

		/* Require unique monsters if needed */
		if (uniq && !(r_ptr->flags1 & (RF1_UNIQUE))) continue;

		/* Require ridable monsters if needed */
		if (ride && !(r_ptr->flags7 & (RF7_RIDING))) continue;

		/* XTRA HACK WHATSEARCH */
		if (temp[0])
		{
		  int xx;
		  char temp2[80];
  
		  for (xx=0; temp[xx] && xx<80; xx++)
		  {
#ifdef JP
		    if (iskanji( temp[xx])) { xx++; continue; }
#endif
		    if (isupper(temp[xx])) temp[xx]=tolower(temp[xx]);
		  }
  
#ifdef JP
		  strcpy(temp2, r_name+r_ptr->E_name);
#else
		  strcpy(temp2, r_name+r_ptr->name);
#endif
		  for (xx=0; temp2[xx] && xx<80; xx++)
		    if (isupper(temp2[xx])) temp2[xx]=tolower(temp2[xx]);
  
#ifdef JP
		  if (my_strstr(temp2, temp) || my_strstr(r_name + r_ptr->name, temp) )
#else
		  if (my_strstr(temp2, temp))
#endif
			  who[n++]=i;
		}

		/* Collect "appropriate" monsters */
		else if (all || (r_ptr->d_char == sym)) who[n++] = i;
	}

	/* Nothing to recall */
	if (!n)
	{
		/* Free the "who" array */
		C_KILL(who, max_r_idx, u16b);

		return;
	}


	/* Prompt XXX XXX XXX */
#ifdef JP
	put_str("vo܂? (k:œ|/y/n): ", 0, 36);
#else
	put_str("Recall details? (k/y/n): ", 0, 40);
#endif


	/* Query */
	query = inkey();

	/* Restore */
	prt(buf, 0, 0);

	why = 2;

	/* Select the sort method */
	ang_sort_comp = ang_sort_comp_hook;
	ang_sort_swap = ang_sort_swap_hook;

	/* Sort the array */
	ang_sort(who, &why, n);

	/* Sort by kills (and level) */
	if (query == 'k')
	{
		why = 4;
		query = 'y';
	}

	/* Catch "escape" */
	if (query != 'y')
	{
		/* Free the "who" array */
		C_KILL(who, max_r_idx, u16b);

		return;
	}

	/* Sort if needed */
	if (why == 4)
	{
		/* Select the sort method */
		ang_sort_comp = ang_sort_comp_hook;
		ang_sort_swap = ang_sort_swap_hook;

		/* Sort the array */
		ang_sort(who, &why, n);
	}


	/* Start at the end */
	i = n - 1;

	/* Scan the monster memory */
	while (1)
	{
		/* Extract a race */
		r_idx = who[i];

		/* Hack -- Auto-recall */
		monster_race_track(r_idx);

		/* Hack -- Handle stuff */
		handle_stuff();

		/* Interact */
		while (1)
		{
			/* Recall */
			if (recall)
			{
				/* Save the screen */
				screen_save();

				/* Recall on screen */
				screen_roff(who[i], 0);
			}

			/* Hack -- Begin the prompt */
			roff_top(r_idx);

			/* Hack -- Complete the prompt */
#ifdef JP
			Term_addstr(-1, TERM_WHITE, " ['r'vo, ESC]");
#else
			Term_addstr(-1, TERM_WHITE, " [(r)ecall, ESC]");
#endif

			/* Command */
			query = inkey();

			/* Unrecall */
			if (recall)
			{
				/* Restore */
				screen_load();
			}

			/* Normal commands */
			if (query != 'r') break;

			/* Toggle recall */
			recall = !recall;
		}

		/* Stop scanning */
		if (query == ESCAPE) break;

		/* Move to "prev" monster */
		if (query == '-')
		{
			if (++i == n)
			{
				i = 0;
				if (!expand_list) break;
			}
		}

		/* Move to "next" monster */
		else
		{
			if (i-- == 0)
			{
				i = n - 1;
				if (!expand_list) break;
			}
		}
	}

	/* Free the "who" array */
	C_KILL(who, max_r_idx, u16b);

	/* Re-display the identity */
	prt(buf, 0, 0);
}


/*:::݂̎푰EƂȂǂőIACe𑕔i邢͑Oj\`FbNB*/
/*:::slot̓ACȇӏINVEN_???ԍ ĂꍇꂪO邱ƂɂȂB*/
/*:::item_new͐VACeINVEN_???ԍiUbNj邢͕̏ꍇo_listY*/
/*:::OAƂApŐVɑ̂Ȃitem_newɂ͂ӂ̈INVEN_PACKĂ̊֐ĂԂƂɂB*/
/*:::ŖȂƂ͎vȂ炩ȂЂǂB|C^܂ɂ悭ĂȂB*/
///mod140914 j[NNXΉʂȂǂŎ푰ϗeOĂ͂Ȃ̂OĂ܂̂ŏύX
//slot==item_neŵƂOKɂĂ
bool wield_check( int slot, int item_new)
{
	object_type *o_ptr_old = &inventory[slot];
	object_type *o_ptr_new;

	if(slot < INVEN_RARM) return TRUE;

	if(item_new >= 0) o_ptr_new = &inventory[item_new];
	else			  o_ptr_new = &o_list[0 - item_new];


	//msg_format("slot:%d oldTV:%d newTV:%d",slot, o_ptr_old->tval, o_ptr_new->tval);

	if (mimic_info[p_ptr->mimic_form].MIMIC_FLAGS & MIMIC_NO_WIELD)
	{
		msg_print("͑ύXłȂB");
		return (FALSE);
	}

	if(check_invalidate_inventory(slot))
	{
		msg_print("̑ύX邱Ƃ͂łȂB");
		return (FALSE);
	}

	//푰
	/*:::V͏ɓ݂𑕔*/
	if(p_ptr->prace == RACE_KARASU_TENGU || p_ptr->prace == RACE_HAKUROU_TENGU){
		if(slot == INVEN_HEAD && o_ptr_new->sval != SV_HEAD_TOKIN)
		{
			msg_print("Ȃ͓ɓ݂𑕔ȂƂȂB");
			return (FALSE);
		}
	}


	if(p_ptr->pclass == CLASS_KOKORO)
	{
		if(slot == INVEN_HEAD && o_ptr_new->tval == TV_HEAD)
		{
			msg_print("Ȃ̖͊ʈȊO肽͂ȂB");
			return (FALSE);
		}
	}
	if(p_ptr->pclass == CLASS_ALICE)
	{
		if(slot == INVEN_HANDS)
		{
			msg_print("Ɛl`𑀂ȂB");
			return (FALSE);
		}
		if(object_is_weapon(o_ptr_new))
		{
			msg_print("Ȃ͎畐͂ȂB");
			return (FALSE);
		}
		else if(slot == INVEN_RARM)
		{
			msg_print("Ɛl`𑀂ȂB");
			return (FALSE);
		}
	}
	if(p_ptr->pclass == CLASS_BENBEN || p_ptr->pclass == CLASS_YATSUHASHI)
	{
		if(slot == INVEN_HANDS)
		{
			msg_print("܂͉t̎זB");
			return (FALSE);
		}
	}

	//O
	if(p_ptr->pclass == CLASS_3_FAIRIES && slot >= INVEN_RIGHT && slot <= INVEN_FEET && slot != INVEN_LITE)
	{
		int i;
		int cnt = 0;
		for( i= INVEN_RIGHT;i<=INVEN_FEET;i++)
		{
			if(i == INVEN_LITE) continue;
			if(!inventory[i].k_idx) continue;
			if(i == slot) continue;

			if(inventory[i].tval == o_ptr_new->tval) cnt++;
			else if(wield_slot(&inventory[i]) == wield_slot(o_ptr_new)) cnt++;

		}
		if(cnt > 2)
		{
			msg_print("łɎOlƂ̕ʂ̑ĂB");
			return (FALSE);
		}
	}


	if(p_ptr->pclass == CLASS_MAID || p_ptr->pclass == CLASS_SAKUYA)
	{
		if(slot == INVEN_BODY && p_ptr->psex == SEX_MALE && (o_ptr_new->tval != TV_CLOTHES || o_ptr_new->sval != SV_CLOTH_SUIT))
		{
			msg_print("Ȃ͏ɃX[c𒅗pȂƂȂB");
			return (FALSE);
		}
		if(slot == INVEN_BODY && p_ptr->psex == SEX_FEMALE &&  (o_ptr_new->tval != TV_CLOTHES || o_ptr_new->sval != SV_CLOTH_MAID))
		{
			msg_print("Ȃ͏ɃCh𒅗pȂƂȂB");
			return (FALSE);
		}
	}
	else if(p_ptr->pclass == CLASS_KISUME)
	{
		if(slot == INVEN_BODY && (o_ptr_new->tval != TV_ARMOR || o_ptr_new->sval != SV_ARMOR_TUB))
		{
			msg_print("Ȃ͉oȂB");
			return (FALSE);
		}
	}
	//v1.1.37
	if(p_ptr->mimic_form == MIMIC_KOSUZU_HYAKKI && o_ptr_old->name1 == ART_HYAKKI && slot != item_new)
	{
		msg_print("͊GȂB");
		return (FALSE);
	}

	/*:::Pꏈ@OȂ*/
	///mod151101 _̓Pƃx[XACepFXsł̂ŌpڂB͉ƕ悤B
	if(p_ptr->pclass == CLASS_KOGASA 
		&& o_ptr_old->tval == TV_STICK && o_ptr_old->sval == SV_WEAPON_KOGASA && o_ptr_old->weight == 30 && slot != item_new)
	{
		msg_print("Ƃ͂łȂBƂ͂Ȃ̖{̂B");
		return (FALSE);
	}

	if(p_ptr->pclass == CLASS_IKU && slot == INVEN_OUTER && o_ptr_old->name1 == ART_HEAVENLY_MAIDEN && slot != item_new)
	{
		msg_print("厖ȉH߂BȂ悤ɂ悤B");
		return (FALSE);
	}
	if(p_ptr->pclass == CLASS_YUGI  && o_ptr_old->tval == TV_SHIELD && o_ptr_old->sval == SV_SAKAZUKI && slot != item_new)
	{
		msg_print("͂ȂB");
		return (FALSE);
	}
	if(p_ptr->pclass == CLASS_EIKI && 
		!ironman_no_fixed_art && 
		(object_is_melee_weapon(o_ptr_new) && o_ptr_new->name1 != ART_EIKI
		|| o_ptr_old->name1 == ART_EIKI && slot != item_new))
	{
		msg_print("Ȃ͉̖_ȊÔ̂U邤͂ȂB");
		return (FALSE);
	}

	/*:::lAjÂ͌C𗚂Ȃ@OƂ͂ł邪ɗɎIɊO\*/
	if(p_ptr->muta3 & MUT3_FISH_TAIL || p_ptr->prace == RACE_NINGYO  || p_ptr->pclass == CLASS_TOZIKO || p_ptr->pclass == CLASS_KISUME){
		if(slot == INVEN_FEET && o_ptr_new->tval != 0)
		{
			msg_print("Ȃ͌C𗚂ƂłȂB");
			return (FALSE);
		}
	}
	/*:::Ԕ؊͎Ȃ*/
	if(p_ptr->pclass == CLASS_BANKI ){
		if(slot == INVEN_NECK && o_ptr_new->tval != 0)
		{
			msg_print("Ȃ͎ȂB");
			return (FALSE);
		}
	}
	//͎wւpR}h瑕B
	//܂艿iȉ̂̂𑕔łȂB{c
	if (p_ptr->pclass == CLASS_JYOON) 
	{
		if (slot >= INVEN_RIGHT && slot <= INVEN_LEFT)
		{
			msg_print("wւ̑͐EƓZR}hsB");
			return (FALSE);
		}
		/*
		if (o_ptr_new->k_idx && object_is_cheap_to_jyoon(o_ptr_new))
		{
			msg_print("Ȃ͂Ȉ𑕔ȂB");
			return (FALSE);
		}

		if (o_ptr_old->k_idx && object_is_cheap_to_jyoon(o_ptr_old) && slot != item_new)
		{
			msg_print("̂悤Ȉ͓xƐgɂ邱Ƃ͂Ȃ낤B");
			if (!get_check_strict("{ɍ̑O܂H", CHECK_OKAY_CANCEL))
			{
				return FALSE;
			}
		}
		*/

	}

	/*:::pĂƊԂȂ*/
	if(p_ptr->muta2 & (MUT2_BIGHORN) || p_ptr->pclass == CLASS_KASEN){
		if(slot == INVEN_HEAD && ( 
			o_ptr_new->sval == SV_HEAD_METALCAP 
		||  o_ptr_new->sval == SV_HEAD_STARHELM 
		||  o_ptr_new->sval == SV_HEAD_STEELHELM 
		||  o_ptr_new->sval == SV_HEAD_DRAGONHELM 
			))
		{
			if(p_ptr->pclass == CLASS_KASEN)
				msg_print("Ȃ͂𑕔łȂB");
			else
				msg_print("pזŊԂȂB");
			return (FALSE);
		}
	}

	if(p_ptr->pclass == CLASS_HECATIA)
	{
		if(slot == INVEN_HEAD && ( 
			o_ptr_new->sval == SV_HEAD_METALCAP 
		||  o_ptr_new->sval == SV_HEAD_STARHELM 
		||  o_ptr_new->sval == SV_HEAD_STEELHELM 
		||  o_ptr_new->sval == SV_HEAD_DRAGONHELM ))
		{
			msg_print("Ȃ͊𑕔łȂB");
			return (FALSE);
		}
	}


	if(p_ptr->muta3 & MUT3_PEGASUS){
		if(slot == INVEN_HEAD && o_ptr_new->tval != 0)
		{
			msg_print("Ȃ͍ɉłȂB");
			return (FALSE);
		}
	}


	if(p_ptr->prace == RACE_KOBITO || p_ptr->pclass == CLASS_NINJA)
	{
		if(((slot == INVEN_RARM || slot == INVEN_LARM) && o_ptr_new->weight > 60) 
			|| (slot == INVEN_BODY && o_ptr_new->weight > 100)
			|| (slot == INVEN_HEAD && o_ptr_new->weight > 50)
			|| (slot == INVEN_HANDS && o_ptr_new->weight > 30)
			|| (slot == INVEN_FEET && o_ptr_new->weight > 30))
		{
			msg_print("𑕔ƏdĂ܂ȂB");
			return (FALSE);

		}
	}

	if(p_ptr->pclass == CLASS_NINJA)
	{
		if(o_ptr_new->tval == TV_SHIELD) 
		{
			msg_print("͓̎זB");
			return (FALSE);

		}
	}

	return (TRUE);
}

