/* Purpose: create a player character */

/*
 * Copyright (c) 1997 Ben Harrison, James E. Wilson, Robert A. Koeneke
 *
 * This software may be copied and distributed for educational, research,
 * and not for profit purposes provided that this copyright and statement
 * are included in all such copies.  Other copyrights may also apply.
 */

#include "angband.h"

/*
 * How often the autoroller will update the display and pause
 * to check for user interuptions.
 * Bigger values will make the autoroller faster, but slower
 * system may have problems because the user can't stop the
 * autoroller for this number of rolls.
 */
#define AUTOROLLER_STEP 5431L

/*
 * Define this to cut down processor use while autorolling
 */
#if 0
#  define AUTOROLLER_DELAY
#endif

/*
 * Maximum number of tries for selection of a proper quest monster
 */
#define MAX_TRIES 100

//#define MAX_CLASS_CHOICE     MAX_CLASS
///mod140202 j[NvC[̂߂ɒʏIEƔԍőʂɂ
#define MAX_CLASS_CHOICE     27


static bool old_data_cheat_flag = FALSE;
static bool old_collector = FALSE;

/*
 * Forward declare
 */
typedef struct hist_type hist_type;

/*
 * Player background information
 */
struct hist_type
{
	cptr info;			    /* Textual History */

	byte roll;			    /* Frequency of this entry */
	byte chart;			    /* Chart index */
	byte next;			    /* Next chart index */
	byte bonus;			    /* Social Class Bonus + 50 */
};

///del1401 bg[]ƂĐ̃ev͂S




static cptr info_difficulty[5] ={
	"Kp̃[hłBvC[̔\͂オAQ[I[o[ɂȂĂReBj[\łB̃[h50KŏI܂BXRA啝ɒቺ܂B",
	"ʏ̃[hłBG̗̑͂ႭA܂܂ЂǂƂNɂ悤ɒĂ邽ߖ{Ƃ̕ϋؓ{肩ȂȒPłB50KNA_ŃQ[NAɂȂ܂B",
	"G͋ȂA΂ΏՂ狭GoA̎ɕsKo܂B{Iɖ{ƕϋؓ{Ɠl̐ݒłł{ƕϋؓ{ȒPłBXRA㏸܂BHARDȍ~łȂƑIłȂEƂ␫i݂܂B",
	"G܂͋fӐ[ȂAL蓾Ȃقǂ̋GpɂɏoAssȂ܂ł̗lXȍȂɏP|܂BXRA啝ɏ㏸܂B",
	"ɂ߂ēȃ[hłBS1KQ[Jnꂻ~݂̂łBxオ₷ȂA[w̃ACeo₷ȂAՕi܂Ƃ߂ĐAuACeJ[hvo܂B_NGXg͂ȂȂAKƂɓ̃NGXg_W܂B\Sȏ𐮂ȂōőPsƂ߂܂B"
};

static cptr race_jouhou[MAX_RACES] =
{
#ifdef JP
"Ȃ͕ʂ̐lԂłBlԂ͎ɐlɏZł܂AOEł邱Ƃ܂Bẑق̏ZlBɔׂƎZ̓IɂnłȂɂ͓Mׂ̂܂BGł_ȂɎ_炵_ȂAǂ̂悤ȐEƂłȂɂȂƂ\łB",
  
"Ȃ͌ẑɐݒႫd̈lłBႢƌĂySN͐Ă邩܂񂵁AЂƂƍ܂ꂽ΂肩܂Bd͈ʂɒʏ̐lԂ傫g̔\͂܂AƂl̂͋ŏptɂ͌܂B͔jׂ̍UɎキAjב̍U▂@ɂ傫ȃ_[W󂯂Ă܂܂B",
  
"Ȃ͐lԂƗd̃n[tłBʏ̐lԂ͂vȑ̂AxオƓłɑ΂ϐ𓾂܂B܂rIȂHŊ邱Ƃ\łB_炵_͎Aǂ̂悤ȐEƂłȂɂȂ܂BlԂɔׂƒ܂ÂԂ񐬒xȂ܂B",
  
"Ȃ͐lłBCs̉ʂĂɎAȂ鍂݂߂ďCs𑱂Ă܂Bg̔\͂͏l݂ł̐_͌܂ĂAƂɐpƂɊւĂ͍ōNX̓K܂B܂킸ȐHƂŊ邱Ƃ\łBėlXȂƂoĂ߂␬xȂ܂B{̎𖳗ɐL΂Ă邽߂΂Βn̎hqɑ_܂BxオƍȂǂɑ΂ϐ𓾂܂B",
  
"Ȃ͓VȄZlłBX̂r񂾂xƎRC܂܂ɕ炵Ă܂Aʏ̐lԂꡂɗ킷퓬\͂܂Bpɑ΂čōNX̓K܂dp͑SƌĂقǈ܂B𐶂Ă̂Őx͊ɖłBlƓlɂ΂Βn̎hqɑ_܂BVl̐ȓ͔̂jׂ̗͂ɂUS󂯕t܂񂪁AVl̓̂ɑŌ^U݂܂B",
  
"Ȃ͗dłBd͎R̗͂̋Ōz̎鏊ɏo܂BYDłȐ퓬sׂ͐]IɕsłBg̔\́AmƂɌׂƂ͂قƂǂ܂B̏㎩bƂzȂߐxɖłBBB邱Ƃ͓ӂłB`SłΑ傫ȗ_ƂȂ邱Ƃł傤B",
  
"Ȃ͉͓łBӂɏZ݉jB҂Ő΂ɓM邱Ƃ܂Bd̂ɂ͂قǋxȓ̂Ă܂񂪁A̒ł͌Ⴆ悤ȗ͋𔭊܂BrL΂ĉ̓GɍUƓ̓Z܂B̑ϐ̂قAΎ_ւ̑ϐl܂d͋łB͓GWjAɂȂꍇ͐_ƂȂ͂ȋ@B܂B",
  
"Ȃ͖@głBŌ@gƂ͐EƂł͂ȂA@̒T̉ʂĂɎ̖@Ŏ悤ɂȂҒB̂Ƃ܂B͐lԂł҂̂ł܂̖@g݂܂Bg̔\͕͂nł̒mƖ@Sʂւ̓K͐łBxオɂꂻ̐_͂ɌS𑝂Am\ቺUւ̑ϐl܂B܂ɐڐGĖ͂z邱Ƃł悤ɂȂ܂B@g͖͂ŊĂ邽߈؂̐HȂĂ|܂B",
  
"ȂVłBV͗d̎Rň吨͂zWcŁAV͂̒ŕ񓹕̖SĂ܂Bɂ߂čqւAmrIdp⎩R̐p𓾈ӂƂĂ܂BȃJgĂG̒eU{g@Ė邱Ƃ܂BV͓Ɂu݁v𑕔Ȃ΂Ȃ܂B",
  
"Ȃ͔TVłBV͗d̎Rň吨͂zWcŁATV͂̒Ŏqc̖SĂ܂B\͂ƒTm\͂ւAƗ͂ŉߍȊɓK邱Ƃł܂BV͓Ɂu݁v𑕔Ȃ΂Ȃ܂B",
  
"Ȃ͋SłBS͌Âp鋭͂ȗdŁAS푰ō̍rƑ̗͂ւ蔒ł͂炭ŋłBŏ׍Hɗ邱ƂD܂@TȂǂ͋łBS͗hȊp𓪂ɐ₵ĂA͊iɋ͂ȕƂċ@\܂ꕔ̓hłȂȂfbg܂BȂ̑ѐH炢Ȃ̂ŐHƂ͑߂Ɏ܂傤B",
  
"Ȃ͎_łB_͔ފ݂̏ZlŁAOr̐̑D腖l̍ٔ̏LȂǑʂȖEɏ]Ă܂B퓬\͍͂AჂ⍬ȂǑ̍Uɑϐ܂B劙𑕔ƉƂȂtĕ̈З͂㏸܂B",
  
"Ȃ͏blłBbl͐lƏb̗̓݂ŁA܂̏blƏbllԂƐlbɕ܂B̏bl͐lԂ荂g̔\͂ÄŒm͒ቺĂ܂B̔ӂɂ͗͂܂Bbl͏b̉sqȊoA댯@邱ƂӂłB",

"Ȃ͕tr_łBtr_͌Â݂ŁA_̈łԂ͂قڗdłB퓬\͂͂߂łA̐S킩̂㩉▂gpӂłBxオƎ􂢂̂̂𑕔Ă̈eɘa邱Ƃ\ɂȂ܂Bʏ̐̐g̍\ȂߓłڒׂȂǂ̉e܂󂯂܂BH̑ɖ̃GlM[zĉh{𓾂܂BjׂƗ򉻍U_łB",

"Ȃ͗dƂĎ𓾂Âl`ŁAtr_̈łBG|Ƃł͌ol𓾂邱ƂłAgɂ̗̗͂͂ƓăxAbv܂B͂ȕɎɓΈCɖ`yɂȂ邱Ƃł傤Bǂ炩ƂƏpmm̓܂Bdl`͖@̏Ȃǂ疂͂zĉh{ɂ܂B͂ŊĂ邽ߗ򉻍U_łBl`̑̂̂ߓłCɂقAƋ|⋶Cɑ΂ϐ𓾂܂B",
  
"Ȃ͌痈dełB̖hqƂĐ퓬PςłߗlXȋZ\ɏGł܂Aӂ҂̂ߐ͂x߂łB傫ȎgĂǂɂẲ\𕷂Ƃł܂BqȂ̏Zl̂ߔj׍Uɑϐ܂Aꕔ̍Uɑ΂Ă͑Ō󂯂Ă܂܂B",
  
"Ȃ͐ldςłBd̊ɂ͔͂łd炵ʍmpmɌĂ܂BƂɕϐgp𓾈ӂƂĂ܂BEƂɊ֌WȂGf킹\͂ĂAƐ_m\͂l܂Bɏb̉sqȊoĂ邽ߐ\͂߂łBxɂȂƎ኱̐_i𓾂Ĕjׂ_ƂȂȂ邱Ƃ܂B͂Ȏ푰łɂ͂ⒷԂ܂B",
  
"Ȃ͗ɏオ͓łBŋ߃ToCoQ[ɋ邱Ƃߕʂ͓̉菭\͂㏸Ă܂B܂d_ƂȂȂĂ܂A֌W̓ZĂ܂B",
  
"Ȃ͐ldKłBmɒĂϐgɂĐlx邱ƂD݂܂Aeł͂܂BƉ̂悤ɎpēG̍U]ZK܂B",
  
"Ȃ͐lłBlԂ̏㔼gƋȋ̉gĂ܂BȔ̂ߌC𗚂ƂłAVɒnɂꍇړx܂Bł͋ɂ߂đfsłAߐڐ퓬̂Ƃ傫ȔɂŌɂ͂Ȃ̈З͂҂ł܂B@̓KႭ͂ȂɗdpӂłB",
  
"Ȃ̓ztSułBƂɍKƂ~̌㊘ƂČzɏꂽ̂̌ڂ̂܂̕|ɐlǂoĂ܂C̓łȗdłBc݂̑̊îߓe͂łAZ\␬ɊւĂ͈ĊODGłBƓłƖჂɑ΂ϐ𓾂܂B",
  
"Ȃ͓łBhȑ̊i܂o傫Ȃ菬Ȃƒ݂͂ǂ̂ȂdłB̞̎̂Bɂ蕨h͂AƖჁAjЁAUɑ΂ϐ𓾂܂Bm̔\͂@̏K͋łAϗe̗dp͓ӂłB",
  
"Ȃ͏łB͂܂͂Ȃ̑̂łBm\߂łpm̔\͂܂eȂɂȂ܂BpƗdpӂŐp͂ȂłB͈ÍƒnUւ̑ϐِE̜܂݂ڂɂĂ܂舫e󂯂܂񂪁Aj׍Uɂ蕁ʂ̗dȏ̑Ō󂯂Ă܂܂B",
  
"Ȃ͖@ɂĉ̖𐁂܂ꂽΉłBr͂Ƒϋv͂܂͋ɂ߂ĊɖݏdłBmقƂǂȂ@̏K͋ɂ߂čłB΂̑̂̂ߑ̍Uɑϐ܂A(DISENCHANT)̍Uɑ΂Ă͑Ō󂯂Ă܂܂BHƂ͊zΗނŁAAȍz΂HׂƑ̗͂񕜂LȌʂo邱Ƃ܂Bxオƃ_W̕ǂ̂܂ܐHׂ邱Ƃo悤ɂȂ܂B",
  
"Ȃ͏lłBʂ̐lԂ̕Gx̐gȂꑰŁA̗͂͗dHɂS푰ŒłB̏゠܂̑̂̏̂ߏd̂𑕔ł܂BB\͂Ɖ\͂͌Q𔲂čÂȂ̑S푰ňԂłBT▂gpӂłB",
  
"Ȃ͑嗤̖@ɂđꕅsƂĂ鎀̂łB̂dႭł܂񂪎ԂĒb΂Ȃɏ_ȓł悤ɂȂ܂Br͂Ƒϋv͍͂łnÍȂǗlXȍUւ̑ϐ܂j׍Uɑ΂ɂ߂ĐƎłB",
  
"Ȃ͋͂Ȗő̈łBlԂꡂɒg̔\͂ɉsgƌقǂ̑ϋv͂ւ܂B̖ɂȂƂ̗͍͂Xɑ܂AzƎ̉Ă܂܂B̑ɑ΂R͂_AMƐ̍Uő_[W󂯁Aj׍Uł͂ɐrȃ_[W󂯂Ă܂܂BeƖ@̗ӂłp͋łBzS͌ȂĂÂ_Wʂ\͂Ă܂Bʏ̐Hł͋󕠂𖞂ƂłAɊ݂Čtz邱Ƃŉh{𓾂܂B",
  
"Ȃ͎ĂȂɗ܂鍰łBǂ蔲邱ƂłA_WTɂĔɗLłB̂󔖂Ȃߔ\͂Ƒϋv͍͂ŒNXłBn̗͂ɑ΂ĊSȖƉuAłjЂƂ댯ȍUɂϐ܂AƔjׂ̍Uɑ΂Ă͔ɐƎłBxAbvɂ߂̎vOm\͂𓾂܂BȂAH͕ʂɐۂ܂B",
  
"ȂJ_ЂȂGȐ_l̂̈ꒌŁAMقڎRłЂ炵Ă܂B`ʂėlXȌoςނƂŐMW܂AxɂȂƐVȐ_𓾂Ď푰Iȓ傫ς܂Bǂ̂悤ɕω邩ɂĂ͗lXȗvfɉe܂AႦΖ̂鋭G|NGXgȂĖ߂邱Ƃ͑̏ꍇǂʂ炷ł傤BȂAȂŏ̐_lȂ̂͑S_Ɍ܂܂B",
  
"Ȃ͒ė͂~dłBʂ̗d薾炩ɋ͂܂AȂɂƂĂׂ̐̂Ă͌ꂽ̂΂Ȃ̂Ő̑x͋ɂ߂ĊɖłBdƂ͂ˑRƂĔj׍U͂Ȃ̎_łB",
  
"Ȃ͂炩̐_lԂłBȂ̂\͂Aʏ̐lԂS̓IȔ\͂⍂߂łBxオƒxƋ}񕜂̔\͂𓾂܂B͐lԂ菭xȂAXRAቺ܂B",

"Ȃ͂񂲂ƂȂɂnɍ~ĂM̖łBdQ̓sŉi߂Ă߁Am͕̒nl̋yԂƂł͂܂B	Ȃ͎̓Ɛ̑uqvƂċĂ܂B̂ߗdpɕނ閂@܂g⎩R̖@̋łB	Ȃ͔j׍Uɑ΂銮SȖƉu܂Aqꂽ͂ōUƑ_[W󂯂Ă܂܂BlXȋZ\ɗD܂܂eD݂܂B",
  
"Ȃ͕̃jW\E̜߈˂ɂăjWƂĐ܂ς܂B",
  
"Ȃ͋ɂ߂ĒlԂƗH̃n[tłBꌩʂ̐lԂƕς܂񂪂悭Ɖɐlӂӂ핂łAȂ̑̂̈ꕔłB",
  
"Ȃ͖{͐lԂ̕Gx̔w䂵ȂlłA͏Ƃ̗͂ŐlԑɂȂĂ܂B",
  
"Ȃ͎p̉`ɂ苭͂ȃAfbhɓ]܂B@Ɋւ\͂Iɏ㏸A̎׈ȓZK܂Beɂ͑S܂񂪁AȂ͓̂ɗ炸키@ɏ[ɒmĂ܂Bϋv͂ϐDGłAj׍U󂯂ƔQ͋ɂ߂ĐrłB",
  
"Ȃ͋ɂ̐̂łB鐶̎\͂sgł܂B",

"Ȃ́AlXȕɏh{_b`ɂ؂`Âꂽ݂łBʏ̐△Ƃ͑SقȂ݂Ă邽߁A푰ϗe󂯕t܂B",

"Ȃ͏qłBOEŗBꖳ̍ŋG̎푰łB",

"Ȃ͋֒f̔ɂĕsVsƂȂ݂łB푰ϗeAˑRψق󂯕t܂B܂ϐgn̖@ʂ𔭊܂B",

"Ȃ͂ĂnlłA@̗͂ɂĐ𓾂ēo܂BS[Ɩ@g̒Ԃ̂悤ȑ݂ŁAHKvƂvȑ̂@ւ̓K߂łB͂ȂɖŒӗ͂ɂĂ܂B"

#else

"The human is the base character.  All other races are compared to them.  Humans can choose any class and are average at everything.  Humans tend to go up levels faster than most other races because of their shorter life spans.  No racial adjustments or intrinsics occur to characters choosing human.",

"Half-elves tend to be smarter and faster than humans, but not as strong.  Half-elves are slightly better at searching, disarming, saving throws, stealth, bows, and magic, but they are not as good at hand weapons.  Half-elves may choose any class and do not receive any intrinsic abilities.",

"Elves are better magicians then humans, but not as good at fighting.  They tend to be smarter and faster than either humans or half-elves and also have better wisdom.  Elves are better at searching, disarming, perception, stealth, bows, and magic, but they are not as good at hand weapons.  They resist light effects intrinsically.",

"Hobbits, or Halflings, are very good at bows, throwing, and have good saving throws.  They also are very good at searching, disarming, perception, and stealth; so they make excellent rogues, but prefer to be called burglars.  They are much weaker than humans, and no good at melee fighting.  Halflings have fair infravision, so they can detect warm creatures at a distance.  They have a strong hold on their life force, and are thus intrinsically resistant to life draining.",

"Gnomes are smaller than dwarves but larger than Halflings.  They, like the hobbits, live in the earth in burrow-like homes.  Gnomes make excellent mages, and have very good saving throws.  They are good at searching, disarming, perception, and stealth.  They have lower strength than humans so they are not very good at fighting with hand weapons.  Gnomes have fair infra-vision, so they can detect warm-blooded creatures at a distance.  Gnomes are intrinsically protected against paralysis.",

"Dwarves are the headstrong miners and fighters of legend.  Dwarves tend to be stronger and tougher but slower and less intelligent than humans.  Because they are so headstrong and are somewhat wise, they resist spells which are cast on them.  They are very good at searching, perception, fighting, and bows.  Dwarves  have a miserable stealth.  They can never be blinded.",

"Half-orcs make excellent warriors, but are terrible at magic.  They are as bad as dwarves at stealth, and horrible at searching, disarming, and perception.  Half-orcs are quite ugly, and tend to pay more for goods in town.  Because of their preference to living underground to on the surface, half-orcs resist darkness attacks.",

"Half-Trolls are incredibly strong, and have more hit points than most other races.  They are also very stupid and slow.  They are bad at searching, disarming, perception, and stealth.  They are so ugly that a Half-Orc grimaces in their presence.  They also happen to be fun to run...  Half-trolls always have their strength sustained.  At higher levels, Half-Trolls regenerate wounds automatically, and if he or her is warrior slowly.",

"The Amberites are a reputedly immortal race, who are endowed with numerous advantages in addition to their longevity.  They are very tough and their constitution cannot be reduced, and their ability to heal wounds far surpasses that of any other race.  Having seen virtually everything, very little is new to them, and they gain levels much slower than the other races.",

"High-elves are a race of immortal beings dating from the beginning of time.  They are masters of all skills, and are strong and intelligent, although their wisdom is sometimes suspect.  High-elves begin their lives able to see the unseen, and resist light effects just like regular elves.  However, there are few things that they have not seen already, and experience is very hard for them to gain.",

"Barbarians are hardy men of the north.  They are fierce in combat, and their wrath is feared throughout the world.  Combat is their life: they feel no fear, and they learn to enter battle frenzy at will even sooner than half-trolls.  Barbarians are, however, suspicious of magic, which makes magic devices fairly hard for them to use. ",

"Half-Ogres are like Half-Orcs, only more so.  They are big, bad, and stupid.  For warriors, they have all the necessary attributes, and they can even become wizards: after all, they are related to Ogre Magi, from whom they have learned the skill of setting trapped runes once their level is high enough.  Like Half-Orcs, they resist darkness, and like Half-Trolls, they have their strength sustained.",

"Half-Giants limited intelligence makes it difficult for them to become full spellcasters, but with their huge strength they make excellent warriors.  Their thick skin makes them resistant to shards, and like Half-Ogres and Half-Trolls, they have their strength sustained.",

"Half-mortal descendants of the mighty titans, these immensely powerful creatures put almost any other race to shame.  They may lack the fascinating special powers of certain other races, but their enhanced attributes more than make up for that.  They learn to estimate the strengths of their foes, and their love for law and order makes them resistant to the effects of Chaos.",

"With but one eye, a Cyclops can see more than many with two eyes.  They are headstrong, and loud noises bother them very little.  They are not quite qualified for the magic using professions, but as a certain Mr.  Ulysses can testify, their accuracy with thrown rocks can be deadly...",

"Yeeks are among the most pathetic creatures.  Fortunately, their horrible screams can scare away less confident foes, and their skin becomes more and more resistant to acid, as they gain experience.  But having said that, even a mediocre monster can wipe the proverbial floor with an unwary Yeek.",

"Klackons are bizarre semi-intelligent ant-like insectoid creatures.  They make great fighters, but their mental abilities are severely limited.  Obedient and well-ordered, they can never be confused.  They are also very nimble, and become faster as they advance levels.  They are also very acidic, inherently resisting acid, and capable of spitting acid at higher levels. ",

"Kobolds are a weak goblin race.  They love poisoned weapons, and can learn to throw poisoned darts (of which they carry an unlimited supply).  They are also inherently resistant to poison, although they are not one of the more powerful races.",

"The hated and persecuted race of nocturnal dwarves, these cave-dwellers are not much bothered by darkness.  Their natural inclination to magical items has made them immune to effects which could drain away magical energy.",

"Another dark, cave-dwelling race, likewise unhampered by darkness attacks, the Dark Elves have a long tradition and knowledge of magic.  They have an inherent magic missile attack available to them at a low level.  With their keen sight, they also learn to see invisible things as their relatives High-Elves do, but at a higher level.",

"A humanoid race with dragon-like attributes.  As they advance levels, they gain new elemental resistances (up to Poison Resistance), and they also have a breath weapon, which becomes more powerful with experience.  The exact type of the breath weapon depends on the Draconian's class and level.  With their wings, they can easily escape any pit trap unharmed.",

"A secretive and mysterious ancient race.  Their civilization may well be older than any other on our planet, and their intelligence and wisdom are naturally sustained, and are so great that they enable Mind Flayers to become more powerful spellcasters than any other race, even if their physical attributes are a good deal less admirable.  As they advance levels, they gain the powers of See Invisible and Telepathy.",

"A demon-creature from the nether-world, naturally resistant to fire attacks, and capable of learning fire bolt and fire ball attacks.  They are little loved by other races, but can perform fairly well in most professions.  As they advance levels, they gain the powers of See Invisible.",

"A Golem is an artificial creature, built from a lifeless raw material like clay, and awakened to life.  They are nearly mindless, making them useless for professions which rely on magic, but as warriors they are very tough.  They are resistant to poison, they can see invisible things, and move freely.  At higher levels, they also become resistant to attacks which threaten to drain away their life force.  Golems gain very little nutrition from ordinary food, but can absorb mana from staves and wands as their power source.  Golems also gain a natural armor class bonus from their tough body.",

"There are two types of skeletons: the ordinary, warrior-like skeletons, and the spell-using skeletons, which are also called liches.  As undead beings, skeletons need to worry very little about poison or attacks that can drain life.  They do not really use eyes for perceiving things, and are thus not fooled by invisibility.  Their bones are resistant to sharp shrapnel, and they will quickly become resistant to cold.  Although the magical effects of these will affect the skeleton even without entering the skeleton's (non-existent) belly, the potion or food itself will fall through the skeleton's jaws, giving no nutritional benefit.  They can absorb mana from staves and wands as their energy source.",

"Much like Skeletons, Zombies too are undead horrors: they are resistant to life-draining attacks, and can learn to restore their life-force.  Like skeletons, they become resistant to cold-based attacks (actually earlier than skeletons), resist poison and can see invisible.  While still vulnerable to cuts (unlike skeletons), Zombies are resistant to Nether.  Like Golems, they gain very little nutrition from the food of mortals, but can absorb mana from staves and wands as their energy source.",

"One of the mightier undead creatures, the Vampire is an awe-inspiring sight.  Yet this dread creature has a serious weakness: the bright rays of sun are its bane, and it will need to flee the surface to the deep recesses of earth until the sun finally sets.  Darkness, on the other hand, only makes the Vampire stronger.  As undead, the Vampire has a firm hold on its life force, and resists nether attacks.  The Vampire also resists cold and poison based attacks.  It is, however, susceptible to its perpetual hunger for fresh blood, which can only be satiated by sucking the blood from a nearby monster.",

"Another powerful undead creature: the Spectre is a ghastly apparition, surrounded by an unearthly green glow.  They exist only partially on our plane of existence: half-corporeal, they can pass through walls, although the density of the wall will hurt them in the process of doing this.  As undead, they have a firm hold on their life force, see invisible, and resist poison and cold.  They also resist nether.  At higher levels they develop telepathic abilities.  Spectres make superb spellcasters, but their physical form is very weak.  They gain very little nutrition from the food of mortals, but can absorb mana from staves and wands as their energy source.",

"One of the several fairy races, Sprites are very small.  They have tiny wings and can fly over traps that may open up beneath them.  They enjoy sunlight intensely, and need worry little about light based attacks.  Although physically among the weakest races, Sprites are very talented in magic, and can become highly skilled wizards.  Sprites have the special power of spraying Sleeping Dust, and at higher levels they learn to fly faster.",

 "This race is a blasphemous abomination produced by Chaos.  It is not an independent race but rather a humanoid creature, most often a human, twisted by the Chaos, or a nightmarish crossbreed of a human and a beast.  All Beastmen are accustomed to Chaos so much that they are untroubled by confusion and sound, although raw logrus can still have effects on them.  Beastmen revel in chaos, as it twists them more and more.  Beastmen are subject to mutations: when they have been created, they receive a random mutation.  After that, every time they advance a level they have a small chance of gaining yet another mutation.",

"The Ents are a powerful race dating from the beginning of the world, oldest of all animals or plants who inhabit Arda.  Spirits of the land, they were summoned to guard the forests of Middle-earth.  Being much like trees they are very clumsy but strong, and very susceptible to fire.  They gain very little nutrition from the food of mortals, but they can absorb water from potions as their nutrition.",

"Archons are a higher class of angels.  They are good at all skills, and are strong, wise, and are a favorite with any people.  They are able to see the unseen, and their wings allow them to safely fly over traps and other dangerous places.  However, belonging to a higher plane as they do, the experiences of this world do not leave a strong impression on them and they gain levels slowly.",

"Balrogs are a higher class of demons.  They are strong, intelligent and tough.  They do not believe in gods, and are not suitable for priest at all.  Balrog are resistant to fire and nether, and have a firm hold on their life force.  They also eventually learn to see invisible things.  They are good at almost all skills except stealth.  They gain very little nutrition from the food of mortals, and need human corpses as sacrifices to regain their vitality.",

"Dunedain are a race of hardy men from the West.  This elder race surpasses human abilities in every field, especially constitution.  However, being men of the world, very little is new to them, and levels are very hard for them to gain.  Their constitution cannot be reduced. ",

"Shadow Fairies are one of the several fairy races.  They have wings, and can fly over traps that may open up beneath them.  Shadow Fairies must beware of sunlight, as they are vulnerable to bright light.  They are physically weak, but have advantages in using magic and are amazingly stealthy.  Shadow Fairies have a wonderful advantage in that they never aggravate monsters (If their equipment normally aggravates monsters, they only suffer a penalty to stealth, but if they aggravate by their personality itself, the advantage will be lost).",

"A Kutar is an expressionless animal-like living creature.  The word 'kuta' means 'absentmindedly' or 'vacantly'.  Their absentmindedness hurts their searching and perception skills, but renders them incapable of being confused.  Their unearthly calmness and serenity make them among the most stealthy of any race.  Kutars, although expressionless, are beautiful and so have a high charisma.  Members of this race can learn to expand their body horizontally.  This increases armour class, but renders them vulnerable to magical attacks.",

"An android is a artificial creation with a body of machinery.  They are poor at spell casting, but they make excellent warriors.  They don't acquire experience like other races, but rather gain in power as they attach new equipment to their frame.  Rings, amulets, and lights do not influence growth.  Androids are resistant to poison, can move freely, and are immune to life-draining attacks.  Moreover, because of their hard metallic bodies, they get a bonus to AC.  Androids have electronic circuits throughout their body and must beware of electric shocks.  They gain very little nutrition from the food of mortals, but they can use flasks of oil as their energy source."

#endif
};

static cptr class_jouhou[MAX_CLASS] =
{
#ifdef JP
"Ȃ͕̈ɏnBA|Iȍrœ؂JƂł܂Bډa邾\ł͂Ȃ|Ⓤ̋ZpKĂ܂B11̐킢œGɌ鎖͂قƂǂ܂񂪁A퓬ȊÔƂ͋ɂ߂ĕsłBՈȍ~̃_WŐт邽߂ɂ́AȖB\͂Ȃǂǂɂĕ₤KvłB",
  
"Ȃ͒m͂Ƃ铹IсA@̉`߂邽߂ɌƎHXςݏd˂Ă܂BՂ͕nȐg̔\͂̂߂ɋ킵܂AIՂ͋͂lȐ킢\ɂȂ邱Ƃł傤B@mɕxłAT▂̎gpӂłBxオƖ̖͂z邱Ƃł悤ɂȂ܂BS12̖̈@̒2̖̈@Kł܂B̈̕ނɂAptAdptAtƌĂѕς܂B̈͂łύX\łÄ悪̈ƕʂ̕ނ̏ꍇՓx啝ɏ㏸Ă܂܂B",
  
"Ȃ͐_ɎdċVFsƂ𐶋ƂƂĂ܂B_̏𓾂Đpɑ閂@2̈sg\łBM̎ɂ薂@h͂ɗDAxオƋ|Ȃǂɑ΂ϐ𓾂܂BX̏Cs̈ƂĂx̕|Ȃ܂Aقǂ̒Blɂ͂Ȃ܂B܂A݊Ɩ_ȊȌjĂȂ𑕔Ɛ_̕s𔃂@̍sgȂǂɍ肪o܂B͂Ȃx߂łA_ɃACeċF邱Ƃɂ􋖂̌ol𓾂邱Ƃł܂BȂA炠Ȃ͎א_M_ƌĂ΂_ɎdĂ̂܂B̏ꍇ͐płȂdpɑ閂@KAjꂽ𑕔ƃyieB󂯂܂B",
  
"Ȃ͕󕨂߂ĉ̐ƂՂTAgW[n^[łBBⓊȂǗlXȋZ\ɗDATɌ֗ȓZ܂BEƕ΂ΉՂ̔ԐlƐ퓬ɂȂ邽ߔȂ܂Amقǂ̘r߂̋͂܂B@̈K\ł̊wK͒xA܂苭͂Ȗ@͎g܂BZ̈ӂŒZ𑕔ĂƍU񐔂㏸܂BẐقɂ̓NX{ËӂłBȊȎ傫ȕ̈͋łB",
  
"Ȃ͐X̉[ŏb̂悤Ɏĕ炵Ă܂BߍȊňȂ͔Ǝˌ̗ɏGłĂ܂B܂B`ꂽR̗͂gpC߂Ă莩Rϗe̖@sg\łBƖჂł̑ϐ𓾂āAɃX^[̏ڍׂȏ𒲍Zg悤ɂȂ܂BBs͓ӂł̑@ׂȋZpɂĂ͂słB",
  
"Ȃ͐邽߂ɐ키ȐmłB\͂AɌƑ̈𓾈ӂƂ܂B@͎g܂񂪊OGg邽߂̂̋ZKł܂Bjꂽ𑕔ƍU͂܂Aꂽ𑕔ƍU͂啝ɒቺ܂BRZ\̓K܂ׂ̖̐͂b𑀂邱Ƃ͑̋łBx㏸Ƌ|Ɣj׍Uɑ΂ϐ𓾂܂B",
  
"Ȃ͗lXȎɑ΂[mC߁Aiɓ`邱ƂgƂĂ܂B@2̈K\ŁÂ݂Ȃ炸퓬ZpɂĂLK\EłB̔\͂ɂ@̈ɂˏoƂ낪ȂAZ\̐ɂ܂Lт낪ȂpnRł܂BՈȍ~̃_WŐc邽߂ɂ͎ɓ̂SĎgȂ_߂܂B",
  
"Ȃ͎ɎdēX̎GsAN҂Ό}ꖽΓGnP闊]҂łBlXȕpɈTȂǂ̋Z\⍂A֗̕ȏZK܂Bɖ@Eقǂł͂Ȃ̖̂@1̈sg\Ȗ\^EƂłBChij̏ɃChiX[cj𒅗pȂ΂Ȃ܂BDGȖh̊mۂɂ͋J邱Ƃł傤BxAbv̂Ƃ傩J󂯎܂B̋@ƗssȔ󂯂邱Ƃ܂B",
  
"Ȃ͕ɗ炸gŐ킢ƂD݁AX̂ƋZ̒bBɗł܂B̒bB̐ʂ͌Ȃ̂ŁAfłɂւ炸d̐mɕCGU͂@o܂B܂CsɂuCv@KĂAlXȏlꂵZgƂł܂BdZ𑕔Ɗiɍ肪o邽߁A𐮂̂ɂ͋J邱Ƃł傤B㩉▂ƂZp͂܂蓾ӂł͂܂B",
  
"Ȃ͂钴\͎҂ŁA_̗͂ŗlXȊՓIȂƂ𐬂܂B̔\͕͂LAƂɖhƊmɊւĂ͐Ȗ@|܂B\͂̏Ksgɂ͒m\vAxƌ݂̂v܂(\͖͂@ƓR}hgp܂)Bؚ̂͂łeȂA₷\^ƌł傤BxオƍϐepV[̔\͂l܂B͑߂łXRA͒߂łB",
  
"Ȃ͒m͂Ƃ铹IсAĂ̖̈@ɂ߂邱ƂS܂BKł閂@͈̈悾ł̂́Âǂ̐EI݂ɂ̗̖̈@܂Bʏ̖@EȂMPA背xɒBƑÏɉƓ̔\͂𓾂邱Ƃł܂BnCCW̌ď̂܂CŴ悤ɗ̈悲Ƃɕω܂B",
  
"Ȃ͌zɕ炷ʂ̏ZlłBl̓܂񂵁AԔŗVԗd܂B炩̎Ń_WTɐg𓊂܂퓬ɊւĂ͂قƂǉ̎蕿܂B1̈̂ݖ@̏K\ł͂Ȗ@͂Ȃ̎ɂ͗]܂BȂ̖`͋ɖ̂ɂȂł傤BȂAQ[JnɐEƖDȂ悤ɍĐݒ\łB",
  
"Ȃ͎RĂÂƐ_̒bB̂߂ɏCsɖĂ܂BƖ_̈ɏGŁAfł̊iӂłB_𑕔ĂƂɂ͊i̒ǉUo₷Ȃ܂BX̏Cs̎Őpɑ閂@̈sg\łAЂƂƊO@Ɏoĕϗe⎀̗̈KĂ邩܂BxオƋ|⍬ւ̑ϐgɂAɐ_WđfMP񕜂邱Ƃł悤ɂȂ܂B",
  
"Ȃ͕XȂʓw͂ɂČƖ@̗KmłB\͂͏mɉy΂@̏Kn@Eɐ܂Aɖ@̌ʂ悹ēȍUZ܂Bp邢͈ÍEׂ̗dp̖̈@KłA@̌ʂ͏K@̈ŕς܂B̈ɂ͋ɂ߂ďGł܂قƂǌ܂BxオƓFƋ}񕜂̔\͂l܂BȂA͂x߂łB",
  
"(\̈)",
  
"Ȃ͋|NX{ËɓmłB̎ˌ̎͐܂̂ŁAl̐{̑xŐmȎˌsƂł܂Bڋߐł̋͑̐mnEƂɑ傫܂BȂ͎悪pł̕ӂɐĂ؂邱ƂłAA[`[MhɖƑfނŉH邱Ƃłɋ͂Ȗ邱Ƃł܂BBTȂǂ̑̋Z\͊T˕ϓIȃxłBxAbvɂ蓧FӖڑϐ̔\͂𓾂܂B",
  
"Ȃ͓ȏptłB@SǂނƂł܂񂪁ȂɃ}WbNACëɂĂ͒NDĂ܂BA@_AbhƂ̂Ɏ荞Ŏgp\͂ĂA荞񂾖͎Ԍo߂Ŏgp񐔂񕜂܂B܂[U┭Ɋւ邢̓ZK܂Be͂قǓӂł͂Ȃ߁A͂Ȗɓ܂ł͐LєYނ܂B",
  
"Ȃ͋@BZtŁAGȋ@B𑀂Đǂ؂J܂B@B̍쐬eR̒B̓GWjAMhōs܂BȂ͔s\ȃobNpbNĂ肻̒ɋ@Bi[Ďgp܂B@B̎ނ͑ߊi[@B͋ᖡKv܂B@B͋ɂ߂ċ͂łAɂƂɂƂ傫Ȍ_܂B@B̍쐬ɂ͒m\Ɗpv܂AKvȂ̂͐험iċ邽߂̖͂܂B̋@B͐ƓdGŁA̍U󂯂ƈꎞIɎgps\ɂȂ邱Ƃ܂BȂg̐퓬\͕͂}łB㩉ƃNX{Eӂł̎gp͑̋łB",
  
"Ȃ͐}قɋΖĂ܂B}ق̎ɎdĎGȂ{D_}̂dłBɂčLmĂAׂƂɑSĂ̗̈̓ڂ܂ł̖@ŏLĂ܂BxĂĖ{ĂΖ@gp\łB@̏Knx͖{iIȖ@Eɂ͉y΂AOڈȍ~̋͂Ȗ@͈؎g܂BpɂĂȂɐS͂܂{Eɂ͈AA܂傫ȕU񂷂̂͋łB`̏Ղ͉sRȂȂ܂AIՂŋG𑊎ɂ̂͋J邩܂BxȂオMP𑽂߂ɏĎrZgɂ܂B",
  
"Ȃ͌̓ɂ߂邽߂ɓXZ𖁂Ă܂B̈ɂĂ͉Eɏô͂܂B@͎g܂񂪁Al̎c`ǂނƂŁuKEvK邱Ƃ\łB܂u^vƂȍ\邱Ƃɂꕗς킢邱Ƃł܂B񓁗ɂK܂AT▂Ȃǂ͋łB",
  
"Ȃ͏eΊŕmłB	eƃiCẗɗDAiEJEBɂK܂BŖ̈Ɩ@h͂ȂłB背xɂȂ邲ƂɋZ\K|Cg𓾂āA|CgĊ̃JeSZ\wԂƂł܂B|Cg̊Uɂ_WU̐헪xς܂BȂ͌z̏Zl猩Ɩ炩ɈَȑĂ邽߁AXł͌xĂ܂܂B",
  
"Ȃ͖Ĕ邱ƂŐv𗧂ĂĂ܂B_WȂǂőfނƒ܃Vs肵AX̒܎؂Ė𒲍܂B퓬͂܂蓾ӂłȂ߁AGƐ키Ƃ͔⋭ȂǂOɒĂKvł傤BȂ̓UbNƂ͕ʂɑfނ򔠂ɎĂ܂B򔠂̒̃ACe͌dɕی삳ĂG̍UŔj󂳂܂񂪁Ax򔠂oȂƎgpł܂BxオƃUbN̖̒򂪗CUȂǂŔj󂳂ɂȂ܂B̍ɂ͒m\KvŁAޗ̍̎̂߂ɂ͉B\͂T\́Ax̐퓬̏KvłB",
  
"Ȃ͏nɏnBRmłB̏n̋Zp͌Ȃ̂ŁAnɗ܂炸⋐bAʂĂ͗܂ŏ肱Ȃ܂B͂ȃX^[ɏ΋ɂ߂ĐSx邱Ƃł傤BⒷ̈ӂŋ|̈I݂łB܂nɌȂłȂɈ܂BmƓlɖ@͈؎g̈łB",
  
"Ȃ͓ƕtr_̐ƂŁAtr_ɕωȋZĂ܂Btr_ƂȂ͒ɕAȂׂ̂ƂȂĐ킢܂Bʏ̔zƈႢAtr_̍UłȂgolƃACe𓾂邱Ƃł܂BȂ̑Ă镐͗d퉻čőVȔ\͂l邱Ƃ܂BȂ͊Ӓ㩉▂gpɏGłĂAꂽi􂹂ɊO܂BȂg̐퓬\͂͂قǍ܂B_W̐[wł͒n`⑊IԐTdȗ肪v܂B",

"Ȃ͏EGȕ𔄂ĕ炵Ă܂B̖ڗ͊mŁAӒɊւĂ͂ǂ̐EƂDĂ܂BT̋Z\ɗDAdו^ԂƂłAXł̌ӂłB܂Ȃɂ͖@̑iςZpAMhőfނƂȂACe\͂𒊏oʂ̕ɕt邱Ƃł܂BȂ̊{IȐ퓬\͂͂قǍ̂ł͂ȂA@؎gpł܂B_W̉ɒH蒅ɂ͍CfނW߂đbA͂̒グ}Kv܂BȂ͖`p̃UbNɉďÊ^Ԃ߂̓Ă܂B",

"Ȃ͖@̑i΍׍HtłB΂⑕i疂͂𒊏oȂiɓʂȕ{ƂŖ͂t^ZpĂ܂BƂ͊X̕Mhōs܂BȂ͎悪pŖ@̓̈ɗD܂Aߐڐ퓬\͈͂ʐlƕς܂B@̈K\ł@EɔׂƂfɗ܂BC閂@̈͐TdɑIKvł傤BxオƎ莝̕΂疂͂zMP񕜂ZK܂B",

"Ȃ͓ȌPς񂾋ׂÎE҂łBÈł̒ł͂ʂƂłA܂Èł̒ł͓GɌ炸ɍsł܂BZf̈ꌂœG𖳗͉AZ\Aɂ͔EpƌĂ΂Z\gȂ܂BUɂĂ͂̋⊶Ȃ܂AŖhʂɂ͂s܂BϐACɂ͗DĂ̗̂̑͂ɌAdhؑł܂BEpɂhÔ郊XL[Ȃ̂łBEp̎gpɂ͎Ɋp邢͒m\e܂B",

"XiCp[͈ꌂKE_ׂˎłB_߂邱ƂɂAˌ̈З͂Ɛx߂܂B܂A@gƂ͂ł܂񂪁A܂ꂽ_Joˌp͂ȂЗ͂炷Ƃł傤BeNjbNKvƂEƂłB",

"Ȃ͋CtƉƂmʑɗĂ܂Bl̎̓ĂȂR̕iɐŜ̊ԁȀꏊ͂܂ł̐lŔ|Ă펯SʂȂƁA舕Ă댯ɖĂ邱ƁAĎS͂ł邱Ƃm܂BȂ͍K^ɂl̏ZޏꏊɒH蒅܂BKt͒ʂ悤łBł͂Ȃ̂悤Ȑl邱Ƃ͏߂Ăł͂Ȃ炵Ae؂Ȑl_ЂɍsΊO֑ԂĂƋĂ܂B_Ђւ̓͗d̑AłBٕ̈ςNĂ炵͂Ă܂AȂɂƂĂ͉ٕςŉ핗iȂ̂肩ł͂܂EE"

#else

"A Warrior is a hack-and-slash character, who solves most of his problems by cutting them to pieces, but will occasionally fall back on the help of a magical device.  Unfortunately, many high-level devices may be forever beyond their use.",

"A Mage is a spell caster that must live by his wits as he cannot hope to simply hack his way through the dungeon like a warrior.  In addition to his spellbooks, a mage should carry a range of magical devices to help him in his endeavors which he can master far more easily than anyone else.  A mage's prime statistic is Intelligence as this determines his spell casting ability. ",

"A Priest is a character devoted to serving a higher power.  They explore the dungeon in the service of their God.  Since Priests receive new prayers as gifts from their patron deity, they cannot choose which ones they will learn.  Priests are familiar with magical devices which they believe act as foci for divine intervention in the natural order of things.  A priest wielding an edged weapon will be so uncomfortable with it that his fighting ability.  A Priest's primary stat is Wisdom since this determine his success at praying to his deity. ",

"A Rogue is a character that prefers to live by his cunning, but is capable of fighting his way out of a tight spot.  Rogues are good at locating hidden traps and doors and are the masters of disarming traps and picking locks.  A rogue has a high stealth allowing him to sneak around many creatures without having to fight, or to get in a telling first blow.  A rogue may also backstab a fleeing monster.  Intelligence determines a Rogue's spell casting ability.",

"A Ranger is a combination of a warrior and a mage who has developed a special affinity for the natural world around him.  He is a good fighter and also good about a missile weapon such as a bow.  A ranger has a good stealth, good perception, good searching, a good saving throw and is good with magical devices.  Intelligence determines a Ranger's spell casting ability.",

"A Paladin is a combination of a warrior and a priest.  Paladins are very good fighters, but not very good at missile weapons.  A paladin lacks much in the way of abilities.  He is poor at stealth, perception, searching, and magical devices but has a decent saving throw due to his divine alliance.  Wisdom determines a Paladin's success at praying to his deity.",

"A Warrior-Mage is precisely what the name suggests: a cross between the warrior and mage classes.  While their brothers, the rangers, specialize in Nature magic and survival skills, true Warrior-Mages attempt to reach the best of both worlds.  As warriors they are much superior to the usual Mage class.  Intelligence determines a Warrior-Mage's spell casting ability.",

"Chaos Warriors are the feared servants of the terrible Demon Lords of Chaos.  Every Chaos Warrior has a Patron Demon and, when gaining a level, may receive a reward from his Patron.  He might be healed or polymorphed, his stats could be increased, or he might be rewarded with an awesome weapon.  On the other hand, the Patrons might surround him with monsters, drain his stats or wreck his equipment or they might simply ignore him.  The Demon Lords of Chaos are chaotic and unpredictable indeed.  The exact type of reward depends on both the Patron Demon (different Demons give different rewards) and chance.",

"The Monk character class is very different from all other classes.  Their training in martial arts makes them much more powerful with no armor or weapons.  To gain the resistances necessary for survival a monk may need to wear some kind of armor, but if the armor he wears is too heavy, it will severely disturb his martial arts maneuvers.  As the monk advances levels, new, powerful forms of attack become available.  Their defensive capabilities increase likewise, but if armour is being worn, this effect decreases.  Wisdom determines a Monk's spell casting ability.",

"The Mindcrafter is a unique class that uses the powers of the mind instead of magic.  These powers are unique to Mindcrafters, and vary from simple extrasensory powers to mental domination of others.  Since these powers are developed by the practice of certain disciplines, a Mindcrafter requires no spellbooks to use them.  The available powers are simply determined by the character's level.  Wisdom determines a Mindcrafter's ability to use mind powers.",

"High-mages are mages who specialize in one particular field of magic and learn it very well - much better than the ordinary mage.  For the price of giving up a second realm of magic, they gain substantial benefits in the mana costs, minimum levels, and failure rates in the spells of the realm of their specialty.  A high mage's prime statistic is intelligence as this determines his spell casting ability. ",

"Tourists have visited this world for the purpose of sightseeing.  Their fighting skills is bad, and they cannot cast powerful spells.  They are the most difficult class to win the game with.  Intelligence determines a tourist's spell casting ability.",

"Imitators have enough fighting skills to survive, but rely on their ability to imitate monster spells.  When monsters in line of sight use spells, they are added to a temporary spell list which the imitator can choose among.  Spells should be imitated quickly, because timing and situation are everything.  An imitator can only repeat a spell once each time he observes it.  Dexterity determines general imitation ability, but a stat related to the specific action is often also taken into account.",

"Beastmasters are in tune with the minds of the creatures of the world of Hengband.  They are very good at riding, and have enough fighting ability.  They use monsters which summoned or dominated by him as his hands and feet.  Beastmasters can cast trump magic, and very good at summoning spell, but they can not summon non-living creatures.  Charisma determines a Beastmaster's spell casting ability.",

"Sorcerers are the all-around best magicians, being able to cast any spell from most magic realms without having to learn it.  On the downside, they are the worst fighters in the dungeon, being unable to use any weapon but a Wizardstaff.",

"Archers are to bows what warriors are to melee.  They are the best class around with any bow, crossbow, or sling.  They need a lot of ammunition, but will learn how to make it from junk found in the dungeon.  An archer is better than a warrior at stealth, perception, searching and magical devices.",

"Magic-Eaters can absorb the energy of wands, staffs, and rods, and can then use these magics as if they were carrying all of these absorbed devices.  They are middling-poor at fighting.  A Magic-Eater's prime statistic is intelligence.",

"Bards are something like traditional musicians.  Their magical attacks are sound-based, and last as long as the Bard has mana.  Although a bard cannot sing two or more songs at the same time, he or she does have the advantage that many songs affect all areas in sight.  A bard's prime statistic is charisma.",

"Red-Mages can use almost all spells from lower rank spellbooks of most realms without having to learn it.  At higher level, they develop the powerful ability \"Double Magic\".  However, they have large penalties in the mana costs, minimum levels, and failure rates of spells, and they cannot use any spells from higher rank spellbooks.  They are not bad at using magical devices and magic resistance, and are decent fighter, but are bad at other skills.  A red-mage's prime statistic is intelligence.",

"Samurai, masters of the art of the blade, are the next strongest fighters after Warriors.  Their spellpoints do not depend on level, but depend solely on wisdom, and they can use the technique Concentration to temporarily increase SP beyond its usual maximum value.  Samurai are not good at most other skills, and many magical devices may be too difficult for them to use.  Wisdom determines a Samurai's ability to use the special combat techniques available to him.",

"A ForceTrainer is a master of the spiritual Force.  They prefer fighting with neither weapon nor armor.  They are not as good fighters as are Monks, but they can use both magic and the spiritual Force.  Wielding weapons or wearing heavy armor disturbs use of the Force.  Wisdom is a ForceTrainer's primary stat.",

"A Blue-Mage is a spell caster that must live by his wits, as he cannot hope to simply hack his way through the dungeon like a warrior.  A major difference between the Mage and the Blue-Mage is the method of learning spells: Blue-Mages may learn spells from monsters by activating his Learning ability.  A Blue-Mage's prime statistic is Intelligence as this determines his spell casting ability. ",

"Cavalry ride on horses into battle.  Although they cannot cast spells, they are proud of their overwhelming offensive strength on horseback.  They are good at shooting.  At high levels, they learn to forcibly saddle and tame wild monsters.  Since they take pride in the body and the soul, they don't use magical devices well.",

"A Berserker is a fearful fighter indeed, immune to fear and paralysis.  At high levels, Berserkers can reflect bolt spells with their tough flesh.  Furthermore, they can fight without weapons, can remove cursed equipment by force, and can even use their special combat techniques when surrounded by an anti-magic barrier.  Berserkers, however, cannot use any magical devices or read any scrolls, and are hopeless at all non-combat skills.  Since Berserker Spectres are quite easy to *win* with, their scores are lowered.",

"A Weaponsmith can improve weapons and armors for him or herself.  They can extract the essences of special effects from weapons or armors which have various special abilities, and can add these essences to another weapon or armor.  They are good at fighting, but cannot cast spells, and are poor at skills such as stealth or magic defense.",

"Mirror-Masters are spell casters; like other mages, they must live by their wits.  They can create magical mirrors, and employ them in the casting of Mirror-Magic spells.  A Mirror-Master standing on a mirror has greater ability and, for example, can perform quick teleports.  The maximum number of Magical Mirrors which can be controlled simultaneously depends on the level.  Intelligence determines a Mirror-Master's spell casting ability.",

"A Ninja is a fearful assassin lurking in darkness.  He or she can navigate effectively with no light source, catch enemies unawares, and kill with a single blow.  Ninjas can use Ninjutsu, and are good at locating hidden traps and doors, disarming traps and picking locks.  Since heavy armors, heavy weapons, or shields will restrict their motion greatly, they prefer light clothes, and become faster and more stealthy as they gain levels.  A Ninja knows no fear and, at high level, becomes almost immune to poison and able to see invisible things.  Dexterity determines a Ninja's ability to use Ninjutsu.",

"Snipers are good at shooting, and they can kill targets by a few shots. After they concentrate deeply, they can demonstrate their shooting talents. You can see incredibly firepower of their shots."
#endif
};


static cptr seikaku_jouhou[MAX_SEIKAKU] =
{
#ifdef JP
"Ȃ͓ɓMׂȂiłBZ\𕽋ϓIɂȂ܂B",

"Ȃ͍lɎ肪o^CvłB̓IȔ\͂Z\㏸܂BA@Ɋ֌W\͂Z\͗Am̃Xe[^X܂B",

"Ȃ͓̉]Ďv[iłB̓IȔ\͉͂܂Am\▂@Ɋ֌WZ\͏㏸ACW̃Xe[^X܂B",

"Ȃ͏݂Ƃ낪܂X̂Ƃł͓܂Bϋv͂ɂD܂spłB",

"Ȃ͂◎܂񂪖ڒ[^CvłBǂ̃XLrI܂Ȃ܂A̓IȔ\͂͂ႭȂ܂B",

"Ȃ͈xƌ߂l܂B퓬́A@\̗͂㏸܂A@hAgoƂ\͈͂Ȃ܂B",

"Ȃ̓V[eBO̐\qłB@낤Ǝˌ낤ƂƂɂԂƂɂĂ͓ViłB̐g邱ƂȂǑSᒆɂ܂Bo͂łĂ܂B",

"Ȃ͂ƍCoŗĂ艽ɂX}[głB͎dBs͂܂D݂ł͂܂B",

"zŃLm{[JÂ܂BS100Kł삯̂DłBȂ͍\͂ƋZ\܂A_W̑SĂ݂̑Ȃ̎ז悤Ɨǂ܂B̐iIŒZԂŏƃXRAオ܂B",

"Ȃ͔\͂͗Ă܂ȂĂƂȂ܂Ă܂^CvłB",

"Ȃ͂ƕɂƂ肭ސTdȐiłBϋv͂܂ŝ͋ŁA̋Z\͒ႭȂĂ܂܂B",

"܂́AS҂̗Kp̐iłB\͂ȂĂ܂B̐igΏ҂ɂȂ邱Ƃ͗eՂłAĂSɂȂ܂B",

"(\̈@NWƂ̓XRAT[o̎dlɍȂ̂Œ~)",

"߂ƂȁICӂ邺H",

#else

"\"Ordinary\" is a personality with no special skills or talents, with unmodified stats and skills.",

"\"Mighty\" raises your physical stats and skills, but reduces stats and skills which influence magic.  It makes your stats suitable for a warrior.  Also it directly influences your hit-points and spell fail rate.",

"\"Shrewd\" reduces your physical stats, and raises your intelligence and magical skills.  It makes your stats suitable for a mage.  Also it directly influences your hit-points and spell fail rate.",

"\"Pious\" deepens your faith in your God.  It makes your physical ability average, and your stats suitable for priest. ",

"\"Nimble\" renders you highly skilled comparatively well, but reduces your physical ability. ",

"\"Fearless\" raises both your melee and magical ability.  Stats such as magic defense and constitution are reduced.  Also it has a direct bad influence on your hit-points.",

"\"Combat\" gives you comparatively high melee and shooting abilities, and average constitution.  Other skills such as stealth, magic defence, and magical devices are weakened.  All \"Combat\" people have great respect for the legendary \"Combat Echizen\".\n\
(See \"Death Crimson\" / Ecole Software Corp.)",

"A \"Lazy\" person has no good stats and can do no action well.  Also it has a direct bad influence on your spell fail rate.",

"\"Sexy\" rises all of your abilities, but your haughty attitude will aggravate all monsters.  Only females can choose this personality.",

"A \"Lucky\" man has poor stats, equivalent to a \"Lazy\" person.  Mysteriously, however, he can do all things well.  Only males can choose this personality.",

"A \"Patient\" person does things carefully.  Patient people have high constitution, and high resilience, but poor abilities in most other skills.  Also it directly influences your hit-points.",

"\"munchkin\" is a personality for beginners.  It raises all your stats and skills.  With this personality, you can win the game easily, but gain little honor in doing so."
#endif
};

static cptr seikaku_special_jouhou[MAX_SEIKAKU_SPECIAL] =
{
	"̐ĩ͓NX̐pꐫiłB̃NXł͂̐i͑Ił܂B",
	//`muĂv
	"Ȃ͕X̗dƂ̂ɂȂ񂪂Ă܂BΉ_AS\͂啝ɏ㏸AɓZAȂ͑S\ɖӂĂ܂BȂ̖`̃XRA̔͂ǂɏĂ܂܂BȂ̔wɂ͂̊Ԃɂ̔JĂ܂AȂɋCtƂ͂܂B",
	//p`[usv
	"Ȃ͎蓖莟̖{Ssɓǂ݋AɖpłȂpƗdp̖@܂łSďK܂BMȂ͂ɂČN𑹂ȂA̐g̔\͎͂Gdɂ܂B",
	//uRȂDIȁv
	"Ȃ͐XňlÂɕ炵Ă܂AƂˑRcȖ͂Nオ̂܂BNł炱̗͂Ďd܂B̂Ȃ͋ߐڍU\͂AMPőlAZ͂ȍÛ̂ɕςĂ܂BȂ̖`̃XRA25%͂ǂɏĂ܂܂BȂ̔wł͓̏KTKTUȂxĂ܂AȂɋCtƂ͂܂B",
	//ǂ񂰁u̐Év
	"Ȃ͖̐E̗ED܉؉@ECiołB	S߈ˈٕς̉eŖ̐EǂoA̋@ɂȂ̖{̂ɃXgX҂lc炸@̂߂Ɩژ_ł܂B̐iIƒʏ̐iZωAëɒ̂ɂȂ܂B",
	//俎quɔY܂v
	"Ȃ͂̂ƂÄɔY܂Ă܂Bi͂ȂɗFDIȂ͂̌z̏Zllc炸ӂďP|Ă̂łB	AȂ̌ɐΔ_𖼏lė݂͂Ă܂BVȓZgďIȂŊJ܂傤B_ȂɎZ͂̎̎Ń_Ɍ܂AȂDȂ悤ɖO邱Ƃł܂B",
};

//ꐫiǉmemo:
//#define SEIKAKU_SPECIAL_***ǉ
//get_special_seikaku_index()ɏǉ
//seikaku_special_jouhou[]ɐǉ
//table.cseikaku_info_special[]Ƀp[^ǉ
//قA̐iɊւꏈ

//NXID,̃NXꐫiɂȂƂ̓ꐫiCfbNXԂB
//race_idgƎv푰ϗeG[ɂȂ̂ɋCÂă{cB
//̊֐͎ۂp_ptr->pseikakuɊւ炸ꐫiCfbNXԂB
static int get_special_seikaku_index(int class_idx)
{

	if (class_idx == CLASS_CIRNO)		return SEIKAKU_SPECIAL_CIRNO;	
	if (class_idx == CLASS_PATCHOULI)	return SEIKAKU_SPECIAL_PATCHOULI;
	if (class_idx == CLASS_NARUMI)		return SEIKAKU_SPECIAL_NARUMI;
	if (class_idx == CLASS_UDONGE)		return SEIKAKU_SPECIAL_UDONGE;
	if (class_idx == CLASS_SUMIREKO)	return SEIKAKU_SPECIAL_SUMIREKO;

	return SEIKAKU_SPECIAL_NONE;
}





/*:::@iƌpj̗̈@YTV_BOOK_????ɑΉ*/
static cptr realm_jouhou[TV_BOOK_END + 1] = {
	"",//_~[
	"\nΕȂǂ̌f𑀂̈łBłʂȍU@AĎ኱̖hE⏕@܂܂܂B̕΂Gɑ΂ėLȑŌ^܂B",
	"BꂽAm肦Ȃ͂̎möłBmiقڊɑAG̐_ɍU閂@܂B͂ȕ⏕񕜂܂Aɂ߂čxłB",
	"̂⎩̑̂ɑ΂͂߂ēʂȌʂ^̈łBhƕ⏕ɋɂ߂ėDAx̐퓬i܂B̖@MP̂قɐG}KvƂȂ܂B",
	"ȂƂɖJlXȂ̂ĂяöłBƃe|[gnɋɂ߂ėD܂AȊO͕słB̎ނɂĂ͂MP̂قɑ㏞KvƂȂ邱Ƃ܂B܂A@Ɏs͏҂悤Ƃ̂PĂ邱Ƃ܂B",
	"RIȊՂN̈łBmƕ⏕[ĂlXȕ֗Ȗ@܂AGɒڍU閂@͂܂B",
	"̃GlM[𑀂̈łB񕜂ɍłDAh⏕͂łBU@܂Afbhɂ̂ݗLłB",
	"׈Ȃ̂ł|̈łBdAAAfbhɑ΂ėLȍU@A⏕@[Ă܂Bŏʂ̖@ɂ͋͂Ȑ_~낵̖@܂A͓ȏ㓯Ɍʂ𔭊邱Ƃł܂B",
	"R̗͂؂̈łBʂȖ@oXǂAɊmƖhɗD܂BU@̈З͂͂߂łB",
	"̑̂͂̒n`ω̈łB͂lȏp܂A푰Ƃ̓KՓxɑ傫e܂(\)B܂ϐg@͖̑hʂ𔭊ȂȂ芪gȂȂȂǓƓ̃XN𔺂܂B",
	"׈ȗ͂𑀂̈łBłÍ𒆐SƂU@Aɂ߂čUIȕ⏕@AĈ̎g∫ւ̕ϐgƂ܂Bh⊴m͂܂蓾ӂł͂܂B̗̖̈@KƔj׍UɎキȂ܂B",
	"g􂢂ōÜłB⏕⏢𒆐SɑʂȎ܂A􂢂ɂU͈Afbh△ɂ͂قږ͂łB̗̖̈@KƔj׍UɎキȂ܂B",
	"̖ȃGlM[䂪Ƃ̈łBI΂Ȃ͂ȍU@܂B⏕@܂AjIȂ̂łB̗̈̑SĂ̖@̎gpɂ̓XN܂B",
	"KEƂ͌pƂ̊ԂŌpꖁꂽ̋ZłBł̍UɓƓ̌ʂ悹悤ȋZقƂǂłBKE͈xKΔ`ĂȂĂgpł܂Bꕔ̋Z͓̎ނ̕𑕔ĂȂƎgpł܂B",
	"",
	"zŗlXȉ\ss`悤ɂȂ܂Bɕqꕔ̎ҒB͊OE痬ĂAuIJgv𖂖@̂悤ɏKĎgȂ܂BIJg͍U𒆐Sɋ͂őʂȂ̂܂Ȁ𖞂㏞xȂƎgȂȂ̋̂قƂǂłB",
};



/*
static cptr realm_jouhou[VALID_REALM] =
{
#ifdef JP
"͉񕜔\͂ɗDꂽ@łBÂhAm@܂܂Ă܂AU킸ɎĂ܂Bɍx̎ɂ̓AfbhoɋA͂ƌĂ܂B",

"ṕumetav̈łAmӒAɑދpp̎⎩g̔\͂߂Ȃǂ֗̕Ȏ܂܂Ă܂BAڍUp͎̎Ă܂B",

"R̖@͎gp҂f̃}X^[ɂ܂Bɂ͖hATmAÂƍU܂܂Ă܂B܂AȊÖ̗ōō̎Î̗̈ɂ܂B",

"JIX̖@͐䂪ŁA\̂łȂ@܂BJIX͔ɔ񌳑fIłAJIX̎͑złłׂj󕺊łB̎̂̓JIX̐땺ɑ΂AG⎩gψق悤v܂B",

"płÍ̖@قǎ׈ȃJeS[͂܂B͔̎rIwԂ̂łAxɂȂƏp҂ɐƃAfbhRɑ\͂^܂BcOȂƂɁAƂ͂Ȏ͂̐G}ƂďpҎǧKvƂArɂ΂Ώp҂܂B",

"gv̖@̓e|[gn̎ŐIꂽ̂ĂȀo͑̐邽߂ɂg邽߁AI肷ꂽ̂lɎĂ܂BA̖@ɂđSẲʂ̏ꏊ֌Ă΂̂𗝉킯ł͂ȂAɎsƂ͓̐GƂȂ܂B",

"p̖@́ASĂ̗̈悩LpȎ悤Ƃpr̈łBKvȁuvIĂĂx̋͂Ȏ͎Ă܂BʂƂāASĂ̎͊XŔ߂邱Ƃł܂B܂Ä̗ɑ݂铯lȎ̕჌xARXgŏ邱Ƃł܂B",

"̖@́A⓹邽߂̖@܂܂Ă܂B@ɂĎg̐퓬͂ɍ߂邱Ƃł܂A𒼐ڍU悤Ȏ͊܂܂Ă܂B",

"̖@͈ÍƓlɎ׈ȃJeS[łBlXȍU@ɗDA܂̂Ƃmo\͂𓾂邱Ƃł܂Bx͈݂̎ɑAg̓̂邱Ƃł܂B",

"jׂ́u`v̖@łBړG閂@܂܂AɎ׈ȓGɑ΂ׂ͂͋̂܂BAPǂȓGɂ͂܂ʂ܂B",

"̏ẂÂɂČʂ𔭊閂@łB@ƓlAgɌʂ̂̂ƁÂ邱ƂɂĎČʂ𔭊̂܂B҂̏ꍇ́AMP̑ʂ𔭊邱Ƃł܂Aɉ̂̂1Ƃ܂B",

"|̏́AlXȐ퓬̋ZɂďĂ܂B̖{͋ZoƂɓǂޕKv܂AxoZ͎ĝɖ{Kv͂܂BZgƂɂ͕K𑕔ĂȂ΂܂B",

"p͊ނׂ̈łB̎􂢂̌t̂̂悤ɖaȂr܂B͉̎r邱ƂɂČʂ܂Bɂ͑̍s𑩔́A_[W^́AUɑ΂Ĕ̂܂B"
#else

"Life magic is very good for healing; it relies mostly on healing, protection and detection spells.  Also life magic have a few attack spells as well.  It said that some high level spell of life magic can disintegrate Undead monsters into ash.",

"Sorcery is a `meta` realm, including enchantment and general spells.  It provides superb protection spells, spells to enhance your odds in combat and, most importantly, a vast selection of spells for gathering information.  However, Sorcery has one weakness: it has no spells to deal direct damage to your enemies.",

"Nature magic makes you master of elements; it provides protection, detection, curing and attack spells.  Nature also has a spell of Herbal Healing, which is the only powerful healing spell outside the realm of Life magic.",

"There are few types of magic more unpredictable and difficult to control than Chaos magic.  Chaos is the very element of unmaking, and the Chaos spells are the most terrible weapons of destruction imaginable.  The caster can also call on the primal forces of Chaos to induce mutations in his/her opponents and even him/herself.",

"There is no fouler nor more evil category of spells than the necromantic spells of Death Magic.  These spells are relatively hard to learn, but at higher levels the spells give the caster power over living and the (un)dead, but the most powerful spells need his / her own blood as the focus, often hurting the caster in the process of casting.",

"Trump magic has, indeed, an admirable selection of teleportation spells.  Since the Trump gateways can also be used to summon other creatures, Trump magic has an equally impressive selection of summoning spells.  However, not all monsters appreciate being drawn to another place by Trump user.",

"Arcane magic is a general purpose realm of magic.  It attempts to encompass all 'useful' spells from all realms.  This is the downside of Arcane magic: while Arcane does have all the necessary 'tool' spells for a dungeon delver, it has no ultra-powerful high level spells.  As a consequence, all Arcane spellbooks can be bought in town.  It should also be noted that the 'specialized' realms usually offer the same spell at a lower level and cost. ",

"Craft magic can strengthen the caster or the equipments.  These spells can greatly improve the caster's fighting ability.  Using them against opponents directly is not possible.",

"Demon is a very evil realm, same as Death.  It provides various attack spells and devilish detection spells.  at higher levels, Demon magic provides ability to dominate demons, and to polymorph yourself into a demon.",

"Crusade is a magic of 'Justice'.  It includes damage spells, which are greatly effective against foul and evil monsters, but have poor effects against good monsters.",

"Music magic shows various effects as sing song.  There is two type of song; the one which shows effects instantly and the other one shows effect continuously until SP runs out.  But the latter type has a limit; only one song can be sing at the same time.",

"The books of Kendo describe about various combat techniques.  When learning new techniques, you are required to carry the books, but once you memorizes them, you don't have to carry them.  When using a technique, wielding a weapon is required.",

"Hex is a very terrible realm. Spells gives continual effects when they are spelled continually like songs. Spells may obstract monsters' actions, may deal damages in sight, may revenge against enemies."
#endif
};
*/
/*:::@̈I̕⏕@폜*/
/*
///realm
static cptr realm_subinfo[VALID_REALM] =
{
#ifdef JP
"mƖhƉ񕜂ɗDĂ܂",
"U͂ł܂񂪔ɕ֗ł",
"mƖhɗDĂ܂",
"jIȍUɗDĂ܂",
"̂Gւ̍UɗDĂ܂",
"ƃe|[gɗDĂ܂",
"アȂɕ֗ł",
"ڐ퓬̕⏕ɗDĂ܂",
"UƖh̗ʂɗDĂ܂",
"׈ȉɑ΂UɗDĂ܂",
"lXȖ@ʂ̂̂܂",
"ŌUɓ\͂t܂",
"GזQ_܂"
#else
"Good at detection and healing.",
"Utility and protective spells.",
"Good at detection and defence.",
"Offensive and destructive.",
"Ruins living creatures.",
"Good at summoning, teleportation.",
"Very useful but poor a bit.",
"Support for melee fighting.",
"Good at both offence and defence.",
"Destroys evil creatures.",
"Song with magical effects.",
"Special attacks on melee.",
"Good at obstacle and revenge."
#endif
};
*/

/*
 * Autoroll limit
 */
 /*:::łgĂȂBI[g[[̍Œl?*/
static s16b stat_limit[6];

/*:::̊iI[g[[p*/
static struct {
	s16b agemin, agemax;
	s16b htmin, htmax;
	s16b wtmin, wtmax;
	s16b scmin, scmax;
} chara_limit;

/*
 * Autoroll matches
 */
static s32b stat_match[6];

/*
 * Autoroll round
 */
static s32b auto_round;


static void birth_quit(void)
{
	remove_loc();
	quit(NULL);
}


/*
 *  Show specific help file
 */
static void show_help(cptr helpfile)
{
	/* Save screen */
	screen_save();

	/* Peruse the help file */
	(void)show_file(TRUE, helpfile, NULL, 0, 0);

	/* Load screen */
	screen_load();
}

/*:::@̗̈於AK\*/
///mod160620 IJgǉ
void print_realm_aptitude(int realm, bool second)
{

	char buf[80];
	cptr category[3] ={"p","p","dp"};

	if(realm < MIN_MAGIC || realm > MAX_MAGIC && realm != TV_BOOK_OCCULT) return;

	put_str("                                   ", 3, 40);
	put_str("                                   ", 4, 40);
	put_str("                                   ", 5, 40);
	put_str("                                   ", 6, 40);
	if(realm == TV_BOOK_OCCULT)
		sprintf(buf, "p");
	else
		sprintf(buf, "%s%s", realm_names[realm], category[(realm-1)/4]);
	c_put_str(TERM_L_BLUE, buf, 3, 40);
	sprintf(buf, "EƓKF%c", 'G' - cp_ptr->realm_aptitude[realm]);
	c_put_str(TERM_WHITE, buf, 4, 40);
	c_put_str(TERM_WHITE, "푰KF", 5, 40);
	switch(rp_ptr->realm_aptitude[realm])
	{
	case 0:
		c_put_str(TERM_L_DARK, "", 5, 50);break;
	case 1:case 2:
		c_put_str(TERM_L_RED, "", 5, 50);break;
	case 3:case 4:
		c_put_str(TERM_ORANGE, "", 5, 50);break;
	case 5:
		c_put_str(TERM_WHITE, "", 5, 50);break;
	case 6:case 7:
		c_put_str(TERM_YELLOW, "", 5, 50);break;
	case 8:case 9:
		c_put_str(TERM_L_GREEN, "z", 5, 50);break;
	default:
		c_put_str(TERM_L_RED, "ERROR:wO̐l", 5, 50);break;
	}
	if(second && !same_category_realm(p_ptr->realm1,realm))
		c_put_str(TERM_L_UMBER, "(F̈Ƒ̈)", 6, 40);

}


/*
 * Choose from one of the available magical realms
 */
static byte choose_realm(int *count)
{
	int picks[TV_BOOK_END] = {0};
	int k, i, cs, os;
	byte auto_select = REALM_NONE;
	int n = 0;
	char c;
	char sym[TV_BOOK_END];
	char p2 = ')';
	char buf[80], cur[80];

	if(p_ptr->pclass == CLASS_SAMURAI || p_ptr->pclass == CLASS_YOUMU)
	{
		*count = 1;
		return TV_BOOK_HISSATSU;
	}
	//@Ks/svȐE͏I
	else if(cp_ptr->realm_aptitude[0] == 0 || REALM_SPELLMASTER)
	{
		*count = 0;
		return REALM_NONE;
	}
	for(i=1;i<=TV_BOOK_END;i++)
	{
		if(cp_ptr->realm_aptitude[i] > 1)
		{
			if(p_ptr->realm1 != REALM_NONE)
			{
				if(p_ptr->realm1 == i) continue;
				if(p_ptr->pclass == CLASS_PRIEST && !same_category_realm(p_ptr->realm1,i)) continue;
			}
			picks[(*count)] = i;
			(*count)++;
			auto_select = i;
		}
	}
#if 0
	/* Count the choices */
	if (choices & CH_LIFE)
	{
		(*count)++;
		auto_select = REALM_LIFE;
	}
	if (choices & CH_SORCERY)
	{
		(*count)++;
		auto_select = REALM_SORCERY;
	}
	if (choices & CH_NATURE)
	{
		(*count)++;
		auto_select = REALM_NATURE;
	}
	if (choices & CH_CHAOS)
	{
		(*count)++;
		auto_select = REALM_CHAOS;
	}
	if (choices & CH_DEATH)
	{
		(*count)++;
		auto_select = REALM_DEATH;
	}
	if (choices & CH_TRUMP)
	{
		(*count)++;
		auto_select = REALM_TRUMP;
	}
	if (choices & CH_ARCANE)
	{
		(*count)++;
		auto_select = REALM_ARCANE;
	}
	if (choices & CH_ENCHANT)
	{
		(*count)++;
		auto_select = REALM_CRAFT;
	}
	if (choices & CH_DAEMON)
	{
		(*count)++;
		auto_select = REALM_DAEMON;
	}
	if (choices & CH_CRUSADE)
	{
		(*count)++;
		auto_select = REALM_CRUSADE;
	}
	if (choices & CH_MUSIC)
	{
		(*count)++;
		auto_select = REALM_MUSIC;
	}
	if (choices & CH_HISSATSU)
	{
		(*count)++;
		auto_select = REALM_HISSATSU;
	}
	if (choices & CH_HEX)
	{
		(*count)++;
		auto_select = REALM_HEX;
	}
#endif
	clear_from(10);

	/* Auto-select the realm */
	/*:::K\ȗ̈悪1񖂖@EȂ炱ŏI*/
	if ((*count) < 2) return auto_select;

	///class
	/* Constraint to the 1st realm */
/*
	if (p_ptr->realm2 != 255)
	{
		if (p_ptr->pclass == CLASS_PRIEST)
		{
			if (is_good_realm(p_ptr->realm1))
			{
				choices &= ~(CH_DEATH | CH_DAEMON);
			}
			else
			{
				choices &= ~(CH_LIFE | CH_CRUSADE);
			}
		}
	}
*/
	/* Extra info */
#ifdef JP
	if(p_ptr->pclass == CLASS_LYRICA || p_ptr->pclass == CLASS_MERLIN)
		put_str ("(őI@̓iTɂg܂)", 11, 5);

	put_str ("ӁF@̗̈̑Iɂ肠ȂK̃^Cv܂܂B", 23, 5);
#else
	put_str ("Note: The realm of magic will determine which spells you can learn.", 23, 5);
#endif

	cs = 0;
	for(i=1;i<=(*count);i++)
	{
		sym[n] = I2A(n);
		sprintf(buf, "%c%c %s", sym[n], p2, realm_names[picks[n]]);
		put_str(buf, 12 + (n/4), 2 + 15 * (n%4));
		n++;
	}
#if 0
	cs = 0;
	for (i = 0; i<32; i++)
	{
		/* Analize realms */
		if (choices & (1L << i))
		{
			if (p_ptr->realm1 == i+1)
			{
				
				if (p_ptr->realm2 == 255)
					cs = n;
				/*:::̈IÄƓ̈悪\ȂȂ鏈炵*/
				else
					continue;
			}
			if (p_ptr->realm2 == i+1)
				cs = n;

			sym[n] = I2A(n);

			sprintf(buf, "%c%c %s", sym[n], p2, realm_names[i+1]);
			put_str(buf, 12 + (n/5), 2 + 15 * (n%5));
			picks[n++] = i+1;
		}
	}
#endif
#ifdef JP
	sprintf(cur, "%c%c %s", '*', p2, "_");
#else
	sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif

	/* Get a realm */
	k = -1;
	os = n;
	while (1)	
	{
		/* Move Cursol */
		if (cs != os)
		{
			c_put_str(TERM_WHITE, cur, 12 + (os/4), 2 + 15 * (os%4));
			put_str("                                   ", 3, 40);
			put_str("                                   ", 4, 40);
			put_str("                                   ", 5, 40);
			put_str("                                   ", 6, 40);

			if(cs == n)
			{
#ifdef JP
				sprintf(cur, "%c%c %s", '*', p2, "_");
#else
				sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif
			}
			else
			{
				sprintf(cur, "%c%c %s", sym[cs], p2, realm_names[picks[cs]]);
				print_realm_aptitude(picks[cs],(p_ptr->realm1 != REALM_NONE));

			}
			c_put_str(TERM_YELLOW, cur, 12 + (cs/4), 2 + 15 * (cs%4));
			os = cs;
		}

		if (k >= 0) break;

#ifdef JP
		sprintf(buf, "̈Iŉ(%c-%c) ('='IvVݒ): ", sym[0], sym[n-1]);
#else
		sprintf(buf, "Choose a realm (%c-%c) ('=' for options): ", sym[0], sym[n-1]);
#endif

		put_str(buf, 10, 10);
		c = inkey();
		if (c == 'Q') birth_quit();
		if (c == 'S') return 255;
		if (c == ' ' || c == '\r' || c == '\n')
		{
			if(cs == n)
			{
				k = randint0(n);
				break;
			}
			else
			{
				k = cs;
				break;
			}
		}
		if (c == '*')
		{
			k = randint0(n);
			break;
		}
		if (c == '8')
		{
			if (cs >= 4) cs -= 4;
		}
		if (c == '4')
		{
			if (cs > 0) cs--;
		}
		if (c == '6')
		{
			if (cs < n) cs++;
		}
		if (c == '2')
		{
			if ((cs + 4) <= n) cs += 4;
		}
		k = (islower(c) ? A2I(c) : -1);
		if ((k >= 0) && (k < n))
		{
			cs = k;
			continue;
		}
		k = (isupper(c) ? (26 + c - 'A') : -1);
		if ((k >= 26) && (k < n))
		{
			cs = k;
			continue;
		}
		else k = -1;
		if (c == '?')
		{
#ifdef JP
			show_help("tmagic.txt#Realm");
#else
			show_help("magic.txt#MagicRealms");
#endif
		}
		else if (c == '=')
		{
			screen_save();
#ifdef JP
			do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
#else
			do_cmd_options_aux(OPT_PAGE_BIRTH, "Birth option((*)s effect score)");
#endif

			screen_load();
		}
		else if (c !='2' && c !='4' && c !='6' && c !='8') bell();
	}

	/* Clean up */
	clear_from(10);

	return (picks[k]);
}

/*
 * Choose the magical realms
 */
static bool get_player_realms(void)
{
	int i, count;
	char buf[80];

	/* Clean up infomation of modifications */
	put_str("                                           ", 3, 40);
	put_str("                                           ", 4, 40);
	put_str("                                           ", 5, 40);
	put_str("                                           ", 6, 40);

	/* Select the first realm */
	while (1)
	{
		char temp[80*10];
		cptr t;
		count = 0;

		p_ptr->realm1 = REALM_NONE;
		p_ptr->realm2 = 255;
		p_ptr->realm1 = choose_realm(&count);

		if (255 == p_ptr->realm1) return FALSE;
		if (!p_ptr->realm1) break;

		/* Clean up*/
		clear_from(10);
		print_realm_aptitude(p_ptr->realm1,FALSE);

		roff_to_buf(realm_jouhou[p_ptr->realm1], 74, temp, sizeof(temp));
		t = temp;
		for (i = 0; i < 10; i++)
		{
			if(t[0] == 0)
				break; 
			else
			{
				prt(t, 12+i, 3);
				t += strlen(t) + 1;
			}
		}

		if (count < 2)
		{
#ifdef JP
			prt("L[Ă", 0, 0);
#else
			prt("Hit any key.", 0, 0);
#endif
			(void)inkey();
			prt("", 0, 0);
			break;
		}
		else if(rp_ptr->realm_aptitude[p_ptr->realm1] == 0)
		{
			msg_format("Ȃɂ̗͂̈C邱Ƃ͂łɂȂB");
		}
		if (get_check_strict("낵łH", CHECK_DEFAULT_Y)) break;
	}
	if(p_ptr->realm1 != REALM_NONE)
	{
		put_str("@        :", 6, 1);
		c_put_str(TERM_L_BLUE, realm_names[p_ptr->realm1], 6, 15);
	}
	/* Select the second realm */
	p_ptr->realm2 = REALM_NONE;
	if (p_ptr->realm1 && cp_ptr->realm_aptitude[0] == 3)
	{

		/* Select the second realm */
		while (1)
		{
			char temp[80*8];
			cptr t;

			p_ptr->realm2 = REALM_NONE;
			count = 0;
			p_ptr->realm2 = choose_realm(&count);

			if (255 == p_ptr->realm2) return FALSE;
			if (!p_ptr->realm2) break;

			/* Clean up*/
			clear_from(10);
			print_realm_aptitude(p_ptr->realm2,TRUE);
			roff_to_buf(realm_jouhou[p_ptr->realm2], 74, temp, sizeof(temp));
			t = temp;
			for (i = 0; i< 6; i++)
			{
				if(t[0] == 0)
					break; 
				else
				{
					prt(t, 12+i, 3);
					t += strlen(t) + 1;
				}
			}

			if (count < 2)
			{
#ifdef JP
				prt("L[Ă", 0, 0);
#else
				prt("Hit any key.", 0, 0);
#endif
				(void)inkey();
				prt("", 0, 0);
				break;
			}
#ifdef JP


			if(rp_ptr->realm_aptitude[p_ptr->realm2] == 0)
			{
				msg_format("Ȃɂ̗͂̈C邱Ƃ͂łɂȂB");
			}
			if (get_check_strict("낵łH", CHECK_DEFAULT_Y)) break;
#else
			else if (get_check_strict("Are you sure? ", CHECK_DEFAULT_Y)) break;
#endif

		}
		clear_from(10);

		if (p_ptr->realm2)
		{
			/* Print the realm */
			c_put_str(TERM_L_BLUE, format("%s, %s", realm_names[p_ptr->realm1], realm_names[p_ptr->realm2]), 6, 15);
		}
	}
	if(p_ptr->pclass == CLASS_MAGE)
	{
		if(p_ptr->realm1 <= TV_BOOK_SUMMONS) strcpy(player_class_name, "pt");
		else if(p_ptr->realm1 <= TV_BOOK_NATURE) strcpy(player_class_name, "t");
		else if(p_ptr->realm1 <= TV_BOOK_CHAOS) strcpy(player_class_name, "dpt");
		else  strcpy(player_class_name, "pt");

	}
	else if( p_ptr->pclass == CLASS_HIGH_MAGE)
	{
		if(p_ptr->realm1 == TV_BOOK_ELEMENT) strcpy(player_class_name, "G[e}X^[");
		else if(p_ptr->realm1 == TV_BOOK_FORESEE) strcpy(player_class_name, "vtFbg");
		else if(p_ptr->realm1 == TV_BOOK_ENCHANT) strcpy(player_class_name, "G`^[");
		else if(p_ptr->realm1 == TV_BOOK_SUMMONS) strcpy(player_class_name, "T}i[");
		else if(p_ptr->realm1 == TV_BOOK_MYSTIC) strcpy(player_class_name, "~XeBbN");
		else if(p_ptr->realm1 == TV_BOOK_LIFE) strcpy(player_class_name, "WFl[^[");
		else if(p_ptr->realm1 == TV_BOOK_PUNISH) strcpy(player_class_name, "V[}");
		else if(p_ptr->realm1 == TV_BOOK_NATURE) strcpy(player_class_name, "WI}T[");
		else if(p_ptr->realm1 == TV_BOOK_TRANSFORM) strcpy(player_class_name, "VFCvVt^[");
		else if(p_ptr->realm1 == TV_BOOK_DARKNESS) strcpy(player_class_name, "frT}i[");
		else if(p_ptr->realm1 == TV_BOOK_NECROMANCY) strcpy(player_class_name, "lN}T[");
		else if(p_ptr->realm1 == TV_BOOK_CHAOS) strcpy(player_class_name, "OX}X^[");
		else  strcpy(player_class_name, "IJeBXg");

	}
		c_put_str(TERM_WHITE, "                 ", 5, 15);
		c_put_str(TERM_L_BLUE, player_class_name, 5, 15);



	return (TRUE);
}

/*
 * Save the current data for later
 */
/*:::LCN̋L^*/
/*:::j[NvC[g񂵂͉\Astat_MAX_MAX͕ύX\*/
static void save_prev_data(birther *birther_ptr)
{
	int i;

	/* Save the data */
	birther_ptr->psex = p_ptr->psex;
	birther_ptr->prace = p_ptr->prace;
	birther_ptr->pclass = p_ptr->pclass;
	birther_ptr->pseikaku = p_ptr->pseikaku;
	birther_ptr->realm1 = p_ptr->realm1;
	birther_ptr->realm2 = p_ptr->realm2;
	birther_ptr->age = p_ptr->age;
	birther_ptr->ht = p_ptr->ht;
	birther_ptr->wt = p_ptr->wt;
	birther_ptr->sc = p_ptr->sc;
	birther_ptr->au = p_ptr->au;
	///mod140307 ՓxύX
	birther_ptr->difficulty = difficulty;


	/* Save the stats */
	for (i = 0; i < 6; i++)
	{
		birther_ptr->stat_max[i] = p_ptr->stat_max[i];
		birther_ptr->stat_max_max[i] = p_ptr->stat_max_max[i];
	}

	/* Save the hp */
	for (i = 0; i < PY_MAX_LEVEL; i++)
	{
		birther_ptr->player_hp[i] = p_ptr->player_hp[i];
	}

	birther_ptr->chaos_patron = p_ptr->chaos_patron;

	///sysdel
	/* Save the virtues */
	for (i = 0; i < 8; i++)
	{
		birther_ptr->vir_types[i] = p_ptr->vir_types[i];
	}

	/* Save the history */
	for (i = 0; i < 4; i++)
	{
		strcpy(birther_ptr->history[i], p_ptr->history[i]);
	}
}


/*
 * Load the previous data
 */
/*:::NCbNX^[gpɈȑÕLCN𓾂*/
///system 傪ȃp[^ύX炱ύXKv
static void load_prev_data(bool swap)
{
	int i;

	birther	temp;

	/*** Save the current data ***/
	if (swap) save_prev_data(&temp);


	/*** Load the previous data ***/

	/* Load the data */
	p_ptr->psex = previous_char.psex;
	p_ptr->prace = previous_char.prace;
	p_ptr->pclass = previous_char.pclass;
	p_ptr->pseikaku = previous_char.pseikaku;
	p_ptr->realm1 = previous_char.realm1;
	p_ptr->realm2 = previous_char.realm2;
	p_ptr->age = previous_char.age;
	p_ptr->ht = previous_char.ht;
	p_ptr->wt = previous_char.wt;
	p_ptr->sc = previous_char.sc;
	p_ptr->au = previous_char.au;

	///mod140307 ՓxύX
	difficulty = previous_char.difficulty;

	/* Load the stats */
	for (i = 0; i < 6; i++)
	{
		p_ptr->stat_cur[i] = p_ptr->stat_max[i] = previous_char.stat_max[i];
		p_ptr->stat_max_max[i] = previous_char.stat_max_max[i];
	}

	/* Load the hp */
	for (i = 0; i < PY_MAX_LEVEL; i++)
	{
		p_ptr->player_hp[i] = previous_char.player_hp[i];
	}
	p_ptr->mhp = p_ptr->player_hp[0];
	p_ptr->chp = p_ptr->player_hp[0];

	p_ptr->chaos_patron = previous_char.chaos_patron;

	for (i = 0; i < 8; i++)
	{
		p_ptr->vir_types[i] = previous_char.vir_types[i];
	}

	/* Load the history */
	for (i = 0; i < 4; i++)
	{
		strcpy(p_ptr->history[i], previous_char.history[i]);
	}


	/*** Save the previous data ***/
	if (swap)
	{
		(void)COPY(&previous_char, &temp, birther);
	}
}




/*
 * Returns adjusted stat -JK-  Algorithm by -JWT-
 */
///mod140104 p[^ƕ\LύX
static int adjust_stat(int value, int amount)
{
	int i;

	value += amount;
	if(value < 3) value = 3;
	return (value);




#if 0
	/* Negative amounts */
	if (amount < 0)
	{
		/* Apply penalty */
		for (i = 0; i < (0 - amount); i++)
		{
			if (value >= 18+10)
			{
				value -= 10;
			}
			else if (value > 18)
			{
				value = 18;
			}
			else if (value > 3)
			{
				value--;
			}
		}
	}

	/* Positive amounts */
	else if (amount > 0)
	{
		/* Apply reward */
		for (i = 0; i < amount; i++)
		{
			if (value < 18)
			{
				value++;
			}
			else
			{
				value += 10;
			}
		}
	}

	/* Return the result */
	return (value);
#endif
}




/*
 * Roll for a characters stats
 *
 * For efficiency, we include a chunk of "calc_bonuses()".
 */
/*:::Xe[^X[p_ptr->stat_cur[],stat_max[]Ɋi[*/
/*:::Xe[^X8`17 p[^v73`86͈͓̔*/
static void get_stats(void)
{
	/* Roll and verify some stats */
	while (TRUE)
	{
		int i;
		int sum = 0;

		/* Roll some dice */
		for (i = 0; i < 2; i++)
		{
			s32b tmp = randint0(60*60*60);
			int val;

			/* Extract 5 + 1d3 + 1d4 + 1d5 */
			val = 5 + 3;
			val += tmp % 3; tmp /= 3;
			val += tmp % 4; tmp /= 4;
			val += tmp % 5; tmp /= 5;

			/* Save that value */
			sum += val;
			p_ptr->stat_cur[3*i] = p_ptr->stat_max[3*i] = val;

			/* Extract 5 + 1d3 + 1d4 + 1d5 */
			val = 5 + 3;
			val += tmp % 3; tmp /= 3;
			val += tmp % 4; tmp /= 4;
			val += tmp % 5; tmp /= 5;

			/* Save that value */
			sum += val;
			p_ptr->stat_cur[3*i+1] = p_ptr->stat_max[3*i+1] = val;

			/* Extract 5 + 1d3 + 1d4 + 1d5 */
			val = 5 + 3;
			val += tmp % 3; tmp /= 3;
			val += tmp % 4; tmp /= 4;
			val += tmp;

			/* Save that value */
			sum += val;
			p_ptr->stat_cur[3*i+2] = p_ptr->stat_max[3*i+2] = val;
		}

		/* Verify totals */
		if ((sum > 42+5*6) && (sum < 57+5*6)) break;
		/* 57 was 54... I hate 'magic numbers' :< TY */
	}
}

/*:::{Xe[^X㏸ől(18/70-18/130)𓾂*/
/*:::őlp_ptr->stat_max_max[]Ɋi[Ãp[^ȏȂ猻݃p[^*/

///mod140104 p[^ƕ\LύX@ől͏30(18/120)ɂȂ悤ɂ
void get_max_stats(void)
{
	int		i, j;

	int		dice[6];
#if 0
	/* Roll and verify some stats */
	/*:::1-7𓾂Bv24ɂȂ悤ɁB4̂Ƃől18/100ɂȂB*/
	while (TRUE)
	{
		/* Roll some dice */
		for (j = i = 0; i < 6; i++)
		{
			/* Roll the dice */
			dice[i] = randint1(7);

			/* Collect the maximum */
			j += dice[i];
		}

		/* Verify totals */
		if (j == 24) break;
	}

	/* Acquire the stats */
	for (i = 0; i < 6; i++)
	{
		j = 18 + 60 + dice[i]*10;

		/* Save that value */
		p_ptr->stat_max_max[i] = j;
		if (p_ptr->stat_max[i] > j)
			p_ptr->stat_max[i] = j;
		if (p_ptr->stat_cur[i] > j)
			p_ptr->stat_cur[i] = j;
	}
#endif
	/*:::VőlKpBV̂Ƃstat_maxVől𒴂邱Ƃ͂Ȃ͂*/
	for(i=0;i<6;i++) p_ptr->stat_max_max[i] = STAT_MAX_MAX;

	p_ptr->knowledge &= ~(KNOW_STAT);

	/* Redisplay the stats later */
	p_ptr->redraw |= (PR_STATS);
}


/*
 * Roll for some info that the auto-roller ignores
 */
/*:::LCNɊւ邢̓ꎖs*/
///race class seikaku
///system LCNɖڂɊ֌W
static void get_extra(bool roll_hitdie)
{
	int i, j;

	/* Experience factor */
	/*:::expyieBvZ*/
	if (p_ptr->prace == RACE_ANDROID) p_ptr->expfact = rp_ptr->r_exp;
	else p_ptr->expfact = rp_ptr->r_exp + cp_ptr->c_exp;

	if(EXTRA_MODE && p_ptr->prace != RACE_ANDROID) p_ptr->expfact /= 2;

	//if (((p_ptr->pclass == CLASS_MONK) || (p_ptr->pclass == CLASS_FORCETRAINER) || (p_ptr->pclass == CLASS_NINJA)) && ((p_ptr->prace == RACE_KLACKON) || (p_ptr->prace == RACE_SPRITE)))
	//	p_ptr->expfact -= 15;

	/* Reset record of race/realm changes */
	/*:::uȑÓ`vĨNA*/
	p_ptr->start_race = p_ptr->prace;
	p_ptr->old_race1 = 0L;
	p_ptr->old_race2 = 0L;
	p_ptr->old_realm = 0;

	/*:::Xy}XƐԖ̌ol*/
	for (i = 0; i < 64; i++)
	{
		if (p_ptr->pclass == CLASS_SORCERER) p_ptr->spell_exp[i] = SPELL_EXP_MASTER;
		else if (p_ptr->pclass == CLASS_RED_MAGE) p_ptr->spell_exp[i] = SPELL_EXP_SKILLED;
		else p_ptr->spell_exp[i] = SPELL_EXP_UNSKILLED;
	}
	///skill Z\
/*
	for (i = 0; i < 5; i++)
		for (j = 0; j < 64; j++)
			p_ptr->weapon_exp[i][j] = s_info[p_ptr->pclass].w_start[i][j];
	if ((p_ptr->pseikaku == SEIKAKU_SEXY) && (p_ptr->weapon_exp[TV_HAFTED-TV_WEAPON_BEGIN][SV_WHIP] < WEAPON_EXP_BEGINNER))
	{
		p_ptr->weapon_exp[TV_HAFTED-TV_WEAPON_BEGIN][SV_WHIP] = WEAPON_EXP_BEGINNER;
	}
*/
	///mod131226 skill Z\ƕZ\̓
	///mod140130 skill Z\ƕZ\lݒ
	//for (i = 0; i < 10; i++)
		//p_ptr->skill_exp[i] = s_info[p_ptr->pclass].s_start[i];

	for (i = 0; i < SKILL_EXP_MAX; i++)
	{
		switch(cp_ptr->skill_aptitude[i])
		{
		case 0: case 1: case 2:
			p_ptr->skill_exp[i] =  0;
			break;
		case 3:
			p_ptr->skill_exp[i] =  800;
			break;
		case 4:
			p_ptr->skill_exp[i] =  1600;
			break;
		case 5:
			p_ptr->skill_exp[i] =  2400;
			break;
		default:
			msg_format("ERROR:skill_aptitude[]sȒl");
		}
		/*:::t͍ŏZ\*/
		if(p_ptr->pclass == CLASS_TEACHER) p_ptr->skill_exp[i] =  2400;
		/*:::͐킢̐SȂ*/
		if(p_ptr->pclass == CLASS_SHOU) p_ptr->skill_exp[i] =  0;
		//g͋Z\(e)
		if(p_ptr->pclass == CLASS_MOKOU && i != 20) p_ptr->skill_exp[i] =  3200;

	}

	///mod150824 vYo[Ooꏈ@n[hR[fBO@prism_change_class()Q
	if(CLASS_IS_PRISM_SISTERS)
	{
		//őҋ@Ăȍ̕Z\lݒ
		for(i=0;i<3;i++)
		{
			for (j = 0; j < SKILL_EXP_MAX; j++)
			{
				int init_skill = MAX(0,(class_info[CLASS_LUNASA+i].skill_aptitude[j]-2)) * 800;
				p_ptr->magic_num1[3 + j + SKILL_EXP_MAX * i] = init_skill;
			}
		}
		//bL[K[̂ƂSɕψكtOt^
		if(p_ptr->pseikaku == SEIKAKU_LUCKY)
		{
			p_ptr->magic_num2[14] = 0x80;
			p_ptr->magic_num2[26] = 0x80;
			p_ptr->magic_num2[38] = 0x80;
			p_ptr->magic_num2[50] = 0x80;
			//v1.1.15 6662
			p_ptr->magic_num2[62] = 0x80;
			p_ptr->magic_num2[74] = 0x80;
		}
	}


	/* Hitdice */
	/*:::HDvZ*/
	//v1.1.32 p`[ꐫi
	if (p_ptr->pclass == CLASS_SORCERER || is_special_seikaku(SEIKAKU_SPECIAL_PATCHOULI))
		p_ptr->hitdie = rp_ptr->r_mhp/2 + cp_ptr->c_mhp + ap_ptr->a_mhp;
	else
		p_ptr->hitdie = rp_ptr->r_mhp + cp_ptr->c_mhp + ap_ptr->a_mhp;

	/* Roll for hit point unless quick-start */
	/*:::HPvZ*/
	if (roll_hitdie) do_cmd_rerate_aux();

	/* Initial hitpoints */
	p_ptr->mhp = p_ptr->player_hp[0];
}


/*
 * Get the racial history, and social class, using the "history charts".
 */
///sysdel race
/*:::ftHgƎЉInʂ𓾂B*/
static void get_history(void)
{
	int i, n, chart, roll, social_class;

	char *s, *t;

	char buf[240];

	///tmp131221 ЉInʂƃftHg͂Œ
	p_ptr->sc = 50;
	strcpy(p_ptr->history[0], "LN^[̐⌈ӕ\ȂǍDɏĂ");
	return;
///del140105 Ɏ푰Ƃ̐ftHg菈푰ύXʓ|Ȃ̂őS


}


/*
 * Get character's height and weight
 */
void get_height_weight(void)
{
	int h_percent; /* gςɂׂĂǂ̂炢Ⴄ. */

	/* Calculate the height/weight for males */
	if (p_ptr->psex == SEX_MALE)
	{
		p_ptr->ht = randnor(rp_ptr->m_b_ht, rp_ptr->m_m_ht);
		h_percent = (int)(p_ptr->ht) * 100 / (int)(rp_ptr->m_b_ht);
		p_ptr->wt = randnor((int)(rp_ptr->m_b_wt) * h_percent /100
				    , (int)(rp_ptr->m_m_wt) * h_percent / 300 );
	}
  
	/* Calculate the height/weight for females */
	else if (p_ptr->psex == SEX_FEMALE)
	{
		p_ptr->ht = randnor(rp_ptr->f_b_ht, rp_ptr->f_m_ht);
		h_percent = (int)(p_ptr->ht) * 100 / (int)(rp_ptr->f_b_ht);
		p_ptr->wt = randnor((int)(rp_ptr->f_b_wt) * h_percent /100
				    , (int)(rp_ptr->f_m_wt) * h_percent / 300 );
	}
}


/*
 * Computes character's age, height, and weight
 * by henkma
 */
///sysdel
/*:::NAgȀd𓾂p_ptr->age,p_ptr->ht,p_ptr->wtɊi[BʂƎ푰֌WB*/
static void get_ahw(void)
{
	/* Get character's age */
	p_ptr->age = rp_ptr->b_age + randint1(rp_ptr->m_age);

	/* Get character's height and weight */
	get_height_weight();
}


/*
 * Get the player's starting money
 */
///class system seikaku
/*:::@Xe[^Xƌ炵*/
static void get_money(void)
{
	int i, gold;

	/* Social Class determines starting gold */
	gold = 1000 + randint1(1000);
	if (p_ptr->pclass == CLASS_CIVILIAN)  gold += gold*2 + randint0(2);
	else if (p_ptr->pclass == CLASS_RAN)  gold += gold*3 + randint0(3);


	while(one_in_(7)) gold *= 2;

	if(p_ptr->pclass == CLASS_SHOU) gold *= 3;

	///mod140104 p[^\LύXɔAp[^ŏ鏈Ƃ肠
#if 0
	/* Process the stats */
	for (i = 0; i < 6; i++)
	{
		/* Mega-Hack -- reduce gold for high stats */
		if (p_ptr->stat_max[i] >= 18 + 50) gold -= 300;
		else if (p_ptr->stat_max[i] >= 18 + 20) gold -= 200;
		else if (p_ptr->stat_max[i] > 18) gold -= 150;
		else gold -= (p_ptr->stat_max[i] - 8) * 10;
	}
#endif
	/* Minimum 100 gold */
	//if (gold < 100) gold = 100;

	if(p_ptr->pclass == CLASS_OUTSIDER) gold = 0;
/*
	if (p_ptr->pseikaku == SEIKAKU_NAMAKE)
		gold /= 2;
	else 
*/		
	if (p_ptr->pseikaku == SEIKAKU_MUNCHKIN)
		gold = 10000000;
	//if (p_ptr->prace == RACE_ANDROID) gold /= 5;


	if(p_ptr->pclass == CLASS_TEWI) gold = 1000000;
	else if (p_ptr->pclass == CLASS_SHION) gold = -99999999;


	/* Save the gold */
	p_ptr->au = gold;
}



/*
 * Display stat values, subset of "put_stats()"
 *
 * See 'display_player()' for screen layout constraints.
 */
/*:::I[g[[AIɌ݂̃Xe[^Xʂ̌܂ʒuɕ\*/
static void birth_put_stats(void)
{
	int i, j, m, p;
	int col;
	byte attr;
	char buf[80];


	if (autoroller)
	{
		col = 42;
		/* Put the stats (and percents) */
		for (i = 0; i < 6; i++)
		{
			/* Race/Class bonus */
			j = rp_ptr->r_adj[i] + cp_ptr->c_adj[i] + ap_ptr->a_adj[i];

			/* Obtain the current stat */
			m = adjust_stat(p_ptr->stat_max[i], j);

			/* Put the stat */
			cnv_stat(m, buf);
			c_put_str(TERM_L_GREEN, buf, 3+i, col+24);

			/* Put the percent */
			if (stat_match[i])
			{
				if (stat_match[i] > 1000000L)
				{
					/* Prevent overflow */
					p = stat_match[i] / (auto_round / 1000L);
				}
				else
				{
					p = 1000L * stat_match[i] / auto_round;
				}
			
				attr = (p < 100) ? TERM_YELLOW : TERM_L_GREEN;
				sprintf(buf, "%3d.%d%%", p/10, p%10);
				c_put_str(attr, buf, 3+i, col+13);
			}

			/* Never happened */
			else
			{
#ifdef JP
				c_put_str(TERM_RED, "(Ȃ)", 3+i, col+13);
#else
				c_put_str(TERM_RED, "(NONE)", 3+i, col+13);
#endif

			}
		}
	}
}


static void k_info_reset(void)
{
	int i;

	/* Reset the "objects" */
	for (i = 1; i < max_k_idx; i++)
	{
		object_kind *k_ptr = &k_info[i];

		/* Reset "tried" */
		k_ptr->tried = FALSE;

		/* Reset "aware" */
		k_ptr->aware = FALSE;
	}
}


/*
 * Clear all the global "character" data
 */
/*:::̑S񏉊*/
//Z[uf[^Ɏc悤ȕϐ𑝂₵炱ŖYꂸ
static void player_wipe(void)
{
	int i;

	/*:::bZ[WNA*/
	/* Hack -- free the "last message" string */
	if (p_ptr->last_message) string_free(p_ptr->last_message);

	/*:::p_ptr̃NA*/
	/* Hack -- zero the struct */
	(void)WIPE(p_ptr, player_type);

	/* Wipe the history */
	for (i = 0; i < 4; i++)
	{
		strcpy(p_ptr->history[i], "");
	}

	/*:::NGXgACeȂǁɂO[oϐ̏*/
	/* Wipe the quests */
	for (i = 0; i < max_quests; i++)
	{
		quest[i].status = QUEST_STATUS_UNTAKEN;

		quest[i].cur_num = 0;
		quest[i].max_num = 0;
		quest[i].type = 0;
		quest[i].level = 0;
		quest[i].r_idx = 0;
		quest[i].complev = 0;
		//v1.1.25
		quest[i].comptime = 0;
	}

	/* No weight */
	p_ptr->total_weight = 0;

	/* No items */
	inven_cnt = 0;
	equip_cnt = 0;

	/* Clear the inventory */
	for (i = 0; i < INVEN_TOTAL; i++)
	{
		object_wipe(&inventory[i]);
	}

	/* Clear the inventory2 */
	for (i = 0; i < INVEN_ADD_MAX; i++)
	{
		object_wipe(&inven_add[i]);
	}
	/* Clear the inventory3 */
	///mod160212 inven_addĂBC
	for (i = 0; i < INVEN_SPECIAL_MAX; i++)
	{
		object_wipe(&inven_special[i]);
	}

	/* Start with no artifacts made yet */
	for (i = 0; i < max_a_idx; i++)
	{
		artifact_type *a_ptr = &a_info[i];
		a_ptr->cur_num = 0;
	}

	//EXp[^
	for(i=0;i<EX_BUILDINGS_PARAM_MAX;i++) ex_buildings_param[i] = 0;
	for(i=0;i<EX_BUILDINGS_HISTORY_MAX;i++) ex_buildings_history[i] = 0;

	/* Reset the objects */
	k_info_reset();

	/* Reset the "monsters" */
	for (i = 1; i < max_r_idx; i++)
	{
		monster_race *r_ptr = &r_info[i];

		/* Hack -- Reset the counter */
		r_ptr->cur_num = 0;

		/* Hack -- Reset the max counter */
		r_ptr->max_num = 100;

		/* Hack -- Reset the max counter */
		if (r_ptr->flags1 & RF1_UNIQUE) r_ptr->max_num = 1;

		/* Hack -- Non-unique Nazguls are semi-unique */
		else if (r_ptr->flags7 & RF7_NAZGUL) r_ptr->max_num = MAX_NAZGUL_NUM;

		/* Clear visible kills in this life */
		r_ptr->r_pkills = 0;

		/* Clear all kills in this life */
		r_ptr->r_akills = 0;

		//v1.1.30 _j[NB
		//ȂĂɐݒ肳邩Ȃ낤ƎvĂ˕P̃__~낵őOQ[̃_j[N̋ZoĂ
		if(IS_RANDOM_UNIQUE_IDX(i))
		{
			int j;
			my_strcpy(random_unique_name[i - MON_RANDOM_UNIQUE_1],"wiped_random_unique",sizeof(random_unique_name[i - MON_RANDOM_UNIQUE_1])-2);
			r_ptr->hdice = 1;
			r_ptr->hside = 1;
			r_ptr->ac = 10;
			r_ptr->sleep = 10;
			r_ptr->aaf = 10;
			r_ptr->speed = 110;
			r_ptr->mexp = 1;
			r_ptr->extra = 0;
			r_ptr->freq_spell = 0;
			r_ptr->flags1 = (RF1_FORCE_MAXHP);
			r_ptr->flags2 = 0L;
			r_ptr->flags3 = 0L;
			r_ptr->flags4 = 0L;
			r_ptr->flags5 = 0L;
			r_ptr->flags6 = 0L;
			r_ptr->flags7 = (RF7_UNIQUE2 | RF7_VARIABLE);
			if(i == MON_RANDOM_UNIQUE_3) r_ptr->flags7 |= (RF7_AQUATIC);
			r_ptr->flags8 = 0L;
			r_ptr->flags9 = 0L;
			r_ptr->flagsr = 0L;

			for(j=0;j<3;j++)
			{
				r_ptr->blow[j].method = RBM_HIT;
				r_ptr->blow[j].effect = RBE_HURT;
				r_ptr->blow[j].d_dice = 1;
				r_ptr->blow[j].d_side = 1;
			}
			r_ptr->level = 1;
			r_ptr->rarity = 1;
			r_ptr->r_flags1 = 0L;
			r_ptr->r_flags2 = 0L;
			r_ptr->r_flags3 = 0L;
			r_ptr->r_flags4 = 0L;
			r_ptr->r_flags5 = 0L;
			r_ptr->r_flags6 = 0L;
			r_ptr->r_flags9 = 0L;
			r_ptr->r_flagsr = 0L;
		}

	}

	/* Hack -- Well fed player */
	p_ptr->food = PY_FOOD_FULL - 1;


	/* Wipe the spells */
	///class Xy}XŏSKς݂ɂȂĂ鏈
	if (p_ptr->pclass == CLASS_SORCERER)
		///bug ̍sLɂVKvCɃt[Y@̒iKłcp_ptrLłȂ炵BƂȂƓꖂ@KE͂ǂŔ肵悤B
	//if (REALM_SPELLMASTER)
	{
		p_ptr->spell_learned1 = p_ptr->spell_learned2 = 0xffffffffL;
		p_ptr->spell_worked1 = p_ptr->spell_worked2 = 0xffffffffL;
	}
	else
	{
		p_ptr->spell_learned1 = p_ptr->spell_learned2 = 0L;
		p_ptr->spell_worked1 = p_ptr->spell_worked2 = 0L;
	}
	p_ptr->spell_forgotten1 = p_ptr->spell_forgotten2 = 0L;
	for (i = 0; i < 64; i++) p_ptr->spell_order[i] = 99;
	p_ptr->learned_spells = 0;
	p_ptr->add_spells = 0;
	p_ptr->knowledge = 0;

	/* Clean the mutation count */
	mutant_regenerate_mod = 100;

	/* Clear "cheat" options */
	cheat_peek = FALSE;
	cheat_hear = FALSE;
	cheat_room = FALSE;
	cheat_xtra = FALSE;
	cheat_know = FALSE;
	cheat_live = FALSE;
	cheat_save = FALSE;

	/* Assume no winning game */
	p_ptr->total_winner = FALSE;

	world_player = FALSE;

	/* Assume no panic save */
	p_ptr->panic_save = 0;

	/* Assume no cheating */
	p_ptr->noscore = 0;
	p_ptr->wizard = FALSE;

	/* Not waiting to report score */
	p_ptr->wait_report_score = FALSE;

	/* Default pet command settings */
	p_ptr->pet_follow_distance = PET_FOLLOW_DIST;
	p_ptr->pet_extra_flags = (PF_TELEPORT | PF_ATTACK_SPELL | PF_SUMMON_SPELL);

	/* Wipe the recall depths */
	for (i = 0; i < max_d_idx; i++)
	{
		max_dlv[i] = 0;
		flag_dungeon_complete[i] = 0;
	}

	p_ptr->visit = 1;

	/* Reset wild_mode to FALSE */
	p_ptr->wild_mode = FALSE;

	for (i = 0; i < 108; i++)
	{
		p_ptr->magic_num1[i] = 0;
		p_ptr->magic_num2[i] = 0;
	}

	/* Level one */
	p_ptr->max_plv = p_ptr->lev = 1;

	///mod140423
	p_ptr->silent_floor = 0;
	p_ptr->maripo = 0;
	p_ptr->maripo_presented_flag = 0L;

	///mod140502
	p_ptr->lucky = 0;

	///mod140813
	p_ptr->asthma = 0;
	for (i = 0; i < 5; i++)p_ptr->race_multipur_val[i] = 0;

	/* Initialize arena and rewards information -KMW- */
	p_ptr->arena_number = 0;
	p_ptr->inside_arena = FALSE;
	p_ptr->inside_quest = 0;
	///class ̂܂ˎt̏
	for (i = 0; i < MAX_MANE; i++)
	{
		p_ptr->mane_spell[i] = -1;
		p_ptr->mane_dam[i] = 0;
	}
	p_ptr->mane_num = 0;
	p_ptr->exit_bldg = TRUE; /* only used for arena now -KMW- */

	/* Bounty */
	p_ptr->today_mon = 0;

	/* Reset monster arena */
	///sysdel tougi
	//battle_monsters();

	/* Reset mutations */
	p_ptr->muta1 = 0;
	p_ptr->muta2 = 0;
	p_ptr->muta3 = 0;
	p_ptr->muta1_perma = 0;
	p_ptr->muta2_perma = 0;
	p_ptr->muta3_perma = 0;


	/* Reset virtues*/
	for (i = 0; i < 8; i++)
	{
			p_ptr->virtues[i]=0;
			p_ptr->vir_types[i] = 0;
	}

	/* Set the recall dungeon accordingly */
	if (vanilla_town)
	{
		dungeon_type = 0;
		p_ptr->recall_dungeon = DUNGEON_ANGBAND;
	}
	else
	{
		dungeon_type = 0;
		p_ptr->recall_dungeon = DUNGEON_TAISHI;
	}

	//v1.1.19
	p_ptr->monkey_count = 0;

	//v1.1.25
	score_bonus_kill_unique2 = 0L;

	//v1.1.52 ɒǉYĂ
	qrkdr_rec_turn = 0;
	gambling_gain = 0;
	score_count_pinch = 0;
	score_count_pinch2 = 0;
	nightmare_diary_count = 0; 
	nightmare_diary_win = 0;	
	nightmare_total_point = 0;



}


/*
 *  Hook function for quest monsters
 */
/*:::NGIphook*/
static bool mon_hook_quest(int r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	/* Random quests are in the dungeon */
	if (r_ptr->flags8 & RF8_WILD_ONLY) return FALSE;

	/* No random quests for aquatic monsters */
	if (r_ptr->flags7 & RF7_AQUATIC) return FALSE;

	/* No random quests for multiplying monsters */
	if (r_ptr->flags2 & RF2_MULTIPLY) return FALSE;

	/* No quests to kill friendly monsters */
	if (r_ptr->flags7 & RF7_FRIENDLY) return FALSE;

	/*::: Hack YOXl̓NGɏoȂ*/
	if(r_idx == MON_MOZGUS || r_idx == MON_MOZGUS2) return FALSE;

	//v1.1.42 ̓NGɏoȂ
	if (r_idx == MON_SHION_1 || r_idx == MON_SHION_2) return FALSE;

	return TRUE;
}


/*
 * Determine the random quest uniques
 */
/*:::NGpX^[I肷*/
///system NGGȂ炱̕
void determine_random_questor(quest_type *q_ptr)
{
	int          r_idx;
	monster_race *r_ptr;

	/* Prepare allocation table */
	get_mon_num_prep(mon_hook_quest, NULL);

	while (1)
	{
		/*
		 * Random monster 5 - 10 levels out of depth
		 * (depending on level)
		 */
		r_idx = get_mon_num(q_ptr->level + 5 + randint1(q_ptr->level / 10));
		r_ptr = &r_info[r_idx];

		if (!(r_ptr->flags1 & RF1_UNIQUE)) continue;

		///mod140301 n
		/*:::_Ww肳Ă郂X^[͏oȂƂɂ*/
		if(r_ptr->extra != 0) continue;
		///mod140610 qˎ҃NGXg
		/*:::qˎ҂NGΏۂɂȂȂ悤ɐݒ肷*/
		if(r_ptr->flags3 & RF3_WANTED) continue;

		if (r_ptr->flags1 & RF1_QUESTOR) continue;

		///mod140721 Փxł͏ՃNGXgɋGoȂ
		if(q_ptr->level < 45 && difficulty <= DIFFICULTY_NORMAL && (r_ptr->flags1 & RF1_FLAG_50F))	continue;

		if (r_ptr->rarity > 100) continue;

		if (r_ptr->flags7 & RF7_FRIENDLY) continue;
		if (r_ptr->flags3 & RF3_ANG_FRIENDLY) continue;
		if (r_ptr->flags3 & RF3_GEN_FRIENDLY) continue;

		if (r_ptr->flags7 & RF7_AQUATIC) continue;

		if (r_ptr->flags8 & RF8_WILD_ONLY) continue;

		if (no_questor_or_bounty_uniques(r_idx)) continue;



		/*
		 * Accept monsters that are 2 - 6 levels
		 * out of depth depending on the quest level
		 */
		if (r_ptr->level > (q_ptr->level + (q_ptr->level / 20))) break;
	}

	q_ptr->r_idx = r_idx;
}


/*
 *  Initialize random quests and final quests
 */
/*:::NGXg̏@NG̃X^[肵AIxƃT[yg̃NGXgisԂɂĂ*/
static void init_dungeon_quests(void)
{
	//int number_of_quests = MAX_RANDOM_QUEST - MIN_RANDOM_QUEST + 1;
	///mod140305 50FNG𖳂
	int number_of_quests = 9;
	int i;

	/* Init the random quests */
	init_flags = INIT_ASSIGN;
	p_ptr->inside_quest = MIN_RANDOM_QUEST;

	/*:::̒q_pref.txtǂݍ܂*/
	process_dungeon_file("q_info.txt", 0, 0, 0, 0);

	p_ptr->inside_quest = 0;

	/* Generate quests */
	//quest[40]-[48]NGɎg
	for (i = MIN_RANDOM_QUEST + number_of_quests - 1; i >= MIN_RANDOM_QUEST; i--)
	{
		quest_type      *q_ptr = &quest[i];
		monster_race    *quest_r_ptr;

		q_ptr->status = QUEST_STATUS_TAKEN;

		if(EXTRA_MODE) continue; //Extra[hł̓NGʃNGXgɂȂ̂Ŏ̂ă^[QbgX^[͌߂Ȃ

		///quest KvA
		determine_random_questor(q_ptr);

		/* Mark uniques */
		quest_r_ptr = &r_info[q_ptr->r_idx];
		quest_r_ptr->flags1 |= RF1_QUESTOR;

		q_ptr->max_num = 1;
	}

	if(EXTRA_MODE)//Extra[hł͍ŏIxNGXĝANGXǵ͖@قNGXgȂ
	{
		init_flags = INIT_ASSIGN;
		p_ptr->inside_quest = QUEST_OBERON;
		process_dungeon_file("q_info.txt", 0, 0, 0, 0);
		quest[QUEST_OBERON].status = QUEST_STATUS_TAKEN;
	}
	else
	{
		/*:::Mega Hack ꕔj[NNX͓NGXgŏIɎsɂȂ*/
		for (i = 1; i < max_quests; i++)
		{
			if(check_ignoring_quest(i)) quest[i].status = QUEST_STATUS_FAILED_DONE;
		}
		/* Init the two main quests (Oberon + Serpent) */
		init_flags = INIT_ASSIGN;
		//p_ptr->inside_quest = QUEST_OBERON;
		p_ptr->inside_quest = QUEST_YUKARI;

		process_dungeon_file("q_info.txt", 0, 0, 0, 0);

		//quest[QUEST_OBERON].status = QUEST_STATUS_TAKEN;
		quest[QUEST_YUKARI].status = QUEST_STATUS_TAKEN;

		/*:::Hack - ͎NGXgς(XRAɂ͎QȂ)*/
		///mod160213 ɂ
		if(p_ptr->pclass == CLASS_RAN || p_ptr->pclass == CLASS_YUKARI)
		{
			quest[QUEST_YUKARI].status = QUEST_STATUS_FINISHED;
			p_ptr->inside_quest = QUEST_OBERON;
			init_flags |= INIT_ASSIGN;
			process_dungeon_file("q_info.txt", 0, 0, 0, 0);
			quest[QUEST_OBERON].status = QUEST_STATUS_TAKEN;

		}
		/*:::Hack - pNGXg*/
		else if(p_ptr->pclass == CLASS_MARISA)
		{
			p_ptr->inside_quest = QUEST_MOON_VAULT;
			init_flags |= INIT_ASSIGN;
			process_dungeon_file("q_info.txt", 0, 0, 0, 0);
			quest[QUEST_MOON_VAULT].status = QUEST_STATUS_TAKEN;

			p_ptr->inside_quest = QUEST_MARICON;
			init_flags |= INIT_ASSIGN;
			process_dungeon_file("q_info.txt", 0, 0, 0, 0);
			quest[QUEST_MARICON].status = QUEST_STATUS_TAKEN;
		}
	}

	//p_ptr->inside_quest = QUEST_SERPENT;
	//process_dungeon_file("q_info.txt", 0, 0, 0, 0);
	//quest[QUEST_SERPENT].status = QUEST_STATUS_TAKEN;
	p_ptr->inside_quest = 0;
}

/*
 * Reset turn
 */
/*:::^[͈ڂ̒6Jn@Afbh0炾Iɂ͑^[iŊJn炵*/
static void init_turn(void)
{
#if 0
	if ((p_ptr->prace == RACE_VAMPIRE) ||
	    (p_ptr->prace == RACE_SKELETON) ||
	    (p_ptr->prace == RACE_ZOMBIE) ||
	    (p_ptr->prace == RACE_SPECTRE))
	{
		/* Undead start just after midnight */
		/*:::Afbh0Jn@^[18Ԑi߂@*/
		turn = (TURNS_PER_TICK*3 * TOWN_DAWN) / 4 + 1;
		turn_limit = TURNS_PER_TICK * TOWN_DAWN * MAX_DAYS + TURNS_PER_TICK * TOWN_DAWN * 3 / 4;
	}
	else
	{
		turn = 1;
		turn_limit = TURNS_PER_TICK * TOWN_DAWN * (MAX_DAYS - 1) + TURNS_PER_TICK * TOWN_DAWN * 3 / 4;
	}
#endif
	///mod1401 Afbh邩Jndl𖳂
	turn = 1;
	turn_limit = TURNS_PER_TICK * TOWN_DAWN * (MAX_DAYS - 1) + TURNS_PER_TICK * TOWN_DAWN * 3 / 4;

	dungeon_turn = 1;
	dungeon_turn_limit = TURNS_PER_TICK * TOWN_DAWN * (MAX_DAYS - 1) + TURNS_PER_TICK * TOWN_DAWN * 3 / 4;
}


/* 
 * Try to wield everything wieldable in the inventory. 
 * Code taken from Angband 3.1.0 under Angband license
 */ 
/*:::CxgɂACeSĂ𒲂ׁAł̂𑕔@܂@player_outfit()̂݌Ă΂*/
static void wield_all(void) 
{ 
	object_type *o_ptr; 
	object_type *i_ptr; 
	object_type object_type_body; 
 
	int slot; 
	int item; 
 
	/* Scan through the slots backwards */ 
	for (item = INVEN_PACK - 1; item >= 0; item--) 
	{ 
		o_ptr = &inventory[item]; 
 
		/* Skip non-objects */ 
		if (!o_ptr->k_idx) continue; 
 
		/*:::iłȂ́AAłɉĂꏊ̓pX*/
		/* Make sure we can wield it and that there's nothing else in that slot */ 
		if(p_ptr->pclass == CLASS_3_FAIRIES) slot = wield_slot_3_fairies(o_ptr); 
		else	slot = wield_slot(o_ptr); 

		if (slot < INVEN_RARM) continue; 
		if (o_ptr->tval == TV_LITE && o_ptr->sval == SV_LITE_TORCH && !object_is_artifact(o_ptr) ) continue; /* Does not wield toaches because buys a lantern soon */
		if (inventory[slot].k_idx) continue; 
 

		/* Get local object */ 
		i_ptr = &object_type_body; 
		object_copy(i_ptr, o_ptr); 
 
		/* Modify quantity */ 
		i_ptr->number = 1; 
 
		/* Decrease the item (from the pack) */ 
		if (item >= 0) 
		{ 
			inven_item_increase(item, -1); 
			inven_item_optimize(item); 
		} 
 
		/* Decrease the item (from the floor) */ 
		else 
		{ 
			floor_item_increase(0 - item, -1); 
			floor_item_optimize(0 - item); 
		} 
 
		/* Get the wield slot */ 
		o_ptr = &inventory[slot]; 
 
		/* Wear the new stuff */ 
		object_copy(o_ptr, i_ptr); 
 
		/* Increase the weight */ 
		/*:::Ȃ񂩂ŏdʉẐ͂CB܂ǂقǂȂČvZƎv*/
		p_ptr->total_weight += i_ptr->weight; 
 
		/* Increment the equip counter by hand */ 
		equip_cnt++;

 	} 
	return; 
} 


/*
 * Each player starts out with a few items, given as tval/sval pairs.
 * In addition, he always has some food and a few torches.
 */
/*:::NXƂ̏ACeꗗ*/
///class item NXƂ̏ACeꗗ
#if 0
static byte player_init[MAX_CLASS][3][2] =
{
	{
		/* Warrior */
		{ TV_RING, SV_RING_RES_FEAR }, /* Warriors need it! */
		{ TV_HARD_ARMOR, SV_CHAIN_MAIL },
		{ TV_SWORD, SV_BROAD_SWORD }
	},

	{
		/* Mage */
		{ TV_SORCERY_BOOK, 0 }, /* Hack: for realm1 book */
		{ TV_DEATH_BOOK, 0 }, /* Hack: for realm2 book */
		{ TV_SWORD, SV_DAGGER }
	},

	{
		/* Priest */
		{ TV_SORCERY_BOOK, 0 }, /* Hack: for Life / Death book */
		{ TV_DEATH_BOOK, 0 }, /* Hack: for realm2 book */
		{ TV_HAFTED, SV_MACE }
	},

	{
		/* Rogue */
		{ TV_SORCERY_BOOK, 0 }, /* Hack: for realm1 book */
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR },
		{ TV_SWORD, SV_DAGGER }
	},

	{
		/* Ranger */
		{ TV_NATURE_BOOK, 0 },
		{ TV_DEATH_BOOK, 0 },		/* Hack: for realm2 book */
		{ TV_SWORD, SV_DAGGER }
	},

	{
		/* Paladin */
		{ TV_SORCERY_BOOK, 0 },
		{ TV_SCROLL, SV_SCROLL_PROTECTION_FROM_EVIL },
		{ TV_SWORD, SV_BROAD_SWORD }
	},

	{
		/* Warrior-Mage */
		{ TV_SORCERY_BOOK, 0 }, /* Hack: for realm1 book */
		{ TV_DEATH_BOOK, 0 }, /* Hack: for realm2 book */
		{ TV_SWORD, SV_SHORT_SWORD }
	},

	{
		/* Chaos Warrior */
		{ TV_SORCERY_BOOK, 0 }, /* Hack: For realm1 book */
		{ TV_HARD_ARMOR, SV_METAL_SCALE_MAIL },
		{ TV_SWORD, SV_BROAD_SWORD }
	},

	{
		/* Monk */
		{ TV_SORCERY_BOOK, 0 },
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR },
		{ TV_POTION, SV_POTION_HEROISM }
	},

	{
		/* Mindcrafter */
		{ TV_POTION, SV_POTION_SPEED },
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR },
		{ TV_SWORD, SV_SMALL_SWORD }
	},

	{
		/* High Mage */
		{ TV_SORCERY_BOOK, 0 }, /* Hack: for realm1 book */
		{ TV_RING, SV_RING_SUSTAIN_INT},
		{ TV_SWORD, SV_DAGGER }
	},

	{
		/* Tourist */
		{ TV_FOOD, SV_FOOD_JERKY},
		{ TV_SCROLL, SV_SCROLL_MAPPING },
		{ TV_BOW, SV_SLING}
	},

	{
		/* Imitator */
		{ TV_POTION, SV_POTION_SPEED },
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR },
		{ TV_SWORD, SV_SHORT_SWORD}
	},

	{
		/* Beastmaster */
		{ TV_TRUMP_BOOK, 0 },
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR },
		{ TV_POLEARM, SV_SPEAR}
	},

	{
		/* Sorcerer */
		{ TV_HAFTED, SV_WIZSTAFF }, /* Hack: for realm1 book */
		{ TV_RING, SV_RING_SUSTAIN_INT},
		{ TV_WAND, SV_WAND_MAGIC_MISSILE }
	},

	{
		/* Archer */
		{ TV_BOW, SV_SHORT_BOW },
		{ TV_SOFT_ARMOR, SV_LEATHER_SCALE_MAIL},
		{ TV_SWORD, SV_SHORT_SWORD },
	},

	{
		/* Magic eater */
		{ TV_WAND, SV_WAND_MAGIC_MISSILE },
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR},
		{ TV_SWORD, SV_SHORT_SWORD },
	},

	{
		/* Bard */
		{ TV_MUSIC_BOOK, 0 },
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR},
		{ TV_SWORD, SV_SHORT_SWORD },
	},

	{
		/* Red Mage */
		{ TV_ARCANE_BOOK, 0 },
		{ TV_SOFT_ARMOR, SV_HARD_LEATHER_ARMOR},
		{ TV_SWORD, SV_SHORT_SWORD },
	},

	{
		/* Samurai */
		{ TV_HISSATSU_BOOK, 0 },
		{ TV_HARD_ARMOR, SV_CHAIN_MAIL },
		{ TV_SWORD, SV_BROAD_SWORD }
	},

	{
		/* ForceTrainer */
		{ TV_SORCERY_BOOK, 0 },
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR },
		{ TV_POTION, SV_POTION_RESTORE_MANA }
	},

	{
		/* Blue Mage */
		{ TV_SOFT_ARMOR, SV_ROBE },
		{ TV_WAND, SV_WAND_MAGIC_MISSILE },
		{ TV_SWORD, SV_DAGGER }
	},

	{
		/* Cavalry */
		{ TV_BOW, SV_SHORT_BOW },
		{ TV_SOFT_ARMOR, SV_LEATHER_SCALE_MAIL},
		{ TV_POLEARM, SV_BROAD_SPEAR}
	},

	{
		/* Berserker */
		{ TV_POTION, SV_POTION_HEALING },
		{ TV_HARD_ARMOR, SV_AUGMENTED_CHAIN_MAIL },
		{ TV_POLEARM, SV_BROAD_AXE }
	},

	{
		/* Weaponsmith */
		{ TV_RING, SV_RING_RES_FEAR }, /* Warriors need it! */
		{ TV_HARD_ARMOR, SV_CHAIN_MAIL },
		{ TV_POLEARM, SV_BROAD_AXE }
	},
	{
		/* Mirror-Master */
		{ TV_POTION, SV_POTION_SPEED },
		{ TV_RING, SV_RING_SUSTAIN_INT},
		{ TV_SWORD, SV_DAGGER }
	},
	{
		/* Ninja */
		{ TV_POTION, SV_POTION_SPEED },
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR },
		{ TV_SWORD, SV_DAGGER }
	},
	{
		/* Sniper */
		{ TV_BOW, SV_LIGHT_XBOW },
		{ TV_SOFT_ARMOR, SV_SOFT_LEATHER_ARMOR },
		{ TV_SWORD, SV_DAGGER }
	},
};
#endif

/*
 * Hook function for human corpses
 */
static bool monster_hook_human(int r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (r_ptr->flags1 & (RF1_UNIQUE)) return FALSE;

	if (my_strchr("pht", r_ptr->d_char)) return TRUE;

	return FALSE;
}


/*
 * Add an outfit object
 */
/*:::player_outfitĂ΂BwACeӒ肵UbNɒǉ\Ȃ瑕*/
static void add_outfit(object_type *o_ptr)
{
	s16b slot;

	object_aware(o_ptr);
	object_known(o_ptr);
	///mod140821 i͑S*Ӓ*悤ɏC
	o_ptr->ident |= (IDENT_MENTAL);
	slot = inven_carry(o_ptr);

	/* Auto-inscription */
	autopick_alter_item(slot, FALSE);

	/* Now try wielding everything */ 
	wield_all(); 
}


/*:::player_outfit()gACe*/
/*:::푰ƊJni@HV݂̓Ȃ*/
outfit_type birth_outfit_race[] = {
	{RACE_KARASU_TENGU,2,0,TV_HEAD,SV_HEAD_TOKIN,1},
	{RACE_HAKUROU_TENGU,2,0,TV_HEAD,SV_HEAD_TOKIN,1},

	{RACE_HUMAN,2,0,TV_FOOD,SV_FOOD_RATION,5},
	{RACE_YOUKAI,2,0,TV_FOOD,SV_FOOD_RATION,7},
	{RACE_HALF_YOUKAI,2,0,TV_FOOD,SV_FOOD_RATION,2},
	{RACE_SENNIN,2,0,TV_FOOD,SV_FOOD_SENTAN,3},
	{RACE_TENNIN,2,0,TV_SWEETS,SV_SWEETS_PEACH,6},
	{RACE_FAIRY,2,0,TV_SWEETS,SV_SWEET_COOKIE,4},
	{RACE_KAPPA,2,0,TV_FOOD,SV_FOOD_CUCUMBER,5},
	{RACE_KARASU_TENGU,2,0,TV_FOOD,SV_FOOD_HARDBUSC,6},
	{RACE_HAKUROU_TENGU,2,0,TV_FOOD,SV_FOOD_RATION,6},
	{RACE_ONI,2,0,TV_ALCOHOL,SV_ALCOHOL_ONIKOROSHI,5},
	{RACE_DEATH,2,0,TV_FOOD,SV_FOOD_RATION,3},
	{RACE_WARBEAST,2,0,TV_FOOD,SV_FOOD_VENISON,20},
	{RACE_TSUKUMO,2,0,TV_STAFF,SV_STAFF_NOTHING,1},//P͎Ȃ@ꏈ
	{RACE_ANDROID,2,0,TV_STAFF,SV_STAFF_NOTHING,1},//fBX͎Ȃ\
	{RACE_GYOKUTO,2,0,TV_SWEETS,SV_SWEETS_DANGO,10},
	{RACE_YOUKO,2,0,TV_FOOD,SV_FOOD_ABURAAGE,3},
	{RACE_YAMAWARO,2,0,TV_FOOD,SV_FOOD_CUCUMBER,5},
	{RACE_BAKEDANUKI,2,0,TV_FOOD,SV_FOOD_RATION,6},
	{RACE_NINGYO,2,0,TV_FOOD,SV_FOOD_RATION,3},
	{RACE_HOFGOBLIN,2,0,TV_FOOD,SV_FOOD_RATION,3},
	{RACE_NYUDOU,2,0,TV_FOOD,SV_FOOD_RATION,7},
	{RACE_IMP,2,0,TV_FOOD,SV_FOOD_RATION,3},
	{RACE_GOLEM,2,0,TV_MATERIAL,SV_MATERIAL_STONE,4},
	{RACE_KOBITO,2,0,TV_SWEETS,SV_SWEET_COOKIE,4},
	{RACE_ZOMBIE,2,0,TV_FOOD,SV_FOOD_SENTAN,3},
	{RACE_SPECTRE,2,0,TV_FOOD,SV_FOOD_RATION,2},
	{RACE_STRAYGOD,2,0,TV_FOOD,SV_FOOD_RATION,3},
	{RACE_HALF_GHOST,2,0,TV_FOOD,SV_FOOD_RATION,3},
	{RACE_DAIYOUKAI,2,0,TV_FOOD,SV_FOOD_RATION,3},
	{RACE_GREATER_LILLIPUT,2,0,TV_FOOD,SV_FOOD_RATION,3},
	{RACE_DEMIGOD,2,0,TV_FOOD,SV_FOOD_RATION,3},

	{RACE_LUNARIAN,2,0,TV_SWEETS,SV_SWEETS_PEACH,4},

	{-1,0,0,0,0,0} //I[dummy
};

/*:::EƂƊJni@iȂ*/
outfit_type birth_outfit_class[] = {
	{CLASS_WARRIOR,2,0,TV_SWORD,SV_WEAPON_LONG_SWORD,1},
	{CLASS_WARRIOR,2,0,TV_ARMOR,SV_ARMOR_SCALE,1},
	{CLASS_MAGE,2,0,TV_STICK,SV_WEAPON_QUARTERSTAFF,1},
	{CLASS_MAGE,2,0,TV_CLOTHES,SV_CLOTH_ROBE,1},
	{CLASS_HIGH_MAGE,2,0,TV_STICK,SV_WEAPON_QUARTERSTAFF,1},
	{CLASS_HIGH_MAGE,2,0,TV_CLOTHES,SV_CLOTH_ROBE,1},
	{CLASS_RANGER,2,0,TV_ARMOR,SV_ARMOR_LEATHER,1},
	{CLASS_RANGER,2,0,TV_KNIFE,SV_WEAPON_YAMAGATANA,1},
	{CLASS_RANGER,2,0,TV_BOW,SV_FIRE_SHORT_BOW,1},
	{CLASS_RANGER,2,0,TV_ARROW,SV_AMMO_LIGHT,20},
	{CLASS_MAID,0,0,TV_CLOTHES,SV_CLOTH_MAID,1},
	{CLASS_MAID,1,0,TV_CLOTHES,SV_CLOTH_SUIT,1},
	{CLASS_MAID,2,0,TV_KNIFE,SV_WEAPON_DAGGER,1},
	{CLASS_CIVILIAN,2,0,TV_CLOTHES,SV_CLOTH_EASTERN,1},

	{CLASS_CAVALRY,2,0,TV_POLEARM,SV_WEAPON_GLAIVE,1},
	{CLASS_CAVALRY,2,0,TV_ARMOR,SV_ARMOR_SCALE,1},

	{CLASS_ROGUE,2,0,TV_KNIFE,SV_WEAPON_TANTO,1},
	{CLASS_ROGUE,2,0,TV_CLOTHES,SV_CLOTH_PADDED,1},
	{CLASS_ROGUE,2,0,TV_SCROLL,SV_SCROLL_MAPPING,5},

	{CLASS_ARCHER,2,0,TV_BOW,SV_FIRE_SHORT_BOW,1},
	{CLASS_ARCHER,2,0,TV_CLOTHES,SV_CLOTH_PADDED,1},
	{CLASS_ARCHER,2,0,TV_ARROW,SV_AMMO_LIGHT,30},
	{CLASS_TEACHER,2,0,TV_SWORD,SV_WEAPON_RAPIER,1},
	{CLASS_TEACHER,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_PRIEST,2,0,TV_CLOTHES, SV_CLOTH_ROBE,1},
	{CLASS_PRIEST,2,0,TV_HAMMER,SV_WEAPON_MACE,1},
	{CLASS_OUTSIDER,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_OUTSIDER,2,0,TV_SOUVENIR,SV_SOUVENIR_SMARTPHONE,1},
	{CLASS_TSUKUMO_MASTER,2,0,TV_CLOTHES,SV_CLOTH_EASTERN,1},
	{CLASS_TSUKUMO_MASTER,2,0,TV_AXE,SV_WEAPON_BROAD_AXE,1},
	{CLASS_SYUGEN,2,0,TV_CLOTHES, SV_CLOTH_SYUGEN,1},
	{CLASS_SYUGEN,2,0,TV_STICK, SV_WEAPON_SYAKUJYOU,1},
	{CLASS_MAGIC_KNIGHT,2,0,TV_ARMOR, SV_ARMOR_LEATHER,1},
	{CLASS_MAGIC_KNIGHT,2,0,TV_SWORD, SV_WEAPON_SABRE,1},
	{CLASS_LIBRARIAN,2,0,TV_SWORD,SV_WEAPON_RAPIER,1},
	{CLASS_LIBRARIAN,2,0,TV_CLOTHES,SV_CLOTH_SUIT,1},
	{CLASS_ENGINEER,2,0,TV_CLOTHES, SV_CLOTH_WORKER,1},
	{CLASS_ENGINEER,2,0,TV_HAMMER,SV_WEAPON_SPANNER,1},
	{CLASS_ENGINEER,2,0,TV_MACHINE,SV_MACHINE_WATERGUN,1},
	{CLASS_ENGINEER,2,0,TV_MACHINE,SV_MACHINE_LIGHTBOMB,1},
	{CLASS_SAMURAI,2,0,TV_CLOTHES,SV_CLOTH_EASTERN,1},
	{CLASS_SAMURAI,2,0,TV_KATANA,SV_WEAPON_KATANA,1},
	{CLASS_MINDCRAFTER,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_PALADIN,2,0,TV_ARMOR, SV_ARMOR_CHAIN,1},
	{CLASS_PALADIN,2,0,TV_SWORD, SV_WEAPON_SHORT_SWORD,1},
	{CLASS_SH_DEALER,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_SH_DEALER,2,0,TV_HAMMER,SV_WEAPON_FLAIL,1},
	{CLASS_JEWELER,2,0,TV_KNIFE,SV_WEAPON_DAGGER,1},
	{CLASS_JEWELER,2,0,TV_CLOTHES,SV_CLOTH_ROBE,1},

	{CLASS_RUMIA,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_YOUMU,0,ART_ROUKANKEN,0,0,0},
	{CLASS_YOUMU,0,ART_HAKUROUKEN,0,0,0},
	{CLASS_YOUMU,2,0,TV_CLOTHES,SV_CLOTHES,1},

	{CLASS_UDONGE,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_UDONGE,2,0,TV_GUN,SV_FIRE_GUN_LUNATIC,1},
	{ CLASS_UDONGE,2,0,TV_HAMMER,SV_WEAPON_KINE,1 },
	{CLASS_UDONGE,2,0,TV_POTION,SV_POTION_CURE_SERIOUS,10},

	{CLASS_TEWI,2,0,TV_HAMMER,SV_WEAPON_KINE,1},
	{CLASS_TEWI,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_IKU,0,ART_HEAVENLY_MAIDEN,0,0,0},
	{CLASS_IKU,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_KOGASA,2,0,TV_CLOTHES,SV_CLOTHES,1},

	{CLASS_KOMACHI,2,0,TV_POLEARM,SV_WEAPON_WAR_SCYTHE,1},
	{CLASS_KOMACHI,2,0,TV_CLOTHES,SV_CLOTH_EASTERN,1},

	{CLASS_KASEN,2,0,TV_CLOTHES,SV_CLOTHES,1},

	{CLASS_SUIKA,0,ART_IBUKI,0,0,0},
	{CLASS_SUIKA,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_MARISA,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_MARISA,2,0,TV_HEAD,SV_HEAD_WITCH,1},
	{CLASS_MARISA,2,0,TV_POTION,SV_POTION_SPEED,3},

	{CLASS_WAKASAGI,2,0,TV_CLOTHES,SV_CLOTH_EASTERN,1},
	{CLASS_WAKASAGI,2,0,TV_MATERIAL,SV_MATERIAL_AQUAMARINE,1},

	{CLASS_KOISHI,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_KOISHI,2,0,TV_HEAD,SV_HEAD_HAT,1},
	{CLASS_SEIGA,2,0,TV_CLOTHES, SV_CLOTH_ROBE,1},

	{CLASS_MOMIZI,2,0,TV_CLOTHES, SV_CLOTH_SYUGEN,1},
	{CLASS_MOMIZI,2,0,TV_SWORD,SV_WEAPON_SCIMITAR,1},
	{CLASS_MOMIZI,2,0,TV_SHIELD,SV_SMALL_LEATHER_SHIELD,1},
	{CLASS_CIRNO,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_ORIN,2,0,TV_CLOTHES, SV_CLOTH_DRESS,1},

	{CLASS_SHINMYOUMARU,2,0,TV_CLOTHES, SV_CLOTH_EASTERN,1},
	{CLASS_SHINMYOUMARU,2,ART_SHINMYOUMARU,0,0,0},
	{CLASS_NAZRIN,0,ART_NAZRIN,0,0,0},
	{CLASS_NAZRIN,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_NAZRIN,2,0,TV_STICK, SV_WEAPON_IRONSTICK,1},

	{CLASS_LETTY,2,0,TV_CLOTHES, SV_CLOTHES,1}, 

	{CLASS_YOSHIKA,2,0,TV_CLOTHES, SV_CLOTHES,1}, 
	{CLASS_YOSHIKA,2,0,TV_FOOD, SV_FOOD_SENTAN,5}, 

	{CLASS_PATCHOULI,2,0,TV_CLOTHES, SV_CLOTH_ROBE,1}, 
	{CLASS_AYA,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_BANKI,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_BANKI,2,0,TV_SPEAR, SV_WEAPON_AWL_PIKE,1},
	{CLASS_MYSTIA,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_FLAN,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_FLAN,2,0,TV_STICK, SV_WEAPON_IRONSTICK,1},

	{CLASS_SHOU,0,ART_HOUTOU,0,0,0},
	{CLASS_SHOU,2,0,TV_CLOTHES, SV_CLOTH_LEATHER	,1},
	{CLASS_SHOU,2,0,TV_SPEAR, SV_WEAPON_SPEAR,1},

	{CLASS_MEDICINE,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_MEDICINE,2,0,TV_POTION, SV_POTION_POISON,16},

	{CLASS_YUYUKO,2,0,TV_CLOTHES, SV_CLOTH_EASTERN,1},
	{CLASS_YUYUKO,2,0,TV_FOOD, SV_FOOD_RATION,20},

	{CLASS_SATORI,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_KYOUKO,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_TOZIKO,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_KISUME,2,0,TV_ARMOR, SV_ARMOR_TUB,1},
	{CLASS_LILY_WHITE,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_HATATE,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_HATATE,2,0,TV_CROSSBOW,SV_FIRE_LIGHT_CROSSBOW,1},
	{CLASS_HATATE,2,0,TV_BOLT,SV_AMMO_LIGHT,20},

	{CLASS_MIKO,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_KOKORO,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_WRIGGLE,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_NINJA,2,0,TV_KNIFE,SV_WEAPON_TANTO,1},
	{CLASS_NINJA,2,0,TV_CLOTHES, SV_CLOTH_KUROSHOUZOKU,1},
	{CLASS_NINJA,2,0,TV_SCROLL,SV_SCROLL_DARKNESS,7},
	{CLASS_CHEN,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_YUUKA,0,ART_YUUKA,0,0,0},
	{CLASS_YUUKA,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_MURASA,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_KEINE,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_KEINE,2,0,TV_SWORD,SV_WEAPON_LONG_SWORD,1},

	{CLASS_REIMU,2,0,TV_STICK,SV_WEAPON_OONUSA,1},
	{CLASS_REIMU,2,0,TV_CLOTHES,SV_CLOTH_MIKO,1},

	{CLASS_YUGI,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_YUGI,0,ART_HOSHIGUMA,0,0,0},

	{CLASS_KAGEROU,2,0,TV_CLOTHES, SV_CLOTH_ROBE,1},
	{CLASS_SHIZUHA,2,0,TV_CLOTHES, SV_CLOTH_DRESS,1},

	{CLASS_SANAE,2,0,TV_STICK,SV_WEAPON_QUARTERSTAFF,1},
	{CLASS_SANAE,2,0,TV_CLOTHES,SV_CLOTH_MIKO,1},

	{CLASS_MINORIKO,2,0,TV_STICK,SV_WEAPON_QUARTERSTAFF,1},
	{CLASS_MINORIKO,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_REMY,2,0,TV_CLOTHES, SV_CLOTH_DRESS,1},

	{CLASS_NITORI,2,0,TV_CLOTHES, SV_CLOTH_WORKER,1},
	{CLASS_NITORI,2,0,TV_HAMMER,SV_WEAPON_SPANNER,1},
	{CLASS_NITORI,2,0,TV_MACHINE,SV_MACHINE_WATERGUN,1},

	{CLASS_BYAKUREN,2,0,TV_CLOTHES, SV_CLOTH_DRESS,1},
	{CLASS_SUWAKO,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_NUE,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_NUE,2,0,TV_SPEAR, SV_WEAPON_TRIFURCATE_SPEAR,1},

	{CLASS_SEIJA,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_SEIJA,2,0,TV_WAND, SV_WAND_MAGIC_MISSILE,1},
	{CLASS_SEIJA,2,0,TV_WAND, SV_WAND_STINKING_CLOUD,1},
	{CLASS_SEIJA,2,0,TV_WAND, SV_WAND_SLEEP_MONSTER,1},

	{CLASS_UTSUHO,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_YAMAME,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_MARTIAL_ARTIST,2,0,TV_CLOTHES, SV_CLOTH_DOUGI,1},

	{CLASS_MAGIC_EATER,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_MAGIC_EATER,2,0,TV_WAND, SV_WAND_MAGIC_MISSILE,1},
	{CLASS_MAGIC_EATER,2,0,TV_WAND, SV_WAND_STINKING_CLOUD,1},

	{CLASS_RAN,2,0,TV_CLOTHES, SV_CLOTH_DOUSHI,1},
	{CLASS_RAN,2,0,TV_KNIFE,SV_WEAPON_TANTO,1},
	{CLASS_RAN,2,0,TV_SCROLL, SV_SCROLL_WORD_OF_RECALL,9},

	{CLASS_EIKI,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_EIKI,0,ART_EIKI,0,0,0},

	{CLASS_TENSHI,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_TENSHI,0,ART_HISOU,0,0,0},

	{CLASS_MEIRIN,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_PARSEE,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_PARSEE,2,0,TV_KATANA, SV_WEAPON_SHORT_KATANA,1},

	{CLASS_SHINMYOU_2,2,0,TV_CLOTHES, SV_CLOTH_EASTERN,1},
	{CLASS_SHINMYOU_2,2,ART_SHINMYOUMARU,0,0,0},

	{CLASS_SUMIREKO,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_SUMIREKO,2,ART_3DPRINTER_GUN,0, 0,0},

	{CLASS_ICHIRIN,2,0,TV_CLOTHES,SV_CLOTH_ROBE,1},
	{CLASS_MOKOU,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_KANAKO,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_KANAKO,2,0,TV_STICK,SV_WEAPON_SIXFEET,1},

	{CLASS_FUTO,2,0,TV_CLOTHES, SV_CLOTH_DOUSHI,1},
	{CLASS_FUTO,2,0,TV_BOW,SV_FIRE_SHORT_BOW,1},
	{CLASS_FUTO,2,0,TV_ARROW,SV_AMMO_LIGHT,20},

	{CLASS_SUNNY,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_LUNAR,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_STAR,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_ALICE,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_LUNASA,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_MERLIN,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_LYRICA,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_CLOWNPIECE,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_CLOWNPIECE,2,ART_CLOWNPIECE,0,0,0},

	{CLASS_DOREMY,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_SAKUYA,0,0,TV_CLOTHES,SV_CLOTH_MAID,1},
	{CLASS_BENBEN,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_YATSUHASHI,2,0,TV_CLOTHES,SV_CLOTHES,1},
	//{CLASS_HINA,2,0,TV_CLOTHES, SV_CLOTH_DRESS,1},ꏈōŏ􂢂ɂ
	{CLASS_3_FAIRIES,2,0,TV_CLOTHES, SV_CLOTHES,1},//3񑕔s߂3
	{CLASS_3_FAIRIES,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_3_FAIRIES,2,0,TV_CLOTHES, SV_CLOTHES,1},
	{CLASS_RAIKO,2,0,TV_CLOTHES,SV_CLOTH_SUIT,1},

	{CLASS_CHEMIST,2,0,TV_KNIFE,SV_WEAPON_YAMAGATANA,1},
	{CLASS_CHEMIST,2,0,TV_CLOTHES,SV_CLOTH_SUIT,1},
	{CLASS_CHEMIST,2,0,TV_BOOK_MEDICINE,0,1},
	{CLASS_CHEMIST,2,0,TV_MUSHROOM,SV_MUSHROOM_MON_RED,5},
	{CLASS_CHEMIST,2,0,TV_MUSHROOM,SV_MUSHROOM_MON_WHITE,5},
	{CLASS_CHEMIST,2,0,TV_MUSHROOM,SV_MUSHROOM_MON_GREEN,5},
	{CLASS_CHEMIST,2,0,TV_MUSHROOM,SV_MUSHROOM_MON_BLUE,5},
	{CLASS_CHEMIST,2,0,TV_MUSHROOM,SV_MUSHROOM_MON_BLACK,5},
	{CLASS_CHEMIST,2,0,TV_MUSHROOM,SV_MUSHROOM_POISON,5},
	{CLASS_MAMIZOU,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_YUKARI,0,ART_YUKARI,0,0,0},
	{CLASS_YUKARI,2,0,TV_CLOTHES,SV_CLOTH_DRESS,1},

	{CLASS_RINGO,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_RINGO,2,0,TV_GUN,SV_FIRE_GUN_LUNATIC,1},
	{CLASS_RINGO,2,0,TV_SWEETS,SV_SWEETS_DANGO,30},

	{CLASS_SEIRAN,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_SEIRAN,2,0,TV_GUN,SV_FIRE_GUN_LUNATIC,1},
	{CLASS_SEIRAN,2,0,TV_HAMMER,SV_WEAPON_KINE,1},

	{CLASS_EIRIN,2,0,TV_BOW,SV_FIRE_SHORT_BOW,1},
	{CLASS_EIRIN,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_EIRIN,2,0,TV_ARROW,SV_AMMO_LIGHT,30},

	{CLASS_KAGUYA,2,0,TV_CLOTHES,SV_CLOTH_EASTERN,1},
	//P@ꏈON/OFF
	{CLASS_KAGUYA,0,ART_KAGUYA_DRAGON,0,0,0},
	{CLASS_KAGUYA,0,ART_KAGUYA_HOURAI,0,0,0},
	{CLASS_KAGUYA,0,ART_KAGUYA_HOTOKE,0,0,0},
	{CLASS_KAGUYA,0,ART_KAGUYA_HINEZUMI,0,0,0},
	{CLASS_KAGUYA,0,ART_KAGUYA_TSUBAME,0,0,0},

	{CLASS_SAGUME,2,0,TV_CLOTHES, SV_CLOTH_DRESS,1},

	{CLASS_REISEN2,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_REISEN2,2,0,TV_GUN,SV_FIRE_GUN_INFANTRY,1},

	{CLASS_TOYOHIME,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_TOYOHIME,2,ART_TOYOHIME,0,0,0},
	{CLASS_TOYOHIME,2,0,TV_SWEETS,SV_SWEETS_PEACH,8},

	{CLASS_YORIHIME,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_YORIHIME,2,ART_YORIHIME,0,0,0},

	{CLASS_JUNKO,2,0,TV_CLOTHES, SV_CLOTHES,1},

	{CLASS_HECATIA,2,ART_HECATIA,0,0,0},

	{CLASS_SOLDIER,2,0,TV_CLOTHES,SV_CLOTH_PADDED,1},
	{CLASS_SOLDIER,2,0,TV_KNIFE,SV_WEAPON_KNIFE,1},
	{CLASS_SOLDIER,2,0,TV_GUN,SV_FIRE_GUN_HANDGUN,1},

	{CLASS_NEMUNO,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_NEMUNO,2,0,TV_AXE,SV_WEAPON_NATA,1},

	{CLASS_AUNN,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_NARUMI,2,0,TV_CLOTHES,SV_CLOTHES,1},

	//v1.1.37 ͐FXĂ
	{CLASS_KOSUZU,2,0,TV_CLOTHES,SV_CLOTHES,1},
	{CLASS_KOSUZU,2,0,TV_SCROLL,SV_SCROLL_RUNE_OF_PROTECTION,5},
	{CLASS_KOSUZU,2,0,TV_SCROLL,SV_SCROLL_DISPEL_UNDEAD,5},
	{CLASS_KOSUZU,2,0,TV_SCROLL,SV_SCROLL_STAR_DESTRUCTION,5},
	{CLASS_KOSUZU,2,0,TV_SCROLL,SV_SCROLL_FIRE,3},
	{CLASS_KOSUZU,2,0,TV_SCROLL,SV_SCROLL_ICE,3},
	{CLASS_KOSUZU,2,0,TV_SCROLL,SV_SCROLL_CHAOS,3},
	{CLASS_KOSUZU,2,0,TV_BOOK_OCCULT,3,1},
	{CLASS_KOSUZU,2,0,TV_SOUVENIR,SV_SOUVENIR_OUIJA_BOARD,1},
	{CLASS_KOSUZU,2,ART_HYAKKI,0,0,1},

	{ CLASS_MAI,2,0,TV_CLOTHES,SV_CLOTH_DRESS,1 },
	{ CLASS_MAI,2,0,TV_SPEAR,SV_WEAPON_SPEAR,1 },

	{ CLASS_SATONO,2,0,TV_CLOTHES,SV_CLOTH_DRESS,1 },

	{ CLASS_VFS_CLOWNPIECE,2,0,TV_CLOTHES, SV_CLOTHES,1 },
	{ CLASS_VFS_CLOWNPIECE,2,ART_CLOWNPIECE,0,0,0 },

	{ CLASS_JYOON,2,0,TV_CLOTHES, SV_CLOTH_DRESS,1 },
	{ CLASS_SHION,2,0,TV_CLOTHES, SV_CLOTHES,1 },

	{-1,0,0,0,0,0} //I[dummy
};



/*
 * Init players with some belongings
 *
 * Having an item makes the player "aware" of its purpose.
 */
/*:::EƁA푰Aiɂ鏉ACe肷*/
///race class realm item ACe
void player_outfit(void)
{
	int i, tv, sv;

	object_type	forge;
	object_type	*q_ptr;

	/* Get local object */
	q_ptr = &forge;

	/*:::Pꏈ@pσp[^A[eBt@Ng*/
	if(p_ptr->pclass == CLASS_KOGASA)
	{
		object_prep(q_ptr, lookup_kind(TV_STICK, SV_WEAPON_KOGASA));
		apply_kogasa_magic(q_ptr,1,TRUE);
		add_outfit(q_ptr);
	}
	/*:::AXꏈ@Cl`ɃCsA*/
	else if(p_ptr->pclass == CLASS_ALICE)
	{
		object_prep(q_ptr, lookup_kind(TV_SWORD, SV_WEAPON_RAPIER));
		apply_magic(q_ptr,1,AM_FORCE_NORMAL);
		object_aware(q_ptr);
		object_known(q_ptr);
		q_ptr->ident |= (IDENT_MENTAL);
		object_copy(&inven_add[0], q_ptr); 

	}
	/*:::ꏈ*/
	else if(p_ptr->pclass == CLASS_SAKUYA)
	{
		object_prep(q_ptr, lookup_kind(TV_KNIFE, SV_WEAPON_KNIFE));
		q_ptr->name2 = EGO_WEAPON_DEMONSLAY;
		q_ptr->pval = 1;
		q_ptr->to_d = 10;
		q_ptr->to_h = 10;

		object_aware(q_ptr);
		object_known(q_ptr);
		q_ptr->ident |= (IDENT_MENTAL);
		add_outfit(q_ptr);

	}
	/*:::ꏈ*/
	else if(p_ptr->pclass == CLASS_HINA)
	{
		object_prep(q_ptr, lookup_kind(TV_CLOTHES, SV_CLOTH_DRESS));
		apply_magic(q_ptr,1,AM_FORCE_NORMAL);
		q_ptr->curse_flags = TRC_CURSED;
		q_ptr->to_a = 3;
		object_aware(q_ptr);
		object_known(q_ptr);
		q_ptr->ident |= (IDENT_MENTAL);
		add_outfit(q_ptr);

	}
	
	//푰Œ̏ACe𐶐
	for(i=0;birth_outfit_race[i].type != -1 ;i++)
	{
		//푰ƐʂȂs̓pX
		if(birth_outfit_race[i].type != p_ptr->prace) continue;
		if(birth_outfit_race[i].psex == SEX_MALE && p_ptr->psex == SEX_FEMALE || birth_outfit_race[i].psex == SEX_FEMALE && p_ptr->psex == SEX_MALE) continue;
		//-Hack-P͕tr_HׂȂ̂ŎĂȂ
		if(birth_outfit_race[i].tval==TV_STAFF && birth_outfit_race[i].sval==SV_STAFF_NOTHING && p_ptr->pclass == CLASS_KOGASA) continue;
		//-Hack-fBXHׂȂ̂ŎĂȂ
		if(p_ptr->pclass == CLASS_MEDICINE) break;
		//Ol͐HƂȂ
		if(p_ptr->pclass == CLASS_OUTSIDER) break;
		//h~[HƂȂ
		if(p_ptr->pclass == CLASS_DOREMY) break;
		//푰ɃA[eBt@Ng͖Ή
		if(birth_outfit_race[i].artifact_idx)
		{
			msg_format("ERROR:birth_outfit_race[%d]ɃA[eBt@Ngw肳Ă()",i);
			continue;
		}
		//Ô
		if(birth_outfit_race[i].num < 1 || birth_outfit_race[i].num > 99 )
		{
			msg_format("ERROR:birth_outfit_race[%d]̃ACe",i);
			continue;
		}
		object_prep(q_ptr,lookup_kind(birth_outfit_race[i].tval,birth_outfit_race[i].sval));
			//apply_magićƏ㎿LZ݂̕i𐶐Biapply_magicȂΏɕɂȂ邪Ƃ̏̂
		apply_magic(q_ptr, 1, AM_FORCE_NORMAL);
		q_ptr->number = birth_outfit_race[i].num;
		add_outfit(q_ptr);
	}

	//EƁij[NNX܂ށjŒ̏ACe
	for(i=0;birth_outfit_class[i].type != -1 ;i++)
	{
		//EƂƐʂȂs̓pX
		if(birth_outfit_class[i].type != p_ptr->pclass) continue;
		if(birth_outfit_class[i].psex == SEX_MALE && p_ptr->psex == SEX_FEMALE || birth_outfit_class[i].psex == SEX_FEMALE && p_ptr->psex == SEX_MALE) continue;

		//A[eBt@NgĊJnNX̏ 啔create_named_art()Rs[
		if(birth_outfit_class[i].artifact_idx)
		{
			int tmp_k_idx;
			artifact_type *a_ptr = &a_info[birth_outfit_class[i].artifact_idx];

			/*:::oȂIvVON̂Ƃɂ֌WȂ*/
			if(a_ptr->cur_num) continue;

			if (!a_ptr->name)
			{
				msg_format("ERROR:birth_outfit_class[%d]̃A[eBt@NgID",i);
				continue;
			}
			tmp_k_idx = lookup_kind(a_ptr->tval, a_ptr->sval);
			if (!tmp_k_idx)
			{
				msg_format("ERROR:a_info[%d]tvalsval",i);
				continue;
			}

			object_prep(q_ptr, tmp_k_idx);
			q_ptr->name1 = birth_outfit_class[i].artifact_idx;

			// Hack - Pꏈ@܂PNGXgœ͂ĂȂACeO
			if(p_ptr->pclass == CLASS_KAGUYA)
			{
				if(q_ptr->name1 == ART_KAGUYA_TSUBAME && kaguya_quest_level < 1) continue;
				if(q_ptr->name1 == ART_KAGUYA_HINEZUMI && kaguya_quest_level < 2) continue;
				if(q_ptr->name1 == ART_KAGUYA_HOTOKE && kaguya_quest_level < 3) continue;
				if(q_ptr->name1 == ART_KAGUYA_DRAGON && kaguya_quest_level < 4) continue;
				if(q_ptr->name1 == ART_KAGUYA_HOURAI && kaguya_quest_level < 5) continue;
			}

			/* Extract the fields */
			q_ptr->pval = a_ptr->pval;
			q_ptr->ac = a_ptr->ac;
			q_ptr->dd = a_ptr->dd;
			q_ptr->ds = a_ptr->ds;
			q_ptr->to_a = a_ptr->to_a;
			q_ptr->to_h = a_ptr->to_h;
			q_ptr->to_d = a_ptr->to_d;
			q_ptr->weight = a_ptr->weight;

			///mod150908 NEs[X̏̓ꏈ
			if(q_ptr->name1 == ART_CLOWNPIECE) q_ptr->xtra4 = -1;

			/* Hack -- extract the "cursed" flag */
			if (a_ptr->gen_flags & TRG_CURSED) q_ptr->curse_flags |= (TRC_CURSED);
			if (a_ptr->gen_flags & TRG_HEAVY_CURSE) q_ptr->curse_flags |= (TRC_HEAVY_CURSE);
			if (a_ptr->gen_flags & TRG_PERMA_CURSE) q_ptr->curse_flags |= (TRC_PERMA_CURSE);
			if (a_ptr->gen_flags & (TRG_RANDOM_CURSE0)) q_ptr->curse_flags |= get_curse(0, q_ptr);
			if (a_ptr->gen_flags & (TRG_RANDOM_CURSE1)) q_ptr->curse_flags |= get_curse(1, q_ptr);
			if (a_ptr->gen_flags & (TRG_RANDOM_CURSE2)) q_ptr->curse_flags |= get_curse(2, q_ptr);
			random_artifact_resistance(q_ptr, a_ptr);

			//̓sv̂vȂ̂ɂ͌ĂȂƂ肠ǉ
			q_ptr->number = 1;
			a_info[birth_outfit_class[i].artifact_idx].cur_num+=1;

			q_ptr->ident |= (IDENT_MENTAL);
			add_outfit(q_ptr);

		}	
		//Ô
		else if(birth_outfit_class[i].num < 1 || birth_outfit_class[i].num > 99 )
		{
			msg_format("ERROR:birth_outfit_class[%d]̃ACe",i);
			continue;
		}		
		else
		{
			object_prep(q_ptr,lookup_kind(birth_outfit_class[i].tval,birth_outfit_class[i].sval));
			//apply_magićƏ㎿LZ݂̕i𐶐Biapply_magicȂΏɕɂȂ邪Ƃ̏̂
			apply_magic(q_ptr, 1, AM_FORCE_NORMAL);
			q_ptr->number = birth_outfit_class[i].num;
			//pval̂镐h͏1
			if(object_is_weapon_armour_ammo(q_ptr) && q_ptr->pval) q_ptr->pval = 1;
			add_outfit(q_ptr);
		}
	}
	//ǂ߂閂@̈ڂ
	if(p_ptr->realm1)
	{
		object_prep(q_ptr,lookup_kind(p_ptr->realm1,0));
		q_ptr->number = 1;
		if(EXTRA_MODE) q_ptr->number += randint1(2);
		add_outfit(q_ptr);
	}
	if(p_ptr->realm2)
	{
		object_prep(q_ptr,lookup_kind(p_ptr->realm2,0));
		q_ptr->number = 1;
		if(EXTRA_MODE) q_ptr->number += randint1(2);
		add_outfit(q_ptr);
	}
	//v1.1.44 ǂ񂰓ꐫi
	if (is_special_seikaku(SEIKAKU_SPECIAL_UDONGE))
	{
		object_prep(q_ptr, lookup_kind(TV_BOOK_MEDICINE, 0));
		q_ptr->number = 1;
		if (EXTRA_MODE) q_ptr->number += randint1(2);
		add_outfit(q_ptr);
	}
	//v1.1.52 俎qꐫi
	else if (is_special_seikaku(SEIKAKU_SPECIAL_SUMIREKO))
	{
		object_prep(q_ptr, lookup_kind(TV_SOUVENIR, SV_SOUVENIR_SMARTPHONE));
		q_ptr->number = 1;
		add_outfit(q_ptr);
	}


	if(REALM_SPELLMASTER)
	{
		for(i=1;i<=TV_BOOK_END;i++)
		{
			bool flag_ok = FALSE;
			//v1.1.32 p`[ꐫiusvǉ
			if (is_special_seikaku(SEIKAKU_SPECIAL_PATCHOULI) && i <= MAX_MAGIC)
				flag_ok = TRUE;
			if (cp_ptr->realm_aptitude[i] && rp_ptr->realm_aptitude[i])
				flag_ok = TRUE;

			if(flag_ok)
			{
				object_prep(q_ptr,lookup_kind(i,0));
				q_ptr->number = 1;
				if(EXTRA_MODE) q_ptr->number += randint1(2);
				add_outfit(q_ptr);
			}
		}
	}


	//܂
	if (p_ptr->pclass != CLASS_NINJA && p_ptr->pclass != CLASS_OUTSIDER  && p_ptr->pclass != CLASS_NUE
		&& p_ptr->prace != RACE_VAMPIRE && p_ptr->pclass != CLASS_WRIGGLE && p_ptr->pclass != CLASS_UTSUHO)
	{
		object_prep(q_ptr, lookup_kind(TV_LITE, SV_LITE_TORCH));
		q_ptr->number = (byte)rand_range(3, 7);
		if(EXTRA_MODE) q_ptr->number += 3;
		q_ptr->xtra4 = rand_range(3, 7) * 500;
		add_outfit(q_ptr);
	}

	//Ex[hł̓cnVĂB܂ɔ̂Ȃɏo邽߁B
	if(EXTRA_MODE)
	{
		object_prep(q_ptr, lookup_kind(TV_AXE, SV_WEAPON_PICK));
		apply_magic(q_ptr,0,AM_FORCE_NORMAL);

		object_aware(q_ptr);
		object_known(q_ptr);
		q_ptr->ident |= (IDENT_MENTAL);
		inven_carry(q_ptr);

	}
	//v1.1.37 ̓_ȗd{Ă
	if(p_ptr->pclass == CLASS_KOSUZU)
	{
		int j;
		for(j=0;j<3;j++)
		{
			monster_race *r_ptr;

			object_prep(q_ptr, lookup_kind(TV_CAPTURE, SV_CAPTURE_NONE));
			while (1)
			{
				i = randint1(max_r_idx - 1);
				r_ptr = &r_info[i];
				//x1ȏ20ȉAlԕsAj[Ns
				if(!r_ptr->level || r_ptr->level > 20) continue;
				if(r_ptr->flags3 & RF3_HUMAN) continue;

				if (!item_monster_okay(i)) continue;
				if (!r_ptr->rarity) continue;

				break;
			}
			q_ptr->pval = i;
			q_ptr->xtra3 = get_mspeed(r_ptr);
			if (r_ptr->flags1 & RF1_FORCE_MAXHP) q_ptr->xtra4 = maxroll(r_ptr->hdice, r_ptr->hside);
			else	q_ptr->xtra4 = damroll(r_ptr->hdice, r_ptr->hside);
			q_ptr->xtra5 = q_ptr->xtra4;
			object_aware(q_ptr);
			object_known(q_ptr);
			q_ptr->ident |= (IDENT_MENTAL);
			inven_carry(q_ptr);
		}
	}

#if 0
	/* Give the player some food */
	switch (p_ptr->prace)
	{
	case RACE_VAMPIRE:
		/* Nothing! */
		/* Vampires can drain blood of creatures */
		break;

	case RACE_DEMON:
		/* Demon can drain vitality from humanoid corpse */

		/* Prepare allocation table */
		get_mon_num_prep(monster_hook_human, NULL);

		///del131221 death
		/*
		for (i = rand_range(3,4); i > 0; i--)
		{
			object_prep(q_ptr, lookup_kind(TV_CORPSE, SV_CORPSE));
			q_ptr->pval = get_mon_num(2);
			q_ptr->number = 1;
			add_outfit(q_ptr);
		}
		*/
		break;

#if 0
	case RACE_SKELETON:
		/* Some Skeletons */
		object_prep(q_ptr, lookup_kind(TV_SKELETON, SV_ANY));
		q_ptr->number = (byte)rand_range(7, 12);
		add_outfit(q_ptr);
		break;
#endif
	case RACE_SKELETON:
	case RACE_GOLEM:
	case RACE_ZOMBIE:
	case RACE_SPECTRE:
		/* Staff (of Nothing) */
		object_prep(q_ptr, lookup_kind(TV_STAFF, SV_STAFF_NOTHING));
		q_ptr->number = 1;

		add_outfit(q_ptr);
		break;

	case RACE_ENT:
		/* Potions of Water */
		object_prep(q_ptr, lookup_kind(TV_POTION, SV_POTION_WATER));
		q_ptr->number = (byte)rand_range(15, 23);
		add_outfit(q_ptr);

		break;

	case RACE_ANDROID:
		/* Flasks of oil */
		object_prep(q_ptr, lookup_kind(TV_FLASK, SV_ANY));

		/* Fuel with oil (move pval to xtra4) */
		apply_magic(q_ptr, 1, AM_NO_FIXED_ART);

		q_ptr->number = (byte)rand_range(7, 12);
		add_outfit(q_ptr);

		break;

	default:
		/* Food rations */
		object_prep(q_ptr, lookup_kind(TV_FOOD, SV_FOOD_RATION));
		q_ptr->number = (byte)rand_range(3, 7);

		add_outfit(q_ptr);
	}

	/* Get local object */
	q_ptr = &forge;

	if ((p_ptr->prace == RACE_VAMPIRE) && (p_ptr->pclass != CLASS_NINJA))
	{
		/* Hack -- Give the player scrolls of DARKNESS! */
		object_prep(q_ptr, lookup_kind(TV_SCROLL, SV_SCROLL_DARKNESS));

		q_ptr->number = (byte)rand_range(2, 5);

		add_outfit(q_ptr);
	}
	else if (p_ptr->pclass != CLASS_NINJA)
	{
		/* Hack -- Give the player some torches */
		object_prep(q_ptr, lookup_kind(TV_LITE, SV_LITE_TORCH));
		q_ptr->number = (byte)rand_range(3, 7);
		q_ptr->xtra4 = rand_range(3, 7) * 500;

		add_outfit(q_ptr);
	}

	/* Get local object */
	q_ptr = &forge;

	if ((p_ptr->pclass == CLASS_RANGER) || (p_ptr->pclass == CLASS_CAVALRY))
	{
		/* Hack -- Give the player some arrows */
		object_prep(q_ptr, lookup_kind(TV_ARROW, SV_AMMO_NORMAL));
		q_ptr->number = (byte)rand_range(15, 20);

		add_outfit(q_ptr);
	}
	if (p_ptr->pclass == CLASS_RANGER)
	{
		/* Hack -- Give the player some arrows */
		object_prep(q_ptr, lookup_kind(TV_BOW, SV_SHORT_BOW));

		add_outfit(q_ptr);
	}
	else if (p_ptr->pclass == CLASS_ARCHER)
	{
		/* Hack -- Give the player some arrows */
		object_prep(q_ptr, lookup_kind(TV_ARROW, SV_AMMO_NORMAL));
		q_ptr->number = (byte)rand_range(15, 20);

		add_outfit(q_ptr);
	}
	else if (p_ptr->pclass == CLASS_HIGH_MAGE)
	{
		/* Hack -- Give the player some arrows */
		object_prep(q_ptr, lookup_kind(TV_WAND, SV_WAND_MAGIC_MISSILE));
		q_ptr->number = 1;
		q_ptr->pval = (byte)rand_range(25, 30);

		add_outfit(q_ptr);
	}
	else if (p_ptr->pclass == CLASS_SORCERER)
	{
		for (i = TV_LIFE_BOOK; i <= TV_LIFE_BOOK+MAX_MAGIC-1; i++)
		{
			/* Hack -- Give the player some arrows */
			object_prep(q_ptr, lookup_kind(i, 0));
			q_ptr->number = 1;

			add_outfit(q_ptr);
		}
	}
	else if (p_ptr->pclass == CLASS_TOURIST)
	{
		if (p_ptr->pseikaku != SEIKAKU_SEXY)
		{
			/* Hack -- Give the player some arrows */
			object_prep(q_ptr, lookup_kind(TV_SHOT, SV_AMMO_LIGHT));
			q_ptr->number = (byte)rand_range(15, 20);

			add_outfit(q_ptr);
		}

		object_prep(q_ptr, lookup_kind(TV_FOOD, SV_FOOD_BISCUIT));
		q_ptr->number = (byte)rand_range(2, 4);

		add_outfit(q_ptr);

		object_prep(q_ptr, lookup_kind(TV_FOOD, SV_FOOD_WAYBREAD));
		q_ptr->number = (byte)rand_range(2, 4);

		add_outfit(q_ptr);

		object_prep(q_ptr, lookup_kind(TV_FOOD, SV_FOOD_JERKY));
		q_ptr->number = (byte)rand_range(1, 3);

		add_outfit(q_ptr);

		object_prep(q_ptr, lookup_kind(TV_FOOD, SV_FOOD_PINT_OF_ALE));
		q_ptr->number = (byte)rand_range(2, 4);

		add_outfit(q_ptr);

		object_prep(q_ptr, lookup_kind(TV_FOOD, SV_FOOD_PINT_OF_WINE));
		q_ptr->number = (byte)rand_range(2, 4);

		add_outfit(q_ptr);
	}
	else if (p_ptr->pclass == CLASS_NINJA)
	{
		/* Hack -- Give the player some arrows */
		object_prep(q_ptr, lookup_kind(TV_SPIKE, 0));
		q_ptr->number = (byte)rand_range(15, 20);

		add_outfit(q_ptr);
	}
	else if (p_ptr->pclass == CLASS_SNIPER)
	{
		/* Hack -- Give the player some bolts */
		object_prep(q_ptr, lookup_kind(TV_BOLT, SV_AMMO_NORMAL));
		q_ptr->number = (byte)rand_range(15, 20);

		add_outfit(q_ptr);
	}
	///del131223
	/*
	if(p_ptr->pseikaku == SEIKAKU_SEXY)
	{
		player_init[p_ptr->pclass][2][0] = TV_HAFTED;
		player_init[p_ptr->pclass][2][1] = SV_WHIP;
	}
	*/
	/* Hack -- Give the player three useful objects */
	for (i = 0; i < 3; i++)
	{
		/* Look up standard equipment */
		tv = player_init[p_ptr->pclass][i][0];
		sv = player_init[p_ptr->pclass][i][1];

		if ((p_ptr->prace == RACE_ANDROID) && ((tv == TV_SOFT_ARMOR) || (tv == TV_HARD_ARMOR))) continue;
		/* Hack to initialize spellbooks */
		if (tv == TV_SORCERY_BOOK) tv = TV_LIFE_BOOK + p_ptr->realm1 - 1;
		else if (tv == TV_DEATH_BOOK) tv = TV_LIFE_BOOK + p_ptr->realm2 - 1;

		else if (tv == TV_RING && sv == SV_RING_RES_FEAR &&
		    p_ptr->prace == RACE_BARBARIAN)
			/* Barbarians do not need a ring of resist fear */
			sv = SV_RING_SUSTAIN_STR;

		else if (tv == TV_RING && sv == SV_RING_SUSTAIN_INT &&
		    p_ptr->prace == RACE_MIND_FLAYER)
		  {
			tv = TV_POTION;
			sv = SV_POTION_RESTORE_MANA;
		  }

		/* Get local object */
		q_ptr = &forge;

		/* Hack -- Give the player an object */
		object_prep(q_ptr, lookup_kind(tv, sv));

		/* Assassins begin the game with a poisoned dagger */
		///item ACeGSĂ
		if ((tv == TV_SWORD || tv == TV_HAFTED) && (p_ptr->pclass == CLASS_ROGUE &&
			p_ptr->realm1 == REALM_DEATH)) /* Only assassins get a poisoned weapon */
		{
			q_ptr->name2 = EGO_BRAND_POIS;
		}

		add_outfit(q_ptr);
	}

	/* Hack -- make aware of the water */
	k_info[lookup_kind(TV_POTION, SV_POTION_WATER)].aware = TRUE;
#endif
}

/*
 * Player race
 */
/*:::p_ptr->prace肷*/
///mod140105 V푰e[uɑΉB⏉Is̃tOĂ푰͕\ȂB
static bool get_player_race(void)
{
	int     k, n, cs, os;
	cptr    str;
	char    c;
	char	sym[MAX_RACES];
	char    p2 = ')';
	char    buf[80], cur[80];

	//MAX_BIRTH_RACES𒴂Ď푰𑝂₷Ƃɂ́A\̂ȂǂɕςȂƃG[N
	cptr help_index[MAX_BIRTH_RACES] =
	{"Human","Youkai","Half-Youkai","Sennin","Tennin","Fairy",
	"Kappa","Magician","Karasu-tengu","Hakurou-tengu","Oni","Death",
	"Warbeast","Tsukumo","Android","Gyokuto","Youko","Yamawaro",
	"Bake-danuki","Ningyo","Hofgoblin","Nyudo","Imp","Golem","Kobito","Zombie",
	"Vampire","Spectre","Stray-god","Daiyoukai","Demigod","Lunarian"};


	/* Extra info */
	clear_from(10);
#ifdef JP
	put_str("ӁFs푰tɂăLN^[̐VIȎ{[iXω܂B", 23, 5);
#else
	put_str("Note: Your 'race' determines various intrinsic factors and bonuses.", 23 ,5);
#endif

	/* Dump races */
//	for (n = 0; n < MAX_RACES; n++)
	for (n = 0; n < MAX_BIRTH_RACES; n++)
	{
		/* Analyze */
		rp_ptr = &race_info[n];
		str = rp_ptr->title;

		/*:::̈ꕶMAX_RACEMAX_BIRTH_RACEɂ邱ƂŖɗȂȂÔߎcƂ*/
		if(rp_ptr->flag_nobirth || rp_ptr->flag_special || rp_ptr->flag_only_unique) continue;
		/* Display */
		if (n < 26)
			sym[n] = I2A(n);
		else
			sym[n] = ('A' + n - 26);
#ifdef JP
		sprintf(buf, "%c%c%s", sym[n], p2, str);
#else
		sprintf(buf, "%c%c %s", sym[n], p2, str);
#endif
		if(rp_ptr->flag_nofixed) c_put_str(TERM_L_DARK, buf, 12 + (n/5), 1 + 16 * (n%5));
		else put_str(buf, 12 + (n/5), 1 + 16 * (n%5));

	}

#ifdef JP
	sprintf(cur, "%c%c%s", '*', p2, "_");
#else
	sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif

	/* Choose */
	k = -1;
	cs = p_ptr->prace;
//	os = MAX_RACES;
	os = MAX_BIRTH_RACES;
	while (1)
	{
		/* Move Cursol */
		if (cs != os)
		{
			rp_ptr = &race_info[os];

			if(os != MAX_BIRTH_RACES && rp_ptr->flag_nofixed) c_put_str(TERM_L_DARK, cur, 12 + (os/5), 1 + 16 * (os%5));
			else c_put_str(TERM_WHITE, cur, 12 + (os/5), 1 + 16 * (os%5));
			put_str("                                   ", 3, 40);
//			if(cs == MAX_RACES)
			if(cs == MAX_BIRTH_RACES)
			{
#ifdef JP
				sprintf(cur, "%c%c%s", '*', p2, "_");
#else
				sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif
				put_str("                                               ", 4, 40);
				put_str("                                               ", 5, 40);
			}
			else
			{
				rp_ptr = &race_info[cs];
				str = rp_ptr->title;
#ifdef JP
				sprintf(cur, "%c%c%s", sym[cs], p2, str);
				c_put_str(TERM_L_BLUE, rp_ptr->title, 3, 40);
				///mod140105 XRA{Lq
				//put_str("̎푰C", 3, 40+strlen(rp_ptr->title));
				//put_str("r m\  p ϋv  o ", 4, 40);
				put_str("̎푰C", 3, 40+strlen(rp_ptr->title));
				put_str("r m\  p ϋv  o  XRA{", 4, 40);
#else
				sprintf(cur, "%c%c %s", sym[cs], p2, str);
				c_put_str(TERM_L_BLUE, rp_ptr->title, 3, 40);
				put_str(": Race modification", 3, 40+strlen(rp_ptr->title));
				put_str("Str  Int  Wis  Dex  Con  Chr   EXP ", 4, 40);
#endif
				if(cs == RACE_ANDROID)
				sprintf(buf, "%+3d  %+3d  %+3d  %+3d  %+3d  %+3d  **** %4d%% ",
					///mod140119 AhCh͌ol␳\Ȃ悤ɂ
					rp_ptr->r_adj[0], rp_ptr->r_adj[1], rp_ptr->r_adj[2], rp_ptr->r_adj[3],
					rp_ptr->r_adj[4], rp_ptr->r_adj[5], rp_ptr->score_mult);

				else
				sprintf(buf, "%+3d  %+3d  %+3d  %+3d  %+3d  %+3d %+4d%% %4d%% ",
					///mod140105 ŌɃXRA{Lqǉ
					rp_ptr->r_adj[0], rp_ptr->r_adj[1], rp_ptr->r_adj[2], rp_ptr->r_adj[3],
					rp_ptr->r_adj[4], rp_ptr->r_adj[5], (rp_ptr->r_exp - 100), rp_ptr->score_mult);


				c_put_str(TERM_L_BLUE, buf, 5, 40);
			}
			c_put_str(TERM_YELLOW, cur, 12 + (cs/5), 1 + 16 * (cs%5));
			os = cs;
		}

		if (k >= 0) break;

#ifdef JP
		//sprintf(buf, "푰Iŉ (%c-%c) ('='IvVݒ): ", sym[0], sym[MAX_RACES-1]);
		sprintf(buf, "푰Iŉ (%c-%c) ('='IvVݒ): ", sym[0], sym[MAX_BIRTH_RACES-1]);
#else
		sprintf(buf, "Choose a race (%c-%c) ('=' for options): ", sym[0], sym[MAX_RACES-1]);
#endif

		put_str(buf, 10, 10);
		put_str("D̎푰͖łB ", 11, 10);

		c = inkey();
		if (c == 'Q') birth_quit();
		if (c == 'S') return (FALSE);
		if (c == ' ' || c == '\r' || c == '\n')
		{
//			if(cs == MAX_RACES)
			if(cs == MAX_BIRTH_RACES)//_
			{
//				k = randint0(MAX_RACES);
				k = randint0(MAX_BIRTH_RACES);
				cs = k;
				continue;
			}
			else
			{
				k = cs;
				break;
			}
		}
		if (c == '*')
		{
//			k = randint0(MAX_RACES);
			k = randint0(MAX_BIRTH_RACES);
			cs = k;
			continue;
		}
		if (c == '8')
		{
			if (cs >= 5) cs -= 5;
		}
		if (c == '4')
		{
			if (cs > 0) cs--;
		}
		if (c == '6')
		{
//			if (cs < MAX_RACES) cs++;
			if (cs < MAX_BIRTH_RACES) cs++;
		}
		if (c == '2')
		{
//			if ((cs + 5) <= MAX_RACES) cs += 5;
			if ((cs + 5) <= MAX_BIRTH_RACES) cs += 5;
		}
		k = (islower(c) ? A2I(c) : -1);
//		if ((k >= 0) && (k < MAX_RACES))
		if ((k >= 0) && (k < MAX_BIRTH_RACES))
		{
			cs = k;
			continue;
		}
		k = (isupper(c) ? (26 + c - 'A') : -1);
//		if ((k >= 26) && (k < MAX_RACES))
		if ((k >= 26) && (k < MAX_BIRTH_RACES))
		{
			cs = k;
			continue;
		}
		else k = -1;
		if (c == '?' && cs < MAX_BIRTH_RACES)
		{
			char help_entry[64];
			sprintf(help_entry,"traceclas.txt#%s",help_index[cs]);
#ifdef JP
			show_help(help_entry);
#else
			show_help("raceclas.txt#TheRaces");
#endif
		}
		else if (c == '=')
		{
			screen_save();
#ifdef JP
			do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
#else
			do_cmd_options_aux(OPT_PAGE_BIRTH, "Birth Option((*)s effect score)");
#endif
			screen_load();
		}
		else if (c !='2' && c !='4' && c !='6' && c !='8') bell();
	}

	/* Set race */
	p_ptr->prace = k;

	rp_ptr = &race_info[p_ptr->prace];

	/* Display */
	c_put_str(TERM_L_BLUE, rp_ptr->title, 4, 15);

	/* Success */
	return TRUE;
}


/*
 * Player class
 */
static bool get_player_class(void)
{
	int     k, n, cs, os;
	char    c;
	char	sym[MAX_CLASS_CHOICE];
	char    p2 = ')';
	char    buf[80], cur[80];
	cptr    str;

	cptr help_index[MAX_CLASS_CHOICE+1] =
	{"Warrior","Mage","Priest","Explorer","Ranger","Paladin",
	"Teacher","Maid","Martial-Artist","Mindcrafter","High-Mage","Civilian",
	"Syugen","Magic-Knight"," ","Archer","Magic-Eater","Engineer",
	"Librarian","Samurai"," ","Chemist","Cavalry","Tsukumo-Master","Secondhand-dealer","Jeweler",
	"Ninja", " "};

	/* Extra info */
	clear_from(10);
#ifdef JP
	put_str("ӁFsEƁtɂăLN^[̐VIȔ\͂{[iXω܂B", 23, 5);
#else
	put_str("Note: Your 'class' determines various intrinsic abilities and bonuses.", 23, 5);
#endif

#ifdef JP
	//put_str("()ň͂܂ꂽI͂̎푰ɂ͎ȂEƂłB", 11, 10);
	put_str("D̐EƂ͖łB", 11, 10);
#else
	put_str("Any entries in parentheses should only be used by advanced players.", 11, 5);
#endif


	/* Dump classes */
	for (n = 0; n < MAX_CLASS_CHOICE; n++)
	{
		/* Analyze */
		cp_ptr = &class_info[n];
		//mp_ptr = &m_info[n];

		///mod140202 ʂƂɐEƖ𕪂
		if(p_ptr->psex == SEX_MALE)	str = cp_ptr->title;
		else						str = cp_ptr->f_title;

		if (n < 26)
			sym[n] = I2A(n);
		else
			sym[n] = ('A' + n - 26);

		/*:::ĂȂEƂɂ()B݂͎~*/
		/* Display */
		if (!(rp_ptr->choice & (1L << n)))
#ifdef JP
			sprintf(buf, "%c%c(%s)", sym[n], p2, str);
#else
			sprintf(buf, "%c%c (%s)", sym[n], p2, str);
#endif
		else
#ifdef JP
			sprintf(buf, "%c%c%s", sym[n], p2, str);
#else
			sprintf(buf, "%c%c %s", sym[n], p2, str);
#endif

		if(cp_ptr->flag_nofixed) c_put_str(TERM_L_DARK, buf, 13 + (n/4), 2 + 19 * (n%4));
		else put_str(buf, 13+ (n/4), 2 + 19 * (n%4));
	}

#ifdef JP
	sprintf(cur, "%c%c%s", '*', p2, "_");
#else
	sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif

	/* Get a class */
	k = -1;
	cs = p_ptr->pclass;
	os = MAX_CLASS_CHOICE;
	while (1)
	{
		/* Move Cursol */
		if (cs != os)
		{
			if(os != MAX_CLASS_CHOICE && cp_ptr->flag_nofixed) c_put_str(TERM_L_DARK, cur, 13 + (os/4), 2 + 19 * (os%4));
			else c_put_str(TERM_WHITE, cur, 13 + (os/4), 2 + 19 * (os%4));
			put_str("                                   ", 3, 40);
			if(cs == MAX_CLASS_CHOICE)
			{
#ifdef JP
				sprintf(cur, "%c%c%s", '*', p2, "_");
#else
				sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif
				put_str("                                               ", 4, 40);
				put_str("                                               ", 5, 40);
			}
			else
			{
				int mul_score;
				cp_ptr = &class_info[cs];
			//	mp_ptr = &m_info[cs];
				///mod140202 ʂƂɐEƖ𕪂
				if(p_ptr->psex == SEX_MALE)	str = cp_ptr->title;
				else						str = cp_ptr->f_title;


				if (!(rp_ptr->choice & (1L << cs)))
#ifdef JP
					sprintf(cur, "%c%c(%s)", sym[cs], p2, str);
#else
					sprintf(cur, "%c%c (%s)", sym[cs], p2, str);
#endif
				else
#ifdef JP
					sprintf(cur, "%c%c%s", sym[cs], p2, str);
#else
					sprintf(cur, "%c%c %s", sym[cs], p2, str);
#endif
#ifdef JP
					//c_put_str(TERM_L_BLUE, cp_ptr->title, 3, 40);
					if(p_ptr->psex == SEX_MALE)	c_put_str(TERM_L_BLUE, cp_ptr->title, 3, 40);
					else						c_put_str(TERM_L_BLUE, cp_ptr->f_title, 3, 40);

					if(p_ptr->psex == SEX_MALE)	put_str("̐EƏC", 3, 40+strlen(cp_ptr->title));
					else						put_str("̐EƏC", 3, 40+strlen(cp_ptr->f_title));
					//put_str("̐EƏC", 3, 40+strlen(cp_ptr->title));
					put_str("r m\  p ϋv  o XRA", 4, 40);
#else
					c_put_str(TERM_L_BLUE, cp_ptr->title, 3, 40);
					put_str(": Class modification", 3, 40+strlen(cp_ptr->title));
					put_str("Str  Int  Wis  Dex  Con  Chr   EXP ", 4, 40);
#endif
					mul_score = cp_ptr->score_mult;
					extra_mode_score_mult(&mul_score,cs); 
					sprintf(buf, "%+3d  %+3d  %+3d  %+3d  %+3d  %+3d %+4d%% %3d%% ",
						cp_ptr->c_adj[0], cp_ptr->c_adj[1], cp_ptr->c_adj[2], cp_ptr->c_adj[3],
						cp_ptr->c_adj[4], cp_ptr->c_adj[5], cp_ptr->c_exp, mul_score);
					c_put_str(TERM_L_BLUE, buf, 5, 40);
			}
			c_put_str(TERM_YELLOW, cur, 13 + (cs/4), 2 + 19 * (cs%4));
			os = cs;
		}

		if (k >= 0) break;

#ifdef JP
		sprintf(buf, "EƂIŉ (%c-%c) ('='IvVݒ): ", sym[0], sym[MAX_CLASS_CHOICE-1]);
#else
		sprintf(buf, "Choose a class (%c-%c) ('=' for options): ",  sym[0], sym[MAX_CLASS_CHOICE-1]);
#endif

		put_str(buf, 10, 10);
		c = inkey();
		if (c == 'Q') birth_quit();
		if (c == 'S') return (FALSE);
		if (c == ' ' || c == '\r' || c == '\n')
		{
			if(cs == MAX_CLASS_CHOICE)
			{
				k = randint0(MAX_CLASS_CHOICE);
				cs = k;
				continue;
			}
			else
			{
				k = cs;
				break;
			}
		}
		if (c == '*')
		{
			k = randint0(MAX_CLASS_CHOICE);
			cs = k;
			continue;
		}
		if (c == '8')
		{
			if (cs >= 4) cs -= 4;
		}
		if (c == '4')
		{
			if (cs > 0) cs--;
		}
		if (c == '6')
		{
			if (cs < MAX_CLASS_CHOICE) cs++;
		}
		if (c == '2')
		{
			if ((cs + 4) <= MAX_CLASS_CHOICE) cs += 4;
		}
		k = (islower(c) ? A2I(c) : -1);
		if ((k >= 0) && (k < MAX_CLASS_CHOICE))
		{
			cs = k;
			continue;
		}
		k = (isupper(c) ? (26 + c - 'A') : -1);
		if ((k >= 26) && (k < MAX_CLASS_CHOICE))
		{
			cs = k;
			continue;
		}
		else k = -1;

		if (c == '?' && cs < MAX_CLASS_CHOICE+1)
		{
			char help_entry[64];
			sprintf(help_entry,"traceclas.txt#%s",help_index[cs]);
#ifdef JP
			show_help(help_entry);
#else
			show_help("raceclas.txt#TheRaces");
#endif
		}
		else if (c == '=')
		{
			screen_save();
#ifdef JP
			do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
#else
			do_cmd_options_aux(OPT_PAGE_BIRTH, "Birth Option((*)s effect score)");
#endif

			screen_load();
		}
		else if (c !='2' && c !='4' && c !='6' && c !='8') bell();
	}

	/* Set class */
	p_ptr->pclass = k;
	cp_ptr = &class_info[p_ptr->pclass];
	//mp_ptr = &m_info[p_ptr->pclass];

	if(p_ptr->psex == SEX_MALE )strcpy(player_class_name, cp_ptr->title);
	else strcpy(player_class_name, cp_ptr->f_title);

	/* Display */
	//c_put_str(TERM_L_BLUE, cp_ptr->title, 5, 15);
	if(p_ptr->psex == SEX_MALE)	c_put_str(TERM_L_BLUE, cp_ptr->title, 5, 15);
	else						c_put_str(TERM_L_BLUE, cp_ptr->f_title, 5, 15);



	return TRUE;
}


/*
 * Player seikaku
 */
static bool get_player_seikaku(void)
{
	int     k, n, os, cs, term;
	char    c;
	char	sym[MAX_SEIKAKU];
	char    p2 = ')';
	char    buf[80], cur[80];
	char    tmp[64];
	cptr    str;


	/* Extra info */
	clear_from(10);
#ifdef JP
	put_str("ӁFsitɂăLN^[̔\͂{[iXω܂B", 23, 5);
	put_str("DF̐i͖łB", 24, 6);
#else
	put_str("Note: Your personality determines various intrinsic abilities and bonuses.", 23, 5);
#endif

	/* Dump seikakus */
	for (n = 0; n < MAX_SEIKAKU; n++)
	{

		/* Analyze */
		//v1.1.32 ꐫi
		//ap_ptr = &seikaku_info[n];
		ap_ptr = get_ap_ptr(p_ptr->prace,p_ptr->pclass,n);
		if(p_ptr->psex == SEX_MALE) str = ap_ptr->title;
		else  str = ap_ptr->f_title;
		if (n < 26)
			sym[n] = I2A(n);
		else
			sym[n] = ('A' + n - 26);

		/* Display */
		/* Display */
#ifdef JP
		sprintf(buf, "%c%c%s", I2A(n), p2, str);
#else
		sprintf(buf, "%c%c %s", I2A(n), p2, str);
#endif
		if(ap_ptr->flag_nofixed) term = TERM_L_DARK;
		else term = TERM_WHITE;
		c_put_str(term, buf, 12 + (n/4), 2 + 18 * (n%4));
	}

#ifdef JP
	sprintf(cur, "%c%c%s", '*', p2, "_");
#else
	sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif

	/* Get a seikaku */
	k = -1;
	cs = p_ptr->pseikaku;
	os = MAX_SEIKAKU;
	while (1)
	{
		/* Move Cursol */
		if (cs != os)
		{
			if(os != MAX_SEIKAKU && ap_ptr->flag_nofixed) term = TERM_L_DARK;
			else term = TERM_WHITE;
			c_put_str(term, cur, 12 + (os/4), 2 + 18 * (os%4));
			//c_put_str(TERM_WHITE, cur, 12 + (os/4), 2 + 18 * (os%4));
			put_str("                                             ", 3, 40);
			if(cs == MAX_SEIKAKU)
			{
#ifdef JP
				sprintf(cur, "%c%c%s", '*', p2, "_");
#else
				sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif
				put_str("                                           ", 4, 40);
				put_str("                                           ", 5, 40);
			}
			else
			{
				//v1.1.32 ꐫi
				//ap_ptr = &seikaku_info[cs];
				ap_ptr = get_ap_ptr(p_ptr->prace,p_ptr->pclass,cs);
				if(p_ptr->psex == SEX_MALE) str = ap_ptr->title;
				else  str = ap_ptr->f_title;
#ifdef JP
					sprintf(cur, "%c%c%s", sym[cs], p2, str);
#else
					sprintf(cur, "%c%c %s", sym[cs], p2, str);
#endif
#ifdef JP
				if(p_ptr->psex == SEX_MALE)		
					c_put_str(TERM_L_BLUE, ap_ptr->title, 3, 40);
				else  			
					c_put_str(TERM_L_BLUE, ap_ptr->f_title, 3, 40);
				if(p_ptr->psex == SEX_MALE) 
					put_str("̐iC", 3, 40+strlen(ap_ptr->title));
				else  			
					put_str("̐iC", 3, 40+strlen(ap_ptr->f_title));

					put_str("r m\  p ϋv       ", 4, 40);
#else
					c_put_str(TERM_L_BLUE, ap_ptr->title, 3, 40);
					put_str(": Personality modification", 3, 40+strlen(ap_ptr->title));
					put_str("Str  Int  Wis  Dex  Con  Chr       ", 4, 40);
#endif
					sprintf(buf, "%+3d  %+3d  %+3d  %+3d  %+3d  %+3d       ",
						ap_ptr->a_adj[0], ap_ptr->a_adj[1], ap_ptr->a_adj[2], ap_ptr->a_adj[3],
						ap_ptr->a_adj[4], ap_ptr->a_adj[5]);
					c_put_str(TERM_L_BLUE, buf, 5, 40);
			}
			c_put_str(TERM_YELLOW, cur, 12 + (cs/4), 2 + 18 * (cs%4));
			os = cs;
		}

		if (k >= 0) break;

#ifdef JP
		sprintf(buf, "iIŉ (%c-%c) ('='IvVݒ): ", sym[0], sym[MAX_SEIKAKU-1]);
#else
		sprintf(buf, "Choose a personality (%c-%c) ('=' for options): ", sym[0], sym[MAX_SEIKAKU-1]);
#endif

		put_str(buf, 10, 10);
		c = inkey();
		if (c == 'Q') birth_quit();
		if (c == 'S') return (FALSE);
		if (c == ' ' || c == '\r' || c == '\n')
		{
			if(cs == MAX_SEIKAKU)
			{

				k = randint0(MAX_SEIKAKU);

				cs = k;
				continue;
			}
			else
			{

				k = cs;
				break;
			}
		}
		if (c == '*')
		{
			k = randint0(n);
			cs = k;
			continue;
		}
		if (c == '8')
		{
			if (cs >= 4) cs -= 4;

		}
		if (c == '4')
		{
			if (cs > 0) cs--;

		}
		if (c == '6')
		{
			if (cs < MAX_SEIKAKU) cs++;

		}
		if (c == '2')
		{
			if ((cs + 4) <= MAX_SEIKAKU) cs += 4;

		}
		k = (islower(c) ? A2I(c) : -1);
		if ((k >= 0) && (k < MAX_SEIKAKU))
		{
			cs = k;
			continue;
		}
		k = (isupper(c) ? (26 + c - 'A') : -1);
		if ((k >= 26) && (k < MAX_SEIKAKU))
		{
			cs = k;
			continue;
		}
		else k = -1;
		if (c == '?')
		{
#ifdef JP
			show_help("traceclas.txt#ThePersonalities");
#else
			show_help("raceclas.txt#ThePersonalities");
#endif
		}
		else if (c == '=')
		{
			screen_save();
#ifdef JP
			do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
#else
			do_cmd_options_aux(OPT_PAGE_BIRTH, "Birth Option((*)s effect score)");
#endif

			screen_load();
		}
		else if (c !='2' && c !='4' && c !='6' && c !='8') bell();
	}

	/* Set seikaku */
	//v1.1.32 ꐫi
	//ap_ptr = &seikaku_info[p_ptr->pseikaku];
	ap_ptr = get_ap_ptr(p_ptr->prace,p_ptr->pclass,k);
	p_ptr->pseikaku = k;
#ifdef JP
	if(p_ptr->psex == SEX_MALE)		
		strcpy(tmp, ap_ptr->title);
	else
		strcpy(tmp, ap_ptr->f_title);
	if(ap_ptr->no == 1)
	strcat(tmp,"");
#else
	strcpy(tmp, ap_ptr->title);
	strcat(tmp," ");
#endif
	strcat(tmp,player_name);


	/* Display */
	//c_put_str(TERM_L_BLUE, tmp, 1, 34);
	c_put_str(TERM_L_BLUE, tmp, 1, 24);

	return TRUE;
}

/*:::I[g[[@Œlstat_limit[]ɐݒ肷*/
#ifdef ALLOW_AUTOROLLER
static bool get_stat_limits(void)
{
	int i, j, m, cs, os;
	int cval[6];
	char c;
	char buf[80], cur[80];
	char inp[80];

	/* Clean up */
	clear_from(10);

	/* Extra infomation */
#ifdef JP
	put_str("Œ\͒lݒ肵ĉB", 10, 10);
	put_str("2/8ōڑIA4/6Œl̑AEnterŎ", 11, 10);
#else
	put_str("Set minimum stats.", 10, 10);
	put_str("2/8 for Select, 4/6 for Change value, Enter for Goto next", 11, 10);
#endif
	
#ifdef JP
	put_str("         {l  푰 E i     vl  ől", 13, 10);
#else
	put_str("           Base   Rac  Cla  Per      Total  Maximum", 13, 10);
#endif

	/* Output the maximum stats */
	for (i = 0; i < 6; i++)
	{
		/* Reset the "success" counter */
		stat_match[i] = 0;
		cval[i] = 3;

		/* Race/Class bonus */
		j = rp_ptr->r_adj[i] + cp_ptr->c_adj[i] + ap_ptr->a_adj[i];

		/* Obtain the "maximal" stat */
		m = adjust_stat(17, j);
///mod140104 p[^ƕ\LύXɔ\LύX
#if 0
		/* Above 18 */
		if (m > 18)
		{
#ifdef JP
			sprintf(cur, "18/%02d", (m - 18));
#else
			sprintf(cur, "18/%02d", (m - 18));
#endif
		}
		
		/* From 3 to 18 */
		else
#endif
		{
#ifdef JP
			sprintf(cur, "%2d", m);
#else
			sprintf(cur, "%2d", m);
#endif
		}

		/* Obtain the current stat */
		m = adjust_stat(cval[i], j);
#if 0
		/* Above 18 */
		if (m > 18)
		{
#ifdef JP
			sprintf(inp, "18/%02d", (m - 18));
#else
			sprintf(inp, "18/%02d", (m - 18));
#endif
		}
		
		/* From 3 to 18 */
		else
#endif
		{
#ifdef JP
			sprintf(inp, "%2d", m);
#else
			sprintf(inp, "%2d", m);
#endif
		}

		/* Prepare a prompt */
		sprintf(buf, "%6s       %2d   %+3d  %+3d  %+3d  =  %6s  %6s",
			stat_names[i], cval[i], rp_ptr->r_adj[i], cp_ptr->c_adj[i],
			ap_ptr->a_adj[i], inp, cur);
		
		/* Dump the prompt */
		put_str(buf, 14 + i, 10);
	}
	
	/* Get a minimum stat */
	cs = 0;
	os = 6;
	while (TRUE)
	{
		/* Move Cursol */
		if (cs != os)
		{
			if(os == 6)
			{
#ifdef JP
				c_put_str(TERM_WHITE, "肷", 21, 35);
#else
				c_put_str(TERM_WHITE, "Accept", 21, 35);
#endif
			}
			else if(os < 6)
				c_put_str(TERM_WHITE, cur, 14 + os, 10);
			
			if(cs == 6)
			{
#ifdef JP
				c_put_str(TERM_YELLOW, "肷", 21, 35);
#else
				c_put_str(TERM_YELLOW, "Accept", 21, 35);
#endif
			}
			else
			{
				/* Race/Class bonus */
				j = rp_ptr->r_adj[cs] + cp_ptr->c_adj[cs] + ap_ptr->a_adj[cs];

				/* Obtain the current stat */
				m = adjust_stat(cval[cs], j);
#if 0				
				/* Above 18 */
				if (m > 18)
				{
#ifdef JP
					sprintf(inp, "18/%02d", (m - 18));
#else
					sprintf(inp, "18/%02d", (m - 18));
#endif
				}
				
				/* From 3 to 18 */
				else
#endif
				{
#ifdef JP
					sprintf(inp, "%2d", m);
#else
					sprintf(inp, "%2d", m);
#endif
				}
				
				/* Prepare a prompt */
				sprintf(cur, "%6s       %2d   %+3d  %+3d  %+3d  =  %6s",
					stat_names[cs], cval[cs], rp_ptr->r_adj[cs],
					cp_ptr->c_adj[cs], ap_ptr->a_adj[cs], inp);
				c_put_str(TERM_YELLOW, cur, 14 + cs, 10);
			}
			os = cs;
		}
		
		/* Prompt for the minimum stats */
		c = inkey();
		switch ( c ){
		case 'Q':
			birth_quit();
		case 'S':
			return FALSE;
		case ESCAPE:
			break;
		case ' ':
		case '\r':
		case '\n':
			if(cs == 6) break;
			cs++;
			c = '2';
			break;
		case '8':
		case 'k':
			if (cs > 0) cs--;
			break;
		case '2':
		case 'j':
			if (cs < 6) cs++;
			break;
		case '4':
		case 'h':
			if (cs != 6)
			{
				if (cval[cs] == 3)
				{
					cval[cs] = 17;
					os = 7;
				}
				else if (cval[cs] > 3)
				{
					cval[cs]--;
					os = 7;
				}
				else return FALSE;
			}
			break;
		case '6':
		case 'l':
			if (cs != 6)
			{
				if (cval[cs] == 17)
				{
					cval[cs] = 3;
					os = 7;
				}
				else if (cval[cs] < 17)
				{
					cval[cs]++;
					os = 7;
				}
				else return FALSE;
			}
			break;
		case 'm':
			if(cs != 6)
			{
				cval[cs] = 17;
				os = 7;
			}
			break;
		case 'n':
			if(cs != 6)
			{
				cval[cs] = 3;
				os = 7;
			}
			break;
		case '?':
#ifdef JP
			show_help("jbirth.txt#AutoRoller");
#else
			show_help("birth.txt#AutoRoller");
#endif
			break;
		case '=':
			screen_save();
#ifdef JP
			do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
#else
			do_cmd_options_aux(OPT_PAGE_BIRTH, "Birth Option((*)s effect score)");
#endif

			screen_load();
			break;
		default:
			bell();
			break;
		}
		if(c == ESCAPE || ((c == ' ' || c == '\r' || c == '\n') && cs == 6))break;
	}
	
	for (i = 0; i < 6; i++)
	{
		/* Save the minimum stat */
		stat_limit[i] = cval[i];
	}

	return TRUE;
}
#endif


#define STAT_DEFAULT 10

static bool get_bonus_points(void)
{
	int i, j, m, cs, os;
	int bonus_points;
	int bonus_use_total=0;
	char c;
	char buf[80];
	int bonus_use[6],stat_sum[6];

	/* Clean up */
	clear_from(10);

	if(ironman_no_bonus) bonus_points = 0;
	else if(birth_bonus_10) bonus_points = 10;
	else if(birth_bonus_20) bonus_points = 20;
	else
	{
		bonus_points = damroll(3,6);
		while(1)
		{
			if(one_in_(3)) break;
			bonus_points++;
		}
		if(one_in_(64)) bonus_points += 10;
	}
	if(difficulty == DIFFICULTY_EASY)  bonus_points += 10;
	if(bonus_points > 99) bonus_points = 99;

	put_str("\͒lɃ{[iX|CgUĉB", 10, 10);
	put_str("2/8ōڑIA4/6Œl̑", 11, 10);
	put_str("         {l  푰 E i   {[iX  vl", 13, 10);

	for (i = 0; i < 6; i++)
		bonus_use[i] = 0;

	cs = 0;
	while(1)
	{
		for (i = 0; i < 6; i++)
		{
			stat_sum[i] = STAT_DEFAULT + rp_ptr->r_adj[i] + cp_ptr->c_adj[i] + ap_ptr->a_adj[i] + bonus_use[i];

			sprintf(buf, "%6s       %2d   %+2d   %+2d   %+2d   + %3d   =   %3d",
				stat_names[i], STAT_DEFAULT, rp_ptr->r_adj[i], cp_ptr->c_adj[i],	ap_ptr->a_adj[i], bonus_use[i], stat_sum[i]);
			if(cs == i) c_put_str(TERM_YELLOW, buf, 14 + i, 10);
			else		c_put_str(TERM_WHITE , buf, 14 + i, 10);
		}
		if(cs == 6) c_put_str(TERM_YELLOW, "肷", 21, 35);
		else c_put_str(TERM_WHITE, "肷", 21, 35);
		sprintf(buf,"(c{[iX|CgF%d)",bonus_points - bonus_use_total);
		c_put_str(TERM_WHITE, buf, 22, 35);

		c = inkey();
		switch ( c ){
		case 'Q':
			birth_quit();
		case 'S':
			return FALSE;
		case ESCAPE:
			break;
		case ' ':
		case '\r':
		case '\n':
			if(cs == 6) break;
			cs++;
			c = '2';
			break;
		case '8':
		case 'k':
			if (cs > 0) cs--;
			break;
		case '2':
		case 'j':
			if (cs < 6) cs++;
			break;
		case '4':
		case 'h':
			if (cs != 6 && bonus_use[cs] != 0)
			{
				bonus_use[cs]--;
				bonus_use_total--;
			}
			break;
		case '6':
		case 'l':
			if (cs != 6 && (bonus_use[cs] + STAT_DEFAULT < STAT_MAX_MAX) && bonus_use_total < bonus_points)
			{
				bonus_use[cs]++;
				bonus_use_total++;
			}
			break;
			///mod150103 {[iX|CgIvV̂߃{[iX|CgU蕪ʂIvVݒłȂ
/*
		case '=':
			screen_save();
			do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
			screen_load();
			break;
*/
		case '?':
			show_help("tbirth.txt#BonusPoint");
			break;

		default:
			bell();
			break;
		}
		if(c == ESCAPE || ((c == ' ' || c == '\r' || c == '\n') && cs == 6))break;
	}
	
	for (i = 0; i < 6; i++)
	{
		p_ptr->stat_cur[i] = p_ptr->stat_max[i] = STAT_DEFAULT + bonus_use[i];
	}
	return TRUE;
}


#ifdef ALLOW_AUTOROLLER
static bool get_chara_limits(void)
{
#define MAXITEMS 8

	int i, j, m, cs, os;
	int mval[MAXITEMS], cval[MAXITEMS];
	int max_percent, min_percent;
	char c;
	char buf[80], cur[80];
	cptr itemname[] = {
#ifdef JP
		"N",
		"g(C`)",
		"̏d(|h)",
		"ЉIn"
#else
		"age",
		"height",
		"weight",
		"social class"
#endif
	};

	/* Clean up */
	clear_from(10);
	
	/* Prompt for the minimum stats */
#ifdef JP
	put_str("2/4/6/8ōڑIA+/-Œl̑AEnterŎ", 11, 10);
	put_str("ӁFgƑ̏d̍ől/ŏl肬̒l͔ɏomႭȂ܂B", 23, 2);
#else
	put_str("2/4/6/8 for Select, +/- for Change value, Enter for Goto next", 11, 10);
	put_str("Caution: Values near minimum or maximum is extremery rare.", 23, 5);
#endif
	
	if (p_ptr->psex == SEX_MALE)
	{
		max_percent = (int)(rp_ptr->m_b_ht+rp_ptr->m_m_ht*4-1) * 100 / (int)(rp_ptr->m_b_ht);
		min_percent = (int)(rp_ptr->m_b_ht-rp_ptr->m_m_ht*4+1) * 100 / (int)(rp_ptr->m_b_ht);
	}
	else
	{
		max_percent = (int)(rp_ptr->f_b_ht+rp_ptr->f_m_ht*4-1) * 100 / (int)(rp_ptr->f_b_ht);
		min_percent = (int)(rp_ptr->f_b_ht-rp_ptr->f_m_ht*4+1) * 100 / (int)(rp_ptr->f_b_ht);
	}
	
#ifdef JP
	put_str("̊i/nʂ̍ŏl/őlݒ肵ĉB", 10, 10);
	put_str("                       ŏl  ől", 13,20);
#else
	put_str(" Parameter                    Min     Max", 13,20);
	put_str("Set minimum/maximum attribute.", 10, 10);
#endif

	/* Output the maximum stats */
	for (i = 0; i < MAXITEMS; i++)
	{
		/* Obtain the "maximal" stat */
		switch (i)
		{
		case 0:	/* Minimum age */
			m = rp_ptr->b_age + 1;
			break;
		case 1:	/* Maximum age */
			m = rp_ptr->b_age + rp_ptr->m_age;
			break;

		case 2:	/* Minimum height */
			if (p_ptr->psex == SEX_MALE) m = rp_ptr->m_b_ht-rp_ptr->m_m_ht*4+1;
			else m = rp_ptr->f_b_ht-rp_ptr->f_m_ht*4+1;
			break;
		case 3:	/* Maximum height */
			if (p_ptr->psex == SEX_MALE) m = rp_ptr->m_b_ht+rp_ptr->m_m_ht*4-1;
			else m = rp_ptr->f_b_ht+rp_ptr->f_m_ht*4-1;
			break;
		case 4:	/* Minimum weight */
			if (p_ptr->psex == SEX_MALE) m = (rp_ptr->m_b_wt * min_percent / 100) - (rp_ptr->m_m_wt * min_percent / 75) +1;
			else m = (rp_ptr->f_b_wt * min_percent / 100) - (rp_ptr->f_m_wt * min_percent / 75) +1;
			break;
		case 5:	/* Maximum weight */
			if (p_ptr->psex == SEX_MALE) m = (rp_ptr->m_b_wt * max_percent / 100) + (rp_ptr->m_m_wt * max_percent / 75) -1;
			else m = (rp_ptr->f_b_wt * max_percent / 100) + (rp_ptr->f_m_wt * max_percent / 75) -1;
			break;
		case 6:	/* Minimum social class */
			m = 1;
			break;
		case 7:	/* Maximum social class */
			m = 100;
			break;
		default:
			m = 1;
			break;
		}
		
		/* Save the maximum or minimum */
		mval[i] = m;
		cval[i] = m;
	}

	for (i = 0; i < 4; i++)
	{
		/* Prepare a prompt */
		sprintf(buf, "%-12s (%3d - %3d)", itemname[i], mval[i*2], mval[i*2+1]);

		/* Dump the prompt */
		put_str(buf, 14 + i, 20);

		for (j = 0; j < 2; j++)
		{
			sprintf(buf, "     %3d", cval[i*2+j]);
			put_str(buf, 14 + i, 45 + 8 * j);
		}
	}
	
	/* Get a minimum stat */
	cs = 0;
	os = MAXITEMS;
	while (TRUE)
	{
		/* Move Cursol */
		if (cs != os)
		{
#ifdef JP
			const char accept[] = "肷";
#else
			const char accept[] = "Accept";
#endif
			if(os == MAXITEMS)
			{
				c_put_str(TERM_WHITE, accept, 19, 35);
			}
			else
			{
				c_put_str(TERM_WHITE, cur, 14 + os/2, 45 + 8 * (os%2));
			}
			
			if(cs == MAXITEMS)
			{
				c_put_str(TERM_YELLOW, accept, 19, 35);
			}
			else
			{
				/* Prepare a prompt */
				sprintf(cur, "     %3d", cval[cs]);
				c_put_str(TERM_YELLOW, cur, 14 + cs/2, 45 + 8 * (cs%2));
			}
			os = cs;
		}
		
		/* Prompt for the minimum stats */
		c = inkey();
		switch (c){
		case 'Q':
			birth_quit();
		case 'S':
			return (FALSE);
		case ESCAPE:
			break; /*łbreak*/
		case ' ':
		case '\r':
		case '\n':
			if(cs == MAXITEMS) break;
			cs++;
			c = '6';
			break;
		case '8':
		case 'k':
			if (cs-2 >= 0) cs -= 2;
			break;
		case '2':
		case 'j':
			if (cs < MAXITEMS) cs += 2;
			if (cs > MAXITEMS) cs = MAXITEMS;
			break;
		case '4':
		case 'h':
			if (cs > 0) cs--;
			break;
		case '6':
		case 'l':
			if (cs < MAXITEMS) cs++;
			break;
		case '-':
		case '<':
			if (cs != MAXITEMS)
			{
				if(cs%2)
				{
					if(cval[cs] > cval[cs-1])
					{
						cval[cs]--;
						os = 127;
					}
				}
				else
				{
					if(cval[cs] > mval[cs])
					{
						cval[cs]--;
						os = 127;
					}
				}
			}
			break;
		case '+':
		case '>':
			if (cs != MAXITEMS)
			{
				if(cs%2)
				{
					if(cval[cs] < mval[cs])
					{
						cval[cs]++;
						os = 127;
					}
				}
				else
				{
					if(cval[cs] < cval[cs+1])
					{
						cval[cs]++;
						os = 127;
					}
				}
			}
			break;
		case 'm':
			if(cs != MAXITEMS)
			{
				if(cs%2)
				{
					if(cval[cs] < mval[cs])
					{
						cval[cs] = mval[cs];
						os = 127;
					}
				}
				else
				{
					if(cval[cs] < cval[cs+1])
					{
						cval[cs] = cval[cs+1];
						os = 127;
					}
				}
			}
			break;
		case 'n':
			if(cs != MAXITEMS)
			{
				if(cs%2)
				{
					if(cval[cs] > cval[cs-1])
					{
						cval[cs] = cval[cs-1];
						os = 255;
					}
				}
				else
				{
					if(cval[cs] > mval[cs])
					{
						cval[cs] = mval[cs];
						os = 255;
					}
				}
			}
			break;
		case '?':
#ifdef JP
			show_help("jbirth.txt#AutoRoller");
#else
			show_help("birth.txt#AutoRoller");
#endif
			break;
		case '=':
			screen_save();
#ifdef JP
			do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
#else
			do_cmd_options_aux(OPT_PAGE_BIRTH, "Birth Option((*)s effect score)");
#endif

			screen_load();
			break;
		default:
			bell();
			break;
		}
		if(c == ESCAPE || ((c == ' ' || c == '\r' || c == '\n') && cs == MAXITEMS))break;
	}

	/* Input the minimum stats */
	chara_limit.agemin = cval[0];
	chara_limit.agemax = cval[1];
	chara_limit.htmin = cval[2];
	chara_limit.htmax = cval[3];
	chara_limit.wtmin = cval[4];
	chara_limit.wtmax = cval[5];
	chara_limit.scmin = cval[6];
	chara_limit.scmax = cval[7];

	return TRUE;
}
#endif

#define HISTPREF_LIMIT 1024
static char *histpref_buf = NULL;

/*
 * Hook function for reading the histpref.prf file.
 */
void add_history_from_pref_line(cptr t)
{
	/* Do nothing if the buffer is not ready */
	if (!histpref_buf) return;

	my_strcat(histpref_buf, t, HISTPREF_LIMIT);
}


static bool do_cmd_histpref(void)
{
	char buf[80];
	errr err;
	int i, j, n;
	char *s, *t;
	char temp[64 * 4];
	char histbuf[HISTPREF_LIMIT];

#ifdef JP
	if (!get_check("ݒt@C[h܂? ")) return FALSE;
#else
	if (!get_check("Load background history preference file? ")) return FALSE;
#endif

	/* Prepare the buffer */
	histbuf[0] = '\0';
	histpref_buf = histbuf;

#ifdef JP
	sprintf(buf, "histedit-%s.prf", player_base);
#else
	sprintf(buf, "histpref-%s.prf", player_base);
#endif
	err = process_histpref_file(buf);

	/* Process 'hist????.prf' if 'hist????-<name>.prf' doesn't exist */
	if (0 > err)
	{
#ifdef JP
		strcpy(buf, "histedit.prf");
#else
		strcpy(buf, "histpref.prf");
#endif
		err = process_histpref_file(buf);
	}

	if (err)
	{
#ifdef JP
		msg_print("ݒt@C̓ǂݍ݂Ɏs܂B");
#else
		msg_print("Failed to load background history preference.");
#endif
		msg_print(NULL);

		/* Kill the buffer */
		histpref_buf = NULL;

		return FALSE;
	}
	else if (!histpref_buf[0])
	{
#ifdef JP
		msg_print("LȐݒ͂̃t@Cɂ܂B");
#else
		msg_print("There does not exist valid background history preference.");
#endif
		msg_print(NULL);

		/* Kill the buffer */
		histpref_buf = NULL;

		return FALSE;
	}

	/* Clear the previous history strings */
	for (i = 0; i < 4; i++) p_ptr->history[i][0] = '\0';

	/* Skip leading spaces */
	for (s = histpref_buf; *s == ' '; s++) /* loop */;

	/* Get apparent length */
	n = strlen(s);

	/* Kill trailing spaces */
	while ((n > 0) && (s[n - 1] == ' ')) s[--n] = '\0';

	roff_to_buf(s, 60, temp, sizeof(temp));
	t = temp;
	for (i = 0; i < 4; i++)
	{
		if (t[0] == 0) break;
		else
		{
			strcpy(p_ptr->history[i], t);
			t += strlen(t) + 1;
		}
	}

	/* Fill the remaining spaces */
	for (i = 0; i < 4; i++)
	{
		for (j = 0; p_ptr->history[i][j]; j++) /* loop */;

		for (; j < 59; j++) p_ptr->history[i][j] = ' ';
		p_ptr->history[i][59] = '\0';
	}

	/* Kill the buffer */
	histpref_buf = NULL;

	return TRUE;
}

/*
 *  Character background edit-mode
 */
/*::: p_ptr->history[][]ҏW*/
static void edit_history(void)
{
	char old_history[4][60];
	int y = 0, x = 0;
	int i, j;

	/* Edit character background */
	for (i = 0; i < 4; i++)
	{
		sprintf(old_history[i], "%s", p_ptr->history[i]);
	}
	/* Turn 0 to space */
	for (i = 0; i < 4; i++)
	{
		for (j = 0; p_ptr->history[i][j]; j++) /* loop */;

		for (; j < 59; j++) p_ptr->history[i][j] = ' ';
		p_ptr->history[i][59] = '\0';
	}
	display_player(1);
#ifdef JP
	c_put_str(TERM_L_GREEN, "(LN^[̐ - ҏW[h)", 11, 20);
	put_str("[ J[\L[ňړAEnterŏIACtrl-AŃt@Cǂݍ ]", 17, 10);
#else
	c_put_str(TERM_L_GREEN, "(Character Background - Edit Mode)", 11, 20);
	put_str("[ Cursor key for Move, Enter for End, Ctrl-A for Read pref ]", 17, 10);
#endif

	while (TRUE)
	{
		int skey;
		char c;

		for (i = 0; i < 4; i++)
		{
			put_str(p_ptr->history[i], i + 12, 10);
		}
#ifdef JP
		if (iskanji2(p_ptr->history[y], x))
			c_put_str(TERM_L_BLUE, format("%c%c", p_ptr->history[y][x],p_ptr->history[y][x+1]), y + 12, x + 10);
		else
#endif
		c_put_str(TERM_L_BLUE, format("%c", p_ptr->history[y][x]), y + 12, x + 10);

		/* Place cursor just after cost of current stat */
		Term_gotoxy(x + 10, y + 12);

		/* Get special key code */
		skey = inkey_special(TRUE);

		/* Get a character code */
		if (!(skey & SKEY_MASK)) c = (char)skey;
		else c = 0;

		if (skey == SKEY_UP || c == KTRL('p'))
		{
			y--;
			if (y < 0) y = 3;
#ifdef JP
			if ((x > 0) && (iskanji2(p_ptr->history[y], x-1))) x--;
#endif
		}
		else if (skey == SKEY_DOWN || c == KTRL('n'))
		{
			y++;
			if (y > 3) y = 0;
#ifdef JP
			if ((x > 0) && (iskanji2(p_ptr->history[y], x-1))) x--;
#endif
		}
		else if (skey == SKEY_RIGHT || c == KTRL('f'))
		{
#ifdef JP
			if (iskanji2(p_ptr->history[y], x)) x++;
#endif
			x++;
			if (x > 58)
			{
				x = 0;
				if (y < 3) y++;
			}
		}
		else if (skey == SKEY_LEFT || c == KTRL('b'))
		{
			x--;
			if (x < 0)
			{
				if (y)
				{
					y--;
					x = 58;
				}
				else x = 0;
			}

#ifdef JP
			if ((x > 0) && (iskanji2(p_ptr->history[y], x-1))) x--;
#endif
		}
		else if (c == '\r' || c == '\n')
		{
			Term_erase(0, 11, 255);
			Term_erase(0, 17, 255);
#ifdef JP
			put_str("(LN^[̐ - ҏWς)", 11, 20);
#else
			put_str("(Character Background - Edited)", 11, 20);
#endif
			break;
		}
		else if (c == ESCAPE)
		{
			clear_from(11);
#ifdef JP
			put_str("(LN^[̐)", 11, 25);
#else
			put_str("(Character Background)", 11, 25);
#endif

			for (i = 0; i < 4; i++)
			{
				sprintf(p_ptr->history[i], "%s", old_history[i]);
				put_str(p_ptr->history[i], i + 12, 10);
			}
			break;
		}
		else if (c == KTRL('A'))
		{
			if (do_cmd_histpref())
			{
#ifdef JP
				if ((x > 0) && (iskanji2(p_ptr->history[y], x - 1))) x--;
#endif
			}
		}
		else if (c == '\010')
		{
			x--;
			if (x < 0)
			{
				if (y)
				{
					y--;
					x = 58;
				}
				else x = 0;
			}

			p_ptr->history[y][x] = ' ';
#ifdef JP
			if ((x > 0) && (iskanji2(p_ptr->history[y], x - 1)))
			{
				x--;
				p_ptr->history[y][x] = ' ';
			}
#endif
		}
#ifdef JP
		else if (iskanji(c) || isprint(c))
#else
		else if (isprint(c)) /* BUGFIX */
#endif
		{
#ifdef JP
			if (iskanji2(p_ptr->history[y], x))
			{
				p_ptr->history[y][x+1] = ' ';
			}

			if (iskanji(c))
			{
				if (x > 57)
				{
					x = 0;
					y++;
					if (y > 3) y = 0;
				}

				if (iskanji2(p_ptr->history[y], x+1))
				{
					p_ptr->history[y][x+2] = ' ';
				}

				p_ptr->history[y][x++] = c;

				c = inkey();
			}
#endif
			p_ptr->history[y][x++] = c;
			if (x > 58)
			{
				x = 0;
				y++;
				if (y > 3) y = 0;
			}
		}
	} /* while (TRUE) */

}

#define ENTRY_MAX 14 //o̍i@{ƐVoǉ
//oi@select_unique_entry[]̓YɈv悤
#define ENTRY_REIMARI	0
#define ENTRY_KOUMA		1
#define ENTRY_YOUMU		2
#define ENTRY_EIYA		3
#define ENTRY_KAEI		4
#define ENTRY_HUUZIN	5
#define ENTRY_TIREI		6
#define ENTRY_SEIREN	7
#define ENTRY_SHINREI	8
#define ENTRY_KISHIN	9
#define ENTRY_KANZYU	10
#define ENTRY_TENKUU	11
#define ENTRY_TASOGARE	12
#define ENTRY_OTHER		13



const	cptr select_unique_entry[ENTRY_MAX] = {
		"a)Ԏ@l",
		"b)g",
		"c)dX",
		"d)i鏴",
		"e)ԉf",
		"f)_^",
		"g)na",
		"h)@D",
		"i)__",
		"j)Pj",
		"k)`",
		"l)V",
		"m)eANV",
		"n)̑̍i",
	};

typedef struct unique_player_type unique_player_type;
struct unique_player_type
{
	bool flag_fix;  //܂ĂȂFALSE
	cptr name;		//O
	int class_id;	//CLASS_???̒l
	int race;		//RACE_???̒l
	int entry;		//ENTRY_???̒l@oi
	int sex;		//ʁ@Ԃ񍡌Sꉞ
	cptr info;	//LCNɕ\
};

#define UNIQUE_PLAYER_NUM 104
#define CLASS_DUMMY 255
#define RACE_DUMMY 255
static unique_player_type unique_player_table[UNIQUE_PLAYER_NUM] =
{
	{TRUE,"@얲",CLASS_REIMU,RACE_HUMAN,ENTRY_REIMARI,SEX_FEMALE,
	"Ȃ͌zٕ̊̈ςɓ̛ޏ̐lłBɂ߂čݔ\͂܂ӂ҂Ȃ̂ł܂C܂B_Ђւ̐M(̓Iɂ͂ΑK)܂΂Co邩܂BΑK͓G|NGXgȂƎQq҂Ă񂾂񗭂܂Ă܂B܂Z[ut@C̈ȑO̖`ŒNꂽΑK͑SĈp܂BŏIIɂ͔݂ɂȂ邱Ƃł傤BȂXRA͋ɂ߂ĒႭȂ܂BޏǂɃttōsĈٕς̎d҂@̂߂ċAĂ邱Ƃ͌zɂē풃юłNȂ߂łB"},
	{TRUE,"J@",CLASS_MARISA,RACE_HUMAN,ENTRY_REIMARI,SEX_FEMALE,
	"Ȃ͕ʂ̖@ĝĂ܂AȂ܂ٕ̈ςɓz̉pYłBǧyƎȂ̈Aċ͂ȍU@głBȂ̓Ǝ̖@͎gp@ŁAȖ@Đ@KAfނW߂Ēo͂疂@A@ď`Ŏgp܂Bfނ̎W͒nȍƂłAꂽ@̈З͂͐؂DƌĂԂɂӂ킵̂łB܂Z[ut@C̈ȑO̖`ŒNJ@XɓnfރACe͂ƂĒ~ςĂ܂B@ȂĂ͂ȓZK܂BȂʏ̖@K\ŁÄƑ̈RɕύX邱Ƃł܂B"},

	{TRUE,"[~A",CLASS_RUMIA,RACE_YOUKAI,ENTRY_KOUMA,SEX_FEMALE,
	"Ȃ͌z̋ĂȂYdłBł𑀂\͂AÍUɊւXLƑϐ܂Bg̔\͂͒ʏ̐lԂ͍߂łdƂĂ͂}łB̈͂Ŗ@͎g܂BƈÍUS󂯕tȂȂ܂B"},
	{TRUE,"`m",CLASS_CIRNO,RACE_FAIRY,ENTRY_KOUMA,SEX_FEMALE,
	"Ȃ͕ǐ͖΂ŗVŕ炵ĂX̗dłBdƂĂ͋KiOƂقǋ͂܂A͂܂łd̒ł̘błBX̗dȂ̂ŗCUɋAƗCUS󂯕tȂȂ܂BΉ͂Ȃ̑GłBC֌W̓ZLxłA@Ȃǂ͂܂ǂ߂̈łBTȂǍׂƂłB"},
	{TRUE,"g@",CLASS_MEIRIN,RACE_YOUKAI,ENTRY_KOUMA,SEX_FEMALE,
	"Ȃ͍gقŖԂ𖱂߂dŁAp̒BlłBȂ̊i̒ʏU͈s̍U񐔂߂łAs͂ʏZȂ܂BiUAōs΍sقǏs͂ɌIȍU͂㏸܂B茘Ζhɒ܂AXN΂Ȃ̍U͂𔭊邱Ƃ\łBC𑀂\͂ĂAm⏕Ȃ܂BxɂȂƔj׍U_ƂȂȂ܂B"},
	{TRUE,"p`[Em[bW",CLASS_PATCHOULI,RACE_MAGICIAN,ENTRY_KOUMA,SEX_FEMALE,
	"Ȃ͐܂̖@gŁA܂ł̐l̂قƂǂǏɔ₵ė܂B݂͍gق̑}قɏZłĊOo͂HłBȂ͖cȖ@̒mĂAQ[Jn_Ŗp4̈SĂLĂ܂BxĂĖ@ĂΖ@sg\łBɎj𑀂鋭͂Ȗ@AԌo߂ɂ閂͂̉񕜂ɂ߂đƂ܂Bg̔\͂͂Ȃnŏd̂A܂ĐڋߐȂǂ͑S̖dłBbĂAb̒qȂƖ@̎sオAꍇɂĂ͊ǂނƂ玸s邩܂B̖␶̖ȂǂŚb̒qǂȂ܂B"},
	{TRUE,"\Z@",CLASS_SAKUYA,RACE_HUMAN,ENTRY_KOUMA,SEX_FEMALE,
	"Ȃ͍gقɐ؂萷肷lԂ̃ChŁA̓iCt̏NWłBȂ͎Ԃ𑀂Ƃlԗꂵ\͂ĂA^[ȂŎԂ~߂邱Ƃł܂BԒ~ɓGɒڍU邱Ƃ͂ł܂񂪁AԂ~߂܂܍DȂxe邱Ƃł邽߁AmT̊TOSɂȂ܂BقɂiCte|[gȂǂɊւZLxɏK܂BȂ̓ChȂ̂ŏɃCh𒅂Ȃ΂܂B"},	
	{TRUE,"~AEXJ[bg",CLASS_REMY,RACE_VAMPIRE,ENTRY_KOUMA,SEX_FEMALE,
	"Ȃ͍gق̎ŁA^𑀂͂Ƃ͂ȋzSłBɋɂ߂ċA̋Z\ɗDAlȍUւ̑ϐA@̏K\ŁȀ㋭͂ȃACe悭ɓ܂BzSȂ̂ŔjׁEME̍Uɑ΂Ă͐ƎłB͂ȕXRA͂ȂႭȂ܂B"},
	{TRUE,"th[EXJ[bg",CLASS_FLAN,RACE_VAMPIRE,ENTRY_KOUMA,SEX_FEMALE,
	"Ȃ͍gق̖̎ŁAoƓl͂ȋzSłBSNnɂĊOɂȂǋ܂łBj̔\͂ĂA_W̃gbvhAȂǂQВ[󂵂Đi݂܂BȂ̔j̗͂͂΂Ή󂷂ׂłȂ̂܂ł󂵂܂BlXȓZ܂͑SĔjIsłBȂ̓قȐ_͂ǂ̂悤ȋ낵̂ĂނƂ͂܂B"},

	{TRUE,"eBEzCgbN",CLASS_LETTY,RACE_YOUKAI,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͊C𑀂dłBԂ͂ǂɉBZłē~ɂȂƊOɏoĂ܂BCEUӂŁA܂ΓGɍsɓ|Ƃ\łBɑ΂Ă͗Lɐ킦܂AfbhS[肾ƂقƂǖ͂łBCɋϐŉ͂Ȃ̑GłB`̏Ղ͊yɂȂ܂IՂ͂Ȃ̋J邱Ƃł傤B"},
	{TRUE,"",CLASS_CHEN,RACE_WARBEAST,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͑d_̎ł锪_̂̂܂łBc͂܂܂BG̕sӂՂ̂܂AꂽGɈuŋ삯ꌂėEȂǑfs𓾈ӂƂ܂BU󂯂蕂VɐɓƎĎ̉Ă܂܂B̜߂ĂȂȂ͂}ȉLłBĂƂɒT_ɍsƎɎ߂Ă炦܂B▂̈͂łB"},
	{TRUE,"AXE}[KgCh",CLASS_ALICE,RACE_MAGICIAN,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͐l`łBSɎēl`邱ƂڎwX𑱂Ă܂BȂ̐퓬X^C͓ƓŁA͕ɖ@̎ől`𕐑Đ킢܂Bl`𑀂TŖ@̈sg\łBl`̐̓xAbvɂ葝Al`̍U͂͒m\ApAl`̎ށAĎŌ܂܂Bl`̎ɂϐ\͏㏸ʂȂǂ̂͔܂Bl`ɂU͋͂łȂg͂ȂłアߗǎȖh̊mۂdvłBl`𑀂זɂȂ̂ŃO[u𑕔邱Ƃ͂ł܂BȂ͐Ȗ@ɎgĂ邽ߗ򉻍U_łBR͑Sł܂B"},
	{TRUE,"[zCg",CLASS_LILY_WHITE,RACE_FAIRY,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͏t̓m点dŁAtƂĂ΂܂B͏tČCς̂ߕʂ̗d薾炩ɋ͂܂B30oƏt̏I肪߂ÂACȂĂ܂܂B܂ł**ȂƃQ[I[o[łBȂ̐퓬\͍͂Ƃ͌AMɒlقǂ̒ZĂ܂BȂ̖`͉ߍȂ̂ƂȂł傤B"},
	{TRUE,"iTEvYo[",CLASS_LUNASA,RACE_SPECTRE,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͑̎o̒łBÒŐ^ʖڂłB@K邱ƂłAe͂܂D݂ł͂܂BȂ̑tł鉹ɂ͕҂̋C𒾂߂͂܂BȂ͎łX̔pmقɍsđ̎oƖ`シ邱Ƃł܂BolAbp[^AiȂǂ͎oŋL܂BȂ͗̂̂߃_Wŕǂ𔲂邱Ƃł܂B`ɂĔɗLłXRA啝ɉA܂j׍U͂Ȃ̑GłBȂAx̎oƌスɏXRAオ܂B"},
	{TRUE,"EvYo[",CLASS_MERLIN,RACE_SPECTRE,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͑̎o̎łB邭N炩ŁAɂ͈ӎv̑aʂȂقǃnCeVłBȂ̑tł鉹ɂ͕҂̋Cg͂܂BȂ͎łX̔pmقɍsđ̎oƖ`シ邱Ƃł܂BolAbp[^AiȂǂ͎oŋL܂BȂ͗̂̂߃_Wŕǂ𔲂邱Ƃł܂B`ɂĔɗLłXRA啝ɉA܂j׍U͂Ȃ̑GłBȂAx̎oƌスɏXRAオ܂B"},
	{TRUE,"JEvYo[",CLASS_LYRICA,RACE_SPECTRE,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͑̎o̎OłBq҂łvZڒ[ÂƂpɂȂ܂BȂ̑tł鉹͒ʏ̐Eɂ݂͑ȂŁAlXȕsvcȌʂN܂BȂ͎łX̔pmقɍsđ̎oƖ`シ邱Ƃł܂BolAbp[^AiȂǂ͎oŋL܂BȂ͗̂̂߃_Wŕǂ𔲂邱Ƃł܂B`ɂĔɗLłXRA啝ɉA܂j׍U͂Ȃ̑GłBȂAx̎oƌスɏXRAオ܂B"},



	{TRUE,"鮁@d",CLASS_YOUMU,RACE_HALF_GHOST,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͔ľmłBEŒtqƂĎɎdĂ܂BȂ炩ȂbĂA񓁗̒BlłBuOόvuOvƂR铁ŏ珊Ă܂Bقȑ̎ƋCƓ̌ZŐ킢܂B܂|̔`ǂނƂŋ͂ȋZ̏K\łB"},
	{TRUE,"s@HXq",CLASS_YUYUKO,RACE_SPECTRE,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͔ʘO̎𖱂߂鋭͂ȖSłB䩗mƂڂɔߐڐ퓬\͂܂B܂̖̈@𓾈ӂƂAɎ̗͂𑀂_W̓GZ܂BlXȍUɑ΂ϐAnUSɖőM_ƂAɕǂ𔲂Ĉړ邱Ƃł܂B_WTɂĊɋ߂͂̎łAB̎_ƂĂɂ󂫂܂BH͑ʂɎ܂傤B"},
	{TRUE,"_@",CLASS_RAN,RACE_YOUKO,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͑d_̎łB傩SŐ[wւ̎hq𖽂܂BȂgdƂĒm̌ςłAĎ傩狭͂Ȏt^Ă邽߂ʂŋɂ߂č\͂܂Bߊ܂ł̊͋͂TԂłBeڂU炸Ƀ_W֐葱Kvł傤BȂAS̈ʒu͍ŏm炳ĂA҂̖@ȂǂōsƂł܂B"},
	{TRUE,"_@",CLASS_YUKARI,RACE_DAIYOUKAI,ENTRY_YOUMU,SEX_FEMALE,
	"Ȃ͌zŌÎQ̑dŁAzێǗڂ𕉂Ă܂BuEv𑀍삷\͂A͂ȓZK܂BbIȔ\͒lɒm\̍͑SEƒgbvNXłBXRA{͋ɂ߂ĒႭȂA܂Ȃx߂łB"},

	{TRUE,"OEiCgoO",CLASS_WRIGGLE,RACE_YOUKAI,ENTRY_EIYA,SEX_FEMALE,
	"Ȃ͌u̗dłB峂𑀂\͂ĂA峂gĐ킹͂mȂǂ̓ZK܂BȂ͌ȂĂ_WƂ炷ƂłAxオƑMւ̑ϐ𓾂܂B͂Ȃ̑GłBȂg̐퓬\͂͂قǍ͂Ȃ߁AՈȍ~͋邩܂B"},
	{TRUE,"~XeBAE[C",CLASS_MYSTIA,RACE_YOUKAI,ENTRY_EIYA,SEX_FEMALE,
	"Ȃ͉̐Őlf킹鐝̗dłB͂̂̂ƂŒ҂𒹖ڂɂ荬邱Ƃł܂B܂ñX^[xz菢Z܂B퓬\͕͂WIłqɗD܂B"},
	{TRUE,"㔒@d",CLASS_KEINE,RACE_WARBEAST,ENTRY_EIYA,SEX_FEMALE,
	"Ȃ͔błAlԂ̐Ml̎qŋtĕ炵Ă܂B퓬ɂĂ͔A@Ȃǈʂ̂ƂȂɂȂ܂BjHׂ\͂AlXȑ݂BZK܂Bblɂ͒ɂ߂čm܂AȂ̌ŐΓłBi͏b炵Ƃ͂قƂǂ܂񂪁AƏbł锒(nN^N)̗͂FZIɃp[Abv܂BɂȂ鎞ɂ͑傫Ȋp邽߁Ȃiɂ͋CĂB"},
	{TRUE,"@Ă",CLASS_TEWI,RACE_WARBEAST,ENTRY_EIYA,SEX_FEMALE,
	"Ȃ͂ȂÊ̗deŁAiœeB𗦂Ă܂BmɒĂ㩂ꌂEgĐ킢܂B܂Aǂŉ҂̂Q[X^[gɑʂ̎Ă܂BbIȐ퓬\͂͂ɂƂ͂A`̏IՂł͋킷邱Ƃł傤B"},
	{TRUE,"ED܉؉@ECio",CLASS_UDONGE,RACE_GYOKUTO,ENTRY_EIYA,SEX_FEMALE,
	"Ȃ͌痈dełB̂т艮̑ʓe̒ł͑z퓬ZXĂ܂Bg𑀂Ƃɂ߂ĉpɕx񂾔\͂AUh䊴mƑʂȓZK܂Bnł̕炵ߋʓe̔j׍UϐĂ܂B"},
	{TRUE,"Ӂ@i",CLASS_EIRIN,RACE_HOURAI,ENTRY_EIYA,SEX_FEMALE,
	"Ȃ͂Č̌҂ƌĂ΂ꂽMȑ݂łA͎̋PƋɒnlƂĕ炵Ă܂BȂ͓V˓Iȓ]AxĂĖ@ĂΑSĂ̖@sg\łBɂ钲܂̃VsLĂA|̈ӂŁAȂȀ؂̓ŕ󂯕t܂BȂ͋P̌ɂ苤ɓSɕVR̗ɏo܂BP̔\͂̓tAړ邽тɂȂ̃xɍ킹ĕϓ܂BȂ`܂傤BȂƋP̂ǂ炩Еł|ƃQ[I[o[łB"},
	{TRUE,"HR@P",CLASS_KAGUYA,RACE_HOURAI,ENTRY_EIYA,SEX_FEMALE,
	"Ȃ͂Ɍ邩P̐lłBzŉi̎ƂĒԂЂƕ炵Ă܂Aŋ߂܂ɉɂȂ߁ÂɒT߂܂̐_x͎ŒToƈON܂BwSXxw̃jR[xwC̎wցxwIKxwAUg[gxƂGۗLĂ悤łB撣ē|Ďɓ܂傤BZ[uf[^̈ȑO̖`҂̐_Ȃɓ͂ĂꍇAȂ͂Q[Jn珊LĂ܂BJnɈLĂ邲ƂɃXRAɂȂ܂BȂ͕sg̖HlłAx|ꂽ`ɖOĂ܂߃Q[I[o[łB"},
	{TRUE,"@g",CLASS_MOKOU,RACE_HOURAI,ENTRY_EIYA,SEX_FEMALE,
	"Ȃ͐NȏOɖH̖ŕsVsƂȂlԂłBHPsĂ̏ŕƂ|j̔\͂Ă܂BƂɂMPAHPMPǂȂƃQ[I[o[łB퓬ɂđȏɖ܂AMP̎cʂɂ͋Cz܂傤BsVsł邱Ƃ΂Ȃ̐g̔\͂͂قǍ܂񂪁ASNɂ킽킢̌oςł邽ߗlXȋZ\ɗD܂B@̈K\łAȂ͈̑̂؂̕ϗe󂯕tȂߕϐg@̎gp͂ł܂BȂ͐琔SN̐ɂOĂAxAbvɂ͑̌olKvłB܂̂тɃXRA啝Ɍ܂B"},

	{TRUE,"@H",CLASS_YUUKA,RACE_DAIYOUKAI,ENTRY_KAEI,SEX_FEMALE,
	"Ȃ͋͂ȗdłBԂ炩\͂܂퓬Ŕ\͂gp邱Ƃ͂قƂǂȂAɍd͂Ɛg̔\͂œG|܂Bɍŏ狭͂ȕĂ邽߁A킢Ō邱Ƃ͂قƂǂȂł傤B͋ɂ߂ĒxAXRA啝ɉ܂B"},
	{TRUE,"fBXER[",CLASS_MEDICINE,RACE_ANDROID,ENTRY_KAEI,SEX_FEMALE,
	"Ȃ͖̋uɎ̂ĂĂl`łB܂𓾂Ă炠܂oĂ炸AFXȏɍsČL߂悤ƂĂ܂BȂ͗lXȓł𑀂͂ĂAiɂ͑SĂ̍U͂ȓő܂BȂ̑̂͗闖̓łŖĂAłzđ̗͂Ɩx񕜂邱Ƃł܂Aʏ̗dl`ƈقȂ薂Hɂ邱Ƃł܂BȂ̏Ȑg̔\͕͂}łBʂ̐ɑ΂Ă͗Lɐ킦܂ł̌ȂGɂ͋킷邱Ƃł傤Bol𓾂邱ƂłȂ͂ȑ邱ƂɂăxAbv܂B"},
	{TRUE,"ˁ@",CLASS_KOMACHI,RACE_DEATH,ENTRY_KAEI,SEX_FEMALE,
	"Ȃ͎Or̐őDĕ炵Ă鎀_łB΂ΎdoėlXȂƂɎ˂݂܂B𑀂Ƃ֗Ȕ\͂Ae|[gn̓Z[Ă܂BHg萶҂ꌂœ|Ȃǎ_炵ZĂ܂BiłlGfPɂ͓オ܂B"},
	{TRUE,"lGfPE}UihD",CLASS_EIKI,RACE_DEITY,ENTRY_KAEI,SEX_FEMALE,
	"Ȃ͌zS腖lłB腖ɂȂO͂nlłB͂Ƃ\͂A̔\͂ɂQ[ɂđSẴLN^[̍sɗւȂȂ܂B܂Ȃ͐lقƂɓǍَȐ_ĂA鐸_U𖳌܂BȂ́̕u̖_vƌĂ΂łBG̃xقǈЗ͂オAlƂ̈ꌂ瓦邱Ƃ͂ł܂BɂlXȋ͂Ȕ\͂܂A͒xXRA啝ɉ܂B"},

	{TRUE,"H@×t",CLASS_SHIZUHA,RACE_STRAYGOD,ENTRY_HUUZIN,SEX_FEMALE,
	"Ȃ͍gtƗt̐_lłBȂMSɐM҂͂قƂǂ܂B~ŁACU󂯂Ə_[W傫Ȃ܂BؚȊO̊ɂȂ̐g̔\͍͂AɊiŐ킢܂Bϋv͂͂Ȃ߂ŁAMقǂ̓Z܂BȂ̑IȐ퓬\͂͂̕ӂ̗dȉłA`𑱂lXȌoςłƂ͐VȐMlđ啝Ƀp[Abv邩܂B"},
	{TRUE,"H@q",CLASS_MINORIKO,RACE_STRAYGOD,ENTRY_HUUZIN,SEX_FEMALE,
	"Ȃ͎̏Hi_lłBlXɍD_lłAL_ɂ͑ɗLȐ_l̂łȂg͂܂M𓾂Ă܂BIȋCȂ_lōr͋łB̈słnے劙̈͂ȂɍI݂łBR@Kł܂AR@͂U͂Ɍ̂łx̓eo傷Kv܂B܂Ȃ͓~ȂߗCUɂĂ傫ȃ_[W󂯂܂BIȐ퓬\͂͒߂łA`ʂĐVȐM𓾂ƑSʂ̐_iɕω邩܂B"},
	{TRUE,"R@",CLASS_HINA,RACE_DEITY,ENTRY_HUUZIN,SEX_FEMALE,
	"Ȃ͖_łB_ƌĂ΂Ă͂܂Ԃ͗dɋ߂悤ŁAj׍U_łBzĂ̐gɗߍޗ͂Ă܂B͎ꂽACezG׈ȍU󂯂邱Ƃŗ܂AZŏGɉt邱ƂŌ܂BȂ͖܂Η܂قǋȂ܂A܂߂Ƌɂ߂Ċ댯ȎɂȂ̂Ŗ̗ʂɂ͏ɋCzĉBȂ͐lĂXł̔ɋJ܂Al̐l`̔Ŋ􋖂̎𓾂邱Ƃł܂B܂Ȃ̓}CiXʂigɂĐ킢邱Ƃł̑ĩ}CiXʂł蔽]邱Ƃł܂B͋ɂ߂čłB"},
	{TRUE,"͏@ɂƂ",CLASS_NITORI,RACE_KAPPA,ENTRY_HUUZIN,SEX_FEMALE,
	"Ȃ͉͓̃GWjAŁAʏ̃GWjAƓlɑgċ@B̊J\łBJ@Bi[郊bN̗eʂ͏Ȃ߂łȂɓZƂēƎ̋@Bgp\ɂȂ܂BƎ̋@B͊JȂĂ背xŎgp\ɂȂAGlM[͐n`ŏ[U\łBʏ̃GWjA̋@BU͂Ɍ܂RXg̖ʂł͗LłB܂bN̒ɂ͗lXȋߐڐ퓬pM~bNd܂Ăʏ̃GWjAɔ׊i\͂߂łB𑀂\͂Ă肢̐U̓ZK܂B"},
	{TRUE,"@",CLASS_MOMIZI,RACE_HAKUROU_TENGU,ENTRY_HUUZIN,SEX_FEMALE,
	"Ȃ͗d̎Rŕ炷[̏VłB痢̔\͂AmTɊւĂ͔єėDĂ܂BȂĂÂ_WʂAx㏸ƖӖڂɑ΂ϐlAɎӂ̂G펞m悤ɂȂ܂B퓬\͂͂}łBȂAȂ͓݈ȊO̓h𑕔ł܂B"},
	{TRUE,"˖ہ@",CLASS_AYA,RACE_KARASU_TENGU,ENTRY_HUUZIN,SEX_FEMALE,
	"Ȃ͌z̏̐VƂɏMR₷VłBڂɔV̒łȂÊłBSLN^[ō̉ƕqAL}bvł͈ړxɑ؂̏P󂯂܂BڋߐɋA_邩R̖@̈K\ŁAɕ֗ȓZ𑽂\^łB͂Ȃx߂ŃXRA啝ɒቺ܂B"},
	{TRUE,"J@c",CLASS_SANAE,RACE_DEMIGOD,ENTRY_HUUZIN,SEX_FEMALE,
	"Ȃ͕̐_Ɏd_EŁAj(͂ӂ/ق)ƌĂ΂܂BMO̐E_lƋɌzւƈڂZł܂BȂg_̌ĂAX`pŋ͂ȊՂN܂B̂߂ɂ͐^[ꍇɂĂ͐\^[̒rKvłBG̓ǂ݂ĉrȂ҂Ȃǐ헪Iȗ肪v邱Ƃł傤BȂ̐g̔\͕͂ʂ̐lԂƕς炸Ae͂قǓӂł͂܂B"},
	{TRUE,"@_ގq",CLASS_KANAKO,RACE_DEITY,ENTRY_HUUZIN,SEX_FEMALE,
	"Ȃ͐M̎O̐E_ЂƌzֈڏZĂ_lŁAVVnŐVȐM𓾂悤Ɛ͓IɊĂ܂BȂ̏Ղ̐퓬\͕͂}łÂGł|тɐMW܂ĂȂ͂ǂǂ񋭂Ȃ܂Bɓ̏@̑\Iȑ݂|Ƒ啝ɐMW܂AVȑϐ𓾂邱Ƃ܂BŏIIɂ͑ςȋɂȂ܂A͒xXRA啝ɒቺ܂B"},
	{TRUE,"k@zKq",CLASS_SUWAKO,RACE_DEITY,ENTRY_HUUZIN,SEX_FEMALE,
	"Ȃ͂ēy̐_X𑩂˂鋭Ȑ_iłA݂͐_Ђ̌oc_ގqɔCċCyȐ_l𑗂Ă܂BzM_̗͂؂đn𑀂ZAdpS̈sgłAɔȂɂȂ܂B̗͐̂͂ĂMPႭ@Z̎gpɋJ܂AlԌn̓G|ĊF狰MPől㏸܂BIɂ͋ɂ߂ċ͂ł͂ȂxXRA啝ɒቺ܂B"},

	{TRUE,"LX",CLASS_KISUME,RACE_YOUKAI,ENTRY_TIREI,SEX_FEMALE,
	"Ȃ͒ޕrƂ̗dŁAN̓ɗ邱ƂȂ̐błB̒ɓĂAɂ͉ȊO̕𑕔łÂs\łBȂ̊iU͏󂩂̗łBU񐔂͏1łЗ͍͂AĂ鉱vȂ̂ƂɈЗ͂ˏオ܂Bяオ邱Ƃɂ藎ÜЗ͂啝ɑZ܂B"},
	{TRUE,"J@}",CLASS_YAMAME,RACE_YOUKAI,ENTRY_TIREI,SEX_FEMALE,
	"Ȃ͓yw偂̗dłBaC𑀂͂AőϐȂGɍUƑ傫ȃ_[W^邱Ƃł܂B܂gēG̓WQ莩ňړ邱Ƃł܂BȂ̐g̔\͂͗dƂĂ͂}ŁÄȂǂ͂܂蓾ӂł͂܂B"},
	{TRUE,"@pXB",CLASS_PARSEE,RACE_YOUKAI,ENTRY_TIREI,SEX_FEMALE,
	"Ȃ͎i[PłBi肳ꂽ肷邱ƂȂ̗͂ɂȂ܂BG̃x荂ƍU͂㏸Aɂ̓GƍU͂ɒˏオ܂B܂̗͂ĂقǍU͂⑬x㏸܂BقɂZ܂AقƂǂ̗̑͂ĂGقǋ͂ɂȂ悤ȃnCXNȂ̂łBȂ̊bIȐ퓬\͂͒ႢߋG𑊎ɂƂ͊댯`Kvł傤B"},
	{TRUE,"F@EV",CLASS_YUGI,RACE_ONI,ENTRY_TIREI,SEX_FEMALE,
	"Ȃ͋S̎lV̈lɐ鋭ȋSłB̔ނȂrŕs𗝂Ȃ܂ł̔jN܂BȂ͍ō̘r͂܂iȂǂ̋Z\̒bBɂ͂܂苻ȂAȗ͂œG˂邱ƂD݂܂BȂ͏ɕЎɔuĂāAu̕svcȗ͂łނƂł܂B"},
	{TRUE,"Ön@Ƃ",CLASS_SATORI,RACE_YOUKAI,ENTRY_TIREI,SEX_FEMALE,
	"Ȃ͒na̎̊o(Ƃ)dłB҂W܂nɂĂیĂAi͊Oɏo邱ƂȂybgBɈ͂܂ĕ炵Ă܂BȂ͋̑O̖ڂő҂̐Sǂ݁A҂̃gE}hĐ_UAɂ͓ǂ񂾐SۂɍČZ܂B̓Z͐_Ȃɑ΂Ă͑S͂łBȂ̐g̔\͂͗dƂĂ͂ȂႢ̂Ő키Ɛ헪͐TdɑIт܂傤Bxオƕǂ̌̓GmAɍE|ECɑ΂ϐ𓾂܂B"},
	{TRUE,"ΉL@",CLASS_ORIN,RACE_WARBEAST,ENTRY_TIREI,SEX_FEMALE,
	"Ȃ͉ΎԂƌĂ΂鉻LłBi͒na̋ܔMnœĂ܂BɐNĎ̂̂DŁAlł͂Ȃ茙Ă܂B̂邽߂̔LԂĂA̒ɂ̓ACe[ł܂B[ACe͓G̍UŔj󂳂܂񂪈xoȂƎg܂BBTɗDA@KAɔLԂœG瀂čU邱Ƃł܂BΉƒn̍UɑϐAƉΉ̓dϐƋCϐl܂Bj׍Uɑ΂Ă͋ɂ߂ĐƎłB"},
	{TRUE,"GH@",CLASS_UTSUHO,RACE_YOUKAI,ENTRY_TIREI,SEX_FEMALE,
	"Ȃ͒naŃybgƂĕ炷}ȒnGłA@G̐gɎ荞ŔIɃp[AbvA낤ƂjZ𑀂͂ɂ܂B₠Ȃ͖̑̂s̃GlM[̉łB͂ȉuUłAقƂǂ̍UΉM̂ߑϐG肾Ƃ肱邩܂BȂ̖㩉Ȃǂ̋Z\͉ȂׂĒႭAԂďĂȊÔƂ͂قƂǂł܂B܂jZ̐̂߂ɂ͕ИrJĂȂ΂Ȃ炸AO[uƃu[c͂ꂼЕłȂߐ\ቺ܂B"},
	{TRUE,"Ön@",CLASS_KOISHI,RACE_YOUKAI,ENTRY_TIREI,SEX_FEMALE,
	"Ȃ͓ƐSo̗dłBقƂǖĂȈӎɌẑpjĂ܂BǐS̓ɖӎ𑀂\͂𓾂ĂAG͂΂Ζڂ̑Oɂ邠Ȃ܂BG̕sӂċȈꌂƂeՂł傤Bʏ̐_Ȃɑ΂Ă͂̔\͂͌ʂቺ܂BȂ̐_͂Ȃ̂e󂯂܂B"},

	{TRUE,"iY[",CLASS_NAZRIN,RACE_WARBEAST,ENTRY_SEIREN,SEX_FEMALE,
	"Ȃ͔V̎g̗dlŁA݂͖@ɋ͂˂̋߂ŕ炵Ă܂B_EWO̖ŕT͂̕łBɑlꌂEȂǂ̏ZABs▂gpӂłB܂Ȃ͔V̎gł邽ߗdłɂ炸j׍U_Ƃ܂BȂ̑̊i͂ȂnŁA퓬\͂͂ɂƂ͌܂BȂTdȗ肪v܂ł댯͑傫ł傤B"},
	{TRUE,"Xǁ@P",CLASS_KOGASA,RACE_TSUKUMO,ENTRY_SEIREN,SEX_FEMALE,
	"Ȃ͓PƌĂ΂P̕tr_łBɎPȂ̖{̂ŁAƂ͂ł܂BȂ͂̎PU񂵂Đ키ƂɂȂ܂BPȂ̂Őɂ͋̂ł_ƉΉ͋łBtr_̎푰킹ƁAł͎_ƉΉƔjׂƗ򉻂_ƂƂɂȂ܂BxオƎPp[AbvA͉P邩܂Bʏ̕tr_ƈႢŐHۂ邱ƂłAN邱ƂŊ͂𓾂܂B܂Ȃ͒b肪ӂŁA̖ڗ̕邱Ƃł܂B"},
	{TRUE,"_@",CLASS_ICHIRIN,RACE_YOUKAI,ENTRY_SEIREN,SEX_FEMALE,
	"Ȃ͓gƂdŁA_̂悤Ȏṕu_RvƌĂ΂Ƃꏏɂ܂BiUƂAȂ̑ɉ_RUs܂B_R̋Ȍɂ͂Ȃ̈З͂҂łAÜЗ͂͂قƂǂȂ̘r͂Ɋ֌WȂ܂܂BdƍUɍ肪ô͒ʏ̊iƓłB_R͗ꂽꏊɍU背[U[ȂǕ֗ȓZAɃs`̂Ƃɂ͂΂΂ȂĂ܂BȂ͉_RƂ̘AĝߏɗJĂKvA肪ǂƍU͂啝ɒቺ܂B"},
	{TRUE,"с@",CLASS_MURASA,RACE_YOUKAI,ENTRY_SEIREN,SEX_FEMALE,
	"Ȃ͏MHŁA͐lMꂳ邱ƂłB̂鏊ǂɂło܂BHƂ͂Ă̂OŁArIdɋ߂̂Ă܂BɊւ鑽ʂȓZAG̐USɖ邱Ƃł܂B܂̒ł͍ňړłAp[^AɑfUɂGꌂœ|Ƃ܂B肾ƂقƂǂ̍Ui͖͂łBḦȂ̂Ŕj׍U͑̋łB"},
	{TRUE,"Њہ@",CLASS_SHOU, RACE_WARBEAST ,ENTRY_SEIREN,SEX_FEMALE,
	"Ȃ͐lX̋z琶܂ꂽdbłAFXč͖@ŔV̑㗝𖱂߂Ă܂B_iĂ邽ߗdłɂ炸j׍Uɑϐ܂Bg̔\͂Ab̉sqȊoAȂǂ̋Z\DGłB󂪏W܂\͂肠܂莑ɋJ܂BɍŏV̕󓃂Ă肱gċ͂ȉuU\łBS̓IɌ̂Ȃ\͂̍łAE܂ڂɔĕp̐S͑S܂B撣Ēb܂傤B󓃂Ƒ̓ZgȂȂ邽߁A薳Ȃ悤ɋCĉB"},
	{TRUE,"@@",CLASS_BYAKUREN,RACE_MAGICIAN,ENTRY_SEIREN,SEX_FEMALE,
	"Ȃ͐Nɂ킽镕󂩂ꂽ͂Ȗ@głBVɋA˂铿̍młA݂͖@̎IȎw҂ƂďCsƕzȂ炵Ă܂BȂ̓Z͋͂Ȑg̋@ɂeŁAǂGXƉ|Ƃłł傤B̖@؂Ƒłア̂Ŗf͋֕łBIɋɂ߂ċ͂łAXRA͑啝ɒቺ܂B"},
	{TRUE,"b@ʂ",CLASS_NUE,RACE_DAIYOUKAI,ENTRY_SEIREN,SEX_FEMALE,
	"Ȃ͂ĕ|ɊׂꂽƉ\dłBɑ΂Ff킹\͂AG̐_֍Ud|̂ӂłBȂĂ_WʂƂłAÂł͓G甭Â炭Ȃ܂B܂Ȃ͎̐̂BĉɕϐgĂ܂Bϐg͋͂łGɐ̂jĂ܂Ƃ̓GtA炢ȂȂ܂ŕϐg܂B邢ꏊɂ茫Gł肠Ȃ̋ȑ̍UꂽƂ͐̂j₷悤łBIɋԂ񐬒͒xXRAȂ߂łB"},

	{TRUE,"HJ@q",CLASS_KYOUKO,RACE_YOUKAI,ENTRY_SHINREI,SEX_FEMALE,
	"Ȃ͗HJi}rRj̗dŁÂ悤ȎƐKĂ܂B疽@Ő^ʖڂɏCsɗވŁA̓pNbNɌX|ӊOȈʂ܂B吺ƃIEԂZŁAœGNOƂG̏@^邱Ƃł܂BxオƍUSɖAG̃{gn@𔽎˂邱Ƃł܂BȂ̐g̔\͂͂قǍȂA{Iɍr͋łB吺Ő키߉Bs̋łB"},
	{TRUE,"{Á@F",CLASS_YOSHIKA,RACE_ZOMBIE,ENTRY_SHINREI,SEX_FEMALE,
	"Ȃ͎א跐M̈p̃LV[łB̃PA͖Sł]͊SɕĂ܂BɓŒ܂̂ЂUŐ킢܂BȂ̗̑͂A̗͂̎R񕜂ɂ߂đAɎ͂̏_Hׂđ̗͂񕜂邱Ƃł܂B▂ȂǓgƂ͂ȂׂċłBȂ̐ŕ̂ŐH͑߂Ɏ܂傤B"},
	{TRUE,"跁@M",CLASS_SEIGA,RACE_SENNIN,ENTRY_SHINREI,SEX_FEMALE,
	"Ȃ͓OꂽlłB{IɎ̗~]ƍDS𖞂lĂ܂BwŕǂɌJZ܂Bxオƈړɕǂ@蔲AɃxオƕǂ@炸ɂ蔲悤ɂȂ܂B@̈K\ŁApȂǂ̉ЁXpɓɍK܂B𐶂l̂߁A΂Βn̎hqɑ_܂B"},
	{TRUE,"h@j",CLASS_TOZIKO,RACE_SPECTRE,ENTRY_SHINREI,SEX_FEMALE,
	"Ȃ͖L_qɏ]҂ƂĎdSłBĂ͋͂ȉłA͍݂قƂǏC܂܂ȖS쐶𑗂Ă܂B̂̂ߕǂ𔲂邱Ƃł_WTɗLłBdUӂŁÄ͋|słBg̋sSȂߌC𗚂Ƃł܂B"},
	{TRUE,"@zs",CLASS_FUTO,RACE_SENNIN,ENTRY_SHINREI,SEX_FEMALE,
	"Ȃ͐lSN̖肩ڊo߂ŁAL_q̌œmƂďCs̓X𑗂Ă܂Bl̊ɖ@̈͂܂蓾ӂłȂAɕ̔pƓ̐p킹Ɠ̋ZŐ킢܂B̋Z͂Ȃ܂OɏΈЗ͂͐łB܂藐ƎMオނߏՂ͂܂J肵܂傤BȂ̐g̔\͂͂قǍƂ͂A|ȊÖ͋̕łB܂Ȃ͔pɂ{̎떂Ă邽߁A_WŒn̎hqɏP邱Ƃ܂B"},
	{TRUE,"L@_q",CLASS_MIKO,RACE_SENNIN,ENTRY_SHINREI,SEX_FEMALE,
	"Ȃ͐lSN̎oĕ𐋂_ilłBulԂ𒴂ׂĒvƌقǂ̈|Iȍ˔\܂Bp̎l̖̈@SďKĂAxĂĖ@ĂΊwKȂĂ@g܂BɂZ\ɗDA͂ȓZgADGȑϐAɂȂ܂BSɋ߂łAXRA͋ɂ߂ĒႭȂ܂B"},
	{TRUE,"b@}~]E",CLASS_MAMIZOU,RACE_BAKEDANUKI,ENTRY_SHINREI,SEX_FEMALE,
	"Ȃ͉K̐eŁAd̐głȂŋ߂܂ŊOEɏZł܂BzłXɎЉɗn݁AlXȊ݂ƂɈꖇł܂BȂ͉(΂)ŁAG⎩gDɕϐgēG|M܂B܂AK̔zĂяoēGU邱Ƃł܂Bϐgn̓Z͒m\ƌAzgZ͖͂ɂČʂ傫ς܂B"},

	{TRUE,"킩P",CLASS_WAKASAGI,RACE_NINGYO,ENTRY_KISHIN,SEX_FEMALE,
	"Ȃ͖̌΂ŉ̂̂΂Eĕ炷lłBliŐ퓬\͂͂Ȃ߂łɂƗ͂܂B̓Zo܂@͎g܂BxオƐł̔\͏㏸ɏオAUɑ΂銮SȖƉu𓾂܂BȂAȂ͐lȂ̂ŌC𗚂Ƃł܂B"},
	{TRUE,"Ԕ؊",CLASS_BANKI,RACE_YOUKAI,ENTRY_KISHIN,SEX_FEMALE,
	"Ȃ͂낭̗dŁÂBĐlŕ炵Ă܂B񂪐Lт̂ł͂Ȃ̂痣Ĕԃ^Cv̂낭ŁAɓgڂ烌[U[Ǝɑ|łB̕g̐Ɛ퓬͂̓xAbvŏオA̕ĝ͖{̂F邱Ƃł܂B{̂̐퓬\͂͒Ⴍ͂܂񂪗dƂĂ͂}łBJꏊŕgɉ삳ڍUX^C{ɂȂ܂BRɓK܂ȊŐZ\͒߂łBȂ͎𑕔ł܂B"},
	{TRUE,"@eT",CLASS_KAGEROU,RACE_WARBEAST,ENTRY_KISHIN,SEX_FEMALE,
	"Ȃ͒jzIIJ~ŁAi͖̒|тɏZł܂BrIg̔\͂܂̈͋ŁA{IɊiŐ킢܂B܂ĝȂ͏rqȂ̂̎͂܂pȂقł͂܂BϗeEÍꂩ̗̖̈@KłA@͎g܂񂪈ꕔ̕ϐg@͑哾ӂłB₩ȃOwAŁAމΉEdU͌łB̔ӂɂ͐g̔\͂ɏ㏸A͂ȘTɕϐg\ɂȂ܂Bϐg͑ïꕔ̂őϐɂ͋CtĂB"},
	{TRUE,"\@فX",CLASS_BENBEN,RACE_TSUKUMO,ENTRY_KISHIN,SEX_FEMALE,
	"Ȃ͌Âi̕tr_łBŎgt邱ƂłAlXȌʂytłĐ킢܂BɓG𒼐ڍU悤ȉyD݁Ax̋ߐڐ퓬Ȃ܂B܂@̈K邱Ƃ\łBȂ͖@r݂Ȃłtł܂AאڍU⑕ύXȂǒԎgƂƉtr؂܂B܂t̎זɂȂO[uނ𑕔ł܂BȂ̖{͔̂îߒʏ̐Hł͕𖞂A@̓[U͂zĕ𖞂܂BłӖځAUɑϐ܂jׂƗ򉻍U͂Ȃ̑GłB"},
	{TRUE,"\@",CLASS_YATSUHASHI,RACE_TSUKUMO,ENTRY_KISHIN,SEX_FEMALE,
	"Ȃ͌ÂՂ̕tr_łBŎgt邱ƂłAlXȌʂytłĐ킢܂BɝߎœGf킹悤ȉyD݁Ae͋ł@̈K邱Ƃ\łBȂ͖@r݂Ȃłtł܂AאڍU⑕ύXȂǒԎgƂƉtr؂܂B܂t̎זɂȂO[uނ𑕔ł܂BȂ̖{̂͋Ղ̂ߒʏ̐Hł͕𖞂A@̓[U͂zĕ𖞂܂BłӖځAUɑϐ܂jׂƗ򉻍U͂Ȃ̑GłB"},
	{TRUE,"Sl@",CLASS_SEIJA,RACE_YOUKAI,ENTRY_KISHIN,SEX_FEMALE,
	"Ȃ͔t̍V׋SłB厖NĂqˎ҂ɂȂAz̏ZlSĂǂĂ܂BȂ̐g̔\͂͋ɂ߂ĕnȂ߁AGɓe𒧂ނ͖̂dłBǂɉBĂʂ̓gĐ킢܂Bɂ́uvƁusvcvAǂT_h𗘗p邱ƂŎgp񐔂񕜂܂BɌĂ̓_Wŏ[U邱Ƃł܂Bp퓬\͂Ɍ邽ߍ̎莝œ|GÂɌɂ߂Kv܂B܂Ȃ͋ɓx̔P҂̂߁AlɊӂƐ_ɑŌ󂯂Ĕ\͂ቺ܂B"},
	{TRUE,"@j",CLASS_SHINMYOUMARU,RACE_GREATER_LILLIPUT,ENTRY_KISHIN,SEX_FEMALE,
	"Ȃ͈ꐡ@t̖łA`̑ŏȍƂ̐Ȍp҂łBŏȍƂɊ肢邱ƂŗlXȗLȂƂN܂AƂɉ肤Ǝɉ肦悤ɂȂ܂ň莞Ԃ̏Ƃ̏[UKvłB܂Ƃ̗͂gƗlXȑ㏞邱ƂA傫Ȋ肢łقǋȑ㏞ɂȂ܂B@͎g܂񂪉B▂Ȃǂ̋Z\͍oςނ̂߂łB"},
	{TRUE,"x@",CLASS_RAIKO,RACE_TSUKUMO,ENTRY_KISHIN,SEX_FEMALE,
	"Ȃ͑Ƒ_𕹂͂ȕtr_łBgނƂŕ̗͂oăp[AbvAɕ̔\͂ɉ@uXȂǂ𔭓邱Ƃł悤ɂȂ܂BŒA[eBt@Ng͌̕邹̔\͂̑ΏۂɂȂ܂B܂Ȃ͊y̕tr_Ȃ̂ŁAtėlXȌʂytł邱Ƃł܂B肾łȂłtł邽߁AʏUACe̎gpȂǂŉyf܂BIɋɂ߂č\͂rI߂łAXRA͑啝ɉ܂B"},

	{TRUE,"",CLASS_SEIRAN,RACE_GYOKUTO,ENTRY_KANZYU,SEX_FEMALE,
		"Ȃ͌hĂn㒲uC[OBv̈łB{̔CɂĂATƏeӂłBȂَ͈eۂ΂ƂłAeɊւZK܂BZ̎gpɂ͎ɒm\p܂Bڋߐ\́AJȂǂ̋Z\͂}łBՈȍ~؂蔲ɂ͋͂ȏeɓKvł傤B"},
	{TRUE,"",CLASS_RINGO,RACE_GYOKUTO,ENTRY_KANZYU,SEX_FEMALE,
		"Ȃ͌hĂn㒲uC[OBv̈łBǗ̔CɂĂATƒ\͂ɗDĂ܂BȂ̊{IȐ퓬\͕͂}łAcqHׂΐHׂقǃp[AbvƂsvcȔ\͂Ă܂BƂƂɂ͐ɂ݂ȂcqHׂĐ؂蔲܂傤BcqH׉߂Č邱Ƃ͂܂B܂_W̒Tɂ͎XԂxƂĒcq͂Ă܂B"},
	{TRUE,"h~[EXC[g",CLASS_DOREMY,RACE_YOUKAI,ENTRY_KANZYU,SEX_FEMALE,
	"Ȃт̗dŁAl̈DłBʏ̐Hł͂قƂǉh{𓾂ꂸA_WhȂǂŖĂ҂̖Hׂĕ𖞂܂BG𖰂点萸_UZKA܂@̈K\łBȂ̐퓬\͍͂Ƃ͌܂񂪁AȂ̖{͖̂̐EŔ܂B_Wu̐Ev̒ł͔\͂㏸ēZ啝ɋAɓȋZœG|Ƃł̓Gɕϐg邱Ƃł܂B"},
	{TRUE,"H_@TO",CLASS_SAGUME,RACE_LUNARIAN,ENTRY_KANZYU,SEX_FEMALE,
	"Ȃ͌̓s̏dŁAzɃIJg{lłBȂɂČƖ]ޖ]܂Ɋւ炸̎Ԃt]܂BǂނƏĂ邱ƂƑSႤƂN̂ŋCtĂBȂ͈؂q₷錎̖Ȃ̂q܂ލU͑̋łB"},
	{TRUE,"NEs[X",CLASS_CLOWNPIECE,RACE_FAIRY,ENTRY_KANZYU,SEX_FEMALE,
	"Ȃ͒n̏_ɎddłA̗Fl̗͂ŁuvĊoA͂̉ƂȂ܂B̂Ȃ͊Sɗd̘gOꂽȗ͂Ă܂A̗͂͂܂ňꎞIɗ^ꂽ̂łAꂽ̗͓͂xƉ񕜂邱Ƃ͂܂BSɑ̗͂ȂȂƋAĂӂĐQĂ܂Q[I[o[łBȂ͒n̏gĂAgƂŎ⒇ԁAɂ͎͂̓G킹苭邱Ƃł܂B"},
	{TRUE,"",CLASS_JUNKO,RACE_DEITY,ENTRY_KANZYU,SEX_FEMALE,
	"Ȃ͌Â͂ȐłBȂ̊jȂ̂́ÂɕQ𐋂čȂȂȑłB݂̖̏̑͌ɌĂAނƒ@ׂɂ͂܂BȂ͖ĎĂ{Iȗ͂ێėpuvƂ\͂A̔\͂ɂėlXȊzVOȂƂ𐬂邱Ƃł܂B"},
	{TRUE,"wJ[eBAEsXY",CLASS_HECATIA,RACE_DEITY,ENTRY_KANZYU,SEX_FEMALE,
	"Ȃ͒nƌƈيE̒n𓝂ׂ鏗_łBꂼ̒nɂꂼ̂ĂA`Ăĝ𑼂̐ĝƌコ邱Ƃł܂BiAiAHPAMPAˑRψفAg閂@̈͑̂ƂɕʁXɂȂ܂BȂ̓̏ɂ͑傫ȋ̂ڂĂAwbg𑕔ł܂B"},

	{TRUE,"G^jeBo",CLASS_LARVA,RACE_FAIRY,ENTRY_TENKUU,SEX_FEMALE,
		"Ȃ̓AQn̗dŁAƍĐƕϑ(wI)̋ł܂B̔\͈͂ȂقǂɒႢ̂łƂĂAɏ]Ĕ\͂啝ɏ㏸lXȓˑRψقl܂BȂ͂ˑRψقĂĐ\͂Ȃ̂ŁA̕sȐݔ\͂Ɋp邩܂BȂ͔͂ȗd̂߁AȂ̖`͂Ȃ̋J邱ƂɂȂł傤B"},
	{TRUE,"c@lm",CLASS_NEMUNO,RACE_YOUKAI,ENTRY_TENKUU,SEX_FEMALE,
		"Ȃ͗d̎RœƎ̐cގRWłB̓꒣r炷҂ɂ͗e͂܂B_W̒ŒNȂ̓꒣ɂ邱ƂłAœG}ƂɂȂ̗͍͂ł܂B꒣肩oĂƂ̂Ȃ͂قǋ킯ł͂Ȃ̂ŁAGnɍUߍ܂𓾂Ȃ󋵂ւ̑Ώ͋łB"},
	{TRUE," ",CLASS_AUNN,RACE_WARBEAST,ENTRY_TENKUU,SEX_FEMALE,
		"Ȃ͍łB_Ђ₨ɏɏZݒĉAȂ삵Ă܂BȂ̂ő̏blقǑf܂񂪑̂vŔj׍U_Ƃ܂B܂p̐S͎Ă܂BȂ̓ɂ͑傫ȊpĂAgċ͂ȍU邱Ƃł܂̑ɊԂ邱Ƃł܂B"},
	{TRUE,"c ",CLASS_NARUMI,RACE_MAGIC_JIZO,ENTRY_TENKUU,SEX_FEMALE,
		"Ȃ͖@̐X̖͂Ő𓾂ēonłBŐ~ς̎gƍlĂ܂AosłقƂǐXo悤Ƃ܂BȂ̖͐@łӂƂĂA̗͂ɂqłBlꂽXŕɑςĂߗCUɋϐ܂B"},
	{TRUE,"qc T",CLASS_SATONO,RACE_DEMIGOD,ENTRY_TENKUU,SEX_FEMALE,
		"Ȃ͔_u Bށv̔zŁAȎd͒N̔wŗx苶ƂłBȂ̓X^[XJEgĔwŗx邱Ƃł̃X^[̐_͂邱Ƃł܂Bwŗx邠Ȃ͂̃X^[ɋR悵Ă̂ɋ߂ɂȂ܂Bn\ȃX^[łȂĂwŗx邱Ƃł܂B͂ȃX^[XJEgłΈCɐ͂邱Ƃł傤BȂg̐퓬\͂͂قǍ܂B" },
	{TRUE,"c ",CLASS_MAI,RACE_DEMIGOD,ENTRY_TENKUU,SEX_FEMALE,
		"Ȃ͔_u Bށv̔zŁAȎd͒N̔wŗx苶ƂłBȂ̓X^[XJEgĔwŗx邱Ƃł̃X^[̐g̔\͂邱Ƃł܂Bwŗx邠Ȃ͂̃X^[ɋR悵Ă̂ɋ߂ɂȂ܂Bn\ȃX^[łȂĂwŗx邱Ƃł܂B͂ȃX^[XJEgłΈCɐ͂邱Ƃł傤BȂg̐퓬\͂͂قǍ܂B"},
	{FALSE," B",CLASS_DUMMY,RACE_DUMMY,ENTRY_TENKUU,SEX_FEMALE,
		""},

	{TRUE,"ɐ@",CLASS_SUIKA,RACE_ONI,ENTRY_TASOGARE,SEX_FEMALE,
	"Ȃ͌zŒ炭YĂȋSłBȂōNX̐g̔\͂iƓ݊𓾈ӂƂ܂BƑa𑀂\͂A剻薶ɂȂACeW߂ȂǑʂȋZK܂BȂ͂ł|܂񂪁A߂Ɣ\͂啝ɒቺĂ܂܂B"},
	{TRUE,"i]@ߋ",CLASS_IKU,RACE_YOUKAI,ENTRY_TASOGARE,SEX_FEMALE,
	"Ȃ͗{̎gƌĂ΂dłB_lɎdAi͉_C̒Yĕ炵Ă܂BCǂޔ\͂A_W̊댯xACẻlf@G̍U󂯗Ƃł܂B܂𑀂邱ƂӂłB▂@͂ȂɐFXg܂AH߂piłӂƂ܂BȂAH߂͓Vl̎xî߉ꂽςȂƂɂȂ܂B"},
	{TRUE,"ߖ@Vq",CLASS_TENSHI,RACE_TENNIN,ENTRY_TASOGARE,SEX_FEMALE,
	"Ȃ͂Ƃ閼ƂVlƂȂƂłɓVlɂȂlԂŁAfsVEŕsǓVlƌĂ΂Ă܂BȂ͖̎͂{ŁAnɓlXȋ͂ȓZgȂ܂BȂ̈p͓̕VE̕󌕂łužvłBꕔ̓Z͂̌𑕔ĂȂƎg܂B"},
	{TRUE,"`@",CLASS_KOKORO,RACE_TSUKUMO,ENTRY_TASOGARE,SEX_FEMALE,
	"Ȃ͉ʂ̕tr_ŖʗCƂĂ΂܂BȂ̖{̂͐NȏOɍȐlɍꂽZ\Z̖ʂŁÂ߂̕ӂ̕tr_ɔז炩ɋ͂܂B鎖ɖLȊ(\̂܂)\悤ɂȂA݂͊肳邽߂̏Csƌ̓X߂Ă܂Bl̊𑀂͂AGꂳ荬邱ƂӂłBGȋZœ|Ƃł̓G̊\ʂ쐬A𑕔Đ키Ƃł̓G̋ZČ邱Ƃł܂BȂ͒ʏ̓h𑕔ł܂B"},
	{TRUE,"@j",CLASS_SHINMYOU_2,RACE_KOBITO,ENTRY_TASOGARE,SEX_FEMALE,
	"Ȃ͈ꐡ@t̖łA`̑ŏȍƂ̐Ȍp҂łB͋ԕsvcȂoɏĐ킢܂BȂ͐l̕G炢̐gȂlȂ̂ŁA̔\͂͋ɂ߂ĕnŏd̂𑕔ł܂BZ\ƕqAėlXȃgbL[ȓZgȂĊHJ܂傤B"},
	{TRUE,"F@俎q",CLASS_SUMIREKO,RACE_JK,ENTRY_TASOGARE,SEX_FEMALE,
	"Ȃ͊OȄqŒ\͎҂łBDS猶z֌Ejd|悤Ƃ̂̌z̐ldɑj~A͊OEŖĂԂɖ̒Ōz֖KĂ܂BmR}hʏEƂ̒\͎҂Ɠl̒\͂gpłAJR}hƎ̒\͂gpł܂BƎ̔\͓͂Ɋւ̂UɌĂ܂BAȂ̐g̔\͕͂ʂ̐lԂ̂̂ŕ̐SS܂B̂ߒʏEƂ̒\͎҂e킪łB"},

	{ TRUE,"ː_@",CLASS_JYOON,RACE_DEITY,ENTRY_TASOGARE,SEX_FEMALE,
		"Ȃ͉ua_łBACe⏕@ȂǑ̂̂G͂Ȃ̉aHƂȂ邱Ƃł傤B̂Ȃ͗̎w8̎wւ𑕔邱Ƃł܂Awւ̃p[^͔Ă܂܂BȂ͊iUƂɑ҂D悷邱ƂłA܂ɂ͒DhɎUȂ키Ƃł܂B" },
	{ TRUE,"ː_@",CLASS_SHION,RACE_DEITY,ENTRY_TASOGARE,SEX_FEMALE,
		"Ȃ͒NnR_łBςȎ؋ĂAIɓXX̎{݂𗘗p邱Ƃł܂BɎĂȂi͑ɍꔼقǂŖvĂ܂܂BȂ_Wŕʂɐ키Ƃ͋ɂ߂čŁAuS߈ˁv̓ZgăX^[̑̂Đ키ƂɂȂ܂BȂ͎͂ŋNsK̐gɒ~ςĂAߍ񂾕sKJĂƂĂȂȁuX[p[nR_vɕϐg邱Ƃł܂B" },

	{TRUE,"̎Od",CLASS_3_FAIRIES,RACE_FAIRY,ENTRY_OTHER,SEX_FEMALE,
	"Ȃ͌̎OdƌĂ΂Olg̗dłB	wTj[~Nx͌܂\͂Awi`Chx͉\͂AwX^[Tt@CAx͎͂̐T\͂܂B	OlꏏɃ_Wɒ݁AOl킹ĕ2A1A1AhANZT8܂ő\łBʂ̑i͍ő3܂łƂȂ܂B	񓁗ߐځEˌ퓯̃yieB͔܂B"},
	{TRUE,"Tj[~N",CLASS_SUNNY,RACE_FAIRY,ENTRY_OTHER,SEX_FEMALE,
	"Ȃ́u̎OdvƌĂ΂dOlg̈lŁAz̗dłBCōs͂Ȁ̎vő̓l񂵂܂BȂ͌܂\͂ĂAGeŘf킹ōU邱Ƃł܂B퓬ɂĂ͔rIeɌĂAѓ̈͋łBȂ͔͂ȗd̂߁AȂ̖`͂Ȃ̋J邱ƂɂȂł傤B"},
	{TRUE,"i`Ch",CLASS_LUNAR,RACE_FAIRY,ENTRY_OTHER,SEX_FEMALE,
	"Ȃ́u̎OdvƌĂ΂dOlg̈lŁA̗dłBdɂ͒AÂɖ{ǂŉ߂ƂD݂܂BȂ͎͂̉\͂ĂA@̉rWQ邱Ƃł܂B퓬ɂĂ͓e͂܂蓾ӂł͂ȂA@ZȂǂDĂ܂܂키Kv܂BƂǂ]ŕ𗎂Ƃ̂ŋCtĂBȂ͔͂ȗd̂߁AȂ̖`͂Ȃ̋J邱ƂɂȂł傤B"},
	{TRUE,"X^[Tt@CA",CLASS_STAR,RACE_FAIRY,ENTRY_OTHER,SEX_FEMALE,
	"Ȃ́u̎OdvƌĂ΂dOlg̈lŁǍ̗dłBsNƂ͂܂ȂAق̓l̂yɌĂ܂B(댯Ɛ^ɓ܂B)Ȃ͋߂̐̏ꏊT\͂ĂAxオƊmł̂̎ނ͈͂܂B퓬ɂĂ͓e͋ŁA≓uUA㩂ȂǂgĐ키Kv܂BȂ͔͂ȗd̂߁AȂ̖`͂Ȃ̋J邱ƂɂȂł傤B"},
	{TRUE,"؁@ؐ",CLASS_KASEN,RACE_SENNIN,ENTRY_OTHER,SEX_FEMALE,
	"Ȃ͓B𓱂ƂgƂVĂ̐lłBg肱Ȃ\͂ɒĂ܂BVĐl̊ɂȂٗlɐg̔\͂AȂwbg𑕔łAȂj׍U_łBɕтĂE͂̔߂ꂽ͂Ă܂B"},
	{TRUE,"PC@͂",CLASS_HATATE,RACE_KARASU_TENGU,ENTRY_OTHER,SEX_FEMALE,
	"ȂV̐VL҂ŁA˖ەƂ̓Co֌WłBV̊ɂ͂qɌ܂Oʂ̔\͂Ă芴mTɗD܂Bڋߐ͎ˌɓKAEÍE\̂ꂩ̗̖̈@xK\łB"},
	{TRUE,"Ȍ@LP",CLASS_TOYOHIME,RACE_LUNARIAN,ENTRY_OTHER,SEX_FEMALE,
	"Ȃ̖͌Ƃ̕PŁA˕P̎ołBCƎRq͂AK͂ȏԑDɍs܂Br͋ł̍ŐVLĂA݂̓GȂ܂Ƃ߂Đ΂Ƃł܂B	Ȃq̖łAlXȎ׈ȍUő_[W󂯂Ă܂܂B"},
	{TRUE,"Ȍ@˕P",CLASS_YORIHIME,RACE_LUNARIAN,ENTRY_OTHER,SEX_FEMALE,
	"Ȃ̖͌Ƃ̕PŁALP̖łBS̐_̐gɍ~낷͂A_l̗͂В[sg܂B̖hq̎włAڋߐ̋Z\zĂ܂BȂq̖łAlXȎ׈ȍUő_[W󂯂Ă܂܂B"},
	{TRUE,"CZ",CLASS_REISEN2,RACE_GYOKUTO,ENTRY_OTHER,SEX_FEMALE,
	"Ȃ͌̓ełB݂𝑂ɂȂĒnɓo܂ǍFXČ̖hq̈ɔ[܂܂B퓬ɊւZX͂܂ǂȂ悤łAɂ͖ڂɂ~܂ʏrqȓ܂B"},
	{TRUE,"{@",CLASS_KOSUZU,RACE_HUMAN,ENTRY_OTHER,SEX_FEMALE,
		"Ȃ͐l̑ݖ{̖ŁA镶ǂ݉\͂Ă܂B炪Mׂ^߁A鑠̏iɋl߂ēXяo܂BȂg̐퓬\͂͂ƂĂ̊ŐЂɑ΍Rł悤Ȃ̂ł͂܂BȂ̖`͉ߍȂ̂ƂȂł傤B"},
	{TRUE,"NEs[X",CLASS_VFS_CLOWNPIECE,RACE_FAIRY,ENTRY_OTHER,SEX_FEMALE,
		"Ȃ͒nog̗dłBÖٕςŏdvȓȂǍ͎傩̖󂯂Ēnŕ炵Ă܂BdłȂnœpقǂ̗͂Ă܂A̒g͕ʂ̗d݂łBȂ͎ɎŐlX킹邱ƂłA܂nogĉΉƒn̑Uɑ΂ϐ܂B" },

};

//Ex[hɌȂĂEƂ̃XRA{ɕ␳(%PʂŃXRA{ɏ悸)
void extra_mode_score_mult(int *mult, int class_idx)
{
	int mod;

	if(!EXTRA_MODE) return;

	switch(class_idx)
	{
	case CLASS_WARRIOR:
		mod = 90;
		break;
	case CLASS_MAGE:
	case CLASS_HIGH_MAGE:
		mod = 120;
		break;

	case CLASS_MINDCRAFTER:
		mod = 90;
		break;
	case CLASS_ARCHER:
		mod = 120;
		break;
	case CLASS_MAGIC_EATER:
		mod = 80;
		break;
	case CLASS_ENGINEER:
		mod = 150;
		break;
	case CLASS_CHEMIST:
		mod = 150;
		break;
	case CLASS_CAVALRY:
		mod = 110;
		break;
	case CLASS_TSUKUMO_MASTER:
		mod=125;
		break;
	case CLASS_SH_DEALER:
		mod=125;
		break;
	case CLASS_JEWELER:
		mod=150;
		break;
	case CLASS_NINJA:
		mod=90;
		break;
	case CLASS_TEWI:
		mod=120;
		break;
	case CLASS_KOISHI:
		mod=120;
		break;

	case CLASS_MOMIZI:
		mod=70;
		break;
	case CLASS_SEIGA:
		mod = 110;
		break;
	case CLASS_ORIN:
		mod=70;
		break;
	case CLASS_PATCHOULI:
		mod = 120;
		break;
	case CLASS_MEDICINE:
		mod = 120;
		break;
	case CLASS_YUYUKO:
		mod = 120;
		break;
	case CLASS_LILY_WHITE:
		mod=80;
		break;
	case CLASS_CHEN:
		mod=125;
		break;
	case CLASS_NITORI:
		mod=120;
		break;
	case CLASS_SUWAKO:
		mod=150;
		break;
	case CLASS_SEIJA:
		mod=140;
		break;
	case CLASS_RAN:
		mod=60;
		break;
	case CLASS_SUMIREKO:
		mod=75;
		break;
	case CLASS_KANAKO:
		mod=200;
		break;
	case CLASS_CLOWNPIECE:
		mod = 40;
		break;
	case CLASS_DOREMY:
		mod = 150;
		break;
	case CLASS_HINA:
		mod = 160;
		break;
	case CLASS_SAKUYA:
		mod = 60;
		break;
	case CLASS_3_FAIRIES:
		mod = 80;
		break;
	case CLASS_RAIKO:
		mod = 150;
		break;
	case CLASS_RINGO:
		mod = 80;
		break;
	case CLASS_SAGUME:
		mod = 200;
		break;
	case CLASS_SHION:
		mod = 50;
		break;

	default:
		return; //Ȃ
	}

	*mult = *mult * mod / 100;

}

static bool get_unique_player(void)
{
	int i, k, n, cs, os;

	int mode = 0;
	cptr str;
	char c;
	int entry;
	unique_player_type table[12];
	int cnt_table;
	char temp[80*9];
	cptr t;
	char    buf[80], cur[80];
	int mul_exp, mul_score;
	char old_name[32];

	while(1)
	{

		bool ok = TRUE;
		put_str("Ȃ̓oiIłB", 10, 10);
		cs = 0;
		while(1)
		{
			for(n=0;n<ENTRY_MAX;n++)
			{
				if(n == cs) c_put_str(TERM_YELLOW, select_unique_entry[n], 12 + n, 10);
				else put_str(select_unique_entry[n], 12 + n, 10);
			}
			c = inkey();
			if (c == 'Q') birth_quit();
			if (c == 'S') return (FALSE);
			if (c == ' ' || c == '\r' || c == '\n')
			{
				k = cs;
				break;
			}
			if (c == '2' && cs < ENTRY_MAX-1) cs++;
			if (c == '8' && cs > 0) cs--;
			if (c == '?')
			{
				show_help("tbirth.txt#Class");
			}

			if (c >= 'a' && c <= 'a'+ENTRY_MAX-1)
			{
				k = c - 'a';
				break;
			}
		}
		clear_from(10);
		entry = k;

		cnt_table=0;
		for(i=0;i<UNIQUE_PLAYER_NUM;i++)if(unique_player_table[i].entry == entry)
		{
			if(cnt_table == 12)
			{
				put_str("ERROR:get_unique_player()cnt_tablet", 12, 10);
				break;
			}
			table[cnt_table++] = unique_player_table[i];
		}
		if(cnt_table==0)		c_put_str(TERM_L_BLUE, format("iID:%dɒNo^ĂȂ", entry), 8 , 10);

		put_str("Ȃ͒NłH", 10, 10);
		put_str("(D͖ ESCōiI֖߂)", 11, 10);

		cs = 0;
		while(1)
		{
			for(n=0;n<cnt_table;n++)
			{
				if(n == cs)
					c_put_str(TERM_YELLOW, format("%c) %s",('a'+n),table[n].name), 12 + n, 10);
				//HARDȏ
				//
				else if((table[n].class_id == CLASS_RAN || table[n].class_id == CLASS_YUKARI) && difficulty < DIFFICULTY_HARD)
					c_put_str(TERM_L_DARK, format("%c) %s",('a'+n),table[n].name), 12 + n, 10);
				else if(!table[n].flag_fix)
					c_put_str(TERM_L_DARK, format("%c) %s",('a'+n),table[n].name), 12 + n, 10);
				else 
					put_str( format("%c) %s",('a'+n),table[n].name), 12 + n, 10);

			}
			Term_gotoxy(0, 0);
			c = inkey();
			if (c == ESCAPE)
			{
				ok = FALSE;
				break;
			}
			if (c == 'Q') birth_quit();
			if (c == 'S') return (FALSE);
			if (c == ' ' || c == '\r' || c == '\n')
			{
				k = cs;
				if(!table[k].flag_fix)continue;
				//HARDȏ
				//
				if(table[k].class_id == CLASS_RAN && difficulty < DIFFICULTY_HARD) continue;
				if(table[k].class_id == CLASS_YUKARI && difficulty < DIFFICULTY_HARD) continue;
				break;
			}
			if (c == '2' && cs < cnt_table-1) cs++;
			if (c == '8' && cs > 0) cs--;
			if (c == '?')
			{
				show_help("tbirth.txt#Class");
			}

			if (c >= 'a' && c <= 'a'+cnt_table-1)
			{
				k = c - 'a';
				if(!table[k].flag_fix)continue;

				//HARDȏ
				if(table[k].class_id == CLASS_RAN && difficulty < DIFFICULTY_HARD) continue;
				if(table[k].class_id == CLASS_YUKARI && difficulty < DIFFICULTY_HARD) continue;

				break;
			}
		}
		clear_from(10);
		if(!ok)
		{
			continue; //iI܂Ŗ߂
		}

		roff_to_buf(table[k].info, 74, temp, sizeof(temp));
		t = temp;
		for (i = 0; i< 9; i++)
		{
			if(t[0] == 0)
				break; 
			else
			{
				prt(t, 12+i, 3);
				t += strlen(t) + 1;
			}
		}

		if(table[k].race == 255 || table[k].class_id == 255)
		{
			c_put_str(TERM_RED, "ERROR:̃v[[̎푰NXݒ肳ĂȂ", 10, 10);
			inkey();
			return (FALSE);
		}
		if(!class_info[table[k].class_id].flag_only_unique)
		{
			c_put_str(TERM_RED, "ERROR:̃NXɃj[NNXtOݒ肳ĂȂ", 10, 10);
			inkey();
			return (FALSE);
		}

		/*:::OύX*/
		strcpy(old_name, player_name);
		strcpy(player_name, table[k].name);
		put_str("O  :@@@@@@@@@@@@@@@@", 1,16);
		c_put_str(TERM_L_BLUE, player_name, 1, 24);

		/*:::ʊm*/
		p_ptr->psex = table[k].sex;
		sp_ptr = &sex_info[p_ptr->psex];
		c_put_str(TERM_L_BLUE, sp_ptr->title, 3, 15);

		/*:::푰m*/
		p_ptr->prace = table[k].race;
		rp_ptr = &race_info[p_ptr->prace];
		c_put_str(TERM_L_BLUE, rp_ptr->title, 4, 15);

		/*:::EƊm*/
		p_ptr->pclass = table[k].class_id;
		cp_ptr = &class_info[p_ptr->pclass];
		if(p_ptr->psex == SEX_MALE )strcpy(player_class_name, cp_ptr->title);
		else strcpy(player_class_name, cp_ptr->f_title);



		///del m_info폜
		//mp_ptr = &m_info[0];
		if(p_ptr->psex == SEX_MALE)	c_put_str(TERM_L_BLUE, cp_ptr->title, 5, 15);
		else						c_put_str(TERM_L_BLUE, cp_ptr->f_title, 5, 15);



		mul_score = cp_ptr->score_mult * rp_ptr->score_mult / 100;

		extra_mode_score_mult(&mul_score,p_ptr->pclass); 

		mul_exp = cp_ptr->c_exp + rp_ptr->r_exp - 100;

				str = rp_ptr->title;
				c_put_str(TERM_L_BLUE, table[k].name, 3, 40);
				put_str("̔\͒lC", 3, 40+strlen( table[k].name));
				put_str("r m\  p ϋv  o  XRA{", 4, 40);
				if(table[k].race == RACE_ANDROID)
				sprintf(buf, "%+3d  %+3d  %+3d  %+3d  %+3d  %+3d  **** %4d%% ",
					/*::: dl`͌ol␳\Ȃ*/
					rp_ptr->r_adj[0]+cp_ptr->c_adj[0], 
					rp_ptr->r_adj[1]+cp_ptr->c_adj[1],
					rp_ptr->r_adj[2]+cp_ptr->c_adj[2],
					rp_ptr->r_adj[3]+cp_ptr->c_adj[3],
					rp_ptr->r_adj[4]+cp_ptr->c_adj[4],
					rp_ptr->r_adj[5]+cp_ptr->c_adj[5],
					mul_score);

				else
				sprintf(buf, "%+3d  %+3d  %+3d  %+3d  %+3d  %+3d %+4d%% %4d%% ",
					rp_ptr->r_adj[0]+cp_ptr->c_adj[0], 
					rp_ptr->r_adj[1]+cp_ptr->c_adj[1],
					rp_ptr->r_adj[2]+cp_ptr->c_adj[2],
					rp_ptr->r_adj[3]+cp_ptr->c_adj[3],
					rp_ptr->r_adj[4]+cp_ptr->c_adj[4],
					rp_ptr->r_adj[5]+cp_ptr->c_adj[5],
					mul_exp, mul_score);
				c_put_str(TERM_L_BLUE, buf, 5, 40);

		if (!get_check_strict("낵łH", CHECK_DEFAULT_Y))
		{
			Term_clear();
			put_str("LN^[쐬܂B('S'蒼, 'Q'I, '?'wv)", 8, 10);
			put_str("O  :@@@@@@@@@@@@@@@@", 1,16);
			put_str("        :", 3, 1);
			put_str("푰        :", 4, 1);
			put_str("E        :", 5, 1);
			strcpy(player_name, old_name);
			c_put_str(TERM_L_BLUE, player_name, 1, 24);
			continue; //iI܂Ŗ߂
		}
		break;
	}
	put_str("                                                       ", 4, 40);
	put_str("                                                       ", 5, 40);
	return (TRUE);

}



/*:::Olݒp@푰EƌŒ*/
static bool get_outside_player(void)
{
	int i;

	cptr str;
	char c;

	char temp[80*9];
	cptr t;
	char    buf[80], cur[80];
	int mul_exp, mul_score;

	/*:::푰m*/
	p_ptr->prace = RACE_HUMAN;
	rp_ptr = &race_info[p_ptr->prace];
	c_put_str(TERM_L_BLUE, rp_ptr->title, 4, 15);

	/*:::EƊm*/
	p_ptr->pclass = CLASS_OUTSIDER;
	cp_ptr = &class_info[p_ptr->pclass];
	/*:::܂ʂݒ肵ĂȂEƖ͒j*/
	strcpy(player_class_name, cp_ptr->title); 
	c_put_str(TERM_L_BLUE, cp_ptr->title, 5, 15);

	clear_from(10);
	roff_to_buf(class_jouhou[p_ptr->pclass], 74, temp, sizeof(temp));
	t = temp;
	for (i = 0; i< 9; i++)
	{
		if(t[0] == 0)
			break; 
		else
		{
			prt(t, 12+i, 3);
			t += strlen(t) + 1;
		}
	}
	mul_score = cp_ptr->score_mult * rp_ptr->score_mult / 100;
	mul_exp = cp_ptr->c_exp + rp_ptr->r_exp - 100;

				str = cp_ptr->title;
				c_put_str(TERM_L_BLUE, str, 3, 40);
				put_str("̔\͒lC", 3, 40+strlen( str));
				put_str("r m\  p ϋv  o  XRA{", 4, 40);
				sprintf(buf, "%+3d  %+3d  %+3d  %+3d  %+3d  %+3d %+4d%% %4d%% ",
					rp_ptr->r_adj[0]+cp_ptr->c_adj[0], 
					rp_ptr->r_adj[1]+cp_ptr->c_adj[1],
					rp_ptr->r_adj[2]+cp_ptr->c_adj[2],
					rp_ptr->r_adj[3]+cp_ptr->c_adj[3],
					rp_ptr->r_adj[4]+cp_ptr->c_adj[4],
					rp_ptr->r_adj[5]+cp_ptr->c_adj[5],
					mul_exp, mul_score);
				c_put_str(TERM_L_BLUE, buf, 5, 40);

	if (!get_check_strict("낵łH", CHECK_DEFAULT_Y))	return (FALSE);

	put_str("                                                       ", 4, 40);
	put_str("                                                       ", 5, 40);
	clear_from(10);

	return (TRUE);

}

/*
 * Helper function for 'player_birth()'
 *
 * The delay may be reduced, but is recommended to keep players
 * from continuously rolling up characters, which can be VERY
 * expensive CPU wise.  And it cuts down on player stupidity.
 */
/*:::VLN^[*/
///system class race seikaku ŏdv
static bool player_birth_aux(void)
{
	int i, k, n, cs, os;

	int mode = 0;

	bool flag = FALSE;
	bool prev = FALSE;
	bool flag_unique = FALSE;
	bool flag_general = FALSE;
	bool flag_outsider = FALSE;


	cptr str;

	char c;

#if 0
	char p1 = '(';
#endif

	char p2 = ')';
	char b1 = '[';
	char b2 = ']';

	char buf[80], cur[80];


	/*** Intro ***/

	/* Clear screen */
	Term_clear();

	/* Title everything */
#ifdef JP
//	put_str("O  :", 1,26);
	put_str("O  :", 1,16);
#else
	put_str("Name  :", 1,26);
#endif

#ifdef JP
	put_str("        :", 3, 1);
#else
	put_str("Sex         :", 3, 1);
#endif

#ifdef JP
	put_str("푰        :", 4, 1);
#else
	put_str("Race        :", 4, 1);
#endif

#ifdef JP
	put_str("E        :", 5, 1);
#else
	put_str("Class       :", 5, 1);
#endif


	/* Dump the default name */
//	c_put_str(TERM_L_BLUE, player_name, 1, 34);
	c_put_str(TERM_L_BLUE, player_name, 1, 24);


	/*** Instructions ***/

	/* Display some helpful information */
#ifdef JP
	put_str("LN^[쐬܂B('S'蒼, 'Q'I, '?'wv)", 8, 10);
#else
	put_str("Make your charactor. ('S' Restart, 'Q' Quit, '?' Help)", 8, 10);
#endif

	

	while(1)
	{
		char temp[80*9];
		cptr t;
		cptr select_difficulty[5] = {
			"a)EASY",
			"b)NORMAL",
			"c)HARD",
			"d)LUNATIC",
			"e)EXTRA",
		};

		put_str("ՓxIĂF", 10, 10);
		cs = 0;
		while(1)
		{

		for(n=0;n<5;n++)
			{
				if(n == cs) c_put_str(TERM_YELLOW, select_difficulty[n], 12 + n, 10);
				//else if(n == 4 && n != cs) c_put_str(TERM_L_DARK, select_difficulty[n], 12 + n, 10);
				else put_str(select_difficulty[n], 12 + n, 10);
			}
			c = inkey();
			if (c == 'Q') birth_quit();
			if (c == 'S') return (FALSE);
			if (c == ' ' || c == '\r' || c == '\n')
			{
				c = cs + 'a';
			}
			if (c == '2' && cs < 4) cs++;
			if (c == '8' && cs > 0) cs--;
			if (c == 'a')
			{
				difficulty = DIFFICULTY_EASY;	
				break;
			}
			if (c == 'b')
			{
				difficulty = DIFFICULTY_NORMAL;	
				break;
			}
			if (c == 'c')
			{
				difficulty = DIFFICULTY_HARD;	
				break;
			}
			if (c == 'd')
			{
				difficulty = DIFFICULTY_LUNATIC;	
				break;
			}
			if (c == 'e')
			{
				difficulty = DIFFICULTY_EXTRA;	
				break;
			}
			if (c == '?')
			{
				show_help("tbirth.txt#Difficulty");
			}

		}
		clear_from(10);
		roff_to_buf(info_difficulty[difficulty], 74, temp, sizeof(temp));
		t = temp;

		for (i = 0; i< 9; i++)
		{
			if(t[0] == 0)
				break; 
			else
			{
				prt(t, 12+i, 3);
				t += strlen(t) + 1;
			}
		}
		/*
		if( difficulty == DIFFICULTY_EXTRA)
		{
			char tester;
			prt("L[Ă", 0, 0);
			tester = inkey();
			
			prt("", 0, 0);
			if(tester == '@') break;
		}
		else 
		*/
		if (get_check_strict("낵łH", CHECK_DEFAULT_Y)) break;
		clear_from(10);
	}
	clear_from(10);

	/*:::ՓxʂɃIvVݒ肷B̕ϐ̓Z[u[hȂ̂ŁAdungeon.cextract_option_vars()ɓLqKv*/
	switch(difficulty)
	{
	case DIFFICULTY_EASY:
		easy_band = TRUE;
		smart_learn = FALSE;
		smart_cheat = FALSE;
		ironman_nightmare = FALSE;
		ironman_downward = FALSE;
		break;
	case DIFFICULTY_NORMAL:
		easy_band = FALSE;
		smart_learn = FALSE;
		smart_cheat = FALSE;
		ironman_nightmare = FALSE;
		ironman_downward = FALSE;
		break;
	case DIFFICULTY_HARD:
		easy_band = FALSE;
		smart_learn = TRUE;
		smart_cheat = FALSE;
		ironman_nightmare = FALSE;
		ironman_downward = FALSE;
		break;
	case DIFFICULTY_LUNATIC:
		easy_band = FALSE;
		smart_learn = TRUE;
		smart_cheat = TRUE;
		ironman_nightmare = TRUE;
		ironman_downward = FALSE;
		break;
	case DIFFICULTY_EXTRA:
		easy_band = FALSE;
		smart_learn = TRUE;
		smart_cheat = FALSE;
		ironman_nightmare = FALSE;
		ironman_downward = TRUE;
		break;
	}

	{
		cptr select_mode[3] = {
			"a)zŏ͖̒mꂽ҂B",
			"b)z̖ȂZlB",
			"c)zH́H",
		};

		put_str("Ȃ́EEE", 10, 10);
		cs = 0;
		while(1)
		{
			for(n=0;n<3;n++)
			{
				if(n == cs) c_put_str(TERM_YELLOW, select_mode[n], 12 + n, 10);
				else put_str(select_mode[n], 12 + n, 10);
			}
			c = inkey();
			if (c == 'Q') birth_quit();
			if (c == 'S') return (FALSE);
			if (c == ' ' || c == '\r' || c == '\n')
			{
				c=cs+'a';
			}
			if (c == '2' && cs < 2) cs++;
			if (c == '8' && cs > 0) cs--;
			if (c == 'a')
			{
				flag_unique = TRUE;
				break;
			}
			if (c == 'b')
			{
				flag_general = TRUE;
				break;
			}
			if (c == 'c')
			{
				flag_outsider = TRUE;
				break;
			}
			if (c == '?')
			{
				show_help("tbirth.txt#Class");
			}
		}
	}
	clear_from(10);


	//Olpi푰EƌŒj
	if ( flag_outsider && !get_outside_player()) return FALSE;

	/*:::j[NvC[iʁAOA푰AEƌŒZbg)*/
	if (flag_unique && !get_unique_player()) return FALSE;

	//ʐݒ
if(flag_general || flag_outsider)
{

	/*** Player sex ***/

	/* Extra info */
#ifdef JP
//	put_str("ӁFsʁẗႢ̓Q[قƂǉeyڂ܂B", 23, 5);
	put_str("ӁFsʁẗႢ̓Q[قƂǉeyڂ܂񂪁Aȋ͏płB", 23, 5);
#else
	put_str("Note: Your 'sex' does not have any significant gameplay effects.", 23, 5);
#endif


	/* Prompt for "Sex" */
	for (n = 0; n < MAX_SEXES; n++)
	{
		/* Analyze */
		sp_ptr = &sex_info[n];

		/* Display */
#ifdef JP
		sprintf(buf, "%c%c%s", I2A(n), p2, sp_ptr->title);
#else
		sprintf(buf, "%c%c %s", I2A(n), p2, sp_ptr->title);
#endif
		put_str(buf, 12 + (n/5), 2 + 15 * (n%5));
	}

#ifdef JP
	sprintf(cur, "%c%c%s", '*', p2, "_");
#else
	sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif

	/* Choose */
	k = -1;
	cs = 0;
	os = MAX_SEXES;
	while (1)
	{
		if (cs != os)
		{
			put_str(cur, 12 + (os/5), 2 + 15 * (os%5));
			if(cs == MAX_SEXES)
#ifdef JP
				sprintf(cur, "%c%c%s", '*', p2, "_");
#else
				sprintf(cur, "%c%c %s", '*', p2, "Random");
#endif
			else
			{
				sp_ptr = &sex_info[cs];
				str = sp_ptr->title;
#ifdef JP
				sprintf(cur, "%c%c%s", I2A(cs), p2, str);
#else
				sprintf(cur, "%c%c %s", I2A(cs), p2, str);
#endif
			}
			c_put_str(TERM_YELLOW, cur, 12 + (cs/5), 2 + 15 * (cs%5));
			os = cs;
		}

		if (k >= 0) break;

#ifdef JP
		sprintf(buf, "ʂIŉ (%c-%c) ('='IvVݒ): ", I2A(0), I2A(n-1));
#else
		sprintf(buf, "Choose a sex (%c-%c) ('=' for options): ", I2A(0), I2A(n-1));
#endif

		put_str(buf, 10, 10);
		c = inkey();
		if (c == 'Q') birth_quit();
		if (c == 'S') return (FALSE);
		if (c == ' ' || c == '\r' || c == '\n')
		{
			if(cs == MAX_SEXES)
				k = randint0(MAX_SEXES);
			else
				k = cs;
			break;
		}
		if (c == '*')
		{
			k = randint0(MAX_SEXES);
			break;
		}
		if (c == '4')
		{
			if (cs > 0) cs--;
		}
		if (c == '6')
		{
			if (cs < MAX_SEXES) cs++;
		}
		k = (islower(c) ? A2I(c) : -1);
		if ((k >= 0) && (k < MAX_SEXES))
		{
			cs = k;
			continue;
		}
		else k = -1;
		//if (c == '?') do_cmd_help();
		//else 
		if (c == '=')
		{
			screen_save();
#ifdef JP
			do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
#else
			do_cmd_options_aux(OPT_PAGE_BIRTH, "Birth Option((*)s effect score)");
#endif

			screen_load();
		}
		else if(c != '4' && c != '6')bell();
	}

	/* Set sex */
	p_ptr->psex = k;
	sp_ptr = &sex_info[p_ptr->psex];

	/* Display */
	c_put_str(TERM_L_BLUE, sp_ptr->title, 3, 15);

	/* Clean up */
	clear_from(10);
	}
	//푰EƐݒ
	if(flag_general)
	{
	/* Choose the players race */
	p_ptr->prace = 0;
	while(1)
	{
		char temp[80*10];
		cptr t;

		if (!get_player_race()) return FALSE;

		clear_from(10);

		roff_to_buf(race_jouhou[p_ptr->prace], 74, temp, sizeof(temp));
		t = temp;

		for (i = 0; i< 10; i++)
		{
			if(t[0] == 0)
				break; 
			else
			{
				prt(t, 12+i, 3);
				t += strlen(t) + 1;
			}
		}
		if(rp_ptr->flag_nofixed)
		{
			prt("L[Ă", 0, 0);
			(void)inkey();
			prt("", 0, 0);
		}
		else if (get_check_strict("낵łH", CHECK_DEFAULT_Y)) break;

		clear_from(10);
		c_put_str(TERM_WHITE, "                          ", 4, 15);
	}

	/* Clean up */
	clear_from(10);
	put_str("                                                       ", 4, 40);
	put_str("                                                       ", 5, 40);




	/* Choose the players class */
	p_ptr->pclass = 0;
	while(1)
	{
		char temp[80*9];
		cptr t;

		if (!get_player_class()) return FALSE;

		clear_from(10);
		roff_to_buf(class_jouhou[p_ptr->pclass], 74, temp, sizeof(temp));
		t = temp;

		for (i = 0; i< 9; i++)
		{
			if(t[0] == 0)
				break; 
			else
			{
				prt(t, 12+i, 3);
				t += strlen(t) + 1;
			}
		}

		if(cp_ptr->flag_nofixed)
		{
			prt("L[Ă", 0, 0);
			(void)inkey();
			prt("", 0, 0);
		}
		else if (get_check_strict("낵łH", CHECK_DEFAULT_Y)) break;

		c_put_str(TERM_WHITE, "                 ", 5, 15);
	put_str("                                                       ", 4, 40);
	put_str("                                                       ", 5, 40);


	}

	///mod140209 ʂ̏Zl͂ŐEƖς悤ɂ
	if(p_ptr->pclass == CLASS_CIVILIAN)
		{
			get_class_name();
			c_put_str(TERM_WHITE, "                     ", 5, 15);
			c_put_str(TERM_L_BLUE, player_class_name, 5, 15);
		}

}//ʐEI


	put_str("                                           ", 3, 40);
	put_str("                                           ", 4, 40);
	put_str("                                           ", 5, 40);
	put_str("                                           ", 6, 40);


	/* Choose the magic realms */
	if (!get_player_realms()) return FALSE;

	/* Choose the players seikaku */
	p_ptr->pseikaku = 0;
	while(1)
	{
		char temp[80*8];
		cptr t;

		if (!get_player_seikaku()) return FALSE;

		clear_from(10);
		if(p_ptr->pseikaku == SEIKAKU_SPECIAL)
			roff_to_buf(seikaku_special_jouhou[get_special_seikaku_index(p_ptr->pclass)], 74, temp, sizeof(temp));
		else
			roff_to_buf(seikaku_jouhou[p_ptr->pseikaku], 74, temp, sizeof(temp));

		t = temp;

		for (i = 0; i< 6; i++)
		{
			if(t[0] == 0)
				break; 
			else
			{
				prt(t, 12+i, 3);
				t += strlen(t) + 1;
			}
		}
		if(ap_ptr->flag_nofixed)
		{
			prt("L[Ă", 0, 0);
			(void)inkey();
			prt("", 0, 0);
		}
		else if(old_data_cheat_flag && p_ptr->pseikaku == SEIKAKU_COLLECTOR)
		{
			prt("ÕZ[uf[^Ƀ`[gtOĂ邽ߑIs:", 0, 0);
			(void)inkey();
			prt("", 0, 0);
		}
		else if(old_collector && p_ptr->pseikaku != SEIKAKU_COLLECTOR)
		{
			screen_save();
			Term_clear();
			prt("IíuNWƁvł͂Ȃ̂ŁA", 10, 20);
			prt("O܂łɏW߂GgX̃ACe̓Zbg܂B", 11, 20);
			(void)inkey();
			screen_load();
			if (get_check_strict("낵łH", CHECK_OKAY_CANCEL)) break;

		}
		else if (get_check_strict("낵łH", CHECK_DEFAULT_Y)) break;
		put_str("                                                       ", 1, 24);
		c_put_str(TERM_L_BLUE, player_name, 1, 24);
		//c_put_str(TERM_L_BLUE, player_name, 1, 34);
		prt("", 1, 34+strlen(player_name));
	}

	/* Clean up */
	clear_from(10);
	put_str("                                                       ", 3, 40);
	put_str("                                                       ", 4, 40);
	put_str("                                                       ", 5, 40);

	screen_save();
#ifdef JP
	do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
#else
	do_cmd_options_aux(OPT_PAGE_BIRTH, "Birth Option((*)s effect score)");
#endif

	screen_load();


#if 0
#ifdef ALLOW_AUTOROLLER

	/*** Autoroll ***/

	if (autoroller || autochara)
	{
		/* Clear fields */
		auto_round = 0L;
	}

	/* Initialize */
	if (autoroller)
	{
		if (!get_stat_limits()) return FALSE;
	}

	if (autochara)
	{
		///tmp131221 g̏dN֘Ȁ\
		//if (!get_chara_limits()) return FALSE;
	}

#endif /* ALLOW_AUTOROLLER */

	/* Clear */
	clear_from(10);

	/* Reset turn; before auto-roll and after choosing race */
	init_turn();

	/*** Generate ***/

	/* Roll */
	while (TRUE)
	{
		int col;

		col = 42;

		if (autoroller || autochara)
		{
			Term_clear();

			/* Label count */
#ifdef JP
			put_str(" :", 10, col+13);
#else
			put_str("Round:", 10, col+13);
#endif


			/* Indicate the state */
#ifdef JP
			put_str("(ESCŒ~)", 12, col+13);
#else
			put_str("(Hit ESC to stop)", 12, col+13);
#endif
		}

		/* Otherwise just get a character */
		else
		{
			/* Get a new character */
			get_stats();

			/* Roll for age/height/weight */
			get_ahw();

			/* Roll for social class */
			get_history();
		}

		/* Feedback */
		if (autoroller)
		{
			/* Label */
#ifdef JP
			put_str("ŏl", 2, col+5);
#else
			put_str(" Limit", 2, col+5);
#endif


			/* Label */
#ifdef JP
			put_str("", 2, col+13);
#else
			put_str("  Freq", 2, col+13);
#endif


			/* Label */
#ifdef JP
			put_str("ݒl", 2, col+24);
#else
			put_str("  Roll", 2, col+24);
#endif


			/* Put the minimal stats */
			for (i = 0; i < 6; i++)
			{
				int j, m;

				/* Label stats */
				put_str(stat_names[i], 3+i, col);

				/* Race/Class bonus */
				j = rp_ptr->r_adj[i] + cp_ptr->c_adj[i] + ap_ptr->a_adj[i];

				/* Obtain the current stat */
				m = adjust_stat(stat_limit[i], j);

				/* Put the stat */
				cnv_stat(m, buf);
				c_put_str(TERM_L_BLUE, buf, 3+i, col+5);
			}
		}

		/* Auto-roll */
		while (autoroller || autochara)
		{
			bool accept = TRUE;

			/* Get a new character */
			get_stats();

			/* Advance the round */
			auto_round++;

			/* Hack -- Prevent overflow */
			if (auto_round >= 1000000000L)
			{
				auto_round = 1;

				if (autoroller)
				{
					for (i = 0; i < 6; i++)
					{
						stat_match[i] = 0;
					}
				}
			}

			if (autoroller)
			{
				/* Check and count acceptable stats */
				for (i = 0; i < 6; i++)
				{
					/* This stat is okay */
					if (p_ptr->stat_max[i] >= stat_limit[i])
					{
						stat_match[i]++;
					}

					/* This stat is not okay */
					else
					{
						accept = FALSE;
					}
				}
			}

			/* Break if "happy" */
			if (accept)
			{
				/* Roll for age/height/weight */
				get_ahw();

				/* Roll for social class */
				get_history();
				///del131221 ̊iI[g[
				/*
				if (autochara)
				{
					if ((p_ptr->age < chara_limit.agemin) || (p_ptr->age > chara_limit.agemax)) accept = FALSE;
					if ((p_ptr->ht < chara_limit.htmin) || (p_ptr->ht > chara_limit.htmax)) accept = FALSE;
					if ((p_ptr->wt < chara_limit.wtmin) || (p_ptr->wt > chara_limit.wtmax)) accept = FALSE;
					if ((p_ptr->sc < chara_limit.scmin) || (p_ptr->sc > chara_limit.scmax)) accept = FALSE;
				}
				*/
				if (accept) break;
			}

			/* Take note every x rolls */
			flag = (!(auto_round % AUTOROLLER_STEP));

			/* Update display occasionally */
			if (flag)
			{
				/* Dump data */
				birth_put_stats();

				/* Dump round */
				put_str(format("%10ld", auto_round), 10, col+20);

#ifdef AUTOROLLER_DELAY
				/* Delay 1/10 second */
				if (flag) Term_xtra(TERM_XTRA_DELAY, 10);
#endif

				/* Make sure they see everything */
				Term_fresh();

				/* Do not wait for a key */
				inkey_scan = TRUE;

				/* Check for a keypress */
				if (inkey())
				{
					/* Roll for age/height/weight */
					get_ahw();

					/* Roll for social class */
					///sysdel
					get_history();

					break;
				}
			}
		}

		if (autoroller || autochara) sound(SOUND_LEVEL);

		/* Flush input */
		flush();


		/*** Display ***/

		/* Mode */
		mode = 0;

		/* Roll for base hitpoints */
		get_extra(TRUE);

		/* Roll for gold */
		get_money();

		/* Hack -- get a chaos patron even if you are not a chaos warrior */
		p_ptr->chaos_patron = (s16b)randint0(MAX_PATRON);

		/* Input loop */
		while (TRUE)
		{
			/* Calculate the bonuses and hitpoints */
			p_ptr->update |= (PU_BONUS | PU_HP);

			/* Update stuff */
			update_stuff();

			/* Fully healed */
			p_ptr->chp = p_ptr->mhp;

			/* Fully rested */
			p_ptr->csp = p_ptr->msp;

			/* Display the player */
			display_player(mode);

			/* Prepare a prompt (must squeeze everything in) */
			Term_gotoxy(2, 23);
			Term_addch(TERM_WHITE, b1);
#ifdef JP
			Term_addstr(-1, TERM_WHITE, "'r' ̐l");
#else
			Term_addstr(-1, TERM_WHITE, "'r'eroll");
#endif

#ifdef JP
			if (prev) Term_addstr(-1, TERM_WHITE, ", 'p' O̐l");
#else
			if (prev) Term_addstr(-1, TERM_WHITE, ", 'p'previous");
#endif

#ifdef JP
			if (mode) Term_addstr(-1, TERM_WHITE, ", 'h' ̑̏");
#else
			if (mode) Term_addstr(-1, TERM_WHITE, ", 'h' Misc.");
#endif

#ifdef JP
			else Term_addstr(-1, TERM_WHITE, ", 'h' \");
#else
			else Term_addstr(-1, TERM_WHITE, ", 'h'istory");
#endif

#ifdef JP
			Term_addstr(-1, TERM_WHITE, ", Enter ̐lɌ");
#else
			Term_addstr(-1, TERM_WHITE, ", or Enter to accept");
#endif

			Term_addch(TERM_WHITE, b2);

			/* Prompt and get a command */
			c = inkey();

			/* Quit */
			if (c == 'Q') birth_quit();

			/* Start over */
			if (c == 'S') return (FALSE);

			/* Escape accepts the roll */
			if (c == '\r' || c == '\n' || c == ESCAPE) break;

			/* Reroll this character */
			if ((c == ' ') || (c == 'r')) break;

			/* Previous character */
			if (prev && (c == 'p'))
			{
				load_prev_data(TRUE);
				continue;
			}

			/* Toggle the display */
			if ((c == 'H') || (c == 'h'))
			{
				mode = ((mode != 0) ? 0 : 1);
				continue;
			}

			/* Help */
			if (c == '?')
			{
#ifdef JP
				show_help("jbirth.txt#AutoRoller");
#else
				show_help("birth.txt#AutoRoller");
#endif
				continue;
			}
			else if (c == '=')
			{
				screen_save();
#ifdef JP
				do_cmd_options_aux(OPT_PAGE_BIRTH, "IvV((*)̓XRAɉe)");
#else
				do_cmd_options_aux(OPT_PAGE_BIRTH, "Birth Option((*)s effect score)");
#endif

				screen_load();
				continue;
			}

			/* Warning */
#ifdef JP
			bell();
#else
			bell();
#endif

		}

		/* Are we done? */
		if (c == '\r' || c == '\n' || c == ESCAPE) break;

		/* Save this for the "previous" character */
		save_prev_data(&previous_char);
		previous_char.quick_ok = FALSE;

		/* Note that a previous roll exists */
		prev = TRUE;
	}
#endif
	///mod140510 {[iX|Cgɂ
	while(1)
	{
		bool ok = FALSE;
		get_bonus_points();
		init_turn();
		get_ahw();
		get_history();
		get_extra(TRUE);
		get_money();
		//ǐ_lꏈ@ŏ̐_i^Cv肵JIXpgϐ֊i[ deity_table[]3`14
		//JIXpgϐĝ̓NCbNX^[gɕێ邽
		if(p_ptr->prace == RACE_STRAYGOD)
		{
			if(p_ptr->pclass == CLASS_SHIZUHA) p_ptr->chaos_patron = 2;
			else if(p_ptr->pclass == CLASS_MINORIKO) p_ptr->chaos_patron = 1;
			else p_ptr->chaos_patron = 2 + (s16b)randint1(12);

			p_ptr->race_multipur_val[3] = p_ptr->chaos_patron;
		}
		else
			p_ptr->chaos_patron = (s16b)randint0(MAX_PATRON);

		p_ptr->update |= (PU_BONUS | PU_HP | PU_MANA);
		update_stuff();
		p_ptr->chp = p_ptr->mhp;
		p_ptr->csp = p_ptr->msp;
		display_player(0);
		Term_gotoxy(2, 23);
		Term_addstr(-1, TERM_WHITE, "'r' {[iX|Cgă[");
		Term_addstr(-1, TERM_WHITE, ", Enter ̐lɌ");
		while(1)
		{
			c = inkey();
			if (c == 'Q') birth_quit();
			if (c == 'S') return (FALSE);
			if (c == '\r' || c == '\n' || c == ESCAPE)
			{
				ok = TRUE;
				break;
			}
			if ((c == 'r')) break;
		}
		if(ok) break;
		put_str("                                                       ", 3, 30);
		put_str("                                                       ", 4, 30);
		put_str("                                                       ", 5, 30);
		put_str("                                                       ", 6, 30);
		put_str("                                                       ", 7, 30);
		put_str("                                                       ", 8, 30);

	}
	///mod150315 d\͌(ŏLCNp)
	if(p_ptr->prace == RACE_FAIRY) get_fairy_type(TRUE);

	/* Clear prompt */
	clear_from(23);

	/* Get a name, recolor it, prepare savefile */

	if(!flag_unique) get_name();


	/* Process the player name */
	process_player_name(creating_savefile);

	/*** Edit character background ***/
	edit_history();

	/*** Finish up ***/

	get_max_stats();


	///del140105 virtue
	//get_virtues();

	/* Prompt for it */
#ifdef JP
	prt("[ 'Q' f, 'S' ߂, Enter Q[Jn ]", 23, 14);
#else
	prt("['Q'uit, 'S'tart over, or Enter to continue]", 23, 10);
#endif


	/* Get a key */
	c = inkey();

	/* Quit */
	if (c == 'Q') birth_quit();

	/* Start over */
	if (c == 'S') return (FALSE);


	/* Initialize random quests */
	init_dungeon_quests();

	/* Save character data for quick start */
	save_prev_data(&previous_char);
	previous_char.quick_ok = TRUE;

	/* Accept */
	return (TRUE);
}


/*
 * Ask whether the player use Quick Start or not.
 */
/*:::NCbNX^[g̊mF@sȂf[^[h@NCbNX^[gȂȂFALSEԂ*/
static bool ask_quick_start(void)
{
	/* Doesn't have previous data */
	if (!previous_char.quick_ok) return FALSE;


	/* Clear screen */
	Term_clear();

	/* Extra info */
#ifdef JP
	put_str("NCbNEX^[ggƈȑOƑSLN^[Ŏn߂܂B", 11, 5);
#else
	put_str("Do you want to use the quick start function(same character as your last one).", 11, 2);
#endif

	/* Choose */
	while (1)
	{
		char c;

#ifdef JP
		put_str("NCbNEX^[gg܂H[y/N]", 14, 10);
#else
		put_str("Use quick start? [y/N]", 14, 10);
#endif
		c = inkey();

		if (c == 'Q') quit(NULL);
		else if (c == 'S') return (FALSE);
		else if (c == '?')
		{
#ifdef JP
			show_help("tbirth.txt#QuickStart");
#else
			show_help("birth.txt#QuickStart");
#endif
		}
		else if ((c == 'y') || (c == 'Y'))
		{
			/* Yes */
			break;
		}
		else
		{
			/* No */
			return FALSE;
		}
	}

	/*:::NCbNX^[gpɐFXȃf[^ǂݍ*/
	load_prev_data(FALSE);

	//v1.1.30 init_dungeon_quests()init_turn()tɂBȂƑ啝ɓo߂Z[uf[^ŃNCbNX^[gƂɃNGX^[ɋGo炵
	/*:::푰ƂɃ^[vZ*/
	init_turn();
	/*:::NGXg*/
	init_dungeon_quests();

	sp_ptr = &sex_info[p_ptr->psex];
	rp_ptr = &race_info[p_ptr->prace];
	cp_ptr = &class_info[p_ptr->pclass];
	//mp_ptr = &m_info[p_ptr->pclass];
	//v1.1.32 ꐫi
	//ap_ptr = &seikaku_info[p_ptr->pseikaku];
	ap_ptr = get_ap_ptr(p_ptr->prace,p_ptr->pclass,p_ptr->pseikaku);

	/* Calc hitdie, but don't roll */
	get_extra(FALSE);

	/* Calculate the bonuses and hitpoints */
	p_ptr->update |= (PU_BONUS | PU_HP);

	/* Update stuff */
	update_stuff();

	/* Fully healed */
	p_ptr->chp = p_ptr->mhp;

	/* Fully rested */
	p_ptr->csp = p_ptr->msp;

	/* Process the player name */
	process_player_name(FALSE);

	return TRUE;
}



// VɓψقݎĂψقƑƂ̕ψقȂƂȂB@ʓ|푰ϗexS̕ψق悤ɂĂ܂H
//Ƃ肠푰ψق͕̎ψقS邱ƂɂBvoȂψقdȂƂOɃR[hǂɂCB
/*:::^ψق𓾂BQ[JnƎ푰ϗeȂǂ̂ƂgB*/
void gain_perma_mutation(void)
{
	p_ptr->muta1_perma = 0;
	p_ptr->muta2_perma = 0;
	p_ptr->muta3_perma &= MUT3_GOOD_LUCK ; //Hack @XVœI[͓]ƂĂȂ

	if(p_ptr->pseikaku == SEIKAKU_LUCKY) p_ptr->muta3_perma |= MUT3_GOOD_LUCK;
	if(p_ptr->prace == RACE_ONI) p_ptr->muta2_perma |= MUT2_BIGHORN;
	if(p_ptr->prace == RACE_NINGYO) p_ptr->muta3_perma |= MUT3_FISH_TAIL;
	if(p_ptr->pclass == CLASS_TEWI) p_ptr->muta3_perma |= MUT3_GOOD_LUCK;
	if(p_ptr->pclass == CLASS_SUIKA) p_ptr->muta2_perma |= MUT2_ALCOHOL;
	if(p_ptr->pclass == CLASS_KOISHI) p_ptr->muta2_perma |= (MUT2_RTELEPORT | MUT2_BIRDBRAIN);
	if(p_ptr->pclass == CLASS_YOSHIKA) p_ptr->muta3_perma |= MUT3_MORONIC;
	if(p_ptr->pclass == CLASS_PATCHOULI) p_ptr->muta2_perma |= MUT2_ASTHMA;
	if(p_ptr->pclass == CLASS_YUGI) p_ptr->muta3_perma |= MUT3_HYPER_STR;

	if(p_ptr->pclass == CLASS_KYOUKO) p_ptr->muta1_perma |= MUT1_BEAST_EAR;
	if(p_ptr->pclass == CLASS_KEINE) p_ptr->muta2_perma |= MUT2_HARDHEAD;
	if(p_ptr->pclass == CLASS_REMY) p_ptr->muta3_perma |= MUT3_GOOD_LUCK;
	if(p_ptr->pclass == CLASS_UTSUHO) p_ptr->muta2_perma |= (MUT2_BIRDBRAIN);
	if(p_ptr->pclass == CLASS_LUNAR) p_ptr->muta2_perma |= (MUT2_DISARM);
	if(p_ptr->pclass == CLASS_3_FAIRIES) p_ptr->muta2_perma |= (MUT2_DISARM);
	if(p_ptr->pclass == CLASS_YUKARI) p_ptr->muta3_perma |= MUT3_HYPER_INT;
	if(p_ptr->pclass == CLASS_EIRIN) p_ptr->muta3_perma |= MUT3_HYPER_INT;
	if(p_ptr->pclass == CLASS_TOYOHIME) p_ptr->muta3_perma |= MUT3_GOOD_LUCK;
	if(p_ptr->pclass == CLASS_AUNN) p_ptr->muta2_perma |= MUT2_BIGHORN;

	if (p_ptr->pclass == CLASS_SHION) p_ptr->muta3_perma |= MUT3_BAD_LUCK;

	p_ptr->muta1 = p_ptr->muta1_perma;
	p_ptr->muta2 = p_ptr->muta2_perma;
	p_ptr->muta3 = p_ptr->muta3_perma;



}

/*
 * Create a new character.
 *
 * Note that we may be called with "junk" leftover in the various
 * fields, so we must be sure to clear them first.
 */
/*:::LN^[CN*/
void player_birth(void)
{
	int i, j;
	char buf[80];

	playtime = 0;

	//iRN^[p̃tO@ȃtOȂĂ̂ǂꂩ̃tOłǂɂȂ̂ȂׂĂȂ
	if(p_ptr->noscore) old_data_cheat_flag = TRUE;
	if(p_ptr->pseikaku == SEIKAKU_COLLECTOR) old_collector = TRUE;

	/* 
	 * Wipe monsters in old dungeon
	 * This wipe destroys value of m_list[].cur_num .
	 */
	wipe_m_list();

	/* Wipe the player */
	player_wipe();

	/* Create a new character */

	/* Quick start? */
	/*:::NCbNX^[g̊mFBYȂOf[^[hAłȂȂplayer_birth_aux()[v*/
	if (!ask_quick_start())
	{
		/* No, normal start */
		while (1)
		{
			/* Roll up a new character */
			if (player_birth_aux()) break;

			/* Wipe the player */
			player_wipe();
		}
	}

	//S̊p⃉bL[}̃I[Ȃǐ^ψق𓾂
	gain_perma_mutation();

	/*:::ꏈ@S̓Q[Jn琌Ă*/
	///mod150205ɂ
	if(p_ptr->pclass == CLASS_SUIKA) p_ptr->alcohol = 2000;

	/*:::ꏈ@킩PƉeT͍ŏ瑐̍dlbg[NɉĂ*/
	if(p_ptr->pclass == CLASS_WAKASAGI) p_ptr->grassroots = 1;
	if(p_ptr->pclass == CLASS_KAGEROU) p_ptr->grassroots = 1;

	//ꏈ@͍ŏS̏ꏊmĂ
	if(p_ptr->pclass == CLASS_RAN) max_dlv[DUNGEON_ANGBAND] = 1;

	//ꏈ@͖500܂Ă
	if(p_ptr->pclass == CLASS_HINA) p_ptr->magic_num1[0] = 500;


	/* Note player birth in the message recall */
	message_add(" ");
	message_add("  ");
	message_add("====================");
	message_add(" ");
	message_add("  ");

	///system j[NvC[̋Lqς悤
#ifdef JP
	do_cmd_write_nikki(NIKKI_GAMESTART, 1, "-------- VKQ[Jn --------");
#else
	do_cmd_write_nikki(NIKKI_GAMESTART, 1, "-------- Start New Game --------");
#endif
	do_cmd_write_nikki(NIKKI_HIGAWARI, 0, NULL);

#ifdef JP
	sprintf(buf,"                            ʂ%sIB", sex_info[p_ptr->psex].title);
#else
	sprintf(buf,"                            choose %s personality.", sex_info[p_ptr->psex].title);
#endif
	do_cmd_write_nikki(NIKKI_BUNSHOU, 1, buf);

#ifdef JP
	sprintf(buf,"                            푰%sIB", race_info[p_ptr->prace].title);
#else
	sprintf(buf,"                            choose %s race.", race_info[p_ptr->prace].title);
#endif
	do_cmd_write_nikki(NIKKI_BUNSHOU, 1, buf);

#ifdef JP
	sprintf(buf,"                            EƂ%sIB", class_info[p_ptr->pclass].title);
#else
	sprintf(buf,"                            choose %s class.", class_info[p_ptr->pclass].title);
#endif
	do_cmd_write_nikki(NIKKI_BUNSHOU, 1, buf);

	if (p_ptr->realm1)
	{
#ifdef JP
		sprintf(buf,"                            @̗̈%s%sIB",realm_names[p_ptr->realm1], p_ptr->realm2 ? format("%s",realm_names[p_ptr->realm2]) : "");
#else
		sprintf(buf,"                            choose %s%s realm.",realm_names[p_ptr->realm1], p_ptr->realm2 ? format(" realm and %s",realm_names[p_ptr->realm2]) : "");
#endif
		do_cmd_write_nikki(NIKKI_BUNSHOU, 1, buf);
	}

#ifdef JP
//	sprintf(buf,"                            i%sIB", seikaku_info[p_ptr->pseikaku].title);
	if(p_ptr->psex == SEX_MALE)
		sprintf(buf,"                            i%sIB", ap_ptr->title);
	else
		sprintf(buf,"                            i%sIB", ap_ptr->f_title);
#else
	sprintf(buf,"                            choose %s.", seikaku_info[p_ptr->pseikaku].title);
#endif
	do_cmd_write_nikki(NIKKI_BUNSHOU, 1, buf);

	/* Init the shops */
	for (i = 1; i < max_towns; i++)
	{
		for (j = 0; j < MAX_STORES; j++)
		{
			//iuNWƁv́AÕZ[uf[^̔قNAȂ
			if(p_ptr->pseikaku == SEIKAKU_COLLECTOR && j == STORE_MUSEUM)
				continue;

			/* Initialize */
			store_init(i, j);
		}
	}

	/* Generate the random seeds for the wilderness */
	seed_wilderness();

	/* Give beastman a mutation at character birth */
	///sysdel race
	//if (p_ptr->prace == RACE_BEASTMAN) hack_startup = TRUE;
	//else 
	hack_startup = TRUE; //hack_mutationSẮ̊JntOƂčȂ

	//v1.1.25 Jno[WL^
	start_ver[0] = H_VER_MAJOR;
	start_ver[1] = H_VER_MINOR;
	start_ver[2] = H_VER_PATCH;
	start_ver[3] = H_VER_EXTRA;

	/* Set the message window flag as default */
	if (!window_flag[1])
		window_flag[1] |= PW_MESSAGE;

	/* Set the inv/equip window flag as default */
	if (!window_flag[2])
		window_flag[2] |= PW_INVEN;
}

/*:::푰AEƁAiÄ̐t@CɃRs[*/
void dump_yourself(FILE *fff)
{
	char temp[80*10];
	int i;
	cptr t;

	if (!fff) return;

	roff_to_buf(race_jouhou[p_ptr->prace], 78, temp, sizeof(temp));
	fprintf(fff, "\n\n");
#ifdef JP
	fprintf(fff, "푰: %s(%s)\n", race_info[p_ptr->prace].title, race_info[p_ptr->prace].E_title);
#else
	fprintf(fff, "Race: %s\n", race_info[p_ptr->prace].title);
#endif
	t = temp;
	for (i = 0; i < 10; i++)
	{
		if(t[0] == 0)
			break; 
		fprintf(fff, "%s\n",t);
		t += strlen(t) + 1;
	}

	///mod150315 dZ
	if(p_ptr->prace == RACE_FAIRY && CHECK_FAIRY_TYPE)
		fprintf(fff, "(%s)\n",fairy_table[CHECK_FAIRY_TYPE].fairy_desc);


	///mod140206 j[Nv[[class_jouhou[]ɐȂ̂ŏ
	if(cp_ptr->flag_only_unique)
	{
		int i;
		for(i=0;i<UNIQUE_PLAYER_NUM;i++)
		{
			if(unique_player_table[i].class_id == p_ptr->pclass) break;
		}
		if(i==UNIQUE_PLAYER_NUM)
		{
			msg_print("ERROR:Ȃ̃NXIDunique_player_table[]ɓo^ĂȂ");
			return;
		}
		roff_to_buf(unique_player_table[i].info, 78, temp, sizeof(temp));		
	}
	else 
		roff_to_buf(class_jouhou[p_ptr->pclass], 78, temp, sizeof(temp));

	fprintf(fff, "\n");
#ifdef JP
	if(p_ptr->psex == SEX_MALE) fprintf(fff, "E: %s(%s)\n", class_info[p_ptr->pclass].title,class_info[p_ptr->pclass].E_title);
	else fprintf(fff, "E: %s(%s)\n", class_info[p_ptr->pclass].f_title,class_info[p_ptr->pclass].E_title);
#else
	fprintf(fff, "Class: %s\n", class_info[p_ptr->pclass].title);
#endif
	t = temp;

	for (i = 0; i < 10; i++)
	{
		if(t[0] == 0)
			break; 
		fprintf(fff, "%s\n",t);
		t += strlen(t) + 1;
	}
	if(p_ptr->pseikaku == SEIKAKU_SPECIAL)
		roff_to_buf(seikaku_special_jouhou[get_special_seikaku_index(p_ptr->pclass)], 74, temp, sizeof(temp));
	else
		roff_to_buf(seikaku_jouhou[p_ptr->pseikaku], 78, temp, sizeof(temp));

	fprintf(fff, "\n");
#ifdef JP
		//if(p_ptr->psex == SEX_MALE) fprintf(fff, "i: %s\n", seikaku_info[p_ptr->pseikaku].title);
		//else fprintf(fff, "i: %s\n", seikaku_info[p_ptr->pseikaku].f_title);
		if(p_ptr->psex == SEX_MALE) fprintf(fff, "i: %s\n", ap_ptr->title);
		else fprintf(fff, "i: %s\n", ap_ptr->f_title);
#else
	fprintf(fff, "Pesonality: %s\n", seikaku_info[p_ptr->pseikaku].title);
#endif
	t = temp;
	for (i = 0; i < 6; i++)
	{
		if(t[0] == 0)
			break; 
		fprintf(fff, "%s\n",t);
		t += strlen(t) + 1;
	}
	fprintf(fff, "\n");
	if (p_ptr->realm1)
	{
		roff_to_buf(realm_jouhou[p_ptr->realm1], 78, temp, sizeof(temp));
#ifdef JP
		fprintf(fff, "@: %s\n", realm_names[p_ptr->realm1]);
#else
		fprintf(fff, "Realm: %s\n", realm_names[p_ptr->realm1]);
#endif
		t = temp;
		for (i = 0; i < 6; i++)
		{
			if(t[0] == 0)
				break; 
			fprintf(fff, "%s\n",t);
			t += strlen(t) + 1;
		}
	}
	fprintf(fff, "\n");
	if (p_ptr->realm2)
	{
		roff_to_buf(realm_jouhou[p_ptr->realm2], 78, temp, sizeof(temp));
#ifdef JP
		fprintf(fff, "@: %s\n", realm_names[p_ptr->realm2]);
#else
		fprintf(fff, "Realm: %s\n", realm_names[p_ptr->realm2]);
#endif
		t = temp;
		for (i = 0; i < 6; i++)
		{
			if(t[0] == 0)
				break; 
			fprintf(fff, "%s\n",t);
			t += strlen(t) + 1;
		}
	}
}


//v1.1.32 ꐫi֘A
//iSEIKAKU_SPECIAL̂ƂALɉiinfospecial_seikaku_info[]玝Ă.
//ȊO̐îƂ͕ʂap_ptrԂ
const player_seikaku * get_ap_ptr(int race_idx, int class_idx, int seikaku_idx)
{

	if(seikaku_idx == SEIKAKU_SPECIAL)
	{
		int idx2 = get_special_seikaku_index(class_idx);
		if(idx2 >= MAX_SEIKAKU_SPECIAL)
		{
			msg_format("ERROR:ꐫiidxMAX");

		}
		else
			return (const player_seikaku *) &seikaku_info_special[idx2];
	}
	
	return (const player_seikaku *) &seikaku_info[seikaku_idx];
}


//݂́ꐫiidxɈvĂ邩肷B
//LCN⃍[hpseikakupclassm肵ĂȂԂŎgȂ悤
bool is_special_seikaku(int idx)
{
	if (p_ptr->pseikaku != SEIKAKU_SPECIAL)
		return FALSE;

	if (get_special_seikaku_index(p_ptr->pclass) == idx)
		return TRUE;

	return FALSE;

}
