/* File: cmd1.c */

/*
 * Copyright (c) 1997 Ben Harrison, James E. Wilson, Robert A. Koeneke
 *
 * This software may be copied and distributed for educational, research,
 * and not for profit purposes provided that this copyright and statement
 * are included in all such copies.  Other copyrights may also apply.
 */

/* Purpose: Movement commands (part 1) */

#include "angband.h"
#define MAX_VAMPIRIC_DRAIN 50


/*
 * Determine if the player "hits" a monster (normal combat).
 * Note -- Always miss 5%, always hit 5%, otherwise random.
 */
/*:::ˌƓ̖ 
 *:::chance:do_cmd_fire_auxȂǂŌvZl
 *:::AC:GAC XiCp[̂Ƃ
 *:::vis m_ptr->ml */
bool test_hit_fire(int chance, int ac, int vis)
{
	int k;

	/* Percentile dice */
	k = randint0(100);

	/* Hack -- Instant miss or hit */
	if (k < 10) return (k < 5);

	///seikaku Ȃ܂ˌs
	//if (p_ptr->pseikaku == SEIKAKU_NAMAKE)
	//	if (one_in_(20)) return (FALSE);

	/* Never hit */
	if (chance <= 0) return (FALSE);

	/* Invisible monsters are harder to hit */
	if (!vis) chance = (chance + 1) / 2;

	/* Power competes against armor */
	if (randint0(chance) < (ac * 3 / 4)) return (FALSE);

	/* Assume hit */
	return (TRUE);
}



/*
 * Determine if the player "hits" a monster (normal combat).
 *
 * Note -- Always miss 5%, always hit 5%, otherwise random.
 */
 /*:::ʏU:::*/
 /*:::chance:l 푰EƐil+(ACeC+p[^C+jq[[̑)*3:::*/
bool test_hit_norm(int chance, int ac, int vis)
{
	int k;

	/* Percentile dice */
	k = randint0(100);

	/* Hack -- Instant miss or hit */
	/*:::k<10Ȃ50%̊mTrueFalseԂBۏؒl5%ƐΎs5%sōς܂eNjbN炵:::*/
	if (k < 10) return (k < 5);


	///seikaku Ȃ܂̖s
	//if (p_ptr->pseikaku == SEIKAKU_NAMAKE)
	//	if (one_in_(20)) return (FALSE);

	/* Wimpy attack never hits */
	if (chance <= 0) return (FALSE);

	/* Penalize invisible targets */
	if (!vis) chance = (chance + 1) / 2;

	/* Power must defeat armor */
	if (randint0(chance) < (ac * 3 / 4)) return (FALSE);

	/* Assume hit */
	return (TRUE);
}



/*
 * Critical hits (from objects thrown by player)
 * Factor in item weight, total plusses, and player level.
 */
/*:::ˌƓ̃NeBJ@/̏dʁACɈˑ@XiCp[̏WɃ{[iX*/
s16b critical_shot(int weight, int plus, int dam)
{
	int i, k;

	/* Extract "shot" power */
	i = ((p_ptr->to_h_b + plus) * 4) + (p_ptr->lev * 2);

	/* Snipers can shot more critically with crossbows */
	if (p_ptr->concent) i += ((i * p_ptr->concent) / 5);
	///class XiCp[
	if ((p_ptr->pclass == CLASS_SNIPER) && (p_ptr->tval_ammo == TV_BOLT)) i *= 2;

	/* Critical hit */
	if (randint1(5000) <= i)
	{
		k = weight * randint1(500);

		if (k < 900)
		{
#ifdef JP
			msg_print("育I");
#else
			msg_print("It was a good hit!");
#endif

			dam += (dam / 2);
		}
		else if (k < 1350)
		{
#ifdef JP
			msg_print("Ȃ̎育I");
#else
			msg_print("It was a great hit!");
#endif

			dam *= 2;
		}
		else
		{
#ifdef JP
			msg_print("S̈ꌂI");
#else
			msg_print("It was a superb hit!");
#endif

			dam *= 3;
		}
	}

	return (dam);
}



/*
 * Critical hits (by player)
 *
 * Factor in weapon weight, total plusses, player level.
 */
/*:::NeBJqbgɂdaml␳vZ*/
/*:::weight:d
 *:::plus:qbgCl
 *:::dam:_CX_[W
 *:::meichuu:̃qbgCl
 *:::mode:pȂǂ̍ÛƂ
 *:::킪d햽CقǃNeBJɂȂ₷B킪dقǂ悢NeBJɂȂ₷B
 */
s16b critical_norm(int weight, int plus, int dam, s16b meichuu, int mode)
{
	int i, k;
	int chance = 5000;
	if(p_ptr->pclass == CLASS_NINJA) chance = 4444;
	else if(p_ptr->pclass == CLASS_YUGI) chance = 3500;

	/* Extract "blow" power */
	i = (weight + (meichuu * 3 + plus * 5) + (p_ptr->lev * 3));

	/* Chance */
	///class NeBJ@E҂ƌpƂ̓ꏈ
	if ((randint1(chance) <= i) || (mode == HISSATSU_MAJIN) || (mode == HISSATSU_3DAN))
	{
		k = weight + randint1(650);
		if ((mode == HISSATSU_MAJIN) || (mode == HISSATSU_3DAN)) k+= randint1(650);
		if(mode == HISSATSU_MAJIN && k < 700) k = 700;

		if (k < 400)
		{
#ifdef JP
			msg_print("育I");
#else
			msg_print("It was a good hit!");
#endif

			dam = 2 * dam + 5;
		}
		else if (k < 700)
		{
#ifdef JP
			msg_print("Ȃ̎育I");
#else
			msg_print("It was a great hit!");
#endif

			dam = 2 * dam + 10;
		}
		else if (k < 900)
		{
#ifdef JP
			msg_print("S̈ꌂI");
#else
			msg_print("It was a superb hit!");
#endif

			dam = 3 * dam + 15;
		}
		else if (k < 1300)
		{
#ifdef JP
			msg_print("ō̉S̈ꌂI");
#else
			msg_print("It was a *GREAT* hit!");
#endif

			dam = 3 * dam + 20;
		}
		else
		{
#ifdef JP
			msg_print("ނȂō̉S̈ꌂI");
#else
			msg_print("It was a *SUPERB* hit!");
#endif

			dam = ((7 * dam) / 2) + 25;
		}
	}

	return (dam);
}


/*:::XC{Kp@ڍז*/
static int mult_slaying(int mult, const u32b* flgs, const monster_type* m_ptr)
{
	bool yukari = FALSE;
	static const struct slay_table_t {
		int slay_flag;
		u32b affect_race_flag;
		int slay_mult;
		size_t flag_offset;
		size_t r_flag_offset;
	} slay_table[] = {

#define OFFSET(X) offsetof(monster_race, X)
		/*:::̍\悭@KɓւΑvƎv*/
		///sys mon XCtOKp
		{TR_SLAY_ANIMAL, RF3_ANIMAL, 25, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_ANIMAL, RF3_ANIMAL, 40, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_SLAY_EVIL,   RF3_ANG_CHAOS,   20, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_EVIL,   RF3_ANG_CHAOS,   35, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_SLAY_GOOD,   RF3_ANG_COSMOS,   20, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_GOOD,   RF3_ANG_COSMOS,   35, OFFSET(flags3), OFFSET(r_flags3)},

///mod131231 X^[tOύX
		{TR_SLAY_HUMAN,  RF3_HUMAN,  25, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_HUMAN,  RF3_HUMAN,  40, OFFSET(flags3), OFFSET(r_flags3)},
//		{TR_SLAY_HUMAN,  RF2_HUMAN,  25, OFFSET(flags2), OFFSET(r_flags2)},
//		{TR_KILL_HUMAN,  RF2_HUMAN,  40, OFFSET(flags2), OFFSET(r_flags2)},
		{TR_SLAY_UNDEAD, RF3_UNDEAD, 30, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_UNDEAD, RF3_UNDEAD, 50, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_SLAY_DEMON,  RF3_DEMON,  30, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_DEMON,  RF3_DEMON,  50, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_SLAY_KWAI,   RF3_KWAI,   30, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_KWAI,   RF3_KWAI,   50, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_SLAY_DEITY,  RF3_DEITY,  30, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_DEITY,  RF3_DEITY,  50, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_SLAY_HUMAN,  RF3_DEMIHUMAN,  20, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_HUMAN,  RF3_DEMIHUMAN,  35, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_SLAY_DRAGON, RF3_DRAGON, 30, OFFSET(flags3), OFFSET(r_flags3)},
		{TR_KILL_DRAGON, RF3_DRAGON, 50, OFFSET(flags3), OFFSET(r_flags3)},
/*:::undefdefine𖳌ɂ炵@OFFSET()͂ŎgꂪȂ̂łɌ肵Ă̂낤*/
#undef OFFSET
	};
	int i;
	monster_race* r_ptr = &r_info[m_ptr->r_idx];

	//ulԂƗd̋EvɂVtg
	if(p_ptr->pclass == CLASS_YUKARI && p_ptr->tim_general[2]) yukari = TRUE;

	for (i = 0; i < sizeof(slay_table) / sizeof(slay_table[0]); ++ i)
	{
		const struct slay_table_t* p = &slay_table[i];
		u32b arg = p->affect_race_flag;

		if(yukari) arg <<= 1L;

		if ((have_flag(flgs, p->slay_flag)) &&
//		    (*(u32b*)(((char*)r_ptr) + p->flag_offset) & p->affect_race_flag))
		    (*(u32b*)(((char*)r_ptr) + p->flag_offset) & arg))
		{
			if (is_original_ap_and_seen(m_ptr) && !yukari)
			{
				*(u32b*)(((char*)r_ptr) + p->r_flag_offset) |= p->affect_race_flag;
			}

			mult = MAX(mult, p->slay_mult);
		}
	}

	return mult;
}
/*:::UKp*/
///system mon HURT_ELECɂ͂ɒǉKvƎv
///mod131231 X^[tOύX _flag3flagrɈړB₱̂Œ
static int mult_brand(int mult, const u32b* flgs, const monster_type* m_ptr)
{
	static const struct brand_table_t {
		int brand_flag;
		u32b resist_mask;
		u32b hurt_flag;
	} brand_table[] = {
		{TR_BRAND_ACID, RFR_EFF_IM_ACID_MASK, 0U           },
		{TR_BRAND_ELEC, RFR_EFF_IM_ELEC_MASK, RFR_HURT_ELEC},
		{TR_BRAND_FIRE, RFR_EFF_IM_FIRE_MASK, RFR_HURT_FIRE},
		{TR_BRAND_COLD, RFR_EFF_IM_COLD_MASK, RFR_HURT_COLD},
//		{TR_BRAND_FIRE, RFR_EFF_IM_FIRE_MASK, RF3_HURT_FIRE},
//		{TR_BRAND_COLD, RFR_EFF_IM_COLD_MASK, RF3_HURT_COLD},
		{TR_BRAND_POIS, RFR_EFF_IM_POIS_MASK, 0U           },
	};
	int i;
	monster_race* r_ptr = &r_info[m_ptr->r_idx];

	for (i = 0; i < sizeof(brand_table) / sizeof(brand_table[0]); ++ i)
	{
		const struct brand_table_t* p = &brand_table[i];

		if (have_flag(flgs, p->brand_flag))
		{
			/* Notice immunity */
			if (r_ptr->flagsr & p->resist_mask)
			{
				if (is_original_ap_and_seen(m_ptr))
				{
					r_ptr->r_flagsr |= (r_ptr->flagsr & p->resist_mask);
				}
			}

			/* Otherwise, take the damage */
			//else if (r_ptr->flags3 & p->hurt_flag)
			else if (r_ptr->flagsr & p->hurt_flag)
			{
				if (is_original_ap_and_seen(m_ptr))
				{
					r_ptr->r_flagsr |= p->hurt_flag;
				}

				mult = MAX(mult, 50);
			}
			else
			{
				mult = MAX(mult, 25);
			}
		}
	}

	return mult;
}
/*
 * Extract the "total damage" from a given object hitting a given monster.
 *
 * Note that "flasks of oil" do NOT do fire damage, although they
 * certainly could be made to do so.  XXX XXX
 *
 * Note that most brands and slays are x3, except Slay Animal (x2),
 * Slay Evil (x2), and Kill dragon (x5).
 */
/*:::_CX_[WAAX^[𓾂ăXCȂǂl_[W𑝉*/
///item mon XCɂ_CX
s16b tot_dam_aux(object_type *o_ptr, int tdam, monster_type *m_ptr, int mode, bool thrown)
{
	int mult = 10;

	u32b flgs[TR_FLAG_SIZE];

	/* Extract the flags */
	object_flags(o_ptr, flgs);
	torch_flags(o_ptr, flgs); /* torches has secret flags */

	if (!thrown)
	{
		/* Magical Swords */
		if (p_ptr->special_attack & (ATTACK_ACID)) add_flag(flgs, TR_BRAND_ACID);
		if (p_ptr->special_attack & (ATTACK_COLD)) add_flag(flgs, TR_BRAND_COLD);
		if (p_ptr->special_attack & (ATTACK_ELEC)) add_flag(flgs, TR_BRAND_ELEC);
		if (p_ptr->special_attack & (ATTACK_FIRE)) add_flag(flgs, TR_BRAND_FIRE);
		if (p_ptr->special_attack & (ATTACK_POIS)) add_flag(flgs, TR_BRAND_POIS);

		///mod150415 }̓ōU
		if (p_ptr->pclass == CLASS_YAMAME && p_ptr->lev > randint0(100)) add_flag(flgs, TR_BRAND_POIS);
		//v1.1.47 ~XeBAuq[}P[Wv
		if (p_ptr->pclass == CLASS_MYSTIA && music_singing(MUSIC_NEW_MYSTIA_HUMAN_CAGE))
			add_flag(flgs, TR_SLAY_HUMAN);
		///mod151115 ̓ꏈ
		if(p_ptr->pclass == CLASS_HINA)
		{
			if(p_ptr->magic_num1[0] > 27000) add_flag(flgs, TR_KILL_GOOD);
			else if(p_ptr->magic_num1[0] > 18000) add_flag(flgs, TR_SLAY_GOOD);
			if(p_ptr->magic_num1[0] > 18000) add_flag(flgs, TR_KILL_HUMAN);
			else if(p_ptr->magic_num1[0] > 12000) add_flag(flgs, TR_SLAY_HUMAN);
		}
		if (p_ptr->special_attack & (ATTACK_DARK))
		{
			if(have_flag(flgs,TR_SLAY_GOOD))  add_flag(flgs, TR_KILL_GOOD);
			else add_flag(flgs, TR_SLAY_GOOD);
		}
		if (p_ptr->special_attack & (ATTACK_FORCE))
		{
			add_flag(flgs, TR_FORCE_WEAPON);
		}
		if (p_ptr->kamioroshi & KAMIOROSHI_IZUNA)
			add_flag(flgs, TR_SLAY_EVIL);
		else if (p_ptr->kamioroshi & KAMIOROSHI_ATAGO)
			add_flag(flgs, TR_BRAND_FIRE);

		if(p_ptr->pclass == CLASS_MEDICINE && p_ptr->lev > 34) add_flag(flgs, TR_BRAND_POIS);
	}

	/* Hex - Slay Good (Runesword) */
	if (hex_spelling(HEX_RUNESWORD)) add_flag(flgs, TR_SLAY_GOOD);



	/* Some "weapons" and "ammo" do extra damage */
	switch (o_ptr->tval)
	{
		///item TVAL weapon
		case TV_BULLET:
		case TV_ARROW:
		case TV_BOLT:
		case TV_KNIFE:
		case TV_SWORD:
		case TV_KATANA:
		case TV_HAMMER:
		case TV_STICK:
		case TV_AXE:
		case TV_SPEAR:
		case TV_POLEARM:		
		case TV_OTHERWEAPON:
		case TV_LITE:
		{
			/* Slaying */
			mult = mult_slaying(mult, flgs, m_ptr);

			/* Elemental Brand */
			mult = mult_brand(mult, flgs, m_ptr);

			/* Hissatsu */
			///class p
			if (p_ptr->pclass == CLASS_SAMURAI || p_ptr->pclass == CLASS_YOUMU)
			{
				mult = mult_hissatsu(mult, flgs, m_ptr, mode);
			}

			/*:::ꏈ@NmX̑劙͒jɑ΂XXC*/
			if(o_ptr->name1 == ART_KRONOS)
			{
				monster_race *r_ptr = &r_info[m_ptr->r_idx];
				if((r_ptr->flags1 & RF1_MALE) && mult < 40) mult = 40;
			}
			//v1.1.14 _l̓{@UɂĂ݂
			if(mode == HISSATSU_GION)
			{
				monster_race *r_ptr = &r_info[m_ptr->r_idx];
				if((r_ptr->flags1 & RF1_FEMALE) && mult < 30) mult = 30;
			}

			/* Force Weapon */
			///mod150808 AX͖
			if ((p_ptr->pclass != CLASS_ALICE) && (p_ptr->pclass != CLASS_SAMURAI) && (p_ptr->pclass != CLASS_MARTIAL_ARTIST) && (have_flag(flgs, TR_FORCE_WEAPON)) && (p_ptr->csp > (o_ptr->dd * o_ptr->ds / 5)))
			{
				p_ptr->csp -= (1+(o_ptr->dd * o_ptr->ds / 5));
				p_ptr->redraw |= (PR_MANA);
				mult = mult * 3 / 2 + 20;
			}




			/*:::ꏈ*/
			/* Hack -- The Nothung cause special damage to Fafner */
			///item mon m[gDOt@ti[ɑ_[W^鏈
			if ((o_ptr->name1 == ART_NOTHUNG) && (m_ptr->r_idx == MON_FAFNER))
				mult = 150;
			break;
		}
	}
	if (mult > 150) mult = 150;

	/* Return the total damage */
	return (tdam * mult / 10);
}


/*
 * Search for hidden things
 */
/*:::gbvAgbvABhA*/
static void discover_hidden_things(int y, int x)
{
	s16b this_o_idx, next_o_idx = 0;

	cave_type *c_ptr;

	/* Access the grid */
	c_ptr = &cave[y][x];

	/* Invisible trap */
	if (c_ptr->mimic && is_trap(c_ptr->feat))
	{
		/* Pick a trap */
		disclose_grid(y, x);

		/* Message */
		msg_print(_("gbv𔭌B", "You have found a trap."));

		/* Disturb */
		disturb(0, 1);
	}

	/* Secret door */
	if (is_hidden_door(c_ptr))
	{
		/* Message */
		msg_print(_("BhA𔭌B", "You have found a secret door."));

		/* Disclose */
		disclose_grid(y, x);

		/* Disturb */
		disturb(0, 0);
	}

	/* Scan all objects in the grid */
	for (this_o_idx = c_ptr->o_idx; this_o_idx; this_o_idx = next_o_idx)
	{
		object_type *o_ptr;

		/* Acquire object */
		o_ptr = &o_list[this_o_idx];

		/* Acquire next object */
		next_o_idx = o_ptr->next_o_idx;

		/* Skip non-chests */
		if (o_ptr->tval != TV_CHEST) continue;

		/* Skip non-trapped chests */
		/*:::㩂邩ǂ͔pvalŌ܂炵*/
		if (!chest_traps[o_ptr->pval]) continue;

		/* Identify once */
		if (!object_is_known(o_ptr))
		{
			/* Message */
			if(o_ptr->pval < 0 && !chest_traps[0-o_ptr->pval]) msg_print("͊JĂSB");
			else msg_print(_("Ɏd|ꂽgbv𔭌I", "You have discovered a trap on the chest!"));

			/* Know the trap */
			object_known(o_ptr);

			/* Notice it */
			disturb(0, 0);
		}
	}
}
/*:::TZ\ɂBn`*/
void search(void)
{
	int i, chance;

	/* Start with base search ability */
	chance = p_ptr->skill_srh;

	/* Penalize various conditions */
	if (p_ptr->blind || no_lite()) chance = chance / 10;
	if (p_ptr->confused || p_ptr->image) chance = chance / 10;

	/* Search the nearby grids, which are always in bounds */
	for (i = 0; i < 9; ++ i)
	{
		/* Sometimes, notice things */
		if (randint0(100) < chance)
		{
			discover_hidden_things(py + ddy_ddd[i], px + ddx_ddd[i]);
		}
	}
}


/*
 * Helper routine for py_pickup() and py_pickup_floor().
 *
 * Add the given dungeon object to the character's inventory.
 *
 * Delete the object afterwards.
 */
/*:::ACeォUbNɓ鏈@UbNɋ󂫂ƊmFς݂ł邱*/
void py_pickup_aux(int o_idx)
{
	int slot;

#ifdef JP
/*
 * ACeEۂɁuQ̃P[LĂv
 * "You have two cakes." ƃACeE̍v݂̂̕\IWi
 * Aa
 * ƂwÊŁAu`EA`ĂvƂ\
 * ɂĂB̂߂̔zB
 */
	char o_name[MAX_NLEN];
	char old_name[MAX_NLEN];
	char kazu_str[80];
	int hirottakazu;
	bool moon_vault_trap = FALSE;
#else
	char o_name[MAX_NLEN];
#endif

	object_type *o_ptr;

	o_ptr = &o_list[o_idx];

	//sۓWpACe
	if(p_ptr->inside_quest == QUEST_MOON_VAULT && o_ptr->marked & OM_SPECIAL_FLAG)
		moon_vault_trap = TRUE;
	//󕨌ɁȂ(inven_carry()̂ƂmarkedNÂcheck_find_art_quest_completion()͎gȂ)
	else if(p_ptr->inside_quest == QUEST_VAULT && o_ptr->marked & OM_SPECIAL_FLAG)
		complete_quest(QUEST_VAULT);



#ifdef JP
	/* Describe the object */
	object_desc(old_name, o_ptr, OD_NAME_ONLY);
	object_desc_kosuu(kazu_str, o_ptr);
	hirottakazu = o_ptr->number;
#endif
	/* Carry the object */
	/*:::UbNɃACe*/
	slot = inven_carry(o_ptr);

	/* Get the object again */
	o_ptr = &inventory[slot];

	/* Delete the object */
	/*:::̃ACe*/
	delete_object_idx(o_idx);

		///system i֘AȂ
	if (p_ptr->pseikaku == SEIKAKU_MUNCHKIN)
	{
		bool old_known = identify_item(o_ptr);

		/* Auto-inscription/destroy */
		autopick_alter_item(slot, (bool)(destroy_identify && !old_known));

		/* If it is destroyed, don't pick it up */
		if (o_ptr->marked & OM_AUTODESTROY) return;
	}

	/* Describe the object */
	object_desc(o_name, o_ptr, 0);

	/* Message */

#ifdef JP
///msg131223
#if 0
	if ((o_ptr->name1 == ART_CRIMSON) && (p_ptr->pseikaku == SEIKAKU_COMBAT))
	{
		msg_format("āA%śwN]xɓꂽB", player_name);
		msg_print("Awׂ̃T[ygx̕X^[A");
		msg_format("%sɏPDDD", player_name);
	}
	else
#endif
	{
		if (plain_pickup)
		{
			msg_format("%s(%c)ĂB",o_name, index_to_label(slot));
		}
		else
		{
			if (o_ptr->number > hirottakazu) {
			    msg_format("%sEāA%s(%c)ĂB",
			       kazu_str, o_name, index_to_label(slot));
			} else {
				msg_format("%s(%c)EB", o_name, index_to_label(slot));
			}
		}
	}
	strcpy(record_o_name, old_name);
#else
	msg_format("You have %s (%c).", o_name, index_to_label(slot));
	strcpy(record_o_name, o_name);
#endif
	record_turn = turn;



	check_find_art_quest_completion(o_ptr);

	if(moon_vault_trap) activate_moon_vault_trap();


}


/*
 * Player "wants" to pick up an object or gold.
 * Note that we ONLY handle things that can be picked up.
 * See "move_player()" for handling of other things.
 */
/*:::ACeɑ΂鏈*/
void carry(bool pickup)
{
	cave_type *c_ptr = &cave[py][px];

	s16b this_o_idx, next_o_idx = 0;

	char	o_name[MAX_NLEN];

	/* Recenter the map around the player */
	verify_panel();

	/* Update stuff */
	p_ptr->update |= (PU_MONSTERS);

	/* Redraw map */
	p_ptr->redraw |= (PR_MAP);

	/* Window stuff */
	p_ptr->window |= (PW_OVERHEAD);

	/* Handle stuff */
	handle_stuff();

	/* Automatically pickup/destroy/inscribe items */
	autopick_pickup_items(c_ptr);


#ifdef ALLOW_EASY_FLOOR

	if (easy_floor)
	{
		py_pickup_floor(pickup);
		return;
	}

#endif /* ALLOW_EASY_FLOOR */

	/* Scan the pile of objects */
	for (this_o_idx = c_ptr->o_idx; this_o_idx; this_o_idx = next_o_idx)
	{
		object_type *o_ptr;

		/* Acquire object */
		o_ptr = &o_list[this_o_idx];

/*:::`*/
#ifdef ALLOW_EASY_SENSE /* TNB */

		/* Option: Make item sensing easy */
		if (easy_sense)
		{
			/* Sense the object */
			(void)sense_object(o_ptr);
		}

#endif /* ALLOW_EASY_SENSE -- TNB */

		/* Describe the object */
		object_desc(o_name, o_ptr, 0);

		/* Acquire next object */
		next_o_idx = o_ptr->next_o_idx;

		/* Hack -- disturb */
		disturb(0, 0);

		///sys item IɏE@PACeƂȂ炱
		/* Pick up gold */
		if (o_ptr->tval == TV_GOLD)
		{
			int value = (long)o_ptr->pval;

			/* Delete the gold */
			delete_object_idx(this_o_idx);

			/* Message */
#ifdef JP
		msg_format(" $%ld ̉l%sB",
			   (long)value, o_name);
#else
			msg_format("You collect %ld gold pieces worth of %s.",
				   (long)value, o_name);
#endif


			sound(SOUND_SELL);

			/* Collect the gold */
			p_ptr->au += value;

			/* Redraw gold */
			p_ptr->redraw |= (PR_GOLD);

			/* Window stuff */
			p_ptr->window |= (PW_PLAYER);
		}

		/* Pick up objects */
		else
		{
			/* Hack - some objects were handled in autopick_pickup_items(). */
			if (o_ptr->marked & OM_NOMSG)
			{
				/* Clear the flag. */
				o_ptr->marked &= ~OM_NOMSG;
			}
			/* Describe the object */
			else if (!pickup)
			{
#ifdef JP
				msg_format("%sB", o_name);
#else
				msg_format("You see %s.", o_name);
#endif

			}

			/* Note that the pack is too full */
			else if (!inven_carry_okay(o_ptr))
			{
#ifdef JP
				msg_format("UbNɂ%s錄ԂȂB", o_name);
#else
				msg_format("You have no room for %s.", o_name);
#endif

			}

			/* Pick up the item (if requested and allowed) */
			else
			{
				int okay = TRUE;

				/* Hack -- query every item */
				if (carry_query_flag)
				{
					char out_val[MAX_NLEN+20];
#ifdef JP
					sprintf(out_val, "%sE܂? ", o_name);
#else
					sprintf(out_val, "Pick up %s? ", o_name);
#endif

					okay = get_check(out_val);
				}

				/* Attempt to pick up an object. */
				if (okay)
				{
					/* Pick up the object */
					py_pickup_aux(this_o_idx);
				}
			}
		}
	}
}


/*
 * Determine if a trap affects the player.
 * Always miss 5% of the time, Always hit 5% of the time.
 * Otherwise, match trap power against player armor.
 */
/*:::gbv̖B
 *:::melee1.cɓ̊֐A̓X^[ɑŌU鎞̖ɎgB*/
static int check_hit(int power)
{
	int k, ac;

	/* Percentile dice */
	k = randint0(100);

	/* Hack -- 5% hit, 5% miss */
	if (k < 10) return (k < 5);

	//if (p_ptr->pseikaku == SEIKAKU_NAMAKE)
	//	if (one_in_(20)) return (TRUE);

	/* Paranoia -- No power */
	if (power <= 0) return (FALSE);

	/* Total armor */
	ac = p_ptr->ac + p_ptr->to_a;

	/* Power competes against Armor */
	if (randint1(power) > ((ac * 3) / 4)) return (TRUE);

	/* Assume miss */
	return (FALSE);
}



/*
 * Handle player hitting a real trap
 */
/*:::gbvɂꍇ*/
///mod160813 TȌ̂extern
void hit_trap(bool break_trap)
{
	int i, num, dam;
	int x = px, y = py;

	/* Get the cave grid */
	cave_type *c_ptr = &cave[y][x];
	feature_type *f_ptr = &f_info[c_ptr->feat];
	int trap_feat_type = have_flag(f_ptr->flags, FF_TRAP) ? f_ptr->subtype : NOT_TRAP;

#ifdef JP
	cptr name = "gbv";
#else
	cptr name = "a trap";
#endif

	/* Disturb the player */
	disturb(0, 1);

	if(world_player || SAKUYA_WORLD)
	{
		msg_print("gbv͍쓮ȂB");
		return;
	}


	cave_alter_feat(y, x, FF_HIT_TRAP);

	if(p_ptr->pclass == CLASS_FLAN) break_trap = TRUE;
	if(p_ptr->pseikaku == SEIKAKU_BERSERK && randint1(p_ptr->lev) > 10 )break_trap = TRUE;

	/* Analyze XXX XXX XXX */
	switch (trap_feat_type)
	{
		case TRAP_TRAPDOOR:
		{
			if (p_ptr->levitation)
			{
#ifdef JP
				msg_print("Ƃ˂щzB");
#else
				msg_print("You fly over a trap door.");
#endif

			}
			else
			{
#ifdef JP
				msg_print("Ƃ˂ɗI");
				///msg131223
				//if ((p_ptr->pseikaku == SEIKAKU_COMBAT) || (inventory[INVEN_BOW].name1 == ART_CRIMSON))
				//	msg_print("`I");
#else
				msg_print("You have fallen through a trap door!");
#endif

				sound(SOUND_FALL);
				dam = damroll(2, 8);
#ifdef JP
				name = "Ƃ";
#else
				name = "a trap door";
#endif

				take_hit(DAMAGE_NOESCAPE, dam, name, -1);

				/* Still alive and autosave enabled */
				if (autosave_l && (p_ptr->chp >= 0))
					do_cmd_save_game(TRUE);

#ifdef JP
				do_cmd_write_nikki(NIKKI_BUNSHOU, 0, "Ƃ˂ɗ");
#else
				do_cmd_write_nikki(NIKKI_BUNSHOU, 0, "You have fallen through a trap door!");
#endif
				///mod160813 NGXgtAŃgbvhAɗƂ̏ǉ@TOp
				if(EXTRA_MODE)
				{
					prepare_change_floor_mode(CFM_DOWN | CFM_RAND_PLACE | CFM_NO_RETURN);
					if(INSIDE_EXTRA_QUEST)
					{
						leave_quest_check();
						p_ptr->inside_quest = 0;
					}
				}
				else
				{
					prepare_change_floor_mode(CFM_SAVE_FLOORS | CFM_DOWN | CFM_RAND_PLACE | CFM_RAND_CONNECT);
					if(p_ptr->inside_quest)
					{
						leave_quest_check();
						p_ptr->inside_quest = 0;
					}
				}

				/* Leaving */
				p_ptr->leaving = TRUE;
			}
			break;
		}

		case TRAP_PIT:
		{
			if (p_ptr->levitation)
			{
#ifdef JP
				msg_print("ƂщzB");
#else
				msg_print("You fly over a pit trap.");
#endif

			}
			else
			{
#ifdef JP
				msg_print("ƂɗĂ܂I");
#else
				msg_print("You have fallen into a pit!");
#endif

				dam = damroll(2, 6);
#ifdef JP
				name = "Ƃ";
#else
				name = "a pit trap";
#endif

				take_hit(DAMAGE_NOESCAPE, dam, name, -1);
			}
			break;
		}

		case TRAP_SPIKED_PIT:
		{
			if (p_ptr->levitation)
			{
#ifdef JP
				msg_print("gQ̂闎ƂщzB");
#else
				msg_print("You fly over a spiked pit.");
#endif

			}
			else
			{
#ifdef JP
				msg_print("XpCN~ꂽƂɗĂ܂I");
#else
				msg_print("You fall into a spiked pit!");
#endif


				/* Base damage */
#ifdef JP
				name = "Ƃ";
#else
				name = "a pit trap";
#endif

				dam = damroll(2, 6);

				/* Extra spike damage */
				if (randint0(100) < 50)
				{
#ifdef JP
					msg_print("XpCNhI");
#else
					msg_print("You are impaled!");
#endif


#ifdef JP
					name = "gQ̂闎Ƃ";
#else
					name = "a spiked pit";
#endif

					dam = dam * 2;
					(void)set_cut(p_ptr->cut + randint1(dam));
				}

				/* Take the damage */
				take_hit(DAMAGE_NOESCAPE, dam, name, -1);
			}
			break;
		}

		case TRAP_POISON_PIT:
		{
			if (p_ptr->levitation)
			{
#ifdef JP
				msg_print("gQ̂闎ƂщzB");
#else
				msg_print("You fly over a spiked pit.");
#endif

			}
			else
			{
#ifdef JP
			msg_print("XpCN~ꂽƂɗĂ܂I");
#else
				msg_print("You fall into a spiked pit!");
#endif


				/* Base damage */
				dam = damroll(2, 6);

#ifdef JP
				name = "Ƃ";
#else
				name = "a pit trap";
#endif


				/* Extra spike damage */
				if (randint0(100) < 50)
				{
#ifdef JP
					msg_print("łhꂽXpCNhI");
#else
					msg_print("You are impaled on poisonous spikes!");
#endif


#ifdef JP
					name = "gQ̂闎Ƃ";
#else
					name = "a spiked pit";
#endif


					dam = dam * 2;
					(void)set_cut(p_ptr->cut + randint1(dam));

					if (p_ptr->resist_pois || IS_OPPOSE_POIS())
					{
#ifdef JP
						msg_print("ł̉e͂ȂI");
#else
						msg_print("The poison does not affect you!");
#endif

					}

					else
					{
						dam = dam * 2;
						(void)set_poisoned(p_ptr->poisoned + randint1(dam));
					}
				}

				/* Take the damage */
				take_hit(DAMAGE_NOESCAPE, dam, name, -1);
			}

			break;
		}

		case TRAP_TY_CURSE:
		{
#ifdef JP
			msg_print("sJbƌI");
#else
			msg_print("There is a flash of shimmering light!");
#endif

			num = 2 + randint1(3);
			for (i = 0; i < num; i++)
			{
				(void)summon_specific(0, y, x, dun_level, 0, (PM_ALLOW_GROUP | PM_ALLOW_UNIQUE | PM_NO_PET));
			}

			if (dun_level > randint1(100)) /* No nasty effect for low levels */
			{
				bool stop_ty = FALSE;
				int count = 0;

				do
				{
					stop_ty = activate_ty_curse(stop_ty, &count);
				}
				while (one_in_(6));
			}
			break;
		}

		case TRAP_TELEPORT:
		{
#ifdef JP
			msg_print("e|[gEgbvɂЂI");
#else
			msg_print("You hit a teleport trap!");
#endif

			teleport_player(100, TELEPORT_PASSIVE);
			break;
		}

		case TRAP_FIRE:
		{
#ifdef JP
			msg_print("ɕ܂ꂽI");
#else
			msg_print("You are enveloped in flames!");
#endif

			dam = damroll(4, 6);
#ifdef JP
			(void)fire_dam(dam, "̃gbv", -1);
#else
			(void)fire_dam(dam, "a fire trap", -1);
#endif

			break;
		}

		case TRAP_ACID:
		{
#ifdef JP
			msg_print("_ꂽI");
#else
			msg_print("You are splashed with acid!");
#endif

			dam = damroll(4, 6);
#ifdef JP
			(void)acid_dam(dam, "_̃gbv", -1);
#else
			(void)acid_dam(dam, "an acid trap", -1);
#endif

			break;
		}

		case TRAP_SLOW:
		{
			if (check_hit(125))
			{
#ifdef JP
				msg_print("ȃ_[cłĎhI");
#else
				msg_print("A small dart hits you!");
#endif

				dam = damroll(1, 4);
#ifdef JP
				take_hit(DAMAGE_ATTACK, dam, "_[c", -1);
#else
				take_hit(DAMAGE_ATTACK, dam, "a dart trap", -1);
#endif

				if (!CHECK_MULTISHADOW()) (void)set_slow(p_ptr->slow + randint0(20) + 20, FALSE);
			}
			else
			{
#ifdef JP
				msg_print("ȃ_[cłIA^ǂȂB");
#else
				msg_print("A small dart barely misses you.");
#endif

			}
			break;
		}

		case TRAP_LOSE_STR:
		{
			if (check_hit(125))
			{
#ifdef JP
				msg_print("ȃ_[cłĎhI");
#else
				msg_print("A small dart hits you!");
#endif

				dam = damroll(1, 4);
#ifdef JP
				take_hit(DAMAGE_ATTACK, dam, "_[c", -1);
#else
				take_hit(DAMAGE_ATTACK, dam, "a dart trap", -1);
#endif

				if (!CHECK_MULTISHADOW()) (void)do_dec_stat(A_STR);
			}
			else
			{
#ifdef JP
				msg_print("ȃ_[cłIA^ǂȂB");
#else
				msg_print("A small dart barely misses you.");
#endif

			}
			break;
		}

		case TRAP_LOSE_DEX:
		{
			if (check_hit(125))
			{
#ifdef JP
				msg_print("ȃ_[cłĎhI");
#else
				msg_print("A small dart hits you!");
#endif

				dam = damroll(1, 4);
#ifdef JP
				take_hit(DAMAGE_ATTACK, dam, "_[c", -1);
#else
				take_hit(DAMAGE_ATTACK, dam, "a dart trap", -1);
#endif

				if (!CHECK_MULTISHADOW()) (void)do_dec_stat(A_DEX);
			}
			else
			{
#ifdef JP
				msg_print("ȃ_[cłIA^ǂȂB");
#else
				msg_print("A small dart barely misses you.");
#endif

			}
			break;
		}

		case TRAP_LOSE_CON:
		{
			if (check_hit(125))
			{
#ifdef JP
				msg_print("ȃ_[cłĎhI");
#else
				msg_print("A small dart hits you!");
#endif

				dam = damroll(1, 4);
#ifdef JP
				take_hit(DAMAGE_ATTACK, dam, "_[c", -1);
#else
				take_hit(DAMAGE_ATTACK, dam, "a dart trap", -1);
#endif

				if (!CHECK_MULTISHADOW()) (void)do_dec_stat(A_CON);
			}
			else
			{
#ifdef JP
				msg_print("ȃ_[cłIA^ǂȂB");
#else
				msg_print("A small dart barely misses you.");
#endif

			}
			break;
		}

		case TRAP_BLIND:
		{
#ifdef JP
			msg_print("KXɕݍ܂ꂽI");
#else
			msg_print("A black gas surrounds you!");
#endif

			if (!p_ptr->resist_blind)
			{
				(void)set_blind(p_ptr->blind + randint0(50) + 25);
			}
			break;
		}

		case TRAP_CONFUSE:
		{
#ifdef JP
			msg_print("߂KXɕݍ܂ꂽI");
#else
			msg_print("A gas of scintillating colors surrounds you!");
#endif

			if (!p_ptr->resist_conf)
			{
				(void)set_confused(p_ptr->confused + randint0(20) + 10);
			}
			break;
		}

		case TRAP_POISON:
		{
#ifdef JP
			msg_print("hIȗΐF̃KXɕݍ܂ꂽI");
#else
			msg_print("A pungent green gas surrounds you!");
#endif

			if (!p_ptr->resist_pois && !IS_OPPOSE_POIS())
			{
				(void)set_poisoned(p_ptr->poisoned + randint0(20) + 10);
				if(p_ptr->muta2 & MUT2_ASTHMA) set_asthma(p_ptr->asthma + 3000);
			}
			break;
		}

		case TRAP_SLEEP:
		{
#ifdef JP
			msg_print("Ȕɕ܂ꂽI");
#else
			msg_print("A strange white mist surrounds you!");
#endif

			if (!p_ptr->free_act)
			{
#ifdef JP
msg_print("Ȃ͖ɏAB");
#else
				msg_print("You fall asleep.");
#endif


				if (ironman_nightmare)
				{
#ifdef JP
msg_print("g̖т悾iɕ񂾁B");
#else
					msg_print("A horrible vision enters your mind.");
#endif


					/* Pick a nightmare */
					get_mon_num_prep(get_nightmare, NULL);

					/* Have some nightmares */
					have_nightmare(get_mon_num(MAX_DEPTH));

					/* Remove the monster restriction */
					get_mon_num_prep(NULL, NULL);
				}
				(void)set_paralyzed(p_ptr->paralyzed + randint0(10) + 5);
			}
			break;
		}

		case TRAP_TRAPS:
		{
#ifdef JP
msg_print("܂΂䂢MI");
#else
			msg_print("There is a bright flash of light!");
#endif

			/* Make some new traps */
			project(0, 1, y, x, 0, GF_MAKE_TRAP, PROJECT_HIDE | PROJECT_JUMP | PROJECT_GRID, -1);

			break;
		}

		case TRAP_ALARM:
		{
#ifdef JP
			msg_print("܂苿I");
#else
			msg_print("An alarm sounds!");
#endif

			aggravate_monsters(0,TRUE);

			break;
		}

		case TRAP_OPEN:
		{
#ifdef JP
			msg_print("剹Ƌɂ܂̕ǂꂽI");
#else
			msg_print("Suddenly, surrounding walls are opened!");
#endif
			(void)project(0, 3, y, x, 0, GF_DISINTEGRATE, PROJECT_GRID | PROJECT_HIDE, -1);
			(void)project(0, 3, y, x - 4, 0, GF_DISINTEGRATE, PROJECT_GRID | PROJECT_HIDE, -1);
			(void)project(0, 3, y, x + 4, 0, GF_DISINTEGRATE, PROJECT_GRID | PROJECT_HIDE, -1);
			aggravate_monsters(0,TRUE);

			break;
		}

		case TRAP_ARMAGEDDON:
		{
			static int levs[10] = {0, 0, 20, 10, 5, 3, 2, 1, 1, 1};
			int evil_idx = 0, good_idx = 0;

			int lev;
#ifdef JP
			msg_print("ˑRVE̐푈Ɋ܂ꂽI");
#else
			msg_print("Suddenly, you are surrounded by immotal beings!");
#endif

			/* Summon Demons and Angels */
			for (lev = dun_level; lev >= 20; lev -= 1 + lev/16)
			{
				num = levs[MIN(lev/10, 9)];
				for (i = 0; i < num; i++)
				{
					int x1 = rand_spread(x, 7);
					int y1 = rand_spread(y, 5);

					/* Skip illegal grids */
					if (!in_bounds(y1, x1)) continue;

					/* Require line of projection */
					if (!projectable(py, px, y1, x1)) continue;

					if (summon_specific(0, y1, x1, lev, SUMMON_ARMAGE_EVIL, (PM_NO_PET)))
						evil_idx = hack_m_idx_ii;

					if (summon_specific(0, y1, x1, lev, SUMMON_ARMAGE_GOOD, (PM_NO_PET)))
					{
						good_idx = hack_m_idx_ii;
					}

					/* Let them fight each other */
					if (evil_idx && good_idx)
					{
						monster_type *evil_ptr = &m_list[evil_idx];
						monster_type *good_ptr = &m_list[good_idx];
						evil_ptr->target_y = good_ptr->fy;
						evil_ptr->target_x = good_ptr->fx;
						good_ptr->target_y = evil_ptr->fy;
						good_ptr->target_x = evil_ptr->fx;
					}
				}
			}
			break;
		}

		case TRAP_PIRANHA:
		{
#ifdef JP
			msg_print("ˑRǂ琅oIsjAI");
#else
			msg_print("Suddenly, the room is filled with water with piranhas!");
#endif

			/* Water fills room */
			fire_ball_hide(GF_WATER_FLOW, 0, 1, 10);

			/* Summon Piranhas */
			num = 1 + dun_level/20;
			for (i = 0; i < num; i++)
			{
				(void)summon_specific(0, y, x, dun_level, SUMMON_PIRANHAS, (PM_ALLOW_GROUP | PM_NO_PET));
			}
			break;
		}



		//r[
		case TRAP_BEAM:
		{
			int tmp_y,tmp_x;
			int j,k,dir;
			byte dir_table[8] = {1,2,3,4,6,7,8,9};
			byte dir_init = randint0(8);
			bool flag=FALSE;

			for(i=0;i<8;i++)
			{
				//_ȕp߂
				k = dir_init + i;
				if(k>=8) k -= 8;
				dir=dir_table[k];

				//x,y(̈ʒû͂)1ObhȏJĕǂȂǂʒuT
				for(j=1;j<16;j++)
				{
					tmp_x = x + ddx[dir] * j;
					tmp_y = y + ddy[dir] * j;

					if(!in_bounds(tmp_y,tmp_x)) break;

					if(!cave_have_flag_bold(tmp_y,tmp_x,FF_PROJECT))
					{
						if(j==1) break;
						else
						{
							tmp_x = x + ddx[dir] * (j-1);
							tmp_y = y + ddy[dir] * (j-1);
							flag = TRUE;
							break;
						}
					}

				}
				if(flag) break;
			}

			//xǂꏊꍇ灗̈ʒuփ[U[
			if(flag)
			{
				int typ;
				int flg = PROJECT_BEAM | PROJECT_KILL | PROJECT_THRU | PROJECT_PLAYER;
				int dam = dun_level * 2 + randint1(50);

				if(randint1(dun_level+50) > 50) typ = GF_NUKE;
				else typ = GF_FIRE;

				//-hack- ʏproject()̓X^[̈ʒu炵Ȃ̂ŃO[oϐgėO@@z܂ :)
				hack_project_start_x = tmp_x;
				hack_project_start_y = tmp_y;

				if(one_in_(7))
					msg_print("*ɏĂ܂[*");
				else
					msg_print("ǂ炩r[łI");

				(void)project(PROJECT_WHO_TRAP_BEAM, 0, py, px, dam, typ, flg, -1);
				hack_project_start_x = 0;
				hack_project_start_y = 0;

			}
			else
			{
				msg_print("NȂ悤B");
			}
	
			break;
		}




	}

	if (break_trap && is_trap(c_ptr->feat))
	{
		cave_alter_feat(y, x, FF_DISARM);
#ifdef JP
		msg_print("gbv𕲍ӂB");
#else
		msg_print("You destroyed the trap.");
#endif
	}
}

/*:::I[ɂ_[W󂯂鏈*/
///mon I[_[W
///mod140211 ̃\[Xt@Cg߂staticOB
void touch_zap_player(monster_type *m_ptr)
{
	int aura_damage = 0;
	monster_race *r_ptr = &r_info[m_ptr->r_idx];

	//hbyQK[ꏈ
	if(r_ptr->flags7 & RF7_DOPPELGANGER)
	{
		msg_print("Ȃ͎̃hbyQK[ɐGĂ܂I");
		take_hit(DAMAGE_LOSELIFE,p_ptr->chp,"hbyQK[Ƃ̐ڐG",-1);
		set_stun(100+randint0(3));

		return;
	}

	if (r_ptr->flags2 & RF2_AURA_FIRE)
	{
		if (!p_ptr->immune_fire)
		{
			char aura_dam[80];

			aura_damage = damroll(1 + (r_ptr->level / 26), 1 + (r_ptr->level / 17));

			/* Hack -- Get the "died from" name */
			monster_desc(aura_dam, m_ptr, MD_IGNORE_HALLU | MD_ASSUME_VISIBLE | MD_INDEF_VISIBLE);

#ifdef JP
			msg_print("ˑRƂĂMȂI");
#else
			msg_print("You are suddenly very hot!");
#endif
			/*
			if (prace_is_(RACE_ENT)) aura_damage += aura_damage / 3;
			if (IS_OPPOSE_FIRE()) aura_damage = (aura_damage + 2) / 3;
			if (p_ptr->resist_fire) aura_damage = (aura_damage + 2) / 3;
			*/

			///mod140302 f_Aϐ
			aura_damage = mod_fire_dam(aura_damage);

			take_hit(DAMAGE_NOESCAPE, aura_damage, aura_dam, -1);
			if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flags2 |= RF2_AURA_FIRE;
			handle_stuff();
		}
	}
	///mod131231 X^[tOύX
	if (r_ptr->flags2 & RF2_AURA_COLD)
	//if (r_ptr->flags3 & RF3_AURA_COLD)
	{
		if (!p_ptr->immune_cold)
		{
			char aura_dam[80];

			aura_damage = damroll(1 + (r_ptr->level / 26), 1 + (r_ptr->level / 17));

			/* Hack -- Get the "died from" name */
			monster_desc(aura_dam, m_ptr, MD_IGNORE_HALLU | MD_ASSUME_VISIBLE | MD_INDEF_VISIBLE);

#ifdef JP
			msg_print("ˑRƂĂȂI");
#else
			msg_print("You are suddenly very cold!");
#endif
			/*
			if (IS_OPPOSE_COLD()) aura_damage = (aura_damage + 2) / 3;
			if (p_ptr->resist_cold) aura_damage = (aura_damage + 2) / 3;
			*/
			///mod140302 f_Aϐ
			aura_damage = mod_cold_dam(aura_damage);

			take_hit(DAMAGE_NOESCAPE, aura_damage, aura_dam, -1);
///mod131231 X^[tOύX
			if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flags2 |= RF2_AURA_COLD;
			//if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flags3 |= RF3_AURA_COLD;
			handle_stuff();
		}
	}

	if (r_ptr->flags2 & RF2_AURA_ELEC)
	{
		if (!p_ptr->immune_elec)
		{
			char aura_dam[80];

			aura_damage = damroll(1 + (r_ptr->level / 26), 1 + (r_ptr->level / 17));

			/* Hack -- Get the "died from" name */
			monster_desc(aura_dam, m_ptr, MD_IGNORE_HALLU | MD_ASSUME_VISIBLE | MD_INDEF_VISIBLE);

			/*
			if (IS_OPPOSE_ELEC()) aura_damage = (aura_damage + 2) / 3;
			if (p_ptr->resist_elec) aura_damage = (aura_damage + 2) / 3;
			*/
			///mod140302 f_Aϐ
			aura_damage = mod_elec_dam(aura_damage);


#ifdef JP
			msg_print("dI");
#else
			msg_print("You get zapped!");
#endif

			take_hit(DAMAGE_NOESCAPE, aura_damage, aura_dam, -1);
			if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flags2 |= RF2_AURA_ELEC;
			handle_stuff();
		}
	}
}

/*:::ψق̕ʂɂU:::*/
/*:::m_idx:X^[m_list[]ID
 *:::attack:ʂ̎
 *:::fear X^[|ǂ
 *:::mdeath X^[񂾂ǂ
 */
///sys mutation ψٕʂɂU@ǉiƓ\
///mod140323 ψٕʍU͕ʃ[`ŎA܂͎͂gĂȂ
#if 0
static void natural_attack(s16b m_idx, int attack, bool *fear, bool *mdeath)
{
	int             k, bonus, chance;
	int             n_weight = 0;
	monster_type    *m_ptr = &m_list[m_idx];
	monster_race    *r_ptr = &r_info[m_ptr->r_idx];
	char            m_name[80];

	int             dss, ddd;

	cptr            atk_desc;

	/*:::Uʂɂ_CXƏdʂ*/
	switch (attack)
	{
		case MUT2_HARDHEAD:
			dss = 3;
			ddd = 7;
			n_weight = 5;
#ifdef JP
			atk_desc = "Γ";
#else
			atk_desc = "tail";
#endif

			break;
		case MUT2_HORNS:
			dss = 2;
			ddd = 6;
			n_weight = 15;
#ifdef JP
			atk_desc = "p";
#else
			atk_desc = "horns";
#endif

			break;
		case MUT2_BIGHORN:
			dss = 4;
			ddd = 6;
			n_weight = 30;
#ifdef JP
			atk_desc = "傫Ȋp";
#else
			atk_desc = "beak";
#endif

			break;
		case MUT2_TAIL:
			dss = 1;
			ddd = 4;
			n_weight = 35;
#ifdef JP
			atk_desc = "K";
#else
			atk_desc = "trunk";
#endif

			break;
		case MUT2_BIGTAIL:
			dss = 2;
			ddd = 5;
			n_weight = 5;
#ifdef JP
			atk_desc = "傫ȐK";
#else
			atk_desc = "tentacles";
#endif

			break;
		default:
			dss = ddd = n_weight = 1;
#ifdef JP
			atk_desc = "`̕";
#else
			atk_desc = "undefined body part";
#endif

	}

	/* Extract monster name (or "it") */
	monster_desc(m_name, m_ptr, 0);


	/* Calculate the "attack quality" */
	bonus = p_ptr->to_h_m;
	bonus += (p_ptr->lev * 6 / 5);
	chance = (p_ptr->skill_thn + (bonus * BTH_PLUS_ADJ));

	/* Test for hit */
	/*:::*/
	if ((!(r_ptr->flags2 & RF2_QUANTUM) || !randint0(2)) && test_hit_norm(chance, r_ptr->ac, m_ptr->ml))
	{
		/* Sound */
		sound(SOUND_HIT);

#ifdef JP
		msg_format("%s%sōUB", m_name, atk_desc);
#else
		msg_format("You hit %s with your %s.", m_name, atk_desc);
#endif

		/*:::_CX_[WANeBJ_[WvZ*/
		k = damroll(ddd, dss);
		k = critical_norm(n_weight, bonus, k, (s16b)bonus, 0);

		/* Apply the player damage bonuses */
		k += p_ptr->to_d_m;

		/* No negative damage */
		if (k < 0) k = 0;

		/* Modify the damage */
		k = mon_damage_mod(m_ptr, k, FALSE);
		/*:::EBU[h̓_[W\*/
		/* Complex message */
		if (p_ptr->wizard)
		{
#ifdef JP
				msg_format("%d/%d ̃_[W^B", k, m_ptr->hp);
#else
			msg_format("You do %d (out of %d) damage.", k, m_ptr->hp);
#endif

		}

		/* Anger the monster */
		/*:::G{点*/
		if (k > 0) anger_monster(m_ptr);

		/* Damage, check for fear and mdeath */
		switch (attack)
		{
			case MUT2_HARDHEAD:
				*mdeath = mon_take_hit(m_idx, k, fear, NULL);
				break;
			case MUT2_HORNS:
				*mdeath = mon_take_hit(m_idx, k, fear, NULL);
				break;
			case MUT2_BIGHORN:
				*mdeath = mon_take_hit(m_idx, k, fear, NULL);
				break;
			case MUT2_TAIL:
				*mdeath = mon_take_hit(m_idx, k, fear, NULL);
				break;
			case MUT2_BIGTAIL:
				*mdeath = mon_take_hit(m_idx, k, fear, NULL);
				break;
			default:
				*mdeath = mon_take_hit(m_idx, k, fear, NULL);
		}

		touch_zap_player(m_ptr);
	}
	/* Player misses */
	else
	{
		/* Sound */
		sound(SOUND_MISS);

		/* Message */
#ifdef JP
			msg_format("~XI %sɂ킳ꂽB", m_name);
#else
		msg_format("You miss %s.", m_name);
#endif

	}
}
#endif

//eɓisƂAĂe̎ނɂMELEE_MODE_*Ԃ
int select_gun_melee_mode(void)
{
	object_type *o_ptr;
	int melee_mode[2] = {0,0};
	int slot;
	bool flag_ammo = TRUE;
	int timeout_base, timeout_max;
	
	for(slot = INVEN_RARM;slot <= INVEN_LARM;slot++)
	{
		o_ptr = &inventory[slot];
		if(o_ptr->tval != TV_GUN) continue;

		switch(o_ptr->sval)
		{
		case SV_FIRE_GUN_LUNATIC:
		case SV_FIRE_GUN_HANDGUN:
		case SV_FIRE_GUN_CRIMSON:
		case SV_FIRE_GUN_MAGNUM:
			melee_mode[slot-INVEN_RARM] =  MELEE_MODE_GUN_HANDGUN;
			timeout_base = calc_gun_timeout(o_ptr) * 1000;
			timeout_max = timeout_base * (calc_gun_load_num(o_ptr) - 1); 
			if(o_ptr->timeout > timeout_max) flag_ammo = FALSE;

			break;
		case SV_FIRE_GUN_HUNTING:
		case SV_FIRE_GUN_MUSKET:
		case SV_FIRE_GUN_SHOTGUN:
		case SV_FIRE_GUN_LASER:
			melee_mode[slot-INVEN_RARM] =  MELEE_MODE_GUN_LONGBARREL;
			break;
		case SV_FIRE_GUN_INFANTRY:
			melee_mode[slot-INVEN_RARM] =  MELEE_MODE_GUN_BAYONET;
			break;
		case SV_FIRE_GUN_ROCKET:
			melee_mode[slot-INVEN_RARM] =  MELEE_MODE_GUN_LAUNCHER;
			break;
		default:
			msg_print("ERROR:select_gun_melee_mode()ɂ̏ȅo^ĂȂ");
			return 0;
		}
	}
	//eŊiƏe̋Z\Ƃio悤ɂĂ݂
	//v1.1.21 ceƂȂƂɂ
	if(melee_mode[0] == MELEE_MODE_GUN_HANDGUN && melee_mode[1] == MELEE_MODE_GUN_HANDGUN
		&& ref_skill_exp(SKILL_MARTIALARTS) >= 4800 && ref_skill_exp(TV_GUN) >= 4800)
	{
		if(flag_ammo) return MELEE_MODE_GUN_TWOHAND;
	}

	if(melee_mode[0] && (!melee_mode[1] || one_in_(2)))
		return melee_mode[0];
	else
		return melee_mode[1];

}

/*:::ōUƂ̃bZ[WuUvύXB*/
///pend nx═_CXmodeɉĂƔhȕ\ɂĂ
cptr msg_py_atk(object_type *o_ptr,int mode)
{
	int tv = o_ptr->tval;
	int sv = o_ptr->sval;
	if(!o_ptr->k_idx)
	{
		msg_print("ERROR:ĂȂ̂msg_py_atk()Ă΂ꂽ");
		return "";
	}

	if(!ex_attack_msg) return "UB";

	if(tv == TV_KNIFE)
	{
		if(sv == SV_WEAPON_DOKUBARI)
			 return "ŉtHjŎhB";
		else
		{
			if(one_in_(2)) return "aB";
			return "˂B";
		}
	}

	if(tv == TV_SWORD)
	{
		//匕
		if(sv == SV_WEAPON_CLAYMORE || sv == SV_WEAPON_GREAT_SWORD || sv == SV_WEAPON_EXECUTIONERS_SWORD)
		{
			if(one_in_(4)) return "aB";
			if(one_in_(3)) return "֐n@tB";
			 return "֐nU艺낵B";

		}
		//hˌ
		else if(sv == SV_WEAPON_RAPIER)
		{
			if(one_in_(4)) return "aB";
			return "˂B";

		}
		else
		{
			if(one_in_(4)) return "aB";
			if(one_in_(3)) return "֎aB";
			if(one_in_(2)) return "˂B";
			return "֎a肩B";
		}


	}
	if(tv == TV_KATANA)
	{
			if(one_in_(6)) return "֓U艺낵B";
			if(one_in_(5)) return "a􂢂B";
			if(one_in_(4)) return "aB";
			if(one_in_(3)) return "֎aB";
			if(one_in_(2)) return "֓˂B";
			return "֎a肩B";
	}
	if(tv == TV_HAMMER)
	{
		if(sv == SV_WEAPON_FLAIL || sv == SV_WEAPON_BALL_AND_CHAIN)
		{
			if(one_in_(4)) return "֓S𒼌I";
			if(one_in_(3)) return "֕U񂵂B";
			return "B";
		}
		else
		{
			if(one_in_(4)) return "B";
			if(one_in_(3)) return "֕U艺낵B";
			if(one_in_(2)) return "B";
			return "łB";
		}
	}
	if(tv == TV_STICK)
	{
		if(one_in_(4)) return "B";
		if(one_in_(3)) return "łB";
		if(one_in_(2)) return "˂B";
		return "ガB";
	}

	if(tv == TV_AXE)
	{
		if(one_in_(2)) return "@aB";
		return "֕U艺낵B";
	}

	if(tv == TV_SPEAR)
	{
		if(!one_in_(4)) return "˂B";
		return "ガB";
	}

	if(tv == TV_POLEARM)
	{
		if(sv == SV_WEAPON_WAR_SCYTHE || sv == SV_WEAPON_SCYTHE_OF_SLICING)
		{
			if(one_in_(2)) return "a􂢂B";
			return "ガB";
		}
		if(sv == SV_WEAPON_GLAIVE || sv == SV_WEAPON_NAGINATA)
		{
			if(one_in_(3)) return "aB";
			if(one_in_(2)) return "֐nU艺낵B";
			return "˂B";
		}
		if(sv == SV_WEAPON_LUCERNE_HAMMER)
		{
			if(one_in_(3)) return "B";
			if(one_in_(2)) return "˂B";
			return "փn}[@tB";
		}
		if(sv == SV_WEAPON_HALBERD)
		{
			if(one_in_(3)) return "ガB";
			if(one_in_(2)) return "˂B";
			return "֐n@tB";
		}


	}

	if(tv == TV_OTHERWEAPON)
	{
		if(sv == SV_OTHERWEAPON_FISHING)
		{
			if(one_in_(10)) return "݂グI";
			if(one_in_(2)) return "@B";
			return "łB";
		}
		else if(sv == SV_OTHERWEAPON_NEEDLE)
		{
			if(one_in_(3)) return "hI";
			if(one_in_(2)) return "˂I";
			return "ɐj˂ĂI";
		}
	}

	return "UB";

}


/*:::@݂̌̏ԂfÚuށv肷*/
//findmode:U[h ̂Ƃ
//  MELEE_FIND_NOHAND@肪gLbNoȂ@U̒ǉUAɉוĂ鎞̊i
//  MELEE_FIND_LONGARM ꂽ}X܂ōUU@ϗe@uLrv͓CV̒ʔw

///mod160111 v1.0.89ŗD揇ʂȂǌ
///mod160325 v1.0.99EXTRA[hΉ̂߂܂
int find_martial_arts_method(int findmode)
{
	int plev = p_ptr->lev;
	bool kick = FALSE;

	if(findmode == MELEE_FIND_NOHAND) kick = TRUE;

/*D1:ϐg*/
	switch(p_ptr->mimic_form)
	{
	case MIMIC_GIGANTIC://剻
		if(kick || one_in_(3))	return MELEE_MODE_GIGA_KICK;
		else			return MELEE_MODE_GIGA_PUNCH;
	case MIMIC_NUE://ʂϐg
		return MELEE_MODE_NUE;
	case MIMIC_BEAST://ȏb
		return MELEE_MODE_BEAST;
	case MIMIC_SLIME://XC
		return MELEE_MODE_SLIME;
	case MIMIC_CAT://L
		return MELEE_MODE_CLAW;
	case MIMIC_DRAGON://
		return MELEE_MODE_DRAGON;
	case MIMIC_MIST://
		return MELEE_MODE_MIST;
	case MIMIC_KOSUZU_HYAKKI://v1.1.37 ϐg
		return MELEE_MODE_HYAKKI;
	default:
		break;
	}

	if (SUPER_SHION) return MELEE_MODE_SUPER_SHION;

/*D2:Ȉꎞ*/
	//ACeJ[huŒ܁uȂȂElSvvLV[ȊOg
	if(findmode == MELEE_FIND_EX_CLAW) return MELEE_MODE_EX_CLAW;

	//EƁumvɂXj[LOU
	if(findmode == MELEE_FIND_SNEAKING_KILL) return MELEE_MODE_SNEAKING;

	//l
	if(p_ptr->kamioroshi & KAMIOROSHI_ATAGO) return MELEE_MODE_ATAGO;
	//ړ
	if(p_ptr->lightspeed) return MELEE_MODE_LIGHTSPEED;
	//فX_uXRAt
	if(p_ptr->pclass == CLASS_BENBEN && music_singing(MUSIC_NEW_TSUKUMO_DOUBLESCORE)) return MELEE_MODE_BENBEN;
	//܋@̂Ƃkickɂ͂ȂȂ͂
	if(p_ptr->clawextend) return MELEE_MODE_EX_CLAW;
	//LrU@ϗe@͓CV@ǉioȂ̂Ńp`̂ ꕔNX͐pUD
	if(findmode == MELEE_FIND_LONGARM)
	{
		if(p_ptr->pclass == CLASS_REMY) return MELEE_MODE_REMY_OTHER;
		else if(p_ptr->pclass == CLASS_MINDCRAFTER) return MELEE_MODE_MIND;
		else if(p_ptr->pclass == CLASS_MAMIZOU) return MELEE_MODE_MAMIZOU;
		else if(p_ptr->pclass == CLASS_SUWAKO) return MELEE_MODE_SUWAKO;
		else if(p_ptr->pclass == CLASS_YUKARI) return MELEE_MODE_YUKARI;
		else return MELEE_MODE_LONGARM;
	}
	//v1.1.26 俎qeiԂŉuUɕʂ̊iʂoȂ邽߂̕
	if(findmode == MELEE_FIND_SUMIREKO_DISTANT)
	{
		return MELEE_MODE_SUMIREKO;
	}

/*D3:ꕔ̎푰ψٍU*/
	//LX
	if(p_ptr->pclass == CLASS_KISUME)
	{
		if(p_ptr->concent == 0) return MELEE_MODE_KISUME1;
		if(p_ptr->concent == 1) return MELEE_MODE_KISUME2;
		if(p_ptr->concent == 2) return MELEE_MODE_KISUME3;
		if(p_ptr->concent == 3) return MELEE_MODE_KISUME4;
		else return MELEE_MODE_KISUME5;
	}

	//ei
	if(!kick && (inventory[INVEN_RARM].tval == TV_GUN || inventory[INVEN_LARM].tval == TV_GUN))
	{
		//v1.1.21 K=J^ȊÔƂ1/2ŃLbNU
		int tmp = select_gun_melee_mode();
		if(tmp == MELEE_MODE_GUN_TWOHAND || !one_in_(2)) return tmp;
		else kick = TRUE;

	}

	//ω1/3ŋ͂ȍU
	if (p_ptr->mimic_form == MIMIC_DEMON_LORD && one_in_(3)) 
		return MELEE_MODE_D_LORD;

	//zS(~A͕ʏ)1/4ŋzU
	if((prace_is_(RACE_VAMPIRE) || p_ptr->mimic_form == MIMIC_VAMPIRE) && p_ptr->pclass != CLASS_REMY && one_in_(4))
		return MELEE_MODE_VAMP;

	//푰jŴƂ1/3
	if(p_ptr->prace == RACE_NINJA && one_in_(3))
	{
		if(kick || one_in_(3)) return MELEE_MODE_KICK_NINJA;
		else return MELEE_MODE_PUNCH_NINJA;
	}
	//푰ɐ̂̂Ƃ1/3
	else if(p_ptr->prace == RACE_ULTIMATE && one_in_(3))
	{
		if(one_in_(10)) return MELEE_MODE_FISH_TAIL;
		else if(one_in_(9)) return MELEE_MODE_BIGHORN;
		else if(one_in_(8)) return MELEE_MODE_BIGTAIL;
		else if(one_in_(7)) return MELEE_MODE_VAMP;
		else 	return MELEE_MODE_ULTIMATE;
	}

	//ψ
	if(p_ptr->muta2 & MUT2_BIGHORN && one_in_(10)) return MELEE_MODE_BIGHORN;
	if(p_ptr->muta2 & MUT2_BIGTAIL && one_in_(8)) return MELEE_MODE_BIGTAIL;
	if(p_ptr->muta2 & MUT2_HORNS && one_in_(14)) return MELEE_MODE_HORNS;
	if(p_ptr->muta2 & MUT2_HARDHEAD && one_in_(7)) return MELEE_MODE_HEADBUTT;

/*D4:pUoE */
	///pend ̐EƂ͎肪ǂĂĂp`ƂoĂ܂̂ŉɂΒ
	switch(p_ptr->pclass)
	{
	case CLASS_MINDCRAFTER:
		return MELEE_MODE_MIND;
	case CLASS_NINJA:
		return MELEE_MODE_NINJA;

	//iƂ̐pU͑f莞̂
	case CLASS_MARTIAL_ARTIST:
		if((randint0(100) < plev+30) && !kick) return MELEE_MODE_MA;
		else break;
	case CLASS_YUKARI:
		return MELEE_MODE_YUKARI;

	case CLASS_KOISHI:
		return MELEE_MODE_KOISHI;
	//v1.1.23
	case CLASS_NITORI:
		return MELEE_MODE_NITORI;
	case CLASS_CIRNO:
		return MELEE_MODE_CIRNO;
	case CLASS_YOSHIKA:
		return MELEE_MODE_YOSHIKA;
	case CLASS_HINA:
		return MELEE_MODE_HINA;
	case CLASS_MEDICINE:
		return MELEE_MODE_MEDI;
	case CLASS_ICHIRIN:
		return MELEE_MODE_ICHIRIN;
	case CLASS_SUMIREKO:
		return MELEE_MODE_SUMIREKO;
	case CLASS_FUTO:
		return MELEE_MODE_FUTO;
	case CLASS_TOZIKO:
		return MELEE_MODE_TOZIKO;
	case CLASS_YUYUKO:
		return MELEE_MODE_YUYUKO;
	case CLASS_MOKOU:
		return MELEE_MODE_MOKOU;
	case CLASS_MEIRIN:
		return MELEE_MODE_MEIRIN;
	case CLASS_3_FAIRIES:
		return MELEE_MODE_3_FAIRIES;
	case CLASS_KANAKO:
		return MELEE_MODE_KANAKO;
	case CLASS_RAIKO:
		return MELEE_MODE_RAIKO;
	case CLASS_MARISA:
		return MELEE_MODE_MARISA;
	case CLASS_MAMIZOU:
		return MELEE_MODE_MAMIZOU;

	case CLASS_MURASA:
		{ //т͎̂n`ōUς
			feature_type *f_ptr = &f_info[cave[py][px].feat];
			if (have_flag(f_ptr->flags, FF_WATER) && have_flag(f_ptr->flags, FF_DEEP) && !one_in_(3)) return MELEE_MODE_MURASA2;
			else  return MELEE_MODE_MURASA1;
		}
	case CLASS_MIKO:
		return MELEE_MODE_MIKO;
	case CLASS_KOKORO:
		return MELEE_MODE_KOKORO;
	case CLASS_UTSUHO:
		return MELEE_MODE_UTSUHO;
	case CLASS_TENSHI:
		return MELEE_MODE_TENSHI;
	case CLASS_SUWAKO:
		return MELEE_MODE_SUWAKO;
	case CLASS_SHINMYOU_2:
		return MELEE_MODE_SHINMYOU2;
	case CLASS_REIMU: //얲ΑKNōU̎ނς
		if(1 + randint1(10) < osaisen_rank()) return MELEE_MODE_REIMU2;
		else return MELEE_MODE_REIMU1;
	case CLASS_RAN: //̉]U1/4
		if(one_in_(4)) return MELEE_MODE_RAN;
		else break;
	case CLASS_CHEN: //̓U͔GĂȂɂoȂ
		if( !p_ptr->magic_num1[0]) return MELEE_MODE_CHEN;
		else break;
	case CLASS_BYAKUREN: //@̓U͋̂
		if(p_ptr->tim_general[0]) return MELEE_MODE_HIZIRI;
		else break;
	case CLASS_IKU:
		if(!kick) return MELEE_MODE_DRILL;
		else break;

	case CLASS_REMY:
		if(one_in_(3) && !kick) return MELEE_MODE_REMY_HAND;
		else if(one_in_(2)) return MELEE_MODE_REMY_KICK;
		else return MELEE_MODE_REMY_OTHER;
	case CLASS_KASEN:
		return MELEE_MODE_KASEN;
	case CLASS_UDONGE:
		return MELEE_MODE_UDONGE;

	case CLASS_ORIN:
		if(one_in_(3)) return MELEE_MODE_ORIN;
		else break;

	case CLASS_DOREMY:
		return MELEE_MODE_DOREMY;
		break;

	case CLASS_JYOON:
		if (p_ptr->special_attack & ATTACK_WASTE_MONEY)
			return MELEE_MODE_JYOON_2;
		else
			return MELEE_MODE_JYOON_1;




	}




/*D5:ʓIȍUiI*/

	if(!kick)//p`LbNgƂAǂɂȂ邩I
	{
		int kick_chance;

		if(p_ptr->pclass == CLASS_SHIZUHA || p_ptr->pclass == CLASS_ALICE) //×tƃAX̓LbNoȂ
			kick_chance = 100;
		else if((p_ptr->pclass == CLASS_WRIGGLE || p_ptr->pclass == CLASS_BENBEN))//OƕفX̓LbNo₷
			kick_chance = 70;
		else if(p_ptr->prace == RACE_NINGYO) //l̓LbN(=l̔)o₷
			kick_chance = 50;
		else
			kick_chance = 35;

		if( randint0(100) < kick_chance ) kick = TRUE;

	}

	if(kick)
	{
		//l̔ƂRU͕KUɂȂ
		if(p_ptr->muta3 & MUT3_FISH_TAIL) return MELEE_MODE_FISH_TAIL;
		//LV[̏RU͑SݕtɂȂ
		if(prace_is_(RACE_ZOMBIE)) return MELEE_MODE_BITE; 

		//i̋E͋͂ȃLbN
		if(randint1(ref_skill_exp(SKILL_MARTIALARTS)) > 4000 || p_ptr->pclass == CLASS_MARTIAL_ARTIST)
			return MELEE_MODE_KICK2;

		//S̏R͊mŊpUɂȂ
		if(prace_is_(RACE_ONI) && one_in_(2)) return MELEE_MODE_BIGHORN;

		//TVAbl̏RmŊݕtUɂȂ(܂ȂȃC[W̃L͏O)
		if(prace_is_(RACE_HAKUROU_TENGU) && one_in_(2)) return MELEE_MODE_BITE;
		if(p_ptr->prace == RACE_WARBEAST && one_in_(2) 
			&& p_ptr->pclass != CLASS_KEINE && p_ptr->pclass != CLASS_ORIN && p_ptr->pclass != CLASS_NAZRIN && p_ptr->pclass != CLASS_SHOU)
			return MELEE_MODE_BITE;

		return MELEE_MODE_KICK1; //ʂ̏R
	}
	else
	{

		//̃p`͋Ղ̒܂ōU
		if(p_ptr->pclass == CLASS_YATSUHASHI )	return MELEE_MODE_CLAW;

		//p`~ȃC[W̃L
		if(p_ptr->pclass == CLASS_YAMAME || p_ptr->pclass == CLASS_MYSTIA || p_ptr->pclass == CLASS_KAGEROU || p_ptr->pclass == CLASS_ORIN)
		{
			if(randint1(ref_skill_exp(SKILL_MARTIALARTS)) > 4000) return MELEE_MODE_EX_CLAW;
			else return MELEE_MODE_CLAW;
		}
		//܂Ɉ~芚ݕt肵ȃL
		if(p_ptr->pclass == CLASS_RUMIA)
		{
			if(randint1(ref_skill_exp(SKILL_MARTIALARTS)) > 5000) return MELEE_MODE_EX_CLAW;
			else if(one_in_(3)) return MELEE_MODE_CLAW;
			else if(one_in_(2)) return MELEE_MODE_PUNCH1;
			else return MELEE_MODE_BITE;
		}

		//i̋E͋͂ȃp`
		if(randint1(ref_skill_exp(SKILL_MARTIALARTS)) > 4000 || p_ptr->pclass == CLASS_MARTIAL_ARTIST)
			return MELEE_MODE_PUNCH2;

		//LV[ꏈ
		if(prace_is_(RACE_ZOMBIE))
		{
			if(randint1(ref_skill_exp(SKILL_MARTIALARTS)) > 4000) return MELEE_MODE_YOSHIKA;
			else if(one_in_(2)) return MELEE_MODE_BITE;
			else return MELEE_MODE_CLAW;
		}

		if(prace_is_(RACE_ONI)) return MELEE_MODE_PUNCH_ONI;
		if(prace_is_(RACE_DAIYOUKAI) && one_in_(2)) return MELEE_MODE_EX_CLAW;
		if(prace_is_(RACE_WARBEAST) && p_ptr->pclass != CLASS_KEINE && one_in_(2)) return MELEE_MODE_CLAW;

		return MELEE_MODE_PUNCH1; //ʂ̉
	}

}


/*
 * Player attacks a (poor, defenseless) creature        -RAK-
 *
 * If no "weapon" is available, then "punch" the monster one time.
 */
/*:::ɂU f̎hand=0ňxĂ΂
 *:::x,y:ΏۃX^[ʒu
 *:::hand:0ȂEA1Ȃ獶
 *:::mode:KEȂǓȒʏÛƂȊO0*/

///class sys item i@ɂU
static void py_attack_aux(int y, int x, bool *fear, bool *mdeath, s16b hand, int mode)
{
	int		num = 0, k, bonus, chance;
	//int vir;

	cave_type       *c_ptr = &cave[y][x];

	monster_type    *m_ptr = &m_list[c_ptr->m_idx];
	monster_race    *r_ptr = &r_info[m_ptr->r_idx];

	/* Access the weapon */
	object_type     *o_ptr = &inventory[INVEN_RARM + hand];

	char            m_name[80];

	bool            success_hit = FALSE;
	bool            backstab = FALSE;
	bool            sneakingkill = FALSE; //EƁumvpobNX^bu
	bool            vorpal_cut = FALSE;
	int             chaos_effect = 0;
	bool            stab_fleeing = FALSE;
	bool            fuiuchi = FALSE;
	bool            monk_attack = FALSE;
	bool            do_quake = FALSE;
	bool            weak = FALSE;
	bool            drain_msg = TRUE;
	int             drain_result = 0, drain_heal = 0;
	bool            can_drain = FALSE;
	bool            can_feed = FALSE;
	int             num_blow;
	int             drain_left = MAX_VAMPIRIC_DRAIN;
	u32b flgs[TR_FLAG_SIZE]; /* A massive hack -- life-draining weapons */ /*złȂ؂ꖡɂgƂɂ*/
	bool            is_human = (r_ptr->d_char == 'p');
	bool            is_lowlevel = (r_ptr->level < (p_ptr->lev - 15));
	bool            zantetsu_mukou, e_j_mukou;

	bool			weapon_invalid = FALSE;

	//񒚌ei@ce
	bool		flag_gun_kata = FALSE;

	//v1.1.42 h~[EXC[g̊iUŃX^[𖰂点tOJEg
	bool		counting_sheep = 0;

	int				martial_arts_method = 0;


	///mod140914 pƂ̕KEZł͌ĂȂ̍U
	if((mode == HISSATSU_2 || mode == HISSATSU_ISSEN || mode == HISSATSU_UNDEAD) && o_ptr->tval != TV_KATANA) return;
	if(mode == HISSATSU_MAJIN && o_ptr->tval != TV_AXE) return;
	if((mode == HISSATSU_3WAY || mode == HISSATSU_HAGAN )&& !object_has_a_blade(o_ptr)) return;
	if((mode == HISSATSU_ZANMA || mode == HISSATSU_FUKI || mode == HISSATSU_COLD || mode == HISSATSU_ELEC || mode == HISSATSU_DOUBLE) && o_ptr->tval != TV_KATANA && o_ptr->tval != TV_SWORD) return;
	if(mode == HISSATSU_QUAKE && o_ptr->weight < 100) return;
	if(mode == HISSATSU_3DAN && o_ptr->tval != TV_SPEAR && o_ptr->tval != TV_POLEARM) return;

	//v1.1.14 _lꏈ
	if(mode == HISSATSU_GION && o_ptr->tval != TV_KATANA && o_ptr->tval != TV_SWORD) return;

	///mod140216 iύX
	//if(!o_ptr->k_idx && !p_ptr->riding) monk_attack = TRUE;
	//if(empty_hands(TRUE) & EMPTY_HAND_RARM) monk_attack = TRUE;
	if(p_ptr->do_martialarts) monk_attack = TRUE;

	if(check_invalidate_inventory(INVEN_RARM + hand)) weapon_invalid = TRUE;

	switch (p_ptr->pclass)
	{
	case CLASS_KOISHI:
		{
			int tmp = p_ptr->lev * 6;
			if(r_ptr->flags2 & RF2_EMPTY_MIND) tmp = 0;
			else if(r_ptr->flags2 & RF2_WEIRD_MIND) tmp /= 4;
			else if(r_ptr->flags2 & RF2_ELDRITCH_HORROR) tmp /= 2;
			else if(!monster_living(r_ptr)) tmp = tmp * 2 / 3;
			if(randint0(tmp) > r_ptr->level) fuiuchi = TRUE;
	
		}
		break;

	case CLASS_SOLDIER:

		//v1.1.21 m(Xj[LOZ\)̕sӑł s畁ʂ̃obNX^bu
		if(HAVE_SOLDIER_SKILL(SOLDIER_SKILL_COMBAT,SS_C_SNEAKING))
		{
			int tmp = r_ptr->level;
			bool flag_fail = FALSE;

			//QĂGłȂƖ
			//Ô߂ɉ炩̍U[h͖ɂƂ
			if (MON_CSLEEP(m_ptr) && m_ptr->ml  && !mode)
			{

				if(((r_ptr->flags1 & RF1_UNIQUE) ||(r_ptr->flags7 & RF7_UNIQUE2))) flag_fail = TRUE;
				if(!monster_living(r_ptr)) flag_fail = TRUE;

				if(r_ptr->flags2 & RF2_GIGANTIC) tmp *= 2;
				if(!(r_ptr->flags3 & (RF3_HUMAN | RF3_DEMIHUMAN))) tmp *= 3;

				if(flag_fail || randint1(tmp) > randint1(p_ptr->lev))
					backstab = TRUE;
				else
					sneakingkill = TRUE;
			}
		}
		//v1.1.22 ÎZ\̂Ƃ̕sӑł
		if(HAVE_SOLDIER_SKILL(SOLDIER_SKILL_MAGICBULLET,SS_M_NOCTO_VISION) && !(cave[py][px].info & CAVE_GLOW) && p_ptr->cur_lite <= 0 )
		{

			if (MON_CSLEEP(m_ptr) && m_ptr->ml)
				backstab = TRUE;
			else if(check_torime(c_ptr->m_idx)) 
				fuiuchi = TRUE;

		}
		//v1.1.22 Z\̕sӑł
		if(CHECK_CONCEALMENT)
		{
			if (MON_CSLEEP(m_ptr) && m_ptr->ml)
				backstab = TRUE;
			else if (randint1(r_ptr->level * 2) < (p_ptr->lev + p_ptr->skill_stl * 2))
				fuiuchi = TRUE;
		}

		break;

	/*:::ƔE҂̓Ō*/
		///mod141221 Eғꔻ
	case CLASS_NINJA:
		if (monk_attack || o_ptr->tval == TV_KNIFE)
		{
			int tmp = p_ptr->lev * 6 + (p_ptr->skill_stl + 10) * 4;
			if (p_ptr->monlite && (mode != HISSATSU_NYUSIN)) tmp /= 3;
			if (p_ptr->cursed & TRC_AGGRAVATE) tmp /= 2;
			if (r_ptr->level > (p_ptr->lev * p_ptr->lev / 20 + 10)) tmp /= 3;
			if (MON_CSLEEP(m_ptr) && m_ptr->ml)
			{
				/* Can't backstab creatures that we can't see, right? */
				backstab = TRUE;
			}
			else if (((p_ptr->special_defense & NINJA_S_STEALTH) || p_ptr->tim_superstealth) && (randint0(tmp) > (r_ptr->level+20)) && m_ptr->ml && !(r_ptr->flagsr & RFR_RES_ALL))
			{
				fuiuchi = TRUE;
			}
			else if (MON_MONFEAR(m_ptr) && m_ptr->ml)
			{
				stab_fleeing = TRUE;
			}
		}
		break;
	case CLASS_CHEN:
			if ( (mode == HISSATSU_NYUSIN && randint1(r_ptr->level * 2) < p_ptr->lev || MON_CSLEEP(m_ptr)) && m_ptr->ml)
			{
				fuiuchi = TRUE;
			}
			break;

		///mod140817 ~XeBAڏ
	case CLASS_MYSTIA:
		if(check_torime(c_ptr->m_idx)) fuiuchi = TRUE;
		break;

	case CLASS_NUE:
			if ( (p_ptr->cur_lite <= 0 && !(cave[py][px].info & CAVE_GLOW) && randint1(r_ptr->level * 2) < p_ptr->lev || MON_CSLEEP(m_ptr)) && m_ptr->ml)
			{
				fuiuchi = TRUE;
			}
			break;
			//ۃvXeBr[g̍Ux㏸
	case CLASS_RAIKO:
		if(music_singing(MUSIC_NEW_RAIKO_PRISTINE) && !hand)
			do_cmd_concentrate(0);
		break;


	/*:::iZ\҂̊i*/
	case CLASS_MONK:
	case CLASS_FORCETRAINER:
	//case CLASS_BERSERKER:
		if ((empty_hands(TRUE) & EMPTY_HAND_RARM) && !p_ptr->riding) monk_attack = TRUE;
		break;
	}

	if(p_ptr->tim_unite_darkness)
	{
		if(!(cave[py][px].info & CAVE_GLOW)  && m_ptr->ml && (MON_CSLEEP(m_ptr) || randint1(p_ptr->lev * 3 + (p_ptr->skill_stl + 10) * 4) > r_ptr->level * 2)) fuiuchi = TRUE;
	}

	/*:::f̂ƂiZ\𓾂*/
	//if (!o_ptr->k_idx) /* Empty hand */
	if(monk_attack)
	{
		if(p_ptr->pclass == CLASS_MEIRIN)
			do_cmd_concentrate(0);
		///mod131226 skill Z\ƕZ\̓
		gain_skill_exp(SKILL_MARTIALARTS, m_ptr);
		/*
		if ((r_ptr->level + 10) > p_ptr->lev)
		{
			if (p_ptr->skill_exp[GINOU_SUDE] < s_info[p_ptr->pclass].s_max[GINOU_SUDE])
			{
				if (p_ptr->skill_exp[GINOU_SUDE] < WEAPON_EXP_BEGINNER)
					p_ptr->skill_exp[GINOU_SUDE] += 40;
				else if ((p_ptr->skill_exp[GINOU_SUDE] < WEAPON_EXP_SKILLED))
					p_ptr->skill_exp[GINOU_SUDE] += 5;
				else if ((p_ptr->skill_exp[GINOU_SUDE] < WEAPON_EXP_EXPERT) && (p_ptr->lev > 19))
					p_ptr->skill_exp[GINOU_SUDE] += 1;
				else if ((p_ptr->lev > 34))
					if (one_in_(3)) p_ptr->skill_exp[GINOU_SUDE] += 1;
				p_ptr->update |= (PU_BONUS);
			}
		}
		*/
	}
	/*:::̂ƂΉol𓾂*/
	//v1.1.14 _lʂ͏
	else if (object_is_melee_weapon(o_ptr) && mode != HISSATSU_GION)
	{
		///mod131227 skill Z\ƕZ\̓
		gain_skill_exp(o_ptr->tval,m_ptr);
	/*
		if ((r_ptr->level + 10) > p_ptr->lev)
		{
			int tval = inventory[INVEN_RARM+hand].tval - TV_WEAPON_BEGIN;
			int sval = inventory[INVEN_RARM+hand].sval;
			int now_exp = p_ptr->weapon_exp[tval][sval];
			if (now_exp < s_info[p_ptr->pclass].w_max[tval][sval])
			{
				int amount = 0;
				if (now_exp < WEAPON_EXP_BEGINNER) amount = 80;
				else if (now_exp < WEAPON_EXP_SKILLED) amount = 10;
				else if ((now_exp < WEAPON_EXP_EXPERT) && (p_ptr->lev > 19)) amount = 1;
				else if ((p_ptr->lev > 34) && one_in_(2)) amount = 1;
				p_ptr->weapon_exp[tval][sval] += amount;
				p_ptr->update |= (PU_BONUS);
			}
		}
	*/
		///mod140714 tr_g΂炭gĂƕ킪d퉻鏈
		///mod151219 ےǉ
		//v1.1.52 VA[ił͗d퉻Ȃ悤ɂ
		if((p_ptr->pclass == CLASS_TSUKUMO_MASTER || p_ptr->pclass == CLASS_RAIKO)
			&& !object_is_fixed_artifact(o_ptr) && o_ptr->xtra1 < 100 && !p_ptr->inside_arena)
		{
			if( (r_ptr->level > o_ptr->xtra1 / 2) && (randint0(o_ptr->xtra1) < r_ptr->level) && one_in_(5))
			{
				if(p_ptr->wizard) o_ptr->xtra1 = (o_ptr->xtra1 < 50) ? 50 : 100; 
				else o_ptr->xtra1++; 

				if(o_ptr->xtra1 == 50 || o_ptr->xtra1 == 100) make_evilweapon(o_ptr,r_ptr); 
			}
		}


	}

	/* Disturb the monster */
	(void)set_monster_csleep(c_ptr->m_idx, 0);

	/* Extract monster name (or "it") */
	monster_desc(m_name, m_ptr, 0);
	/*:::Ȃ*/
	/* Calculate the "attack quality" */
	bonus = p_ptr->to_h[hand] + o_ptr->to_h;
	chance = (p_ptr->skill_thn + (bonus * BTH_PLUS_ADJ));
	if (mode == HISSATSU_IAI) chance += 60;
	if (mode == HISSATSU_GION) chance += 60;
	if (p_ptr->special_defense & KATA_KOUKIJIN) chance += 150;

	if(mode == HISSATSU_EIGOU)
	{
		chance += 100;
		if(!heavy_armor()) chance *= 3;
	}
	if (p_ptr->sutemi) chance = MAX(chance * 3 / 2, chance + 60);

	//msg_format("chance:%d",chance);

	///sysdel virtue
	//vir = virtue_number(V_VALOUR);
	/*
	if (vir)
	{
		chance += (p_ptr->virtues[vir - 1]/10);
	}
	*/
	///item aSEJ
	///del131223 aS
	//zantetsu_mukou = ((o_ptr->name1 == ART_ZANTETSU) && (r_ptr->d_char == 'j'));
	zantetsu_mukou = 0;

	//V{ύXSc
	e_j_mukou = ((o_ptr->name1 == ART_EXCALIBUR_J) && (r_ptr->d_char == 'c'));

	///sys item KEAŐj̍U񐔏C
	if ((mode == HISSATSU_ATTACK_ONCE) || (mode == HISSATSU_KYUSHO) || (mode == HISSATSU_MINEUCHI) || (mode == HISSATSU_3DAN) || (mode == HISSATSU_IAI)) num_blow = 1;

	else if (mode == HISSATSU_COLD) num_blow = p_ptr->num_blow[hand]+2;
	/*:::͓CV̒ʔw@U񐔂ɉ*/
	else if (mode == HISSATSU_KAPPA)
	{
			num_blow = p_ptr->num_blow[hand] / m_ptr->cdis;
			if(num_blow < 1) num_blow=1;
	}
	/*:::ψُp̐Lr@ɉ*/
	else if (mode == HISSATSU_LONGARM)
	{
			num_blow = p_ptr->num_blow[hand] - m_ptr->cdis / 2;
			if(num_blow < 1) num_blow=1;
	}
	//\EXJv`A@GƂ̋ōU񐔂
	else if(mode == HISSATSU_SOULSCULPTURE)
	{
		if(p_ptr->pclass == CLASS_SAKUYA) num_blow = p_ptr->num_blow[hand] * 7 / (m_ptr->cdis+2);
		else if (p_ptr->pclass == CLASS_NEMUNO)
		{
			if(IS_NEMUNO_IN_SANCTUARY)
				num_blow = p_ptr->num_blow[hand] * 4 / (m_ptr->cdis + 1);
			else
				num_blow = p_ptr->num_blow[hand] * 3 / (m_ptr->cdis + 1);
		}
		else
		{
			msg_print("ERROR:\ȂNXGF_SOULSCULPTUREgꂽ");
			num_blow = p_ptr->num_blow[hand];
		}

		if(num_blow < 1) num_blow=1;
	}
	else num_blow = p_ptr->num_blow[hand];

	if(mode == HISSATSU_SHINMYOU) num_blow = num_blow * 3 / 2;
	else if(mode == HISSATSU_UNZAN) num_blow = num_blow * (20+randint0(11)) / 10;

	/* Hack -- DOKUBARI always hit once */
	///mod131223 tval
	//if ((o_ptr->tval == TV_SWORD) && (o_ptr->sval == SV_DOKUBARI)) num_blow = 1;
	///ϐgɓŐjĂU1ɂȂȂ悤ɂĂ
	if (!weapon_invalid && (o_ptr->tval == TV_KNIFE) && (o_ptr->sval == SV_WEAPON_DOKUBARI)) num_blow = 1;

	/* Attack once for each legal blow */
	/*:::U񐔂Ƃɔ*/
	while ((num++ < num_blow) && !p_ptr->is_dead)
	{
		bool dokubari = FALSE;
		bool sinker = FALSE;
		///sys item Őj
		///mod131223 tval
		if ((!weapon_invalid && (o_ptr->tval == TV_KNIFE) && (o_ptr->sval == SV_WEAPON_DOKUBARI)) || (mode == HISSATSU_KYUSHO))
		{
			int n = 1;
			dokubari = TRUE;

			if (p_ptr->migite && p_ptr->hidarite)
			{
				n *= 2;
			}
			if (mode == HISSATSU_3DAN)
			{
				n *= 2;
			}
			///mod141129 LUNATICœŐjɂ

			if(difficulty == DIFFICULTY_LUNATIC && one_in_(2)) success_hit = one_in_(n*2);
			else success_hit = one_in_(n);
		}
		///class E҂̕sӑł͕K
		//else if ((p_ptr->pclass == CLASS_NINJA) && ((backstab || fuiuchi) && !(r_ptr->flagsr & RFR_RES_ALL))) success_hit = TRUE;
		else if (((backstab || fuiuchi) && !(r_ptr->flagsr & RFR_RES_ALL))) success_hit = TRUE;
		else if(sneakingkill) success_hit = TRUE;
		///fP͍UK
		else if(p_ptr->pclass == CLASS_EIKI) success_hit = TRUE;
		/*:::ʏ̖*/
		else success_hit = test_hit_norm(chance, r_ptr->ac, m_ptr->ml);

		///mod141102 Ƃ薽␳..悤Ǝvǂ߂
		//if(p_ptr->pclass == CLASS_SATORI && !p_ptr->blind && !p_ptr->image && p_ptr->confused && m_ptr->ml && !(r_ptr->flags2 & (RF2_EMPTY_MIND | RF2_WEIRD_MIND)) 
		//	&& (randint1(r_ptr->level*3 + 100) < (p_ptr->lev + p_ptr->stat_ind[A_INT]+3) )) success_hit = TRUE;

		/*
		if (mode == HISSATSU_MAJIN)
		{
			if (one_in_(2))
				success_hit = FALSE;
		}
		*/

		/* Test for hit */
		if (success_hit)
		{
			///sys item *؂ꖡ* tOɂ
			//int vorpal_chance = ((o_ptr->name1 == ART_VORPAL_BLADE) || (o_ptr->name1 == ART_CHAINSWORD)) ? 2 : 4;
			int vorpal_chance;

			/* Sound */
			sound(SOUND_HIT);

			if(p_ptr->prace == RACE_STRAYGOD && (backstab || stab_fleeing || fuiuchi || sneakingkill))
			{
				if(fuiuchi)
				{
					if(one_in_(10)) set_deity_bias(DBIAS_COSMOS, -1);
				}
				else
				{
					if(one_in_(3)) set_deity_bias(DBIAS_COSMOS, -1);
					if(one_in_(2)) set_deity_bias(DBIAS_REPUTATION, -1);
				}
			}

			/* Message */
			///sys UbZ[W@킲ƂɕύX悤H
			if(p_ptr->pclass == CLASS_KISUME && p_ptr->concent && !monk_attack)
				 msg_format("Ȃ͕\%s֌ėI", m_name);
			else if(mode == HISSATSU_GION)
				msg_format("_ľ%s؂􂢂I", m_name);
			else if(sneakingkill && monk_attack); //m̊isӑł͂ł̓bZ[WoȂ
			else if (backstab || sneakingkill)
				msg_format("Ȃ͗⍓ɂĂ閳͂%s֊Pd|I", m_name);
			else if (fuiuchi)
			{
				msg_format("sӂ˂%sɋȈꌂ킹I", m_name);
			}
			else if (stab_fleeing)
				msg_format("%s֔wPI", m_name);
			//else if (!monk_attack) msg_format("%sUB", m_name);
			else if (!monk_attack)
				msg_format("%s%s", m_name,msg_py_atk(o_ptr,mode));
			//else msg_format("%sUB", m_name);

			//̖
			if(p_ptr->pclass == CLASS_HINA) 
				hina_gain_yaku(-(p_ptr->to_dd[hand]) / 2);

			/* Hack -- bare hands do one damage */
			k = 1;

			object_flags(o_ptr, flgs);



			/*:::ו̓ʌvZ*/
			/* Select a chaotic effect (50% chance) */
			if ((have_flag(flgs, TR_CHAOTIC)) && one_in_(2) && !weapon_invalid)
			{
				///sysdel virtue
				//if (one_in_(10))
				//chg_virtue(V_CHANCE, 1);

				if (randint1(5) < 3)
				{
					/* Vampiric (20%) */
					chaos_effect = 1;
				}
				else if (one_in_(250))
				{
					/* Quake (0.12%) */
					chaos_effect = 2;
				}
				else if (!one_in_(10))
				{
					/* Confusion (26.892%) */
					chaos_effect = 3;
				}
				else if (one_in_(2))
				{
					/* Teleport away (1.494%) */
					chaos_effect = 4;
				}
				else
				{
					/* Polymorph (1.494%) */
					chaos_effect = 5;
				}
			}

			/* Vampiric drain */
			/*:::z*/
			///mod140410 Lv45ȏŖgƋzt*/
			if ((have_flag(flgs, TR_VAMPIRIC) ) || (chaos_effect == 1) || (mode == HISSATSU_DRAIN) || hex_spelling(HEX_VAMP_BLADE) || ((p_ptr->special_attack & (ATTACK_DARK)) && p_ptr->lev > 44))
			{
				/* Only drain "living" monsters */
				if (monster_living(r_ptr))
					can_drain = TRUE;
				else
					can_drain = FALSE;

				if(weapon_invalid) can_drain = FALSE;
			}
			//GUx[g̃hX
			if(monster_living(r_ptr) && check_equip_specific_fixed_art(ART_ECSEDI))
			{
					can_drain = TRUE;
			}

			//FU
			if(monster_living(r_ptr) && mode == HISSATSU_YOSHIKA)
			{
					can_drain = TRUE;
			}

			//v1.1.46 ؂ꖡ(vorpal_cut)ɂ̕Ɉڂ


			/*:::fŨbZ[WAЗ́AʍČvZ*/
			///class fUGtFNg
			if (monk_attack)
			{
				int mult = 100;
				int special_effect = 0, stun_effect = 0, times = 0, max_times;
				int min_level = 1;
				//const martial_arts *ma_ptr = &ma_blows[0], *old_ptr = &ma_blows[0];
				const martial_arts_new *ma_ptr = &ma_blows_new[0], *old_ptr = &ma_blows_new[0];
				int resist_stun = 0;
				int weight = 8;
				int findmode = 0;

				if(mode == HISSATSU_KAPPA || mode == HISSATSU_LONGARM) findmode = MELEE_FIND_LONGARM;
				else if(sneakingkill) findmode = MELEE_FIND_SNEAKING_KILL;
				else if(mode == HISSATSU_YOSHIKA && p_ptr->prace != RACE_ZOMBIE) findmode = MELEE_FIND_EX_CLAW;
				//v1.1.26 俎qeiԂŉuUIƂ͕ʂ̊ioȂ悤ɂ
				else if(mode == HISSATSU_NO_AURA && p_ptr->pclass == CLASS_SUMIREKO) findmode = MELEE_FIND_SUMIREKO_DISTANT;

				/*:::푰EƃxˑRψقȂǂɉUނ肷*/
				martial_arts_method = find_martial_arts_method(findmode);

				//KJ^tO
				if(martial_arts_method == MELEE_MODE_GUN_TWOHAND)
					flag_gun_kata = TRUE;

				if(mode == HISSATSU_UNZAN) martial_arts_method = MELEE_MODE_ICHIRIN2;

				if (r_ptr->flags1 & RF1_UNIQUE) resist_stun += 88;
				if (r_ptr->flags2 & RF2_GIGANTIC) resist_stun += 88;
				if (r_ptr->flags3 & RF3_NO_STUN) resist_stun += 66;
				if (r_ptr->flags3 & RF3_NO_CONF) resist_stun += 33;
				if (r_ptr->flags3 & RF3_NO_SLEEP) resist_stun += 33;
				if (r_ptr->flags2 & RF2_POWERFUL) resist_stun += 33;
				if ((r_ptr->flags3 & RF3_UNDEAD) || (r_ptr->flags3 & RF3_NONLIVING))
					resist_stun += 66;
				/*
				if (p_ptr->special_defense & KAMAE_BYAKKO)
					max_times = (p_ptr->lev < 3 ? 1 : p_ptr->lev / 3);
				else if (p_ptr->special_defense & KAMAE_SUZAKU)
					max_times = 1;
				else if (p_ptr->special_defense & KAMAE_GENBU)
					max_times = 1;
				else
					max_times = (p_ptr->lev < 7 ? 1 : p_ptr->lev / 7);
				*/
				max_times = ref_skill_exp(SKILL_MARTIALARTS) / 2000 + 1;

				/* Attempt 'times' */
				/*:::fUGtFNg琔I肵ԍxȂ̂*/
				for (times = 0; times < max_times; times++)
				{
					if(!martial_arts_method)
					{
						msg_print("ERROR:fUނ܂ĂȂ");
						return;
					}


					do
					{
						int mode_pick[50];
						int mode_cnt=0;
						int i;
						for(i = 0;(ma_blows_new[i].method != 0 && mode_cnt < 50);i++)
						{
							if(ma_blows_new[i].method == martial_arts_method)
							{
								mode_pick[mode_cnt++] = i;
							}
						}
						if(!mode_cnt)
						{
							msg_format("ERROR:w肳ꂽ(%d)̑fUo^ĂȂ",martial_arts_method);
							return;
						}		

						if(p_ptr->pclass == CLASS_SUMIREKO && mode == HISSATSU_NO_AURA)
						{
							if(mode_cnt < 3)
							{
								msg_format("ERROR:俎quU₪Ȃ");
								return;
							}		
							ma_ptr = &ma_blows_new[ mode_pick[2 + randint0(mode_cnt-2)]];

						}
						else
						{
							//ma_ptr = &ma_blows[randint0(MAX_MA)];
							ma_ptr = &ma_blows_new[ mode_pick[randint0(mode_cnt)]];
							//if ((p_ptr->pclass == CLASS_FORCETRAINER) && (ma_ptr->min_level > 1)) min_level = ma_ptr->min_level + 3;
							//else 
						}
							min_level = ma_ptr->min_level;
					}
					while ((min_level > p_ptr->lev) ||
					       (randint1(p_ptr->lev) < ma_ptr->chance));



					/* keep the highest level attack available we found */
					/*::: Hack - old_ptrƂ̔r>ƁAfU₪x1݂̂̂ƂȊO̕ނł邪Î>=ɂ*/
					//if ((ma_ptr->min_level > old_ptr->min_level) &&
					if ((ma_ptr->min_level >= old_ptr->min_level) &&
					    !p_ptr->stun && !p_ptr->confused)
					{
						old_ptr = ma_ptr;

						if (p_ptr->wizard && cheat_xtra)
						{
#ifdef JP
							msg_print("UđI܂B");
#else
							msg_print("Attack re-selected.");
#endif
						}
					}
					else
					{
						ma_ptr = old_ptr;
					}
				}
				/*:::iUmsg*/
				msg_format(ma_ptr->desc, m_name);


				//if (p_ptr->pclass == CLASS_FORCETRAINER) min_level = MAX(1, ma_ptr->min_level - 3);
				//else 
					min_level = ma_ptr->min_level;
					weight = ma_ptr->weight;



				/*:::iŨ_[W*/
				k = damroll(ma_ptr->dd + p_ptr->to_dd[hand], ma_ptr->ds + p_ptr->to_ds[hand]);
				///mod141221 Eҗpbackstabstab_fleeingǉ
				if (backstab)
				{
					k *= (3 + (p_ptr->lev / 20));
				}
				else if (fuiuchi)
				{
						k = k*(5+(p_ptr->lev*2/25))/2;
				}
				else if (stab_fleeing)
				{
					k = (3 * k) / 2;
				}
				/*:::ꏈ@n܎E@*/
				if( martial_arts_method == MELEE_MODE_EX_CLAW && mode == HISSATSU_EXCLAW && !(r_ptr->flagsr & (RFR_RES_ALL | RFR_IM_POIS))) 
					if(mult < 200) mult = 200;
				/*:::ꏈ@эj~*/
				if(p_ptr->kamioroshi & KAMIOROSHI_IZUNA && (r_ptr->flags3 & (RF3_ANG_CHAOS)) ) 
					if(mult < 150) mult = 150;

				/*:::ꏈ@}i*/
				if( p_ptr->pclass == CLASS_YAMAME && p_ptr->lev > randint0(50) && !(r_ptr->flagsr & (RFR_RES_ALL | RFR_IM_POIS))) 
					if(mult < 200) mult = 200;


				switch(ma_ptr->effect)
				{
				case MELEE_STUN:
					stun_effect = 3 + randint0(3);
					break;
				case MELEE_STUN2:
					stun_effect = 5 + randint0(5);
					break;
				case MELEE_STUN3:
					stun_effect = 10 + randint0(10);
					break;
				//얲iȂ
				case MELEE_SLAY_EVIL:
					if(r_ptr->flags3 & (RF3_UNDEAD | RF3_DEMON | RF3_KWAI))
					{
						if(mult < 250) mult = 250;
						stun_effect = 5 + randint0(5);
					}
					break;
				///mod140217 ߋ̉HߊiȂǁ@dϐ̂ȂGɃXC+NO
				case MELEE_ELEC:
					if(!(r_ptr->flagsr & (RFR_RES_ALL | RFR_IM_ELEC)))
					{
						if(mult<200) mult=200;
						stun_effect = 10 + randint0(5);
					}
					break;
				///mod140309 ؐ̕ъi@AfbhXC+NO
				///mod141231 XCǉ
				case MELEE_KASEN:
					stun_effect = 5 + randint0(5);
					if(r_ptr->flags3 & (RF3_UNDEAD) || r_ptr->flags3 & (RF3_ANIMAL))
					{
						if(mult < 300) mult = 300;
						stun_effect = 10 + randint0(10);
					}
					break;
				/*:::Hack iz*/
				case MELEE_VAMP:
					if (monster_living(r_ptr))
					{
						can_drain = TRUE;
						can_feed = TRUE;
					}
					break;
				//n@_+z
				case MELEE_MELT:
					if(r_ptr->flagsr & RFR_RES_ALL) k=0;
					else if(!(r_ptr->flagsr & RFR_IM_ACID))
					{
						if(mult<200) mult=200;
					}
					if (monster_living(r_ptr))
					{
						can_drain = TRUE;
						can_feed = TRUE;
					}
					break;
				//͂ȉΉU
				case MELEE_ATAGO:
					if(r_ptr->flagsr & RFR_RES_ALL) k=0;
					else if(!(r_ptr->flagsr & RFR_IM_FIRE))
					{
						if(r_ptr->flagsr & RFR_HURT_FIRE && mult<500) mult = 500;
						else if(mult<300) mult=300;
					}
					break;
					//ΉU
				case MELEE_FIRE:
					if(r_ptr->flagsr & RFR_RES_ALL) k=0;
					else if(!(r_ptr->flagsr & RFR_IM_FIRE))
					{
						if(r_ptr->flagsr & RFR_HURT_FIRE && mult<300) mult = 300;
						else if(mult<200) mult=200;
					}
					break;
					//CAXU
				case MELEE_COLD:
					if(r_ptr->flagsr & RFR_RES_ALL) k=0;
					else if(!(r_ptr->flagsr & RFR_IM_COLD))
					{
						if(r_ptr->flagsr & RFR_HURT_COLD && mult<300) mult = 300;
						else if(mult<200) mult=200;
					}
					break;

				case MELEE_SLOW:
					special_effect = MA_SLOW;
					break;

				case MELEE_POIS: //őϐ̂ȂGɑ_[W
					if(r_ptr->flagsr & RFR_RES_ALL) k=0;
					else if(!(r_ptr->flagsr & RFR_IM_POIS))
					{
						if(monster_living(r_ptr)) mult = MAX(300,mult);
						else mult = MAX(200,mult);
					}
					break;
				case MELEE_SINK: //ѐvU
						if(monster_living(r_ptr) && !((r_ptr->flags1 & RF1_UNIQUE) || (r_ptr->flags7 & RF7_UNIQUE2) || (r_ptr->flags1 & RF1_QUESTOR)))
							sinker = TRUE;
						//breakȂ
				case MELEE_WATER:
					if(	(r_ptr->flags7 & RF7_AQUATIC)
						|| (r_ptr->flagsr & RFR_RES_WATE)) mult = 50;
					else
					{
						if(!(r_ptr->flags3 & RF3_NO_STUN)) stun_effect = 3 + randint0(3);
						if(r_ptr->flagsr & RFR_HURT_WATER) mult = 200;
					}
					break;
				case MELEE_NUE: //t^
					if(r_ptr->flags3 & RF3_NO_CONF)
					{
						if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flags3 |= RF3_NO_CONF;
					}
					else if(randint0(100) > r_ptr->level)
					{
						msg_format("%^s͍悤B", m_name);
						(void)set_monster_confused(c_ptr->m_idx, MON_CONFUSED(m_ptr) + 10 + randint0(p_ptr->lev) / 5);
					}
					break;

				//v1.1.20@ӂ̔LԍU͏dʂLԂ̒g̏dʂɂȂ
				case MELEE_NEKOGURUMA:
					{
						int inven2_num = calc_inven2_num();
						int nekoguruma_weight = 0;
						int i;

						for (i = 0; i < inven2_num; i++)
						{
							object_type *tmp_o_ptr = &inven_add[i];
							if(!tmp_o_ptr->k_idx) continue;

							nekoguruma_weight += tmp_o_ptr->weight * tmp_o_ptr->number;
						}

						// -hack- dʒlύX@Ƃplev|Ԃ񌸂炵Ƃ
						weight = nekoguruma_weight / p_ptr->lev; 
						if(weight < 1) weight = 1;
						if(weight > 20) weight = 20;
						if(cheat_xtra) msg_format("weight:%d",weight);
						if(nekoguruma_weight > 200)
						{
							stun_effect = nekoguruma_weight / 100 + randint1(nekoguruma_weight / 100);
						}
					}
					break;

					//v1.1.42 h~[U ̐EŖXCA̐EȊOł͐tOǉ
				case MELEE_SLEEP:
					if (IN_DREAM_WORLD)
					{
						mult = 300;
					}
					else
					{
						counting_sheep++;
					}
					break;

				default:

					//v1.1.47 ~XeBAuq[}P[Wv
					if (p_ptr->pclass == CLASS_MYSTIA && music_singing(MUSIC_NEW_MYSTIA_HUMAN_CAGE) && (r_ptr->flags3 & RF3_HUMAN))
					{
						if(mult < 200) mult = 200;
					}

					break;

				}
				k = k * mult / 100;//i[XC

				/*:::LXꏈ ACȂǂ_[WɉZ*/
				if(p_ptr->pclass == CLASS_KISUME) k += calc_kisume_bonus();


#if 0
				if (p_ptr->special_attack & ATTACK_SUIKEN) k *= 2;

				if (ma_ptr->effect == MA_KNEE)
				{
					if (r_ptr->flags1 & RF1_MALE)
					{
#ifdef JP
						msg_format("%sɋIGR킵I", m_name);
#else
						msg_format("You hit %s in the groin with your knee!", m_name);
#endif

						sound(SOUND_PAIN);
						special_effect = MA_KNEE;
					}
					else
						msg_format(ma_ptr->desc, m_name);
				}

				else if (ma_ptr->effect == MA_SLOW)
				{
					if (!((r_ptr->flags1 & RF1_NEVER_MOVE) ||
					    my_strchr("~#{}.UjmeEv$,DdsbBFIJQSXclnw!=?", r_ptr->d_char)))
					{
#ifdef JP
						msg_format("%s̑Ɋ֐ߏR킵I", m_name);
#else
						msg_format("You kick %s in the ankle.", m_name);
#endif

						special_effect = MA_SLOW;
					}
					else msg_format(ma_ptr->desc, m_name);
				}
				else
				{
					if (ma_ptr->effect)
					{
						stun_effect = (ma_ptr->effect / 2) + randint1(ma_ptr->effect / 2);
					}

					msg_format(ma_ptr->desc, m_name);
				}
#endif

				//if (p_ptr->special_defense & KAMAE_SUZAKU) weight = 4;
				/*:::CpmɋC܂Ăꍇdʔ葝*/
				if ((p_ptr->pclass == CLASS_FORCETRAINER) && (p_ptr->magic_num1[0]))
				{
					weight += (p_ptr->magic_num1[0]/30);
					if (weight > 20) weight = 20;
				}
				/*:::iŨNeBJ*/


				k = critical_norm(p_ptr->lev * weight, min_level, k, p_ptr->to_h[0], 0);


				//v1.1.46 ̓ꏈ@[hɂċD肷
				if (p_ptr->pclass == CLASS_JYOON)
				{
					if (martial_arts_method == MELEE_MODE_JYOON_1)
					{
						int tmp, gain_money;

						tmp = MAX(1, r_ptr->level / 3);

						gain_money = k * tmp + randint1(k * tmp);
						//|(mɂ̓_CXlœGHPƂ)͎擾z5{ɂĂ݂
						if (k > m_ptr->hp) gain_money = gain_money * 3 + randint1(gain_money * 4);
						//z͋DȂ
						if (is_pet(m_ptr)) gain_money = 0;
						//hbv̂ȂX^[͋ĂȂƂɂĂ
						if (!(r_ptr->flags1 & (RF1_DROP_60| RF1_DROP_90 | RF1_DROP_1D2| RF1_DROP_2D2| RF1_DROP_3D2| RF1_DROP_4D2))) 
							gain_money = 0;

						if (gain_money > 0)
						{
							msg_format("$%dDB", gain_money);
							p_ptr->au += gain_money;
							p_ptr->redraw |= PR_GOLD;
						}


					}
					else if (martial_arts_method == MELEE_MODE_JYOON_2)
					{
						int tmp = (p_ptr->lev - 15);
						int waste_money = k * tmp + randint1(k * tmp);

						jyoon_record_money_waste(waste_money);

						if (waste_money > p_ptr->au)
						{

							p_ptr->au = 0;
						}
						else 			
							p_ptr->au -= waste_money;
						p_ptr->redraw |= PR_GOLD;
						//ȂȂZR}hɂU[hf
						if (!p_ptr->au)
						{
							msg_print("U~߂B");
							p_ptr->special_attack &= ~(ATTACK_WASTE_MONEY);
							p_ptr->redraw |= PR_STATUS;

						}


					}
				}


				if ((special_effect == MA_KNEE) && ((k + p_ptr->to_d[hand]) < m_ptr->hp))
				{
#ifdef JP
					msg_format("%^s͋ɂɂ߂ĂI", m_name);
#else
					msg_format("%^s moans in agony!", m_name);
#endif

					stun_effect = 7 + randint1(13);
					resist_stun /= 3;
				}

				else if ((special_effect == MA_SLOW) && ((k + p_ptr->to_d[hand]) < m_ptr->hp))
				{
					if (!(r_ptr->flags1 & RF1_UNIQUE) &&
					    (randint1(p_ptr->lev) > r_ptr->level) &&
					    m_ptr->mspeed > 60)
					{
#ifdef JP
						msg_format("%^s̑xxȂB", m_name);
#else
						msg_format("%^s starts limping slower.", m_name);
#endif

						m_ptr->mspeed -= 10;
					}
				}

				if (stun_effect && ((k + p_ptr->to_d[hand]) < m_ptr->hp))
				{
					if (p_ptr->lev > randint1(r_ptr->level + resist_stun + 10))
					{
						if (set_monster_stunned(c_ptr->m_idx, stun_effect + MON_STUNNED(m_ptr)))
						{
#ifdef JP
							msg_format("%^s̓ttɂȂB", m_name);
#else
							msg_format("%^s is stunned.", m_name);
#endif
						}
						else
						{
#ifdef JP
							msg_format("%^s͂ɃttɂȂB", m_name);
#else
							msg_format("%^s is more stunned.", m_name);
#endif
						}
					}
				}
			}

			/* Handle normal weapon */
			/*:::ʏ핐ɂU*/
			else if (o_ptr->k_idx)
			{
				int wgt = o_ptr->weight;
				/*:::_CX+ǉ_CXîƂñX̂݁Hj*/
				///mod150510 fP̓ꏈ
				if(o_ptr->name1 == ART_EIKI)
					k = damroll(r_ptr->level / 10 + o_ptr->dd + p_ptr->to_dd[hand], o_ptr->ds + p_ptr->to_ds[hand]);
				else 
					k = damroll(o_ptr->dd + p_ptr->to_dd[hand], o_ptr->ds + p_ptr->to_ds[hand]);


				/*:::_CXɃXCȂǓKp*/
				k = tot_dam_aux(o_ptr, k, m_ptr, mode, FALSE);

				if (backstab)
				{
					k *= (3 + (p_ptr->lev / 20));
				}
				else if (fuiuchi)
				{
						k = k*(5+(p_ptr->lev*2/25))/2;
				}
				else if (stab_fleeing)
				{
					k = (3 * k) / 2;
				}

				if ((p_ptr->impact[hand] && ((k > 50) || one_in_(7))) ||
					 (chaos_effect == 2) || (mode == HISSATSU_QUAKE))
				{
					do_quake = TRUE;
				}
				//LXяオ̏dʉZ
				if(p_ptr->pclass == CLASS_KISUME && p_ptr->concent)
					wgt += p_ptr->concent * (wgt + 100);

				/*:::NeBJ*/
			//	if ((!(o_ptr->tval == TV_SWORD) || !(o_ptr->sval == SV_DOKUBARI)) && !(mode == HISSATSU_KYUSHO))
				if ((!(o_ptr->tval == TV_KNIFE) || !(o_ptr->sval == SV_WEAPON_DOKUBARI)) && !(mode == HISSATSU_KYUSHO))
					k = critical_norm(wgt, o_ptr->to_h, k, p_ptr->to_h[hand], mode);

				drain_result = k;

				//v1.1.46 ؂ꖡ̕玝ĂēeڂBaSƎp؂ꖡ͏łł͎gȂ̂ō폜
				if (have_flag(flgs, TR_EX_VORPAL))
				{
					vorpal_chance = 2;
				}
				else if (have_flag(flgs, TR_VORPAL))
				{
					if ((p_ptr->special_attack & ATTACK_VORPAL) && object_has_a_blade(o_ptr))
						vorpal_chance = 2;
					else if (p_ptr->special_attack & ATTACK_UNSUMMON)
						vorpal_chance = 3;
					else
						vorpal_chance = 4;
				}
				else
				{
					if ((p_ptr->special_attack & ATTACK_VORPAL) && object_has_a_blade(o_ptr))
						vorpal_chance = 4;
					else if (p_ptr->special_attack & ATTACK_UNSUMMON)
						vorpal_chance = 4;
					else
						vorpal_chance = 0;
				}

				if(vorpal_chance && (randint1(vorpal_chance * 3 / 2) == 1))
					vorpal_cut = TRUE;
				else 
					vorpal_cut = FALSE;

				if (weapon_invalid) vorpal_cut = FALSE;

				/*:::H[pqbg*/
				if (vorpal_cut)
				{
					int mult = 2;

					///del msg `F[\[
#if 0
					///sydel item `F[\[̃bZ[W@Ƃ@ςɃXgũbZ[WOɓ悤
					if ((o_ptr->name1 == ART_CHAINSWORD) && !one_in_(2))
					{
						char chainsword_noise[1024];
#ifdef JP
						if (!get_rnd_line("chainswd_j.txt", 0, chainsword_noise))
#else
						if (!get_rnd_line("chainswd.txt", 0, chainsword_noise))
#endif
						{
							msg_print(chainsword_noise);
						}
					}
#endif
					if (o_ptr->name1 == ART_VORPAL_BLADE)
					{
#ifdef JP
						msg_print("ڂɂ~܂ʃH[pu[hAB̑ƁI");
#else
						msg_print("Your Vorpal Blade goes snicker-snack!");
#endif
					}
					else
					{
#ifdef JP
						msg_format("n%ss؂􂢂I", m_name);
#else
						msg_format("Your weapon cuts deep into %s!", m_name);
#endif
					}

					/* Try to increase the damage */
					while (one_in_(vorpal_chance))
					{
						mult++;
					}

					k *= mult;

					/* Ouch! */
					/*:::؂ꖡbZ[W@ύX悤*/
					if (((r_ptr->flagsr & RFR_RES_ALL) ? k/100 : k) > m_ptr->hp)
					{
#ifdef JP
				//		msg_format("%s^ɂI", m_name);
#else
						msg_format("You cut %s in half!", m_name);
#endif
					}
					else
					{
						switch (mult)
						{
						case 2: //msg_format("%saI", m_name); break;
						case 3: msg_format("%sԂaI", m_name); break;
						case 4: //msg_format("%sb^aɂI", m_name); break;
						case 5: msg_format("%sőaɂI", m_name); break;
						case 6: //msg_format("%shgɂI", m_name); break;
						case 7: default:msg_format("%saĎaĎa܂I", m_name); break;
						//default: msg_format("%sא؂ɂI", m_name); break;

						}
					}
					drain_result = drain_result * 3 / 2;
				}

				k += o_ptr->to_d;
				drain_result += o_ptr->to_d;
			}

			/*:::U܂ŁBi/틤*/

			//pXB_CXu[Xg
			if(p_ptr->pclass == CLASS_PARSEE && r_ptr->level > p_ptr->lev)
			{
				int k_old = k;

				if(r_ptr->flags1 & RF1_FEMALE) k *= 3;
				else k = k * 3 / 2;

				if(cheat_xtra) msg_format("pXB̃_CXu[Xg:%d%d",k_old, k);

			}

			/* Apply the player damage bonuses */
			k += p_ptr->to_d[hand];
			drain_result += p_ptr->to_d[hand];

			///class pƂ̕KE
			if ((mode == HISSATSU_SUTEMI) || (mode == HISSATSU_3DAN)) k *= 3; ///mod140914 23
			if ((mode == HISSATSU_SEKIRYUKA) && !monster_living(r_ptr)) k = 0;
			if ((mode == HISSATSU_SEKIRYUKA) && !p_ptr->cut) k /= 2;

			/* No negative damage */
			if (k < 0) k = 0;

			if ((mode == HISSATSU_ZANMA) && monster_living(r_ptr))
			{
				k = 0;
			}

			///item aS
			if (zantetsu_mukou)
			{
#ifdef JP
				msg_print("ȓ炩̂͐؂I");
#else
				msg_print("You cannot cut such a elastic thing!");
#endif
				k = 0;
			}

			if (e_j_mukou)
			{
#ifdef JP
				msg_print("w偂͋肾I");
#else
				msg_print("Spiders are difficult for you to deal with!");
#endif
				k /= 2;
			}

			if (mode == HISSATSU_MINEUCHI 
				|| ((p_ptr->special_attack & ATTACK_CHAOS) && !(r_ptr->flagsr & RFR_RES_CHAO) && !(r_ptr->flags1 & RF1_UNIQUE) && !(r_ptr->flags7 & RF7_UNIQUE2)&& (p_ptr->lev > randint1(r_ptr->level * (r_ptr->flags2 & RF2_POWERFUL || r_ptr->flags2 & RF2_GIGANTIC)?20:10))))
			{
				int tmp = (10 + randint1(15) + p_ptr->lev / 5);

				if(mode == HISSATSU_MINEUCHI) k = 0;
				anger_monster(m_ptr);

				if (!(r_ptr->flags3 & (RF3_NO_STUN)))
				{
					/* Get stunned */
					if (MON_STUNNED(m_ptr))
					{
#ifdef JP
						msg_format("%s͂Ђǂ낤ƂB", m_name);
#else
						msg_format("%s is more dazed.", m_name);
#endif

						tmp /= 2;
					}
					else
					{
#ifdef JP
						msg_format("%s ͂낤ƂB", m_name);
#else
						msg_format("%s is dazed.", m_name);
#endif
					}

					/* Apply stun */
					(void)set_monster_stunned(c_ptr->m_idx, MON_STUNNED(m_ptr) + tmp);
				}
				else
				{
#ifdef JP
					msg_format("%s ɂ͌ʂȂB", m_name);
#else
					msg_format("%s is not effected.", m_name);
#endif
				}
			}

			/* Modify the damage */
			/*:::Ƃ͂ꃁ^̏*/
			///item ̑劙 class m@
			///del131223 ̑劙폜
			//k = mon_damage_mod(m_ptr, k, (bool)(((o_ptr->tval == TV_POLEARM) && (o_ptr->sval == SV_DEATH_SCYTHE)) || ((p_ptr->pclass == CLASS_BERSERKER) && one_in_(2))));
			k = mon_damage_mod(m_ptr, k, (bool)((p_ptr->pseikaku == SEIKAKU_BERSERK) && one_in_(2)));

			///item Őj
			///mod131223 tval
			if ((!weapon_invalid && (o_ptr->tval == TV_KNIFE) && (o_ptr->sval == SV_WEAPON_DOKUBARI)) || (mode == HISSATSU_KYUSHO))
			{
				if ((randint1(randint1(r_ptr->level/7)+5) == 1) && !(r_ptr->flags1 & RF1_UNIQUE) && !(r_ptr->flags7 & RF7_UNIQUE2))
				{
					k = m_ptr->hp + 1;
#ifdef JP
					msg_format("%s̋}˂hI", m_name);
#else
					msg_format("You hit %s on a fatal spot!", m_name);
#endif
					set_deity_bias(DBIAS_REPUTATION, -3);

				}
				else k = 1;
			}
			/*:::E҃qbg*/
			///class E҃qbg
			///mod140511 悤ȂƂ
			else if ((p_ptr->pclass == CLASS_KOISHI && fuiuchi) || 
				(p_ptr->pclass == CLASS_NINJA) && (o_ptr->tval == TV_KNIFE || monk_attack) && ((p_ptr->cur_lite <= 0) || one_in_(7)))
			{
				int maxhp = maxroll(r_ptr->hdice, r_ptr->hside);
				if (one_in_(backstab ? 13 : (stab_fleeing || fuiuchi) ? 15 : 27))
				{
					k *= 5;
					drain_result *= 2;
#ifdef JP
					if(p_ptr->pclass == CLASS_KOISHI)
						msg_format("%s͑ShɈꌂ󂯂I", m_name);
					else if(o_ptr->k_idx)
						msg_format("n%sɐ[XƓ˂hI", m_name);
					else
						msg_format("sꌂ%sɓ˂hI", m_name);
#else
					msg_format("You critically injured %s!", m_name);
#endif
				}
				else if (((m_ptr->hp < maxhp/2) && one_in_((p_ptr->num_blow[0]+p_ptr->num_blow[1]+1)*10)) || ((one_in_(666) || ((backstab || fuiuchi) && one_in_(11))) && !(r_ptr->flags1 & RF1_UNIQUE) && !(r_ptr->flags7 & RF7_UNIQUE2)))
				{
					if ((r_ptr->flags1 & RF1_UNIQUE) || (r_ptr->flags7 & RF7_UNIQUE2) || (m_ptr->hp >= maxhp/2))
					{
						k = MAX(k*5, m_ptr->hp/2);
						drain_result *= 2;
#ifdef JP
					if(p_ptr->pclass == CLASS_KOISHI)
						msg_format("%s͑ShɈꌂ󂯂I", m_name);
					else if(o_ptr->k_idx)
						msg_format("n%s̋}тI", m_name);
					else
						msg_format("%s̋}֋ȈꌂI", m_name);
#else
						msg_format("You fatally injured %s!", m_name);
#endif
					}
					else
					{
						k = m_ptr->hp + 1;
#ifdef JP
					if(p_ptr->pclass == CLASS_KOISHI)
						msg_format("%s̈ӎ͓r؂ꂽB", m_name);
					else if(o_ptr->k_idx)
						msg_format("n%s̋}тI", m_name);
					else
						msg_format("%s|B", m_name);
#else
						msg_format("You hit %s on a fatal spot!", m_name);
#endif
					}
				}
			}
			//ѓU@j[NAAϐ̂Ƃ̃tO͗Ȃ
			else if(sinker)
			{
				int resist = 100 + r_ptr->level * 6;
				if(r_ptr->flags2 & RF2_POWERFUL) resist = resist * 3 / 2;
				if(r_ptr->flags2 & RF2_GIGANTIC) resist *= 2;
				if(r_ptr->flags7 & RF7_CAN_FLY) resist *= 2;

				if(randint1(resist) < p_ptr->lev)
				{
						k = m_ptr->hp + 1;
						msg_format("%sMꂳB", m_name);

				}
			}

			//v1.1.21 m(Xj[LO萬)
			else if(sneakingkill)
			{
				k = m_ptr->hp + 1;
				msg_format("%s𖳗͉B", m_name);

			}


			if( k > 9999) k = 9999;

			/* Complex message */
			if (p_ptr->wizard || cheat_xtra)
			{
#ifdef JP
				msg_format("%d/%d ̃_[W^B", k, m_ptr->hp);
#else
				msg_format("You do %d (out of %d) damage.", k, m_ptr->hp);
#endif
			}

			if (k <= 0)
			{
				can_drain = FALSE;
				can_feed = FALSE;
			}

			if (drain_result > m_ptr->hp)
				drain_result = m_ptr->hp;

			/* Damage, check for fear and death */
			if (mon_take_hit(c_ptr->m_idx, k, fear, NULL))
			{
				*mdeath = TRUE;
				///class o[T[J[@|ƂU񐔂cĂGlM[H
				///sys AX̘AUƂ̏pŗǂł͂Ȃ낤
				/*
				if ((p_ptr->pclass == CLASS_BERSERKER) && energy_use)
				{
					if (p_ptr->migite && p_ptr->hidarite)
					{
						if (hand) energy_use = energy_use*3/5+energy_use*num*2/(p_ptr->num_blow[hand]*5);
						else energy_use = energy_use*num*3/(p_ptr->num_blow[hand]*5);
					}
					else
					{
						energy_use = energy_use*num/p_ptr->num_blow[hand];
					}
				}
				*/
				///item aS
				if ((o_ptr->name1 == ART_ZANTETSU) && is_lowlevel && !weapon_invalid)
#ifdef JP
					msg_print("܂܂ʂ̂aĂ܂DDD");
#else
					msg_print("Sigh... Another trifling thing I've cut....");
#endif

				///mod140714 tr_g̗d퉻@G|͗d퉻₷
				//v1.1.29 ۂ̒ǉƁ̗d퉻Ă̂Œǉ
				if((p_ptr->pclass == CLASS_TSUKUMO_MASTER || p_ptr->pclass == CLASS_RAIKO) && 
					!object_is_fixed_artifact(o_ptr) && o_ptr->xtra1 < 100)
				{
					if(randint0(o_ptr->xtra1) < (r_ptr->level-o_ptr->xtra1 / 4) || (r_ptr->flags1 & RF1_UNIQUE))
					{
						o_ptr->xtra1++; 
						if((r_ptr->flags1 & RF1_UNIQUE) && (o_ptr->xtra1 % 50)) o_ptr->xtra1++; //j[N|2|Cg{[iX
						if(o_ptr->xtra1 == 50 || o_ptr->xtra1 == 100) make_evilweapon(o_ptr,r_ptr); 
					}
				}

				/*:::X^[|Ƃzs悤ɂ邽߁AbreakžɈړ*/
				//break;
			}

			/* Are we draining it?  A little note: If the monster is
			dead, the drain does not work... */
			/*:::z X^[|ɂ悤ɂ*/
			if (can_drain && (drain_result > 0))
			{
				///item ̓ꋭ
				if (o_ptr->name1 == ART_MURAMASA)
				{
					if (is_human)
					{
						int to_h = o_ptr->to_h;
						int to_d = o_ptr->to_d;
						int i, flag;

						flag = 1;
						for (i = 0; i < to_h + 3; i++) if (one_in_(4)) flag = 0;
						if (flag) to_h++;

						flag = 1;
						for (i = 0; i < to_d + 3; i++) if (one_in_(4)) flag = 0;
						if (flag) to_d++;

						if (o_ptr->to_h != to_h || o_ptr->to_d != to_d)
						{
#ifdef JP
							msg_print("d͌zċȂI");
#else
							msg_print("Muramasa sucked blood, and became more powerful!");
#endif
							o_ptr->to_h = to_h;
							o_ptr->to_d = to_d;
						}
					}
				}
				else
				{
					if (drain_result > 5) /* Did we really hurt it? */
					{
						///mod140412 GɎ~߂hHP啝ɉ񕜂邱ƂɂĂ݂
						if(*mdeath) drain_heal = drain_result;
						else drain_heal = damroll(2, drain_result / 6);

						if(p_ptr->pclass == CLASS_YOSHIKA) drain_heal *= 2;
						/* Hex */
						if (hex_spelling(HEX_VAMP_BLADE)) drain_heal *= 2;

						if (cheat_xtra)
						{
#ifdef JP
							msg_format("Draining left: %d", drain_left);
#else
							msg_format("Draining left: %d", drain_left);
#endif

						}

						if (drain_left)
						{
							if (drain_heal < drain_left)
							{
								drain_left -= drain_heal;
							}
							else
							{
								drain_heal = drain_left;
								drain_left = 0;
							}

							if (drain_msg)
							{
#ifdef JP
								msg_format("%s琶͂zI", m_name);
#else
								msg_format("Your weapon drains life from %s!", m_name);
#endif
								if(one_in_(100)) set_deity_bias(DBIAS_COSMOS, -1);

								drain_msg = FALSE;
							}

							/*:::ˑRψقƋz̉񕜗ʂ炵*/
							drain_heal = (drain_heal * mutant_regenerate_mod) / 100;

							hp_player(drain_heal);
							/* We get to keep some of it! */
						}
					}
				}
				m_ptr->maxhp -= (k+7)/8;
				if (m_ptr->hp > m_ptr->maxhp) m_ptr->hp = m_ptr->maxhp;
				if (m_ptr->maxhp < 1) m_ptr->maxhp = 1;
				weak = TRUE;
			}

			if (can_feed && (drain_result > 0))
			{
				if(p_ptr->food < PY_FOOD_MAX) set_food(MIN(PY_FOOD_MAX-1,p_ptr->food + drain_result*5));
			}

			can_drain = FALSE;
			can_feed = FALSE;
			drain_result = 0;

			if(*mdeath) break;

			/* Anger the monster */
			///mod140412 ̓s͋z̑OɎĂ
			if (k > 0) anger_monster(m_ptr);

			//I[_[W@jۓU̓I[󂯂Ȃ
			//֊iA\EXJv`AA_uXRAI[󂯂Ȃ
			//v1.1.14 _ľ
			if(mode != HISSATSU_SHINMYOU && 
				mode != HISSATSU_NO_AURA && 
				mode != HISSATSU_GION && 
				mode != HISSATSU_SOULSCULPTURE && 
				mode != HISSATSU_DOUBLESCORE && 
				!(p_ptr->pclass == CLASS_ICHIRIN && p_ptr->do_martialarts ))
				touch_zap_player(m_ptr);


			/* Confusion attack */
			/*:::̎菈*/
			///sys ʂ̍̎菈Ƃ̕ӂɏ悹΂
			if ((p_ptr->special_attack & ATTACK_CONFUSE) 
				|| (p_ptr->special_attack & ATTACK_CHAOS) && !(r_ptr->flagsr & RFR_RES_CHAO) && p_ptr->lev > randint1(r_ptr->level * 4) 
				|| (chaos_effect == 3) || (mode == HISSATSU_CONF) || hex_spelling(HEX_CONFUSION))
			{
				bool flg= FALSE;
				/* Cancel glowing hands */
				if (p_ptr->special_attack & ATTACK_CONFUSE)
				{
					flg = TRUE;
					p_ptr->special_attack &= ~(ATTACK_CONFUSE);
#ifdef JP
					msg_print("̋PȂȂB");
#else
					msg_print("Your hands stop glowing.");
#endif
					p_ptr->redraw |= (PR_STATUS);

				}

				/* Confuse the monster */
				if (r_ptr->flags3 & RF3_NO_CONF)
				{
					if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flags3 |= RF3_NO_CONF;

#ifdef JP
					if(flg) msg_format("%^sɂ͌ʂȂB", m_name);
#else
					msg_format("%^s is unaffected.", m_name);
#endif

				}
				else if (randint0(100) < r_ptr->level)
				{
#ifdef JP
					if(flg) msg_format("%^sɂ͌ʂȂB", m_name);
#else
					msg_format("%^s is unaffected.", m_name);
#endif

				}
				else
				{
#ifdef JP
					msg_format("%^s͍悤B", m_name);
#else
					msg_format("%^s appears confused.", m_name);
#endif

					(void)set_monster_confused(c_ptr->m_idx, MON_CONFUSED(m_ptr) + 10 + randint0(p_ptr->lev) / 5);
				}
			}
//v1.1.20 cȖ@̌ʕύX
#if 0
			///mod140725 cȖ@̖E@ʏ̖EƈႤɂ邽player_castFALSEœnB
			if(p_ptr->special_attack & ATTACK_UNSUMMON)
			{
				if((r_ptr->flagsr & ( RFR_RES_TIME)) && !one_in_(6)) ;
				else if((r_ptr->flagsr & (RFR_RES_TELE)) && !one_in_(3)) ;
				else if(randint1(r_ptr->level * 3 + 100) > p_ptr->lev); 
				else if(genocide_aux(c_ptr->m_idx,0, FALSE, 0,"(̃bZ[W͏oȂ͂)"))
				{
						msg_format("%^s͂̊KB", m_name);
						num = num_blow + 1; /* Can't hit it anymore! */
						*mdeath = TRUE;
				}

			}

			else 
#endif				
			if (chaos_effect == 4)
			{
				bool resists_tele = FALSE;

				if (r_ptr->flagsr & RFR_RES_TELE)
				{
					if (r_ptr->flags1 & RF1_UNIQUE)
					{
						if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flagsr |= RFR_RES_TELE;
#ifdef JP
						msg_format("%^sɂ͌ʂȂB", m_name);
#else
						msg_format("%^s is unaffected!", m_name);
#endif

						resists_tele = TRUE;
					}
					else if (r_ptr->level > randint1(100))
					{
						if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flagsr |= RFR_RES_TELE;
#ifdef JP
						msg_format("%^s͒R͂ĂI", m_name);
#else
						msg_format("%^s resists!", m_name);
#endif

						resists_tele = TRUE;
					}
				}

				if (!resists_tele)
				{
#ifdef JP
					msg_format("%^s͏I", m_name);
#else
					msg_format("%^s disappears!", m_name);
#endif

					teleport_away(c_ptr->m_idx, 50, TELEPORT_PASSIVE);
					num = num_blow + 1; /* Can't hit it anymore! */
					*mdeath = TRUE;
				}
			}

			else if ((chaos_effect == 5) && (randint1(90) > r_ptr->level))
			{
				if (!(r_ptr->flags1 & (RF1_UNIQUE | RF1_QUESTOR)) &&
				    !(r_ptr->flagsr & RFR_EFF_RES_CHAO_MASK))
				{
					if (polymorph_monster(y, x))
					{
#ifdef JP
						msg_format("%^s͕ωI", m_name);
#else
						msg_format("%^s changes!", m_name);
#endif

						*fear = FALSE;
						weak = FALSE;
					}
					else
					{
#ifdef JP
						msg_format("%^sɂ͌ʂȂB", m_name);
#else
						msg_format("%^s is unaffected.", m_name);
#endif
					}

					/* Hack -- Get new monster */
					m_ptr = &m_list[c_ptr->m_idx];

					/* Oops, we need a different name... */
					monster_desc(m_name, m_ptr, 0);

					/* Hack -- Get new race */
					r_ptr = &r_info[m_ptr->r_idx];
				}
			}
			///sys item S[fn}[@gW[n^[ƂœƂłĂ
			/*:::S[fn}[ŉƂACeD*/
			else if (o_ptr->name1 == ART_G_HAMMER && !weapon_invalid)
			{
				monster_type *m_ptr = &m_list[c_ptr->m_idx];

				if (m_ptr->hold_o_idx && ( m_ptr->r_idx < MON_TSUKUMO_WEAPON1 || m_ptr->r_idx > MON_TSUKUMO_WEAPON5))
				{
					object_type *q_ptr = &o_list[m_ptr->hold_o_idx];
					char o_name[MAX_NLEN];

					object_desc(o_name, q_ptr, OD_NAME_ONLY);
					q_ptr->held_m_idx = 0;
					q_ptr->marked = OM_TOUCHED;
					m_ptr->hold_o_idx = q_ptr->next_o_idx;
					q_ptr->next_o_idx = 0;
#ifdef JP
					msg_format("%sDB", o_name);
#else
					msg_format("You snatched %s.", o_name);
#endif
					inven_carry(q_ptr);
				}
			}

			if((mode == HISSATSU_EIGOU) && !dokubari) num--;
		}

		/* Player misses */
		else
		{
			backstab = FALSE; /* Clumsy! */
			fuiuchi = FALSE; /* Clumsy! */
			///del131223 ̑劙폜
#if 0
			/*:::̑劙*/
			///sysdel item race ̑劙sƂ̏
			if ((o_ptr->tval == TV_POLEARM) && (o_ptr->sval == SV_DEATH_SCYTHE) && one_in_(3))
			{
				u32b flgs[TR_FLAG_SIZE];

				/* Sound */
				sound(SOUND_HIT);

				/* Message */
#ifdef JP
				msg_format("~XI %sɂ킳ꂽB", m_name);
#else
				msg_format("You miss %s.", m_name);
#endif
				/* Message */
#ifdef JP
				msg_print("U񂵂劙gɕԂĂI");
#else
				msg_print("Your scythe returns to you!");
#endif

				/* Extract the flags */
				object_flags(o_ptr, flgs);

				k = damroll(o_ptr->dd + p_ptr->to_dd[hand], o_ptr->ds + p_ptr->to_ds[hand]);
				{
					int mult;
					switch (p_ptr->mimic_form)
					{
					case MIMIC_NONE:
						switch (p_ptr->prace)
						{
						//	case RACE_YEEK:
						//	case RACE_KLACKON:
							case RACE_HUMAN:
							//case RACE_AMBERITE:
							case RACE_DUNADAN:
							//case RACE_BARBARIAN:
							case RACE_BEASTMAN:
								mult = 25;break;
						//	case RACE_HALF_ORC:
						//	case RACE_HALF_TROLL:
						//	case RACE_HALF_OGRE:
							//case RACE_HALF_GIANT:
							//case RACE_HALF_TITAN:
							//case RACE_CYCLOPS:
						//	case RACE_IMP:
							case RACE_SKELETON:
							case RACE_ZOMBIE:
							case RACE_VAMPIRE:
							case RACE_SPECTRE:
							//case RACE_DEMON:
						//	case RACE_DRACONIAN:
								mult = 30;break;
							default:
								mult = 10;break;
						}
						break;
					case MIMIC_DEMON:
					case MIMIC_DEMON_LORD:
					case MIMIC_VAMPIRE:
						mult = 30;break;
					default:
						mult = 10;break;
					}

					if (p_ptr->align < 0 && mult < 20)
						mult = 20;
					if (!(p_ptr->resist_acid || IS_OPPOSE_ACID() || p_ptr->immune_acid) && (mult < 25))
						mult = 25;
					if (!(p_ptr->resist_elec || IS_OPPOSE_ELEC() || p_ptr->immune_elec) && (mult < 25))
						mult = 25;
					if (!(p_ptr->resist_fire || IS_OPPOSE_FIRE() || p_ptr->immune_fire) && (mult < 25))
						mult = 25;
					if (!(p_ptr->resist_cold || IS_OPPOSE_COLD() || p_ptr->immune_cold) && (mult < 25))
						mult = 25;
					if (!(p_ptr->resist_pois || IS_OPPOSE_POIS()) && (mult < 25))
						mult = 25;

					if ((p_ptr->pclass != CLASS_SAMURAI) && (have_flag(flgs, TR_FORCE_WEAPON)) && (p_ptr->csp > (p_ptr->msp / 30)))
					{
						p_ptr->csp -= (1+(p_ptr->msp / 30));
						p_ptr->redraw |= (PR_MANA);
						mult = mult * 3 / 2 + 20;
					}
					k *= mult;
					k /= 10;
				}

				k = critical_norm(o_ptr->weight, o_ptr->to_h, k, p_ptr->to_h[hand], mode);
				if (one_in_(6))
				{
					int mult = 2;
#ifdef JP
					msg_format("ObT؂􂩂ꂽI");
#else
					msg_format("Your weapon cuts deep into yourself!");
#endif
					/* Try to increase the damage */
					while (one_in_(4))
					{
						mult++;
					}

					k *= mult;
				}
				k += (p_ptr->to_d[hand] + o_ptr->to_d);

				if (k < 0) k = 0;

#ifdef JP
				take_hit(DAMAGE_FORCE, k, "̑劙", -1);
#else
				take_hit(DAMAGE_FORCE, k, "Death scythe", -1);
#endif

				redraw_stuff();
			}
			else
#endif
			{
				/* Sound */
				sound(SOUND_MISS);

				/* Message */
#ifdef JP
				msg_format("~XI %sɂ킳ꂽB", m_name);
#else
				msg_format("You miss %s.", m_name);
#endif
			}

			if(mode == HISSATSU_EIGOU) break;
		}
		backstab = FALSE;
		fuiuchi = FALSE;

	}	//U񐔃[vI

	//h~[iUŖ点鏈
	if (counting_sheep && !(*mdeath))
	{
		int sleep_power = (p_ptr->lev+10) * counting_sheep;

		if (r_ptr->flagsr & RFR_RES_ALL) sleep_power = 0;
		if (r_ptr->flags1 & RF1_QUESTOR) sleep_power = 0;
		if ((r_ptr->flags1 & RF1_UNIQUE) || (r_ptr->flags7 & RF7_UNIQUE2)) sleep_power /= 2;
		if ((r_ptr->flags3 & RF3_NO_SLEEP)) sleep_power /= 3;

		if (randint1(sleep_power) > randint1(MAX(r_ptr->level,10)))
		{
			msg_format("%s͖B", m_name);
			set_monster_csleep(c_ptr->m_idx, randint1(3));
		}

	}

	//KJ^Ƃce
	if(flag_gun_kata)
	{
		object_type *tmp_o_ptr;
		int i;
		int timeout_base,timeout_max;
		for(i=INVEN_RARM;i<=INVEN_LARM;i++)
		{
			tmp_o_ptr = &inventory[i];

			if(tmp_o_ptr->tval != TV_GUN)
				msg_print("ERROR:e𑕔ĂȂ̂ɎceĂ΂Ă");
			else
			{
				timeout_base = calc_gun_timeout(tmp_o_ptr) * 1000;
				timeout_max = timeout_base * (calc_gun_load_num(tmp_o_ptr) - 1); 
				tmp_o_ptr->timeout += timeout_base;
				p_ptr->window |= PW_EQUIP;

				//KJ^cêߒe؂`FbN
				if(o_ptr->timeout > timeout_max)
					p_ptr->update |= PU_BONUS;
			}

		}
	}

	if (weak && !(*mdeath))
	{
#ifdef JP
		msg_format("%s͎キȂ悤B", m_name);
#else
		msg_format("%^s seems weakened.", m_name);
#endif
	}
	//if (drain_left != MAX_VAMPIRIC_DRAIN)
	//{
		///sysdel virtue
	//	if (one_in_(4))
	//	{
	//		chg_virtue(V_UNLIFE, 1);
	//	}
	//}
	/* Mega-Hack -- apply earthquake brand */
	if (do_quake)
	{
		earthquake(py, px, 10);
		if (!cave[y][x].m_idx) *mdeath = TRUE;
	}
	///mod140828 t̍U̕򉻏
	if(p_ptr->pclass == CLASS_FLAN && o_ptr->k_idx)
	{
		int blast;
		object_flags(o_ptr, flgs);
		if(object_is_artifact(o_ptr) && have_flag(flgs,TR_RES_DISEN)) blast = 0;
		else if(object_is_artifact(o_ptr) || have_flag(flgs,TR_RES_DISEN)) blast = 1;
		else blast = 13;

		if(randint0(169) < blast)
		{
			msg_print("j̗͂ɕ킪ςȂI");
			apply_disenchant(0,INVEN_RARM + hand);

		}

	}

}




/*:::ψٕʂ⏂ȂǂɂǉiUp[`@*/
static void py_attack_aux2(int y, int x, bool *fear, bool *mdeath)
{
	int		num = 0, k, bonus_h, bonus_d , chance;

	cave_type       *c_ptr = &cave[y][x];

	monster_type    *m_ptr = &m_list[c_ptr->m_idx];
	monster_race    *r_ptr = &r_info[m_ptr->r_idx];
	object_type     *o_ptr;

	char            m_name[80];

//	bool            success_hit = FALSE;
	bool            monk_attack = FALSE;
	//bool            do_quake = FALSE;
	bool            weak = FALSE;
	bool            drain_msg = TRUE;
	int             drain_result = 0, drain_heal = 0;
	bool            can_drain = FALSE;
	bool            can_feed = FALSE;
	int             num_blow;
	int             drain_left = MAX_VAMPIRIC_DRAIN;
	//u32b flgs[TR_FLAG_SIZE]; /* A massive hack -- life-draining weapons */
	//bool            is_human = (r_ptr->d_char == 'p');
	//bool            is_lowlevel = (r_ptr->level < (p_ptr->lev - 15));
	bool flag_gain_exp = FALSE;

	//int				martial_arts_method = 0;
	int i;

	int method[10];

	num_blow=0;
	for(i=0;i<10;i++) method[i]=0;


	/*:::ɗOpy_attack_aux()ŊiƂTRUEɂȂ͂ */
	//if(!buki_motteruka(INVEN_RARM) && !buki_motteruka(INVEN_LARM) && empty_hands(TRUE) == (EMPTY_HAND_RARM | EMPTY_HAND_LARM)) monk_attack = TRUE;
	if(p_ptr->do_martialarts) monk_attack = TRUE;

	/*:::܂U\Ȏimethod[]Ɋi[*/

	/*:::nxɉV[hobV nx20on߂50100%*/
	if(	(!check_invalidate_inventory(INVEN_RARM) &&inventory[INVEN_RARM].tval == TV_SHIELD || !check_invalidate_inventory(INVEN_LARM) &&inventory[INVEN_LARM].tval == TV_SHIELD)
		&& randint0(4800) < ref_skill_exp(SKILL_SHIELD)-3200)
	{
		method[num_blow++] = MELEE_MODE_SHIELD;
	//	msg_format("shield");

	}
	/*:::UɉוĂƂȀpnxɉǉŊi inx20ȏォΓψُ*/
	///mod141116 LXɂ͕U̒ǉiȂ
	///mod141221 E҂
	if(!monk_attack && p_ptr->pclass != CLASS_KISUME && p_ptr->pclass != CLASS_NINJA)
	{
		if(p_ptr->muta2 & MUT2_HARDHEAD && randint0(100) < p_ptr->lev + 25)	method[num_blow++] = MELEE_MODE_HEADBUTT;
		else if(randint0(4800) < ref_skill_exp(SKILL_MARTIALARTS)-3200)
		{
			method[num_blow++] = find_martial_arts_method(MELEE_FIND_NOHAND);
		}
		//_𗼎莝ĂĊiZ\ƂAɒǉio
		///mod150428 CAd񐔏オɂ
		if(inventory[INVEN_RARM].k_idx && inventory[INVEN_RARM].tval == TV_STICK && p_ptr->ryoute)
		{
			int num_xtra = 0;
			if(p_ptr->pclass == CLASS_MARTIAL_ARTIST) num_xtra++;
			if(randint1(ref_skill_exp(SKILL_MARTIALARTS)) > 3000) num_xtra++;
			if(randint1(ref_skill_exp(SKILL_MARTIALARTS)) > 4500) num_xtra++;
			if(randint1(ref_skill_exp(SKILL_MARTIALARTS)) > 6000) num_xtra++;
			if(heavy_armor()) num_xtra /= 2;
			for(;num_xtra>0;num_xtra--) method[num_blow++] = find_martial_arts_method(MELEE_FIND_NOHAND);
		}

	}
	/*:::pĂƂxɉĊpU*/
	if(p_ptr->muta2 & (MUT2_HORNS) && randint0(100) < p_ptr->lev + 20)	method[num_blow++] = MELEE_MODE_HORNS;	
	if(p_ptr->muta2 & (MUT2_BIGHORN) && randint0(100) < p_ptr->lev + 30)	method[num_blow++] = MELEE_MODE_BIGHORN;	
	/*:::KĂƂxɉĐKU*/
	if(p_ptr->muta2 & (MUT2_BIGTAIL) && randint0(100) < p_ptr->lev + 40)	method[num_blow++] = MELEE_MODE_BIGTAIL;	
	if(p_ptr->muta3 & (MUT3_FISH_TAIL) && randint0(100) < p_ptr->lev + 50)	method[num_blow++] = MELEE_MODE_FISH_TAIL;

	//e̓ǉi
	if(!monk_attack && (inventory[INVEN_RARM].tval == TV_GUN || inventory[INVEN_LARM].tval == TV_GUN) 
		&& !check_invalidate_inventory(INVEN_RARM) && randint0(8000) < ref_skill_exp(TV_GUN))
	{
		method[num_blow++] = select_gun_melee_mode();
	}


	if(num_blow==0) return;


	//msg_format("BLOW:%d",num_blow);
	//for(i=0;i<10;i++) 
	//	msg_format("%d:%d",i,method[i]);

	/* Disturb the monster */
	(void)set_monster_csleep(c_ptr->m_idx, 0);

	/* Extract monster name (or "it") */
	monster_desc(m_name, m_ptr, 0);

	/*:::U񐔂Ƃɔ whilenum𒆂ň̂ɕssȂ̂forɂ*/
	//while ((num++ < num_blow) && !p_ptr->is_dead)
	for (num=0; num < num_blow && !p_ptr->is_dead; num++ )
	{
		bool sinker = FALSE;
		int mult = 100;
		/*:::ol𓾂@ȊO͊i*/
		if(method[num] == MELEE_MODE_SHIELD) gain_skill_exp(SKILL_SHIELD, m_ptr);
		else if(!flag_gain_exp)
		{
			flag_gain_exp = TRUE;
			gain_skill_exp(SKILL_MARTIALARTS, m_ptr);
		}

		/*:::iȂǂ̏CČvZ*/
		bonus_h = ((int)(adj_dex_th[p_ptr->stat_ind[A_DEX]]) - 128);
		bonus_d = ((int)(adj_str_td[p_ptr->stat_ind[A_STR]]) - 128);
		if(method[num] == MELEE_MODE_SHIELD)
		{
			bonus_h +=  p_ptr->lev / 2 * ref_skill_exp(SKILL_SHIELD) / 8000;
			bonus_d +=  p_ptr->lev / 4 * ref_skill_exp(SKILL_SHIELD) / 8000;
		}
		else 
		{
			int tmp =  p_ptr->lev / 2 * ref_skill_exp(SKILL_MARTIALARTS) / 8000;
			if(heavy_armor()) tmp /= 2;
			bonus_h += tmp;
			bonus_d += tmp/2;
		}
		if (p_ptr->stun > 50 || p_ptr->drowning){	bonus_h -= 20;	bonus_d -= 20;	}
		else if (p_ptr->stun){	bonus_h -= 5;	bonus_d -= 5;	}
		if (IS_HERO()) bonus_h += 12;
		if (p_ptr->shero) bonus_d += 3+(p_ptr->lev/5);

		for (i = INVEN_RARM; i < INVEN_TOTAL; i++)
		{
			o_ptr = &inventory[i];
			if (!o_ptr->k_idx) continue;
			if(check_invalidate_inventory(i)) continue;
			//̎ECC͖
			if(object_is_melee_weapon(o_ptr)) continue;
			if(object_is_shooting_weapon(o_ptr)) continue;
			//Ăwւ̏C͖@(ɏƎwւ𑕔ďUƂ̎wւ̏CKp邪܂ǂł낤)
			if(i == INVEN_RIGHT && !(method[num] == MELEE_MODE_SHIELD && inventory[INVEN_RARM].tval == TV_SHIELD)) continue;
			if(i == INVEN_LEFT && !(method[num] == MELEE_MODE_SHIELD && inventory[INVEN_LARM].tval == TV_SHIELD)) continue;
			//ȉCKp@1/2ɂĂ
			bonus_h += o_ptr->to_h/2;
			bonus_d += o_ptr->to_d/2;
		}
		chance = (p_ptr->skill_thn + (bonus_h * BTH_PLUS_ADJ));

		/* Test for hit */
		if ( test_hit_norm(chance, r_ptr->ac, m_ptr->ml))
		{
			int resist_stun = 0;
			int special_effect = 0, stun_effect = 0, times = 0, max_times;
			int min_level = 1;
			const martial_arts_new *ma_ptr = &ma_blows_new[0], *old_ptr = &ma_blows_new[0];
			int weight = 8;

			k = 1;

			if (r_ptr->flags1 & RF1_UNIQUE) resist_stun += 88;
			if (r_ptr->flags2 & RF2_GIGANTIC) resist_stun += 88;
			if (r_ptr->flags3 & RF3_NO_STUN) resist_stun += 66;
			if (r_ptr->flags3 & RF3_NO_CONF) resist_stun += 33;
			if (r_ptr->flags3 & RF3_NO_SLEEP) resist_stun += 33;
			if (r_ptr->flags2 & RF2_POWERFUL) resist_stun += 33;
			if ((r_ptr->flags3 & RF3_UNDEAD) || (r_ptr->flags3 & RF3_NONLIVING)) resist_stun += 66;

			if(method[num] == MELEE_MODE_SHIELD)  max_times = ref_skill_exp(SKILL_SHIELD) / 2000 + 1;
			else max_times = ref_skill_exp(SKILL_MARTIALARTS) / 2000 + 1;

			/*:::wUGtFNg琔I肵ԍxȂ̂*/
			for (times = 0; times < max_times; times++)
			{
				do
				{
					int mode_pick[20];
					int mode_cnt=0;
					int i;
					for(i = 0;(ma_blows_new[i].method != 0 && mode_cnt < 20);i++)
					{
						if(ma_blows_new[i].method == method[num])
						{
							mode_pick[mode_cnt++] = i;
						}
					}
					if(!mode_cnt)
					{
						msg_format("ERROR:ǉiɂĎw肳ꂽ(%d)̑fUo^ĂȂ",method[num]);
						return;
					}		
					ma_ptr = &ma_blows_new[ mode_pick[randint0(mode_cnt)]];
					min_level = ma_ptr->min_level;
				}
				while ((min_level > p_ptr->lev) || (randint1(p_ptr->lev) < ma_ptr->chance));

				if ((ma_ptr->min_level >= old_ptr->min_level) && !p_ptr->stun && !p_ptr->confused)	old_ptr = ma_ptr;
				else ma_ptr = old_ptr;
			}
			min_level = ma_ptr->min_level;
			weight = ma_ptr->weight;
			//V[hobṼ_[WdʂFX׍H@ɏĂ鎞̌vZsRɂȂ邪ʓ|Ȃ̂Ŗ
			if(method[num] == MELEE_MODE_SHIELD && inventory[INVEN_RARM].tval == TV_SHIELD)
			{
				bonus_d += (inventory[INVEN_RARM].ac + inventory[INVEN_RARM].to_a)/2;
				weight =  inventory[INVEN_RARM].weight / 10;
			}
			else if(method[num] == MELEE_MODE_SHIELD && inventory[INVEN_LARM].tval == TV_SHIELD)
			{
				bonus_d += (inventory[INVEN_LARM].ac + inventory[INVEN_LARM].to_a)/2;
				weight =  inventory[INVEN_LARM].weight / 10;
			}

			k = damroll(ma_ptr->dd , ma_ptr->ds );

			switch(ma_ptr->effect)
			{
			case MELEE_STUN:
				stun_effect = 3 + randint0(3);
				break;
			case MELEE_STUN2:
				stun_effect = 5 + randint0(5);
				break;
			case MELEE_STUN3:
				stun_effect = 10 + randint0(10);
				break;
			//얲iȂ
			case MELEE_SLAY_EVIL:
				if(r_ptr->flags3 & (RF3_UNDEAD | RF3_DEMON | RF3_KWAI))
				{
					if(mult < 250) mult = 250;
					stun_effect = 5 + randint0(5);
				}
				break;

			case MELEE_VAMP:
				if (monster_living(r_ptr))
				{
					can_drain = TRUE;
					can_feed = TRUE;
				}
				break;
			case MELEE_ELEC:
				if(!(r_ptr->flagsr & (RFR_RES_ALL | RFR_IM_ELEC)))
				{
					if(mult<200) mult=200;
					stun_effect = 10 + randint0(5);
				}
				break;

			case MELEE_MELT:
				if(!(r_ptr->flagsr & (RFR_RES_ALL | RFR_IM_ACID)))
					if(mult<200) mult=200;
				if (monster_living(r_ptr))
				{
					can_drain = TRUE;
					can_feed = TRUE;
				}
				break;
			//͂ȉΉU
			case MELEE_ATAGO:
				if(r_ptr->flagsr & RFR_RES_ALL) k=0;
				else if(!(r_ptr->flagsr & RFR_IM_FIRE))
				{
					if(r_ptr->flagsr & RFR_HURT_FIRE && mult<500) mult = 500;
					else if(mult<300) mult=300;
				}
				break;
			//ΉU
			case MELEE_FIRE:
				if(r_ptr->flagsr & RFR_RES_ALL) k=0;
				else if(!(r_ptr->flagsr & RFR_IM_FIRE))
				{
					if(r_ptr->flagsr & RFR_HURT_FIRE && mult<300) mult = 300;
					else if(mult<200) mult=200;
				}
				break;
			//CAXU
			case MELEE_COLD:
				if(r_ptr->flagsr & RFR_RES_ALL) k=0;
				else if(!(r_ptr->flagsr & RFR_IM_COLD))
				{
					if(r_ptr->flagsr & RFR_HURT_COLD && mult<300) mult = 300;
					else if(mult<200) mult=200;
				}
				break;
			case MELEE_SLOW:
				special_effect = MA_SLOW;
				break;
			case MELEE_POIS: //őϐ̂ȂGɑ_[W
				if(r_ptr->flagsr & RFR_RES_ALL) k=0;
				else if(!(r_ptr->flagsr & RFR_IM_POIS))
				{
					if(monster_living(r_ptr)) mult = MAX(300,mult);
					else mult = MAX(200,mult);
				}
				break;
			case MELEE_SINK: //ѐvU
					if(monster_living(r_ptr) && !((r_ptr->flags1 & RF1_UNIQUE) || (r_ptr->flags7 & RF7_UNIQUE2) || (r_ptr->flags1 & RF1_QUESTOR)))
						sinker = TRUE;
					//breakȂ
			case MELEE_WATER:
				if(	(r_ptr->flags7 & RF7_AQUATIC)
					|| (r_ptr->flagsr & RFR_RES_WATE)) mult = 50;
				else
				{
					if(!(r_ptr->flags3 & RF3_NO_STUN)) stun_effect = 3 + randint0(3);
					if(r_ptr->flagsr & RFR_HURT_WATER) mult = 200;
				}
					break;
			case MELEE_NUE: //t^
				if(r_ptr->flags3 & RF3_NO_CONF)
				{
					if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flags3 |= RF3_NO_CONF;
				}
				else if(randint0(100) > r_ptr->level)
				{
					msg_format("%^s͍悤B", m_name);
					(void)set_monster_confused(c_ptr->m_idx, MON_CONFUSED(m_ptr) + 10 + randint0(p_ptr->lev) / 5);
				}
				break;

			//v1.1.20@ӂ̔LԍU͏dʂLԂ̒g̏dʂɂȂ
			case MELEE_NEKOGURUMA:
				{
					int inven2_num = calc_inven2_num();
					int nekoguruma_weight = 0;
				//	int i;

					for (i = 0; i < inven2_num; i++)
					{
						object_type *tmp_o_ptr = &inven_add[i];
						if(!tmp_o_ptr->k_idx) continue;

						nekoguruma_weight += tmp_o_ptr->weight * tmp_o_ptr->number;
					}

					// -hack- dʒlύX@Ƃplev|Ԃ񌸂炵Ƃ
					weight = nekoguruma_weight / p_ptr->lev; 
					if(weight < 1) weight = 1;
					if(weight > 40) weight = 40;
					if(cheat_xtra) msg_format("weight:%d",weight);
					if(nekoguruma_weight > 200)
					{
						stun_effect = nekoguruma_weight / 100 + randint1(nekoguruma_weight / 100);
					}
				}

			}
			k = k * mult / 100;//i[XC
			/*:::Uɂ郁bZ[W*/
			msg_format(ma_ptr->desc, m_name);
			k = critical_norm(p_ptr->lev * weight, min_level, k, bonus_h, 0);
			k += bonus_d;
			drain_result = k;
			if (stun_effect && k < m_ptr->hp)
			{
				if (p_ptr->lev > randint1(r_ptr->level + resist_stun + 10))
				{
					if (set_monster_stunned(c_ptr->m_idx, stun_effect + MON_STUNNED(m_ptr)))
					{
#ifdef JP
						msg_format("%^s̓ttɂȂB", m_name);
#else
						msg_format("%^s is stunned.", m_name);
#endif
					}
					else
					{
#ifdef JP
						msg_format("%^s͂ɃttɂȂB", m_name);
#else
						msg_format("%^s is more stunned.", m_name);
#endif
					}
				}
			}

			/* No negative damage */
			if (k < 0) k = 0;

			/* Modify the damage */
			/*:::Ƃ͂ꃁ^̏*/
			k = mon_damage_mod(m_ptr, k, (bool)(( p_ptr->pseikaku == SEIKAKU_BERSERK) && one_in_(2)));


			//ѓU@j[NAAϐ̂Ƃ̃tO͗Ȃ
			if(sinker)
			{
				int resist = 100 + r_ptr->level * 6;
				if(r_ptr->flags2 & RF2_POWERFUL) resist = resist * 3 / 2;
				if(r_ptr->flags2 & RF2_GIGANTIC) resist *= 2;
				if(r_ptr->flags7 & RF7_CAN_FLY) resist *= 2;

				if(randint1(resist) < p_ptr->lev)
				{
						k = m_ptr->hp + 1;
						msg_format("%sMꂳB", m_name);

				}
			}

			/* Complex message */
			if (p_ptr->wizard || cheat_xtra)
			{
#ifdef JP
				msg_format("%d/%d ̃_[W^B", k, m_ptr->hp);
#else
				msg_format("You do %d (out of %d) damage.", k, m_ptr->hp);
#endif
			}
			if (k <= 0)
			{
				can_drain = FALSE;
				can_feed = FALSE;
			}

			if (drain_result > m_ptr->hp)
				drain_result = m_ptr->hp;
			/* Damage, check for fear and death */
			if (mon_take_hit(c_ptr->m_idx, k, fear, NULL))
			{
				*mdeath = TRUE;
				break;
			}

			/*:::z*/
			if (can_drain && (drain_result > 0))
			{

					if (drain_result > 5) /* Did we really hurt it? */
					{
						///mod140412 GɎ~߂hHP啝ɉ񕜂邱ƂɂĂ݂
						if(*mdeath) drain_heal = drain_result;
						else drain_heal = damroll(2, drain_result / 6);

						if (cheat_xtra)
							msg_format("Draining left: %d", drain_left);

						if (drain_left)
						{
							if (drain_heal < drain_left)
							{
								drain_left -= drain_heal;
							}
							else
							{
								drain_heal = drain_left;
								drain_left = 0;
							}

							if (drain_msg)
							{
								msg_format("%s琶͂zI", m_name);
								drain_msg = FALSE;
							}

							/*:::ˑRψقƋz̉񕜗ʂ炵*/
							drain_heal = (drain_heal * mutant_regenerate_mod) / 100;

							hp_player(drain_heal);
							/* We get to keep some of it! */
						}
					}
				m_ptr->maxhp -= (k+7)/8;
				if (m_ptr->hp > m_ptr->maxhp) m_ptr->hp = m_ptr->maxhp;
				if (m_ptr->maxhp < 1) m_ptr->maxhp = 1;
				weak = TRUE;
			}

			if (can_feed && (drain_result > 0))
			{
				if(p_ptr->food < PY_FOOD_MAX) set_food(MIN(PY_FOOD_MAX-1,p_ptr->food + drain_result*5));
			}

			can_drain = FALSE;
			can_feed = FALSE;
			drain_result = 0;

			if(*mdeath) break;






			/* Anger the monster */
			if (k > 0) anger_monster(m_ptr);

			touch_zap_player(m_ptr);

			/* Confusion attack */
			/*:::̎菈*/
			///sys ʂ̍̎菈Ƃ̕ӂɏ悹΂
#if 0
			if ((p_ptr->special_attack & ATTACK_CONFUSE) || (chaos_effect == 3) || (mode == HISSATSU_CONF) || hex_spelling(HEX_CONFUSION))
			{
				/* Cancel glowing hands */
				if (p_ptr->special_attack & ATTACK_CONFUSE)
				{
					p_ptr->special_attack &= ~(ATTACK_CONFUSE);
#ifdef JP
					msg_print("̋PȂȂB");
#else
					msg_print("Your hands stop glowing.");
#endif
					p_ptr->redraw |= (PR_STATUS);

				}

				/* Confuse the monster */
				if (r_ptr->flags3 & RF3_NO_CONF)
				{
					if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flags3 |= RF3_NO_CONF;

#ifdef JP
					msg_format("%^sɂ͌ʂȂB", m_name);
#else
					msg_format("%^s is unaffected.", m_name);
#endif

				}
				else if (randint0(100) < r_ptr->level)
				{
#ifdef JP
					msg_format("%^sɂ͌ʂȂB", m_name);
#else
					msg_format("%^s is unaffected.", m_name);
#endif

				}
				else
				{
#ifdef JP
					msg_format("%^s͍悤B", m_name);
#else
					msg_format("%^s appears confused.", m_name);
#endif

					(void)set_monster_confused(c_ptr->m_idx, MON_CONFUSED(m_ptr) + 10 + randint0(p_ptr->lev) / 5);
				}
			}
#endif

		}

		/* Player misses */
		else
		{
			sound(SOUND_MISS);

				/* Message */
#ifdef JP
				msg_format("~XI %sɂ킳ꂽB", m_name);
#else
				msg_format("You miss %s.", m_name);
#endif
		}
	}


	if (weak && !(*mdeath))
	{
		msg_format("%s͎キȂ悤B", m_name);
	}

}


/*:::AXp@l`ɂU[`*/
static void py_attack_aux_alice(int y, int x, bool *fear, bool *mdeath, int mode)
{
	int		num = 0, k, chance, bonus;

	cave_type       *c_ptr = &cave[y][x];
	monster_type    *m_ptr = &m_list[c_ptr->m_idx];
	monster_race    *r_ptr = &r_info[m_ptr->r_idx];

	object_type     *o_ptr;

	char            m_name[80];

	bool            success_hit = FALSE;
	bool            vorpal_cut = FALSE;
	bool            fuiuchi = FALSE;
	bool            weak = FALSE;
	bool            drain_msg = TRUE;
	int             drain_result = 0, drain_heal = 0;
	bool            can_drain = FALSE;
	int             drain_left = MAX_VAMPIRIC_DRAIN;
	u32b flgs[TR_FLAG_SIZE]; //؂ꖡ
	bool            is_human = (r_ptr->d_char == 'p');

	int total_blow_num = 0;
	int attack_doll_array[100];
	int i;

	if(p_ptr->pclass != CLASS_ALICE)
		{msg_format("ERROR:NXAXȊO̎alice_attack_aux()Ă΂ꂽ"); return;}

	/*:::l`̍U񐔂߁AԂ_ɐݒ肷*/
	for(i=0;i<100;i++) attack_doll_array[i]=0;
	for(i=0;i<INVEN_DOLL_NUM_MAX;i++)//Sl`[v
	{
		int j;
		int tmp_blow_num = calc_doll_blow_num(i);//l`̂̍U񐔌vZ
		for(j=0;j<tmp_blow_num;j++)
		{
			if(!i) 
			{
				attack_doll_array[total_blow_num] = i;//ԏ̏Cl`͕ʂɊi[
			}
			else//ȊO̎mœւ
			{
				if(one_in_(total_blow_num+1)) attack_doll_array[total_blow_num] = i;
				else
				{
					int move = randint0(total_blow_num);	
					attack_doll_array[total_blow_num] = attack_doll_array[move];
					attack_doll_array[move] = i;
				}
			}
			total_blow_num++;
			if(total_blow_num == 100) 
			{msg_format("ERROR:alice_attack_aux()̍U񐔂100ȏ"); return; }
		}
	}
	if(!total_blow_num) 
	{msg_format("ERROR:alice_attack_aux()ōU񐔂0"); return;}


//̓ẐƂ͖ɂH
	if(p_ptr->tim_unite_darkness)
	{
		if(!(cave[py][px].info & CAVE_GLOW)  && m_ptr->ml && (MON_CSLEEP(m_ptr) || randint1(p_ptr->lev * 3 + (p_ptr->skill_stl + 10) * 4) > r_ptr->level * 2)) fuiuchi = TRUE;
	}

	(void)set_monster_csleep(c_ptr->m_idx, 0);
	monster_desc(m_name, m_ptr, 0);

	/* Attack once for each legal blow */
	/*:::U񐔂Ƃɔ*/
	while ((num < total_blow_num) && !p_ptr->is_dead)
	{
		bool dokubari = FALSE;
		int doll_num = attack_doll_array[num];

		o_ptr =  &inven_add[doll_num];
		if(!object_is_melee_weapon(o_ptr))
		{msg_format("ERROR:Ȃl`Ă΂ꂽ(%d)",doll_num); return;}

		//nx1/10xɂĂ
		if(one_in_(10)) gain_skill_exp(o_ptr->tval,m_ptr);

		//calc_bonuses()ŌvZĂȂnxŔf
		bonus = p_ptr->to_h[0] + o_ptr->to_h + (ref_skill_exp(o_ptr->tval) - WEAPON_EXP_BEGINNER) / 200;
		chance = (p_ptr->skill_thn + (bonus * BTH_PLUS_ADJ));

		///sys item Őj
		///mod131223 tval
		if ((o_ptr->tval == TV_KNIFE) && (o_ptr->sval == SV_WEAPON_DOKUBARI))
		{
			dokubari = TRUE;
			success_hit = one_in_(3);
		}

		else if (( fuiuchi && !(r_ptr->flagsr & RFR_RES_ALL))) success_hit = TRUE;
		/*:::ʏ̖*/
		else 
		{
			success_hit = test_hit_norm(chance, r_ptr->ac, m_ptr->ml);
			//I[ɂ閽
			if(r_ptr->flags2 & RF2_AURA_FIRE && one_in_(20)) success_hit = FALSE;
			if(r_ptr->flags2 & RF2_AURA_COLD && one_in_(20)) success_hit = FALSE;
			if(r_ptr->flags2 & RF2_AURA_ELEC && one_in_(20)) success_hit = FALSE;
		}

		/* Test for hit */
		if (success_hit)
		{
			int vorpal_chance;

			/* Sound */
			sound(SOUND_HIT);

			if (fuiuchi)
				msg_format("%s͕sӂ˂%sɋȈꌂ킹I",alice_doll_name[doll_num], m_name);
			else if(ex_attack_msg)
				msg_format("%s%s%s",alice_doll_name[doll_num], m_name, msg_py_atk(o_ptr,mode));
			else 
				msg_format("%s%s", m_name, msg_py_atk(o_ptr,mode));

			k = 1;

			object_flags(o_ptr, flgs);
			//v1.1.46 AXEXTRA[hœu΂g̏ǉ
			if (have_flag(flgs, TR_EX_VORPAL)) 
				vorpal_chance = 2;
			else if ((p_ptr->special_attack & ATTACK_VORPAL) && object_has_a_blade(o_ptr) && have_flag(flgs, TR_VORPAL))
				vorpal_chance = 2;
			else if ((p_ptr->special_attack & ATTACK_VORPAL) && object_has_a_blade(o_ptr) || have_flag(flgs, TR_VORPAL))
				vorpal_chance = 4;
			else
				vorpal_chance = 0;

			/* Vampiric drain */
			/*:::z*/
			//gp

			if ((p_ptr->special_attack & (ATTACK_DARK)) && p_ptr->lev > 44 || o_ptr->name1 == ART_MURAMASA)
			{
				if (monster_living(r_ptr))
					can_drain = TRUE;
				else
					can_drain = FALSE;
			}

			if (vorpal_chance && randint1(vorpal_chance*3/2) == 1 )
				vorpal_cut = TRUE;
			else 
				vorpal_cut = FALSE;

			/*:::_CX(ǉ_CXj*/
			k = damroll(o_ptr->dd , o_ptr->ds );
			/*:::_CXɃXCȂǓKp*/
			k = tot_dam_aux(o_ptr, k, m_ptr, mode, FALSE);

			if (fuiuchi)
			{
				k = k*(5+(p_ptr->lev*2/25))/2;
			}
			/* nk͋NȂ*/

			/*:::NeBJ*/ 
			if (!dokubari)
			k = critical_norm(o_ptr->weight, o_ptr->to_h, k, p_ptr->to_h[0], mode);

			drain_result = k;
			/*:::H[pqbg*/
			if (vorpal_cut)
			{
				int mult = 2;
				if (o_ptr->name1 == ART_VORPAL_BLADE)
					msg_print("ڂɂ~܂ʃH[pu[hAB̑ƁI");
				else
					msg_format("n%ss؂􂢂I", m_name);
				while (one_in_(vorpal_chance))
				{
					mult++;
				}

				k *= mult;

				switch (mult)
				{
					case 2: //msg_format("%saI", m_name); break;
					case 3: msg_format("%sԂaI", m_name); break;
					case 4: //msg_format("%sb^aɂI", m_name); break;
					case 5: msg_format("%sőaɂI", m_name); break;
					case 6: //msg_format("%shgɂI", m_name); break;
					case 7: default:msg_format("%saĎaĎa܂I", m_name); break;
					//default: msg_format("%sא؂ɂI", m_name); break;
				}
				drain_result = drain_result * 3 / 2;
			}

			k += o_ptr->to_d;
			drain_result += o_ptr->to_d;
			k += p_ptr->to_d[0];
			drain_result += p_ptr->to_d[0];

			/* No negative damage */
			if (k < 0) k = 0;

			/* Modify the damage */
			/*:::Ƃ͂ꃁ^̏*/
			k = mon_damage_mod(m_ptr, k, FALSE);

			///item Őj
			if (dokubari)
			{
				if ((randint1(randint1(r_ptr->level/7)+5) == 1) && !(r_ptr->flags1 & RF1_UNIQUE) && !(r_ptr->flags7 & RF7_UNIQUE2))
				{
					k = m_ptr->hp + 1;
					msg_format("%s̋}˂hI", m_name);
				}
				else k = 1;
			}

			if( k > 9999) k = 9999;
			/* Complex message */
			if (p_ptr->wizard || cheat_xtra)
			{
				msg_format("%d/%d ̃_[W^B", k, m_ptr->hp);
			}

			if (k <= 0)
			{
				can_drain = FALSE;
			}

			if (drain_result > m_ptr->hp)
				drain_result = m_ptr->hp;

			/* Damage, check for fear and death */
			if (mon_take_hit(c_ptr->m_idx, k, fear, NULL))
			{
				*mdeath = TRUE;

				//G|Ƃ܂l`̍U񐔂cĂ΂̕s͂̏
				if (energy_use && p_ptr->lev > 24)
				{
					energy_use = 25 + 75 * (num+1) / total_blow_num;
				}
			}

			/*:::z X^[|ɂ悤ɂ*/
			if (can_drain && (drain_result > 0))
			{
				///item ̓ꋭ
				if (o_ptr->name1 == ART_MURAMASA)
				{
					if (is_human)
					{
						int to_h = o_ptr->to_h;
						int to_d = o_ptr->to_d;
						int i, flag;

						flag = 1;
						for (i = 0; i < to_h + 3; i++) if (one_in_(4)) flag = 0;
						if (flag) to_h++;

						flag = 1;
						for (i = 0; i < to_d + 3; i++) if (one_in_(4)) flag = 0;
						if (flag) to_d++;

						if (o_ptr->to_h != to_h || o_ptr->to_d != to_d)
						{
							msg_print("d͌zċȂI");

							o_ptr->to_h = to_h;
							o_ptr->to_d = to_d;
						}
					}
				}
				else
				{
					if (drain_result > 5) /* Did we really hurt it? */
					{
						///mod140412 GɎ~߂hHP啝ɉ񕜂邱ƂɂĂ݂
						if(*mdeath) drain_heal = drain_result;
						else drain_heal = damroll(2, drain_result / 6);

						if (cheat_xtra)
						{
							msg_format("Draining left: %d", drain_left);
						}

						if (drain_left)
						{
							if (drain_heal < drain_left)
							{
								drain_left -= drain_heal;
							}
							else
							{
								drain_heal = drain_left;
								drain_left = 0;
							}
							if (drain_msg)
							{
								msg_format("%s琶͂zI", m_name);
								drain_msg = FALSE;
							}

							/*:::ˑRψقƋz̉񕜗ʂ炵*/
							drain_heal = (drain_heal * mutant_regenerate_mod) / 100;

							hp_player(drain_heal);
						}
					}
				}
				m_ptr->maxhp -= (k+7)/8;
				if (m_ptr->hp > m_ptr->maxhp) m_ptr->hp = m_ptr->maxhp;
				if (m_ptr->maxhp < 1) m_ptr->maxhp = 1;
				weak = TRUE;
			}

			can_drain = FALSE;
			drain_result = 0;

			if(*mdeath) break;

			/* Anger the monster */
			///mod140412 ̓s͋z̑OɎĂ
			if (k > 0) anger_monster(m_ptr);
			//AX̐l`U̓I[_[W󂯂Ȃ
			//touch_zap_player(m_ptr);


			/* Confusion attack */
			/*:::̎菈*/
			///sys ʂ̍̎菈Ƃ̕ӂɏ悹΂
			if (p_ptr->special_attack & ATTACK_CONFUSE )
			{
				p_ptr->special_attack &= ~(ATTACK_CONFUSE);
				msg_print("̋PȂȂB");
				p_ptr->redraw |= (PR_STATUS);

				if (r_ptr->flags3 & RF3_NO_CONF)
				{
					if (is_original_ap_and_seen(m_ptr)) r_ptr->r_flags3 |= RF3_NO_CONF;
					msg_format("%^sɂ͌ʂȂB", m_name);

				}
				else if (randint0(100) < r_ptr->level)
				{
					msg_format("%^sɂ͌ʂȂB", m_name);
				}
				else
				{
					msg_format("%^s͍悤B", m_name);
					(void)set_monster_confused(c_ptr->m_idx, MON_CONFUSED(m_ptr) + 10 + randint0(p_ptr->lev) / 5);
				}
			}

		}

		/* Player misses */
		else
		{
			fuiuchi = FALSE; /* Clumsy! */
			{
				/* Sound */
				sound(SOUND_MISS);
				if(ex_attack_msg)
					msg_format("%s̍U%sɂ킳ꂽB",alice_doll_name[doll_num], m_name);
				else
					msg_format("~XI %sɂ킳ꂽB", m_name);
			}

		}
		fuiuchi = FALSE;

		num++;
	}

	if (weak && !(*mdeath))
	{
		msg_format("%s͎キȂ悤B", m_name);
	}

}




/*:::wObh֍UBx,yɂ̓X^[邱ƁB*/
bool py_attack(int y, int x, int mode)
{
	bool            fear = FALSE;
	bool            mdeath = FALSE;
	bool            stormbringer = FALSE;

	//AXl`UptO@@AōUs
	bool			alice_doll_attack = (p_ptr->pclass == CLASS_ALICE && !p_ptr->do_martialarts);

	cave_type       *c_ptr = &cave[y][x];
	monster_type    *m_ptr = &m_list[c_ptr->m_idx];
	monster_race    *r_ptr = &r_info[m_ptr->r_idx];
	char            m_name[80];

	if(!c_ptr->m_idx)
	{
		msg_print("ERROR:py_attack()ŎwObhɃX^[Ȃ");
		return FALSE;
	}

	if(m_ptr->r_idx < 1 || m_ptr->r_idx >= max_r_idx)
	{
		msg_format("ERROR:py_attack()ŎwObh̃X^[r_idx(%d)",m_ptr->r_idx);
		delete_monster_idx(c_ptr->m_idx);
		return FALSE;
	}

	/* Disturb the player */
	disturb(0, 1);

	//v1.1.14 ˕P̋_lZbg鏈Bʏprocess_player̃[vɍsbZ[WɈâōŏɂƂ
	if(p_ptr->pclass == CLASS_YORIHIME && mode != HISSATSU_GION && (p_ptr->kamioroshi & KAMIOROSHI_GION)) 
		reset_concentration(TRUE);

	if(SAKUYA_WORLD)
	{
		msg_print("͍UłȂB");
		return FALSE;
	}

	if(p_ptr->pclass == CLASS_MEIRIN && p_ptr->do_martialarts)
	{
		energy_use = p_ptr->magic_num1[0];
		if(cheat_xtra) msg_format("Energy_use:%d",energy_use);
	}
	else if(p_ptr->pclass == CLASS_RAIKO && music_singing(MUSIC_NEW_RAIKO_PRISTINE))
	{
		energy_use = 75 - p_ptr->concent * 5;
		if(energy_use < 25) energy_use = 25;

		if(cheat_xtra) msg_format("Energy_use:%d",energy_use);
	}
	else if(mode == HISSATSU_GION || mode == HISSATSU_DOUBLESCORE)
	{
		; //JE^[n̍U͍sȂ
	}
	else
		energy_use = 100;

	if(IS_METAMORPHOSIS && r_info[MON_EXTRA_FIELD].flags1 & RF1_NEVER_MOVE)
	{
		msg_print("̐ĝ͒ڍUɌȂ悤B");
		return FALSE;
	}

	/*:::肪ȊOōǂĂUpψقĂȂꍇAUłȂ*/
	///sys 肪ӂĂƍUłȂ@ǉi1`2񂭂炢oĂȂ
	if (!p_ptr->migite && !p_ptr->hidarite &&
	    !(p_ptr->muta2 & (MUT2_HORNS | MUT2_BIGHORN | MUT2_HARDHEAD | MUT2_BIGTAIL)))
	{
#ifdef JP
		msg_format("%sUłȂB", (empty_hands(FALSE) == EMPTY_HAND_NONE) ? "肪ӂ" : "");
#else
		msg_print("You cannot do attacking.");
#endif
		return FALSE;
	}

	//\ỏtf(_uXRAt̊iU)
	if((p_ptr->pclass == CLASS_BENBEN || p_ptr->pclass == CLASS_YATSUHASHI) && music_singing_any())
	{
		if(music_singing(MUSIC_NEW_TSUKUMO_DOUBLESCORE) && p_ptr->do_martialarts) mode = HISSATSU_DOUBLESCORE;
		else stop_tsukumo_music();
	}

	/* Extract monster name (or "it") */
	monster_desc(m_name, m_ptr, 0);
	/*:::X^[ĂꍇAvoHPo[̏XVtO𗧂Ă*/
	if (m_ptr->ml)
	{
		/* Auto-Recall if possible and visible */
		if (!p_ptr->image) monster_race_track(m_ptr->ap_r_idx);

		/* Track a new monster */
		health_track(c_ptr->m_idx);
	}

	///del131223 aS
#if 0
	if ((r_ptr->flags1 & RF1_FEMALE) &&
	    !(p_ptr->stun || p_ptr->confused || p_ptr->image || !m_ptr->ml))
	{
		if ((inventory[INVEN_RARM].name1 == ART_ZANTETSU) || (inventory[INVEN_LARM].name1 == ART_ZANTETSU))
		{
#ifdef JP
			msg_print("َҁAȂ͎aʁI");
#else
			msg_print("I can not attack women!");
#endif
			return FALSE;
		}
	}
#endif
	if ((d_info[dungeon_type].flags1 & DF1_NO_MELEE) && !alice_doll_attack)
	{
#ifdef JP
		msg_print("ȂU邱ƂłȂB");
#else
		msg_print("Something prevent you from attacking.");
#endif
		return FALSE;
	}
	if(alice_doll_attack)
	{
		if (d_info[dungeon_type].flags1 & DF1_NO_MAGIC || p_ptr->anti_magic)
		{
			msg_print("l`ȂI");
			return FALSE;
		}
		if(p_ptr->confused)
		{
			msg_print("ĂĐl`𑀂ȂI");
			return FALSE;
		}

	}

	///sys class item th[A^bN@Xgu
	/* Stop if friendly */
	if (!is_hostile(m_ptr) && !flag_friendly_attack && 
	    !(p_ptr->stun || p_ptr->confused || p_ptr->image ||
	    p_ptr->shero || !m_ptr->ml))
	{
		if (!check_invalidate_inventory(INVEN_RARM) && inventory[INVEN_RARM].name1 == ART_STORMBRINGER) stormbringer = TRUE;
		if (!check_invalidate_inventory(INVEN_LARM) && inventory[INVEN_LARM].name1 == ART_STORMBRINGER) stormbringer = TRUE;
		if (stormbringer)
		{
#ifdef JP
			msg_format("n͋~%sUI", m_name);
#else
			msg_format("Your black blade greedily attacks %s!", m_name);
#endif
			///del131223 virtue
			//chg_virtue(V_INDIVIDUALISM, 1);
			//chg_virtue(V_HONOUR, -1);
			//chg_virtue(V_JUSTICE, -1);
			//chg_virtue(V_COMPASSION, -1);
		}
		else if ( p_ptr->pseikaku != SEIKAKU_BERSERK && mode != HISSATSU_EXCLAW && mode != HISSATSU_YOSHIKA )
		{
#ifdef JP
			if (get_check("{ɍU܂H"))
#else
			if (get_check("Really hit it? "))
#endif
			{
				///del131223 virtue
				//chg_virtue(V_INDIVIDUALISM, 1);
				//chg_virtue(V_HONOUR, -1);
				//chg_virtue(V_JUSTICE, -1);
				//chg_virtue(V_COMPASSION, -1);
			}
			else
			{
#ifdef JP
				msg_format("%sÛ~߂B", m_name);
#else
				msg_format("You stop to avoid hitting %s.", m_name);
#endif
				return FALSE;
			}
		}
	}


	/* Handle player fear */
	if (p_ptr->afraid && mode != HISSATSU_EXCLAW && mode != HISSATSU_YOSHIKA && mode != HISSATSU_GION && !alice_doll_attack && mode != HISSATSU_DOUBLESCORE
		|| p_ptr->pclass == CLASS_KOMACHI && m_ptr->r_idx == MON_EIKI)
	{
		/* Message */
		if (m_ptr->ml)
#ifdef JP
			msg_format("%sUłȂI", m_name);
#else
			msg_format("You are too afraid to attack %s!", m_name);
#endif

		else
#ifdef JP
			msg_format ("ɂ͉̂I");
#else
			msg_format ("There is something scary in your way!");
#endif

		/* Disturb the monster */
		(void)set_monster_csleep(c_ptr->m_idx, 0);

		/* Done */
		return FALSE;
	}

	//hbyQK[ꏈ
	if(r_ptr->flags7 & RF7_DOPPELGANGER)
	{
		msg_print("Ȃ͎̃hbyQK[ɐGĂ܂I");
		take_hit(DAMAGE_LOSELIFE,p_ptr->chp,"hbyQK[Ƃ̐ڐG",-1);
		set_stun(100+randint0(3));
		delete_monster_idx(c_ptr->m_idx);
		return TRUE;
	}


	/*:::G̐Q݂PƂ̓*/
	///sysdel virtue
#if 0
	if (MON_CSLEEP(m_ptr)) /* It is not honorable etc to attack helpless victims */
	{
		if (!(r_ptr->flags3 & RF3_EVIL) || one_in_(5)) chg_virtue(V_COMPASSION, -1);
		if (!(r_ptr->flags3 & RF3_EVIL) || one_in_(5)) chg_virtue(V_HONOUR, -1);
	}
#endif
	/*:::񓁗Z\ol𓾂*/
	///mod151205 O
	if (p_ptr->migite && p_ptr->hidarite && p_ptr->pclass != CLASS_3_FAIRIES)
	{
		///mod131226 skill Z\ƕZ\̓
		gain_skill_exp(SKILL_2WEAPONS,m_ptr);
		/*
		if ((p_ptr->skill_exp[GINOU_NITOURYU] < s_info[p_ptr->pclass].s_max[GINOU_NITOURYU]) && ((p_ptr->skill_exp[GINOU_NITOURYU] - 1000) / 200 < r_ptr->level))
		{
			if (p_ptr->skill_exp[GINOU_NITOURYU] < WEAPON_EXP_BEGINNER)
				p_ptr->skill_exp[GINOU_NITOURYU] += 80;
			else if(p_ptr->skill_exp[GINOU_NITOURYU] < WEAPON_EXP_SKILLED)
				p_ptr->skill_exp[GINOU_NITOURYU] += 4;
			else if(p_ptr->skill_exp[GINOU_NITOURYU] < WEAPON_EXP_EXPERT)
				p_ptr->skill_exp[GINOU_NITOURYU] += 1;
			else if(p_ptr->skill_exp[GINOU_NITOURYU] < WEAPON_EXP_MASTER)
				if (one_in_(3)) p_ptr->skill_exp[GINOU_NITOURYU] += 1;
			p_ptr->update |= (PU_BONUS);
		}
		*/
	}
	/*:::nZ\ol𓾂*/
	///sys nol
	/* Gain riding experience */
	if (p_ptr->riding && !CLASS_RIDING_BACKDANCE)
	{
		///mod131226 skill Z\ƕZ\̓
		gain_skill_exp(SKILL_RIDING,m_ptr);
#if 0
		int cur = p_ptr->skill_exp[GINOU_RIDING];
		int max = s_info[p_ptr->pclass].s_max[GINOU_RIDING];

		if (cur < max)
		{
			int ridinglevel = r_info[m_list[p_ptr->riding].r_idx].level;
			int targetlevel = r_ptr->level;
			int inc = 0;

			if ((cur / 200 - 5) < targetlevel)
				inc += 1;

			/* Extra experience */
			if ((cur / 100) < ridinglevel)
			{
				if ((cur / 100 + 15) < ridinglevel)
					inc += 1 + (ridinglevel - (cur / 100 + 15));
				else
					inc += 1;
			}

			p_ptr->skill_exp[GINOU_RIDING] = MIN(max, cur + inc);

			p_ptr->update |= (PU_BONUS);
		}
#endif
	}

	riding_t_m_idx = c_ptr->m_idx;

	/*:::EAAψٕʂ̏ɍU@^[Qbg񂾂璆~*/
	/*:::îƂmigitêTRUEɂȂĂ͂*/
	/*:::|gύXɂANX{EeĂƂhidariteTRUEɂȂĊi邱ƂɂȂB*/
	///mod150808 AXꏈǉ
	if(IS_METAMORPHOSIS)
	{
		//X^[ϐgאڍU
		monplayer_attack_monst(c_ptr->m_idx);
	}
	else if(p_ptr->pclass == CLASS_ALICE && !p_ptr->do_martialarts)
	{
		//AXl`אڍU
		py_attack_aux_alice(y, x, &fear, &mdeath, mode);
	}
	else if(mode == HISSATSU_SOULSCULPTURE && p_ptr->pclass == CLASS_SAKUYA)
	{

		//\EXJv`A
		if (p_ptr->migite && inventory[INVEN_RARM].tval == TV_KNIFE)	
			py_attack_aux(y, x, &fear, &mdeath, 0, mode);
		if (p_ptr->hidarite && !mdeath && inventory[INVEN_RARM].tval == TV_KNIFE)
			py_attack_aux(y, x, &fear, &mdeath, 1, mode);
	}
	else
	{
		if (p_ptr->migite)	
			py_attack_aux(y, x, &fear, &mdeath, 0, mode);
		//ǉ@jۓU͉E蕪̂
		if (p_ptr->hidarite && !mdeath && mode != HISSATSU_SHINMYOU)
			py_attack_aux(y, x, &fear, &mdeath, 1, mode);

	}

	///mod140323 ǉi U̎͏oȂ
	//ɏǉdisplay_player_various()́u+v\ɂǉ
	if(!mdeath && !(IS_METAMORPHOSIS) && !mode && !(mimic_info[p_ptr->mimic_form].MIMIC_FLAGS & MIMIC_NO_EXATACK) 
		&& p_ptr->pclass != CLASS_3_FAIRIES ) 
		py_attack_aux2(y,x,&fear,&mdeath);

	/* Mutations which yield extra 'natural' attacks */
	///sys ψٕʍU@͒ǉi
#if 0
	if (!mdeath)
	{
		if ((p_ptr->muta2 & MUT2_HORNS) && !mdeath)
			natural_attack(c_ptr->m_idx, MUT2_HORNS, &fear, &mdeath);
		if ((p_ptr->muta2 & MUT2_BIGHORN) && !mdeath)
			natural_attack(c_ptr->m_idx, MUT2_BIGHORN, &fear, &mdeath);
		if ((p_ptr->muta2 & MUT2_HARDHEAD) && !mdeath)
			natural_attack(c_ptr->m_idx, MUT2_HARDHEAD, &fear, &mdeath);
		if ((p_ptr->muta2 & MUT2_TAIL) && !mdeath)
			natural_attack(c_ptr->m_idx, MUT2_TAIL, &fear, &mdeath);
		if ((p_ptr->muta2 & MUT2_BIGTAIL) && !mdeath)
			natural_attack(c_ptr->m_idx, MUT2_BIGTAIL, &fear, &mdeath);
	}
#endif




	/* Hack -- delay fear messages */
	if (fear && m_ptr->ml && !mdeath)
	{
		/* Sound */
		sound(SOUND_FLEE);

		/* Message */
#ifdef JP
		msg_format("%^s͋|ēoI", m_name);
#else
		msg_format("%^s flees in terror!", m_name);
#endif

	}

	if ((p_ptr->special_defense & KATA_IAI) && ((mode != HISSATSU_IAI) || mdeath))
	{
		set_action(ACTION_NONE);
	}

	return mdeath;
}

/*:::_͂Ap^[̏Ƃ̕s\@*/
bool pattern_seq(int c_y, int c_x, int n_y, int n_x)
{
	feature_type *cur_f_ptr = &f_info[cave[c_y][c_x].feat];
	feature_type *new_f_ptr = &f_info[cave[n_y][n_x].feat];
	bool is_pattern_tile_cur = have_flag(cur_f_ptr->flags, FF_PATTERN);
	bool is_pattern_tile_new = have_flag(new_f_ptr->flags, FF_PATTERN);
	int pattern_type_cur, pattern_type_new;

	if (!is_pattern_tile_cur && !is_pattern_tile_new) return TRUE;

	pattern_type_cur = is_pattern_tile_cur ? cur_f_ptr->subtype : NOT_PATTERN_TILE;
	pattern_type_new = is_pattern_tile_new ? new_f_ptr->subtype : NOT_PATTERN_TILE;

	if (pattern_type_new == PATTERN_TILE_START)
	{
		if (!is_pattern_tile_cur && !p_ptr->confused && !p_ptr->stun && !p_ptr->image)
		{
#ifdef JP
			if (get_check("p^[̏n߂ƁASĂȂ΂Ȃ܂BłH"))
#else
			if (get_check("If you start walking the Pattern, you must walk the whole way. Ok? "))
#endif
				return TRUE;
			else
				return FALSE;
		}
		else
			return TRUE;
	}
	else if ((pattern_type_new == PATTERN_TILE_OLD) ||
		 (pattern_type_new == PATTERN_TILE_END) ||
		 (pattern_type_new == PATTERN_TILE_WRECKED))
	{
		if (is_pattern_tile_cur)
		{
			return TRUE;
		}
		else
		{
#ifdef JP
			msg_print("p^[̏ɂ̓X^[gn_n߂ȂĂ͂Ȃ܂B");
#else
			msg_print("You must start walking the Pattern from the startpoint.");
#endif

			return FALSE;
		}
	}
	else if ((pattern_type_new == PATTERN_TILE_TELEPORT) ||
		 (pattern_type_cur == PATTERN_TILE_TELEPORT))
	{
		return TRUE;
	}
	else if (pattern_type_cur == PATTERN_TILE_START)
	{
		if (is_pattern_tile_new)
			return TRUE;
		else
		{
#ifdef JP
			msg_print("p^[̏͐ŕ˂΂Ȃ܂B");
#else
			msg_print("You must walk the Pattern in correct order.");
#endif

			return FALSE;
		}
	}
	else if ((pattern_type_cur == PATTERN_TILE_OLD) ||
		 (pattern_type_cur == PATTERN_TILE_END) ||
		 (pattern_type_cur == PATTERN_TILE_WRECKED))
	{
		if (!is_pattern_tile_new)
		{
#ifdef JP
			msg_print("p^[𓥂݊OĂ͂܂B");
#else
			msg_print("You may not step off from the Pattern.");
#endif

			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	else
	{
		if (!is_pattern_tile_cur)
		{
#ifdef JP
			msg_print("p^[̏ɂ̓X^[gn_n߂ȂĂ͂Ȃ܂B");
#else
			msg_print("You must start walking the Pattern from the startpoint.");
#endif

			return FALSE;
		}
		else
		{
			byte ok_move = PATTERN_TILE_START;
			switch (pattern_type_cur)
			{
				case PATTERN_TILE_1:
					ok_move = PATTERN_TILE_2;
					break;
				case PATTERN_TILE_2:
					ok_move = PATTERN_TILE_3;
					break;
				case PATTERN_TILE_3:
					ok_move = PATTERN_TILE_4;
					break;
				case PATTERN_TILE_4:
					ok_move = PATTERN_TILE_1;
					break;
				default:
					if (p_ptr->wizard)
#ifdef JP
						msg_format("ȃp^[sA%dB", pattern_type_cur);
#else
						msg_format("Funny Pattern walking, %d.", pattern_type_cur);
#endif

					return TRUE; /* Goof-up */
			}

			if ((pattern_type_new == ok_move) ||
			    (pattern_type_new == pattern_type_cur))
				return TRUE;
			else
			{
				if (!is_pattern_tile_new)
#ifdef JP
					msg_print("p^[𓥂݊OĂ͂܂B");
#else
					msg_print("You may not step off from the Pattern.");
#endif
				else
#ifdef JP
					msg_print("p^[̏͐ŕ˂΂Ȃ܂B");
#else
					msg_print("You must walk the Pattern in correct order.");
#endif

				return FALSE;
			}
		}
	}
}

/*:::n`ǂf*/
bool player_can_enter(s16b feature, u16b mode)
{
	feature_type *f_ptr = &f_info[feature];

	if (p_ptr->riding) return monster_can_cross_terrain(feature, &r_info[m_list[p_ptr->riding].r_idx], mode | CEM_RIDING);

	/* Pattern */
	if (have_flag(f_ptr->flags, FF_PATTERN))
	{
		if (!(mode & CEM_P_CAN_ENTER_PATTERN)) return FALSE;
	}

	/* "CAN" flags */
	if (have_flag(f_ptr->flags, FF_CAN_FLY) && p_ptr->levitation) return TRUE;
	if (have_flag(f_ptr->flags, FF_CAN_SWIM) && p_ptr->can_swim) return TRUE;
	if (have_flag(f_ptr->flags, FF_CAN_PASS) && p_ptr->pass_wall) return TRUE;

	if (!have_flag(f_ptr->flags, FF_WALL) && have_flag(f_ptr->flags, FF_CAN_PASS) && CHECK_FAIRY_TYPE == 41) return TRUE;

	if (!have_flag(f_ptr->flags, FF_MOVE)) return FALSE;

	return TRUE;
}


/*
 * Move the player
 */
/*:::̏ꏊύXBnx,ny:ړ mpe_mode:ړ[h MPE_????̌`defines.hɒ`*/
/*:::̊֐Ă΂ꂽ_nx,ny͈ړ\łƊmFĂ邱*/
/*:::Kړ莀񂾂肹̃ObhɋTRUEԂ*/
bool move_player_effect(int ny, int nx, u32b mpe_mode)
{
	cave_type *c_ptr = &cave[ny][nx];
	feature_type *f_ptr = &f_info[c_ptr->feat];

	//v1.1.14 ˕P̋_lZbg鏈Bʏprocess_player̃[vɍsbZ[WɈâōŏɂƂ
	if(p_ptr->pclass == CLASS_YORIHIME && (p_ptr->kamioroshi & KAMIOROSHI_GION) )
	{
		if(py != ny || px != nx) reset_concentration(TRUE);
		else reset_concent = FALSE;
	}


	if (!(mpe_mode & MPE_STAYING))
	{
		int oy = py;
		int ox = px;
		cave_type *oc_ptr = &cave[oy][ox];
		int om_idx = oc_ptr->m_idx; //ꏊ̃X^[(R撆X^[ ꏏɈړ)
		int nm_idx = c_ptr->m_idx; //s̃X^[(ꏊւ)

		/* Move the player */
		py = ny;
		px = nx;
		/*:::X^[ƏꏊւH*/
		/* Hack -- For moving monster or riding player's moving */
		if (!(mpe_mode & MPE_DONT_SWAP_MON))
		{
			/* Swap two monsters */
			c_ptr->m_idx = om_idx; 
			oc_ptr->m_idx = nm_idx;

			if (om_idx > 0) /* Monster on old spot (or p_ptr->riding) */
			{
				monster_type *om_ptr = &m_list[om_idx];
				om_ptr->fy = ny;
				om_ptr->fx = nx;
				update_mon(om_idx, TRUE);
			}

			if (nm_idx > 0) /* Monster on new spot */
			{
				monster_type *nm_ptr = &m_list[nm_idx];
				nm_ptr->fy = oy;
				nm_ptr->fx = ox;
				update_mon(nm_idx, TRUE);
			}
		}

		/* Redraw old spot */
		lite_spot(oy, ox);

		/* Redraw new spot */
		lite_spot(ny, nx);

		/* Check for new panel (redraw map) */
		verify_panel();

		if (mpe_mode & MPE_FORGET_FLOW)
		{
			forget_flow();

			/* Mega-Hack -- Forget the view */
			p_ptr->update |= (PU_UN_VIEW);

			/* Redraw map */
			p_ptr->redraw |= (PR_MAP);
		}

		/* Update stuff */
		p_ptr->update |= (PU_VIEW | PU_LITE | PU_FLOW | PU_MON_LITE | PU_DISTANCE);

		/* Window stuff */
		p_ptr->window |= (PW_OVERHEAD | PW_DUNGEON);

		/* Remove "unsafe" flag */
		if ((!p_ptr->blind && !no_lite()) || !is_trap(c_ptr->feat)) c_ptr->info &= ~(CAVE_UNSAFE);

		/* For get everything when requested hehe I'm *NASTY* */
		/*:::{ȂǂŒn`Y鏈炵*/
		if (dun_level && (d_info[dungeon_type].flags1 & DF1_FORGET)) wiz_dark();

		/* Handle stuff */
		if (mpe_mode & MPE_HANDLE_STUFF) handle_stuff();





		/*:::n`ɂp[^ȂǂύXƂ̃bZ[W*/
		if(c_ptr->feat != oc_ptr->feat)
		{
			bool flag_update = FALSE;
			feature_type *of_ptr = &f_info[oc_ptr->feat];
			///mod140316 n`p[AbvȂǂ̂߂PU_BONUSXV悤ɂ

			if(p_ptr->pclass == CLASS_MURASA || p_ptr->pclass == CLASS_WAKASAGI ||  p_ptr->prace == RACE_KAPPA || p_ptr->prace == RACE_YAMAWARO )
			{
				/* 璷Ȃ̂ŃbZ[W폜
				if(have_flag(f_ptr->flags, FF_WATER) && !have_flag(of_ptr->flags, FF_WATER) )
					msg_print("͂NoCI");
				if(!have_flag(f_ptr->flags, FF_WATER) && have_flag(of_ptr->flags, FF_WATER) )
					msg_print("͂CEE");
				*/
				flag_update = TRUE;
			}
			else if(p_ptr->prace == RACE_NINGYO )
			{
				/*
				if(have_flag(f_ptr->flags, FF_WATER) && !have_flag(of_ptr->flags, FF_WATER) )
					msg_print("ɓB");
				if(!have_flag(f_ptr->flags, FF_WATER) && have_flag(of_ptr->flags, FF_WATER) )
					msg_print("ɏオB");
				*/
				flag_update = TRUE;
			}
			else if(CHECK_FAIRY_TYPE == 5 || CHECK_FAIRY_TYPE == 27 || CHECK_FAIRY_TYPE == 32 || CHECK_FAIRY_TYPE == 39 ||  CHECK_FAIRY_TYPE == 40 ||  CHECK_FAIRY_TYPE == 43)
			{
				flag_update = TRUE;
			}
			//v1.1.22 mZ\ n`oƂ̂ƂlCHECK_CONCEAL͎gȂ
			else if(HAVE_SOLDIER_SKILL(SOLDIER_SKILL_MAGICBULLET,SS_M_CONCEALMENT))
			{
				flag_update = TRUE;
			}
			//v1.1.47 }̒w偂̑
			else if (p_ptr->pclass == CLASS_YAMAME)
			{
				flag_update = TRUE;
			}


			///mod140402 Mꏈ
			if(have_flag(f_ptr->flags, FF_WATER) && have_flag(f_ptr->flags, FF_DEEP) )
			{

				if(prace_is_(RACE_VAMPIRE) && !p_ptr->levitation && !p_ptr->can_swim)
				{
					msg_print("Ȃ̑̂͏uԂɐւƒłEE");
					if(p_ptr->wild_mode)
					{
						/*:::-Hack- S̃}bvړenergy_use{ɂȂĂĐɓuԎɂ˂Ȃ̂łŒĂ*/
						energy_use = MIN(energy_use,100);
						change_wild_mode();
					}
					set_action(ACTION_NONE);
					flag_update = TRUE;
				}
				else if(!p_ptr->resist_water && !p_ptr->levitation && p_ptr->total_weight > weight_limit() && !p_ptr->can_swim)
				{
					msg_print("וdĉjȂIMĂI");
					if(p_ptr->wild_mode)
					{
						energy_use = MIN(energy_use,100);
						change_wild_mode();
					}
					set_action(ACTION_NONE);
					flag_update = TRUE;
				}
			}
			///mod150413 Mꏈ֘AC
		//	else if(!have_flag(f_ptr->flags, FF_WATER) && have_flag(of_ptr->flags, FF_WATER) )
			else if((have_flag(f_ptr->flags, FF_WATER) || have_flag(of_ptr->flags, FF_WATER)) && f_ptr != of_ptr)
			{
					flag_update = TRUE;
			}

			p_ptr->redraw |= (PR_STATE); //n`\̂ߊOɏo
			if(flag_update)
			{
				p_ptr->update |= (PU_BONUS);
				handle_stuff();
			}
		}
		///mod150110 򐅖v
		if(p_ptr->pclass == CLASS_CHEN && !p_ptr->magic_num1[0] &&
			have_flag(f_ptr->flags, FF_WATER) && have_flag(f_ptr->flags, FF_DEEP) && !p_ptr->levitation)
		{
			msg_print("ɓĎĂ܂I");
			p_ptr->magic_num1[0] = 1;
			p_ptr->update |= (PU_BONUS);
			handle_stuff();
		}

		//v1.1.35 lm꒣
		if((c_ptr->cave_xtra_flag & CAVE_XTRA_FLAG_NEMUNO) != (oc_ptr->cave_xtra_flag & CAVE_XTRA_FLAG_NEMUNO))
		{
			if(c_ptr->cave_xtra_flag & CAVE_XTRA_FLAG_NEMUNO)
				msg_print("Ȃ͓꒣ɖ߂B");
			else
				msg_print("Ȃ͓꒣肩oB");
			disturb(0, 1);
			p_ptr->update |= (PU_BONUS | PU_HP);
			handle_stuff();
		}


		/*:::B*/
		///class E҂̒B
		if (p_ptr->pclass == CLASS_NINJA)
		{
			if (c_ptr->info & (CAVE_GLOW)) set_superstealth(FALSE);
			else if (p_ptr->cur_lite <= 0) set_superstealth(TRUE);
		}

		///sys 삯͐[nł͋@\Ȃ炵
		if ((p_ptr->action == ACTION_HAYAGAKE) &&
		    (!have_flag(f_ptr->flags, FF_PROJECT) ||
		     (!p_ptr->levitation && have_flag(f_ptr->flags, FF_DEEP))))
		{
#ifdef JP
			msg_print("ł͑fȂB");
#else
			msg_print("You cannot run in here.");
#endif
			set_action(ACTION_NONE);
		}
	}

	/*:::TȂ*/
	if (mpe_mode & MPE_ENERGY_USE)
	{
		/*:::ǌ@̉*/
		if (music_singing(MUSIC_WALL))
		{
			(void)project(0, 0, py, px, (60 + p_ptr->lev), GF_DISINTEGRATE,
				PROJECT_KILL | PROJECT_ITEM, -1);

			if (!player_bold(ny, nx) || p_ptr->is_dead || p_ptr->leaving) return FALSE;
		}

		/* Spontaneous Searching */
		///sys mo@Tƈ{悤
		if ((p_ptr->skill_fos >= 50) || (0 == randint0(50 - p_ptr->skill_fos)))
		{
			search();
		}

		/* Continuous Searching */
		if (p_ptr->action == ACTION_SEARCH)
		{
			search();
		}
	}



	/* Handle "objects" */
	/*:::̃ACeɑ΂鏈*/
	if (!(mpe_mode & MPE_DONT_PICKUP))
	{
		carry((mpe_mode & MPE_DO_PICKUP) ? TRUE : FALSE);
	}

	///mod140428 @̈ړуACeEɑACeꗗXV
	if(!running)
	{
		p_ptr->window |= PW_FLOOR_ITEM_LIST;
		window_stuff();
	}

	/* Handle "store doors" */
	if (have_flag(f_ptr->flags, FF_STORE))
	{
		/* Disturb */
		disturb(0, 1);

		energy_use = 0;
		/* Hack -- Enter store */
		command_new = SPECIAL_KEY_STORE;
	}

	/* Handle "building doors" -KMW- */
	else if (have_flag(f_ptr->flags, FF_BLDG))
	{
		/* Disturb */
		disturb(0, 1);

		energy_use = 0;
		/* Hack -- Enter building */
		command_new = SPECIAL_KEY_BUILDING;
	}

	/* Handle quest areas -KMW- */
	else if (have_flag(f_ptr->flags, FF_QUEST_ENTER))
	{
		/* Disturb */
		disturb(0, 1);

		energy_use = 0;
		/* Hack -- Enter quest level */
		command_new = SPECIAL_KEY_QUEST;
	}
	/*:::oBŃNAɂȂ^CṽNGXg̏ꍇH*/
	else if (have_flag(f_ptr->flags, FF_QUEST_EXIT))
	{
		if (quest[p_ptr->inside_quest].type == QUEST_TYPE_FIND_EXIT)
		{
			complete_quest(p_ptr->inside_quest);
		}

		leave_quest_check();

		p_ptr->inside_quest = c_ptr->special;
		dun_level = 0;
		p_ptr->oldpx = 0;
		p_ptr->oldpy = 0;

		p_ptr->leaving = TRUE;
	}

	/* Set off a trap */
	else if (have_flag(f_ptr->flags, FF_HIT_TRAP) && !(mpe_mode & MPE_STAYING))
	{
		/* Disturb */
		disturb(0, 1);

		/* Hidden trap */
		/*:::BgbvɈꍇgbv@ʂȂƂ̓gbvɎsƂ*/
		if (c_ptr->mimic || have_flag(f_ptr->flags, FF_SECRET))
		{
			/* Message */
#ifdef JP
			msg_print("gbvI");
#else
			msg_print("You found a trap!");
#endif

			/* Pick a trap */
			disclose_grid(py, px);
		}

		/* Hit the trap */
		hit_trap((mpe_mode & MPE_BREAK_TRAP) ? TRUE : FALSE);

		if (!player_bold(ny, nx) || p_ptr->is_dead || p_ptr->leaving) return FALSE;
	}

	/* Warn when leaving trap detected region */
	if (!(mpe_mode & MPE_STAYING) && (disturb_trap_detect || alert_trap_detect)
	    && p_ptr->dtrap && !(c_ptr->info & CAVE_IN_DETECT))
	{
		/* No duplicate warning */
		p_ptr->dtrap = FALSE;

		/* You are just on the edge */
		if (!(c_ptr->info & CAVE_UNSAFE))
		{
			if (alert_trap_detect)
			{
#ifdef JP
				msg_print("* :̐̓gbv̊m͈͊OłI *");
#else
				msg_print("*Leaving trap detect region!*");
#endif
			}

			if (disturb_trap_detect) disturb(0, 1);
		}
	}

	return player_bold(ny, nx) && !p_ptr->is_dead && !p_ptr->leaving;
}

/*:::Ăgbv𔻒肷*/
bool trap_can_be_ignored(int feat)
{
	feature_type *f_ptr = &f_info[feat];

	if (!have_flag(f_ptr->flags, FF_TRAP)) return TRUE;

	switch (f_ptr->subtype)
	{
	case TRAP_TRAPDOOR:
	case TRAP_PIT:
	case TRAP_SPIKED_PIT:
	case TRAP_POISON_PIT:
		if (p_ptr->levitation) return TRUE;
		break;
	case TRAP_TELEPORT:
		if (p_ptr->anti_tele) return TRUE;
		break;
	case TRAP_FIRE:
		if (p_ptr->immune_fire) return TRUE;
		break;
	case TRAP_ACID:
		if (p_ptr->immune_acid) return TRUE;
		break;
	case TRAP_BLIND:
		if (p_ptr->resist_blind) return TRUE;
		break;
	case TRAP_CONFUSE:
		if (p_ptr->resist_conf) return TRUE;
		break;
	case TRAP_POISON:
		if (p_ptr->resist_pois) return TRUE;
		break;
	case TRAP_SLEEP:
		if (p_ptr->free_act) return TRUE;
		break;
	}

	return FALSE;
}


/*
 * Determine if a "boundary" grid is "floor mimic"
 */
#define boundary_floor(C, F, MF) \
	((C)->mimic && permanent_wall(F) && \
	 (have_flag((MF)->flags, FF_MOVE) || have_flag((MF)->flags, FF_CAN_FLY)) && \
	 have_flag((MF)->flags, FF_PROJECT) && \
	 !have_flag((MF)->flags, FF_OPEN))

/*
 * Move player in the given direction, with the given "pickup" flag.
 *
 * This routine should (probably) always induce energy expenditure.
 *
 * Note that moving will *always* take a turn, and will *always* hit
 * any monster which might be in the destination grid.  Previously,
 * moving into walls was "free" and did NOT hit invisible monsters.
 */
/*:::w肵ֈړB
 *:::ړ͏Ƀ^[ÃObhɃX^[ɍUB
 *:::ǂɌĈړ̂̓^[ǂ̒̌ȂX^[͍UȂH
 *:::do_pickup:ACeE
 *:::break_trap:gbvj󂷂impHj
 *:::oktomove:ړɐǂ̃tO
 */
void move_player(int dir, bool do_pickup, bool break_trap)
{
	/* Find the result of moving */
	/*:::ړObḧʒuvZ*/
	int y = py + ddy[dir];
	int x = px + ddx[dir];

	/* Examine the destination */
	/*:::ړn`𓾂*/
	cave_type *c_ptr = &cave[y][x];

	feature_type *f_ptr = &f_info[c_ptr->feat];

	monster_type *m_ptr;

	/*:::R撆X^[monster_typemonster_race𓾂*/
	monster_type *riding_m_ptr = &m_list[p_ptr->riding];
	monster_race *riding_r_ptr = &r_info[p_ptr->riding ? riding_m_ptr->r_idx : 0]; /* Paranoia */

	char m_name[80];

	bool p_can_enter = player_can_enter(c_ptr->feat, CEM_P_CAN_ENTER_PATTERN);
	bool p_can_kill_walls = FALSE;
	bool stormbringer = FALSE;

	bool oktomove = TRUE;
	bool do_past = FALSE;




	if(IS_METAMORPHOSIS && !c_ptr->m_idx)
	{
		monster_race *r_ptr = &r_info[MON_EXTRA_FIELD];

		if(r_ptr->flags1 & RF1_NEVER_MOVE)
		{
			msg_print("Ȃ͓ȂB");
			return;
		}
		if(cave_have_flag_bold(y,x,FF_WATER) && cave_have_flag_bold(y,x,FF_DEEP) && !(r_ptr->flags7 & (RF7_CAN_SWIM|RF7_CAN_FLY)))
		{
			msg_print("Ȃ͉jȂB");
			return;
		}
		if(!cave_have_flag_bold(y,x,FF_WATER) && (r_ptr->flags7 & (RF7_AQUATIC)) && !(r_ptr->flags7 & (RF7_CAN_FLY)))
		{
			msg_print("Ȃ͗œȂB");
			return;
		}
	}

	/* Exit the area */
	/*:::rŗׂ̃}bvɈڂƂ*/
	if (!dun_level && !p_ptr->wild_mode &&
		((x == 0) || (x == MAX_WID - 1) ||
		 (y == 0) || (y == MAX_HGT - 1)))
	{
		/* Can the player enter the grid? */
			/*:::邩ǂmF*/
		if (c_ptr->mimic && player_can_enter(c_ptr->mimic, 0))
		{
			/* Hack: move to new area */
			if ((y == 0) && (x == 0))
			{
				p_ptr->wilderness_y--;
				p_ptr->wilderness_x--;
				p_ptr->oldpy = cur_hgt - 2;
				p_ptr->oldpx = cur_wid - 2;
				ambush_flag = FALSE;
			}

			else if ((y == 0) && (x == MAX_WID - 1))
			{
				p_ptr->wilderness_y--;
				p_ptr->wilderness_x++;
				p_ptr->oldpy = cur_hgt - 2;
				p_ptr->oldpx = 1;
				ambush_flag = FALSE;
			}

			else if ((y == MAX_HGT - 1) && (x == 0))
			{
				p_ptr->wilderness_y++;
				p_ptr->wilderness_x--;
				p_ptr->oldpy = 1;
				p_ptr->oldpx = cur_wid - 2;
				ambush_flag = FALSE;
			}

			else if ((y == MAX_HGT - 1) && (x == MAX_WID - 1))
			{
				p_ptr->wilderness_y++;
				p_ptr->wilderness_x++;
				p_ptr->oldpy = 1;
				p_ptr->oldpx = 1;
				ambush_flag = FALSE;
			}

			else if (y == 0)
			{
				p_ptr->wilderness_y--;
				p_ptr->oldpy = cur_hgt - 2;
				p_ptr->oldpx = x;
				ambush_flag = FALSE;
			}

			else if (y == MAX_HGT - 1)
			{
				p_ptr->wilderness_y++;
				p_ptr->oldpy = 1;
				p_ptr->oldpx = x;
				ambush_flag = FALSE;
			}

			else if (x == 0)
			{
				p_ptr->wilderness_x--;
				p_ptr->oldpx = cur_wid - 2;
				p_ptr->oldpy = y;
				ambush_flag = FALSE;
			}

			else if (x == MAX_WID - 1)
			{
				p_ptr->wilderness_x++;
				p_ptr->oldpx = 1;
				p_ptr->oldpy = y;
				ambush_flag = FALSE;
			}
			/*:::}bvoƂleaving*/
			p_ptr->leaving = TRUE;
			energy_use = 100;

			return;
		}

		/* "Blocked" message appears later */
		/* oktomove = FALSE; */
		/*:::ʂȂƂ̃tOH*/
		p_can_enter = FALSE;
	}

	/* Get the monster */
	m_ptr = &m_list[c_ptr->m_idx];

	///item Xg[uK[̃tO
	if (!check_invalidate_inventory(INVEN_RARM) && inventory[INVEN_RARM].name1 == ART_STORMBRINGER) stormbringer = TRUE;
	if (!check_invalidate_inventory(INVEN_LARM) && inventory[INVEN_LARM].name1 == ART_STORMBRINGER) stormbringer = TRUE;

	/* Player can not walk through "walls"... */
	/* unless in Shadow Form */
	p_can_kill_walls = p_ptr->kill_wall && have_flag(f_ptr->flags, FF_HURT_DISI) &&
		(!p_can_enter || !have_flag(f_ptr->flags, FF_LOS)) &&
		!have_flag(f_ptr->flags, FF_PERMANENT);

	/* Hack -- attack monsters */
	/*:::ړɃX^[āAuĂorĂȂ̃ObhɈړłvƂAU*/
	if (c_ptr->m_idx && (m_ptr->ml || p_can_enter || p_can_kill_walls))
	{

		monster_race *r_ptr = &r_info[m_ptr->r_idx];
		//̐Eꏈ
		if(SAKUYA_WORLD)
		{
			monster_desc(m_name, m_ptr, 0);
			msg_format("%^s̑̂זłɍsȂB", m_name);
			energy_use = 0;
			oktomove = FALSE;
			disturb(0, 1);
		}
		/* Attack -- only if we can see it OR it is not in a wall */
		/*:::X^[FDIŌĂAEoENOEmψقłȂȀꏊɓꍇ̂*/
		else if (!is_hostile(m_ptr) &&
		    !(p_ptr->confused || p_ptr->image || !m_ptr->ml || p_ptr->stun ||
		    ((p_ptr->muta2 & MUT2_BERS_RAGE) && p_ptr->shero)) &&
		    pattern_seq(py, px, y, x) && (p_can_enter || p_can_kill_walls))
		{
			/* Disturb the monster */
			/*:::N*/
			(void)set_monster_csleep(c_ptr->m_idx, 0);

			/* Extract monster name (or "it") */
			monster_desc(m_name, m_ptr, 0);

			if (m_ptr->ml)
			{
				/* Auto-Recall if possible and visible */
				if (!p_ptr->image) monster_race_track(m_ptr->ap_r_idx);

				/* Track a new monster */
				health_track(c_ptr->m_idx);
			}

			/* displace? */
			/*:::Xg[uK[𑕔ĂƂAX^[FDIłybgłUH*/
			///class mmŗFDIȓGɂU鏈
			if ((stormbringer && (randint1(1000) > 666)) || ( p_ptr->pseikaku == SEIKAKU_BERSERK))
			{
				py_attack(y, x, 0);
				oktomove = FALSE;
			}
			else if (monster_can_cross_terrain(cave[py][px].feat, r_ptr, 0))
			{
				do_past = TRUE;
			}
			else
			{
#ifdef JP
				msg_format("%^sזI", m_name);
#else
				msg_format("%^s is in your way!", m_name);
#endif

				energy_use = 0;
				oktomove = FALSE;
			}

			/* now continue on to 'movement' */
		}
		else
		{
			py_attack(y, x, 0);
			oktomove = FALSE;
		}
	}

	//v1.1.24 ꏈ@NGXgu}v̐̒ł͍ɈړłȂ
	if(oktomove && QRKDR)
	{
		if(cave_have_flag_bold(py,px,FF_WATER) && x < px)
		{
			msg_print("}ɉ߂ꂽI");
			oktomove = FALSE;
			disturb(0, 1);
		}

	}

	/*:::R掞̏܂*/
	if (oktomove && p_ptr->riding)
	{

		if (riding_r_ptr->flags1 & RF1_NEVER_MOVE)
		{
#ifdef JP
			msg_print("ȂI");
#else
			msg_print("Can't move!");
#endif
			energy_use = 0;
			oktomove = FALSE;
			disturb(0, 1);
		}
		else if (MON_MONFEAR(riding_m_ptr))
		{
			char m_name[80];

			/* Acquire the monster name */
			monster_desc(m_name, riding_m_ptr, 0);

			/* Dump a message */
#ifdef JP
			msg_format("%s|ĂĐłȂB", m_name);
#else
			msg_format("%^s is too scared to control.", m_name);
#endif
			oktomove = FALSE;
			disturb(0, 1);
		}
		else if (p_ptr->riding_ryoute && !CLASS_RIDING_BACKDANCE)
		{
			oktomove = FALSE;
			disturb(0, 1);
		}
		//v1.1.24 }NGXgpꏈ
		else if(QRKDR && have_flag(f_ptr->flags, FF_WATER) && !((riding_r_ptr->flags7 & (RF7_CAN_SWIM | RF7_AQUATIC))))
		{
			char m_name[80];
			monster_desc(m_name, riding_m_ptr, 0);

			msg_format("%sɓ肽ȂB", m_name);
			energy_use = 0;
			oktomove = FALSE;
			disturb(0, 1);
		}
		else if (have_flag(f_ptr->flags, FF_CAN_FLY) && (riding_r_ptr->flags7 & RF7_CAN_FLY))
		{
			/* Allow moving */
		}
		else if (have_flag(f_ptr->flags, FF_CAN_SWIM) && (riding_r_ptr->flags7 & RF7_CAN_SWIM))
		{
			/* Allow moving */
		}
		else if (have_flag(f_ptr->flags, FF_WATER) &&
			!(riding_r_ptr->flags7 & RF7_AQUATIC) &&
			(have_flag(f_ptr->flags, FF_DEEP) || (riding_r_ptr->flags2 & RF2_AURA_FIRE)))
		{
#ifdef JP
			msg_format("%s̏ɍsȂB", f_name + f_info[get_feat_mimic(c_ptr)].name);
#else
			msg_print("Can't swim.");
#endif
			energy_use = 0;
			oktomove = FALSE;
			disturb(0, 1);
		}
		else if (!have_flag(f_ptr->flags, FF_WATER) && (riding_r_ptr->flags7 & RF7_AQUATIC))
		{
#ifdef JP
			msg_format("%sオȂB", f_name + f_info[get_feat_mimic(&cave[py][px])].name);
#else
			msg_print("Can't land.");
#endif
			energy_use = 0;
			oktomove = FALSE;
			disturb(0, 1);
		}
		else if (have_flag(f_ptr->flags, FF_LAVA) && !(riding_r_ptr->flagsr & RFR_EFF_IM_FIRE_MASK))
		{
#ifdef JP
			msg_format("%s̏ɍsȂB", f_name + f_info[get_feat_mimic(c_ptr)].name);
#else
			msg_print("Too hot to go through.");
#endif
			energy_use = 0;
			oktomove = FALSE;
			disturb(0, 1);
		}

		if (oktomove && MON_STUNNED(riding_m_ptr) && one_in_(2))
		{
			char m_name[80];
			monster_desc(m_name, riding_m_ptr, 0);
#ifdef JP
			msg_format("%sNOƂĂĂ܂ȂI",m_name);
#else
			msg_format("You cannot control stunned %s!",m_name);
#endif
			oktomove = FALSE;
			disturb(0, 1);
		}
	}

	if (!oktomove)
	{
	}

	else if (!have_flag(f_ptr->flags, FF_MOVE) && have_flag(f_ptr->flags, FF_CAN_FLY) && !p_ptr->levitation)
	{
#ifdef JP
		msg_format("΂Ȃ%s̏ɂ͍sȂB", f_name + f_info[get_feat_mimic(c_ptr)].name);
#else
		msg_format("You need to fly to go through the %s.", f_name + f_info[get_feat_mimic(c_ptr)].name);
#endif

		energy_use = 0;
		running = 0;
		oktomove = FALSE;
	}

	/*
	 * Player can move through trees and
	 * has effective -10 speed
	 * Rangers can move without penality
	 */
	/*:::؂̏Ō鏈*/
	else if (have_flag(f_ptr->flags, FF_TREE) && !p_can_kill_walls)
	{
		if ((p_ptr->pclass != CLASS_RANGER) && !p_ptr->levitation && (!p_ptr->riding || !(riding_r_ptr->flags8 & RF8_WILD_WOOD))) energy_use *= 2;
	}

#ifdef ALLOW_EASY_DISARM /* TNB */

	/* Disarm a visible trap */
	else if ((do_pickup != easy_disarm) && have_flag(f_ptr->flags, FF_DISARM) && !c_ptr->mimic)
	{
		if (!trap_can_be_ignored(c_ptr->feat))
		{
			(void)do_cmd_disarm_aux(y, x, dir);
			return;
		}
	}

#endif /* ALLOW_EASY_DISARM -- TNB */

	/* Player can not walk through "walls" unless in wraith form...*/
	else if (!p_can_enter && !p_can_kill_walls)
	{
		/* Feature code (applying "mimic" field) */
		s16b feat = get_feat_mimic(c_ptr);
		feature_type *mimic_f_ptr = &f_info[feat];
		cptr name = f_name + mimic_f_ptr->name;

		oktomove = FALSE;

		/* Notice things in the dark */
		if (!(c_ptr->info & CAVE_MARK) && !player_can_see_bold(y, x))
		{
			/* Boundary floor mimic */
			if (boundary_floor(c_ptr, f_ptr, mimic_f_ptr))
			{
#ifdef JP
				msg_print("ȏɂ͐i߂Ȃ悤B");
#else
				msg_print("You feel you cannot go any more.");
#endif
			}

			/* Wall (or secret door) */
			else
			{
#ifdef JP
				msg_format("%ss͂΂ł悤B", name);
#else
				msg_format("You feel %s %s blocking your way.",
					is_a_vowel(name[0]) ? "an" : "a", name);
#endif

				c_ptr->info |= (CAVE_MARK);
				lite_spot(y, x);
			}
		}

		/* Notice things */
		else
		{
			/* Boundary floor mimic */
			if (boundary_floor(c_ptr, f_ptr, mimic_f_ptr))
			{
#ifdef JP
				msg_print("ȏɂ͐i߂ȂB");
#else
				msg_print("You cannot go any more.");
#endif

				if (!(p_ptr->confused || p_ptr->stun || p_ptr->image))
					energy_use = 0;
			}

			/* Wall (or secret door) */
			else
			{
#ifdef ALLOW_EASY_OPEN
				/* Closed doors */
				if (easy_open && is_closed_door(feat) && easy_open_door(y, x)) return;
#endif /* ALLOW_EASY_OPEN */

#ifdef JP
				msg_format("%ss͂΂łB", name);
#else
				msg_format("There is %s %s blocking your way.",
					is_a_vowel(name[0]) ? "an" : "a", name);
#endif

				/*
				 * Well, it makes sense that you lose time bumping into
				 * a wall _if_ you are confused, stunned or blind; but
				 * typing mistakes should not cost you a turn...
				 */
				if (!(p_ptr->confused || p_ptr->stun || p_ptr->image))
					energy_use = 0;
			}
		}

		/* Disturb the player */
		disturb(0, 1);

		/* Sound */
		if (!boundary_floor(c_ptr, f_ptr, mimic_f_ptr)) sound(SOUND_HITWALL);
	}

	/* Normal movement */
	if (oktomove && !pattern_seq(py, px, y, x))
	{
		if (!(p_ptr->confused || p_ptr->stun || p_ptr->image))
		{
			energy_use = 0;
		}

		/* To avoid a loop with running */
		disturb(0, 1);

		oktomove = FALSE;
	}

	/* Normal movement */
	if (oktomove)
	{
		u32b mpe_mode = MPE_ENERGY_USE;
		/*:::x*/
		if (p_ptr->warning)
		{
			if (!process_warning(x, y,FALSE))
			{
				energy_use = 25;
				return;
			}
		}


		//hbyQK[ꏈ
		if(do_past && r_info[m_ptr->r_idx].flags7 & RF7_DOPPELGANGER)
		{
			msg_print("Ȃ͎̃hbyQK[ɐGĂ܂I");
			take_hit(DAMAGE_LOSELIFE,p_ptr->chp,"hbyQK[Ƃ̐ڐG",-1);
			set_stun(100+randint0(3));
			energy_use = 100;
			delete_monster_idx(cave[y][x].m_idx);

			return;
		}

		if (do_past)
		{
#ifdef JP
			msg_format("%sނB", m_name);
#else
			msg_format("You push past %s.", m_name);
#endif
		}

		/* Change oldpx and oldpy to place the player well when going back to big mode */
		if (p_ptr->wild_mode)
		{
			if (ddy[dir] > 0)  p_ptr->oldpy = 1;
			if (ddy[dir] < 0)  p_ptr->oldpy = MAX_HGT - 2;
			if (ddy[dir] == 0) p_ptr->oldpy = MAX_HGT / 2;
			if (ddx[dir] > 0)  p_ptr->oldpx = 1;
			if (ddx[dir] < 0)  p_ptr->oldpx = MAX_WID - 2;
			if (ddx[dir] == 0) p_ptr->oldpx = MAX_WID / 2;
		}

		if (p_can_kill_walls)
		{
			cave_alter_feat(y, x, FF_HURT_DISI);

			/* Update some things -- similar to GF_KILL_WALL */
			p_ptr->update |= (PU_FLOW);
		}

		/* Sound */
		/* sound(SOUND_WALK); */

#ifdef ALLOW_EASY_DISARM /* TNB */

		if (do_pickup != always_pickup) mpe_mode |= MPE_DO_PICKUP;

#else /* ALLOW_EASY_DISARM -- TNB */

		if (do_pickup) mpe_mode |= MPE_DO_PICKUP;

#endif /* ALLOW_EASY_DISARM -- TNB */

		if (break_trap) mpe_mode |= MPE_BREAK_TRAP;

		/* Move the player */
		(void)move_player_effect(y, x, mpe_mode);
	}
}


static bool ignore_avoid_run;

/*
 * Hack -- Check for a "known wall" (see below)
 */
/*:::Ώۂ̃ObhuLĂǁvǂ*/
static int see_wall(int dir, int y, int x)
{
	cave_type   *c_ptr;

	/* Get the new location */
	/*:::dirɓ1-9̐ɂxy-1`+1̌vZ*/
	y += ddy[dir];
	x += ddx[dir];

	/* Illegal grids are not known walls */
	if (!in_bounds2(y, x)) return (FALSE);

	/* Access grid */
	c_ptr = &cave[y][x];

	/* Must be known to the player */
	if (c_ptr->info & (CAVE_MARK))
	{
		/* Feature code (applying "mimic" field) */
		s16b         feat = get_feat_mimic(c_ptr);
		feature_type *f_ptr = &f_info[feat];

		/* Wall grids are known walls */
		if (!player_can_enter(feat, 0)) return !have_flag(f_ptr->flags, FF_DOOR);

		/* Don't run on a tree unless explicitly requested */
		if (have_flag(f_ptr->flags, FF_AVOID_RUN) && !ignore_avoid_run)
			return TRUE;

		/* Don't run in a wall */
		if (!have_flag(f_ptr->flags, FF_MOVE) && !have_flag(f_ptr->flags, FF_CAN_FLY))
			return !have_flag(f_ptr->flags, FF_DOOR);
	}

	return FALSE;
}


/*
 * Hack -- Check for an "unknown corner" (see below)
 */
static int see_nothing(int dir, int y, int x)
{
	/* Get the new location */
	y += ddy[dir];
	x += ddx[dir];

	/* Illegal grids are unknown */
	if (!in_bounds2(y, x)) return (TRUE);

	/* Memorized grids are always known */
	if (cave[y][x].info & (CAVE_MARK)) return (FALSE);

	/* Viewable door/wall grids are known */
	if (player_can_see_bold(y, x)) return (FALSE);

	/* Default */
	return (TRUE);
}





/*
 * The running algorithm:                       -CJS-
 *
 * In the diagrams below, the player has just arrived in the
 * grid marked as '@', and he has just come from a grid marked
 * as 'o', and he is about to enter the grid marked as 'x'.
 *
 * Of course, if the "requested" move was impossible, then you
 * will of course be blocked, and will stop.
 *
 * Overview: You keep moving until something interesting happens.
 * If you are in an enclosed space, you follow corners. This is
 * the usual corridor scheme. If you are in an open space, you go
 * straight, but stop before entering enclosed space. This is
 * analogous to reaching doorways. If you have enclosed space on
 * one side only (that is, running along side a wall) stop if
 * your wall opens out, or your open space closes in. Either case
 * corresponds to a doorway.
 *
 * What happens depends on what you can really SEE. (i.e. if you
 * have no light, then running along a dark corridor is JUST like
 * running in a dark room.) The algorithm works equally well in
 * corridors, rooms, mine tailings, earthquake rubble, etc, etc.
 *
 * These conditions are kept in static memory:
 * find_openarea         You are in the open on at least one
 * side.
 * find_breakleft        You have a wall on the left, and will
 * stop if it opens
 * find_breakright       You have a wall on the right, and will
 * stop if it opens
 *
 * To initialize these conditions, we examine the grids adjacent
 * to the grid marked 'x', two on each side (marked 'L' and 'R').
 * If either one of the two grids on a given side is seen to be
 * closed, then that side is considered to be closed. If both
 * sides are closed, then it is an enclosed (corridor) run.
 *
 * LL           L
 * @x          LxR
 * RR          @R
 *
 * Looking at more than just the immediate squares is
 * significant. Consider the following case. A run along the
 * corridor will stop just before entering the center point,
 * because a choice is clearly established. Running in any of
 * three available directions will be defined as a corridor run.
 * Note that a minor hack is inserted to make the angled corridor
 * entry (with one side blocked near and the other side blocked
 * further away from the runner) work correctly. The runner moves
 * diagonally, but then saves the previous direction as being
 * straight into the gap. Otherwise, the tail end of the other
 * entry would be perceived as an alternative on the next move.
 *
 * #.#
 * ##.##
 * .@x..
 * ##.##
 * #.#
 *
 * Likewise, a run along a wall, and then into a doorway (two
 * runs) will work correctly. A single run rightwards from @ will
 * stop at 1. Another run right and down will enter the corridor
 * and make the corner, stopping at the 2.
 *
 * ##################
 * o@x       1
 * ########### ######
 * #2          #
 * #############
 *
 * After any move, the function area_affect is called to
 * determine the new surroundings, and the direction of
 * subsequent moves. It examines the current player location
 * (at which the runner has just arrived) and the previous
 * direction (from which the runner is considered to have come).
 *
 * Moving one square in some direction places you adjacent to
 * three or five new squares (for straight and diagonal moves
 * respectively) to which you were not previously adjacent,
 * marked as '!' in the diagrams below.
 *
 *   ...!              ...
 *   .o@!  (normal)    .o.!  (diagonal)
 *   ...!  (east)      ..@!  (south east)
 *                      !!!
 *
 * You STOP if any of the new squares are interesting in any way:
 * for example, if they contain visible monsters or treasure.
 *
 * You STOP if any of the newly adjacent squares seem to be open,
 * and you are also looking for a break on that side. (that is,
 * find_openarea AND find_break).
 *
 * You STOP if any of the newly adjacent squares do NOT seem to be
 * open and you are in an open area, and that side was previously
 * entirely open.
 *
 * Corners: If you are not in the open (i.e. you are in a corridor)
 * and there is only one way to go in the new squares, then turn in
 * that direction. If there are more than two new ways to go, STOP.
 * If there are two ways to go, and those ways are separated by a
 * square which does not seem to be open, then STOP.
 *
 * Otherwise, we have a potential corner. There are two new open
 * squares, which are also adjacent. One of the new squares is
 * diagonally located, the other is straight on (as in the diagram).
 * We consider two more squares further out (marked below as ?).
 *
 * We assign "option" to the straight-on grid, and "option2" to the
 * diagonal grid, and "check_dir" to the grid marked 's'.
 *
 * ##s
 * @x?
 * #.?
 *
 * If they are both seen to be closed, then it is seen that no benefit
 * is gained from moving straight. It is a known corner.  To cut the
 * corner, go diagonally, otherwise go straight, but pretend you
 * stepped diagonally into that next location for a full view next
 * time. Conversely, if one of the ? squares is not seen to be closed,
 * then there is a potential choice. We check to see whether it is a
 * potential corner or an intersection/room entrance.  If the square
 * two spaces straight ahead, and the space marked with 's' are both
 * unknown space, then it is a potential corner and enter if
 * find_examine is set, otherwise must stop because it is not a
 * corner. (find_examine option is removed and always is TRUE.)
 */




/*
 * Hack -- allow quick "cycling" through the legal directions
 */
static byte cycle[] =
{ 1, 2, 3, 6, 9, 8, 7, 4, 1, 2, 3, 6, 9, 8, 7, 4, 1 };

/*
 * Hack -- map each direction into the "middle" of the "cycle[]" array
 */
static byte chome[] =
{ 0, 8, 9, 10, 7, 0, 11, 6, 5, 4 };

/*
 * The direction we are running
 */
static byte find_current;

/*
 * The direction we came from
 */
static byte find_prevdir;

/*
 * We are looking for open area
 */
static bool find_openarea;

/*
 * We are looking for a break
 */
static bool find_breakright;
static bool find_breakleft;



/*
 * Initialize the running algorithm for a new direction.
 *
 * Diagonal Corridor -- allow diaginal entry into corridors.
 *
 * Blunt Corridor -- If there is a wall two spaces ahead and
 * we seem to be in a corridor, then force a turn into the side
 * corridor, must be moving straight into a corridor here. ???
 *
 * Diagonal Corridor    Blunt Corridor (?)
 *       # #                  #
 *       #x#                 @x#
 *       @p.                  p
 */
/*:::邽߂̏Hڍז*/
static void run_init(int dir)
{
	int             row, col, deepleft, deepright;
	int             i, shortleft, shortright;


	/* Save the direction */
	find_current = dir;

	/* Assume running straight */
	find_prevdir = dir;

	/* Assume looking for open area */
	find_openarea = TRUE;

	/* Assume not looking for breaks */
	find_breakright = find_breakleft = FALSE;

	/* Assume no nearby walls */
	deepleft = deepright = FALSE;
	shortright = shortleft = FALSE;

	p_ptr->run_py = py;
	p_ptr->run_px = px;

	/* Find the destination grid */
	row = py + ddy[dir];
	col = px + ddx[dir];

	ignore_avoid_run = cave_have_flag_bold(row, col, FF_AVOID_RUN);

	/* Extract cycle index */
	i = chome[dir];

	/* Check for walls */
	if (see_wall(cycle[i+1], py, px))
	{
		find_breakleft = TRUE;
		shortleft = TRUE;
	}
	else if (see_wall(cycle[i+1], row, col))
	{
		find_breakleft = TRUE;
		deepleft = TRUE;
	}

	/* Check for walls */
	if (see_wall(cycle[i-1], py, px))
	{
		find_breakright = TRUE;
		shortright = TRUE;
	}
	else if (see_wall(cycle[i-1], row, col))
	{
		find_breakright = TRUE;
		deepright = TRUE;
	}

	/* Looking for a break */
	if (find_breakleft && find_breakright)
	{
		/* Not looking for open area */
		find_openarea = FALSE;

		/* Hack -- allow angled corridor entry */
		if (dir & 0x01)
		{
			if (deepleft && !deepright)
			{
				find_prevdir = cycle[i - 1];
			}
			else if (deepright && !deepleft)
			{
				find_prevdir = cycle[i + 1];
			}
		}

		/* Hack -- allow blunt corridor entry */
		else if (see_wall(cycle[i], row, col))
		{
			if (shortleft && !shortright)
			{
				find_prevdir = cycle[i - 2];
			}
			else if (shortright && !shortleft)
			{
				find_prevdir = cycle[i + 2];
			}
		}
	}
}


/*
 * Update the current "run" path
 *
 * Return TRUE if the running should be stopped
 */
/*:::ĂƂ̎̈̕߁Afind_currentɊi[Ă炵Bڍז*/
static bool run_test(void)
{
	int         prev_dir, new_dir, check_dir = 0;
	int         row, col;
	int         i, max, inv;
	int         option = 0, option2 = 0;
	cave_type   *c_ptr;
	s16b        feat;
	feature_type *f_ptr;

	/* Where we came from */
	prev_dir = find_prevdir;


	/* Range of newly adjacent grids */
	max = (prev_dir & 0x01) + 1;

	/* break run when leaving trap detected region */
	if ((disturb_trap_detect || alert_trap_detect)
	    && p_ptr->dtrap && !(cave[py][px].info & CAVE_IN_DETECT))
	{
		/* No duplicate warning */
		p_ptr->dtrap = FALSE;

		/* You are just on the edge */
		if (!(cave[py][px].info & CAVE_UNSAFE))
		{
			if (alert_trap_detect)
			{
#ifdef JP
				msg_print("* :̐̓gbv̊m͈͊OłI *");
#else
				msg_print("*Leaving trap detect region!*");
#endif
			}

			if (disturb_trap_detect)
			{
				/* Break Run */
				return(TRUE);
			}
		}
	}

	/* Look at every newly adjacent square. */
	for (i = -max; i <= max; i++)
	{
		s16b this_o_idx, next_o_idx = 0;

		/* New direction */
		new_dir = cycle[chome[prev_dir] + i];

		/* New location */
		row = py + ddy[new_dir];
		col = px + ddx[new_dir];

		/* Access grid */
		c_ptr = &cave[row][col];

		/* Feature code (applying "mimic" field) */
		feat = get_feat_mimic(c_ptr);
		f_ptr = &f_info[feat];

		/* Visible monsters abort running */
		if (c_ptr->m_idx)
		{
			monster_type *m_ptr = &m_list[c_ptr->m_idx];

			/* Visible monster */
			if (m_ptr->ml) return (TRUE);
		}

		/* Visible objects abort running */
		for (this_o_idx = c_ptr->o_idx; this_o_idx; this_o_idx = next_o_idx)
		{
			object_type *o_ptr;

			/* Acquire object */
			o_ptr = &o_list[this_o_idx];

			/* Acquire next object */
			next_o_idx = o_ptr->next_o_idx;

			/* Visible object */
			if (o_ptr->marked & OM_FOUND) return (TRUE);
		}

		/* Assume unknown */
		inv = TRUE;

		/* Check memorized grids */
		if (c_ptr->info & (CAVE_MARK))
		{
			bool notice = have_flag(f_ptr->flags, FF_NOTICE);

			if (notice && have_flag(f_ptr->flags, FF_MOVE))
			{
				/* Open doors */
				if (find_ignore_doors && have_flag(f_ptr->flags, FF_DOOR) && have_flag(f_ptr->flags, FF_CLOSE))
				{
					/* Option -- ignore */
					notice = FALSE;
				}

				/* Stairs */
				else if (find_ignore_stairs && have_flag(f_ptr->flags, FF_STAIRS))
				{
					/* Option -- ignore */
					notice = FALSE;
				}

				/* Lava */
				else if (have_flag(f_ptr->flags, FF_LAVA) && (p_ptr->immune_fire || IS_INVULN()))
				{
					/* Ignore */
					notice = FALSE;
				}

				/* Deep water */
				else if (have_flag(f_ptr->flags, FF_WATER) && have_flag(f_ptr->flags, FF_DEEP) &&
				         (p_ptr->levitation || p_ptr->can_swim || (p_ptr->total_weight <= weight_limit())))
				{
					/* Ignore */
					notice = FALSE;
				}
			}

			/* Interesting feature */
			if (notice) return (TRUE);

			/* The grid is "visible" */
			inv = FALSE;
		}

		/* Analyze unknown grids and floors considering mimic */
		if (inv || !see_wall(0, row, col))
		{
			/* Looking for open area */
			if (find_openarea)
			{
				/* Nothing */
			}

			/* The first new direction. */
			else if (!option)
			{
				option = new_dir;
			}

			/* Three new directions. Stop running. */
			else if (option2)
			{
				return (TRUE);
			}

			/* Two non-adjacent new directions.  Stop running. */
			else if (option != cycle[chome[prev_dir] + i - 1])
			{
				return (TRUE);
			}

			/* Two new (adjacent) directions (case 1) */
			else if (new_dir & 0x01)
			{
				check_dir = cycle[chome[prev_dir] + i - 2];
				option2 = new_dir;
			}

			/* Two new (adjacent) directions (case 2) */
			else
			{
				check_dir = cycle[chome[prev_dir] + i + 1];
				option2 = option;
				option = new_dir;
			}
		}

		/* Obstacle, while looking for open area */
		else
		{
			if (find_openarea)
			{
				if (i < 0)
				{
					/* Break to the right */
					find_breakright = TRUE;
				}

				else if (i > 0)
				{
					/* Break to the left */
					find_breakleft = TRUE;
				}
			}
		}
	}

	/* Looking for open area */
	if (find_openarea)
	{
		/* Hack -- look again */
		for (i = -max; i < 0; i++)
		{
			/* Unknown grid or non-wall */
			if (!see_wall(cycle[chome[prev_dir] + i], py, px))
			{
				/* Looking to break right */
				if (find_breakright)
				{
					return (TRUE);
				}
			}

			/* Obstacle */
			else
			{
				/* Looking to break left */
				if (find_breakleft)
				{
					return (TRUE);
				}
			}
		}

		/* Hack -- look again */
		for (i = max; i > 0; i--)
		{
			/* Unknown grid or non-wall */
			if (!see_wall(cycle[chome[prev_dir] + i], py, px))
			{
				/* Looking to break left */
				if (find_breakleft)
				{
					return (TRUE);
				}
			}

			/* Obstacle */
			else
			{
				/* Looking to break right */
				if (find_breakright)
				{
					return (TRUE);
				}
			}
		}
	}

	/* Not looking for open area */
	else
	{
		/* No options */
		if (!option)
		{
			return (TRUE);
		}

		/* One option */
		else if (!option2)
		{
			/* Primary option */
			find_current = option;

			/* No other options */
			find_prevdir = option;
		}

		/* Two options, examining corners */
		else if (!find_cut)
		{
			/* Primary option */
			find_current = option;

			/* Hack -- allow curving */
			find_prevdir = option2;
		}

		/* Two options, pick one */
		else
		{
			/* Get next location */
			row = py + ddy[option];
			col = px + ddx[option];

			/* Don't see that it is closed off. */
			/* This could be a potential corner or an intersection. */
			if (!see_wall(option, row, col) ||
			    !see_wall(check_dir, row, col))
			{
				/* Can not see anything ahead and in the direction we */
				/* are turning, assume that it is a potential corner. */
				if (see_nothing(option, row, col) &&
				    see_nothing(option2, row, col))
				{
					find_current = option;
					find_prevdir = option2;
				}

				/* STOP: we are next to an intersection or a room */
				else
				{
					return (TRUE);
				}
			}

			/* This corner is seen to be enclosed; we cut the corner. */
			else if (find_cut)
			{
				find_current = option2;
				find_prevdir = option2;
			}

			/* This corner is seen to be enclosed, and we */
			/* deliberately go the long way. */
			else
			{
				find_current = option;
				find_prevdir = option2;
			}
		}
	}

	/* About to hit a known wall, stop */
	if (see_wall(find_current, py, px))
	{
		return (TRUE);
	}

	/* Failure */
	return (FALSE);
}



/*
 * Take one step along the current "run" path
 */
/*:::^ꂽ֑*/
void run_step(int dir)
{
	/* Start running */
	if (dir)
	{
		/* Ignore AVOID_RUN on a first step */
		ignore_avoid_run = TRUE;

		/* Hack -- do not start silly run */
		if (see_wall(dir, py, px))
		{
			/* Message */
#ifdef JP
			msg_print("̕ɂ͑܂B");
#else
			msg_print("You cannot run in that direction.");
#endif

			/* Disturb */
			disturb(0, 0);

			/* Done */
			return;
		}

		/* Initialize */
		run_init(dir);
	}

	/* Keep running */
	else
	{
		/* Update run */
		if (run_test())
		{
			/* Disturb */
			disturb(0, 0);

			/* Done */
			return;
		}
	}

	/* Decrease the run counter */
	if (--running <= 0) return;

	/* Take time */
	energy_use = 100;

	/* Move the player, using the "pickup" flag */
#ifdef ALLOW_EASY_DISARM /* TNB */

	move_player(find_current, FALSE, FALSE);

#else /* ALLOW_EASY_DISARM -- TNB */

	move_player(find_current, always_pickup, FALSE);

#endif /* ALLOW_EASY_DISARM -- TNB */

	if (player_bold(p_ptr->run_py, p_ptr->run_px))
	{
		p_ptr->run_py = 0;
		p_ptr->run_px = 0;
		disturb(0, 0);
	}
}


#ifdef TRAVEL
/*
 * Test for traveling
 */
/*:::gxR}hŐiޕ߂*/
static int travel_test(int prev_dir)
{
	int new_dir = 0;
	int i, max;
	const cave_type *c_ptr;
	int cost;

	/* Cannot travel when blind */
	if (p_ptr->blind || no_lite())
	{
		msg_print(_("ڂȂI", "You cannot see!"));
		return (0);
	}

	/* break run when leaving trap detected region */
	if ((disturb_trap_detect || alert_trap_detect)
	    && p_ptr->dtrap && !(cave[py][px].info & CAVE_IN_DETECT))
	{
		/* No duplicate warning */
		p_ptr->dtrap = FALSE;

		/* You are just on the edge */
		if (!(cave[py][px].info & CAVE_UNSAFE))
		{
			if (alert_trap_detect)
			{
#ifdef JP
				msg_print("* :̐̓gbv̊m͈͊OłI *");
#else
				msg_print("*Leaving trap detect region!*");
#endif
			}

			if (disturb_trap_detect)
			{
				/* Break Run */
				return (0);
			}
		}
	}

	/* Range of newly adjacent grids */
	max = (prev_dir & 0x01) + 1;

	/* Look at every newly adjacent square. */
	for (i = -max; i <= max; i++)
	{
		/* New direction */
		int dir = cycle[chome[prev_dir] + i];

		/* New location */
		int row = py + ddy[dir];
		int col = px + ddx[dir];

		/* Access grid */
		c_ptr = &cave[row][col];

		/* Visible monsters abort running */
		if (c_ptr->m_idx)
		{
			monster_type *m_ptr = &m_list[c_ptr->m_idx];

			/* Visible monster */
			if (m_ptr->ml) return (0);
		}

	}

	/* Travel cost of current grid */
	cost = travel.cost[py][px];

	/* Determine travel direction */
	for (i = 0; i < 8; ++ i) {
		int dir_cost = travel.cost[py+ddy_ddd[i]][px+ddx_ddd[i]];

		if (dir_cost < cost)
		{
			new_dir = ddd[i];
			cost = dir_cost;
		}
	}

	if (!new_dir) return (0);

	/* Access newly move grid */
	c_ptr = &cave[py+ddy[new_dir]][px+ddx[new_dir]];

	/* Close door abort traveling */
	if (!easy_open && is_closed_door(c_ptr->feat)) return (0);

	/* Visible and unignorable trap abort tarveling */
	if (!c_ptr->mimic && !trap_can_be_ignored(c_ptr->feat)) return (0);

	/* Move new grid */
	return (new_dir);
}


/*
 * Travel command
 */
/*:::gxR}hɂړ*/
//travel.runɒl鎞Ă΂
//travel_test()ŖړInɋ߂ׂ̃Obh肵ֈړtravel.run1炷
void travel_step(void)
{
	/* Get travel direction */
	travel.dir = travel_test(travel.dir);

	/* disturb */
	if (!travel.dir)
	{
		if (travel.run == 255)
		{
#ifdef JP
			msg_print("؂܂I");
#else
			msg_print("No route is found!");
#endif
		}
		disturb(0, 1);
		return;
	}

	energy_use = 100;

	move_player(travel.dir, always_pickup, FALSE);

	if ((py == travel.y) && (px == travel.x))
		travel.run = 0;
	else if (travel.run > 0)
		travel.run--;

	/* Travel Delay */
	/*:::Term->xtra_hookݒ肳Ă΂s*/
	Term_xtra(TERM_XTRA_DELAY, delay_factor);
}
#endif

///mod131226 skill Z\ƕZ\̓̂߂Ɋ֐ǉ
///mod140130 AZ\ol@vZ
/*:::iAAnA񓁁AAol*/
/*:::skill_numɂ͊i0,n1,2,3,4,5-9\ȀꍇTVALl10(knife)`20(gun)ɕϊ*/
/*:::m_ptr͂̊֐Ă΂ƂU/ꂽ*/
void gain_skill_exp(int skill_num , monster_type* m_ptr)
{

	int n = skill_num;
	int amount;
	int old_skill_lev, new_skill_lev, max_skill_lev;
	cptr skill_desc;
	monster_race* r_ptr = &r_info[m_ptr->r_idx];
	int ridinglevel = r_info[m_list[p_ptr->riding].r_idx].level;
	int targetlevel = r_ptr->level;
	int skill_max;

	/*:::TVAL(23`)ΉZ\lz񍀖(10`)ɕϊ*/
	if(skill_num >= TV_KNIFE) n = skill_num -= SKILL_WEAPON_SHIFT;

	/*:::EƂƂ̂̋Z\̍ől𓾂 Kl*1600 */
	skill_max = cp_ptr->skill_aptitude[n] * SKILL_LEV_TICK * 10;
	max_skill_lev = cp_ptr->skill_aptitude[n] * 10;
	old_skill_lev = p_ptr->skill_exp[n] / SKILL_LEV_TICK;

	if(n==0) skill_desc = "i";
	else if(n==1) skill_desc = "";
	else if(n==2) skill_desc = "n";
	else if(n==3) skill_desc = "񓁗";
	else if(n==4) skill_desc = "";
	else if(n==10) skill_desc = "Z";
	else if(n==11) skill_desc = "";
	else if(n==12) skill_desc = "";
	else if(n==13) skill_desc = "݊";
	else if(n==14) skill_desc = "_";
	else if(n==15) skill_desc = "";
	else if(n==16) skill_desc = "";
	else if(n==17) skill_desc = "";
	else if(n==18) skill_desc = "|";
	else if(n==19) skill_desc = "NX{E";
	else if(n==20) skill_desc = "e";
	else if(n>=21&&n<=23) return; /*MAGICBOOK/MAGICWEAPON/OTHERWEAPONɂ͏nxȂ*/
	else{
		msg_format("ERROR:gain_skill_exp()ݎgĂȂZ\(%d)ŌĂ΂ꂽB",skill_num);
		return;
	}

	//ɏ̏ꍇI
	if(p_ptr->skill_exp[n] >= skill_max) return;

	//v1.1.41 ƗT̓R͏nxȂ
	if (CLASS_RIDING_BACKDANCE && n == SKILL_RIDING) return;

	//msg_format("TEST:RIDINGLEV:%d",ridinglevel);

	/*:::Z\olvZ@Lт낪傫Əオ₷*/
	if(max_skill_lev - old_skill_lev > 30) amount = 20;
	else if(max_skill_lev - old_skill_lev > 20) amount = 10;
	else if(max_skill_lev - old_skill_lev > 10) amount = 5;
	else amount = 1;
	
	/*:::Z\ႢƏオ₷*/
	if(old_skill_lev < 10) amount += 4;
	else if(old_skill_lev < 20) amount += 3;
	else if(old_skill_lev < 30) amount += 2;
	else if(old_skill_lev < 40) amount += 1;


	/*:::^[Qbg⁗アƏオɂ*/
	if((targetlevel < old_skill_lev / 4) ) amount /= 10;
	else if((targetlevel < old_skill_lev / 2) ) amount /= 5;
	else if((targetlevel < old_skill_lev) && one_in_(2)) amount /= 2;
	if((p_ptr->lev < old_skill_lev ) && one_in_(2)) amount /= 2;

	/*:::R惂X^[アƋRZ\͏オɂ*/
	if(n == SKILL_RIDING && (ridinglevel < old_skill_lev) && one_in_(2)) amount /= 2;
	/*:::͏オɂ*/
	if(n == SKILL_SHIELD && one_in_(2)) amount /= 2;

	/*:::ybgɂZ\lグ}~*/
	if(is_pet(m_ptr) && p_ptr->skill_exp[n] > 4000)
	{
		if(one_in_(10)) msg_format("zł%s̗Kɂ͂ȂȂB",skill_desc);
		amount = 0;
	}
	/*:::ɑBX^[ɂZ\lグ}~*/
	if(r_ptr->r_akills > 100 && targetlevel < old_skill_lev)
	{
		if(one_in_(10)) msg_format("̓Gł%s̗Kɂ͂ȂȂB",skill_desc);
		amount = 0;
	}
	//msg_format("GAIN_SKILL:(n:%d)%s:amount:%d",n,skill_desc,amount);
	
	p_ptr->skill_exp[n] += amount;
	/*::: */
	if(p_ptr->skill_exp[n] > skill_max) p_ptr->skill_exp[n] = skill_max;
	new_skill_lev = p_ptr->skill_exp[n] / SKILL_LEV_TICK;
	if(new_skill_lev > old_skill_lev){
		msg_format("%s̋Z\x%dɃAbv!", skill_desc,new_skill_lev);
	}
	p_ptr->update |= (PU_BONUS);

}


/*:::AZ\̌olQƂ*/
s16b ref_skill_exp(int skill_num){
	int n = skill_num;
	if(skill_num >= TV_KNIFE) n = skill_num -= SKILL_WEAPON_SHIFT;

	if(n >= 5 && n <= 9 || n >= 24){
		msg_format("ERROR:ref_skill_exp()ݎgĂȂZ\(%d)ŌĂ΂ꂽB",skill_num);
	}

	return p_ptr->skill_exp[n];
}

/*:::qbgAEFCƗ[`ɂB^[QbgIȂFALSE*/
bool hit_and_away(void)
{
	int x, y,dir;

	if (!get_rep_dir(&dir, FALSE)) return FALSE;
	y = py + ddy[dir];
	x = px + ddx[dir];
	if (cave[y][x].m_idx)
	{
		py_attack(y, x, 0);
		//v1.1.30 I[Ȃǂœ|ꂽe|Ȃ悤ɂƂ
		if (p_ptr->is_dead || randint0(p_ptr->skill_dis) < 7)
#ifdef JP
			msg_print("EsI");
#endif
		else 
		{
			msg_print("Ȃ͍U㗣EB");
			teleport_player(30, 0L);
		}
	}
	else
	{
#ifdef JP
		msg_print("̕ɂ̓X^[͂܂B");
#else
		msg_print("You don't see any monster in this direction");
#endif
		msg_print(NULL);
		return FALSE;
	}
	return TRUE;
}




