/* File: dungeonc */

/*
 * Copyright (c) 1997 Ben Harrison, James E. Wilson, Robert A. Koeneke
 *
 * This software may be copied and distributed for educational, research,
 * and not for profit purposes provided that this copyright and statement
 * are included in all such copies.  Other copyrights may also apply.
 */

/* Purpose: Angband game engine */

#include "angband.h"

#define TY_CURSE_CHANCE 200
#define CHAINSWORD_NOISE 100

static bool load = TRUE;
/*:::͉̕ϐHS̃}bvł̃^[JEg֌WH̊ɂ͖ȂƂ20ɍĐݒ肳ĂH*/
static int wild_regen = 20;

/*
 * Return a "feeling" (or NULL) about an item.  Method 1 (Heavy).
 */
/*:::ȈՊӒ@ȈՊӒ*/
///mod151121 Ŏĝextern

byte value_check_aux1(object_type *o_ptr)
{
	/* Artifacts */
	if (object_is_artifact(o_ptr))
	{
		/* Cursed/Broken */
		if (object_is_cursed(o_ptr) || object_is_broken(o_ptr)) return FEEL_TERRIBLE;

		/* Normal */
		return FEEL_SPECIAL;
	}

	/* Ego-Items */
	if (object_is_ego(o_ptr))
	{
		/* Cursed/Broken */
		if (object_is_cursed(o_ptr) || object_is_broken(o_ptr)) return FEEL_WORTHLESS;

		/* Normal */
		return FEEL_EXCELLENT;
	}

	/* Cursed items */
	if (object_is_cursed(o_ptr)) return FEEL_CURSED;

	/* Broken items */
	if (object_is_broken(o_ptr)) return FEEL_BROKEN;

	///mod151121ǉ..悤Ǝv߂BIDENT_BROKENƈeo邩Ȃ
	//if(o_ptr->pval < 0 || o_ptr->to_a < 0 || o_ptr->to_d < 0 || o_ptr->to_h < 0)
	//	 return FEEL_BROKEN;

	if ((o_ptr->tval == TV_RING) || (o_ptr->tval == TV_AMULET)) return FEEL_AVERAGE;

	/* Good "armor" bonus */
	if (o_ptr->to_a > 0) return FEEL_GOOD;

	/* Good "weapon" bonus */
	if (o_ptr->to_h + o_ptr->to_d > 0) return FEEL_GOOD;

	/* Default to "average" */
	return FEEL_AVERAGE;
}


/*
 * Return a "feeling" (or NULL) about an item.  Method 2 (Light).
 */
/*:::アȈՊӒ*/
static byte value_check_aux2(object_type *o_ptr)
{
	/* Cursed items (all of them) */
	if (object_is_cursed(o_ptr)) return FEEL_CURSED;

	/* Broken items (all of them) */
	if (object_is_broken(o_ptr)) return FEEL_BROKEN;

	/* Artifacts -- except cursed/broken ones */
	if (object_is_artifact(o_ptr)) return FEEL_UNCURSED;

	/* Ego-Items -- except cursed/broken ones */
	if (object_is_ego(o_ptr)) return FEEL_UNCURSED;

	/* Good armor bonus */
	if (o_ptr->to_a > 0) return FEEL_UNCURSED;

	/* Good weapon bonuses */
	if (o_ptr->to_h + o_ptr->to_d > 0) return FEEL_UNCURSED;

	/* No feeling */
	return FEEL_NONE;
}



static void sense_inventory_aux(int slot, bool heavy)
{
	byte        feel;
	object_type *o_ptr = &inventory[slot];
	char        o_name[MAX_NLEN];

	/* We know about it already, do not tell us again */
	if (o_ptr->ident & (IDENT_SENSE))return;

	if(check_invalidate_inventory(slot)) return;

	/* It is fully known, no information needed */
	if (object_is_known(o_ptr)) return;

	/* Check for a feeling */
	feel = (heavy ? value_check_aux1(o_ptr) : value_check_aux2(o_ptr));

	/* Skip non-feelings */
	if (!feel) return;

	/* Bad luck */
	if ((p_ptr->muta3 & MUT3_BAD_LUCK) && !randint0(13))
	{
		switch (feel)
		{
			case FEEL_TERRIBLE:
			{
				feel = FEEL_SPECIAL;
				break;
			}
			case FEEL_WORTHLESS:
			{
				feel = FEEL_EXCELLENT;
				break;
			}
			case FEEL_CURSED:
			{
				if (heavy)
					feel = randint0(3) ? FEEL_GOOD : FEEL_AVERAGE;
				else
					feel = FEEL_UNCURSED;
				break;
			}
			case FEEL_AVERAGE:
			{
				feel = randint0(2) ? FEEL_CURSED : FEEL_GOOD;
				break;
			}
			case FEEL_GOOD:
			{
				if (heavy)
					feel = randint0(3) ? FEEL_CURSED : FEEL_AVERAGE;
				else
					feel = FEEL_CURSED;
				break;
			}
			case FEEL_EXCELLENT:
			{
				feel = FEEL_WORTHLESS;
				break;
			}
			case FEEL_SPECIAL:
			{
				feel = FEEL_TERRIBLE;
				break;
			}
		}
	}

	/* Stop everything */
	if (disturb_minor) disturb(0, 0);

	/* Get an object description */
	object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));
	//fPꏈ
	if(p_ptr->pclass == CLASS_EIKI)
	{
		identify_item(o_ptr);
		object_desc(o_name, o_ptr, 0L);
		msg_format("%sɈႢȂB",o_name);
	}
	else
	{
		/* Message (equipment) */
		if (slot >= INVEN_RARM)
		{
			msg_format("%s%s(%c)%sƂ...",
				describe_use(slot),o_name, index_to_label(slot),game_inscriptions[feel]);
		}
		/* Message (inventory) */
		else
		{
			msg_format("UbN̒%s(%c)%sƂ...",
				o_name, index_to_label(slot),game_inscriptions[feel]);

		}
		/* We have "felt" it */
		o_ptr->ident |= (IDENT_SENSE);
		/* Set the "inscription" */
		o_ptr->feeling = feel;
	}


	/* Auto-inscription/destroy */
	autopick_alter_item(slot, destroy_feeling);

	/* Combine / Reorder the pack (later) */
	p_ptr->notice |= (PN_COMBINE | PN_REORDER);

	/* Window stuff */
	p_ptr->window |= (PW_INVEN | PW_EQUIP);
}



/*
 * Sense the inventory
 *
 *   Class 0 = Warrior --> fast and heavy
 *   Class 1 = Mage    --> slow and light
 *   Class 2 = Priest  --> fast but light
 *   Class 3 = Rogue   --> okay and heavy
 *   Class 4 = Ranger  --> slow but heavy  (changed!)
 *   Class 5 = Paladin --> slow but heavy
 */
///class item TVAL ACe̊ȈՊӒ
static void sense_inventory1(void)
{
	int         i;
	int         plev = p_ptr->lev;
	bool        heavy = FALSE;
	object_type *o_ptr;


	/*** Check for "sensing" ***/

	/* No sensing when confused */
	if (p_ptr->confused) return;

	///mod140202 ȈՊӒ\͂NXŒ̕ϐQƂɂ
	switch (cp_ptr->sense_arms)
	{
		case 1:
			if (0 != randint0(240000L / (plev + 5))) return;
			break;
		case 2:
			if (0 != randint0(80000L / (plev * plev + 40))) return;
			break;
		case 3:
			if (0 != randint0(70000L / (plev * plev + 40))) return;
			heavy = TRUE;
			break;
		case 4:
			if (0 != randint0(20000L / (plev * plev + 40))) return;
			heavy = TRUE;
			break;
		case 5:
			if (0 != randint0(8000L / (plev * plev + 40))) return;
			heavy = TRUE;
			break;
		default:
			msg_print("ERROR:player_class.sense_arms̐ݒl");
			return;

	}

#if 0
	/* Analyze the class */
	switch (p_ptr->pclass)
	{
		case CLASS_WARRIOR:
		case CLASS_ARCHER:
		case CLASS_SAMURAI:
		case CLASS_CAVALRY:
		{
			/* Good sensing */
			if (0 != randint0(9000L / (plev * plev + 40))) return;

			/* Heavy sensing */
			heavy = TRUE;

			/* Done */
			break;
		}

		case CLASS_SMITH:
		{
			/* Good sensing */
			if (0 != randint0(6000L / (plev * plev + 50))) return;

			/* Heavy sensing */
			heavy = TRUE;

			/* Done */
			break;
		}

		case CLASS_MAGE:
		case CLASS_HIGH_MAGE:
		case CLASS_SORCERER:
		case CLASS_MAGIC_EATER:
		{
			/* Very bad (light) sensing */
			if (0 != randint0(240000L / (plev + 5))) return;

			/* Done */
			break;
		}

		case CLASS_PRIEST:
		case CLASS_BARD:
		{
			/* Good (light) sensing */
			if (0 != randint0(10000L / (plev * plev + 40))) return;

			/* Done */
			break;
		}

		case CLASS_ROGUE:
		case CLASS_NINJA:
		{
			/* Okay sensing */
			if (0 != randint0(20000L / (plev * plev + 40))) return;

			/* Heavy sensing */
			heavy = TRUE;

			/* Done */
			break;
		}

		case CLASS_RANGER:
		{
			/* Bad sensing */
			if (0 != randint0(95000L / (plev * plev + 40))) return;

			/* Changed! */
			heavy = TRUE;

			/* Done */
			break;
		}

		case CLASS_PALADIN:
		case CLASS_SNIPER:
		{
			/* Bad sensing */
			if (0 != randint0(77777L / (plev * plev + 40))) return;

			/* Heavy sensing */
			heavy = TRUE;

			/* Done */
			break;
		}

		case CLASS_WARRIOR_MAGE:
		case CLASS_RED_MAGE:
		{
			/* Bad sensing */
			if (0 != randint0(75000L / (plev * plev + 40))) return;

			/* Done */
			break;
		}

		case CLASS_MINDCRAFTER:
		case CLASS_IMITATOR:
		case CLASS_BLUE_MAGE:
		case CLASS_MIRROR_MASTER:
		{
			/* Bad sensing */
			if (0 != randint0(55000L / (plev * plev + 40))) return;

			/* Done */
			break;
		}

		case CLASS_CHAOS_WARRIOR:
		{
			/* Bad sensing */
			if (0 != randint0(80000L / (plev * plev + 40))) return;

			/* Changed! */
			heavy = TRUE;

			/* Done */
			break;
		}

		case CLASS_MONK:
		case CLASS_FORCETRAINER:
		{
			/* Okay sensing */
			if (0 != randint0(20000L / (plev * plev + 40))) return;

			/* Done */
			break;
		}

		case CLASS_TOURIST:
		{
			/* Good sensing */
			if (0 != randint0(20000L / ((plev+50)*(plev+50)))) return;

			/* Heavy sensing */
			heavy = TRUE;

			/* Done */
			break;
		}

		case CLASS_BEASTMASTER:
		{
			/* Bad sensing */
			if (0 != randint0(65000L / (plev * plev + 40))) return;

			/* Done */
			break;
		}
		case CLASS_BERSERKER:
		{
			/* Heavy sensing */
			heavy = TRUE;

			/* Done */
			break;
		}
	}
#endif
	///del131221  virtue
	//if (compare_virtue(V_KNOWLEDGE, 100, VIRTUE_LARGE)) heavy = TRUE;

	/*** Sense everything ***/

	/* Check everything */
	for (i = 0; i < INVEN_TOTAL; i++)
	{
		bool okay = FALSE;

		o_ptr = &inventory[i];

		/* Skip empty slots */
		if (!o_ptr->k_idx) continue;

		/* Valid "tval" codes */
		switch (o_ptr->tval)
		{
			///mod131223 ȈՊӒ\ȕh
			case TV_BULLET:
			case TV_ARROW:
			case TV_BOLT:
			case TV_BOW:
			case TV_CROSSBOW:
			case TV_GUN:
			case TV_KNIFE:
			case TV_SWORD:
			case TV_KATANA:
			case TV_HAMMER:
			case TV_STICK:
			case TV_AXE:
			case TV_SPEAR:
			case TV_POLEARM:		
			case TV_OTHERWEAPON:	
			case TV_BOOTS:
			case TV_GLOVES:
			case TV_HEAD:
			case TV_SHIELD:
			case TV_CLOAK:
			case TV_CLOTHES:
			case TV_ARMOR:
			case TV_DRAG_ARMOR:
			{
				okay = TRUE;
				break;
			}
		}

		/* Skip non-sense machines */
		if (!okay) continue;

		/* Occasional failure on inventory items */
		if ((i < INVEN_RARM) && (0 != randint0(5))) continue;

		/* Good luck */
		if ((p_ptr->muta3 & MUT3_GOOD_LUCK) && !randint0(13))
		{
			heavy = TRUE;
		}

		sense_inventory_aux(i, heavy);
	}
}

/*:::ȈՊӒ菈*/
///class item TVAL ȈՊӒ
static void sense_inventory2(void)
{
	int         i;
	int         plev = p_ptr->lev;
	object_type *o_ptr;


	/*** Check for "sensing" ***/

	/* No sensing when confused */
	if (p_ptr->confused) return;



	///mod140202 ȈՊӒ\͂NXŒ̕ϐQƂɂ
	switch (cp_ptr->sense_mags)
	{
		case 1:
			return;
		case 2:
			if (0 != randint0(120000L / (plev * plev + 20))) return;
			break;
		case 3:
			if (0 != randint0(80000L / (plev * plev + 40))) return;
			break;
		case 4:
			if (0 != randint0(20000L / (plev * plev + 40))) return;
			break;
		case 5:
			if (0 != randint0(8000L / (plev * plev + 40))) return;
			break;
		default:
			msg_print("ERROR:player_class.sense_mags̐ݒl");
			return;
	}
#if 0

	/* Analyze the class */
	switch (p_ptr->pclass)
	{
		case CLASS_WARRIOR:
		case CLASS_ARCHER:
		case CLASS_SAMURAI:
		case CLASS_CAVALRY:
		case CLASS_BERSERKER:
		case CLASS_SNIPER:
		{
			return;
		}

		case CLASS_SMITH:
		case CLASS_PALADIN:
		case CLASS_CHAOS_WARRIOR:
		case CLASS_IMITATOR:
		case CLASS_BEASTMASTER:
		case CLASS_NINJA:
		{
			/* Very bad (light) sensing */
			if (0 != randint0(240000L / (plev + 5))) return;

			/* Done */
			break;
		}

		case CLASS_RANGER:
		case CLASS_WARRIOR_MAGE:
		case CLASS_RED_MAGE:
		case CLASS_MONK:
		{
			/* Bad sensing */
			if (0 != randint0(95000L / (plev * plev + 40))) return;

			/* Done */
			break;
		}

		case CLASS_PRIEST:
		case CLASS_BARD:
		case CLASS_ROGUE:
		case CLASS_FORCETRAINER:
		case CLASS_MINDCRAFTER:
		{
			/* Good sensing */
			if (0 != randint0(20000L / (plev * plev + 40))) return;

			/* Done */
			break;
		}

		case CLASS_MAGE:
		case CLASS_HIGH_MAGE:
		case CLASS_SORCERER:
		case CLASS_MAGIC_EATER:
		case CLASS_MIRROR_MASTER:
		case CLASS_BLUE_MAGE:
		{
			/* Good sensing */
			if (0 != randint0(9000L / (plev * plev + 40))) return;

			/* Done */
			break;
		}

		case CLASS_TOURIST:
		{
			/* Good sensing */
			if (0 != randint0(20000L / ((plev+50)*(plev+50)))) return;

			/* Done */
			break;
		}
	}
#endif
	/*** Sense everything ***/

	/* Check everything */
	for (i = 0; i < INVEN_TOTAL; i++)
	{
		bool okay = FALSE;

		o_ptr = &inventory[i];

		/* Skip empty slots */
		if (!o_ptr->k_idx) continue;

		/* Valid "tval" codes */
		///mod131223@ȈՊӒ\Ȗ@̃ACeƑ
		switch (o_ptr->tval)
		{

			case TV_MAGICITEM:
			case TV_MAGICWEAPON:
			case TV_RIBBON:
			case TV_RING:
			case TV_AMULET:
			case TV_LITE:
			case TV_WHISTLE:
			case TV_FIGURINE:
			{
				okay = TRUE;
				break;
			}
		}

		/* Skip non-sense machines */
		if (!okay) continue;

		/* Occasional failure on inventory items */
		if ((i < INVEN_RARM) && (0 != randint0(5))) continue;

		sense_inventory_aux(i, TRUE);
	}
}



/*
 * Go to any level (ripped off from wiz_jump)
 */
static void pattern_teleport(void)
{
	int min_level = 0;
	int max_level = 99;

	/* Ask for level */
#ifdef JP
	if (!EXTRA_MODE && get_check("̊KɃe|[g܂H"))
#else
	if (get_check("Teleport level? "))
#endif

	{
		char	ppp[80];
		char	tmp_val[160];

		/* Only downward in ironman mode */
		if (ironman_downward)
			min_level = dun_level;

		/* Maximum level */
		if (dungeon_type == DUNGEON_ANGBAND)
		{
			if (dun_level > 100)
				max_level = MAX_DEPTH - 1;
			else if (dun_level == 100)
				max_level = 100;
		}
		else
		{
			max_level = d_info[dungeon_type].maxdepth;
			min_level = d_info[dungeon_type].mindepth;
		}

		/* Prompt */
#ifdef JP
		sprintf(ppp, "e|[g:(%d-%d)", min_level, max_level);
#else
		sprintf(ppp, "Teleport to level (%d-%d): ", min_level, max_level);
#endif


		/* Default */
		sprintf(tmp_val, "%d", dun_level);

		/* Ask for a level */
		if (!get_string(ppp, tmp_val, 10)) return;

		/* Extract request */
		command_arg = atoi(tmp_val);
	}
#ifdef JP
	//else if (get_check("ʏe|[gH"))
	else if (get_check("̃tA̖]ޏꏊɓ]ڂ܂H"))
#else
	else if (get_check("Normal teleport? "))
#endif
	{
		dimension_door(D_DOOR_PATTERN);
		return;
	}
	else
	{
		return;
	}

	/* Paranoia */
	if (command_arg < min_level) command_arg = min_level;

	/* Paranoia */
	if (command_arg > max_level) command_arg = max_level;

	/* Accept request */
#ifdef JP
	msg_format("%d KɃe|[g܂B", command_arg);
#else
	msg_format("You teleport to dungeon level %d.", command_arg);
#endif


	if (autosave_l) do_cmd_save_game(TRUE);

	/* Change level */
	dun_level = command_arg;

	leave_quest_check();

	if (record_stair) do_cmd_write_nikki(NIKKI_PAT_TELE,0,NULL);

	p_ptr->inside_quest = 0;
	energy_use = 0;

	/*
	 * Clear all saved floors
	 * and create a first saved floor
	 */
	prepare_change_floor_mode(CFM_FIRST_FLOOR);

	/* Leaving */
	p_ptr->leaving = TRUE;
}


static void wreck_the_pattern(void)
{
	int to_ruin = 0, r_y, r_x;
	int pattern_type = f_info[cave[py][px].feat].subtype;

	if (pattern_type == PATTERN_TILE_WRECKED)
	{
		/* Ruined already */
		return;
	}

#ifdef JP
	msg_print("p^[ŉĂ܂I");
	msg_print("낵NI");
#else
	msg_print("You bleed on the Pattern!");
	msg_print("Something terrible happens!");
#endif

	if (!IS_INVULN())
#ifdef JP
		take_hit(DAMAGE_NOESCAPE, damroll(10, 8), "p^[", -1);
#else
		take_hit(DAMAGE_NOESCAPE, damroll(10, 8), "corrupting the Pattern", -1);
#endif

	to_ruin = randint1(45) + 35;

	while (to_ruin--)
	{
		scatter(&r_y, &r_x, py, px, 4, 0);

		if (pattern_tile(r_y, r_x) &&
		    (f_info[cave[r_y][r_x].feat].subtype != PATTERN_TILE_WRECKED))
		{
			cave_set_feat(r_y, r_x, feat_pattern_corrupted);
		}
	}

	cave_set_feat(py, px, feat_pattern_corrupted);
}


/* Returns TRUE if we are on the Pattern... */
static bool pattern_effect(void)
{
	int pattern_type;

	if (!pattern_tile(py, px)) return FALSE;
/*
	if ((prace_is_(RACE_AMBERITE)) &&
	    (p_ptr->cut > 0) && one_in_(10))
	{
		wreck_the_pattern();
	}
*/
	pattern_type = f_info[cave[py][px].feat].subtype;

	switch (pattern_type)
	{
	case PATTERN_TILE_END:
		(void)set_poisoned(0);
		(void)set_image(0);
		(void)set_stun(0);
		(void)set_cut(0);
		(void)set_blind(0);
		(void)set_afraid(0);
		(void)do_res_stat(A_STR);
		(void)do_res_stat(A_INT);
		(void)do_res_stat(A_WIS);
		(void)do_res_stat(A_DEX);
		(void)do_res_stat(A_CON);
		(void)do_res_stat(A_CHR);
		(void)restore_level();
		(void)hp_player(1000);

		cave_set_feat(py, px, feat_pattern_old);

#ifdef JP
		msg_print("up^[v̂͑̕̕苭͂łȂ悤B");
#else
		msg_print("This section of the Pattern looks less powerful.");
#endif

		/*
		 * We could make the healing effect of the
		 * Pattern center one-time only to avoid various kinds
		 * of abuse, like luring the win monster into fighting you
		 * in the middle of the pattern...
		 */
		break;

	case PATTERN_TILE_OLD:
		/* No effect */
		break;

	case PATTERN_TILE_TELEPORT:
		pattern_teleport();
		break;

	case PATTERN_TILE_WRECKED:
		if (!IS_INVULN())
#ifdef JP
			take_hit(DAMAGE_NOESCAPE, 200, "ꂽup^[v_[W", -1);
#else
			take_hit(DAMAGE_NOESCAPE, 200, "walking the corrupted Pattern", -1);
#endif
		break;

	default:
		//if (prace_is_(RACE_AMBERITE) && !one_in_(2))
		//	return TRUE;
		//else 
			if (!IS_INVULN())
#ifdef JP
			take_hit(DAMAGE_NOESCAPE, damroll(1, 3), "up^[v_[W", -1);
#else
			take_hit(DAMAGE_NOESCAPE, damroll(1, 3), "walking the Pattern", -1);
#endif
		break;
	}

	return TRUE;
}





/*
 * Regenerate hit points				-RAK-
 */
/*:::HP񕜁@ڍז*/
static void regenhp(int percent)
{
	s32b new_chp;
	u32b new_chp_frac;
	s32b old_chp;

	if (p_ptr->special_defense & KATA_KOUKIJIN) return;
	if (p_ptr->action == ACTION_HAYAGAKE) return;

	/* Save the old hitpoints */
	old_chp = p_ptr->chp;

	///mod140720 FƐnC*}*
	if(p_ptr->pclass == CLASS_YOSHIKA ||  (p_ptr->pclass == CLASS_HIGH_MAGE && p_ptr->realm1 == TV_BOOK_LIFE && p_ptr->lev > 39)) 
	{
		percent = percent * p_ptr->lev / 10;
	}


	//zKq~
	if (p_ptr->pclass == CLASS_SUWAKO && p_ptr->tim_general[0]) percent *= 10;

	if(p_ptr->pclass == CLASS_SUNNY && is_daytime()) percent *= 2;
	if(p_ptr->pclass == CLASS_LUNAR && !is_daytime()) percent *= 2;

	if(p_ptr->prace == RACE_HOURAI) percent = percent * 5 / 2;

	/*
	 * Extract the new hitpoints
	 *
	 * 'percent' is the Regen factor in unit (1/2^16)
	 */
	new_chp = 0;
	new_chp_frac = (p_ptr->mhp * percent + PY_REGEN_HPBASE);

	/* Convert the unit (1/2^16) to (1/2^32) */
	s64b_LSHIFT(new_chp, new_chp_frac, 16);

	/* Regenerating */
	s64b_add(&(p_ptr->chp), &(p_ptr->chp_frac), new_chp, new_chp_frac);


	/* Fully healed */
	if (0 < s64b_cmp(p_ptr->chp, p_ptr->chp_frac, p_ptr->mhp, 0))
	{
		p_ptr->chp = p_ptr->mhp;
		p_ptr->chp_frac = 0;
	}

	/* Notice changes */
	if (old_chp != p_ptr->chp)
	{
		/* Redraw */
		p_ptr->redraw |= (PR_HP);

		/* Window stuff */
		p_ptr->window |= (PW_PLAYER);

		wild_regen = 20;
	}
}


/*
 * Regenerate mana points
 */
/*:::MP񕜁A͒߃RXgɂ錸 upkeep_factor=ybgێȂǃRXg regen_amount=񕜊{l@ڍז*/
static void regenmana(int upkeep_factor, int regen_amount)
{
	s32b old_csp = p_ptr->csp;
	s32b regen_rate = regen_amount * 100 - upkeep_factor * PY_REGEN_NORMAL;

	/*
	 * Excess mana will decay 32 times faster than normal
	 * regeneration rate.
	 */
	if (p_ptr->csp > p_ptr->msp)
	{
		/* PY_REGEN_NORMAL is the Regen factor in unit (1/2^16) */
		s32b decay = 0;
		u32b decay_frac = (p_ptr->msp * 32 * PY_REGEN_NORMAL + PY_REGEN_MNBASE);

		///mod150419 iƂ̒MPʂ͂Ƒ
		if(p_ptr->pclass == CLASS_MARTIAL_ARTIST)
		{
			decay_frac *= 3;
			p_ptr->update |= (PU_BONUS);

		}
		/* Convert the unit (1/2^16) to (1/2^32) */
		s64b_LSHIFT(decay, decay_frac, 16);

		/* Decay */
		s64b_sub(&(p_ptr->csp), &(p_ptr->csp_frac), decay, decay_frac);

		/* Stop decaying */
		if (p_ptr->csp < p_ptr->msp)
		{
			p_ptr->csp = p_ptr->msp;
			p_ptr->csp_frac = 0;
		}
	}

	/* Regenerating mana (unless the player has excess mana) */
	else if (regen_rate > 0)
	{
		/* (percent/100) is the Regen factor in unit (1/2^16) */
		s32b new_mana = 0;
		u32b new_mana_frac = (p_ptr->msp * regen_rate / 100 + PY_REGEN_MNBASE);

		//p`[MP񕜑x
		if(p_ptr->pclass == CLASS_PATCHOULI)
		{
			new_mana_frac += new_mana_frac / 20 * p_ptr->lev ;
		}
		else if(p_ptr->prace == RACE_LUNARIAN)//̖MP񕜑x
		{
			new_mana_frac *= 2;
		}
		else if (p_ptr->pclass == CLASS_SUWAKO && p_ptr->tim_general[0]) 
		{
			new_mana_frac *= 10;
		}

		/* Convert the unit (1/2^16) to (1/2^32) */
		s64b_LSHIFT(new_mana, new_mana_frac, 16);

		/* Regenerate */
		s64b_add(&(p_ptr->csp), &(p_ptr->csp_frac), new_mana, new_mana_frac);

		/* Must set frac to zero even if equal */
		if (p_ptr->csp >= p_ptr->msp)
		{
			p_ptr->csp = p_ptr->msp;
			p_ptr->csp_frac = 0;
		}
	}


	/* Reduce mana (even when the player has excess mana) */
	if (regen_rate < 0)
	{
		/* PY_REGEN_NORMAL is the Regen factor in unit (1/2^16) */
		//s32b reduce_mana = 0;
		//u32b reduce_mana_frac = (p_ptr->msp * (-1) * regen_rate / 100 + PY_REGEN_MNBASE);
		/* Convert the unit (1/2^16) to (1/2^32) */
		//s64b_LSHIFT(reduce_mana, reduce_mana_frac, 16);

		//ybg߃RXg𗐖\ɕύX
		///mod141101 ߃RXgɘa
		//s32b reduce_mana = upkeep_factor / 10;
		s32b reduce_mana = 0 - regen_rate / PY_REGEN_NORMAL / 3;
		u32b reduce_mana_frac = 0;
		if(reduce_mana < 0) reduce_mana = 0;



		/* Reduce mana */
		s64b_sub(&(p_ptr->csp), &(p_ptr->csp_frac), reduce_mana, reduce_mana_frac);

		/* Check overflow */
		if (p_ptr->csp < 0)
		{
			p_ptr->csp = 0;
			p_ptr->csp_frac = 0;
		}
	}


	/* Redraw mana */
	if (old_csp != p_ptr->csp)
	{
		/* Redraw */
		p_ptr->redraw |= (PR_MANA);

		/* Window stuff */
		p_ptr->window |= (PW_PLAYER);
		p_ptr->window |= (PW_SPELL);

		wild_regen = 20;
	}
}



/*
 * Regenerate magic
 * regen_amount: PY_REGEN_NORMAL * 2 (if resting) * 2 (if having regenarate)
 */
static void regenmagic(int regen_amount)
{
	s32b new_mana;
	int i;
	int dev = 30;
	int mult = (dev + adj_mag_mana[p_ptr->stat_ind[A_INT]]); /* x1 to x2 speed bonus for recharging */

	if(p_ptr->pclass != CLASS_SEIJA) //ׂ̂Ƃ͏Ɩ@_񕜂Ȃ
	{
		for (i = 0; i < EATER_EXT*2; i++)
		{
			if (!p_ptr->magic_num2[i]) continue;
			if (p_ptr->magic_num1[i] == ((long)p_ptr->magic_num2[i] << 16)) continue;

			/* Increase remaining charge number like float value */
			new_mana = (regen_amount * mult * ((long)p_ptr->magic_num2[i] + 13)) / (dev * 8);
			p_ptr->magic_num1[i] += new_mana;

			/* Check maximum charge */
			if (p_ptr->magic_num1[i] > (p_ptr->magic_num2[i] << 16))
			{
				p_ptr->magic_num1[i] = ((long)p_ptr->magic_num2[i] << 16);
			}
			wild_regen = 20;
		}
	}
	for (i = EATER_EXT*2; i < EATER_EXT*3; i++)
	{
		if (!p_ptr->magic_num1[i]) continue;
		if (!p_ptr->magic_num2[i]) continue;

		/* Decrease remaining period for charging */
		new_mana = (regen_amount * mult * ((long)p_ptr->magic_num2[i] + 10) * EATER_ROD_CHARGE) 
					/ (dev * 16 * PY_REGEN_NORMAL); 
		p_ptr->magic_num1[i] -= new_mana;

		/* Check minimum remaining period for charging */
		if (p_ptr->magic_num1[i] < 0) p_ptr->magic_num1[i] = 0;
		wild_regen = 20;
	}
}






/*
 * Regenerate the monsters (once per 100 game turns)
 *
 * XXX XXX XXX Should probably be done during monster turns.
 */
/*:::X^[SĂ̎R process_world()Ă΂*/
///system X^[R񕜁@[h͂Ɖ񕜑x𑁂Ă
static void regen_monsters(void)
{
	int i, frac;


	/* Regenerate everyone */
	for (i = 1; i < m_max; i++)
	{
		/* Check the i'th monster */
		monster_type *m_ptr = &m_list[i];
		monster_race *r_ptr = &r_info[m_ptr->r_idx];


		/* Skip dead monsters */
		if (!m_ptr->r_idx) continue;

		/* Allow regeneration (if needed) */
		if (m_ptr->hp < m_ptr->maxhp)
		{
			/* Hack -- Base regeneration */
			frac = m_ptr->maxhp / 100;

			/* Hack -- Minimal regeneration rate */
			if (!frac) if (one_in_(2)) frac = 1;

			/* Hack -- Some monsters regenerate quickly */
			if (r_ptr->flags2 & RF2_REGENERATE) frac *= 2;

			//v1.1.41 R@񕜑x
			if (p_ptr->pclass == CLASS_MAI && i == p_ptr->riding)
			{
				int chr = p_ptr->stat_ind[A_CHR] + 3;
				frac += MAX(0, frac * (chr - 5) / 15);
			}

			/* Hack -- Regenerate */
			m_ptr->hp += frac;

			/* Do not over-regenerate */
			if (m_ptr->hp > m_ptr->maxhp) m_ptr->hp = m_ptr->maxhp;

			/* Redraw (later) if needed */
			if (p_ptr->health_who == i) p_ptr->redraw |= (PR_HEALTH);
			if (p_ptr->riding == i) p_ptr->redraw |= (PR_UHEALTH);
		}
	}
}


/*
 * Regenerate the captured monsters (once per 30 game turns)
 *
 * XXX XXX XXX Should probably be done during monster turns.
 */
/*:::uLĂvX^[{[̒̃X^[HP񕜂BƂ⏰̃{[̒̃X^[͉񕜂ȂB*/
static void regen_captured_monsters(void)
{
	int i, frac;
	bool heal = FALSE;

	/* Regenerate everyone */
	for (i = 0; i < INVEN_TOTAL; i++)
	{
		monster_race *r_ptr;
		object_type *o_ptr = &inventory[i];

		if (!o_ptr->k_idx) continue;
		if (o_ptr->tval != TV_CAPTURE) continue;
		if (!o_ptr->pval) continue;

		heal = TRUE;

		r_ptr = &r_info[o_ptr->pval];

		/* Allow regeneration (if needed) */
		if (o_ptr->xtra4 < o_ptr->xtra5)
		{
			/* Hack -- Base regeneration */
			frac = o_ptr->xtra5 / 100;

			/* Hack -- Minimal regeneration rate */
			if (!frac) if (one_in_(2)) frac = 1;

			/* Hack -- Some monsters regenerate quickly */
			if (r_ptr->flags2 & RF2_REGENERATE) frac *= 2;

			/* Hack -- Regenerate */
			o_ptr->xtra4 += frac;

			/* Do not over-regenerate */
			if (o_ptr->xtra4 > o_ptr->xtra5) o_ptr->xtra4 = o_ptr->xtra5;
		}
	}

	if (heal)
	{
		/* Combine pack */
		p_ptr->notice |= (PN_COMBINE);

		/* Window stuff */
		p_ptr->window |= (PW_INVEN);
		p_ptr->window |= (PW_EQUIP);
		wild_regen = 20;
	}
}

/*:::肪Ȏ̃bZ[W*/
static void notice_lite_change(object_type *o_ptr)
{
	/* Hack -- notice interesting fuel steps */
	if ((o_ptr->xtra4 < 100) || (!(o_ptr->xtra4 % 100)))
	{
		/* Window stuff */
		p_ptr->window |= (PW_EQUIP);
	}

	/* Hack -- Special treatment when blind */
	if (p_ptr->blind)
	{
		/* Hack -- save some light for later */
		if (o_ptr->xtra4 == 0) o_ptr->xtra4++;
	}

	/* The light is now out */
	else if (o_ptr->xtra4 == 0)
	{
		disturb(0, 1);
#ifdef JP
msg_print("肪Ă܂I");
#else
		msg_print("Your light has gone out!");
#endif

		/* Recalculate torch radius */
		p_ptr->update |= (PU_TORCH);

		/* Some ego light lose its effects without fuel */
		p_ptr->update |= (PU_BONUS);
	}

	/* The light is getting dim */
	else if (o_ptr->name2 == EGO_LITE_LONG)
	{
		if ((o_ptr->xtra4 < 50) && (!(o_ptr->xtra4 % 5))
		    && (turn % (TURNS_PER_TICK*2)))
		{
			if (disturb_minor) disturb(0, 1);
#ifdef JP
msg_print("肪ɂȂĂĂB");
#else
			msg_print("Your light is growing faint.");
#endif

		}
	}

	/* The light is getting dim */
	else if ((o_ptr->xtra4 < 100) && (!(o_ptr->xtra4 % 10)))
	{
		if (disturb_minor) disturb(0, 1);
#ifdef JP
msg_print("肪ɂȂĂĂB");
#else
		msg_print("Your light is growing faint.");
#endif

	}
}

/*:::NGXg̏IԂ`FbNHڍז*/
///quest
void leave_quest_check(void)
{
	/* Save quest number for dungeon pref file ($LEAVING_QUEST) */
	leaving_quest = p_ptr->inside_quest;

	/* Leaving an 'only once' quest marks it as failed */
	if (leaving_quest &&
	    ((quest[leaving_quest].flags & QUEST_FLAG_ONCE)  || (quest[leaving_quest].type == QUEST_TYPE_RANDOM)) &&
	    (quest[leaving_quest].status == QUEST_STATUS_TAKEN))
	{
		quest[leaving_quest].status = QUEST_STATUS_FAILED;
		quest[leaving_quest].complev = (byte)p_ptr->lev;

		/* Additional settings */
		switch (quest[leaving_quest].type)
		{
		case QUEST_TYPE_TOWER:
			quest[QUEST_TOWER1].status = QUEST_STATUS_FAILED;
			quest[QUEST_TOWER1].complev = (byte)p_ptr->lev;
			break;
		case QUEST_TYPE_FIND_ARTIFACT:
			a_info[quest[leaving_quest].k_idx].gen_flags &= ~(TRG_QUESTITEM);
			break;
		case QUEST_TYPE_RANDOM:
			r_info[quest[leaving_quest].r_idx].flags1 &= ~(RF1_QUESTOR);

			/* Floor of random quest will be blocked */
			prepare_change_floor_mode(CFM_NO_RETURN);
			break;
		}

		/* Record finishing a quest */
		if (quest[leaving_quest].type == QUEST_TYPE_RANDOM)
		{
			if (record_rand_quest) do_cmd_write_nikki(NIKKI_RAND_QUEST_F, leaving_quest, NULL);
		}
		else
		{
			if (record_fix_quest) do_cmd_write_nikki(NIKKI_FIX_QUEST_F, leaving_quest, NULL);
		}
	}
	//ꏈ@̌sۓWƃ}RNG͊KioƒBI
	else if(leaving_quest == QUEST_MOON_VAULT && quest[leaving_quest].status == QUEST_STATUS_COMPLETED)
	{
		quest[QUEST_MOON_VAULT].status = QUEST_STATUS_FINISHED;
	}
	else if(leaving_quest == QUEST_MARICON && quest[leaving_quest].status == QUEST_STATUS_COMPLETED)
	{
		quest[QUEST_MARICON].status = QUEST_STATUS_FINISHED;
	}
	else if(leaving_quest)
	{
		quest[leaving_quest].flags |= QUEST_FLAG_RETRY;
	}


}

/*:::oƂ̏*/
void leave_tower_check(void)
{
	leaving_quest = p_ptr->inside_quest;
	/* Check for Tower Quest */
	if (leaving_quest &&
		(quest[leaving_quest].type == QUEST_TYPE_TOWER) &&
		(quest[QUEST_TOWER1].status != QUEST_STATUS_COMPLETED))
	{
		if(quest[leaving_quest].type == QUEST_TYPE_TOWER)
		{
			quest[QUEST_TOWER1].status = QUEST_STATUS_FAILED;
			quest[QUEST_TOWER1].complev = (byte)p_ptr->lev;
		}
	}
}


/*
 * Forcibly pseudo-identify an object in the inventory
 * (or on the floor)
 *
 * note: currently this function allows pseudo-id of any object,
 * including silly ones like potions & scrolls, which always
 * get '{average}'. This should be changed, either to stop such
 * items from being pseudo-id'd, or to allow psychometry to
 * detect whether the unidentified potion/scroll/etc is
 * good (Cure Light Wounds, Restore Strength, etc) or
 * bad (Poison, Weakness etc) or 'useless' (Slime Mold Juice, etc).
 */
/*:::TCRg[*/
bool psychometry(void)
{
	int             item;
	object_type     *o_ptr;
	char            o_name[MAX_NLEN];
	byte            feel;
	cptr            q, s;
	bool okay = FALSE;

	item_tester_no_ryoute = TRUE;
	/* Get an item */
#ifdef JP
q = "ǂ̃ACe𒲂ׂ܂H";
s = "ׂACe܂B";
#else
	q = "Meditate on which item? ";
	s = "You have nothing appropriate.";
#endif

	if (!get_item(&item, q, s, (USE_EQUIP | USE_INVEN | USE_FLOOR))) return (FALSE);

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}

	/* It is fully known, no information needed */
	if (object_is_known(o_ptr))
	{
#ifdef JP
msg_print("VƂ͔ȂB");
#else
		msg_print("You cannot find out anything more about that.");
#endif

		return TRUE;
	}

	/* Check for a feeling */
	feel = value_check_aux1(o_ptr);

	/* Get an object description */
	object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

	/* Skip non-feelings */
	if (!feel)
	{
#ifdef JP
msg_format("%s͓ɕς͊ƂȂB", o_name);
#else
		msg_format("You do not perceive anything unusual about the %s.", o_name);
#endif

		return TRUE;
	}

#ifdef JP
msg_format("%s%sƂ...",
    o_name,  game_inscriptions[feel]);
#else
	msg_format("You feel that the %s %s %s...",
			   o_name, ((o_ptr->number == 1) ? "is" : "are"),
			   game_inscriptions[feel]);
#endif


	/* We have "felt" it */
	o_ptr->ident |= (IDENT_SENSE);

	/* "Inscribe" it */
	o_ptr->feeling = feel;

	/* Player touches it */
	o_ptr->marked |= OM_TOUCHED;

	/* Combine / Reorder the pack (later) */
	p_ptr->notice |= (PN_COMBINE | PN_REORDER);

	/* Window stuff */
	p_ptr->window |= (PW_INVEN | PW_EQUIP | PW_PLAYER);

	/* Valid "tval" codes */
	///item TVAL TCRg[̂Ƃ̎j\tOH
	///mod131223 tval
	switch (o_ptr->tval)
	{
	case TV_BULLET:
	case TV_ARROW:
	case TV_BOLT:
	case TV_BOW:
	case TV_CROSSBOW:
	case TV_GUN:
	case TV_MAGICITEM:
	case TV_MAGICWEAPON:
	case TV_OTHERWEAPON:
	case TV_KNIFE:
	case TV_SWORD:
	case TV_KATANA:
	case TV_HAMMER:
	case TV_STICK:
	case TV_AXE:
	case TV_SPEAR:
	case TV_POLEARM:		
	case TV_BOOTS:
	case TV_GLOVES:
	case TV_HEAD:
	case TV_SHIELD:
	case TV_CLOAK:
	case TV_CLOTHES:
	case TV_ARMOR:
	case TV_DRAG_ARMOR:
	case TV_RING:
	case TV_RIBBON:
	case TV_AMULET:
	case TV_LITE:
	case TV_FIGURINE:
	case TV_WHISTLE:
		okay = TRUE;
		break;
	}

	/* Auto-inscription/destroy */
	autopick_alter_item(item, (bool)(okay && destroy_feeling));

	/* Something happened */
	return (TRUE);
}


/*
 * If player has inscribed the object with "!!", let him know when it's
 * recharged. -LM-
 */
/*:::!!ɂď[Uʒm*/
static void recharged_notice(object_type *o_ptr)
{
	char o_name[MAX_NLEN];

	cptr s;

	if (o_ptr->name1 == ART_CLOWNPIECE)
	{
		msg_print("ɍĂщ΂B");
		p_ptr->update |= PU_TORCH;
		return;
	}

	/* No inscription */
	if (!o_ptr->inscription) return;

	/* Find a '!' */
	s = my_strchr(quark_str(o_ptr->inscription), '!');

	/* Process notification request. */
	while (s)
	{
		/* Find another '!' */
		if (s[1] == '!')
		{
			/* Describe (briefly) */
			object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

			/* Notify the player */
			if(o_ptr->name1 == ART_YAKUZAGUN_1 || o_ptr->name1 == ART_YAKUZAGUN_2)
				msg_format("%suUhXGv", o_name);
			else if(o_ptr->tval == TV_GUN && o_ptr->sval != SV_FIRE_GUN_LASER && o_ptr->sval != SV_FIRE_GUN_LUNATIC)
				msg_format("%s͍đUꂽB", o_name);
			else
				msg_format("%s͍ď[UꂽB", o_name);

			disturb(0, 0);

			/* Done. */
			return;
		}

		/* Keep looking for '!'s */
		s = my_strchr(s + 1, '!');
	}
}

/*:::process_upkeep_with_speed()Ă΂B̂̌ʔ*/
///mod140817 ̊֌WɋVlȊO̐E֏
static void check_music(void)
{
	const magic_type *s_ptr;
	int spell;
	s32b need_mana;
	u32b need_mana_frac;

	/* Music singed by player */
	//if (p_ptr->pclass != CLASS_BARD) return;
	if (!(CHECK_MUSIC_CLASS)) return;

	if (!p_ptr->magic_num1[0] && !p_ptr->magic_num1[1]) return;
	if (p_ptr->anti_magic)
	{
		stop_singing();
		stop_tsukumo_music();
		return;
	}

	spell = p_ptr->magic_num2[0];
	if(p_ptr->pclass == CLASS_BARD)
	{
		msg_print("ERROR:Vl͖̉̂");
		return;
		//s_ptr = &technic_info[REALM_MUSIC - MIN_TECHNIC][spell];
		//need_mana = mod_need_mana(s_ptr->smana, spell, REALM_MUSIC);
	}
	else if(p_ptr->pclass == CLASS_MYSTIA)
	{
		switch(spell)
		{
		case MUSIC_NEW_MYSTIA_YAZYAKU: //~XeBA@鐝̉
			need_mana = 8; break;
		case MUSIC_NEW_MYSTIA_MYSTERIOUS: //~XeBA@~XeAX\O
			need_mana = 24; break;
		case MUSIC_NEW_MYSTIA_CHORUSMASTER: //~XeBA@^钆̃R[X}X^[
			need_mana = 36; break;
		case MUSIC_NEW_MYSTIA_HUMAN_CAGE: //v1.1.47 ~XeBA@q[}P[W
			need_mana = 30; break;

		default:
			msg_format("ERROR:̐EƂ̉yidx(%d)̌pRXgcheck_music()ɓo^ĂȂ",spell);
			return;

		}
	}
	else if(p_ptr->pclass == CLASS_KYOUKO)
	{
		switch(spell)
		{
		case MUSIC_NEW_KYOUKO_NENBUTSU: //q@O
			need_mana = 24; break;
		case MUSIC_NEW_KYOUKO_SCREAM: //q@vC}XN[
			need_mana = 36; break;

		default:
			msg_format("ERROR:̐EƂ̉yidx(%d)̌pRXgcheck_music()ɓo^ĂȂ",spell);
			return;

		}
	}
	//Oo1ÂȂ̂ŉ
	else if(p_ptr->pclass == CLASS_LUNASA) need_mana = 24;
	else if(p_ptr->pclass == CLASS_MERLIN) need_mana = 36;
	else if(p_ptr->pclass == CLASS_LYRICA) need_mana = 8;
	else if(p_ptr->pclass == CLASS_BENBEN || p_ptr->pclass == CLASS_YATSUHASHI)
	{
		switch(spell)
		{
		case MUSIC_NEW_TSUKUMO_HEIKE: //uƂ̑剅v
			need_mana = 9; break;
		case MUSIC_NEW_TSUKUMO_STORM: //̃ATu
			need_mana = 24; break;
		case MUSIC_NEW_TSUKUMO_DOUBLESCORE: //_uXRA
			need_mana = 48; break;
		case MUSIC_NEW_TSUKUMO_SCOREWEB: //XRAEFu
			need_mana = 36; break;
		case MUSIC_NEW_TSUKUMO_NORIGOTO: //Vً̏
			need_mana = 12; break;
		case MUSIC_NEW_TSUKUMO_JINKIN: //lՂƂɖS
			need_mana = 24; break;
		case MUSIC_NEW_TSUKUMO_ECHO: //GR[`Fo[
			need_mana = 32; break;
		case MUSIC_NEW_TSUKUMO_ECHO2: //̎c
			need_mana = 8; break;

		default:
			msg_format("ERROR:̐EƂ̉yidx(%d)̌pRXgcheck_music()ɓo^ĂȂ",spell);
			return;
		}
	}
	else if(p_ptr->pclass == CLASS_RAIKO)
	{
		switch(spell)
		{
		case MUSIC_NEW_RAIKO_AYANOTUDUMI: //Amcd~
			need_mana = 6; break;
		case MUSIC_NEW_RAIKO_DENDEN: //{̃ff
			need_mana = 32; break;
		case MUSIC_NEW_RAIKO_PRISTINE: //vXeBr[g
			need_mana = 48; break;

		default:
			msg_format("ERROR:̐EƂ̉yidx(%d)̌pRXgcheck_music()ɓo^ĂȂ",spell);
			return;

		}
	}
	else
	{
		msg_print("ERROR:̐EƂ̉̌pcheck_music()ɓo^ĂȂ");
		return;
	}

	need_mana_frac = 0;

	/* Divide by 2 */
	s64b_RSHIFT(need_mana, need_mana_frac, 1);

	if (s64b_cmp(p_ptr->csp, p_ptr->csp_frac, need_mana, need_mana_frac) < 0)
	{
		stop_singing();
		stop_tsukumo_music();
		stop_raiko_music();

		return;
	}
	else
	{
		s64b_sub(&(p_ptr->csp), &(p_ptr->csp_frac), need_mana, need_mana_frac);

		p_ptr->redraw |= PR_MANA;
		if (p_ptr->magic_num1[1])
		{
			p_ptr->magic_num1[0] = p_ptr->magic_num1[1];
			p_ptr->magic_num1[1] = 0;
#ifdef JP
			msg_print("̂ĊJB");
#else
			msg_print("You restart singing.");
#endif
			p_ptr->action = ACTION_SING;

			/* Recalculate bonuses */
			p_ptr->update |= (PU_BONUS | PU_HP);

			/* Redraw map and status bar */
			p_ptr->redraw |= (PR_MAP | PR_STATUS | PR_STATE);

			/* Update monsters */
			p_ptr->update |= (PU_MONSTERS);

			/* Window stuff */
			p_ptr->window |= (PW_OVERHEAD | PW_DUNGEON);
		}
	}
	if(p_ptr->pclass == CLASS_BARD)
	{
		/*
		if (p_ptr->spell_exp[spell] < SPELL_EXP_BEGINNER) p_ptr->spell_exp[spell] += 5;
		else if(p_ptr->spell_exp[spell] < SPELL_EXP_SKILLED)	{ if (one_in_(2) && (dun_level > 4) && ((dun_level + 10) > p_ptr->lev)) p_ptr->spell_exp[spell] += 1; }
		else if(p_ptr->spell_exp[spell] < SPELL_EXP_EXPERT)	{ if (one_in_(5) && ((dun_level + 5) > p_ptr->lev) && ((dun_level + 5) > s_ptr->slevel)) p_ptr->spell_exp[spell] += 1; }
		else if(p_ptr->spell_exp[spell] < SPELL_EXP_MASTER)	{ if (one_in_(5) && ((dun_level + 5) > p_ptr->lev) && (dun_level > s_ptr->slevel)) p_ptr->spell_exp[spell] += 1; }
		*/
	}
	/* Do any effects of continual song */
	//do_spell(REALM_MUSIC, spell, SPELL_CONT);
	do_spell(TV_BOOK_MUSIC, spell, SPELL_CONT);

}


/* Choose one of items that have cursed flag */
static object_type *choose_cursed_obj_name(u32b flag)
{
	int i;
	int choices[INVEN_TOTAL-INVEN_RARM];
	int number = 0;

	/* Paranoia -- Player has no warning-item */
	if (!(p_ptr->cursed & flag)) return NULL;

	/* Search Inventry */
	for (i = INVEN_RARM; i < INVEN_TOTAL; i++)
	{
		object_type *o_ptr = &inventory[i];

		if(check_invalidate_inventory(i)) continue;

		if (o_ptr->curse_flags & flag)
		{
			choices[number] = i;
			number++;
		}
		else if ((flag == TRC_ADD_L_CURSE) || (flag == TRC_ADD_H_CURSE))
		{
			u32b cf = (flag == TRC_ADD_L_CURSE) ? TR_ADD_L_CURSE : TR_ADD_H_CURSE;
			u32b flgs[4];
			object_flags(o_ptr, flgs);
			if (have_flag(flgs, cf))
			{
				choices[number] = i;
				number++;
			}
		}
	}

	/* Choice one of them */
	return (&inventory[choices[randint0(number)]]);
}


/*
 * Handle timed damage and regeneration every 10 game turns
 */
/*:::ւ̃^[_[WƍĐ*/
static void process_world_aux_hp_and_sp(void)
{
	feature_type *f_ptr = &f_info[cave[py][px].feat];
	bool cave_no_regen = FALSE;
	int upkeep_factor = 0;

	/* Default regeneration */
	int regen_amount = PY_REGEN_NORMAL;


	/*** Damage over Time ***/


	if(p_ptr->pclass == CLASS_HINA && p_ptr->magic_num1[0] > HINA_YAKU_LIMIT3 && one_in_(6) && !IS_INVULN())
	{
		take_hit(DAMAGE_NOESCAPE, 1, "̕S", -1);
	}


	/* Take damage from poison */
	if (p_ptr->poisoned && !IS_INVULN())
	{
		/* Take damage */
#ifdef JP
		take_hit(DAMAGE_NOESCAPE, 1, "", -1);
#else
		take_hit(DAMAGE_NOESCAPE, 1, "poison", -1);
#endif

	}
	///sys ̃_[WŃbZ[Woɂ͂ҏW
	/* Take damage from cuts */
	if (p_ptr->cut && !IS_INVULN())
	{
		int dam;

		/* Mortal wound or Deep Gash */
		if (p_ptr->cut > 1000)
		{
			dam = 200;
		}

		else if (p_ptr->cut > 200)
		{
			dam = 80;
		}

		/* Severe cut */
		else if (p_ptr->cut > 100)
		{
			dam = 32;
		}

		else if (p_ptr->cut > 50)
		{
			dam = 16;
		}

		else if (p_ptr->cut > 25)
		{
			dam = 7;
		}

		else if (p_ptr->cut > 10)
		{
			dam = 3;
		}

		/* Other cuts */
		else
		{
			dam = 1;
		}

		if(p_ptr->pclass == CLASS_HINA)
		{
			hina_gain_yaku(-dam);
		}
		else
		{
			/* Take damage */
			///msg131221
			take_hit(DAMAGE_NOESCAPE, dam, "̒ɂ", -1);
		}


	}


	/* (Vampires) Take damage from sunlight */
	///sysdel131221 zS̗z_[W𖳂ɂ
#if 0
	if (prace_is_(RACE_VAMPIRE) || (p_ptr->mimic_form == MIMIC_VAMPIRE))
	{
		if (!dun_level && !p_ptr->resist_lite && !IS_INVULN() && is_daytime())
		{
			if ((cave[py][px].info & (CAVE_GLOW | CAVE_MNDK)) == CAVE_GLOW)
			{
				/* Take damage */
#ifdef JP
msg_print("Ȃ̃Afbh̓̂ĂłI");
take_hit(DAMAGE_NOESCAPE, 1, "", -1);
#else
				msg_print("The sun's rays scorch your undead flesh!");
				take_hit(DAMAGE_NOESCAPE, 1, "sunlight", -1);
#endif

				cave_no_regen = TRUE;
			}
		}

		if (inventory[INVEN_LITE].tval && (inventory[INVEN_LITE].name2 != EGO_LITE_DARKNESS) &&
		    !p_ptr->resist_lite)
		{
			object_type * o_ptr = &inventory[INVEN_LITE];
			char o_name [MAX_NLEN];
			char ouch [MAX_NLEN+40];

			/* Get an object description */
			object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

#ifdef JP
msg_format("%sȂ̃Afbh̓̂ĂłI", o_name);
#else
			msg_format("The %s scorches your undead flesh!", o_name);
#endif


			cave_no_regen = TRUE;

			/* Get an object description */
			object_desc(o_name, o_ptr, OD_NAME_ONLY);

#ifdef JP
sprintf(ouch, "%s𑕔_[W", o_name);
#else
			sprintf(ouch, "wielding %s", o_name);
#endif

			if (!IS_INVULN()) take_hit(DAMAGE_NOESCAPE, 1, ouch, -1);
		}
	}
#endif
	///sys n_[W@bZ[W悤H
	if (have_flag(f_ptr->flags, FF_LAVA) && !IS_INVULN() && !p_ptr->immune_fire)
	{
		int damage = 0;

		if (have_flag(f_ptr->flags, FF_DEEP))
		{
			damage = 6000 + randint0(4000);
		}
		else if (!p_ptr->levitation)
		{
			damage = 3000 + randint0(2000);
		}

		if(CHECK_FAIRY_TYPE == 5) damage = 0;
		else if(p_ptr->pclass == CLASS_SUWAKO) damage = 0;
		else if(p_ptr->pclass == CLASS_FUTO && p_ptr->lev > 29) damage = 0;
		else if(SAKUYA_WORLD) damage = 0;


		if (damage)
		{
			///race@n_[W
			/*
			if (prace_is_(RACE_ENT)) damage += damage / 3;
			if (p_ptr->resist_fire) damage = damage / 3;
			if (IS_OPPOSE_FIRE()) damage = damage / 3;
			*/
			///mod140302 f_Aϐ
			damage = mod_fire_dam(damage);

			if (p_ptr->levitation) damage = damage / 5;

			damage = damage / 100 + (randint0(100) < (damage % 100));

			if (p_ptr->levitation)
			{
#ifdef JP
				msg_print("MŉΏI");
				take_hit(DAMAGE_NOESCAPE, damage, format("%s̏ɕV_[W", f_name + f_info[get_feat_mimic(&cave[py][px])].name), -1);
#else
				msg_print("The heat burns you!");
				take_hit(DAMAGE_NOESCAPE, damage, format("flying over %s", f_name + f_info[get_feat_mimic(&cave[py][px])].name), -1);
#endif
			}
			else
			{
				cptr name = f_name + f_info[get_feat_mimic(&cave[py][px])].name;
#ifdef JP
				msg_format("%sŉΏI", name);
#else
				msg_format("The %s burns you!", name);
#endif
				take_hit(DAMAGE_NOESCAPE, damage, name, -1);
			}
			///mod140719 
			if(p_ptr->wild_mode)
			{
				/*:::-Hack- S̃}bvړenergy_use{ɂȂĂėnn`ɓuԉxHĎɂ˂sRȂ̂ŒĂ*/
				energy_use = MIN(energy_use,100);
				change_wild_mode();
			}
			cave_no_regen = TRUE;
		}
	}

	if(p_ptr->drowning)
	{
		int dam;
		if(prace_is_(RACE_VAMPIRE)) dam = 30 + randint1(20);
		else dam = randint1(20);

		take_hit(DAMAGE_NOESCAPE, dam, "M", -1);
		cave_no_regen = TRUE;
	}

#if 0
	if (have_flag(f_ptr->flags, FF_WATER) && have_flag(f_ptr->flags, FF_DEEP) &&
	    !p_ptr->levitation && !p_ptr->can_swim)
	{
		if (p_ptr->total_weight > weight_limit())
		{
			/* Take damage */
#ifdef JP

			//msg_print("MĂI");
			take_hit(DAMAGE_NOESCAPE, randint1(p_ptr->lev), "M", -1);
#else
			msg_print("You are drowning!");
			take_hit(DAMAGE_NOESCAPE, randint1(p_ptr->lev), "drowning", -1);
#endif

			cave_no_regen = TRUE;
		}
	}
#endif
	if (p_ptr->riding)
	{
		int damage;
		if ((r_info[m_list[p_ptr->riding].r_idx].flags2 & RF2_AURA_FIRE) && !p_ptr->immune_fire)
		{
			damage = r_info[m_list[p_ptr->riding].r_idx].level / 2;
			/*
			if (prace_is_(RACE_ENT)) damage += damage / 3;
			if (p_ptr->resist_fire) damage = damage / 3;
			if (IS_OPPOSE_FIRE()) damage = damage / 3;
			*/
			///mod140302 f_Aϐ
			damage = mod_fire_dam(damage);

			if (CLASS_RIDING_BACKDANCE) damage /= 3;

	#ifdef JP
msg_print("MI");
take_hit(DAMAGE_NOESCAPE, damage, "̃I[", -1);
#else
			msg_print("It's hot!");
			take_hit(DAMAGE_NOESCAPE, damage, "Fire aura", -1);
#endif
		}
		if ((r_info[m_list[p_ptr->riding].r_idx].flags2 & RF2_AURA_ELEC) && !p_ptr->immune_elec)
		{
			damage = r_info[m_list[p_ptr->riding].r_idx].level / 2;
			/*
			if (prace_is_(RACE_KAPPA)) damage += damage / 3;
			if (p_ptr->resist_elec) damage = damage / 3;
			if (IS_OPPOSE_ELEC()) damage = damage / 3;
			*/
			///mod140302 f_Aϐ
			damage = mod_elec_dam(damage);

			if (CLASS_RIDING_BACKDANCE) damage /= 3;

#ifdef JP
msg_print("ɂI");
take_hit(DAMAGE_NOESCAPE, damage, "dC̃I[", -1);
#else
			msg_print("It hurts!");
			take_hit(DAMAGE_NOESCAPE, damage, "Elec aura", -1);
#endif
		}

///mod131231 X^[tOύX
//		if ((r_info[m_list[p_ptr->riding].r_idx].flags3 & RF3_AURA_COLD) && !p_ptr->immune_cold)
		if ((r_info[m_list[p_ptr->riding].r_idx].flags2 & RF2_AURA_COLD) && !p_ptr->immune_cold)
		{
			damage = r_info[m_list[p_ptr->riding].r_idx].level / 2;
			/*
			if (p_ptr->resist_cold) damage = damage / 3;
			if (IS_OPPOSE_COLD()) damage = damage / 3;
			*/
			///mod140302 f_Aϐ
			damage = mod_cold_dam(damage);

			if (CLASS_RIDING_BACKDANCE) damage /= 3;

#ifdef JP
msg_print("₽I");
take_hit(DAMAGE_NOESCAPE, damage, "C̃I[", -1);
#else
			msg_print("It's cold!");
			take_hit(DAMAGE_NOESCAPE, damage, "Cold aura", -1);
#endif
		}
	}

	/* Spectres -- take damage when moving through walls */
	/*
	 * Added: ANYBODY takes damage if inside through walls
	 * without wraith form -- NOTE: Spectres will never be
	 * reduced below 0 hp by being inside a stone wall; others
	 * WILL BE!
	 */
	if (!have_flag(f_ptr->flags, FF_MOVE) && !have_flag(f_ptr->flags, FF_CAN_FLY))
	{
		if (!IS_INVULN() && !p_ptr->wraith_form && !p_ptr->kabenuke 
			&& CHECK_FAIRY_TYPE != 41
			&& !(IS_METAMORPHOSIS && (r_info[MON_EXTRA_FIELD].flags2 & RF2_PASS_WALL))
			&& !((p_ptr->pclass == CLASS_SEIGA) && (p_ptr->lev > 39))
			&& !((p_ptr->pclass == CLASS_YUKARI) && (p_ptr->lev > 39))
		    && ((p_ptr->chp > (p_ptr->lev / 5)) || !p_ptr->pass_wall))
		{
			cptr dam_desc;

			cave_no_regen = TRUE;


			if (p_ptr->pass_wall)
			{
#ifdef JP
				msg_print("̂̕qCI");
				dam_desc = "x";
#else
				msg_print("Your molecules feel disrupted!");
				dam_desc = "density";
#endif
			}
			else
			{
#ifdef JP
				msg_print("ꂽɉׂꂽI");
				dam_desc = "d";
#else
				msg_print("You are being crushed!");
				dam_desc = "solid rock";
#endif
			}

			take_hit(DAMAGE_NOESCAPE, 1 + (p_ptr->lev / 5), dam_desc, -1);
		}
	}


	/*** handle regeneration ***/

	/* Getting Weak */
	if (p_ptr->food < PY_FOOD_WEAK)
	{
		/* Lower regeneration */
		if (p_ptr->food < PY_FOOD_STARVE)
		{
			regen_amount = 0;
		}
		else if (p_ptr->food < PY_FOOD_FAINT)
		{
			regen_amount = PY_REGEN_FAINT;
		}
		else
		{
			regen_amount = PY_REGEN_WEAK;
		}
	}

	//v1.1.41 ƗTudďrqɓ̂vƂɗxĂƎR񕜑x啝ቺ
	if (CLASS_RIDING_BACKDANCE && heavy_armor() && p_ptr->riding)
	{
		regen_amount /= 3;
	}

	/* Are we walking the pattern? */
	if (pattern_effect())
	{
		cave_no_regen = TRUE;
	}
	else
	{
		/* Regeneration ability */
		if (p_ptr->regenerate)
		{
			regen_amount = regen_amount * 2;
		}
		if (p_ptr->special_defense & (KAMAE_MASK | KATA_MASK))
		{
			regen_amount /= 2;
		}
		if (p_ptr->cursed & TRC_SLOW_REGEN)
		{
			regen_amount /= 5;
		}
	}


	/* Searching or Resting */
	if ((p_ptr->action == ACTION_SEARCH) || (p_ptr->action == ACTION_REST))
	{
		regen_amount = regen_amount * 2;
		//͋xẻ񕜂
		if(p_ptr->pclass == CLASS_MEIRIN && (p_ptr->action == ACTION_REST)) regen_amount = regen_amount * 2;
	}

	upkeep_factor = calculate_upkeep();

	/* No regeneration while special action */
	if ((p_ptr->action == ACTION_LEARN) ||
	    (p_ptr->action == ACTION_HAYAGAKE) ||
	    (p_ptr->special_defense & KATA_KOUKIJIN))
	{
		upkeep_factor += 100;
	}

	/* Regenerate the mana */
	regenmana(upkeep_factor, regen_amount);

	//v1.1.15 wJ[eBȂ̂HP
	if(p_ptr->pclass == CLASS_HECATIA)
	{
		int i;
		for(i=0;i<6;i++)
		{
			p_ptr->magic_num1[i] += p_ptr->lev * 4;
			if(p_ptr->magic_num1[i] > 10000) p_ptr->magic_num1[i] = 10000;
		}
	}


	/* Recharge magic eater's power */
	///class@pm̖@R
	if (p_ptr->pclass == CLASS_MAGIC_EATER || p_ptr->pclass == CLASS_SEIJA)
	{
		regenmagic(regen_amount);
	}

	if ((p_ptr->csp == 0) && (p_ptr->csp_frac == 0))
	{
		/*:::100𒴂Ƃ͏Ƀybg*/
		while (upkeep_factor > 100)
		{
#ifdef JP
			///msg131221
			msg_print("Ȃɑ̔z𐧌łȂI");
#else
			msg_print("Too many pets to control at once!");
#endif
			msg_print(NULL);
			do_cmd_pet_dismiss();

			upkeep_factor = calculate_upkeep();

#ifdef JP
			msg_format("ێlo %d%%", upkeep_factor);
#else
			msg_format("Upkeep: %d%% mana.", upkeep_factor);
#endif
			msg_print(NULL);
		}
	}

	/* Poisoned or cut yields no healing */
	if (p_ptr->poisoned) regen_amount = 0;
	if (p_ptr->cut) regen_amount = 0;

	if(p_ptr->pclass == CLASS_HINA && p_ptr->magic_num1[0] > HINA_YAKU_LIMIT3) regen_amount = 0;

	/* Special floor -- Pattern, in a wall -- yields no healing */
	if (cave_no_regen) regen_amount = 0;

	regen_amount = (regen_amount * mutant_regenerate_mod) / 100;

	/* Regenerate Hit Points if needed */
	if ((p_ptr->chp < p_ptr->mhp) && !cave_no_regen)
	{
		regenhp(regen_amount);
	}
}


/*
 * Handle timeout every 10 game turns
 */
/*:::Xe[^XُꎞʂȂǂ̗LԃJEg*/
static void process_world_aux_timeout(void)
{
	const int dec_count = (easy_band ? 2 : 1);
	int i;

	/*** Timeout Various Things ***/
	//X^[Tt@CA̔eN ACeJ[hgEX[hłΏۂ
	//v1.1.14 TOǉ
	//v1.1.21 ʓ|SJEgĂ܂BƂɂƏd
	//if(EXTRA_MODE || p_ptr->pclass == CLASS_SAGUME || p_ptr->pclass == CLASS_STAR || p_ptr->pclass == CLASS_3_FAIRIES)
	{
		int x,y;
		for (y = 1; y < cur_hgt - 1; y++)
		{
			for (x = 1; x < cur_wid - 1; x++)
			{
				if(have_flag(f_info[cave[y][x].mimic].flags, FF_BOMB)) bomb_count(y,x,-1);

			}
		}
	}

	/* Mimic */
	if (p_ptr->tim_mimic)
	{
		(void)set_mimic(p_ptr->tim_mimic - 1, p_ptr->mimic_form, TRUE);
	}

	/* Hack -- Hallucinating */
	if (p_ptr->image)
	{
		(void)set_image(p_ptr->image - dec_count);
	}

	/* Blindness */
	if (p_ptr->blind)
	{
		(void)set_blind(p_ptr->blind - dec_count);
	}

	/* Times see-invisible */
	if (p_ptr->tim_invis)
	{
		(void)set_tim_invis(p_ptr->tim_invis - 1, TRUE);
	}

	/*:::JIXpg炷łɕVJEgɖ߂*/
	if (multi_rew)
	{
		multi_rew = FALSE;
	}

	/* Timed esp */
	if (p_ptr->tim_esp)
	{
		(void)set_tim_esp(p_ptr->tim_esp - 1, TRUE);
	}

	/* Timed temporary elemental brands. -LM- */
	if (p_ptr->ele_attack)
	{
		p_ptr->ele_attack--;

		/* Clear all temporary elemental brands. */
		if (!p_ptr->ele_attack) set_ele_attack(0, 0);
	}

	/* Timed temporary elemental immune. -LM- */
	if (p_ptr->ele_immune)
	{
		p_ptr->ele_immune--;

		/* Clear all temporary elemental brands. */
		if (!p_ptr->ele_immune) set_ele_immune(0, 0);
	}

	/* Timed infra-vision */
	if (p_ptr->tim_infra)
	{
		(void)set_tim_infra(p_ptr->tim_infra - 1, TRUE);
	}

	/* Timed stealth */
	if (p_ptr->tim_stealth)
	{
		(void)set_tim_stealth(p_ptr->tim_stealth - 1, TRUE);
	}

	/* Timed levitation */
	if (p_ptr->tim_levitation)
	{
		(void)set_tim_levitation(p_ptr->tim_levitation - 1, TRUE);
	}

	///mod140813 ړ@s񐔃JEĝʏ̃^CAbvɕύX
	if (p_ptr->lightspeed)
	{
		(void)set_lightspeed(p_ptr->lightspeed - 1, TRUE);
	}

	/* Timed sh_touki */
	if (p_ptr->tim_sh_touki)
	{
		(void)set_tim_sh_touki(p_ptr->tim_sh_touki - 1, TRUE);
	}

	/* Timed sh_fire */
	if (p_ptr->tim_sh_fire)
	{
		(void)set_tim_sh_fire(p_ptr->tim_sh_fire - 1, TRUE);
	}

	/* Timed sh_holy */
	if (p_ptr->tim_sh_holy)
	{
		(void)set_tim_sh_holy(p_ptr->tim_sh_holy - 1, TRUE);
	}

	/* Timed eyeeye */
	if (p_ptr->tim_eyeeye)
	{
		(void)set_tim_eyeeye(p_ptr->tim_eyeeye - 1, TRUE);
	}

	if (p_ptr->tim_res_insanity)
	{
		(void)set_tim_res_insanity(p_ptr->tim_res_insanity - 1, TRUE);
	}

	/* Timed resist-magic */
	if (p_ptr->resist_magic)
	{
		(void)set_resist_magic(p_ptr->resist_magic - 1, TRUE);
	}

	/* Timed regeneration */
	if (p_ptr->tim_regen)
	{
		(void)set_tim_regen(p_ptr->tim_regen - 1, TRUE);
	}
	/*:::_~낵pJEg_E*/
	if (p_ptr->kamioroshi_count)
	{
		p_ptr->kamioroshi_count--;
		if (!p_ptr->kamioroshi_count) set_kamioroshi(0, 0);
	}
	/* Timed resist nether */
	if (p_ptr->tim_res_nether)
	{
		(void)set_tim_res_nether(p_ptr->tim_res_nether - 1, TRUE);
	}

	if (p_ptr->tim_res_dark)
	{
		(void)set_tim_res_dark(p_ptr->tim_res_dark - 1, TRUE);
	}
	for(i=0;i<TIM_GENERAL_MAX;i++)
	{
		if (p_ptr->tim_general[i]) (void)set_tim_general(p_ptr->tim_general[i] - 1, TRUE, i, 0);
	}

	///mod140325 ꎞI\͏㏸
	for(i=0;i<6;i++)
	{
		if (p_ptr->tim_addstat_count[i]) (void)set_tim_addstat(i,0,p_ptr->tim_addstat_count[i] - 1, TRUE);
	}


	/*::: K^̃JjY */
	if (p_ptr->lucky)
	{
		(void)set_tim_lucky(p_ptr->lucky - 1, TRUE);
	}
	/*::: \m */
	if (p_ptr->foresight)
	{
		(void)set_foresight(p_ptr->foresight - 1, TRUE);
	}
	/*::: ҏp */
	if (p_ptr->deportation)
	{
		(void)set_deportation(p_ptr->deportation - 1, TRUE);
	}

	/*::: ܋ */
	if (p_ptr->clawextend)
	{
		(void)set_clawextend(p_ptr->clawextend - 1, TRUE);
	}

	/*::: Timed speedster*/
	if (p_ptr->tim_speedster)
	{
		(void)set_tim_speedster(p_ptr->tim_speedster - 1, TRUE);
	}
	/*::: Timed resist water */
	if (p_ptr->tim_res_water)
	{
		(void)set_tim_res_water(p_ptr->tim_res_water - 1, TRUE);
	}
	/*::: Timed resist chaos */
	if (p_ptr->tim_res_chaos)
	{
		(void)set_tim_res_chaos(p_ptr->tim_res_chaos - 1, TRUE);
	}
	/*::: [_[ZX */
	if (p_ptr->radar_sense)
	{
		(void)set_radar_sense(p_ptr->radar_sense - 1, TRUE);
	}

	if (p_ptr->tim_unite_darkness)
	{
		(void)set_tim_unite_darkness(p_ptr->tim_unite_darkness - 1, TRUE);
	}

	/*::: ꎞB */
	if (p_ptr->tim_superstealth)
	{
		(void)set_tim_superstealth(p_ptr->tim_superstealth - 1, TRUE, FALSE);
	}

	/* Timed resist time */
	if (p_ptr->tim_res_time)
	{
		(void)set_tim_res_time(p_ptr->tim_res_time - 1, TRUE);
	}
	///mod140326
	/* Reactive Heal */
	if (p_ptr->reactive_heal)
	{
		(void)set_reactive_heal(p_ptr->reactive_heal - 1, TRUE);
	}
	/* Timed reflect */
	if (p_ptr->tim_reflect)
	{
		(void)set_tim_reflect(p_ptr->tim_reflect - 1, TRUE);
	}
	/* O */
	if (p_ptr->nennbaku)
	{
		(void)set_nennbaku(p_ptr->nennbaku - 1, TRUE);
	}

	/* Multi-shadow */
	if (p_ptr->multishadow)
	{
		(void)set_multishadow(p_ptr->multishadow - 1, TRUE);
	}

	/* Timed Robe of dust */
	if (p_ptr->dustrobe)
	{
		(void)set_dustrobe(p_ptr->dustrobe - 1, TRUE);
	}

	/* Timed infra-vision */
	if (p_ptr->kabenuke)
	{
		(void)set_kabenuke(p_ptr->kabenuke - 1, TRUE);
	}

	/* Paralysis */
	if (p_ptr->paralyzed)
	{
		(void)set_paralyzed(p_ptr->paralyzed - dec_count);
	}

	/* Confusion */
	if (p_ptr->confused)
	{
		(void)set_confused(p_ptr->confused - dec_count);
	}

	/* Afraid */
	if (p_ptr->afraid)
	{
		(void)set_afraid(p_ptr->afraid - dec_count);
	}

	/* Fast */
	if (p_ptr->fast)
	{
		(void)set_fast(p_ptr->fast - 1, TRUE);
	}

	/* Slow */
	if (p_ptr->slow)
	{
		(void)set_slow(p_ptr->slow - dec_count, TRUE);
	}

	/* Protection from evil */
	if (p_ptr->protevil)
	{
		(void)set_protevil(p_ptr->protevil - 1, TRUE);
	}

	/* Invulnerability */
	if (p_ptr->invuln)
	{
		(void)set_invuln(p_ptr->invuln - 1, TRUE);
	}

	/* Wraith form */
	if (p_ptr->wraith_form)
	{
		(void)set_wraith_form(p_ptr->wraith_form - 1, TRUE);
	}

	/* Heroism */
	if (p_ptr->hero)
	{
		(void)set_hero(p_ptr->hero - 1, TRUE);
	}

	/* Super Heroism */
	if (p_ptr->shero)
	{
		(void)set_shero(p_ptr->shero - 1, TRUE);
	}

	/* Blessed */
	if (p_ptr->blessed)
	{
		(void)set_blessed(p_ptr->blessed - 1, TRUE);
	}

	/* Shield */
	if (p_ptr->shield)
	{
		(void)set_shield(p_ptr->shield - 1, TRUE);
	}

	/* Tsubureru */
	if (p_ptr->tim_sh_death)
	{
		(void)set_tim_sh_death(p_ptr->tim_sh_death - 1, TRUE);
	}

	/* Magicdef */
	if (p_ptr->magicdef)
	{
		(void)set_magicdef(p_ptr->magicdef - 1, TRUE);
	}

	/* Tsuyoshi */
	if (p_ptr->tsuyoshi)
	{
		(void)set_tsuyoshi(p_ptr->tsuyoshi - 1, TRUE);
	}

	/* Oppose Acid */
	if (p_ptr->oppose_acid)
	{
		(void)set_oppose_acid(p_ptr->oppose_acid - 1, TRUE);
	}

	/* Oppose Lightning */
	if (p_ptr->oppose_elec)
	{
		(void)set_oppose_elec(p_ptr->oppose_elec - 1, TRUE);
	}

	/* Oppose Fire */
	if (p_ptr->oppose_fire)
	{
		(void)set_oppose_fire(p_ptr->oppose_fire - 1, TRUE);
	}

	/* Oppose Cold */
	if (p_ptr->oppose_cold)
	{
		(void)set_oppose_cold(p_ptr->oppose_cold - 1, TRUE);
	}

	/* Oppose Poison */
	if (p_ptr->oppose_pois)
	{
		(void)set_oppose_pois(p_ptr->oppose_pois - 1, TRUE);
	}

	if (p_ptr->ult_res)
	{
		(void)set_ultimate_res(p_ptr->ult_res - 1, TRUE);
	}

	/*** Poison and Stun and Cut ***/


	/* Poison */
	if (p_ptr->poisoned)
	{
		int adjust = adj_con_fix[p_ptr->stat_ind[A_CON]] + 1;

		/* Apply some healing */
		(void)set_poisoned(p_ptr->poisoned - adjust);
	}

	/* Stun */
	if (p_ptr->stun)
	{
		int adjust = adj_con_fix[p_ptr->stat_ind[A_CON]] + 1;

		/* Apply some healing */
		(void)set_stun(p_ptr->stun - adjust);
	}

	/* Cut */
	if (p_ptr->cut)
	{
		int adjust = adj_con_fix[p_ptr->stat_ind[A_CON]] + 1;

		/* Hack -- Truly "mortal" wound */
		if (p_ptr->cut > 1000) adjust = 0;

		/* Apply some healing */
		(void)set_cut(p_ptr->cut - adjust);
	}

	///mod140326 AR[lɎ悤ɂ
	if (p_ptr->alcohol)
	{
		int adjust = adj_con_fix[p_ptr->stat_ind[A_CON]] + 1;
		///mod150131 ӎsĎAƉ񕜑
		//v1.1.12 Ƒ
		if(p_ptr->alcohol > DRANK_4)
		{
			adjust += 5;
			adjust *= 10;
		}
		(void)set_alcohol(p_ptr->alcohol - adjust);
	}
	///mod140813 blɎ悤ɂ
	if (p_ptr->asthma)
	{
		int adjust = adj_con_fix[p_ptr->stat_ind[A_CON]] + 1;
		(void)set_asthma(p_ptr->asthma - adjust);
	}


}


/*
 * Handle burning fuel every 10 game turns
 */
/*:::̔R*/
static void process_world_aux_light(void)
{
	/* Check for light being wielded */
	object_type *o_ptr = &inventory[INVEN_LITE];

	if(check_invalidate_inventory(INVEN_LITE)) return;

	/* Burn some fuel in the current lite */
	if (o_ptr->tval == TV_LITE)
	{
		/* Hack -- Use some fuel (except on artifacts) */
		if (!(object_is_fixed_artifact(o_ptr) || o_ptr->sval == SV_LITE_FEANOR) && (o_ptr->xtra4 > 0))
		{
			/* Decrease life-span */
			if (o_ptr->name2 == EGO_LITE_LONG)
			{
				if (turn % (TURNS_PER_TICK*2)) o_ptr->xtra4--;
			}
			else o_ptr->xtra4--;

			/* Notice interesting fuel steps */
			notice_lite_change(o_ptr);
		}
	}
}


/*
 * Handle mutation effects once every 10 game turns
 */
/*:::ˑRψق̃_ muta2̂*/
static void process_world_aux_mutation(void)
{
	/* No mutation with effects */
	if (!p_ptr->muta2) return;

	/* No effect on monster arena */
	if (p_ptr->inside_battle) return;

	/* No effect on the global map */
	if (p_ptr->wild_mode) return;


	if ((p_ptr->muta2 & MUT2_BERS_RAGE) && one_in_(3000))
	{
		disturb(0, 1);
#ifdef JP
		msg_print("ˑRȂ̌I");
#else
		msg_print("RAAAAGHH!");
		msg_print("You feel a fit of rage coming over you!");
#endif

		(void)set_shero(10 + randint1(p_ptr->lev), FALSE);
		(void)set_afraid(0);
	}

	if ((p_ptr->muta2 & MUT2_COWARDICE) && (randint1(3000) == 13))
	{
		if (!p_ptr->resist_fear || IS_VULN_FEAR)
		{
			disturb(0, 1);
#ifdef JP
			msg_print("ƂĂÂ... ƂĂI");
#else
			msg_print("It's so dark... so scary!");
#endif

			set_afraid(p_ptr->afraid + 13 + randint1(26));
		}
	}

	if ((p_ptr->muta2 & MUT2_RTELEPORT) && (randint1(5000) == 88)  || p_ptr->pclass == CLASS_KOISHI && one_in_(2000))
	{
		///mod140121 _e|ψف@ϐhs mŉEĂ

			disturb(1, 1);

			teleport_player(30 + randint0(170), TELEPORT_NONMAGICAL);
			msg_print("c̊ԂɂmȂꏊɂB");
			msg_print(NULL);
			msg_print(NULL);

			if( (p_ptr->lev + 40 < dun_level) && weird_luck())
			{
				msg_print("ɎĂB");
				acquirement(py, px, 1, TRUE, FALSE);
			}

	}

	if ((p_ptr->muta2 & MUT2_HALLU) && (randint1(6400) == 42))
	{
		if (!p_ptr->resist_chaos)
		{
			disturb(0, 1);
			p_ptr->redraw |= PR_EXTRA;
			(void)set_image(p_ptr->image + randint0(50) + 20);
		}
	}

	if ((p_ptr->muta2 & MUT2_YAKU) && (randint1(3000) == 13))
	{
		disturb(0, 1);
		curse_equipment(100,(dun_level / 3 + 1));

	}

	if ((p_ptr->muta2 & MUT2_PROD_MANA) &&
	    !p_ptr->anti_magic && one_in_(9000))
	{
		int dire = 0;
		disturb(0, 1);
#ifdef JP
		msg_print("@̃GlM[ˑRȂ̒ɗꍞłIGlM[Ȃ΂ȂȂI");
#else
		msg_print("Magical energy flows through you! You must release it!");
#endif

		flush();
		msg_print(NULL);
		(void)get_hack_dir(&dire);
		fire_ball(GF_MANA, dire, p_ptr->lev * 2, 3);
	}

	if ((p_ptr->muta2 & MUT2_ATT_DEMON) &&
	    !p_ptr->anti_magic && (randint1(6666) == 666))
	{
		bool pet = one_in_(6);
		u32b mode = PM_ALLOW_GROUP;

		if (pet) mode |= PM_FORCE_PET;
		else mode |= (PM_ALLOW_UNIQUE | PM_NO_PET);

		if (summon_specific((pet ? -1 : 0), py, px,
				    dun_level, SUMMON_DEMON, mode))
		{
#ifdef JP
			msg_print("Ȃ̓f[񂹂I");
#else
			msg_print("You have attracted a demon!");
#endif

			disturb(0, 1);
		}
	}

	if ((p_ptr->muta2 & MUT2_SPEED_FLUX) && one_in_(6000))
	{
		disturb(0, 1);
		if (one_in_(2))
		{
#ifdef JP
			msg_print("͓IłȂȂCB");
#else
			msg_print("You feel less energetic.");
#endif

			if (p_ptr->fast > 0)
			{
				set_fast(0, TRUE);
			}
			else
			{
				set_slow(randint1(30) + 10, FALSE);
			}
		}
		else
		{
#ifdef JP
			msg_print("͓IɂȂCB");
#else
			msg_print("You feel more energetic.");
#endif

			if (p_ptr->slow > 0)
			{
				set_slow(0, TRUE);
			}
			else
			{
				set_fast(randint1(30) + 10, FALSE);
			}
		}
		msg_print(NULL);
	}
	if ((p_ptr->muta2 & MUT2_BANISH_ALL) && one_in_(9000))
	{
		disturb(0, 1);
#ifdef JP
		msg_print("ˑRقƂǌǓƂɂȂCB");
#else
		msg_print("You suddenly feel almost lonely.");
#endif

		banish_monsters(100);
		///del131221 X͌サȂ
#if 0
		if (!dun_level && p_ptr->town_num)
		{
			int n;

			/* Pick a random shop (except home) */
			do
			{
				n = randint0(MAX_STORES);
			}
			while ((n == STORE_HOME) || (n == STORE_MUSEUM));

#ifdef JP
			msg_print("X̎luɌđĂI");
#else
			msg_print("You see one of the shopkeepers running for the hills!");
#endif

			store_shuffle(n);
		}
#endif
		msg_print(NULL);
	}

	if ((p_ptr->muta2 & MUT2_EAT_LIGHT) && one_in_(3000))
	{
		object_type *o_ptr;

#ifdef JP
		msg_print("eɂ܂ꂽB");
#else
		msg_print("A shadow passes over you.");
#endif

		msg_print(NULL);

		/* Absorb light from the current possition */
		if ((cave[py][px].info & (CAVE_GLOW | CAVE_MNDK)) == CAVE_GLOW)
		{
			hp_player(10);
		}

		o_ptr = &inventory[INVEN_LITE];

		/* Absorb some fuel in the current lite */
		if (o_ptr->tval == TV_LITE)
		{
			/* Use some fuel (except on artifacts) */
			if (!object_is_fixed_artifact(o_ptr) && (o_ptr->xtra4 > 0))
			{
				/* Heal the player a bit */
				hp_player(o_ptr->xtra4 / 20);

				/* Decrease life-span of lite */
				o_ptr->xtra4 /= 2;

#ifdef JP
				msg_print("GlM[zI");
#else
				msg_print("You absorb energy from your light!");
#endif


				/* Notice interesting fuel steps */
				notice_lite_change(o_ptr);
			}
		}

		/*
		 * Unlite the area (radius 10) around player and
		 * do 50 points damage to every affected monster
		 */
		unlite_area(50, 10);
	}

	if ((p_ptr->muta2 & MUT2_ATT_ANIMAL) &&
	    !p_ptr->anti_magic && one_in_(7000))
	{
		bool pet = one_in_(3);
		u32b mode = PM_ALLOW_GROUP;

		if (pet) mode |= PM_FORCE_PET;
		else mode |= (PM_ALLOW_UNIQUE | PM_NO_PET);

		if (summon_specific((pet ? -1 : 0), py, px, dun_level, SUMMON_ANIMAL, mode))
		{
#ifdef JP
			msg_print("񂹂I");
#else
			msg_print("You have attracted an animal!");
#endif

			disturb(0, 1);
		}
	}

	if ((p_ptr->muta2 & MUT2_RAW_CHAOS) &&
	    !p_ptr->anti_magic && one_in_(8000))
	{
		disturb(0, 1);
#ifdef JP
		msg_print("̋ԂcłCI");
#else
		msg_print("You feel the world warping around you!");
#endif

		msg_print(NULL);
		fire_ball(GF_CHAOS, 0, p_ptr->lev, 8);
	}
	if ((p_ptr->muta2 & MUT2_NORMALITY) && one_in_(5000))
	{
		if (!lose_mutation(0))
#ifdef JP
			msg_print("ʏɋ߂ÂĂCB");
#else
		msg_print("You feel oddly normal.");
#endif

	}
	if ((p_ptr->muta2 & MUT2_WRAITH) && !p_ptr->anti_magic && one_in_(3000))
	{
		disturb(0, 1);
#ifdef JP
		msg_print("񕨎I");
#else
		msg_print("You feel insubstantial!");
#endif

		msg_print(NULL);
		set_wraith_form(randint1(p_ptr->lev / 2) + (p_ptr->lev / 2), FALSE);
	}
	if ((p_ptr->muta2 & MUT2_ATT_GHOST) &&
	    !p_ptr->anti_magic && one_in_(7000))
	{
		bool pet = one_in_(3);
		u32b mode = PM_ALLOW_GROUP;

		if (pet) mode |= PM_FORCE_PET;
		else mode |= (PM_ALLOW_UNIQUE | PM_NO_PET);

		if (summon_specific((pet ? -1 : 0), py, px, dun_level, SUMMON_GHOST, mode))
		{
#ifdef JP
			msg_print("H삪ĂI");
#else
			msg_print("You have attracted an animal!");
#endif

			disturb(0, 1);
		}
	}
	if ((p_ptr->muta2 & MUT2_ATT_KWAI) &&
	    !p_ptr->anti_magic && one_in_(7000))
	{
		bool pet = one_in_(3);
		u32b mode = PM_ALLOW_GROUP;

		if (pet) mode |= PM_FORCE_PET;
		else mode |= (PM_ALLOW_UNIQUE | PM_NO_PET);

		if (summon_specific((pet ? -1 : 0), py, px, dun_level, SUMMON_KWAI, mode))
		{
#ifdef JP
			msg_print("dĂI");
#else
			msg_print("You have attracted an animal!");
#endif

			disturb(0, 1);
		}
	}
	if ((p_ptr->muta2 & MUT2_ATT_DRAGON) &&
	    !p_ptr->anti_magic && one_in_(3000))
	{
		bool pet = one_in_(5);
		u32b mode = PM_ALLOW_GROUP;

		if (pet) mode |= PM_FORCE_PET;
		else mode |= (PM_ALLOW_UNIQUE | PM_NO_PET);

		if (summon_specific((pet ? -1 : 0), py, px, dun_level, SUMMON_DRAGON, mode))
		{
#ifdef JP
			msg_print("hS񂹂I");
#else
			msg_print("You have attracted a dragon!");
#endif

			disturb(0, 1);
		}
	}
	if ((p_ptr->muta2 & MUT2_XOM) && one_in_(3000))
	{
#ifdef JP
			msg_print("]ucOȂ܂ꂵĂȂv");
#endif
		(void)set_shero(10 + randint1(p_ptr->lev), FALSE);
		(void)set_afraid(0);

	}
	if ((p_ptr->muta2 & MUT2_BIRDBRAIN) && one_in_(3000) || p_ptr->pclass == CLASS_KOISHI && one_in_(1000))
	{
		disturb(0, 1);
#ifdef JP
		msg_print("cH@YĂCB");
#endif

		lose_all_info();
		if (music_singing_any()) stop_singing();
		if (hex_spelling_any()) stop_hex_spell_all();
		stop_tsukumo_music();
		stop_raiko_music();
	}

	if ((p_ptr->muta2 & MUT2_WALK_SHAD) &&
	    !p_ptr->anti_magic && one_in_(12000) && !p_ptr->inside_arena)
	{
		alter_reality();
	}

	if ((p_ptr->muta2 & MUT2_WARNING) && one_in_(1000))
	{
		int danger_amount = 0;
		int monster;

		for (monster = 0; monster < m_max; monster++)
		{
			monster_type    *m_ptr = &m_list[monster];
			monster_race    *r_ptr = &r_info[m_ptr->r_idx];

			/* Paranoia -- Skip dead monsters */
			if (!m_ptr->r_idx) continue;

			if (r_ptr->level >= p_ptr->lev)
			{
				danger_amount += r_ptr->level - p_ptr->lev + 1;
			}
		}

		if (danger_amount > 100)
#ifdef JP
			msg_print("ɋ낵CI");
#else
		msg_print("You feel utterly terrified!");
#endif

		else if (danger_amount > 50)
#ifdef JP
			msg_print("낵CI");
#else
		msg_print("You feel terrified!");
#endif

		else if (danger_amount > 20)
#ifdef JP
			msg_print("ɐSzȋCI");
#else
		msg_print("You feel very worried!");
#endif

		else if (danger_amount > 10)
#ifdef JP
			msg_print("SzȋCI");
#else
		msg_print("You feel paranoid!");
#endif

		else if (danger_amount > 5)
#ifdef JP
			msg_print("قƂǈSȋCB");
#else
		msg_print("You feel almost safe.");
#endif

		else
#ifdef JP
			msg_print("₵CB");
#else
		msg_print("You feel lonely.");
#endif

	}
	if ((p_ptr->muta2 & MUT2_INVULN) && !p_ptr->anti_magic &&
	    one_in_(5000))
	{
		disturb(0, 1);
#ifdef JP
		msg_print("GȋCI");
#else
		msg_print("You feel invincible!");
#endif

		msg_print(NULL);
		(void)set_invuln(randint1(8) + 8, FALSE);
	}

	///mod140813 b
	if ((p_ptr->muta2 & MUT2_ASTHMA) && one_in_(1000))
	{
		msg_print("b̔삾I");
		(void)set_asthma(p_ptr->asthma + 1000 + randint0(2000));
	}

	if ((p_ptr->muta2 & MUT2_THE_WORLD) && !p_ptr->anti_magic &&
	    one_in_(4000))
	{
		disturb(0, 1);
		if (world_player)
		{
#ifdef JP
			msg_print("Ɏ͎~܂ĂB");
#endif
		}
		else
		{
			world_player = TRUE;
			if(p_ptr->pclass == CLASS_SAKUYA) sakuya_time_stop(FALSE);

#ifdef JP
			msg_print("˔@Aӂ̑SĂÎ~B");
#endif
			msg_print(NULL);
	
			/* Hack */
			p_ptr->energy_need -= 1000 + (400)*TURNS_PER_TICK/10;
			/* Redraw map */
			p_ptr->redraw |= (PR_MAP);
			/* Update monsters */
			p_ptr->update |= (PU_MONSTERS);
			/* Window stuff */
			p_ptr->window |= (PW_OVERHEAD | PW_DUNGEON);
			handle_stuff();
		}
	}
	if ((p_ptr->muta2 & MUT2_DISARM) && one_in_(10000))
	{
		int slot = 0;
		object_type *o_ptr = NULL;

		disturb(0, 1);
#ifdef JP
		msg_print("ē]񂾁I");
		take_hit(DAMAGE_NOESCAPE, randint1(p_ptr->wt / 6), "]|", -1);
#else
		msg_print("You trip over your own feet!");
		take_hit(DAMAGE_NOESCAPE, randint1(p_ptr->wt / 6), "tripping", -1);
#endif

		msg_print(NULL);
		if (buki_motteruka(INVEN_RARM))
		{
			slot = INVEN_RARM;
			o_ptr = &inventory[INVEN_RARM];

			if (buki_motteruka(INVEN_LARM) && one_in_(2))
			{
				o_ptr = &inventory[INVEN_LARM];
				slot = INVEN_LARM;
			}
		}
		else if (buki_motteruka(INVEN_LARM))
		{
			o_ptr = &inventory[INVEN_LARM];
			slot = INVEN_LARM;
		}

		///pend 藎ƂBꕔLN^[͏Ov
		if (slot && !object_is_cursed(o_ptr) && p_ptr->pclass != CLASS_KOGASA)
		{
#ifdef JP
			msg_print("𗎂ƂĂ܂I");
#else
			msg_print("You drop your weapon!");
#endif
			inven_drop(slot, 1);
		}
	}
}

/*
 * Handle curse effects once every 10 game turns
 */
/*:::􂢔@gṽ_e|R̕΂HPz*/
static void process_world_aux_curse(void)
{

	if(p_ptr->inside_battle) return;

	//v1.1.48 XL}bvł͔ȂƂɂ
	if (p_ptr->wild_mode) return;

	//v1.1.48 ̕s^p[ƂmŏɃX[p[nR_ɕϐg
	if (p_ptr->pclass == CLASS_SHION && one_in_(99) && !p_ptr->tim_mimic)
	{
		int power = CALC_SUPER_SHION_TURNS;

		if (randint1(power) > 13)
		{

			msg_print("ߍ܂ꂽs^p[\I");
			disturb(1, 1);
			set_tim_general(power, FALSE, 0, 0);

			//ϐgmagic_num1[0]݃^[ɂ[1]Zbg
			p_ptr->magic_num1[0] = turn;
			p_ptr->magic_num1[1] = 0;
			//HPS
			hp_player(9999);


		}
		else if (power >= 13)
		{
			msg_print("ߍ܂ꂽs^p[\ȋC...");

		}
	}

	//v1.1.48 X[p[nR_̂Ƃɂ͐FXN
	if (SUPER_SHION && one_in_(66) && !p_ptr->inside_battle && !p_ptr->wild_mode)
	{
		int mode = randint1(6);
		switch (mode)
		{

		case 1:
		case 2:
		{
			int y, x, feat;
			feature_type *f_ptr;

			if (mode == 1)msg_print("Ȃ͓SCɏPꂽI");
			if (mode == 2)msg_print("Ȃ͗n◬ɏPꂽI");

			for (y = 1; y < cur_hgt - 1; y++)
			{
				for (x = 1; x < cur_wid - 1; x++)
				{
					cave_type *c_ptr = &cave[y][x];
					feat = get_feat_mimic(c_ptr);
					f_ptr = &f_info[feat];

					if (mode == 1 && have_flag(f_ptr->flags, FF_FLOOR))
						cave_set_feat(y, x, feat_deep_water);
					if (mode == 2 && have_flag(f_ptr->flags, FF_FLOOR))
						cave_set_feat(y, x, feat_deep_lava);
				}
			}

			p_ptr->redraw |= (PR_MAP);
			p_ptr->window |= (PW_OVERHEAD | PW_DUNGEON);
			handle_stuff();
			break;
		}

		case 3:
			if (dun_level)
			{
				msg_print("Ȃ͗ՂɏPꂽI");
				earthquake(py, px, 12);

			}
			else
			{
				msg_print("Ȃ͗ɏPꂽI");
				project(0,9,py,px,666,GF_TORNADO,(PROJECT_KILL | PROJECT_GRID | PROJECT_ITEM),-1);
			}
			break;
		case 4:
			msg_print("Ȃ͗JɏPꂽI");
			cast_meteor(300, 4, GF_METEOR);
			break;
		case 5:
			msg_print("Ȃ͓̘̎c݂ɏPꂽI");
			project_hack2(GF_DISTORTION, 1, 1000, 0);
			break;
		case 6:
			msg_print("s̃̕I[ꂽI");
			floor_attack(GF_DISENCHANT, 0, 0, p_ptr->lev * 8, 0);
			break;
		}


	}

	//̖̃yieB
	if(p_ptr->pclass == CLASS_HINA  && !p_ptr->inside_battle && !p_ptr->wild_mode)
	{
		int yaku = p_ptr->magic_num1[0];

		if(yaku > HINA_YAKU_LIMIT3)
		{
			if(one_in_(50))
			{
				int power = yaku / 50;
				switch(randint1(8))
				{
				case 1:
					msg_print("˔@AȗI");
					project(0,8,py,px,power+randint1(power),GF_TORNADO,(PROJECT_KILL|PROJECT_GRID|PROJECT_JUMP|PROJECT_ITEM),-1);
					break;
				case 2:
					if(dun_level && !p_ptr->inside_quest)
					{
						msg_print("˔@AnkI");
						earthquake_aux(py,px,10,0);
					}
					else
						msg_print("nEE");
					break;
				case 3:
					msg_print("˔@AJ~蒍I");
					cast_meteor(power/2, 3,GF_METEOR);
					break;
				case 4:
					msg_print("˔@Ad͏ُ킪I");
					project(0,8,py,px,power+randint1(power),GF_GRAVITY,(PROJECT_KILL|PROJECT_GRID|PROJECT_JUMP|PROJECT_ITEM),-1);
					break;
				case 5:
					msg_print("˔@AJIX̉QI");
					project(0,8,py,px,power+randint1(power),GF_CHAOS,(PROJECT_KILL|PROJECT_GRID|PROJECT_JUMP|PROJECT_ITEM),-1);
					break;
				case 6:
					msg_print("˔@A嗒I");
					project_hack2(GF_TSUKUMO_STORM,1,power/2,power/2);
					break;
				case 7:
					msg_print("˔@AvY}I");
					project(0,8,py,px,power+randint1(power),GF_PLASMA,(PROJECT_KILL|PROJECT_GRID|PROJECT_JUMP|PROJECT_ITEM),-1);
					break;
				case 8:
					mass_genocide(power,FALSE);
					msg_print("ӂ肩瑼҂̋CzCB");
					break;

				}

			}
		}
		if(yaku > (HINA_YAKU_LIMIT3) && dun_level > 10 && !p_ptr->inside_quest && one_in_(200))
		{
			bool entry = FALSE;
			if(one_in_(2))
			{
				if(summon_named_creature(0,py,px,MON_REIMU,PM_NO_PET)) entry = TRUE;
			}
			else
			{
				if(summon_named_creature(0,py,px,MON_MARISA,PM_NO_PET)) entry = TRUE;
			}

			if(entry) 
			{
				msg_print("ٕω̐ƂȂގɂĂI");
				disturb(1, 1);
			}

		}
	}

	if ((p_ptr->cursed & TRC_P_FLAG_MASK) && !p_ptr->inside_battle && !p_ptr->wild_mode)
	{
		/*
		 * Hack: Uncursed teleporting items (e.g. Trump Weapons)
		 * can actually be useful!
		 */
		if ((p_ptr->cursed & TRC_TELEPORT_SELF) && one_in_(200))
		{
			char o_name[MAX_NLEN];
			object_type *o_ptr;
			int i, i_keep = 0, count = 0;

			/* Scan the equipment with random teleport ability */
			for (i = INVEN_RARM; i < INVEN_TOTAL; i++)
			{
				u32b flgs[TR_FLAG_SIZE];
				o_ptr = &inventory[i];

				/* Skip non-objects */
				if (!o_ptr->k_idx) continue;

				if(check_invalidate_inventory(i)) continue;

				/* Extract the item flags */
				object_flags(o_ptr, flgs);

				if (have_flag(flgs, TR_TELEPORT))
				{
					/* {.} will stop random teleportation. */
					if (!o_ptr->inscription || !my_strchr(quark_str(o_ptr->inscription), '.'))
					{
						count++;
						if (one_in_(count)) i_keep = i;
					}
				}
			}

			o_ptr = &inventory[i_keep];
			object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

#ifdef JP
			msg_format("%se|[g̔\͂𔭓悤ƂĂB", o_name);
#else
			msg_format("Your %s is activating teleportation.", o_name);
#endif

#ifdef JP
			if (get_check_strict("e|[g܂H", CHECK_OKAY_CANCEL))
#else
			if (get_check_strict("Teleport? ", CHECK_OKAY_CANCEL))
#endif
			{
				disturb(0, 1);
				teleport_player(50, 0L);
			}
			else
			{
#ifdef JP
				msg_format("%s{.}(sIh)ƖނƔ}ł܂B", o_name);
#else
				msg_format("You can inscribe {.} on your %s to disable random teleportation. ", o_name);
#endif
				disturb(1, 1);
			}
		}
		/* Make a chainsword noise */
		///item131221 `F[\[̃bZ[WXg[uK[ɍւĂ݂
		if ((p_ptr->cursed & TRC_STORMBRINGER) && one_in_(CHAINSWORD_NOISE))
		{
			char noise[1024];
#ifdef JP
			if (!get_rnd_line("storm_j.txt", 0, noise))
			//if (!get_rnd_line("chainswd_j.txt", 0, noise))

#else
			if (!get_rnd_line("chainswd.txt", 0, noise))
#endif
				msg_print(noise);
			disturb(FALSE, FALSE);
		}
		/* TY Curse */
		if ((p_ptr->cursed & TRC_TY_CURSE) && one_in_(TY_CURSE_CHANCE))
		{
			int count = 0;
			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 20)
			{
				msg_format("Â̎􂢂ǂɂG߂B");
				return;
			}
			(void)activate_ty_curse(FALSE, &count);
		}
		/* Handle experience draining */
		if (p_ptr->prace != RACE_ANDROID && 
			((p_ptr->cursed & TRC_DRAIN_EXP) && one_in_(4)))
		{
			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 3) return;

			if(p_ptr->pclass == CLASS_HINA)
			{
				hina_gain_yaku(randint1(3));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				p_ptr->magic_num1[1] += 100 + randint1(100);
				return;
			}


			p_ptr->exp -= (p_ptr->lev+1)/2;
			if (p_ptr->exp < 0) p_ptr->exp = 0;
			p_ptr->max_exp -= (p_ptr->lev+1)/2;
			if (p_ptr->max_exp < 0) p_ptr->max_exp = 0;
			check_experience();
		}
		/* Add light curse (Later) */
		if ((p_ptr->cursed & TRC_ADD_L_CURSE) && one_in_(2000))
		{
			u32b new_curse;
			object_type *o_ptr;

			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("i̎􂢂AȂ͂zB");
				hina_gain_yaku(50 + randint1(50));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("i̎􂢂AȂ͂zB");
				p_ptr->magic_num1[1] += 1000 + randint1(1000);
				return;
			}

			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 10)
			{
				msg_format("􂢂ǂɂG߂B");
				return;
			}
			o_ptr = choose_cursed_obj_name(TRC_ADD_L_CURSE);

			new_curse = get_curse(0, o_ptr);
			if (!(o_ptr->curse_flags & new_curse))
			{
				char o_name[MAX_NLEN];

				object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

				o_ptr->curse_flags |= new_curse;
#ifdef JP
				msg_format("ӂɖI[%sƂ܂...", o_name);
#else
				msg_format("There is a malignant black aura surrounding your %s...", o_name);
#endif

				o_ptr->feeling = FEEL_NONE;

				p_ptr->update |= (PU_BONUS);
			}
		}
		/* Add heavy curse (Later) */
		if ((p_ptr->cursed & TRC_ADD_H_CURSE) && one_in_(2000))
		{
			u32b new_curse;
			object_type *o_ptr;

			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("i̋͂Ȏ􂢂AȂ͂zB");
				hina_gain_yaku(300 + randint1(300));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("i̋͂Ȏ􂢂AȂ͂zB");
				p_ptr->magic_num1[1] += 5000 + randint1(5000);
				return;
			}

			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 15)
			{
				msg_format("͂Ȏ􂢂ǂɂG߂B");
				return;
			}
			o_ptr = choose_cursed_obj_name(TRC_ADD_H_CURSE);

			new_curse = get_curse(1, o_ptr);
			if (!(o_ptr->curse_flags & new_curse))
			{
				char o_name[MAX_NLEN];

				object_desc(o_name, o_ptr, (OD_OMIT_PREFIX | OD_NAME_ONLY));

				o_ptr->curse_flags |= new_curse;
#ifdef JP
				msg_format("ӂɖI[%sƂ܂...", o_name);
#else
				msg_format("There is a malignant black aura surrounding your %s...", o_name);
#endif

				o_ptr->feeling = FEEL_NONE;

				p_ptr->update |= (PU_BONUS);
			}
		}
		/* Call animal */
		if ((p_ptr->cursed & TRC_CALL_ANIMAL) && one_in_(2500))
		{
			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("i̎􂢂AȂ͂zB");
				hina_gain_yaku(50 + randint1(50));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("i̎􂢂AȂ͂zB");
				p_ptr->magic_num1[1] += 1000 + randint1(1000);
				return;
			}

			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 10)
			{
				msg_format("􂢂ǂɂG߂B");
				return;
			}
			if (summon_specific(0, py, px, dun_level, SUMMON_ANIMAL,
			    (PM_ALLOW_GROUP | PM_ALLOW_UNIQUE | PM_NO_PET)))
			{
				char o_name[MAX_NLEN];

				object_desc(o_name, choose_cursed_obj_name(TRC_CALL_ANIMAL), (OD_OMIT_PREFIX | OD_NAME_ONLY));
#ifdef JP
				msg_format("%s񂹂I", o_name);
#else
				msg_format("Your %s have attracted an animal!", o_name);
#endif

				disturb(0, 1);
			}
		}
		/* Call demon */
		if ((p_ptr->cursed & TRC_CALL_DEMON) && one_in_(1111))
		{
			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("i̋͂Ȏ􂢂AȂ͂zB");
				hina_gain_yaku(200 + randint1(200));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("i̎􂢂AȂ͂zB");
				p_ptr->magic_num1[1] += 3000 + randint1(3000);
				return;
			}

			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 15)
			{
				msg_format("͂Ȏ􂢂ǂɂG߂B");
				return;
			}
			if (summon_specific(0, py, px, dun_level, SUMMON_DEMON, (PM_ALLOW_GROUP | PM_ALLOW_UNIQUE | PM_NO_PET)))
			{
				char o_name[MAX_NLEN];

				object_desc(o_name, choose_cursed_obj_name(TRC_CALL_DEMON), (OD_OMIT_PREFIX | OD_NAME_ONLY));
#ifdef JP
				msg_format("%s񂹂I", o_name);
#else
				msg_format("Your %s have attracted a demon!", o_name);
#endif

				disturb(0, 1);
			}
		}
		/* Call dragon */
		if ((p_ptr->cursed & TRC_CALL_DRAGON) && one_in_(800))
		{
			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("i̋͂Ȏ􂢂AȂ͂zB");
				hina_gain_yaku(300 + randint1(300));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("i̎􂢂AȂ͂zB");
				p_ptr->magic_num1[1] += 5000 + randint1(5000);
				return;
			}
			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 15)
			{
				msg_format("͂Ȏ􂢂ǂɂG߂B");
				return;
			}
			if (summon_specific(0, py, px, dun_level, SUMMON_DRAGON,
			    (PM_ALLOW_GROUP | PM_ALLOW_UNIQUE | PM_NO_PET)))
			{
				char o_name[MAX_NLEN];

				object_desc(o_name, choose_cursed_obj_name(TRC_CALL_DRAGON), (OD_OMIT_PREFIX | OD_NAME_ONLY));
#ifdef JP
				msg_format("%shS񂹂I", o_name);
#else
				msg_format("Your %s have attracted an animal!", o_name);
#endif

				disturb(0, 1);
			}
		}
		if ((p_ptr->cursed & TRC_COWARDICE) && one_in_(1500))
		{
			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("i̎􂢂AȂ͂zB");
				hina_gain_yaku(30 + randint1(10));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("i̎􂢂AȂ͂zB");
				p_ptr->magic_num1[1] += 1000 + randint1(1000);
				return;
			}

			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 5)
			{
				msg_format("􂢂ǂɂG߂B");
				return;
			}
			if (!p_ptr->resist_fear || IS_VULN_FEAR)
			{
				disturb(0, 1);
#ifdef JP
				msg_print("ƂĂÂ... ƂĂI");
#else
				msg_print("It's so dark... so scary!");
#endif

				set_afraid(p_ptr->afraid + 13 + randint1(26));
			}
		}
		/* Teleport player */
		if ((p_ptr->cursed & TRC_TELEPORT) && one_in_(200) && !p_ptr->anti_tele)
		{
			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("i̋͂Ȏ􂢂AȂ͂zB");
				hina_gain_yaku(100 + randint1(200));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("i̎􂢂AȂ͂zB");
				p_ptr->magic_num1[1] += 2000 + randint1(2000);
				return;
			}

			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 10)
			{
				msg_format("͂Ȏ􂢂ǂɂG߂B");
				return;
			}
			disturb(0, 1);

			/* Teleport player */
			teleport_player(40, TELEPORT_PASSIVE);
		}
		/* Handle HP draining */
		if ((p_ptr->cursed & TRC_DRAIN_HP) && one_in_(666))
		{
			char o_name[MAX_NLEN];
			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("i̎􂢂AȂ͂zB");
				hina_gain_yaku(20 + randint1(20));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("i̎􂢂AȂ͂zB");
				p_ptr->magic_num1[1] += 500 + randint1(500);
				return;
			}

			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 5)
			{
				msg_format("􂢂ǂɂG߂B");
				return;
			}

			object_desc(o_name, choose_cursed_obj_name(TRC_DRAIN_HP), (OD_OMIT_PREFIX | OD_NAME_ONLY));
#ifdef JP
			msg_format("%s͂Ȃ̗̑͂zI", o_name);
#else
			msg_format("Your %s drains HP from you!", o_name);
#endif
			take_hit(DAMAGE_LOSELIFE, MIN(p_ptr->lev*2, 100), o_name, -1);
		}
		/* Handle mana draining */
		if ((p_ptr->cursed & TRC_DRAIN_MANA) && p_ptr->csp && one_in_(666))
		{
			char o_name[MAX_NLEN];
			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("i̎􂢂AȂ͂zB");
				hina_gain_yaku(25 + randint1(25));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("i̎􂢂AȂ͂zB");
				p_ptr->magic_num1[1] += 500 + randint1(500);
				return;
			}

			if(p_ptr->prace == RACE_TSUKUMO && randint1(p_ptr->lev) > 5)
			{
				msg_format("􂢂ǂɂG߂B");
				return;
			}

			object_desc(o_name, choose_cursed_obj_name(TRC_DRAIN_MANA), (OD_OMIT_PREFIX | OD_NAME_ONLY));
#ifdef JP
			msg_format("%s͂Ȃ̖͂zI", o_name);
#else
			msg_format("Your %s drains mana from you!", o_name);
#endif
			p_ptr->csp -= MIN(p_ptr->lev, 50);
			if (p_ptr->csp < 0)
			{
				p_ptr->csp = 0;
				p_ptr->csp_frac = 0;
			}
			p_ptr->redraw |= PR_MANA;
		}
	}

	/* Rarely, take damage from the Jewel of Judgement */
	if (one_in_(999) && !p_ptr->anti_magic)
	{
		object_type *o_ptr;

		o_ptr = &inventory[INVEN_LITE];
		if (o_ptr->name1 == ART_JUDGE)
		{

			if(p_ptr->pclass == CLASS_HINA)
			{
				msg_format("wR̕΁xȂ̗̑͂z悤ƂAtɖzB");
				hina_gain_yaku(200 + randint1(200));
				return;
			}
			//v1.1.48 ͎􂢂s^p[Ƃċz
			if (p_ptr->pclass == CLASS_SHION)
			{
				msg_format("wR̕΁xȂ̗̑͂z悤ƂAtɕs^p[zB");
				p_ptr->magic_num1[1] += 2000 + randint1(2000);
				return;
			}

			if (object_is_known(o_ptr))
				msg_print("wR̕΁x͂Ȃ̗̑͂zI");
			else
				msg_print("ȂɂȂ̗̑͂zI");
			take_hit(DAMAGE_LOSELIFE, MIN(p_ptr->lev, 50), "R̕", -1);

		}

	}

	//v1.1.48 nR_GS Od͈ႤXbgɑł̂ŃyieBȂ܂Ȃ낤
	if (inventory[INVEN_BODY].name2 == EGO_BODY_POVERTY && one_in_(100))
	{
		int lose_money = p_ptr->au / 20 + randint0(p_ptr->au / 20) + 1;

		//v1.1.48 ͎􂢂s^p[Ƃċz
		if (p_ptr->pclass == CLASS_SHION)
		{
			p_ptr->magic_num1[1] += 1000 + randint1(1000);
			return;
		}

		if (p_ptr->au < 1) return;

		//zȂ\͎̗d͖h䂷
		if (CHECK_FAIRY_TYPE != 9)
		{
			p_ptr->au -= lose_money;
			p_ptr->redraw |= PR_GOLD;
			msg_print("zyȂCB");
			disturb(0, 1);
		}
	}

	/*:::̉H߂ɋLr*/
	if (one_in_(999) && !p_ptr->anti_magic)
	{
		if ( check_equip_specific_fixed_art(ART_HAGOROMO_MOON) && !p_ptr->resist_insanity)
		{
			msg_print("̉H߂ɌCEE");
			if (lose_all_info()) msg_print("}ɋLBɂȂB");
		}
	}
	//i̋߂ł͓ɖ
	if(!dun_level && !p_ptr->wild_mode && distance(p_ptr->wilderness_y,p_ptr->wilderness_x,55,46) < 6 && !p_ptr->town_num && one_in_(10) && !p_ptr->levitation && randint0(p_ptr->skill_srh) < 10)
	{
		teleport_player(100, TELEPORT_NONMAGICAL);
		msg_print("..ɖCB");

	}
	//Q[I[o[
	if(p_ptr->pclass == CLASS_HINA && p_ptr->magic_num1[0] >= HINA_YAKU_MAX)
	{
		msg_format("܂ɗ܂唚NI");
		project_hack2(GF_DISINTEGRATE,0,0,9999);
		take_hit(DAMAGE_NOESCAPE,9999,"̑唚",-1);
	}

}

///mod140330 Dxɂ鏈
//v1.1.19 Dx}WbNio[r
void process_world_aux_alcohol(void)
{
	int freq;
	int eccentricity;

	/*:::AłȂƂDxőiKȂ牽ȂiӎsĂœ|Ă邽߁j*/
	if(!(p_ptr->muta2 & MUT2_ALCOHOL) && p_ptr->alcohol >= DRANK_4)return;
	//[h}bvł͉NȂ
	if(p_ptr->wild_mode) return;
	if (p_ptr->inside_battle) return;

	if(p_ptr->alcohol < DRANK_2) return;
	else if(p_ptr->alcohol < DRANK_3) freq = 100;
	else if(p_ptr->alcohol < DRANK_4) freq = 20;
	else freq = 10;

	if(!one_in_(freq)) return;
	/*:::ȍ~ADɂ鉽炩̌ʔ*/

	if(p_ptr->alcohol < DRANK_3) eccentricity = randint0(50);
	else eccentricity = randint0(90);

	if(eccentricity < 10)//j
	{
		msg_format("ƂĂKȋCI");
		set_blessed(randint1(25) + 25, FALSE);
	}
	else if(eccentricity < 15)//
	{
		msg_format("̂dEE");
		set_slow(randint1(25) + 25, FALSE);
	}
	else if(eccentricity < 20)//
	{
		msg_format("EEEEH");
		if(!p_ptr->resist_conf) set_confused(randint1(25) + 25);
	}
	else if(eccentricity < 25)//
	{
		msg_format("̂yI");
		set_fast(randint1(25) + 25, FALSE);
	}
	else if(eccentricity < 30)//
	{
		msg_format("吺ŉ̂oȂI");
		aggravate_monsters(0,FALSE);
	}
	else if(eccentricity < 35)//NO
	{
		msg_format("ڂ肷EE");
		set_stun(p_ptr->stun + 10 + randint0(21));
	}
	else if(eccentricity < 40)//m
	{
		msg_format("ɐla肽ȂEE");
			set_shero(randint1(25) + 25, FALSE);
			hp_player(30);
			set_afraid(0);
	}
	else if(eccentricity < 45)//؂菝
	{
		msg_format("mȂɉĂEE");
		take_hit(DAMAGE_NOESCAPE,randint1(10),"ĕ",-1);
		set_cut(p_ptr->cut + randint1(10));
	}
	else if(eccentricity < 50)//Lre|[g
	{
		if(lose_all_info())
		{
			msg_format("LBB");

			if(one_in_(3))
			{ 
				msg_print("EEƂ͂ǂH");
				teleport_player(10 + randint1(200), TELEPORT_NONMAGICAL | TELEPORT_PASSIVE);
			}
		}
	}
	/*:::ȉADRANK_3ȍ~̂*/
	else if(eccentricity < 55)//݂̑|
	{
		int food = p_ptr->food;
		set_deity_bias(DBIAS_REPUTATION, -3);
		msg_format("EE!?");
		msg_format("");
		screen_save();
		Term_clear();
		put_str("΂炭҂B", 17 , 40);
		(void)inkey();
		//Term_xtra(TERM_XTRA_DELAY, 2000);
		screen_load();
		msg_format("݂̒ɂȂB");
		if(food > PY_FOOD_ALERT) set_food(food / 2);
		else set_food(food - 1000);
		set_alcohol(p_ptr->alcohol - 2000 );
	}
	else if(eccentricity < 60)//
	{
		if(p_ptr->chp < p_ptr->mhp)
		{
			msg_format("̒ɂ݂ȂCB");
			hp_player(p_ptr->lev * 4);
		}
	}

	else if(eccentricity < 65)//o
	{
		if(!p_ptr->resist_pois && !p_ptr->resist_chaos)
		{
			msg_format("̌iFxČEE");
			if(!p_ptr->resist_chaos) set_image(20 + randint0(81));
		}
	}

	else if(eccentricity < 70)//
	{
		int slot = INVEN_RIBBON + randint0(10);
		
		if(inventory[slot].k_idx )
		{
			if(!wield_check(slot,0)) msg_format("EȂdB");
			else if( object_is_cursed(&inventory[slot]) || check_invalidate_inventory(slot) ) msg_format("EȂEȂB");
			else
			{
				msg_format("EȂB");
				inven_takeoff(slot,1);
			}
		}
	}
	else if(eccentricity < 75)//rόE˔j
	{
		int time = 25 + randint0(25);
		msg_format("̂̌EǂɒuYꂽCI");
		set_tim_addstat(A_STR,100 + 10,time,FALSE);
		set_tim_addstat(A_CON,100 + 10,time,FALSE);
	}
	else if(eccentricity < 80)//++pE˔j
	{
		int time = 25 + randint0(25);
		msg_format("̂̂yI");
		set_fast(time,FALSE);
		set_tim_levitation(time,FALSE);
		set_tim_addstat(A_DEX,100 + 10,time,FALSE);
		//set_tim_speedstar(time,FALSE);

	}
	else if(eccentricity < 85)//ϗeij
	{
		msg_format("ĂCB");
		if (p_ptr->inside_arena || ironman_downward)
			msg_print("AĈH");
		else
		{
			/*:::0ł͂܂͂*/
			p_ptr->alter_reality = 1;
			p_ptr->redraw |= (PR_STATUS);
		}
	}
	else //G
	{
		msg_format("ȂȂłłCI");
		(void)set_invuln(randint1(8) + 8, FALSE);
	}

}


/*
 * Handle recharging objects once every 10 game turns
 */
/*:::bhȂǂ̎[U*/
static void process_world_aux_recharge(void)
{
	int i;
	bool changed;

	/* Process equipment */
	for (changed = FALSE, i = INVEN_RARM; i < INVEN_TOTAL; i++)
	{
		/* Get the object */
		object_type *o_ptr = &inventory[i];

		/* Skip non-objects */
		if (!o_ptr->k_idx) continue;
		///mod160508 ȅ[U͂ł͍sȂ
		if(o_ptr->tval == TV_GUN) continue; 
		if(check_invalidate_inventory(i)) continue;

		/* Recharge activatable objects */
		if (o_ptr->timeout > 0)
		{
			/* Recharge */
			o_ptr->timeout--;

			/* Notice changes */
			if (!o_ptr->timeout)
			{
				recharged_notice(o_ptr);
				changed = TRUE;
			}
		}
	}

	/* Notice changes */
	if (changed)
	{
		/* Window stuff */
		p_ptr->window |= (PW_EQUIP);
		wild_regen = 20;
	}

	/*
	 * Recharge rods.  Rods now use timeout to control charging status,
	 * and each charging rod in a stack decreases the stack's timeout by
	 * one per turn. -LM-
	 */
	for (changed = FALSE, i = 0; i < INVEN_PACK; i++)
	{
		object_type *o_ptr = &inventory[i];
		object_kind *k_ptr = &k_info[o_ptr->k_idx];

		/* Skip non-objects */
		if (!o_ptr->k_idx) continue;

		/* Examine all charging rods or stacks of charging rods. */
		if ((o_ptr->tval == TV_ROD) && (o_ptr->timeout))
		{
			/* Determine how many rods are charging. */
			int temp = (o_ptr->timeout + (k_ptr->pval - 1)) / k_ptr->pval;
			if (temp > o_ptr->number) temp = o_ptr->number;

			/* Decrease timeout by that number. */
			o_ptr->timeout -= temp;

			/* Boundary control. */
			if (o_ptr->timeout < 0) o_ptr->timeout = 0;

			/* Notice changes, provide message if object is inscribed. */
			if (!(o_ptr->timeout))
			{
				recharged_notice(o_ptr);
				changed = TRUE;
			}

			/* One of the stack of rod is charged */
			else if (o_ptr->timeout % k_ptr->pval)
			{
				changed = TRUE;
			}
		}
	}

	/* Notice changes */
	if (changed)
	{
		/* Window stuff */
		p_ptr->window |= (PW_INVEN);
		wild_regen = 20;
	}


	/* Process objects on floor */
	for (i = 1; i < o_max; i++)
	{
		/* Access object */
		object_type *o_ptr = &o_list[i];

		/* Skip dead objects */
		if (!o_ptr->k_idx) continue;

		/* Recharge rods on the ground.  No messages. */
		if ((o_ptr->tval == TV_ROD) && (o_ptr->timeout))
		{
			/* Charge it */
			o_ptr->timeout -= o_ptr->number;

			/* Boundary control. */
			if (o_ptr->timeout < 0) o_ptr->timeout = 0;
		}
	}



	//v1.1.46 pXbgɑĂwւ̏[Us
	if (p_ptr->pclass == CLASS_JYOON)	for (changed = FALSE, i = 0; i < INVEN_ADD_MAX; i++)
	{
		/* Get the object */
		object_type *o_ptr = &inven_add[i];

		/* Skip non-objects */
		if (!o_ptr->k_idx) continue;
		if (o_ptr->tval == TV_GUN) continue;

		//wփXbgĂƂ[UȂBEXTRA[h̒K̗tςŕϐgĂƂ֌W͂B
		//{EwƍwŕׂȂ̂낤ȕϐgȂꏏɂĂB
		if (check_invalidate_inventory(INVEN_RIGHT)) continue;

		/* Recharge activatable objects */
		if (o_ptr->timeout > 0)
		{
			/* Recharge */
			o_ptr->timeout--;

			/* Notice changes */
			if (!o_ptr->timeout)
			{
				recharged_notice(o_ptr);
				changed = TRUE;
			}
		}
	}
}

///mod160509
/*:::ȇU recharge()̏\{̕pxŌĂяoB
 *timeoutlɂ͒ʏ̐{̒li[ĂA{100B
 *enxȂǂɉČlB*/
static void process_world_aux_recharge_gun(void)
{
	int i;
	bool changed = FALSE;

	//ss\ɂ̓`[WȂ
	if(p_ptr->paralyzed || p_ptr->confused || (p_ptr->stun >= 100) 
		|| p_ptr->alcohol >= DRANK_4 && !(p_ptr->muta2 & MUT2_ALCOHOL)) return;
	if (p_ptr->special_defense & KATA_MASK) return;

	for (i = 0; i <= INVEN_LARM; i++)
	{
		/* Get the object */
		object_type *o_ptr = &inventory[i];

		//Z\ueiXvȂ葕̏eɂ`[WȂ
		if(!HAVE_SOLDIER_SKILL(SOLDIER_SKILL_SHOOT,SS_S_MAINTENANCE) && i < INVEN_RARM) continue;


		/* Skip non-objects */
		if (!o_ptr->k_idx) continue;
		if (o_ptr->tval != TV_GUN) continue;
		if(check_invalidate_inventory(i)) continue;

		/* Recharge activatable objects */
		if (o_ptr->timeout > 0)
		{
			int ammo_old,ammo_new;
			int charge = 100;
			int timeout_base = calc_gun_timeout(o_ptr) * 1000;

			ammo_old = o_ptr->timeout / timeout_base;

			charge = charge * 100 / calc_gun_charge_mult(i);

			//eiXĂłȂẽ`[Wx͔
			if(i < INVEN_RARM) charge /= 2;



			o_ptr->timeout -= charge;

			if(o_ptr->timeout < 0) o_ptr->timeout = 0;

			ammo_new = o_ptr->timeout / timeout_base;

			/* Notice changes */
			if (!o_ptr->timeout)
			{
				recharged_notice(o_ptr);
				changed = TRUE;
			}
			else if(ammo_old != ammo_new)
			{
				changed = TRUE;
				//v1.1.21 KJ^͎cêƂȂ̂łŃ`FbN
				if(inventory[INVEN_RARM].tval == TV_GUN && inventory[INVEN_LARM].tval == TV_GUN)
					p_ptr->update |= PU_BONUS;
			}
		}
	}

	/* Notice changes */
	if (changed)
	{
		/* Window stuff */
		p_ptr->window |= (PW_EQUIP | PW_INVEN);
		wild_regen = 20;
	}

}

/*
 * Handle involuntary movement once every 10 game turns
 */
/*:::̑Ԍ*/
static void process_world_aux_movement(void)
{
	/* Delayed Word-of-Recall */
	if (p_ptr->word_recall)
	{
		/*
		 * HACK: Autosave BEFORE resetting the recall counter (rr9)
		 * The player is yanked up/down as soon as
		 * he loads the autosaved game.
		 */
		if (autosave_l && (p_ptr->word_recall == 1) && !p_ptr->inside_battle)
			do_cmd_save_game(TRUE);

		/* Count down towards recall */
		p_ptr->word_recall--;

		p_ptr->redraw |= (PR_STATUS);

		/* Activate the recall */
		if (!p_ptr->word_recall)
		{
			/* Disturbing! */
			disturb(0, 1);


			//sۓW̃gbv
			if(p_ptr->inside_quest == QUEST_MOON_VAULT && quest[QUEST_MOON_VAULT].flags & QUEST_FLAG_SPECIAL)
			{
				msg_print("n̖̏pA҂̏płI");
			}

			/* Determine the level */
			else if (dun_level || p_ptr->inside_quest || p_ptr->enter_dungeon)
			{
				msg_print(_("Ɉ肠銴I",
							"You feel yourself yanked upwards!"));

				if (dungeon_type) p_ptr->recall_dungeon = dungeon_type;
				if (record_stair)
					do_cmd_write_nikki(NIKKI_RECALL, dun_level, NULL);

				dun_level = 0;
				dungeon_type = 0;

				leave_quest_check();
				leave_tower_check();

				p_ptr->inside_quest = 0;

				p_ptr->leaving = TRUE;
			}
			else
			{
				msg_print(_("Ɉ~낳銴I",
							"You feel yourself yanked downwards!"));

				dungeon_type = p_ptr->recall_dungeon;

				if (record_stair)
					do_cmd_write_nikki(NIKKI_RECALL, dun_level, NULL);
				///system G΍DȊKwɋA҂ł
				/* New depth */
				dun_level = max_dlv[dungeon_type];
				if (dun_level < 1) dun_level = 1;

				/* Nightmare mode makes recall more dangerous */
				if (ironman_nightmare && !randint0(666) && (dungeon_type == DUNGEON_ANGBAND))
				{
					if (dun_level < 50)
					{
						dun_level *= 2;
					}
					else if (dun_level < 99)
					{
						dun_level = (dun_level + 99) / 2;
					}
					else if (dun_level > 100)
					{
						dun_level = d_info[dungeon_type].maxdepth - 1;
					}
				}

				if (p_ptr->wild_mode)
				{
					p_ptr->wilderness_y = py;
					p_ptr->wilderness_x = px;
				}
				else
				{
					/* Save player position */
					p_ptr->oldpx = px;
					p_ptr->oldpy = py;
				}
				p_ptr->wild_mode = FALSE;

				/*
				 * Clear all saved floors
				 * and create a first saved floor
				 */
				prepare_change_floor_mode(CFM_FIRST_FLOOR);

				/* Leaving */
				p_ptr->leaving = TRUE;

				if (dungeon_type == DUNGEON_ANGBAND)
				{
					int i;

					for (i = MIN_RANDOM_QUEST; i < MAX_RANDOM_QUEST + 1; i++)
					{
						if ((quest[i].type == QUEST_TYPE_RANDOM) &&
						    (quest[i].status == QUEST_STATUS_TAKEN) &&
						    (quest[i].level < dun_level))
						{
							quest[i].status = QUEST_STATUS_FAILED;
							quest[i].complev = (byte)p_ptr->lev;
							r_info[quest[i].r_idx].flags1 &= ~(RF1_QUESTOR);
						}
					}
				}
			}

			/* Sound */
			sound(SOUND_TPLEVEL);
		}
	}


	/* Delayed Alter reality */
	if (p_ptr->alter_reality)
	{
		if (autosave_l && (p_ptr->alter_reality == 1) && !p_ptr->inside_battle)
			do_cmd_save_game(TRUE);

		/* Count down towards alter */
		p_ptr->alter_reality--;

		p_ptr->redraw |= (PR_STATUS);

		/* Activate the alter reality */
		if (!p_ptr->alter_reality)
		{
			/* Disturbing! */
			disturb(0, 1);

			/* Determine the level */
			if (!quest_number(dun_level) && dun_level)
			{
#ifdef JP
				msg_print("EςI");
#else
				msg_print("The world changes!");
#endif

				/*
				 * Clear all saved floors
				 * and create a first saved floor
				 */
				prepare_change_floor_mode(CFM_FIRST_FLOOR);

				/* Leaving */
				p_ptr->leaving = TRUE;
			}
			else
			{
#ifdef JP
				msg_print("E̊ԕω悤B");
#else
				msg_print("The world seems to change for a moment!");
#endif
			}

			/* Sound */
			sound(SOUND_TPLEVEL);
		}
	}
}


/*
 * Count number of adjacent monsters
 */
static int get_monster_crowd_number(int m_idx)
{
	monster_type *m_ptr = &m_list[m_idx];
	int my = m_ptr->fy;
	int mx = m_ptr->fx;
	int i;
	int count = 0;

	for (i = 0; i < 7; i++)
	{
		int ay = my + ddy_ddd[i];
		int ax = mx + ddx_ddd[i];

		if (!in_bounds(ay, ax)) continue;

		/* Count number of monsters */
		if (cave[ay][ax].m_idx > 0) count++;
 	}

	return count;
}



/*
 * Dungeon rating is no longer linear
 */
#define RATING_BOOST(delta) (delta * delta + 50 * delta)

/*
 * Examine all monsters and unidentified objects,
 * and get the feeling of current dungeon floor
 */
/*:::͋CvZB̃tÃX^[ƐGĂȂACeKxƔr*/
static byte get_dungeon_feeling(void)
{
	const int base = 10;
	int rating = 0;
	int i;

	/* Hack -- no feeling in the town */
	if (!dun_level) return 0;

	/* Examine each monster */
	for (i = 1; i < m_max; i++)
	{
		monster_type *m_ptr = &m_list[i];
		monster_race *r_ptr;
		int delta = 0;

		/* Skip dead monsters */
		if (!m_ptr->r_idx) continue;

		/* Ignore pet */
		if (is_pet(m_ptr)) continue;

		if(m_ptr->r_idx == MON_MASTER_KAGUYA) continue;

		r_ptr = &r_info[m_ptr->r_idx];

		/* Unique monsters */
		///mod150224 UNIQUE2܂ނƂɂ
		if (r_ptr->flags1 & (RF1_UNIQUE) || r_ptr->flags7 & (RF7_UNIQUE2))
		{
			/* Nearly out-of-depth unique monsters */
			if (r_ptr->level + 10 > dun_level)
			{
				/* Boost rating by twice delta-depth */
				delta += (r_ptr->level + 10 - dun_level) * 2 * base;
			}
		}
		else
		{
			/* Out-of-depth monsters */
			if (r_ptr->level > dun_level)
			{
				/* Boost rating by delta-depth */
				delta += (r_ptr->level - dun_level) * base;
			}
		}

		/* Unusually crowded monsters get a little bit of rating boost */
		if (r_ptr->flags1 & RF1_FRIENDS)
		{
			if (5 <= get_monster_crowd_number(i)) delta += 1;
		}
		else
		{
			if (2 <= get_monster_crowd_number(i)) delta += 1;
		}


		rating += RATING_BOOST(delta);
	}

	/* Examine each unidentified object */
	for (i = 1; i < o_max; i++)
	{
		object_type *o_ptr = &o_list[i];
		object_kind *k_ptr = &k_info[o_ptr->k_idx];
		int delta = 0;

		/* Skip dead objects */
		if (!o_ptr->k_idx) continue;

		/* Skip known objects */
		if (object_is_known(o_ptr))
		{
			/* Touched? */
			if (o_ptr->marked & OM_TOUCHED) continue;
		}

		/* Skip pseudo-known objects */
		if (o_ptr->ident & IDENT_SENSE) continue;

		///mod160314 ACeJ[h@ŒᐶKƃRXgœKɌvZ
		if(o_ptr->tval == TV_ITEMCARD)
		{
			int fake_lev = (support_item_list[o_ptr->pval].min_lev + support_item_list[o_ptr->pval].cost * 4) / 2;

			if(fake_lev > dun_level) delta += (fake_lev - dun_level) * base;

		}

		/* Ego objects */
		if (object_is_ego(o_ptr))
		{
			ego_item_type *e_ptr = &e_info[o_ptr->name2];

			delta += e_ptr->rating * base;
		}

		/* Artifacts */
		if (object_is_artifact(o_ptr))
		{
			s32b cost = object_value_real(o_ptr);

			delta += 10 * base;
			if (cost > 10000L) delta += 10 * base;
			if (cost > 50000L) delta += 10 * base;
			if (cost > 100000L) delta += 10 * base;

			/* Special feeling */
			if (!preserve_mode) return 1;
		}
		///item ͋CvZ
		///mod131223 ͋CvZ tval
		if (o_ptr->tval == TV_DRAG_ARMOR) delta += 30 * base;
		if (o_ptr->tval == TV_DRAG_ARMOR && o_ptr->sval >=  SV_DRAGARMOR_MULTI) delta += 30 * base;

		if (o_ptr->tval == TV_SHIELD &&
		    o_ptr->sval == SV_DRAGON_SHIELD) delta += 5 * base;
		if (o_ptr->tval == TV_GLOVES &&
		    o_ptr->sval == SV_HAND_DRAGONGLOVES) delta += 5 * base;
		if (o_ptr->tval == TV_BOOTS &&
		    o_ptr->sval == SV_LEG_DRAGONBOOTS) delta += 5 * base;
		if (o_ptr->tval == TV_HEAD &&
		    o_ptr->sval == SV_HEAD_DRAGONHELM) delta += 5 * base;
		if (o_ptr->tval == TV_RING &&
		    o_ptr->sval == SV_RING_SPEED &&
		    !object_is_cursed(o_ptr)) delta += 25 * base;
		if (o_ptr->tval == TV_RING &&
		    o_ptr->sval == SV_RING_LORDLY &&
		    !object_is_cursed(o_ptr)) delta += 15 * base;
		if (o_ptr->tval == TV_AMULET &&
		    o_ptr->sval == SV_AMULET_THE_MAGI &&
		    !object_is_cursed(o_ptr)) delta += 15 * base;

		/* Out-of-depth objects */
		if (!object_is_cursed(o_ptr) && !object_is_broken(o_ptr) &&
		    k_ptr->level > dun_level)
		{
			/* Rating increase */
			delta += (k_ptr->level - dun_level) * base;
		}

		rating += RATING_BOOST(delta);
	}


	if (rating > RATING_BOOST(1000)) return 2;
	if (rating > RATING_BOOST(800)) return 3;
	if (rating > RATING_BOOST(600)) return 4;
	if (rating > RATING_BOOST(400)) return 5;
	if (rating > RATING_BOOST(300)) return 6;
	if (rating > RATING_BOOST(200)) return 7;
	if (rating > RATING_BOOST(100)) return 8;
	if (rating > RATING_BOOST(0)) return 9;

	return 10;
}


/*
 * Update dungeon feeling, and announce it if changed
 */
/*:::͋CmƏ 1turnƂɌĂ΂*/
static void update_dungeon_feeling(void)
{
	byte new_feeling;
	int quest_num;
	int delay;

	/* No feeling on the surface */
	if (!dun_level) return;

	/* No feeling in the arena */
	if (p_ptr->inside_battle) return;

	/* Extract delay time */
	delay = MAX(10, 150 - p_ptr->skill_fos) * (150 - dun_level) * TURNS_PER_TICK / 100;
	if(p_ptr->pclass == CLASS_IKU) delay = 10 * 30 * TURNS_PER_TICK / 100;//ꏈōőm

 	/* Not yet felt anything */
	//if (turn < p_ptr->feeling_turn + delay && !cheat_xtra) return;
	///mod140216 ߋ͈uŕ͋Cm
	///mod140907 EE\肾AǂȂ̂ňułȂőɂ
	//if (turn < (p_ptr->feeling_turn + delay) && !cheat_xtra && p_ptr->pclass != CLASS_IKU) return;
	if (turn < (p_ptr->feeling_turn + delay) && !cheat_xtra) return;

	/* Extract quest number (if any) */
	quest_num = quest_number(dun_level);
	///system NGXg֘A
	/* No feeling in a quest */
	if (quest_num &&
	    (is_fixed_quest_idx(quest_num) &&
	  //   !((quest_num == QUEST_OBERON) || (quest_num == QUEST_SERPENT) ||
	     !((quest_num == QUEST_OBERON) || (quest_num == QUEST_YUKARI) ||
	       !(quest[quest_num].flags & QUEST_FLAG_PRESET)))) return;

	if(EXTRA_QUEST_FLOOR) return;

	/* Get new dungeon feeling */
	new_feeling = get_dungeon_feeling();

	/* Remember last time updated */
	p_ptr->feeling_turn = turn;

	/* No change */
	if (p_ptr->feeling == new_feeling) return;

	/* Dungeon feeling is changed */
	p_ptr->feeling = new_feeling;

	/* Announce feeling */
	do_cmd_feeling();

	/* Update the level indicator */
	p_ptr->redraw |= (PR_DEPTH);

	/* Disturb */
	if (disturb_minor) disturb(0, 0);
}


/*
 * Handle certain things once every 10 game turns
 */
/*:::1Q[^[ƁA10Q[^[Ƃɍs鏈*/
static void process_world(void)
{
	int day, hour, min;

	const s32b A_DAY = TURNS_PER_TICK * TOWN_DAWN;
	s32b prev_turn_in_today = ((turn - TURNS_PER_TICK) % A_DAY + A_DAY / 4) % A_DAY;
	int prev_min = (1440 * prev_turn_in_today / A_DAY) % 60;
	
	extract_day_hour_min(&day, &hour, &min);

	/* Update dungeon feeling, and announce it if changed */
	update_dungeon_feeling();

	///mod160508 ȅ[U
	process_world_aux_recharge_gun();

	///mod160814 TOu_X̒evŔ
	if(p_ptr->pclass == CLASS_SAGUME && p_ptr->tim_general[0] && p_ptr->csp < 1)
	{
		set_tim_general(0,TRUE,0,0);
	}

	///mod150616 ZύX
	if (p_ptr->inside_battle && !p_ptr->leaving)
	{
		int i;
		int win_m_idx = 0;
		int number_mon[4] = {0,0,0,0};
		int number_team = 0;
		u32b bitflag_survive = 0L;

		/* Examine each monster */
		for (i = 1; i < m_max; i++)
		{
			monster_type *m_ptr = &m_list[i];

			if(!m_ptr->r_idx) continue;
			if(i == p_ptr->riding) continue;

			if(!(m_ptr->mflag & MFLAG_BATTLE_MON_MASK)) 
				msg_print("WARNING:Zɂǂ̃`[ɂnłȂX^[");
			else
				bitflag_survive |= (MFLAG_BATTLE_MON_MASK & m_ptr->mflag);

			win_m_idx = i;
		}


		if (!bitflag_survive)
		{
			p_ptr->au -= battle_mon_wager;
			gambling_gain -= battle_mon_wager;
			msg_print("u[AᑊˁBǓ̑肳Bv");
			msg_print(NULL);
			p_ptr->energy_need = 0;
			//battle_monsters();
		}
		else if (count_bits(bitflag_survive) == 1)
		{

			char m_name[80];
			monster_type *wm_ptr;

			p_ptr->au -= battle_mon_wager;
			gambling_gain -= battle_mon_wager;
	
			if(bitflag_survive == MFLAG_BATTLE_MON_TEAM_A) i = 0;
			else if(bitflag_survive == MFLAG_BATTLE_MON_TEAM_B) i = 1;
			else if(bitflag_survive == MFLAG_BATTLE_MON_TEAM_C) i = 2;
			else if(bitflag_survive == MFLAG_BATTLE_MON_TEAM_D) i = 3;
			if(battle_mon_team_type[i] == 0)
			{
				wm_ptr = &m_list[win_m_idx];
				monster_desc(m_name, wm_ptr, 0);
				msg_format("%sI", m_name);
			}
			else if(battle_mon_team_type[i] < 0)
			{
				msg_format("%sI", battle_mon_special_team_list[0-battle_mon_team_type[i]].name);
			}
			else
			{
				msg_format("%sI", battle_mon_random_team_name_list[battle_mon_team_type[i]]);
			}
			msg_print(NULL);


			if(battle_mon_team_bet & bitflag_survive )
			{
				int reward;

				reward = battle_mon_wager / 100 * battle_mon_odds;
				if(reward > 9999999) reward = 9999999;

				if(battle_mon_odds < 1000 && p_ptr->psex == SEX_MALE) msg_print("u߂łƂIZ̏Iv");
				else if(battle_mon_odds < 1000 ) msg_print("u߂łƂȈIv");
				else if(reward < 1000000 )
				{
					//匊𓖂Ăƒx啝}CiXA啝vX
					msg_print("uȂA匊Iv");
					set_deity_bias(DBIAS_REPUTATION, 3);
					set_deity_bias(DBIAS_COSMOS, -5);
				}
				else if(reward < 9999999)
				{
					msg_print("uǂ悤AR̐_la_HEEv");
					set_deity_bias(DBIAS_REPUTATION, 10);
					set_deity_bias(DBIAS_COSMOS, -30);
				}
				else
				{
					msg_print("͓͖̉A𐁂ē|Aق͓̉QĂĉn߂B");
					set_deity_bias(DBIAS_REPUTATION, 100);
					set_deity_bias(DBIAS_COSMOS, -200);
				}
				msg_print(NULL);
				msg_format("%d󂯎B", reward);
				p_ptr->au += reward;

				//v1.1.25 MuxJEg邱Ƃɂ
				gambling_gain += reward;
				if(gambling_gain > 99999999) gambling_gain = 99999999;

			}
			else
			{
				msg_print("ucOˁB܂肸ɂ܂ĂBv");
			}
			msg_print(NULL);
			p_ptr->energy_need = 0;
			//battle_monsters();
		}
		else if (turn - old_turn == 300 * TURNS_PER_TICK)
		{
			msg_print("u^CAbvBcOǕԋBv");
			msg_print(NULL);
			p_ptr->energy_need = 0;
		}
		//ȊÔƂA܂ĂȂ
	}

	/*** Check monster arena ***/

//Ž̃[`
#if 0
	if (p_ptr->inside_battle && !p_ptr->leaving)
	{
		int i2, j2;
		int win_m_idx = 0;
		int number_mon = 0;

		/* Count all hostile monsters */
		for (i2 = 0; i2 < cur_wid; ++i2)
			for (j2 = 0; j2 < cur_hgt; j2++)
			{
				cave_type *c_ptr = &cave[j2][i2];

				if ((c_ptr->m_idx > 0) && (c_ptr->m_idx != p_ptr->riding))
				{
					number_mon++;
					win_m_idx = c_ptr->m_idx;
				}
			}

		if (number_mon == 0)
		{
#ifdef JP
			msg_print("łɏI܂B");
#else
			msg_print("They have kill each other at the same time.");
#endif
			msg_print(NULL);
			p_ptr->energy_need = 0;
			battle_monsters();
		}
		else if ((number_mon-1) == 0)
		{
			char m_name[80];
			monster_type *wm_ptr;

			wm_ptr = &m_list[win_m_idx];

			monster_desc(m_name, wm_ptr, 0);
#ifdef JP
			msg_format("%sI", m_name);
#else
			msg_format("%s is winner!", m_name);
#endif
			msg_print(NULL);

			if (win_m_idx == (sel_monster+1))
			{
#ifdef JP
				msg_print("߂łƂ܂B");
#else
				msg_print("Congratulations.");
#endif
#ifdef JP
				msg_format("%d󂯎B", battle_odds);
#else
				msg_format("You received %d gold.", battle_odds);
#endif
				p_ptr->au += battle_odds;
			}
			else
			{
#ifdef JP
				msg_print("cOłB");
#else
				msg_print("You lost gold.");
#endif
			}
			msg_print(NULL);
			p_ptr->energy_need = 0;
			battle_monsters();
		}
		else if (turn - old_turn == 150*TURNS_PER_TICK)
		{
#ifdef JP
			msg_print("\܂񂪁Ȁ͈ƂĂ܂B");
#else
			msg_format("This battle have ended in a draw.");
#endif
			p_ptr->au += kakekin;
			msg_print(NULL);
			p_ptr->energy_need = 0;
			battle_monsters();
		}
	}
#endif

	/* Every 10 game turns */
	if (turn % TURNS_PER_TICK) return;

	/*:::AI10turn(Q[1^[)Ƃ̏*/


	/*** Check the Time and Load ***/
	///system AOohւ̖EEEH
	///sysdel
	if (!(turn % (50*TURNS_PER_TICK)))
	{
		/* Check time and load */
		if ((0 != check_time()) || (0 != check_load()))
		{
			/* Warning */
			if (closing_flag <= 2)
			{
				/* Disturb */
				disturb(0, 1);

				/* Count warnings */
				closing_flag++;

				/* Message */
#ifdef JP
msg_print("AOohւ̖傪Ă܂...");
msg_print("Q[I邩Z[u邩ĉB");
#else
				msg_print("The gates to ANGBAND are closing...");
				msg_print("Please finish up and/or save your game.");
#endif

			}

			/* Slam the gate */
			else
			{
				/* Message */
#ifdef JP
msg_print("AAOohւ̖傪܂B");
#else
				msg_print("The gates to ANGBAND are now closed.");
#endif


				/* Stop playing */
				p_ptr->playing = FALSE;

				/* Leaving */
				p_ptr->leaving = TRUE;
			}
		}
	}

	/*** Attempt timed autosave ***/
	/*:::I[gZ[u*/
	if (autosave_t && autosave_freq && !p_ptr->inside_battle)
	{
		if (!(turn % ((s32b)autosave_freq * TURNS_PER_TICK)))
			do_cmd_save_game(TRUE);
	}

	if (mon_fight && !ignore_unview)
	{
#ifdef JP
		msg_print("B");
#else
		msg_print("You hear noise.");
#endif
	}
	//iԃvCɋP邪EOŃ_[W󂯂Ƃkaguya_fightɎcHPL^
	if(kaguya_fight && !ignore_unview && kaguya_fight < 100)
	{

		if(kaguya_fight > 80)
			msg_print("P邪풆̂悤B");
		else if(kaguya_fight > 50)
			msg_print("P͋킵Ă悤B");
		else
			msg_print("P邪댯I");

		if(kaguya_fight <= 80)disturb(0,1);


		kaguya_fight = 100;

	}

	/*** Handle the wilderness/town (sunshine) ***/

	///mod140821 GWjAMh̏Օi̒liς
	if (!(turn % ((TURNS_PER_TICK * TOWN_DAWN) / 2))) engineer_guild_price_change();

	///mod160522 ̎xJE^@悻15Ƃ
	if(p_ptr->pclass == CLASS_RINGO && !(turn % ((TURNS_PER_TICK * TOWN_DAWN) / 1000)))
	{
		p_ptr->magic_num1[4] += dun_level / 10 + 1;
	}

	/* While in town/wilderness */
	///system@tOƂȂ炱
	if (!dun_level && !p_ptr->inside_quest && !p_ptr->inside_battle && !p_ptr->inside_arena)
	{
		/* Hack -- Daybreak/Nighfall in town */
		if (!(turn % ((TURNS_PER_TICK * TOWN_DAWN) / 2)))
		{
			bool dawn;

			//̉OŃp[Abvd
			if(CHECK_FAIRY_TYPE == 30)
			{
				p_ptr->redraw |= (PR_STATE);
				p_ptr->update |= (PU_BONUS);
				handle_stuff();
			}

			/* Check for dawn */
			dawn = (!(turn % (TURNS_PER_TICK * TOWN_DAWN)));

			/* Day breaks */
			/*:::邪}bv𖾂邭*/
			if (dawn)
			{
				int y, x;

				msg_print("邪B");

				if (!p_ptr->wild_mode)
				{
					/* Hack -- Scan the town */
					for (y = 0; y < cur_hgt; y++)
					{
						for (x = 0; x < cur_wid; x++)
						{
							/* Get the cave grid */
							cave_type *c_ptr = &cave[y][x];

							/* Assume lit */
							c_ptr->info |= (CAVE_GLOW);

							/* Hack -- Memorize lit grids if allowed */
							if (view_perma_grids) c_ptr->info |= (CAVE_MARK);

							/* Hack -- Notice spot */
							note_spot(y, x);
						}
					}
				}
			}

			/*:::ɂȂ}bvÂ*/
			/* Night falls */
			else
			{
				int y, x;

				/* Message */
#ifdef JP
				msg_print("񂾁B");
#else
				msg_print("The sun has fallen.");
#endif

				if (!p_ptr->wild_mode)
				{
					/* Hack -- Scan the town */
					for (y = 0; y < cur_hgt; y++)
					{
						for (x = 0; x < cur_wid; x++)
						{
							/* Get the cave grid */
							cave_type *c_ptr = &cave[y][x];

							/* Feature code (applying "mimic" field) */
							feature_type *f_ptr = &f_info[get_feat_mimic(c_ptr)];

							if (!is_mirror_grid(c_ptr) && !have_flag(f_ptr->flags, FF_QUEST_ENTER) &&
							    !have_flag(f_ptr->flags, FF_ENTRANCE))
							{
								/* Assume dark */
								c_ptr->info &= ~(CAVE_GLOW);

								if (!have_flag(f_ptr->flags, FF_REMEMBER))
								{
									/* Forget the normal floor grid */
									c_ptr->info &= ~(CAVE_MARK);

									/* Hack -- Notice spot */
									note_spot(y, x);
								}
							}
						}

						/* Glow deep lava and building entrances */
						glow_deep_lava_and_bldg();
					}
				}
			}

			/* Update the monsters */
			p_ptr->update |= (PU_MONSTERS | PU_MON_LITE);

			/* Redraw map */
			p_ptr->redraw |= (PR_MAP);

			/* Window stuff */
			p_ptr->window |= (PW_OVERHEAD | PW_DUNGEON);

			if (p_ptr->special_defense & NINJA_S_STEALTH)
			{
				if (cave[py][px].info & CAVE_GLOW) set_superstealth(FALSE);
			}
		}
	}

	//ǐ_l͓o߂ōDxƖω
	if(p_ptr->prace == RACE_STRAYGOD && !(turn % (TURNS_PER_TICK * TOWN_DAWN)))
	{
		if(p_ptr->prace == RACE_STRAYGOD && p_ptr->race_multipur_val[DBIAS_WARLIKE] > 60) set_deity_bias(DBIAS_WARLIKE, -3);
		if(p_ptr->prace == RACE_STRAYGOD && p_ptr->race_multipur_val[DBIAS_REPUTATION] > 80) set_deity_bias(DBIAS_REPUTATION, -1);
	}

	///mod151114 ̐l`̔
	if(p_ptr->pclass == CLASS_HINA && !(turn % (TURNS_PER_TICK * TOWN_DAWN / 24)))
	{
		p_ptr->magic_num1[1] += randint1((p_ptr->lev + p_ptr->stat_ind[A_CHR] + 3 + 20) * 5);
		if(p_ptr->magic_num1[1] > 100000) p_ptr->magic_num1[1] = 100000;
	}
	//u􂢂̐l`v̖
	if (p_ptr->pclass == CLASS_HINA && (p_ptr->special_defense & SD_HINA_NINGYOU))
	{
		hina_gain_yaku(-(50+randint1(100)));
		if(!p_ptr->magic_num1[0])
		{
			msg_print("cĂȂB");
			p_ptr->special_defense &= ~(SD_HINA_NINGYOU);
			p_ptr->redraw |= (PR_STATUS);
		}
	}

	//̑i 100JEgĖv
	if (p_ptr->pclass == CLASS_SHION && !(turn % (TURNS_PER_TICK * TOWN_DAWN / 200)))
	{
		int i;
		for (i = INVEN_RARM; i <= INVEN_FEET; i++)
		{
			shion_seizure(i);

		}

	}


	///mod140412  
	///mod150121 d
	if((prace_is_(RACE_VAMPIRE) 
		|| (prace_is_(RACE_WARBEAST) && p_ptr->pclass != CLASS_KEINE) 
		||p_ptr->mimic_form == MIMIC_VAMPIRE)
		&& !(turn % ((TURNS_PER_TICK * TOWN_DAWN) / 2)))
	{
		bool dawn;
		bool beast = prace_is_(RACE_WARBEAST);


		dawn = (!(turn % (TURNS_PER_TICK * TOWN_DAWN)));
		if(dawn)
		{
			if(beast)
			{
				if(turn / A_DAY % 30 + 15 == 30 && (dun_level))
				{
					msg_print("邪炵B");
					disturb(0,1);
				}
			}
			else
			{
				if(dun_level) msg_print("邪炵B");
				msg_print("̂邢EE");
				disturb(0,1);
			}
		}
		else
		{
			if(beast)
			{
				if(turn / A_DAY % 30 + 16 == 30)
				{
					if(dun_level) msg_print("񂾂炵B");
					msg_print("̔ӂI݂͂ȂI");
					disturb(0,1);
				}
			}
			else
			{
				if(dun_level) msg_print("񂾂炵B");
				if(turn / A_DAY % 30 + 16 == 30)
					msg_print("̔ӂI݂͂ȂI");
				else 
					msg_print("͂NĂB");
				disturb(0,1);
			}
		}
			p_ptr->redraw |= (PR_STATE);
			p_ptr->update |= (PU_BONUS);
			handle_stuff();
	}
	else if(p_ptr->pclass == CLASS_SUNNY && !(turn % ((TURNS_PER_TICK * TOWN_DAWN) / 2)) )
	{
		if(!(turn % (TURNS_PER_TICK * TOWN_DAWN)))
		{
			if(dun_level) msg_format("邪悤B");
			msg_format("CoĂI");
		}
		else
		{
			if(dun_level) msg_format("񂾂悤B");
			if(dun_level) msg_format("CoȂEE");
		}
			p_ptr->redraw |= (PR_STATE);
			p_ptr->update |= (PU_BONUS);
			handle_stuff();

	}
	else if(p_ptr->pclass == CLASS_LUNAR && !(turn % ((TURNS_PER_TICK * TOWN_DAWN) / 2)) )
	{
		if(!(turn % (TURNS_PER_TICK * TOWN_DAWN)))
		{
			if(dun_level) msg_format("邪悤B");
			msg_format("CoȂEE");
		}
		else
		{
			if(dun_level) msg_format("񂾂悤B");
			msg_format("CoĂB");
		}
			p_ptr->redraw |= (PR_STATE);
			p_ptr->update |= (PU_BONUS);
			handle_stuff();

	}

	
	///mod150121 dꏈ
	else if(p_ptr->pclass == CLASS_KEINE && !(p_ptr->inside_battle))
	{
		//ɒnɂƔ
		if(FULL_MOON && !dun_level && !p_ptr->magic_num1[0])
		{
			//[h}bv
			if(p_ptr->wild_mode)
			{
				energy_use = MIN(energy_use,100);
				change_wild_mode();
			}
			//ϐg
			if(p_ptr->mimic_form) set_mimic(0,0,TRUE);
			p_ptr->muta2_perma &= ~(MUT2_HARDHEAD);
			p_ptr->muta2 &= ~(MUT2_HARDHEAD);
			p_ptr->muta2 |= (MUT2_BIGHORN);//pψ
			p_ptr->muta2_perma |= (MUT2_BIGHORN);
			msg_print("B̐FςÅpꂽEE");
			//ꍇɂĂ͑
			if(inventory[INVEN_HEAD].k_idx && 
			(	inventory[INVEN_HEAD].sval == SV_HEAD_METALCAP 
			||  inventory[INVEN_HEAD].sval == SV_HEAD_STARHELM 
			||  inventory[INVEN_HEAD].sval == SV_HEAD_STEELHELM 
			||  inventory[INVEN_HEAD].sval == SV_HEAD_DRAGONHELM  ))
			{
				char obj_name[80];
				object_desc(obj_name, &inventory[INVEN_HEAD], 0);

				msg_format("%sEĂ܂I",obj_name);
				inven_takeoff(INVEN_HEAD,255);
				calc_android_exp();
				p_ptr->redraw |= (PR_EQUIPPY);
			}
			p_ptr->update |= (PU_BONUS);
			p_ptr->magic_num1[0] = 1;//tO
			handle_stuff();

		}
		//򉻉
		else if(!(FULL_MOON) && p_ptr->magic_num1[0])
		{
			if(p_ptr->wild_mode)
			{
				energy_use = MIN(energy_use,100);
				change_wild_mode();
			}
			//ϐg
			if(p_ptr->mimic_form) set_mimic(0,0,TRUE);
			msg_print("閾B̐F߂ÅpB");
			p_ptr->muta2_perma &= ~(MUT2_BIGHORN);
			p_ptr->muta2 &= ~(MUT2_BIGHORN);
			p_ptr->muta2 |= (MUT2_HARDHEAD);//Γ
			p_ptr->muta2_perma |= (MUT2_HARDHEAD);
			p_ptr->update |= (PU_BONUS);
			p_ptr->magic_num1[0] = 0;//tO
			handle_stuff();

		}
	}


#if 0
	/* While in the dungeon (vanilla_town or lite_town mode only) */
	/*:::K͂ȊXAc̒̃_Wł܂ɓX*/
	if ((vanilla_town || (lite_town && !p_ptr->inside_quest && !p_ptr->inside_battle && !p_ptr->inside_arena)) && dun_level)
	{
		/*** Shuffle the Storekeepers ***/

		/* Chance is only once a day (while in dungeon) */
		if (!(turn % (TURNS_PER_TICK * STORE_TICKS)))
		{
			/* Sometimes, shuffle the shop-keepers */
			if (one_in_(STORE_SHUFFLE))
			{
				int n, i;

				/* Pick a random shop (except home and museum) */
				do
				{
					n = randint0(MAX_STORES);
				}
				while ((n == STORE_HOME) || (n == STORE_MUSEUM));

				/* Check every feature */
				for (i = 1; i < max_f_idx; i++)
				{
					/* Access the index */
					feature_type *f_ptr = &f_info[i];

					/* Skip empty index */
					if (!f_ptr->name) continue;

					/* Skip non-store features */
					if (!have_flag(f_ptr->flags, FF_STORE)) continue;

					/* Verify store type */
					if (f_ptr->subtype == n)
					{
						/* Message */
#ifdef JP
						if (cheat_xtra) msg_format("%s̓XVbt܂B", f_name + f_ptr->name);
#else
						if (cheat_xtra) msg_format("Shuffle a Shopkeeper of %s.", f_name + f_ptr->name);
#endif

						/* Shuffle it */
						//store_shuffle(n);

						break;
					}
				}
			}
		}
	}
#endif

	/*** Process the monsters ***/
	/*:::_WɐVȃX^[N*/
	/* Check for creature generation. */
	if (one_in_(d_info[dungeon_type].max_m_alloc_chance) &&
	    !p_ptr->inside_arena && !p_ptr->inside_quest && !p_ptr->inside_battle && !(EXTRA_QUEST_FLOOR))
	{
		/* Make a new monster */
		(void)alloc_monster(MAX_SIGHT + 5, 0);
	}

	/* Hack -- Check for creature regeneration */
	/*:::X^[*/
	if (!(turn % (TURNS_PER_TICK*10)) && !p_ptr->inside_battle) regen_monsters();
	if (!(turn % (TURNS_PER_TICK*3))) regen_captured_monsters();

	/*:::tr_g̋AҖߏ*/
	if (!(turn % (TURNS_PER_TICK*10)) && p_ptr->pclass == CLASS_TSUKUMO_MASTER && !(p_ptr->inside_battle)) tsukumo_recall();


	if (!p_ptr->leaving)
	{
		int i;

		/* Hack -- Process the counters of monsters if needed */
		/*:::MAX_MTIMED=7*/
		for (i = 0; i < MAX_MTIMED; i++)
		{
			if (mproc_max[i] > 0) process_monsters_mtimed(i);
		}
	}

	/*:::oChזENHψق󂯂ĂƃJEgJn@3ŃQ[I[o[@ÂĂJEg̓ZbgȂ*/
	if(p_ptr->muta3 & MUT3_BYDO)
	{
		p_ptr->bydo += TURNS_PER_TICK;
		if((s32b)p_ptr->bydo > A_DAY * 3) p_ptr->bydo = A_DAY * 3+1;
		if((s32b)p_ptr->bydo > A_DAY * 3 && !(p_ptr->inside_battle)) take_hit(DAMAGE_LOSELIFE,9999,"Ă̗[@₳}Ă̂́@CBȂ̂H",0);
	}

	/*:::[zCg̃JEg_E*/
	if(p_ptr->pclass == CLASS_LILY_WHITE)
	{
		if(turn > A_DAY * LILY_LIMIT && !(p_ptr->inside_battle)) take_hit(DAMAGE_LOSELIFE,9999,"t̏I",0);
	}
	/*:::̃JEg_E*/
	if(p_ptr->pclass == CLASS_RAN && !p_ptr->total_winner)
	{
		if(turn > A_DAY * RAN_LIMIT && !(p_ptr->inside_battle)) take_hit(DAMAGE_LOSELIFE,9999,"傩̍ċ",0);
	}
	/* Date changes */
	/*:::LLƖ{̏܋ύX@t͂ǂŕς̂H*/
	///system
	if (!hour && !min)
	{
		if (min != prev_min)
		{
			p_ptr->today_mon = 0; //얲肢Zbg

			do_cmd_write_nikki(NIKKI_HIGAWARI, 0, NULL);
		//	determine_today_mon(FALSE);
		}
	}
	/*:::[h̑ẨO*/
	/*
	 * Nightmare mode activates the TY_CURSE at midnight
	 *
	 * Require exact minute -- Don't activate multiple times in a minute
	 */
	if (ironman_nightmare && (min != prev_min))
	{
		/* Every 15 minutes after 11:00 pm */
		if ((hour == 23) && !(min % 15))
		{
			/* Disturbing */
			disturb(0, 1);

			switch (min / 15)
			{
			case 0:
#ifdef JP
				msg_print("ŕsCȏ̉B");
#else
				msg_print("You hear a distant bell toll ominously.");
#endif
				break;

			case 1:
#ifdef JP
				msg_print("ŏB");
#else
				msg_print("A distant bell sounds twice.");
#endif
				break;

			case 2:
#ifdef JP
				msg_print("ŏOB");
#else
				msg_print("A distant bell sounds three times.");
#endif
				break;

			case 3:
#ifdef JP
				msg_print("ŏlB");
#else
				msg_print("A distant bell tolls four times.");
#endif
				break;
			}
		}

		/* TY_CURSE activates at midnight! */
		if (!hour && !min)
		{
			int count = 0;

			disturb(1, 1);
#ifdef JP
			msg_print("ŏA񂾂悤ȐÂ̒֏ĂB");
#else
			msg_print("A distant bell tolls many times, fading into an deathly silence.");
#endif

			activate_ty_curse(FALSE, &count);
		}
	}


	/*** Check the Food, and Regenerate ***/
	/*:::̖x*/
	///system @gdl`͂ŋ󕠂ɂȂȂ悤ɂ΂Hset_foodłق
	if (!p_ptr->inside_battle)
	{
		/* Digest quickly when gorged */
		if (p_ptr->food >= PY_FOOD_MAX)
		{
			/* Digest a lot of food */
			(void)set_food(p_ptr->food - 100);
		}

		/* Digest normally -- Every 50 game turns */
		///sys }񕜂ݐςɂ͂̕ӂKv
		else if (!(turn % (TURNS_PER_TICK*5)))
		{
			/* Basic digestion rate based on speed */
			int digestion = SPEED_TO_ENERGY(p_ptr->pspeed);

			/* Regeneration takes more food */
			if (p_ptr->regenerate)
				digestion += 20;
			if (p_ptr->special_defense & (KAMAE_MASK | KATA_MASK))
				digestion += 20;
			if (p_ptr->cursed & TRC_FAST_DIGEST)
				digestion += 30;

			if(p_ptr->pclass == CLASS_YOSHIKA)
				digestion += 20;


			/* Slow digestion takes less food */
			if (p_ptr->slow_digest)
				digestion -= 5;
			///mod140608 푰Ƃɖƕ␳
			if(p_ptr->prace == RACE_SENNIN) digestion /= 3;
			if(p_ptr->prace == RACE_FAIRY) digestion /= 3;
			if(p_ptr->pclass == CLASS_HINA)	digestion /= 3;
			if(p_ptr->prace == RACE_ONI) digestion += 10;


			/* Minimal digestion */
			if (digestion < 1) digestion = 1;
			/* Maximal digestion */
			if (digestion > 100) digestion = 100;

			//d()
			if(CHECK_FAIRY_TYPE ==37 && !dun_level && turn % (TURNS_PER_TICK * TOWN_DAWN) < 50000)
			{
				set_food(MIN(p_ptr->food + digestion,PY_FOOD_MAX-1));
			}
			/* Digest some food */
			else 
				(void)set_food(p_ptr->food - digestion);
		}


		/* Getting Faint */
		if ((p_ptr->food < PY_FOOD_FAINT))
		{
			/* Faint occasionally */
			if (!p_ptr->paralyzed && (randint0(100) < 10))
			{
				/* Message */
#ifdef JP
				msg_print("܂ɂ󕠂ŋC₵Ă܂B");
#else
				msg_print("You faint from the lack of food.");
#endif

				disturb(1, 1);

				/* Hack -- faint (bypass free action) */
				(void)set_paralyzed(p_ptr->paralyzed + 1 + randint0(5));
				if(one_in_(2)) set_deity_bias(DBIAS_REPUTATION, -1);
			}

			/* Starve to death (slowly) */
			if (p_ptr->food < PY_FOOD_STARVE)
			{
				/* Calculate damage */
				int dam = (PY_FOOD_STARVE - p_ptr->food) / 10;

				/* Take damage */
#ifdef JP
				if (!IS_INVULN()) take_hit(DAMAGE_LOSELIFE, dam, "", -1);
#else
				if (!IS_INVULN()) take_hit(DAMAGE_LOSELIFE, dam, "starvation", -1);
#endif
			}
		}
	}


	///mod140302 l(ؐӊO)ƓVl_ɏP鏈
	//v1.1.42 EXTRANGXgtAł͏oȂ悤ɂ
	if ((p_ptr->prace == RACE_SENNIN || p_ptr->prace == RACE_TENNIN) 
		&& (p_ptr->pclass != CLASS_KASEN) 
		&& p_ptr->lev > 19 
		&& !p_ptr->inside_arena 
		&& !(EXTRA_QUEST_FLOOR)
		&& !p_ptr->inside_battle 
		&& (!p_ptr->inside_quest || !is_fixed_quest_idx(p_ptr->inside_quest)))
	{
		int chance = 3000 - dun_level * 16;
		if( one_in_(chance))
		{
			if (summon_specific(0, py, px, dun_level, SUMMON_DEATH,(PM_ALLOW_GROUP | PM_ALLOW_UNIQUE | PM_NO_PET)))
				msg_format("n̎hqꂽI");
		}
	}


	if(p_ptr->special_defense & MUSOU_TENSEI)
	{
		if(p_ptr->csp < 50)
		{
			msg_print("ĂїlXȂ̂ɂƂ悤ɂȂB");
			p_ptr->special_defense &= ~(MUSOU_TENSEI);
			p_ptr->redraw |= (PR_MAP | PR_STATUS);
			p_ptr->update |= (PU_MONSTERS | PU_BONUS);
			p_ptr->window |= (PW_OVERHEAD | PW_DUNGEON);
		}
		else
		{
			p_ptr->csp -= 50;
			p_ptr->redraw |= PR_MANA;
		}
	}



	///mod140821 GWjǍ̏ᒆ̋@BC鏈
	engineer_malfunction(0, 1);

	/*:::Dxɂ鏈*/
	process_world_aux_alcohol();

	/* Process timed damage and regeneration */
	process_world_aux_hp_and_sp();

	/* Process timeout */
	process_world_aux_timeout();

	/* Process light */
	process_world_aux_light();

	/* Process mutation effects */
	process_world_aux_mutation();

	/* Process curse effects */
	process_world_aux_curse();

	/* Process recharging */
	process_world_aux_recharge();

	/* Feel the inventory */
	sense_inventory1();
	sense_inventory2();

	/* Involuntary Movement */
	process_world_aux_movement();
}

///mod140225
/*:::bR}hŕ\I*/
int choose_browse(void)
{
	int j, line;
	char temp[62*5];
	char com;

	screen_save();
	while(1)
	{
		Term_erase(12, 5, 255);
		Term_erase(12, 4, 255);
		Term_erase(12, 3, 255);
		Term_erase(12, 2, 255);
		Term_erase(12, 1, 255);

		put_str("a/u/U) g̓EˑRψق̔", 2, 16);
		put_str("b/m/M) Kς݂̖@", 3, 16);
		put_str("c/j/J) Kς݂̐EƓZ", 4, 16);

		prt("ɂĂ̐ǂ݂܂H",0,0);
		com = inkey();
		if (com == ESCAPE){ screen_load();return 0;}
		if (com=='a'||com=='u'||com=='U') {screen_load();return 1;}
		if (com=='b'||com=='m'||com=='M') {screen_load();return 2;}
		if (com=='c'||com=='j'||com=='J') {screen_load();return 3;}
	}
	
}



/*
 * Verify use of "wizard" mode
 */
static bool enter_wizard_mode(void)
{
	/* Ask first time */
	if (!p_ptr->noscore)
	{
		/* Wizard mode is not permitted */
		if (!allow_debug_opts || arg_wizard)
		{
#ifdef JP
			msg_print("EBU[h[h͋Ă܂B ");
#else
			msg_print("Wizard mode is not permitted.");
#endif
			return FALSE;
		}

		/* Mention effects */
#ifdef JP
		msg_print("EBU[h[h̓fobOƎ̂߂̃[hłB ");
		msg_print("xEBU[h[hɓƃXRA͋L^܂B");
#else
		msg_print("Wizard mode is for debugging and experimenting.");
		msg_print("The game will not be scored if you enter wizard mode.");
#endif

		msg_print(NULL);

		/* Verify request */
#ifdef JP
		if (!get_check("{ɃEBU[h[hɓ肽̂ł? "))
#else
		if (!get_check("Are you sure you want to enter wizard mode? "))
#endif
		{
			return (FALSE);
		}

		if (p_ptr->pseikaku == SEIKAKU_COLLECTOR)
		{
			msg_print("EBU[h[hɓƎ̏NWƂɃGgXpȂȂ܂B");
			if(!get_check("***{***낵ł? "))	return FALSE;
		}


#ifdef JP
		do_cmd_write_nikki(NIKKI_BUNSHOU, 0, "EBU[h[hɓ˓ăXRAcȂȂB");
#else
		do_cmd_write_nikki(NIKKI_BUNSHOU, 0, "give up recording score to enter wizard mode.");
#endif
		/* Mark savefile */
		p_ptr->noscore |= 0x0002;
	}

	/* Success */
	return (TRUE);
}


#ifdef ALLOW_WIZARD

/*
 * Verify use of "debug" commands
 */
static bool enter_debug_mode(void)
{
	/* Ask first time */
	if (!p_ptr->noscore)
	{
		/* Debug mode is not permitted */
		if (!allow_debug_opts)
		{
#ifdef JP
			msg_print("fobOR}h͋Ă܂B ");
#else
			msg_print("Use of debug command is not permitted.");
#endif
			return FALSE;
		}

		/* Mention effects */
#ifdef JP
		msg_print("fobOER}h̓fobOƎ̂߂̃R}hłB ");
		msg_print("fobOER}hgƃXRA͋L^܂B");
#else
		msg_print("The debug commands are for debugging and experimenting.");
		msg_print("The game will not be scored if you use debug commands.");
#endif

		msg_print(NULL);

		/* Verify request */
#ifdef JP
		if (!get_check("{ɃfobOER}hg܂? "))
#else
		if (!get_check("Are you sure you want to use debug commands? "))
#endif
		{
			return (FALSE);
		}

		if (p_ptr->pseikaku == SEIKAKU_COLLECTOR)
		{
			msg_print("fobOR}hgƎ̏NWƂɃGgXpȂȂ܂B");
			if(!get_check("***{***낵ł? "))	return FALSE;
		}

#ifdef JP
		do_cmd_write_nikki(NIKKI_BUNSHOU, 0, "fobO[hɓ˓ăXRAcȂȂB");
#else
		do_cmd_write_nikki(NIKKI_BUNSHOU, 0, "give up sending score to use debug commands.");
#endif
		/* Mark savefile */
		p_ptr->noscore |= 0x0008;
	}

	/* Success */
	return (TRUE);
}

/*
 * Hack -- Declare the Debug Routines
 */
extern void do_cmd_debug(void);

#endif /* ALLOW_WIZARD */


#ifdef ALLOW_BORG

/*
 * Verify use of "borg" commands
 */
static bool enter_borg_mode(void)
{
	/* Ask first time */
	if (!(p_ptr->noscore & 0x0010))
	{
		/* Mention effects */
#ifdef JP
		msg_print("{[OER}h̓fobOƎ̂߂̃R}hłB ");
		msg_print("{[OER}hgƃXRA͋L^܂B");
#else
		msg_print("The borg commands are for debugging and experimenting.");
		msg_print("The game will not be scored if you use borg commands.");
#endif

		msg_print(NULL);

		/* Verify request */
#ifdef JP
		if (!get_check("{Ƀ{[OER}hg܂? "))
#else
		if (!get_check("Are you sure you want to use borg commands? "))
#endif
		{
			return (FALSE);
		}

#ifdef JP
		do_cmd_write_nikki(NIKKI_BUNSHOU, 0, "{[OER}hgpăXRAcȂȂB");
#else
		do_cmd_write_nikki(NIKKI_BUNSHOU, 0, "give up recording score to use borg commands.");
#endif
		/* Mark savefile */
		p_ptr->noscore |= 0x0010;
	}

	/* Success */
	return (TRUE);
}

/*
 * Hack -- Declare the Ben Borg
 */
extern void do_cmd_borg(void);

#endif /* ALLOW_BORG */



/*
 * Parse and execute the current command
 * Give "Warning" on illegal commands.
 *
 * XXX XXX XXX Make some "blocks"
 */
static void process_command(void)
{
	int old_now_message = now_message;

#ifdef ALLOW_REPEAT /* TNB */

	/* Handle repeating the last command */
	/*:::R}h'n'̂ƂAÕR}hĂcommand_cmdɓBłȂƂR}h̃s[gpɓo^B*/
	repeat_check();

#endif /* ALLOW_REPEAT -- TNB */

	now_message = 0;

	/* Sniper */
	///class XiCp[W
	//if ((p_ptr->pclass == CLASS_SNIPER) && (p_ptr->concent))
	///mod141116 XiCp[ύX
	if ((CLASS_USE_CONCENT) && (p_ptr->concent))
		reset_concent = TRUE;

	break_eibon_flag = TRUE;

	/* Parse the command */
	switch (command_cmd)
	{
		/* Ignore */
		case ESCAPE:
		case ' ':
		{
			break;
		}

		/* Ignore return */
		case '\r':
		case '\n':
		{
			break;
		}

		/*** Wizard Commands ***/

		/* Toggle Wizard Mode */
		case KTRL('W'):
		{
			if (p_ptr->wizard)
			{
				p_ptr->wizard = FALSE;
#ifdef JP
msg_print("EBU[h[hB");
#else
				msg_print("Wizard mode off.");
#endif

			}
			else if (enter_wizard_mode())
			{
				p_ptr->wizard = TRUE;
#ifdef JP
msg_print("EBU[h[h˓B");
#else
				msg_print("Wizard mode on.");
#endif

			}

			/* Update monsters */
			p_ptr->update |= (PU_MONSTERS);

			/* Redraw "title" */
			p_ptr->redraw |= (PR_TITLE);

			break;
		}


#ifdef ALLOW_WIZARD

		/* Special "debug" commands */
		case KTRL('A'):
		{
			/* Enter debug mode */
			if (enter_debug_mode())
			{
				do_cmd_debug();
			}
			break;
		}

#endif /* ALLOW_WIZARD */


#ifdef ALLOW_BORG

		/* Special "borg" commands */
		case KTRL('Z'):
		{
			/* Enter borg mode */
			if (enter_borg_mode())
			{
				if (!p_ptr->wild_mode) do_cmd_borg();
			}

			break;
		}

#endif /* ALLOW_BORG */



		/*** Inventory Commands ***/

		/* Wear/wield equipment */
		case 'w':
		{
			if (!p_ptr->wild_mode) 
			{
				if(p_ptr->pclass == CLASS_3_FAIRIES)
					do_cmd_wield_3_fairies();
				else
					do_cmd_wield(FALSE);
			}
			break_eibon_flag = FALSE;
			break;
		}

		/* Take off equipment */
		case 't':
		{
			if (!p_ptr->wild_mode) do_cmd_takeoff();
			break_eibon_flag = FALSE;
			break;
		}

		/* Drop an item */
		case 'd':
		{
			if (!p_ptr->wild_mode) do_cmd_drop();
			break;
		}

		/* Destroy an item */
		case 'k':
		{
			do_cmd_destroy();
			break_eibon_flag = FALSE;
			break;
		}

		/* Equipment list */
		case 'e':
		{
			do_cmd_equip();
			break;
		}

		/* Inventory list */
		case 'i':
		{
			do_cmd_inven();
			break;
		}


		/*** Various commands ***/

		/* Identify an object */

		case 'I':
		{
			do_cmd_observe();
			break;
		}

		/* Hack -- toggle windows */
		/*:::TuEBhȆꗗƃUbNꗗ؂ւ*/
		case KTRL('I'):
		{
			toggle_inven_equip();
			break;
		}


		/*** Standard "Movement" Commands ***/

		/* Alter a grid */
		/*:::wɉėpR}h*/
		case '+':
		{
			if (!p_ptr->wild_mode) do_cmd_alter();
			break;
		}

		/* Dig a tunnel */
		case 'T':
		{
			if (!p_ptr->wild_mode) do_cmd_tunnel();
			break;
		}

		/* Move (usually pick up things) */
		case ';':
		{
#ifdef ALLOW_EASY_DISARM /* TNB */

			do_cmd_walk(FALSE);

#else /* ALLOW_EASY_DISARM -- TNB */

			do_cmd_walk(always_pickup);

#endif /* ALLOW_EASY_DISARM -- TNB */

			break;
		}

		/* Move (usually do not pick up) */
		case '-':
		{
#ifdef ALLOW_EASY_DISARM /* TNB */

			do_cmd_walk(TRUE);

#else /* ALLOW_EASY_DISARM -- TNB */

			do_cmd_walk(!always_pickup);

#endif /* ALLOW_EASY_DISARM -- TNB */

			break;
		}

		//v1.1.27 EK[h
		case KTRL('g'):
		{
			if(set_mana_shield(TRUE,FALSE))
				energy_use = 100;
			break;
		}

		/*** Running, Resting, Searching, Staying */

		/* Begin Running -- Arg is Max Distance */
		case '.':
		{
			if (!p_ptr->wild_mode) do_cmd_run();
			break;
		}

		/* Stay still (usually pick things up) */
		case ',':
		{
			do_cmd_stay(always_pickup);
			break;
		}

		/* Stay still (usually do not pick up) */
		case 'g':
		{
			do_cmd_stay(!always_pickup);
			break;
		}

		/* Rest -- Arg is time */
		case 'R':
		{
			do_cmd_rest();
			break;
		}

		/* Search for traps/doors */
		case 's':
		{
			do_cmd_search();
			break;
		}

		/* Toggle search mode */
		case 'S':
		{
			if (p_ptr->action == ACTION_SEARCH) set_action(ACTION_NONE);
			else set_action(ACTION_SEARCH);
			break;
		}


		/*** Stairs and Doors and Chests and Traps ***/

		/* Enter store */
		case SPECIAL_KEY_STORE:
		{
			if (!p_ptr->wild_mode) do_cmd_store();
			break;
		}

		/* Enter building -KMW- */
		case SPECIAL_KEY_BUILDING:
		{
			if (!p_ptr->wild_mode) do_cmd_bldg();
			break;
		}

		/* Enter quest level -KMW- */
		case SPECIAL_KEY_QUEST:
		{
			if (!p_ptr->wild_mode) do_cmd_quest();
			break;
		}

		/* Go up staircase */
		case '<':
		{


			if (!p_ptr->wild_mode && !dun_level && !p_ptr->inside_arena && !p_ptr->inside_quest)
			{
				if (vanilla_town) break;

				if (ambush_flag && !SAKUYA_WORLD)
				{
#ifdef JP
					msg_print("P瓦ɂ̓}bv̒[܂ňړȂ΂ȂȂB");
#else
					msg_print("To flee the ambush you have to reach the edge of the map.");
#endif
					break;
				}

				if (p_ptr->food < PY_FOOD_WEAK)
				{
#ifdef JP
					msg_print("̑OɐHƂȂƁB");
#else
					msg_print("You must eat something here.");
#endif
					break;
				}

				change_wild_mode();
			}
			else
				do_cmd_go_up();
			break;
		}

		/* Go down staircase */
		case '>':
		{
			if(cave_have_flag_bold(py,px,FF_PORTAL))
				pass_through_portal();
			else if (p_ptr->wild_mode)
				change_wild_mode();
			else
				do_cmd_go_down();

			break;
		}

		/* Open a door or chest */
		case 'o':
		{
			if (!p_ptr->wild_mode) do_cmd_open();
			break;
		}

		/* Close a door */
		case 'c':
		{
			if (!p_ptr->wild_mode) do_cmd_close();
			break;
		}

		/* Jam a door with spikes */
		case 'j':
		{
			//łR}h폜
			//if (!p_ptr->wild_mode) do_cmd_spike();
			//EƔ\͐ĂBbR}hɓ\B
			///mod140906 [OCNR}ĥƂZsɂ悤ɕύX
			if(rogue_like_commands)
			{
				 if(!p_ptr->wild_mode || p_ptr->pclass == CLASS_YUKARI) do_cmd_new_class_power(FALSE);
			}
			else do_cmd_new_class_power(TRUE);

			break;
		}
		case 'J':
		{
			///mod140202 EƂƓ\
			if (!(p_ptr->wild_mode && p_ptr->pclass != CLASS_YUKARI)) do_cmd_new_class_power(FALSE);
			break;
		}

		/* Bash a door */
		case 'B':
		{
			if (!p_ptr->wild_mode) do_cmd_bash();
			break;
		}

		/* Disarm a trap or chest */
		case 'D':
		{
			if (!p_ptr->wild_mode) do_cmd_disarm();
			break;
		}


		/*** Magic and Prayers ***/

		/* Gain new spells/prayers */
		case 'G':
		{
			///class realm
			///sys wK@肩yieBɂ邩H
			//if ((p_ptr->pclass == CLASS_SORCERER) || (p_ptr->pclass == CLASS_RED_MAGE))
			if (REALM_SPELLMASTER)
				msg_print("Ȃ͎wKKv͂ȂB");
			else if (p_ptr->pclass == CLASS_SAMURAI || p_ptr->pclass == CLASS_YOUMU)
				do_cmd_gain_hissatsu();
			else if (p_ptr->pclass == CLASS_MAGIC_EATER || p_ptr->pclass == CLASS_SEIJA)
				gain_magic();
			else
				do_cmd_study();

			break_eibon_flag = FALSE;

			break;
		}

		/* Browse a book */
		case 'b':
		{
			int choose;
			if (!repeat_pull(&choose))
			{
				choose = choose_browse();
				if(choose) repeat_push(choose);
			}
			switch(choose)
			{
			case 0:
				break;
			case 1:
				do_cmd_racial_power(TRUE);
				break;
			case 2:
				if(p_ptr->pclass == CLASS_MINDCRAFTER || p_ptr->pclass == CLASS_SUMIREKO) do_cmd_mind_browse();
				else do_cmd_browse();
				break;
			case 3:
				do_cmd_new_class_power(TRUE);
				break;
			}
			break;

/*
			if ( (p_ptr->pclass == CLASS_MINDCRAFTER) ||
			     (p_ptr->pclass == CLASS_BERSERKER) ||
			     (p_ptr->pclass == CLASS_NINJA) ||
			     (p_ptr->pclass == CLASS_MIRROR_MASTER) 
			     ) do_cmd_mind_browse();
			else if (p_ptr->pclass == CLASS_SMITH)
				msg_print("bꎞ");
				//do_cmd_kaji(TRUE);
			else if (p_ptr->pclass == CLASS_MAGIC_EATER)
				do_cmd_magic_eater(TRUE, FALSE);
			else if (p_ptr->pclass == CLASS_SNIPER)
				do_cmd_snipe_browse();
			else do_cmd_browse();
			break;
*/
		}

		/* Cast a spell */
		///class mR}h
		case 'm':
		{
			/* -KMW- */
			if (!p_ptr->wild_mode)
			{
				//if ((p_ptr->pclass == CLASS_WARRIOR) || (p_ptr->pclass == CLASS_ARCHER) || (p_ptr->pclass == CLASS_CAVALRY))
				if(cp_ptr->realm_aptitude[0] == 0 && p_ptr->pclass != CLASS_SAMURAI 
					&& p_ptr->pclass != CLASS_YOUMU && p_ptr->pclass != CLASS_MINDCRAFTER && p_ptr->pclass != CLASS_SUMIREKO && p_ptr->pclass != CLASS_SEIJA 
					&& p_ptr->pclass != CLASS_MAGIC_EATER )
				{
#ifdef JP
					msg_print("Ȃ͎gȂB");
#else
					msg_print("You cannot cast spells!");
#endif
				}
				else if (dun_level && (d_info[dungeon_type].flags1 & DF1_NO_MAGIC)/* && (p_ptr->pclass != CLASS_SMITH)*/)
				{
#ifdef JP
					msg_print("_W@zI");
#else
					msg_print("The dungeon absorbs all attempted magic!");
#endif
					msg_print(NULL);
				}
				else if (p_ptr->anti_magic && (p_ptr->pclass != CLASS_BERSERKER)/* && (p_ptr->pclass != CLASS_SMITH)*/)
				{
#ifdef JP

					cptr which_power = "@";
#else
					cptr which_power = "magic";
#endif
					if (p_ptr->pclass == CLASS_MINDCRAFTER || p_ptr->pclass == CLASS_SUMIREKO)
#ifdef JP
						which_power = "\";
#else
						which_power = "psionic powers";
#endif
					else if (p_ptr->pclass == CLASS_IMITATOR)
#ifdef JP
						which_power = "̂܂";
#else
						which_power = "imitation";
#endif
					else if (p_ptr->pclass == CLASS_SAMURAI || p_ptr->pclass == CLASS_YOUMU)
#ifdef JP
						which_power = "KE";
#else
						which_power = "hissatsu";
#endif
					else if (p_ptr->pclass == CLASS_MIRROR_MASTER)
#ifdef JP
						which_power = "@";
#else
						which_power = "mirror magic";
#endif
/*
					else if (p_ptr->pclass == CLASS_NINJA)
#ifdef JP
						which_power = "Ep";
#else
						which_power = "ninjutsu";
#endif
*/
/*
					else if (mp_ptr->spell_book == TV_LIFE_BOOK)
#ifdef JP
						which_power = "F";
#else
						which_power = "prayer";
#endif
*/

#ifdef JP
					msg_format("@oA%sזI", which_power);
#else
					msg_format("An anti-magic shell disrupts your %s!", which_power);
#endif
					energy_use = 0;
				}

				else if (p_ptr->shero && p_ptr->pseikaku != SEIKAKU_BERSERK )
				{
#ifdef JP
					msg_format("mĂēȂI");
#else
					msg_format("You cannot think directly!");
#endif
					energy_use = 0;
				}
				else
				{
					if ((p_ptr->pclass == CLASS_MINDCRAFTER) ||
					    (p_ptr->pclass == CLASS_SUMIREKO) ||
					   // (p_ptr->pclass == CLASS_BERSERKER) ||
					   // (p_ptr->pclass == CLASS_NINJA) ||
					    (p_ptr->pclass == CLASS_MIRROR_MASTER)
					    )
						do_cmd_mind();
					///sysdel ̂܂ˁAAbAXiCp[͂΂炭Ă
					else if (p_ptr->pclass == CLASS_IMITATOR)
						do_cmd_mane(FALSE);
					else if (p_ptr->pclass == CLASS_MAGIC_EATER || p_ptr->pclass == CLASS_SEIJA)
						do_cmd_magic_eater(FALSE, FALSE);
					else if (p_ptr->pclass == CLASS_SAMURAI || p_ptr->pclass == CLASS_YOUMU)
						do_cmd_hissatsu();
					else if (p_ptr->pclass == CLASS_BLUE_MAGE)
						do_cmd_cast_learned();
					//else if (p_ptr->pclass == CLASS_SMITH)
					//do_cmd_kaji(FALSE);
					else if (p_ptr->pclass == CLASS_SNIPER)
						do_cmd_snipe();
					else
						do_cmd_cast();
				}
			}
			break;
		}

		/* Issue a pet command */
		case 'p':
		{
			if (!p_ptr->wild_mode) do_cmd_pet();
			break;
		}

		/*** Use various objects ***/

		/* Inscribe an object */
		/*:::ACeɖt*/
		case '{':
		{
			do_cmd_inscribe();
			break;
		}

		/* Uninscribe an object */
		/*:::ACe̖*/
		case '}':
		{
			do_cmd_uninscribe();
			break;
		}

		/* Activate an artifact */
		case 'A':
		{
			if (!p_ptr->wild_mode)
			{
				do_cmd_activate();
				//v1.1.51 A[iłނg邱Ƃɂ
#if 0
			if (!p_ptr->inside_arena)
				do_cmd_activate();
			else
			{
#ifdef JP
msg_print("A[i@zI");
#else
				msg_print("The arena absorbs all attempted magic!");
#endif

				msg_print(NULL);
			}
#endif
			}
			break;
		}

		/* Eat some food */
		case 'E':
		{
			do_cmd_eat_food();
			break;
		}

		/* Fuel your lantern/torch */
		case 'F':
		{
			do_cmd_refill();
			break_eibon_flag = FALSE;
			break;
		}

		/* Fire an item */
		case 'f':
		{
			if (!p_ptr->wild_mode) (void)do_cmd_fire();
			break;
		}

		/* Throw an item */
		case 'v':
		{
			if (!p_ptr->wild_mode)
			{
				do_cmd_throw();
			}
			break;
		}

		/* Aim a wand */
		case 'a':
		{
			if (!p_ptr->wild_mode)
			{
				//v1.1.51 A[iłނg邱Ƃɂ
				do_cmd_aim_wand();
#if 0
				if (!p_ptr->inside_arena)
				do_cmd_aim_wand();
			else
			{
#ifdef JP
msg_print("A[i@zI");
#else
				msg_print("The arena absorbs all attempted magic!");
#endif

				msg_print(NULL);
			}
#endif
			}
			break;
		}

		/* Zap a rod */
		case 'z':
		{
			if (!p_ptr->wild_mode)
			{
				//v1.1.51 A[iłނg邱Ƃɂ
				if (use_command && rogue_like_commands)
				{
					do_cmd_use();
				}
				else
				{
					do_cmd_zap_rod();
				}


#if 0
			if (p_ptr->inside_arena)
			{
#ifdef JP
msg_print("A[i@zI");
#else
				msg_print("The arena absorbs all attempted magic!");
#endif

				msg_print(NULL);
			}
			else if (use_command && rogue_like_commands)
			{
				do_cmd_use();
			}
			else
			{
				do_cmd_zap_rod();
			}
#endif
			}
			break;
		}

		/* Quaff a potion */
		case 'q':
		{
			if (!p_ptr->wild_mode)
			{
				//v1.1.51 A[iłނg邱Ƃɂ
				do_cmd_quaff_potion();
#if 0
			if (!p_ptr->inside_arena)
				do_cmd_quaff_potion();
			else
			{
#ifdef JP
msg_print("A[i@zI");
#else
				msg_print("The arena absorbs all attempted magic!");
#endif

				msg_print(NULL);
			}
#endif
			}
			break;
		}

		/* Read a scroll */
		case 'r':
		{
			if (!p_ptr->wild_mode)
			{
				//v1.1.51 A[iłނg邱Ƃɂ
				do_cmd_read_scroll();
#if 0
				if (!p_ptr->inside_arena)
				do_cmd_read_scroll();
			else
			{
#ifdef JP
msg_print("A[i@zI");
#else
				msg_print("The arena absorbs all attempted magic!");
#endif

				msg_print(NULL);
			}
#endif
			}
			break;
		}

		/* Use a staff */
		case 'u':
		{
			if (!p_ptr->wild_mode)
			{
			//v1.1.51 A[iłނg邱Ƃɂ
			//if (p_ptr->inside_arena)
			if(FALSE)
			{
#ifdef JP
msg_print("A[i@zI");
#else
				msg_print("The arena absorbs all attempted magic!");
#endif

				msg_print(NULL);
			}
			else if (use_command && !rogue_like_commands)
			{
				do_cmd_use();
			}
			else
				do_cmd_use_staff();
			}
			break;
		}

		/* Use racial power */
		case 'U':
		{
			if (!p_ptr->wild_mode) do_cmd_racial_power(FALSE);
			break;
		}


		/*** Looking at Things (nearby or on map) ***/

		/* Full dungeon map */
		case 'M':
		{
			do_cmd_view_map();
			break;
		}

		/* Locate player on map */
		case 'L':
		{
			do_cmd_locate();
			break;
		}

		/* Look around */
		case 'l':
		{
			do_cmd_look();
			break;
		}

		/* Target monster or location */
		case '*':
		{
			if (!p_ptr->wild_mode) do_cmd_target();
			break;
		}



		/*** Help and Such ***/

		/* Help */
		case '?':
		{
			do_cmd_help();
			break;
		}

		/* Identify symbol */
		case '/':
		{
			do_cmd_query_symbol();
			break;
		}

		/* Character description */
		case 'C':
		{
			do_cmd_change_name();
			break;
		}


		/*** System Commands ***/

		/* Hack -- User interface */
		case '!':
		{
			(void)Term_user(0);
			break;
		}

		/* Single line from a pref file */
		case '"':
		{
			do_cmd_pref();
			break;
		}

		case '$':
		{
			do_cmd_reload_autopick();
			break;
		}
		case '_':
		{
			do_cmd_edit_autopick();
			break;
		}

		/* Interact with macros */
		case '@':
		{
			do_cmd_macros();
			break;
		}

		/* Interact with visuals */
		case '%':
		{
			do_cmd_visuals();
			do_cmd_redraw();
			break;
		}

		/* Interact with colors */
		case '&':
		{
			do_cmd_colors();
			do_cmd_redraw();
			break;
		}

		/* Interact with options */
		case '=':
		{
			do_cmd_options();
			(void)combine_and_reorder_home(STORE_HOME);
			do_cmd_redraw();
			break;
		}

		/*** Misc Commands ***/

		/* Take notes */
		case ':':
		{
			do_cmd_note();
			break;
		}

		/* Version info */
		case 'V':
		{
			do_cmd_version();
			break;
		}

		/* Repeat level feeling */
		case KTRL('F'):
		{
			if (!p_ptr->wild_mode) do_cmd_feeling();
			break;
		}

		/* Show previous message */
		case KTRL('O'):
		{
			do_cmd_message_one();
			break;
		}

		/* Show previous messages */
		case KTRL('P'):
		{
			do_cmd_messages(old_now_message);
			break;
		}

		/* Show quest status -KMW- */
		case KTRL('Q'):
		{
			do_cmd_checkquest();
			break;
		}

		/* Redraw the screen */
		case KTRL('R'):
		{
			now_message = old_now_message;
			do_cmd_redraw();
			break;
		}

#ifndef VERIFY_SAVEFILE

		/* Hack -- Save and don't quit */
		case KTRL('S'):
		{
			do_cmd_save_game(FALSE);
			break;
		}

#endif /* VERIFY_SAVEFILE */

		case KTRL('T'):
		{
			do_cmd_time();
			break;
		}

		/* Save and quit */
		case KTRL('X'):
		case SPECIAL_KEY_QUIT:
		{
			do_cmd_save_and_exit();
			break;
		}

		/* Quit (commit suicide) */
		case 'Q':
		{
			do_cmd_suicide();
			break;
		}

		case '|':
		{
			do_cmd_nikki();
			break;
		}

		/* Check artifacts, uniques, objects */
		case '~':
		{
			do_cmd_knowledge();
			break;
		}

		/* Load "screen dump" */
		case '(':
		{
			do_cmd_load_screen();
			break;
		}

		/* Save "screen dump" */
		case ')':
		{
			do_cmd_save_screen();
			break;
		}

		/* Record/stop "Movie" */
		///sysdel131221 [r[
		///mod150224 [r[H
		case ']':
		{
			prepare_movie_hooks();
			break;
		}

		/* Make random artifact list */
		case KTRL('V'):
		{
			spoil_random_artifact("randifact.txt");
			break;
		}

#ifdef TRAVEL
		case '`':
		{
			if (!p_ptr->wild_mode) do_cmd_travel();
			if (p_ptr->special_defense & KATA_MUSOU)
			{
				set_action(ACTION_NONE);
			}
			break;
		}
#endif

		/* Hack -- Unknown command */
		default:
		{
			if (flush_failure) flush();
			if (one_in_(2))
			{
				char error_m[1024];
				sound(SOUND_ILLEGAL);
#ifdef JP
				if (!get_rnd_line("error_j.txt", 0, error_m))
#else
				if (!get_rnd_line("error.txt", 0, error_m))
#endif

					msg_print(error_m);
			}
			else
#ifdef JP
prt(" '?' Ńwv\܂B", 0, 0);
#else
				prt("Type '?' for help.", 0, 0);
#endif

			break;
		}
	}
	if (!energy_use && !now_message)
		now_message = old_now_message;
}



/*:::ނR}hŒނ郂X^[@Jjlw̔񃆃j[Nł邱*/
///sys ނ@j[Nނ悤ɂɂ͂ݒv@ł͑Ȃ
static bool monster_tsuri(int r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if ((r_ptr->flags7 & RF7_AQUATIC) && !(r_ptr->flags1 & RF1_UNIQUE) && my_strchr("Jjlw", r_ptr->d_char))
		return TRUE;
	else
		return FALSE;
}


/* Hack -- Pack Overflow */
/*:::ACeӂꏈBinventory[23]g*/
static void pack_overflow(void)
{
	if (inventory[INVEN_PACK].k_idx)
	{
		char o_name[MAX_NLEN];
		object_type *o_ptr;

		/* Is auto-destroy done? */
		notice_stuff();
		if (!inventory[INVEN_PACK].k_idx) return;

		/* Access the slot to be dropped */
		o_ptr = &inventory[INVEN_PACK];

		/* Disturbing */
		disturb(0, 1);

		/* Warning */
#ifdef JP
		msg_print("UbNACeӂꂽI");
#else
		msg_print("Your pack overflows!");
#endif

		/* Describe */
		object_desc(o_name, o_ptr, 0);

		/* Message */
#ifdef JP
		msg_format("%s(%c)𗎂ƂB", o_name, index_to_label(INVEN_PACK));
#else
		msg_format("You drop %s (%c).", o_name, index_to_label(INVEN_PACK));
#endif

		/* Drop it (carefully) near the player */
		/*:::ACe𗎂ƂBł͂ȂB*/
		(void)drop_near(o_ptr, 0, py, px);

		/* Modify, Describe, Optimize */
		inven_item_increase(INVEN_PACK, -255);
		inven_item_describe(INVEN_PACK);
		inven_item_optimize(INVEN_PACK);

		/* Handle "p_ptr->notice" */
		notice_stuff();

		/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
		handle_stuff();
	}
}

/*:::̑xŃGlM[100ɔ鏈@̂Ƃ̂Ǝp̂*/
/*:::̍sɍ킹Ɖ̂ȂACeƂȂǂŃ^[ŉxʔł邩珈𕪂Ă̂Ǝv*/
/*
 * process the effects per 100 energy at player speed.
 */
static void process_upkeep_with_speed(void)
{
	/* Give the player some energy */
	if (!load && p_ptr->enchant_energy_need > 0 && !p_ptr->leaving)
	{
		p_ptr->enchant_energy_need -= SPEED_TO_ENERGY(p_ptr->pspeed);
	}

	///mod151219 ჁAӎsAԂɂȂƉ̂Ȃǂ悤ɂĂ݂
	///v1.1.12 xeꂽ̂ŋxe͏O
	if(p_ptr->action && p_ptr->action != ACTION_REST && (p_ptr->paralyzed || p_ptr->confused || (p_ptr->stun >= 100) || p_ptr->alcohol >= DRANK_4 && !(p_ptr->muta2 & MUT2_ALCOHOL)))
	{
		set_action(ACTION_NONE);
	}
	
	/* No turn yet */
	if (p_ptr->enchant_energy_need > 0) return;

	//v1.1.48 ǉ
	if (p_ptr->wild_mode) return;
	
	while (p_ptr->enchant_energy_need <= 0)
	{
		///mod140329 [_[ZX̏ɓĂ݂
		if(!load && p_ptr->radar_sense)
		{
			int rad = p_ptr->lev / 2 + 5;

			map_area(rad);
		//	detect_all(rad);
			detect_traps(rad,TRUE);
			detect_objects_normal(rad);
			detect_objects_gold(rad);

		}
		///mod150116 т͐n`m
		if(p_ptr->pclass == CLASS_MURASA && p_ptr->lev > 19
			|| CHECK_FAIRY_TYPE == 38)
		{
			murasa_detect_water = TRUE;
			map_area(15 + p_ptr->lev / 2);
			murasa_detect_water = FALSE;
		}

		if(p_ptr->pclass == CLASS_KOISHI && !load && p_ptr->magic_num1[0] && one_in_(4))
		{
			int dam = p_ptr->lev + 30 + adj_general[p_ptr->stat_ind[A_CHR]] * 2;
			bool flag = FALSE;
			p_ptr->magic_num1[0] -= 1;
			msg_print("͂̐leI");
			if(fire_random_target(GF_REDEYE, dam, 4, 0,0))flag = TRUE;
			if(fire_random_target(GF_REDEYE, dam, 4, 0,0))flag = TRUE;

			if(!flag) msg_print("EEGȂB");

		}
		//CyVuV[eBO
		if(p_ptr->pclass == CLASS_MOKOU && !load && p_ptr->magic_num2[0])
		{
			int dam = p_ptr->lev * 5 + adj_general[p_ptr->stat_ind[A_CHR]] * 5;
			dam += randint1(dam);
			msg_print("ss̒eꂽI");
			project(0,5,py,px,dam,GF_MISSILE,PROJECT_KILL,-1);

			p_ptr->csp -= 30;
			if(p_ptr->csp < 1)
			{
				msg_print("C͂sB");
				p_ptr->csp = 0;
				p_ptr->csp_frac = 0;
				p_ptr->magic_num2[0] = 0;
			}
			p_ptr->redraw |= (PR_MANA);
			redraw_stuff();

		}
		//v1.1.48 X[p[nR_Ԃ̎@E򉻍U
		if (SUPER_SHION && one_in_(6))
		{

			msg_print("̃I[͂ۂݍ񂾁I");
			project_hack2(GF_DISENCHANT,0,0, p_ptr->lev * 8);

		}

		/* Handle the player song */
		/*:::p̂MPvZʔȂ*/
		if (!load) check_music();

		/* Hex - Handle the hex spells */
		if (!load) check_hex();
		if (!load) revenge_spell();
		
		/* There is some randomness of needed energy */
		p_ptr->enchant_energy_need += ENERGY_NEED();
	}
}


/*
 * Process the player
 *
 * Notice the annoying code to handle "pack overflow", which
 * must come first just in case somebody manages to corrupt
 * the savefiles by clever use of menu commands or something.
 */
static void process_player(void)
{
	int i;

	///race blŏ̕ϐgEEăQ[Jn菈Sʂ̋Lq邱ƂɂBNCbNX^[gɂ͕ۑȂB
	if (hack_startup)
	{
		//GWjAMh
		engineer_guild_price_change();

		//v1.1.21 mŏ̃XL|Cg𓾂
		if(p_ptr->pclass == CLASS_SOLDIER)
			get_soldier_skillpoint();

		//v1.1.52 俎qVi
		if (is_special_seikaku(SEIKAKU_SPECIAL_SUMIREKO))
		{
			okina_make_nameless_arts(0);
		}


		//푰ǐ_l _Zbg
		if(p_ptr->prace == RACE_STRAYGOD)
		{
			p_ptr->race_multipur_val[3] = p_ptr->chaos_patron;
			p_ptr->race_multipur_val[DBIAS_COSMOS] = deity_table[p_ptr->race_multipur_val[3]].dbias_cosmos;
			p_ptr->race_multipur_val[DBIAS_WARLIKE] = deity_table[p_ptr->race_multipur_val[3]].dbias_warlike;
			p_ptr->race_multipur_val[DBIAS_REPUTATION] = deity_table[p_ptr->race_multipur_val[3]].dbias_reputation;
			p_ptr->redraw |= PR_MISC;
			redraw_stuff();
		}
		///mod160721 PJnɂǂ̋Gǂ̐_Ă邩߂
		if(p_ptr->pclass == CLASS_KAGUYA)
		{
			int tmp_list[KAGUYA_QUEST_MAX] = {MON_MORGOTH,MON_AZATHOTH,MON_ONE_RING,MON_UNICORN_ORD,MON_OMEGA};
			int i;

			//X^[XgVbtBƌ悢ASYł肻ȋC邪B
			for(i=0;i<100;i++)
			{
				int n,m,tmp;

				n = randint0(KAGUYA_QUEST_MAX);
				m = randint0(KAGUYA_QUEST_MAX);

				if(n == m) continue;

				tmp = tmp_list[n];
				tmp_list[n] = tmp_list[m];
				tmp_list[m] = tmp;
			}
			//XgۑBkaguya_quest_art_list[]̓Yƈv
			for(i=0;i<KAGUYA_QUEST_MAX;i++)
			{
				p_ptr->magic_num1[i] = tmp_list[i];
			}
		}
		//v1.1.15
		//wJ[eBAJn
		if(p_ptr->pclass == CLASS_HECATIA)
		{
			int i;
			//3̑̂HP/MP̊ϐMAXɂ(fobO[hłȂƊ֌WȂ)
			for(i=0;i<6;i++) p_ptr->magic_num1[i] = 10000;
			//nƌ̑̂̐iݒ肷
			get_hecatia_seikaku();
			//ǉCxg̑OɓĂ̂͂ǂ̑̂̑itO@Ƃ肠n
			p_ptr->magic_num2[1] = HECATE_BODY_EARTH;

		}

		hack_startup = FALSE;
	}


	if(p_ptr->pclass == CLASS_MOKOU && flag_mokou_resurrection)
	{
		mokou_resurrection();
	}

	/*:::ZȂSX^[ɔcĂԂɂB̂Ɓ͍ŝ܂܏I*/
	if (p_ptr->inside_battle)
	{
		for(i = 1; i < m_max; i++)
		{
			monster_type *m_ptr = &m_list[i];
			if (!m_ptr->r_idx) continue;

			/* Hack -- Detect monster */

			m_ptr->mflag2 |= (MFLAG2_MARK | MFLAG2_SHOW);

			/* Update the monster */
			update_mon(i, FALSE);
		}
		prt_time();
	}
	else if (!(load && p_ptr->energy_need <= 0))
	{
		/* Give the player some energy */
		/*:::loadFalsêƂAenergy_need1ȏ̂ƂENERGY𓾂Bload͉낤BQ[[ĥtrueH*/
		p_ptr->energy_need -= SPEED_TO_ENERGY(p_ptr->pspeed);
	}

	/* No turn yet */
	if (p_ptr->energy_need > 0) return;
	/*:::R}hs[ĝƂ͎ԂXVȂ*/
	if (!command_rep)
	{
			prt_time(); 
			///mod140322 sJnɃXRA\XV
			prt_score();

	}
	/*** Check for interupts ***/

	/*:::Sxe@-1-2ƊS񕜂܂ő炵*/
	///sys uől𒴂HP񕜂vƂACtȂƃ[v
	/* Complete resting */
	if (resting < 0)
	{
		/* Basic resting */
		if (resting == -1)
		{
			/* Stop resting */
			/*:::MP>=Ȃ̂͌pƂ̂߂̋LqƎv*/

			if ((p_ptr->chp == p_ptr->mhp) && (p_ptr->csp >= p_ptr->msp))
			{
				set_action(ACTION_NONE);
			}
		}

		/* Complete resting */
		else if (resting == -2)
		{
			/* Stop resting */
			if ((p_ptr->chp == p_ptr->mhp) &&
			    (p_ptr->csp >= p_ptr->msp) &&
			    !p_ptr->blind && !p_ptr->confused &&
			    !p_ptr->poisoned && !p_ptr->afraid &&
			    !p_ptr->stun && !p_ptr->cut &&
			    !p_ptr->slow && !p_ptr->paralyzed &&
			    !p_ptr->image && !p_ptr->word_recall &&
			    !p_ptr->alter_reality)
			{
				set_action(ACTION_NONE);
			}
		}
	}
	/*:::ނ*/
	if (p_ptr->action == ACTION_FISH)
	{
		/* Delay */
		Term_xtra(TERM_XTRA_DELAY, 10);
		if (one_in_(1000))
		{
			int r_idx;
			bool success = FALSE;
			get_mon_num_prep(monster_tsuri,NULL);
			r_idx = get_mon_num(dun_level ? dun_level : wilderness[p_ptr->wilderness_y][p_ptr->wilderness_x].level);
			msg_print(NULL);
			if (r_idx && one_in_(2))
			{
				int y, x;
				y = py+ddy[tsuri_dir];
				x = px+ddx[tsuri_dir];
				if (place_monster_aux(0, y, x, r_idx, PM_NO_KAGE))
				{
					char m_name[80];
					monster_desc(m_name, &m_list[cave[y][x].m_idx], 0);
#ifdef JP
					msg_format("%sނꂽI", m_name);
#else
					msg_format("You have a good catch!", m_name);
#endif
					success = TRUE;
				}
			}
			if (!success)
			{
#ifdef JP
				msg_print("aHĂ܂I`I");
#else
				msg_print("Damn!  The fish stole your bait!");
#endif
			}
			disturb(0, 1);
		}
	}

	/* Handle "abort" */
	/*:::uAR}h̓L[͂ŒfvIvVON̂Ƃ*/
	if (check_abort)
	{
		/* Check for "player abort" (semi-efficiently for resting) */
		if (running || travel.run || command_rep || (p_ptr->action == ACTION_REST) || (p_ptr->action == ACTION_FISH))
		{
			/* Do not wait */
			inkey_scan = TRUE;

			/* Check for a key */
			/*:::L[͂Βf*/
			if (inkey())
			{
				/* Flush input */
				flush();

				/* Disturb */
				disturb(0, 1);

				/* Hack -- Show a Message */
#ifdef JP
msg_print("f܂B");
#else
				msg_print("Canceled.");
#endif

			}
		}
	}

	/*:::Mega Hack Ԕ؊d̂ƂAsJnɕgĂn`ƃACeL*/
	update_minion_sight();

	/*:::ybgԈُ񕜁@NOE|͋Z\ւ*/
	if (p_ptr->riding && !p_ptr->confused && !p_ptr->blind)
	{
		monster_type *m_ptr = &m_list[p_ptr->riding];
		monster_race *r_ptr = &r_info[m_ptr->r_idx];

		if (MON_CSLEEP(m_ptr))
		{
			char m_name[80];

			/* Recover fully */
			(void)set_monster_csleep(p_ptr->riding, 0);

			/* Acquire the monster name */
			monster_desc(m_name, m_ptr, 0);
#ifdef JP
			msg_format("%^sNB", m_name);
#else
			msg_format("You have waked %s up.", m_name);
#endif
		}
		///sys nX^[ԉ񕜁@RZ\

		if (MON_STUNNED(m_ptr))
		{
			/* Hack -- Recover from stun */
			///mod131226 skill Z\ƕZ\̓
			//if (set_monster_stunned(p_ptr->riding,(randint0(r_ptr->level) < p_ptr->skill_exp[GINOU_RIDING]) ? 0 : (MON_STUNNED(m_ptr) - 1)))
			if (set_monster_stunned(p_ptr->riding,(randint0(r_ptr->level) < ref_skill_exp(SKILL_RIDING) || p_ptr->pclass == CLASS_MAI) ? 0 : (MON_STUNNED(m_ptr) - 1)))
			{
				char m_name[80];

				/* Acquire the monster name */
				monster_desc(m_name, m_ptr, 0);

				/* Dump a message */
#ifdef JP
				msg_format("%^sNOԂ痧点B", m_name);
#else
				msg_format("%^s is no longer stunned.", m_name);
#endif
			}
		}

		if (MON_CONFUSED(m_ptr))
		{
			/* Hack -- Recover from confusion */
			if (set_monster_confused(p_ptr->riding,
				(randint0(r_ptr->level) < ref_skill_exp(SKILL_RIDING)) ? 0 : (MON_CONFUSED(m_ptr) - 1)))
///mod131226 skill Z\ƕZ\̓
//				(randint0(r_ptr->level) < p_ptr->skill_exp[GINOU_RIDING]) ? 0 : (MON_CONFUSED(m_ptr) - 1)))
			{
				char m_name[80];

				/* Acquire the monster name */
				monster_desc(m_name, m_ptr, 0);

				/* Dump a message */
#ifdef JP
				msg_format("%^sԂ痧点B", m_name);
#else
				msg_format("%^s is no longer confused.", m_name);
#endif
			}
		}

		if (MON_MONFEAR(m_ptr))
		{
			/* Hack -- Recover from fear */
			///mod131226 skill Z\ƕZ\̓
			if (set_monster_monfear(p_ptr->riding,
				(randint0(r_ptr->level) < ref_skill_exp(SKILL_RIDING)) ? 0 : (MON_MONFEAR(m_ptr) - 1)))
			{
				char m_name[80];

				/* Acquire the monster name */
				monster_desc(m_name, m_ptr, 0);

				/* Dump a message */
#ifdef JP
				msg_format("%^s|痧点B", m_name);
#else
				msg_format("%^s is no longer fear.", m_name);
#endif
			}
		}

		/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
		handle_stuff();
	}
	
	load = FALSE;

	/* Fast */
	/*:::BCpt̃tO*/
	///class Cpm̌ړ@LԂ͍s񐔂ŃJEg
	///mod140813 ʏ̈ꎞƓꏊɈړ
/*
	if (p_ptr->lightspeed)
	{
		(void)set_lightspeed(p_ptr->lightspeed - 1, TRUE);
	}
*/
	/*:::BCptmagic_num1[0]͗܂C̗ʂ炵*/
	///class Cp@C̃^[40
	if ((p_ptr->pclass == CLASS_FORCETRAINER) && (p_ptr->magic_num1[0]))
	{
		if (p_ptr->magic_num1[0] < 40)
		{
			p_ptr->magic_num1[0] = 0;
		}
		else p_ptr->magic_num1[0] -= 40;
		p_ptr->update |= (PU_BONUS);
	}
	/*:::̊wKMP*/
	///class 
	if (p_ptr->action == ACTION_LEARN)
	{
		s32b cost = 0L;
		u32b cost_frac = (p_ptr->msp + 30L) * 256L;

		/* Convert the unit (1/2^16) to (1/2^32) */
		s64b_LSHIFT(cost, cost_frac, 16);

 
		if (s64b_cmp(p_ptr->csp, p_ptr->csp_frac, cost, cost_frac) < 0)
		{
			/* Mana run out */
			p_ptr->csp = 0;
			p_ptr->csp_frac = 0;
			set_action(ACTION_NONE);
		}
		else
		{
			/* Reduce mana */
			s64b_sub(&(p_ptr->csp), &(p_ptr->csp_frac), cost, cost_frac);
		}
		p_ptr->redraw |= PR_MANA;
	}

	/*:::ž^MP*/
	///class p
	if (p_ptr->special_defense & KATA_MASK)
	{
		if (p_ptr->special_defense & KATA_MUSOU)
		{
			if (p_ptr->csp < 3)
			{
				set_action(ACTION_NONE);
			}
			else
			{
				p_ptr->csp -= 2;
				p_ptr->redraw |= (PR_MANA);
			}
		}
	}

	//v1.1.27 EK[hVXe
	count_damage_guard_break = 0;

	/*** Handle actual user input ***/

	/* Repeat until out of energy */
	/*:::R}htEs[v@GlM[gps܂ŌJԂ*/
	while (p_ptr->energy_need <= 0)
	{
		p_ptr->window |= PW_PLAYER;
		p_ptr->sutemi = FALSE;
		p_ptr->counter = FALSE;
		now_damaged = FALSE;

		/* Handle "p_ptr->notice" */
		notice_stuff();

		/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
		handle_stuff();

		/* Place the cursor on the player */
		move_cursor_relative(py, px);

		/* Refresh (optional) */
		if (fresh_before) Term_fresh();


		/* Hack -- Pack Overflow */
		/*:::ACeӂꏈ*/
		pack_overflow();


		/* Hack -- cancel "lurking browse mode" */
		/*:::get_item()browse[hœ߂̕ϐ炵@ڍוs*/
		if (!command_new) command_see = FALSE;


		/* Assume free turn */
		energy_use = 0;

		///mod150822 vYo[Oo͈ӎŝƂ܂ɏ
		if(CLASS_IS_PRISM_SISTERS
			&& (p_ptr->paralyzed || (p_ptr->stun >= 100) || p_ptr->alcohol >= DRANK_4 && !(p_ptr->muta2 & MUT2_ALCOHOL))
			&& one_in_(7))
		{
			prism_change_class(TRUE);
			p_ptr->redraw |= (PR_WIPE | PR_BASIC | PR_EXTRA | PR_MAP | PR_EQUIPPY);
			redraw_stuff();

		}

		///sysdel tougi
		if (p_ptr->inside_battle)
		{
			/* Place the cursor on the player */
			move_cursor_relative(py, px);

			command_cmd = SPECIAL_KEY_BUILDING;

			/* Process the command */
			process_command();
		}

		/* Paralyzed or Knocked Out */
		else if (p_ptr->paralyzed || (p_ptr->stun >= 100))
		{
			/* Take a turn */
			energy_use = 100;
			if(p_ptr->pclass == CLASS_SUMIREKO && !EXTRA_MODE && !p_ptr->inside_arena)
			{
				flag_sumireko_wakeup = TRUE;
				p_ptr->leaving = TRUE;
			}
		}
		///mod140330 AłȂ҂Dx10000C
		//v1.1.19 15000
		else if (p_ptr->alcohol >= DRANK_4 && !(p_ptr->muta2 & MUT2_ALCOHOL))
		{
			/* Take a turn */
			energy_use = 100;
			if(p_ptr->pclass == CLASS_SUMIREKO && !EXTRA_MODE && !p_ptr->inside_arena)
			{
				flag_sumireko_wakeup = TRUE;
				p_ptr->leaving = TRUE;
			}
		}
		/* Resting */
		else if (p_ptr->action == ACTION_REST)
		{
			/* Timed rest */
			/*:::S񕜂łȂ^[wxêƂ*/
			if (resting > 0)
			{
				/* Reduce rest count */
				resting--;

				if (!resting) set_action(ACTION_NONE);

				/* Redraw the state */
				p_ptr->redraw |= (PR_STATE);
			}

			/* Take a turn */
			energy_use = 100;
		}
		//zKq~
		else if(p_ptr->pclass == CLASS_SUWAKO && p_ptr->tim_general[0])
		{
			energy_use = 100;
		}

		/* Fishing */
		else if (p_ptr->action == ACTION_FISH)
		{
			/* Take a turn */
			energy_use = 100;
		}

		/* Running */
		else if (running)
		{
			/* Take a step */
			run_step(0);
		}

#ifdef TRAVEL
		/* Traveling */
		else if (travel.run)
		{
			/* Take a step */
			travel_step();
		}
#endif

		/* Repeated command */
		else if (command_rep)
		{
			/* Count this execution */
			command_rep--;

			/* Redraw the state */
			p_ptr->redraw |= (PR_STATE);

			/* Redraw stuff */
			redraw_stuff();

			/* Hack -- Assume messages were seen */
			msg_flag = FALSE;

			/* Clear the top line */
			prt("", 0, 0);

			/* Process the command */
			process_command();
		}

		/* Normal command */
		else
		{
			/* Place the cursor on the player */
			move_cursor_relative(py, px);
			///mod140917 R}hҎ󎞂ɃX^[XgXV
			if(refresh_mon_list)
			{
				p_ptr->window |= PW_MONSTER_LIST;
				window_stuff();
			}
			can_save = TRUE;
			/* Get a command (normal) */
			request_command(FALSE);
			can_save = FALSE;

			/* Process the command */
			process_command();
		}
		/*:::R}hIAs[vI*/

		/* Hack -- Pack Overflow */
		pack_overflow();

		/*** Clean up ***/

		/* Significant */
		/*:::GlM[sꍇ*/
		if (energy_use)
		{
			///mod150114 ړԂʍɕ\邱Ƃɂ̂ŁAs邽тɕ\XV邱Ƃɂ
			p_ptr->redraw |= (PR_STATE);

			/* Use some energy */
			if (world_player || energy_use > 400)
			{
				/* The Randomness is irrelevant */
				p_ptr->energy_need += energy_use * TURNS_PER_TICK / 10;
			}
			else
			{
				/* There is some randomness of needed energy */
				p_ptr->energy_need += (s16b)((s32b)energy_use * ENERGY_NEED() / 100L);
			}

			/* Hack -- constant hallucination */
			if (p_ptr->image) p_ptr->redraw |= (PR_MAP);


			/* Shimmer monsters if needed */
			/*:::FX^[̍ĕ`揈H*/
			if (shimmer_monsters)
			{
				/* Clear the flag */
				shimmer_monsters = FALSE;

				/* Shimmer multi-hued monsters */
				for (i = 1; i < m_max; i++)
				{
					monster_type *m_ptr;
					monster_race *r_ptr;

					/* Access monster */
					m_ptr = &m_list[i];

					/* Skip dead monsters */
					if (!m_ptr->r_idx) continue;

					/* Skip unseen monsters */
					if (!m_ptr->ml) continue;

					/* Access the monster race */
					r_ptr = &r_info[m_ptr->ap_r_idx];

					/* Skip non-multi-hued monsters */
					if (!(r_ptr->flags1 & (RF1_ATTR_MULTI | RF1_SHAPECHANGER)))
						continue;

					/* Reset the flag */
					shimmer_monsters = TRUE;

					/* Redraw regardless */
					lite_spot(m_ptr->fy, m_ptr->fx);
				}
			}


			/* Handle monster detection */
			/*:::ڍוsBuƂŃX^[XVvtOH*/
			if (repair_monsters)
			{
				/* Reset the flag */
				repair_monsters = FALSE;

				/* Rotate detection flags */
				for (i = 1; i < m_max; i++)
				{
					monster_type *m_ptr;

					/* Access monster */
					m_ptr = &m_list[i];

					/* Skip dead monsters */
					if (!m_ptr->r_idx) continue;

					//ȂǂŏoĂX^[@g悤ɂȂB
					//(gbvȂǁ̍sŏꂽX^[͂̍sI_łɓ̂Ŏ@)
					/* Nice monsters get mean */
					if (m_ptr->mflag & MFLAG_NICE)
					{
						/* Nice monsters get mean */
						m_ptr->mflag &= ~(MFLAG_NICE);
					}

					/* Handle memorized monsters */
					if (m_ptr->mflag2 & MFLAG2_MARK)
					{
						/* Maintain detection */
						if (m_ptr->mflag2 & MFLAG2_SHOW)
						{
							/* Forget flag */
							m_ptr->mflag2 &= ~(MFLAG2_SHOW);

							/* Still need repairs */
							repair_monsters = TRUE;
						}

						/* Remove detection */
						else
						{
							/* Forget flag */
							m_ptr->mflag2 &= ~(MFLAG2_MARK);

							/* Assume invisible */
							m_ptr->ml = FALSE;

							/* Update the monster */
							update_mon(i, FALSE);

							if (p_ptr->health_who == i) p_ptr->redraw |= (PR_HEALTH);
							if (p_ptr->riding == i) p_ptr->redraw |= (PR_UHEALTH);

							/* Redraw regardless */
							lite_spot(m_ptr->fy, m_ptr->fx);
						}
					}
				}
			}
			/*:::̂܂ˎt̂̂܂ˏXV*/
			///class ̂܂˓ꏈ
			if (p_ptr->pclass == CLASS_IMITATOR)
			{
				if (p_ptr->mane_num > (p_ptr->lev > 44 ? 3 : p_ptr->lev > 29 ? 2 : 1))
				{
					p_ptr->mane_num--;
					for (i = 0; i < p_ptr->mane_num; i++)
					{
						p_ptr->mane_spell[i] = p_ptr->mane_spell[i+1];
						p_ptr->mane_dam[i] = p_ptr->mane_dam[i+1];
					}
				}
				new_mane = FALSE;
				p_ptr->redraw |= (PR_IMITATION);
			}
			if (p_ptr->action == ACTION_LEARN)
			{
				new_mane = FALSE;
				p_ptr->redraw |= (PR_STATE);
			}

			/*:::Ԓ~energy_need-1000菬ȂĂ*/
			if (world_player && (p_ptr->energy_need > - 1000))
			{
				/* Redraw map */
				p_ptr->redraw |= (PR_MAP);

				/* Update monsters */
				p_ptr->update |= (PU_MONSTERS);

				/* Window stuff */
				p_ptr->window |= (PW_OVERHEAD | PW_DUNGEON);

#ifdef JP
				msg_print("u͓cv");
#else
				msg_print("You feel time flowing around you once more.");
#endif
				msg_print(NULL);
				world_player = FALSE;
				p_ptr->energy_need = ENERGY_NEED();

				/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
				handle_stuff();
			}

			//v1.1.21 e֌ẄꎞlZbg
			hack_gun_fire_critical_flag = 0L;
			special_shooting_mode = 0;

		}
		/*:::GlM[sꍇ̏*/

		///mod160303 EX[ȟœ̍sƂ̕ϐݒ肳G
		if(hack_ex_bldg_summon_idx || hack_ex_bldg_summon_type )
		{
			if(hack_ex_bldg_summon_type)
				summon_specific(0,py,px,dun_level,hack_ex_bldg_summon_type,hack_ex_bldg_summon_mode);
			else if(hack_ex_bldg_summon_idx)
				summon_named_creature(0,py,px,hack_ex_bldg_summon_idx,hack_ex_bldg_summon_mode);
			hack_ex_bldg_summon_idx = 0;
			hack_ex_bldg_summon_type = 0;
			hack_ex_bldg_summon_mode = 0L;
		}

		/* Hack -- notice death */
		if (!p_ptr->playing || p_ptr->is_dead)
		{
			world_player = FALSE;
			break;
		}

		//GC{̖̎ԗ֖
		if(energy_use && break_eibon_flag) break_eibon_wheel();

		/* Sniper */
		if (energy_use && reset_concent) reset_concentration(TRUE);

		/* Handle "leaving" */
		if (p_ptr->leaving) break;

		/// -Mega Hack- ̐Eꏈ
		//energy_need0ɏA^[ōsB[v
		if (SAKUYA_WORLD)
		{

			set_paralyzed(0);

			if(p_ptr->action == ACTION_REST && p_ptr->food < PY_FOOD_WEAK)
			{
				msg_print("󂢂ē|ꂻBxeǂł͂ȂB");
				p_ptr->action = ACTION_NONE;
				p_ptr->energy_need = 0;
			}

			if(p_ptr->energy_need > 0)//󕠓x ʏsƓ悤ȏɂ
			{
				int digestion = 10;
				//v1.1.19 Dx}WbNio[r
				if(p_ptr->alcohol >= DRANK_4) set_alcohol(DRANK_4-1);
				if(p_ptr->confused && one_in_(7)) set_confused(0);
				if(p_ptr->shero && one_in_(10)) set_shero(0,TRUE);

				if (p_ptr->regenerate) digestion += 20;
				if (p_ptr->cursed & TRC_FAST_DIGEST) digestion += 30;
				if (p_ptr->slow_digest)	digestion -= 5;


				digestion = digestion * p_ptr->energy_need / 500;

				if(p_ptr->action == ACTION_REST) 
					digestion = digestion * (1 + 50*(p_ptr->mhp - p_ptr->chp)/p_ptr->mhp);

				(void)set_food(p_ptr->food - digestion);
				if (p_ptr->wild_mode && p_ptr->food < PY_FOOD_WEAK)
				{
					change_wild_mode();
				}
				if(p_ptr->food < PY_FOOD_STARVE) take_hit(DAMAGE_LOSELIFE, 1, "", -1);
			}

			if(p_ptr->action == ACTION_REST)
			{
				msg_print("Ȃ͋xeB");
				p_ptr->chp = p_ptr->mhp;
				p_ptr->chp_frac = 0L;
				set_stun(0);
				set_cut(0);
				set_image(0);
				set_blind(0);
				set_confused(0);
				set_shero(0,TRUE);
			    if (p_ptr->food >= PY_FOOD_MAX) p_ptr->food = PY_FOOD_MAX -1;
				p_ptr->redraw |= PR_HP | PR_EXTRA | PR_STATE | PR_STATUS;
				p_ptr->action = ACTION_NONE;
			}
			else if(p_ptr->action == ACTION_FISH)//paranoia
			{
				msg_print("ނȂǂĂӖȂB");
				p_ptr->action = ACTION_NONE;
			}

			
			resting = 0;
			p_ptr->energy_need = 0;
			handle_stuff();

		}

	}
	/*:::R}hts[v*/

	/* Update scent trail */
	update_smell();

}


/*
 * Interact with the current dungeon level.
 *
 * This function will not exit until the level is completed,
 * the user dies, or the game is terminated.
 */
/*:::݊Kł̏sAKړEQ[fEQ[I[o[ȊO͂̃[vJԂ*/
static void dungeon(bool load_game)
{
	int quest_num = 0;
	int i;

	/* Set the base level */
	base_level = dun_level;

	/* Reset various flags */
	hack_mind = FALSE;

	/* Not leaving */
	p_ptr->leaving = FALSE;

	/* Reset the "command" vars */
	command_cmd = 0;

#if 0 /* Don't reset here --- It's used for Arena */
	command_new = 0;
#endif

	command_rep = 0;
	command_arg = 0;
	command_dir = 0;


	/* Cancel the target */
	target_who = 0;
	pet_t_m_idx = 0;
	riding_t_m_idx = 0;
	ambush_flag = FALSE;

	/* Cancel the health bar */
	/*:::^[Qbg̗̑̓Q[WH*/
	health_track(0);

	/* Check visual effects */
	shimmer_monsters = TRUE;
	shimmer_objects = TRUE;
	repair_monsters = TRUE;
	repair_objects = TRUE;


	/* Disturb */
	disturb(1, 1);

	/* Get index of current quest (if any) */
	/*:::NGXgȂNGXgIDAłȂȂ0Ԃ*/
	quest_num = quest_number(dun_level);

	/* Inside a quest? */
	if (quest_num)
	{
		/* Mark the quest monster */
		r_info[quest[quest_num].r_idx].flags1 |= RF1_QUESTOR;
	}

	/* Track maximum player level */
	if (p_ptr->max_plv < p_ptr->lev)
	{
		p_ptr->max_plv = p_ptr->lev;
	}

	/* Track maximum dungeon level (if not in quest -KMW-) */
	if ((max_dlv[dungeon_type] < dun_level) && !p_ptr->inside_quest)
	{
		max_dlv[dungeon_type] = dun_level;
		if (record_maxdepth) do_cmd_write_nikki(NIKKI_MAXDEAPTH, dun_level, NULL);

		///mod160522 ̎xJE^ tAZbgŃXJłȂ悤magic_num2ɓƎōŐ[BKǗĂ
		if(p_ptr->pclass == CLASS_RINGO && max_dlv[dungeon_type] > p_ptr->magic_num2[dungeon_type])
		{
			int tmp = (max_dlv[dungeon_type] - p_ptr->magic_num2[dungeon_type]) * (dun_level+100);
			if(tmp > 1000) tmp = 1000;
			p_ptr->magic_num1[4] += tmp;
			p_ptr->magic_num2[dungeon_type] = max_dlv[dungeon_type];
		}

	}
	//v1.1.25 _WetO
	if(!p_ptr->inside_quest && dun_level && dun_level == d_info[dungeon_type].maxdepth && !flag_dungeon_complete[dungeon_type])
	{
		if(dungeon_type != DUNGEON_ANGBAND && dungeon_type != DUNGEON_CHAOS && 
			(!d_info[dungeon_type].final_guardian || !r_info[d_info[dungeon_type].final_guardian].max_num))
		{
			msg_format("Ȃ%s𐧔eI",d_name+d_info[dungeon_type].name);
			flag_dungeon_complete[dungeon_type] = 1;
		}

	}

	/*:::ybg̃RXgvZ炵߂l󂯎ĂȂB"p_ptr->update |= (PU_BONUS)"̏̂߂ɎsĂ̂H*/
	(void)calculate_upkeep();

	/* Validate the panel */
	/*:::݉ʂ̏ڐ𓾂H*/
	panel_bounds_center();

	/* Verify the panel */
	/*:::`֌W̃`FbN⏉H*/
	verify_panel();

	/* Flush messages */
	msg_print(NULL);

	/* Enter "xtra" mode */
	/*:::Ԃ̃tO𗧂ĂH*/
	character_xtra = TRUE;

	/* Window stuff */
	p_ptr->window |= (PW_INVEN | PW_EQUIP | PW_SPELL | PW_PLAYER | PW_MONSTER | PW_OVERHEAD | PW_DUNGEON);

	/* Redraw dungeon */
	p_ptr->redraw |= (PR_WIPE | PR_BASIC | PR_EXTRA | PR_EQUIPPY);

	/* Redraw map */
	p_ptr->redraw |= (PR_MAP);

	/* Update stuff */
	p_ptr->update |= (PU_BONUS | PU_HP | PU_MANA | PU_SPELLS);

	/* Update lite/view */
	p_ptr->update |= (PU_VIEW | PU_LITE | PU_MON_LITE | PU_TORCH);

	/* Update monsters */
	p_ptr->update |= (PU_MONSTERS | PU_DISTANCE | PU_FLOW);

	/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
	/*:::Xe[^XEp[^E}bv̍ČvZEĕ`揈*/
	handle_stuff();
	/* Leave "xtra" mode */
	character_xtra = FALSE;

	/* Update stuff */
	p_ptr->update |= (PU_BONUS | PU_HP | PU_MANA | PU_SPELLS);

	/* Combine / Reorder the pack */
	p_ptr->notice |= (PN_COMBINE | PN_REORDER);

	/* Handle "p_ptr->notice" */
	notice_stuff();

	/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
	handle_stuff();

	/*::: -Giga Hack- 얲EȂǉσp[^X^[Ƃp[^ČvZ*/
	/*:::Q[Jnr_infȍlȂ̂Œڏ㏑*/
	for(i=1; i < m_max; i++)
	{
		monster_type *m_ptr = &m_list[i];

		if(!(r_info[m_ptr->r_idx].flags7 & RF7_VARIABLE)) continue;

		if (m_ptr->r_idx == MON_REIMU ) apply_mon_race_reimu();
		else if (m_ptr->r_idx == MON_MARISA ) apply_mon_race_marisa();
		else if (m_ptr->r_idx == MON_MASTER_KAGUYA ) apply_mon_race_master_kaguya();
		else if(IS_RANDOM_UNIQUE_IDX(m_ptr->r_idx)); //_j[N̓[hɃp[^ǂݍނ̂łł͉Ȃ
		else if(m_ptr->r_idx >= MON_TSUKUMO_WEAPON1 && m_ptr->r_idx <= MON_TSUKUMO_WEAPON5 )
		{
			apply_mon_race_tsukumoweapon(&o_list[m_ptr->hold_o_idx],m_ptr->r_idx);
			lore_do_probe(m_ptr->r_idx);

		}
		else if(m_ptr->r_idx == MON_BANKI_HEAD_1 || m_ptr->r_idx == MON_BANKI_HEAD_2)
			(void) apply_mon_race_banki_head(m_ptr->r_idx);
		else if(m_ptr->r_idx == MON_GREEN_EYED)
			(void) apply_mon_race_green_eyed();

		else msg_format("ERROR:σp[^X^[(r_idx:%d)̃[hp[^Đݒ肪ĂȂ",m_ptr->r_idx);
	}


	//ʂp@tAɓ̕ϐg
	if(p_ptr->pclass == CLASS_NUE)
	{
		check_nue_undefined();
	}

	/*:::Mega Hack - Extra[h_W̖Oł邱Ƃݒ@Z[u[hɑΉ邽߃tAɍ~藧ɌĂ*/
	if(EXTRA_MODE && dun_level)
	{
		init_extra_dungeon_buildings();
	}

	/* Refresh */
	Term_fresh();

	/*:::NGXgŃNGłIxłJłȂC_WNGXgłȂꍇA͋Cm*/
	/*:::NGXg_WɓƂuT^IȃNGXg̃_Ŵ悤vƕ\邽߂̏炵A*/
	/*:::ɂĂ͏₱CBƂĂ̂B*/
	if (quest_num && (is_fixed_quest_idx(quest_num) &&
	  //  !((quest_num == QUEST_OBERON) || (quest_num == QUEST_SERPENT) ||
	    !((quest_num == QUEST_OBERON) ||(quest_num == QUEST_YUKARI) ||
	    !(quest[quest_num].flags & QUEST_FLAG_PRESET)))) do_cmd_feeling();

	if (p_ptr->inside_battle)
	{
		if (load_game)
		{
			p_ptr->energy_need = 0;
			//battle_monsters();
		}
		else
		{
			msg_print("JnI");
			msg_print(NULL);
		}
	}

	if(	flag_sumireko_wakeup)
	{
		flag_sumireko_wakeup = FALSE;
		msg_print("Ȃ͊OEŖڊo߁A΂̌̂ƍĂіAz֍~藧B");

	}

	//v1.1.43 ole[uς̂Ń_W̃C[vOɌol`FbNĂ
	check_experience();

	/*::: Vl̗ImoɊւ鏈炵*/
	if ((p_ptr->pclass == CLASS_BARD) && (p_ptr->magic_num1[0] > MUSIC_DETECT))
		p_ptr->magic_num1[0] = MUSIC_DETECT;

	/* Hack -- notice death or departure */
	/*:::SQ[Iło*/
	if (!p_ptr->playing || p_ptr->is_dead) return;

	/* Print quest message if appropriate */
	///sys NGƃ_W̎̏
	if (!p_ptr->inside_quest && (dungeon_type == DUNGEON_ANGBAND))
	{
		quest_discovery(random_quest_number(dun_level));
		p_ptr->inside_quest = random_quest_number(dun_level);
	}
	if ((dun_level == d_info[dungeon_type].maxdepth) && d_info[dungeon_type].final_guardian)
	{
		if (r_info[d_info[dungeon_type].final_guardian].max_num)
#ifdef JP
			msg_format("̊Kɂ%s̎ł%słB",
				   d_name+d_info[dungeon_type].name, 
				   r_name+r_info[d_info[dungeon_type].final_guardian].name);
#else
			msg_format("%^s lives in this level as the keeper of %s.",
					   r_name+r_info[d_info[dungeon_type].final_guardian].name, 
					   d_name+d_info[dungeon_type].name);
#endif
	}

	/*:::Hack - EX_W̒{X*/
	if (dungeon_type == DUNGEON_CHAOS)
	{
		monster_type *m_ptr_tmp;
		char temp_name[80];
		if(dun_level == 110 && r_info[MON_MORGOTH].max_num)
		{
			msg_format("̊Kɂ%słB",
				   r_name+r_info[MON_MORGOTH].name);
		}
		if(dun_level == 120 && r_info[MON_AZATHOTH].max_num)
		{
			msg_format("̊Kɂ%słB",
				   r_name+r_info[MON_AZATHOTH].name);
		}
	
	}
	//v1.1.27 EK[h
	if(dun_level && (d_info[dungeon_type].flags1 & DF1_NO_MAGIC))
	{
		set_mana_shield(FALSE,FALSE);
	}

	/*:::Kɍ~Ă͒Bł͂ȂH*/
	///class Eғꏈ
	if (!load_game && (p_ptr->special_defense & NINJA_S_STEALTH)) set_superstealth(FALSE);

	/*** Process this dungeon level ***/

	/* Reset the monster generation level */
	monster_level = base_level;

	/* Reset the object generation level */
	object_level = base_level;

	hack_mind = TRUE;

	/*:::tAAnւ̋AҒAA[iꎞɁŏɍsł悤ɂ邽߂̏*/
	if (p_ptr->energy_need > 0 && !p_ptr->inside_battle &&
	    (dun_level || p_ptr->leaving_dungeon || p_ptr->inside_arena))
		p_ptr->energy_need = 0;

	///mod151104 u̐Evꏈ
	if (SAKUYA_WORLD)
	{
		p_ptr->energy_need = 0;
	}


	/* Not leaving dungeon */
	p_ptr->leaving_dungeon = FALSE;

	/* Initialize monster process */
	/*mproc_list[][]/mproc_max[]ɃtÃX^[̈ꎞXe[^Xi[*/
	mproc_init();

	/* Main loop */
	while (TRUE)
	{
		/* Hack -- Compact the monster list occasionally */
		/*:::tÃX^[őɋ߂ȂƂX^[k*/
		if ((m_cnt + 32 > max_m_idx) && !p_ptr->inside_battle) compact_monsters(64);

		/* Hack -- Compress the monster list occasionally */
		/*:::Sς݃X^[ƂXg𐮗*/
		if ((m_cnt + 32 < m_max) && !p_ptr->inside_battle) compact_monsters(0);


		/* Hack -- Compact the object list occasionally */
		/*:::tÃACeE߂ɂȂƂk*/
		if (o_cnt + 32 > max_o_idx) compact_objects(64);

		/* Hack -- Compress the object list occasionally */
		/*:::tA̖ȃACe烊Xg𐮗*/
		if (o_cnt + 32 < o_max) compact_objects(0);

		
		/* Process the player */
		process_player();
		
		process_upkeep_with_speed();

		/* Handle "p_ptr->notice" */
		notice_stuff();

		/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
		handle_stuff();

		/* Hack -- Hilite the player */
		move_cursor_relative(py, px);

		/* Optional fresh */
		if (fresh_after) Term_fresh();

		/* Hack -- Notice death or departure */
		if (!p_ptr->playing || p_ptr->is_dead) break;

		/* Process all of the monsters */
		process_monsters();

		/* Handle "p_ptr->notice" */
		notice_stuff();

		/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
		handle_stuff();

		/* Hack -- Hilite the player */
		move_cursor_relative(py, px);

		/* Optional fresh */
		if (fresh_after) Term_fresh();

		/* Hack -- Notice death or departure */
		if (!p_ptr->playing || p_ptr->is_dead) break;


		/* Process the world */
		process_world();

		/* Handle "p_ptr->notice" */
		notice_stuff();

		/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
		handle_stuff();

		/* Hack -- Hilite the player */
		move_cursor_relative(py, px);

		/* Optional fresh */
		if (fresh_after) Term_fresh();

		/* Hack -- Notice death or departure */
		if (!p_ptr->playing || p_ptr->is_dead) break;

		/* Handle "leaving" */
		if (p_ptr->leaving) break;

		/* Count game turns */
		turn++;

		/*:::wild_regen͏l20 dungeon_turn_limitbirthɌ߂B*/
		if (dungeon_turn < dungeon_turn_limit)
		{
			if (!p_ptr->wild_mode || wild_regen) dungeon_turn++;
			/*:::S̃}bvłdungeon_turn͑ɂ炵B*/
			else if (p_ptr->wild_mode && !(turn % ((MAX_HGT + MAX_WID) / 2))) dungeon_turn++;
		}

		prevent_turn_overflow();

		if (wild_regen) wild_regen--;
	}/*:::C[vI@͎ʂKړ邩Q[I*/

	/* Inside a quest and non-unique questor? */
	/*:::񃆃j[NrŃNGXgꍇX^[tOO*/
	if (quest_num && !(r_info[quest[quest_num].r_idx].flags1 & RF1_UNIQUE))
	{
		/* Un-mark the quest monster */
		r_info[quest[quest_num].r_idx].flags1 &= ~RF1_QUESTOR;
	}

	//Z[uIłSłȂƂBʏ̊KړȌ
	/* Not save-and-quit and not dead? */
	if (p_ptr->playing && !p_ptr->is_dead)
	{
		monster_type *m_ptr;
		int i;
		//wJ[eBAꏈ
		for(i=0;i<3;i++) hecatia_hp[i] = 5600;
		//Ex[hpJEgZbg
		for(i=0;i<EX_BUILDINGS_PARAM_MAX;i++) ex_buildings_param[i] = 0;

		//q̋LĂ閂@NABACeJ[hg悤Ɨϐɂ
		kyouko_echo(TRUE,0);
		//pXB̃_[WJEgNA
		parsee_damage_count = 0L;
		//X^[uڂ܁ṽ^[Qbg
		hassyakusama_target_idx = 0;

		//v1.1.13 ]㩂̉
		if(p_ptr->special_flags & SPF_ORBITAL_TRAP)
		{
			msg_print("]㩂͂B");
			p_ptr->special_flags &= ~(SPF_ORBITAL_TRAP);
		}
		//v1.1.35 lm
		if(p_ptr->pclass == CLASS_NEMUNO)
		{
			erase_nemuno_sanctuary(FALSE,FALSE);
		}

		///mod140423
		if(p_ptr->silent_floor)
		{
			p_ptr->silent_floor=0;
			msg_print("_WَȖ͂B");
		}
		///mod140502
		if(p_ptr->lucky)
		{
				set_tim_lucky(0,TRUE);
		}
		///mod150304 nZNA
		if(p_ptr->pclass == CLASS_KOMACHI || p_ptr->pclass == CLASS_REIMU || p_ptr->pclass == CLASS_REMY || p_ptr->pclass == CLASS_MAMIZOU)
		{
			if(p_ptr->magic_num1[0]) set_tim_general(0,TRUE,0,0);
		}
		//v1.1.17 ϋZZbgƈꎞ\͉
		if(p_ptr->pclass == CLASS_JUNKO)
		{
			junko_make_nameless_arts();
		}
		///mod141101 Ƃ̖@XgNA
		if(p_ptr->pclass == CLASS_SATORI)
		{
			make_magic_list_satori(TRUE);
		}
		//gCyVuV[eBO
		else if(p_ptr->pclass == CLASS_MOKOU && p_ptr->magic_num2[0])
		{
			p_ptr->magic_num2[0] = 0;
		}
		//i`\͉
		else if((p_ptr->pclass == CLASS_LUNAR || p_ptr->pclass == CLASS_3_FAIRIES) && (p_ptr->tim_general[0] || p_ptr->tim_general[1]))
		{
			set_tim_general(0,TRUE,0,0);
			set_tim_general(0,TRUE,1,0);
		}
		else if(p_ptr->pclass == CLASS_SANAE && p_ptr->magic_num1[1])
		{
			msg_print("tA_̋CzB");
			p_ptr->magic_num1[1] = 0;
		}
		else if(p_ptr->pclass == CLASS_KOISHI && p_ptr->magic_num1[0])
		{
			msg_print("͂̐leB");
			p_ptr->magic_num1[0] = 0;
		}
		///mod150516 Vq̗v΂NA
		else if(p_ptr->pclass == CLASS_TENSHI)
		{
			p_ptr->magic_num1[0] = 0;
			p_ptr->magic_num1[1] = 0;
			p_ptr->magic_num1[2] = 0;
	
		}
		//h~[ϐg
		else if(p_ptr->pclass == CLASS_DOREMY && IS_METAMORPHOSIS)
		{
			p_ptr->special_defense &= ~(SD_METAMORPHOSIS);
			p_ptr->special_flags &= ~(SPF_IGNORE_METAMOR_TIME);
			set_mimic(0,0,TRUE);
		}
		//v1.1.48 ߈ˉ..̓tAoĂȂƂɂBłȂƎシB
		/*
		else if (SHION_POSSESSING)
		{
			p_ptr->special_defense &= ~(SD_METAMORPHOSIS);
			p_ptr->special_flags &= ~(SPF_IGNORE_METAMOR_TIME);
			set_mimic(0, 0, TRUE);
		}
		*/
		//̎􂢒f
		else if (p_ptr->pclass == CLASS_HINA)
		{
			if(p_ptr->magic_num1[0]) set_tim_general(0,TRUE,0,0);
			if(p_ptr->special_defense & SD_HINA_NINGYOU)
			{
				msg_print("TU炷̂~߂B");
				p_ptr->special_defense &= ~(SD_HINA_NINGYOU);
				p_ptr->redraw |= (PR_STATUS);
			}
		}


		///mod140517 KړƂAEPHEMERAtOz̏ŏ ĂACe͗Ƃ
		//hbyQK[
		for (i = 1; i < m_max; i++)
		{
			char m_name[80];
			int dist_tmp;
			m_ptr = &m_list[i];
			if (!m_ptr->r_idx) continue;

			if(!(m_ptr->mflag & MFLAG_EPHEMERA)) continue;

			monster_desc(m_name, m_ptr, 0);
			if(m_ptr->r_idx >= MON_TSUKUMO_WEAPON1 && m_ptr->r_idx <= MON_TSUKUMO_WEAPON5 )
				msg_format("%s͌̕ɖ߂B", m_name);
			else if(m_ptr->r_idx == MON_YOUMU )
				msg_format("Ȃ̗̔͌̂ɖ߂B");
			else
				msg_format("%s͏B", m_name);
			monster_drop_carried_objects(m_ptr);
			delete_monster_idx(i);
		}
		//P()B
		for (i = 1; i < m_max; i++)
		{
			m_ptr = &m_list[i];
			if(m_ptr->r_idx != MON_MASTER_KAGUYA) continue;
			delete_monster_idx(i);
		}
		//hbyQK[
		for (i = 1; i < m_max; i++)
		{
			monster_race *r_ptr;
			char m_name[80];
			m_ptr = &m_list[i];
			if (!m_ptr->r_idx) continue;
			r_ptr = &r_info[m_ptr->r_idx];
			if(!(r_ptr->flags7 & RF7_DOPPELGANGER)) continue;

			monster_desc(m_name, m_ptr, 0);
			msg_format("Ȃ̃hbyQK[͏B", m_name);

			monster_drop_carried_objects(m_ptr);
			delete_monster_idx(i);
		}

		/*
		 * Maintain Unique monsters and artifact, save current
		 * floor, then prepare next floor
		 */
		leave_floor();

		/* Forget the flag */
		reinit_wilderness = FALSE;
	}

	/* Write about current level on the play record once per level */
	write_level = TRUE;
}


/*
 * Load some "user pref files"
 *
 * Modified by Arcum Dagsson to support
 * separate macro files for different realms.
 */
/*:::user-win.prf,}Nݒt@CAEt@Cǂݍ*/
static void load_all_pref_files(void)
{
	char buf[1024];


	/* Access the "user" pref file */
	sprintf(buf, "user.prf");

	/* Process that file */
	process_pref_file(buf);

	/*:::user-win.prfJĂBFݒ֘A炵*/
	/* Access the "user" system pref file */
	sprintf(buf, "user-%s.prf", ANGBAND_SYS);

	/* Process that file */
	process_pref_file(buf);

	/*:::푰Ƃprft@CH炵t@C͂Ȃ*/
	/* Access the "race" pref file */
	sprintf(buf, "%s.prf", rp_ptr->title);

	/* Process that file */
	process_pref_file(buf);

	/*:::NXƂprft@CH炵t@C͂Ȃ*/
	/* Access the "class" pref file */
	sprintf(buf, "%s.prf", cp_ptr->title);

	/* Process that file */
	process_pref_file(buf);

	/*:::@.prf }Nݒt@Cǂݍ݂*/
	/* Access the "character" pref file */
	sprintf(buf, "%s.prf", player_base);

	/* Process that file */
	process_pref_file(buf);

	/* Access the "realm 1" pref file */
	if (p_ptr->realm1 != REALM_NONE)
	{
		sprintf(buf, "%s.prf", realm_names[p_ptr->realm1]);

		/* Process that file */
		process_pref_file(buf);
	}

	/* Access the "realm 2" pref file */
	if (p_ptr->realm2 != REALM_NONE)
	{
		sprintf(buf, "%s.prf", realm_names[p_ptr->realm2]);

		/* Process that file */
		process_pref_file(buf);
	}


	/* Load an autopick preference file */
	autopick_load_pref(FALSE);
}


/*
 * Extract option variables from bit sets
 */
/*:::[hoption_flag[]option_info[]QƂeIvVϐɓWJĂ*/
///mod140406 ݒ肩OIvVdifficultyQƂēKpƂɂB
void extract_option_vars(void)
{
	int i;

	for (i = 0; option_info[i].o_desc; i++)
	{
		int os = option_info[i].o_set;
		int ob = option_info[i].o_bit;

		/* Set the "default" options */
		if (option_info[i].o_var)
		{
			/* Set */
			if (option_flag[os] & (1L << ob))
			{
				/* Set */
				(*option_info[i].o_var) = TRUE;
			}

			/* Clear */
			else
			{
				/* Clear */
				(*option_info[i].o_var) = FALSE;
			}
		}
	}


	///mod140307 Փxɂ鎩IvVI
	///mod140406 [hfĂȂ̂player_birth()ړĂ
	switch(difficulty)
	{
	case DIFFICULTY_EASY:
		easy_band = TRUE;
		smart_learn = FALSE;
		smart_cheat = FALSE;
		ironman_nightmare = FALSE;
		ironman_downward = FALSE;
		break;
	case DIFFICULTY_NORMAL:
		easy_band = FALSE;
		smart_learn = FALSE;
		smart_cheat = FALSE;
		ironman_nightmare = FALSE;
		ironman_downward = FALSE;
		break;
	case DIFFICULTY_HARD:
		easy_band = FALSE;
		smart_learn = TRUE;
		smart_cheat = FALSE;
		ironman_nightmare = FALSE;
		ironman_downward = FALSE;
		break;
	case DIFFICULTY_LUNATIC:
		easy_band = FALSE;
		smart_learn = TRUE;
		smart_cheat = TRUE;
		ironman_nightmare = TRUE;
		ironman_downward = FALSE;
		break;
	case DIFFICULTY_EXTRA:
		easy_band = FALSE;
		smart_learn = TRUE;
		smart_cheat = FALSE;
		ironman_nightmare = FALSE;
		ironman_downward = TRUE;
		break;
	}




}


/*
 * Determine bounty uniques
 */
///del131221
#if 0
void determine_bounty_uniques(void)
{
	int          i, j, tmp;
	monster_race *r_ptr;

	get_mon_num_prep(NULL, NULL);
	for (i = 0; i < MAX_KUBI; i++)
	{
		while (1)
		{
			kubi_r_idx[i] = get_mon_num(MAX_DEPTH - 1);
			r_ptr = &r_info[kubi_r_idx[i]];

			if (!(r_ptr->flags1 & RF1_UNIQUE)) continue;

			if (!(r_ptr->flags9 & (RF9_DROP_CORPSE | RF9_DROP_SKELETON))) continue;

			if (r_ptr->rarity > 100) continue;

			if (no_questor_or_bounty_uniques(kubi_r_idx[i])) continue;

			for (j = 0; j < i; j++)
				if (kubi_r_idx[i] == kubi_r_idx[j]) break;

			if (j == i) break;
		}
	}

	/* Sort them */
	for (i = 0; i < MAX_KUBI - 1; i++)
	{
		for (j = i; j < MAX_KUBI; j++)
		{
			if (r_info[kubi_r_idx[i]].level > r_info[kubi_r_idx[j]].level)
			{
				tmp = kubi_r_idx[i];
				kubi_r_idx[i] = kubi_r_idx[j];
				kubi_r_idx[j] = tmp;
			}
		}
	}
}
#endif

/*
 * Determine today's bounty monster
 * Note: conv_old is used if loaded 0.0.3 or older save file
 */
/*:::{̏܋񌈒@폜\*/
///sysdel
#if 0
void determine_today_mon(bool conv_old)
{
	int max_dl = 3, i;
	bool old_inside_battle = p_ptr->inside_battle;
	monster_race *r_ptr;

	if (!conv_old)
	{
		for (i = 0; i < max_d_idx; i++)
		{
			if (max_dlv[i] < d_info[i].mindepth) continue;
			if (max_dl < max_dlv[i]) max_dl = max_dlv[i];
		}
	}
	else max_dl = MAX(max_dlv[DUNGEON_ANGBAND], 3);

	p_ptr->inside_battle = TRUE;
	get_mon_num_prep(NULL, NULL);

	while (1)
	{
		today_mon = get_mon_num(max_dl);
		r_ptr = &r_info[today_mon];

		if (r_ptr->flags1 & RF1_UNIQUE) continue;
		if (r_ptr->flags7 & (RF7_NAZGUL | RF7_UNIQUE2)) continue;
		if (r_ptr->flags2 & RF2_MULTIPLY) continue;
		if ((r_ptr->flags9 & (RF9_DROP_CORPSE | RF9_DROP_SKELETON)) != (RF9_DROP_CORPSE | RF9_DROP_SKELETON)) continue;
		if (r_ptr->level < MIN(max_dl / 2, 40)) continue;
		if (r_ptr->rarity > 10) continue;
		break;
	}

	p_ptr->today_mon = 0;
	p_ptr->inside_battle = old_inside_battle;
}
#endif

/*
 * Actually play a game
 *
 * If the "new_game" parameter is true, then, after loading the
 * savefile, we will commit suicide, if necessary, to allow the
 * player to start a new game.
 */
/*:::Q[[`̈ԏ@VKTRUE,t@CJƂFALSE*/
void play_game(bool new_game)
{
	int i;
	bool load_game = TRUE;
	bool init_random_seed = FALSE;

	//v1.1.25 vCԂoO񍐂B
	//sstart_timeݒ̂Ƃupdate_playtime()sĂ炵B
	//Ƃ肠ŏ̍ŏstart_timeݒ肷悤ɂĂ
	start_time = time(NULL) - 1;

/*:::f[^pT[oHǂ݂͖̂炵*/
#ifdef CHUUKEI
	if (chuukei_client)
	{
		reset_visuals();
		browse_chuukei();
		return;
	}

	else if (chuukei_server)
	{
		prepare_chuukei_hooks();
	}
#endif

	///\131117 sysdel
	///mod150224 [r[H
	if (browsing_movie)
	{
		reset_visuals();
		browse_movie();
		return;
	}
	///race blJnψٗp
	hack_startup = FALSE;

	/* Hack -- Character is "icky" */
	/*:::LN^[ŃQ[is܂łȂƂTRUE?*/
	character_icky = TRUE;

	/* Make sure main term is active */
	/*:::dv[`炵B̂܂܎gB*/
	Term_activate(angband_term[0]);

	/* Initialise the resize hooks */
	/*:::悭񂪂̂܂܎gB*/
	angband_term[0]->resize_hook = resize_map;

	for (i = 1; i < 8; i++)
	{
		/* Does the term exist? */
		if (angband_term[i])
		{
			/* Add the redraw on resize hook */
			angband_term[i]->resize_hook = redraw_window;
		}
	}

	/* Hack -- turn off the cursor */
	(void)Term_set_cursor(0);


	/* Attempt to load */
	/*:::Z[ut@Cǂ݂ɍsĂBVKxH*/
	/*:::f[^[hꂽcharacter_loaded=TRUE*/
	if (!load_player())
	{
		/* Oops */
#ifdef JP
quit("Z[ut@CĂ܂");
#else
		quit("broken savefile");
#endif

	}

	/* Extract the options */
	/*:::IvV̐ݒtOpϐɓȂĂ炵*/
	extract_option_vars();

	/* Report waited score */
	/*:::XRAMҋ@Ăꍇ*/
	if (p_ptr->wait_report_score)
	{
		char buf[1024];
		bool success;

#ifdef JP
		if (!get_check_strict("ҋ@ĂXRAo^sȂ܂H", CHECK_NO_HISTORY))
#else
		if (!get_check_strict("Do you register score now? ", CHECK_NO_HISTORY))
#endif
			quit(0);

		//start_timeZbg
		start_time = time(NULL);

		//v1.1.25 -hack- XRAvZtOĐݒ
		if(p_ptr->chp >= 0 && p_ptr->total_winner)
			finish_the_game = TRUE;

		/* Update stuff */
		p_ptr->update |= (PU_BONUS | PU_HP | PU_MANA | PU_SPELLS);

		/* Update stuff */
		update_stuff();

		p_ptr->is_dead = TRUE;

		//v1.1.25 XRAT[oɑf[^is_deadԂɂ邽߂ɒǉ
		if (!save_player()) msg_print("Z[usI");


		/* No suspending now */
		signals_ignore_tstp();
		
		/* Hack -- Character is now "icky" */
		character_icky = TRUE;

		/* Build the filename */
		path_build(buf, sizeof(buf), ANGBAND_DIR_APEX, "scores.raw");

		/* Open the high score file, for reading/writing */
		highscore_fd = fd_open(buf, O_RDWR);
		/* Handle score, show Top scores */
		success = send_world_score(TRUE);


#ifdef JP
		if (!success && !get_check_strict("XRAo^߂܂H", CHECK_NO_HISTORY))
#else
		if (!success && !get_check_strict("Do you give up score registration? ", CHECK_NO_HISTORY))
#endif
		{
#ifdef JP
			//v1.1.25 XRAT[oɑf[^is_deadԂɂĂ̂܂߂
			p_ptr->is_dead = FALSE;
			if (!save_player()) msg_print("Z[usI");
			prt("ҋ@܂B", 0, 0);
#else
			prt("standing by for future registration...", 0, 0);
#endif

			(void)inkey();
		}
		else
		{
			p_ptr->wait_report_score = FALSE;
			top_twenty();
#ifdef JP
			if (!save_player()) msg_print("Z[usI");
#else
			if (!save_player()) msg_print("death save failed!");
#endif
		}
		/* Shut the high score file */
		(void)fd_close(highscore_fd);

		/* Forget the high score fd */
		highscore_fd = -1;
		
		/* Allow suspending now */
		signals_handle_tstp();

		quit(0);
	}
	/*:::VKTRUE*/
	creating_savefile = new_game;

	/* Nothing loaded */
	/*:::VKA܂̓[hsɂɗ*/
	if (!character_loaded)
	{
		/* Make new player */
		new_game = TRUE;

		/* The dungeon is not ready */
		character_dungeon = FALSE;

		/* Prepare to init the RNG */
		init_random_seed = TRUE;

		/* Initialize the saved floors data */
		init_saved_floors(FALSE);
	}

	/* Old game is loaded.  But new game is requested. */
	/*:::ɗ̂͂ǂ낤H*/
	else if (new_game)
	{
		/* Initialize the saved floors data */
		init_saved_floors(TRUE);
	}

	/* Process old character */
	/*:::[h݂̋@ɓKĂ邩`FbNĂ炵*/
	if (!new_game)
	{
		/* Process the player name */
		process_player_name(FALSE);
//testmsg(format("name:%s",player_name));
	}

	/* Init the RNG */
	/*:::VKA_l̎Zbg*/
	if (init_random_seed)
	{
		u32b seed;

		/* Basic seed */
		seed = (time(NULL));

#ifdef SET_UID

		/* Mutate the seed on Unix machines */
		seed = ((seed >> 3) * (getpid() << 1));

#endif

		/* Seed the RNG */
		Rand_state_init(seed);
	}

	/* Roll new character */
	if (new_game)
	{

		/* The dungeon is not ready */
		character_dungeon = FALSE;

		/* Start in town */
		dun_level = 0;
		p_ptr->inside_quest = 0;
		p_ptr->inside_arena = FALSE;
		p_ptr->inside_battle = FALSE;

		/*:::悭킩񂪓LLqpH*/
		write_level = TRUE;

		/* Hack -- seed for flavors */
		/*:::̃_vfɎg炵H*/
		seed_flavor = randint0(0x10000000);

		/* Hack -- seed for town layout */
		seed_town = randint0(0x10000000);

		/* Roll up a new character */
		/*:::LN^[CN@ŏdv*/
		///class race seikaku system
		player_birth();

		/*:::vCԂƃZ[u񐔃JEg̃Zbg*/
		counts_write(2,0);
		p_ptr->count = 0;

		load = FALSE;
		/*:::܋񃊃Xg̐@폜\*/
		///del131221@܋񃊃Xg
		//determine_bounty_uniques();
		/*:::{̏܋̐ݒ@폜\*/
		///sysdel ܋
		//determine_today_mon(FALSE);

		/* Initialize object array */
		/*:::ĂACeSč폜*/
		wipe_o_list();


	}
	else
	{
		write_level = FALSE;

#ifdef JP
		do_cmd_write_nikki(NIKKI_GAMESTART, 1, "                            ----Q[ĊJ----");
#else
		do_cmd_write_nikki(NIKKI_GAMESTART, 1, "                            ---- Restart Game ----");
#endif
#if 0
/*
 * 1.0.9 ȑO̓Z[uO p_ptr->riding = -1 ƂĂ̂ŁAĐݒ肪KvB
 * svAȑÕZ[ut@CƂ̌݊̂߂ɎcĂB
 */
		///sysdel
		if (p_ptr->riding == -1)
		{
			p_ptr->riding = 0;
			for (i = m_max; i > 0; i--)
			{
				if (player_bold(m_list[i].fy, m_list[i].fx))
				{
					p_ptr->riding = i;
					break;
				}
			}
		}
#endif
		///mod150315 dZ
		//v1.0.50OŊJnėdŃvCɃo[WAbvꍇɗ͂
		//dZ擾ANCbNX^[gpprevious_char.scɕۑ
		if(p_ptr->prace == RACE_FAIRY && !CHECK_FAIRY_TYPE) get_fairy_type(TRUE);

		//v1.1.31c dZsΉ
		//birth()œZݒ肵Ƃ̃~XœZidxNCbNX^[gpɕۑp_ptr->scprev-scl50̂܂܂ɂȂĂ̂Őݒ肵
		if(p_ptr->prace == RACE_FAIRY && previous_char.prace == RACE_FAIRY &&
			CHECK_FAIRY_TYPE && p_ptr->sc == 50)
		{
		
			p_ptr->sc = p_ptr->race_multipur_val[0];
			previous_char.sc = p_ptr->sc;
		}


	}
	/*:::͐VKA[hƂ*/

	creating_savefile = FALSE;
	/*:::lXȃtÕZbg*/
	p_ptr->teleport_town = FALSE;
	p_ptr->sutemi = FALSE;
	world_monster = FALSE;
	now_damaged = FALSE;
	now_message = 0;
	start_time = time(NULL) - 1;
	record_o_name[0] = '\0';

	/* Reset map panel */
	panel_row_min = cur_hgt;
	panel_col_min = cur_wid;

	/* Sexy gal gets bonus to maximum weapon skill of whip */
	/*:::ȂLCNɏȂ̂ȂBǂɂĂ폜\*/
	///del131223 seikaku
	//if (p_ptr->pseikaku == SEIKAKU_SEXY)
	//	s_info[p_ptr->pclass].w_max[TV_HAFTED-TV_WEAPON_BEGIN][SV_WHIP] = WEAPON_EXP_MASTER;

	///mod141005 j[NNX2PL̐FςĂ݂
	for (i = 1; i < max_r_idx; i++) if(monster_is_you(i)) r_info[i].d_attr = (r_info[i].d_attr)%15+1;

	/* Fill the arrays of floors and walls in the good proportions */
	/*:::O[oϐfloor_typefill_typeɃ_W̎ނɂn`oɉĒn`f[^100i[ĂB*/
	/*:::VK̎́urvƂĎsH@ǂł̊֐Ă΂闝RȂB[hɂ͂ǂȂ̂H*/
	set_floor_and_wall(dungeon_type);

	/* Flavor the objects */
	/*:::Ȃǂ̖Ӓ莞_ɂ̂Ǝv*/
	/*:::[h_̃V[hێĂ̂œтɂȂ*/
	flavor_init();

	/* Flash a message */
#ifdef JP
prt("҂...", 0, 0);
#else
	prt("Please wait...", 0, 0);
#endif


	/* Flush the message */
	Term_fresh();


	/* Hack -- Enter wizard mode */
	/*:::̓EBU[h[h˓̂ƂtrueɂȂ̂HĂTrueɂȂ鏈Ȃ*/
	/*:::ǂ̓R}hCfobOIvVtheng𗧂グƂ炵H*/
	if (arg_wizard)
	{
		if (enter_wizard_mode())
		{
			p_ptr->wizard = TRUE;

			if (p_ptr->is_dead || !py || !px)
			{
				/* Initialize the saved floors data */
				init_saved_floors(TRUE);

				/* Avoid crash */
				p_ptr->inside_quest = 0;

				/* Avoid crash in update_view() */
				py = px = 10;
			}
		}
		else if (p_ptr->is_dead)
		{
			quit("Already dead.");
		}
	}

	/* Initialize the town-buildings if necessary */
	/*:::r삩ɋăNGXgłȂꍇA*/
	if (!dun_level && !p_ptr->inside_quest)
	{
		/* Init the wilderness */
		/*:::[h}bv̓ǂݍ*/
		process_dungeon_file("w_info.txt", 0, 0, max_wild_y, max_wild_x);
		/* Init the town */
		init_flags = INIT_ONLY_BUILDINGS;
		/*:::̓ǂݍ t_pref.txtǂ񂾌p_ptr->town_numQƂꂼ̃t@Cǂ*/
		process_dungeon_file("t_info.txt", 0, 0, MAX_HGT, MAX_WID);

	}
//testmsg(format("character_dungeon:%x",character_dungeon));
	/*:::GNXg[h͓S1KJn*/
	if(EXTRA_MODE && new_game)
	{
		dungeon_type = DUNGEON_ANGBAND;
		p_ptr->enter_dungeon = TRUE;
		dun_level = 1;
		prepare_change_floor_mode(CFM_RAND_PLACE | CFM_FIRST_FLOOR);
		change_floor();

	}

	/* Generate a dungeon level if needed */
	/*:::tA𐶐BVKɂ͂ɗĊX͂Ȁʒu͂ǂ܂񂾂낤*/
	else if (!character_dungeon)
	{
		change_floor();
	}

	else
	{
		/* HACK -- Restore from panic-save */
		if (p_ptr->panic_save)
		{
//testmsg(format("py:%d px:%d cur_wid:%d cur_hgt:%d",py,px,cur_wid,cur_hgt));
			/* No player?  -- Try to regenerate floor */
			if (!py || !px)
			{
#ifdef JP
				msg_print("vC[̈ʒuBtAĐ܂B");
#else
				msg_print("What a strange player location.  Regenerate the dungeon floor.");
#endif
				change_floor();
			}

			/* Still no player?  -- Try to locate random place */
			if (!py || !px) py = px = 10;

			/* No longer in panic */
			p_ptr->panic_save = 0;
		}
	}

	/* Character is now "complete" */
	character_generated = TRUE;


	/* Hack -- Character is no longer "icky" */
	character_icky = FALSE;


	if (new_game)
	{
		char buf[80];

#ifdef JP
		sprintf(buf, "%sɍ~藧B", map_name());
#else
		sprintf(buf, "You are standing in the %s.", map_name());
#endif
		do_cmd_write_nikki(NIKKI_BUNSHOU, 0, buf);
	}


	/* Start game */
	p_ptr->playing = TRUE;

	/* Reset the visual mappings */
	/*:::ʂ̕\ݒlɖ߂H*/
	reset_visuals();

	/* Load the "pref" files */
	load_all_pref_files();

	/*::: -Hack- oȂIvV@SẮoς݂ɂ Q[JnɁǉꂽꍇɔ[hɂ̏B*/
	if(ironman_no_fixed_art)
	{
		int a_idx;
		for (a_idx = 1; a_idx < max_a_idx; a_idx++)	a_info[a_idx].cur_num = 1;
	}


	/* Give startup outfit (after loading pref files) */
	/*:::Q[JnAĂACe߂鏈Ȃ*/
	if (new_game)
	{
		//LCN̏ACe𓾂
		player_outfit();

		///mod150315 dZ
		/*::: -Hack- dNCbNX^[g */
		//JnɋZĂȂꍇANCbNX^[gȂ̂scɕۑĂ͂̓ZlRs[
		//sc50̏ꍇAo[W̃NCbNX^[gł܂Zt^sĂȂ̂ōĕt^
		if(p_ptr->prace == RACE_FAIRY && !CHECK_FAIRY_TYPE && !(cp_ptr->flag_only_unique))
		{
			//if(p_ptr->sc == 50) v1.1.31c AeB100̃_~[Is̂ŏύX
			if(p_ptr->sc <= FAIRY_TYPE_MAX && fairy_table[p_ptr->sc].rarity >= 100 )
			{
				get_fairy_type(TRUE);
			}
			else
			{
				if(p_ptr->sc > FAIRY_TYPE_MAX || p_ptr->sc < 1 )
				{
					msg_format("ERROR:p_ptr->scɕۑĂ̗͂dZݒl(%d)",p_ptr->sc);
					get_fairy_type(TRUE);
				}
				else 
				{
					p_ptr->race_multipur_val[0] = p_ptr->sc;
				}
			}
		}

	}

	/* React to changes */
	/*:::ڍוsBEBhE֘AH*/
	Term_xtra(TERM_XTRA_REACT, 0);

	/* Window stuff */
	p_ptr->window |= (PW_INVEN | PW_EQUIP | PW_SPELL | PW_PLAYER);

	/* Window stuff */
	p_ptr->window |= (PW_MESSAGE | PW_OVERHEAD | PW_DUNGEON | PW_MONSTER | PW_OBJECT);

	/* Window stuff */
	/*:::TuEBhEɊւݒH*/
	window_stuff();


	/* Set or clear "rogue_like_commands" if requested */
	if (arg_force_original) rogue_like_commands = FALSE;
	if (arg_force_roguelike) rogue_like_commands = TRUE;

	/* Hack -- Enforce "delayed death" */
	/*:::炩̗RŃZ[uɎ񂾂Ƃ̏H񂾂Ƃɕϋؓ{I炽Ԃ񂱂ɗH*/
	if (p_ptr->chp < 0) p_ptr->is_dead = TRUE;

	if (p_ptr->prace == RACE_ANDROID) calc_android_exp();

	/*:::REbgj[Q[̔n*/
	///class mon
	if (new_game && !EXTRA_MODE && ((p_ptr->pclass == CLASS_CAVALRY) || (p_ptr->pclass == CLASS_BEASTMASTER)))
	{
		monster_type *m_ptr;
		int pet_r_idx = ((p_ptr->pclass == CLASS_CAVALRY) ? MON_HORSE : MON_YASE_HORSE);
		monster_race *r_ptr = &r_info[pet_r_idx];
		place_monster_aux(0, py, px - 1, pet_r_idx,
				  (PM_FORCE_PET | PM_NO_KAGE));
		m_ptr = &m_list[hack_m_idx_ii];
		m_ptr->mspeed = r_ptr->speed;
		m_ptr->maxhp = r_ptr->hdice*(r_ptr->hside+1)/2;
		m_ptr->max_maxhp = m_ptr->maxhp;
		m_ptr->hp = r_ptr->hdice*(r_ptr->hside+1)/2;
		m_ptr->energy_need = ENERGY_NEED() + ENERGY_NEED();
	}

	/*:::Mega Hack - PNGXgisxɍ킹AYACeQUESTITEMtOOĒʏ퐶悤ɂ*/
	///mod160721 PvC͑SQUESTITEM̂܂
	if(kaguya_quest_level < KAGUYA_QUEST_MAX && quest[QUEST_KAGUYA].status < QUEST_STATUS_COMPLETED && p_ptr->pclass != CLASS_KAGUYA)
	{
		a_info[kaguya_quest_art_list[kaguya_quest_level]].gen_flags &= ~(TRG_QUESTITEM);
 	}
	//v1.1.26 PNGXg͓KɂǂꂩtOOBN̂тɕςȂ悤ɂKv̂seed_flavorgB
	//ꂾƋPNG̍Ō̃ACe̔[iς܂L̎ȍ~̋Nɂ_󂪐Ă܂\邪A܂債ɂ͂ȂȂB
	else if(kaguya_quest_level == KAGUYA_QUEST_MAX && p_ptr->pclass != CLASS_KAGUYA)
	{
		a_info[kaguya_quest_art_list[(seed_flavor % KAGUYA_QUEST_MAX)]].gen_flags &= ~(TRG_QUESTITEM);
 	}

	///mod160310 Extra[hł͈ꕔX^[QUESTORtOO
	if(EXTRA_MODE)
	{
		for (i = 1; i < max_r_idx; i++)
		{
			if(!(i == MON_OBERON || i== MON_SERPENT || i == MON_MORGOTH || i == MON_AZATHOTH || i == MON_F_SCARLET
			|| i == MON_GOLFIMBUL || i == MON_HECATIA1 || i == MON_HECATIA2 || i == MON_HECATIA3 || i == MON_MIKO || i == MON_ERIC))
			{
				r_info[i].flags1 &= ~(RF1_QUESTOR);
			}
			else
			{
				r_info[i].flags1 |= (RF1_QUESTOR);
			}
		}
	}

	//fobOAf[^~op
	if(0)
	{
			Term_clear();
			put_str("***lA***", 17 , 40);
			(void)inkey();
			p_ptr->chp = p_ptr->mhp;
			p_ptr->chp_frac = 0;
			(void)set_food(PY_FOOD_MAX - 1);
			reset_tim_flags();
			dun_level = 0;
			p_ptr->inside_arena = FALSE;
			p_ptr->inside_battle = FALSE;
			leave_quest_check();
			leaving_quest = 0;
			p_ptr->inside_quest = 0;
			if (dungeon_type) p_ptr->recall_dungeon = dungeon_type;
			dungeon_type = 0;
			py = 33;
			px = 180;
			p_ptr->wilderness_y = 34;
			p_ptr->wilderness_x = 39;
			p_ptr->oldpy = 33;
			p_ptr->oldpx = 180;
			p_ptr->wild_mode = FALSE;
			wipe_m_list();
			leave_floor();
			change_floor();

	}

	/*:::XƂ̃ACe܂Ƃ߁AiƎޏɐ񂷂*/
	(void)combine_and_reorder_home(STORE_HOME);
	(void)combine_and_reorder_home(STORE_MUSEUM);
	/* Process */
	/*:::C[`*/
	while (TRUE)
	{

		/* Process the level */
		/*:::̊Kł̏@KړASAQ[Io*/
		dungeon(load_game);

		/* Handle "p_ptr->notice" */
		notice_stuff();

		/* Hack -- prevent "icky" message */
		character_xtra = TRUE;

		/* Handle "p_ptr->update" and "p_ptr->redraw" and "p_ptr->window" */
		handle_stuff();

		character_xtra = FALSE;

		/* Cancel the target */
		target_who = 0;

		/* Cancel the health bar */
		health_track(0);


		/* Forget the lite */
		forget_lite();

		/* Forget the view */
		forget_view();

		/* Forget the view */
		clear_mon_lite();

		/* Handle "quit and save" */
		if (!p_ptr->playing && !p_ptr->is_dead) break;

		/* Erase the old cave */
		wipe_o_list();
		if (!p_ptr->is_dead) wipe_m_list();


		/* XXX XXX XXX */
		msg_print(NULL);

		load_game = FALSE;

		/* Accidental Death */
		/*:::ނؕłȂ񂾂Ƃ@ł̓A[iƃEBU[h[h̕*/

		if (p_ptr->playing && p_ptr->is_dead)
		{
			//v1.1.51 VA[iɔ
#if 0
			if (p_ptr->inside_arena)
			{
				p_ptr->inside_arena = FALSE;
				if (p_ptr->arena_number > MAX_ARENA_MONS)
					p_ptr->arena_number++;
				else
					p_ptr->arena_number = -1 - p_ptr->arena_number;
				p_ptr->is_dead = FALSE;
				p_ptr->chp = 0;
				p_ptr->chp_frac = 0;
				p_ptr->exit_bldg = TRUE;
				reset_tim_flags();

				/* Leave through the exit */
				prepare_change_floor_mode(CFM_SAVE_FLOORS | CFM_RAND_CONNECT);

				/* prepare next floor */
				leave_floor();
			}
#endif
			if (p_ptr->inside_arena)
			{
				p_ptr->inside_arena = FALSE;

				p_ptr->is_dead = FALSE;
				p_ptr->chp = p_ptr->mhp;
				p_ptr->chp_frac = 0;
				p_ptr->exit_bldg = TRUE;
				reset_tim_flags();

				/* Leave through the exit */

				//skɍĒ킵烂X^[̔zuɂȂĂ̂CFM_NO_RETURNɕς
				prepare_change_floor_mode(CFM_SAVE_FLOORS | CFM_NO_RETURN);

				/* prepare next floor */
				leave_floor();
			}
			else
			{
				/* Mega-Hack -- Allow player to cheat death */
#ifdef JP
				if ((p_ptr->wizard || cheat_live || difficulty == DIFFICULTY_EASY) && get_check("ReBj[܂? "))
#else
				if ((p_ptr->wizard || cheat_live) && !get_check("Die? "))
#endif
				{
					/* Mark social class, reset age, if needed */
					if (p_ptr->sc) p_ptr->sc = p_ptr->age = 0;

					/* Increase age */
					p_ptr->age++;

					/* Mark savefile */
					if(difficulty != DIFFICULTY_EASY) p_ptr->noscore |= 0x0001;

					/* Message */
#ifdef JP
				//	msg_print("EBU[h[hɔO𑗂A\B");
#else
					msg_print("You invoke wizard mode and cheat death.");
#endif
					msg_print(NULL);

					/* Restore hit points */
					p_ptr->chp = p_ptr->mhp;
					p_ptr->chp_frac = 0;

					if (p_ptr->pclass == CLASS_MAGIC_EATER)
					{
						for (i = 0; i < EATER_EXT*2; i++)
						{
							p_ptr->magic_num1[i] = p_ptr->magic_num2[i]*EATER_CHARGE;
						}
						for (; i < EATER_EXT*3; i++)
						{
							p_ptr->magic_num1[i] = 0;
						}
					}
					/* Restore spell points */
					p_ptr->csp = p_ptr->msp;
					p_ptr->csp_frac = 0;

					/* Hack -- cancel recall */
					if (p_ptr->word_recall)
					{
						/* Message */
#ifdef JP
						msg_print("߂Cꋎ...");
#else
						msg_print("A tension leaves the air around you...");
#endif

						msg_print(NULL);

						/* Hack -- Prevent recall */
						p_ptr->word_recall = 0;
						p_ptr->redraw |= (PR_STATUS);
					}

					/* Hack -- cancel alter */
					if (p_ptr->alter_reality)
					{
						/* Hack -- Prevent alter */
						p_ptr->alter_reality = 0;
						p_ptr->redraw |= (PR_STATUS);
					}

					/* Note cause of death XXX XXX XXX */
#ifdef JP
					(void)strcpy(p_ptr->died_from, "ReBj[");
#else
					(void)strcpy(p_ptr->died_from, "Cheating death");
#endif

					/* Do not die */
					p_ptr->is_dead = FALSE;

					/* Hack -- Healing */
					(void)set_blind(0);
					(void)set_confused(0);
					(void)set_poisoned(0);
					(void)set_afraid(0);
					(void)set_paralyzed(0);
					(void)set_image(0);
					(void)set_stun(0);
					(void)set_cut(0);
					set_alcohol(0);

					if(p_ptr->pclass == CLASS_HINA) hina_gain_yaku(-99999);

					/* Hack -- Prevent starvation */
					(void)set_food(PY_FOOD_MAX - 1);

					dun_level = 0;
					p_ptr->inside_arena = FALSE;
					p_ptr->inside_battle = FALSE;
					leaving_quest = 0;
					p_ptr->inside_quest = 0;
					if (dungeon_type) p_ptr->recall_dungeon = dungeon_type;
					dungeon_type = 0;
					if (lite_town || vanilla_town)
					{
						p_ptr->wilderness_y = 1;
						p_ptr->wilderness_x = 1;
						if (vanilla_town)
						{
							p_ptr->oldpy = 10;
							p_ptr->oldpx = 34;
						}
						else
						{
							p_ptr->oldpy = 33;
							p_ptr->oldpx = 180;
						}
					}
					else
					{
						p_ptr->wilderness_y = 34;
						p_ptr->wilderness_x = 39;
						p_ptr->oldpy = 33;
						p_ptr->oldpx = 180;
					}

					/* Leaving */
					p_ptr->wild_mode = FALSE;
					p_ptr->leaving = TRUE;

#ifdef JP
					do_cmd_write_nikki(NIKKI_BUNSHOU, 1, "                            AReBj[B");
#else
					do_cmd_write_nikki(NIKKI_BUNSHOU, 1, "                            but revived.");
#endif

					/* Prepare next floor */
					leave_floor();
					wipe_m_list();
				}
			}
		}
		///mod150620 俎qꏈ@ჁAӎsāA}AŋIɐl֖߂
		else if(flag_sumireko_wakeup)
		{

			Term_clear();
			put_str("Ȃ͈ӎEE", 17 , 40);
			(void)inkey();
			p_ptr->chp = p_ptr->mhp;
			p_ptr->chp_frac = 0;
			(void)set_food(PY_FOOD_MAX - 1);
			reset_tim_flags();
			dun_level = 0;
			p_ptr->inside_arena = FALSE;
			p_ptr->inside_battle = FALSE;
			leave_quest_check();
			leaving_quest = 0;
			p_ptr->inside_quest = 0;
			if (dungeon_type) p_ptr->recall_dungeon = dungeon_type;
			dungeon_type = 0;
			p_ptr->wilderness_y = 34;
			p_ptr->wilderness_x = 39;
			p_ptr->oldpy = 33;
			p_ptr->oldpx = 180;
			p_ptr->wild_mode = FALSE;
			leave_floor();
			wipe_m_list();
		}

		/* Handle "death" */
		if (p_ptr->is_dead) break;

		/* Make a new level */
		change_floor();
	}

	/* Close stuff */
	close_game();

	/* Quit */
	quit(NULL);
}

///mod140126 Afbh邩Q[Jn̂߂
s32b turn_real(s32b hoge)
{
#if 0
	switch (p_ptr->start_race)
	{
	case RACE_VAMPIRE:
	case RACE_SKELETON:
	case RACE_ZOMBIE:
	case RACE_SPECTRE:
		return hoge - (TURNS_PER_TICK * TOWN_DAWN * 3 / 4);
	default:
		return hoge;
	}
#endif
		return hoge;

}

/*
 * ^[̃I[o[t[ɑ΂Ώ
 * ^[yу^[L^ϐ^[̌E1O܂Ŋ߂.
 */
void prevent_turn_overflow(void)
{
	int rollback_days, i, j;
	s32b rollback_turns;

	if (turn < turn_limit) return;

	rollback_days = 1 + (turn - turn_limit) / (TURNS_PER_TICK * TOWN_DAWN);
	rollback_turns = TURNS_PER_TICK * TOWN_DAWN * rollback_days;

	if (turn > rollback_turns) turn -= rollback_turns;
	else turn = 1; /* Paranoia */
	if (old_turn > rollback_turns) old_turn -= rollback_turns;
	else old_turn = 1;
	if (old_battle > rollback_turns) old_battle -= rollback_turns;
	else old_battle = 1;
	if (p_ptr->feeling_turn > rollback_turns) p_ptr->feeling_turn -= rollback_turns;
	else p_ptr->feeling_turn = 1;

	for (i = 1; i < max_towns; i++)
	{
		for (j = 0; j < MAX_STORES; j++)
		{
			store_type *st_ptr = &town[i].store[j];

			if (st_ptr->last_visit > -10L * TURNS_PER_TICK * STORE_TICKS)
			{
				st_ptr->last_visit -= rollback_turns;
				if (st_ptr->last_visit < -10L * TURNS_PER_TICK * STORE_TICKS) st_ptr->last_visit = -10L * TURNS_PER_TICK * STORE_TICKS;
			}

			if (st_ptr->store_open)
			{
				st_ptr->store_open -= rollback_turns;
				if (st_ptr->store_open < 1) st_ptr->store_open = 1;
			}
		}
	}
}
